//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%       Copyright (C) 1995, by WATCOM Systems Inc. All rights     %
//%       reserved. No part of this software may be reproduced      %
//%       in any form or by any means - graphic, electronic or      %
//%       mechanical, including photocopying, recording, taping     %
//%       or information storage and retrieval systems - except     %
//%       with the written permission of WATCOM Systems Inc.        %
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
// date         by              reason
// ====         ==              ======
// 27-sep-95	T. Schiller	Initial implementation
// 29-sep-95	T. Schiller	Fixed to make it work :)

    .text

    .globl  _GetFPCR		// Get current contents of the FPCR
    .globl  _SetFPCR		// Set contents of the FPCR

_GetFPCR:
    lda	    $sp,-0x10($sp)	// Make some room on the stack
    excb                        // Make sure all instructions have completed
    mf_fpcr $f0                 // Load the FPCR contents into F0
    excb                        // Wait until we've completed
    stt	    $f0, ($sp)          // Write them out to the stack
    ldl	    $v0, 0x04($sp)          // Load the high dword into V0 (all we need)
    lda	    $sp, 0x10($sp)      // Restore the stack
    ret                         // Return

_SetFPCR:
    lda     $sp,-0x10($sp)      // Make some room on the stack
    stq	    $zero, ($sp)
    stl	    $a0, 0x04($sp)      // Write A0 to the stack
    ldt	    $f0, ($sp)          // Load into F0 (note only high dword matters)
    lda	    $sp, 0x10($sp)      // Restore the stack
    excb			// Make sure all instructions have completed
    mt_fpcr $f0                 // Write F0 out to the FPCR
    excb			// Wait until we've completed
    ret                         // Return
