/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1995, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  29-sep-95	T. Schiller	Initial implementation
*/
#include "rtdata.h"
#include "variety.h"


extern unsigned long _GetFPCR(void);
extern void          _SetFPCR(unsigned long);


/*
 * Alpha FPCR Exception Bits
 * -------------------------
 *
 * Bit 63 : Summary Bit (OR of Bits 57 - 52)
 * Bit 57 : Integer Overflow (IOV) Exception
 * Bit 56 : Inexact Result (INE) Exception
 * Bit 55 : Underflow (UNF) Exception
 * Bit 54 : Overflow (OVF) Exception
 * Bit 53 : Division by Zero (DZE) Exception
 * Bit 52 : Invalid Operation (INV) Exception
 *
 * Since we are using only the highword of the FPCR, these bits will map
 * to 31 and 25-20 respectively.
 */

void _ClearFPE(void)
{
    unsigned long fpcr;

    fpcr = _GetFPCR();
    fpcr &= 0x7c0fffffL;
    _SetFPCR(fpcr);
} /* _ClearFPE() */
