/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1995, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  15-dec-95	T. Schiller	Initial implementation based on code
				from J.W.Welch's pdregist.c
*/
#include "variety.h"
#include <windows.h>
#include "rtdata.h"
#ifdef BROKEN
#include "pdreg.h"
#endif

#define GetContextReg(ctx, reg) (*(void**)&((ctx)->Int##reg))

#define AXP_MOV_SP_FP   0x47FE040F
#define AXP_INSTR_SIZE  4


typedef struct __PDATA
{
    unsigned long entry;
    unsigned long end;
    unsigned long handler;
    unsigned long data;
    unsigned long endProlog;
} _PDATA;

_WCRTLINK int _ProcSetsFP(_PDATA *pdata)
{
    unsigned int inst;
    int          usesFP = 0;

    if (pdata->entry != pdata->endProlog)
    {
	inst = *(unsigned int *)(((char *)pdata->endProlog) - AXP_INSTR_SIZE);
	if (inst == AXP_MOV_SP_FP)
	    usesFP = 1;
    } /* if */

    return usesFP;
} /* _ProcSetsFP() */

#ifdef BROKEN

_WCRTLINK _EXCINFO *_SetPData(_EXCINFO *info)
{
    info->pdata = (_PDATA *)RtlLookupFunctionEntry(info->pc);
    return info;
} /* _SetPData() */


_WCRTLINK void _NextExcInfo(_EXCINFO *info)
{
    info->pc = RtlVirtualUnwind(info->pc, info->pdata, &info->context,
				&info->in_func, info->est_frame, 0);
    _SetPData(info);
} /* _NextExcInfo() */


_WCRTLINK void _InitExcInfo(_EXCINFO *info)
{
    RtlCaptureContext(&info->context);
    info->in_func = 1;
    info->pc      = GetContextReg(&info->context, Ra);

    _SetPData(info);
    _NextExcInfo(info);
} /* _InitExcInfo() */
#endif
