;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  03-dec-89    F.W.Crigger     Initial implementation
;  02-jun-90    F.W.Crigger     Windows support added
;  01-mar-91    F.W.Crigger     Windows conventions now same as DOS
;  12-sep-94	Greg Bentz	_DISK_VERIFY doesn't use buffer
;  12-sep-94	Greg Bentz	check for _HUGE_DATA with _BIG_DATA
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;  06-oct-95	M. Hildebrand	Changed _bios prefix to __ibm_bios.
;
include mdef.inc
include struct.inc

        modstart b_disk

        defp    __ibm_bios_disk
	if __WASM__ ge 100
         xdefp  "C",__ibm_bios_disk
	else
         xdefp  <"C",__ibm_bios_disk>
	endif
;
;       unsigned __ibm_bios_disk( unsigned service, struct diskinfo_t *diskinfo );
;struct  diskinfo_t {            /* disk parameters */
;        unsigned drive;         /* drive number    */
;        unsigned head;          /* head number     */
;        unsigned track;         /* track number    */
;        unsigned sector;        /* sector number   */
;        unsigned nsectors;      /* number of sectors to read/write/compare  */
;        void far *buffer;       /* buffer to read to,write from, or compare */
;};
;
        push    ES              ; save ES
        push    BX              ; save BX
        push    CX              ; save CX
        push    DX              ; save DX
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,CX           ; point to diskinfo struct
else
        mov     BX,DX           ; get pointer to diskinfo
endif
        mov     AH,AL           ; get service
        mov     DL,[BX]         ; get drive number
        cmp     AH,2            ; if function uses a buffer
        _if     ae              ; then
          mov   DH,2[BX]        ; - get head
          mov   CX,4[BX]        ; - track
          xchg  CH,CL           ; - shift into position
          ror   CL,1            ; - ...
          ror   CL,1            ; - ...
          and   CL,0c0h         ; - ...
          or    CL,6[BX]        ; - get sector number
          mov   AL,8[BX]        ; - get number of sectors
	  cmp	AH,4		; - if function is not _DISK_VERIFY
	  _if	ne		; - then
            les BX,10[BX]       ; - - get buffer address
          _endif                ; endif
        _endif                  ; endif
        int     13h             ; issue disk request
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        pop     DX              ; restore BX
        pop     CX              ; restore BX
        pop     BX              ; restore BX
        pop     ES              ; restore ES
        ret                     ; return to caller
        endproc __ibm_bios_disk

        endmod
        end
