;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1990 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  16-feb-90    F.W.Crigger     Initial implementation
;  06-jun-90    F.W.Crigger     _bios_keybrd - check for no char from _READY
;  12-jun-90    F.W.Crigger     _bios_keybrd - function code must be in AH
;  18-jul-91	F.W.Crigger	Allow for 3 new keyboard services
;  19-mar-92	F.W.Crigger	save EBX for -3s model in _printer and
;				_serialcom routines
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;  06-oct-95	M. Hildebrand	Changed _bios prefix to __ibm_bios.
;
include mdef.inc
include struct.inc

        modstart biosfunc

;unsigned __ibm_bios_equiplist(void);
;unsigned __ibm_bios_keybrd(unsigned __service);
;unsigned __ibm_bios_memsize(void);
;unsigned __ibm_bios_printer(unsigned __service,unsigned __port,unsigned __data);
;unsigned __ibm_bios_serialcom(unsigned __service,unsigned __port,unsigned __data);

	if __WASM__ ge 100
	    xdefp   "C",__ibm_bios_equiplist
	    xdefp   "C",__ibm_bios_keybrd
	    xdefp   "C",__ibm_bios_memsize
	    xdefp   "C",__ibm_bios_printer
	    xdefp   "C",__ibm_bios_serialcom
	else
	    xdefp   <"C",__ibm_bios_equiplist>
	    xdefp   <"C",__ibm_bios_keybrd>
	    xdefp   <"C",__ibm_bios_memsize>
	    xdefp   <"C",__ibm_bios_printer>
	    xdefp   <"C",__ibm_bios_serialcom>
	endif

        defp    __ibm_bios_equiplist
;
        int     11h             ; get bios equipment list
        ret                     ; return
        endproc __ibm_bios_equiplist

        defp    __ibm_bios_keybrd
;
ifdef __STACK__
        mov     EAX,4[ESP]      ; get function code
endif
        push    EDX             ; save EDX
        mov     AH,AL           ; get service code              12-jun-90
        mov     DH,AH           ; save function code
        int     16h             ; access keyboard services
        _if     e               ; if no character
	  and	DH,0Fh		; - isolate low order func code (18-jul-91)
          cmp   DH,1            ; - if '_KEYBRD_READY' function
          _if   e               ; - then
            sub   EAX,EAX       ; - - indicate no character available
          _endif                ; - endif
        _endif                  ; endif
        pop     EDX             ; restore EDX
        ret                     ; return
        endproc __ibm_bios_keybrd

        defp    __ibm_bios_memsize
;
        int     12h             ; get memory size information
        ret                     ; return
        endproc __ibm_bios_memsize

        defp    __ibm_bios_printer
;
	push	EBX		; save EBX
ifdef __STACK__
        mov     EAX,8[ESP]      ; get function code
        mov     EDX,12[ESP]     ; get port number
        mov     EBX,16[ESP]     ; get data
endif
        mov     AH,AL           ; get function code
        mov     AL,BL           ; get data
        int     17h             ; access printer services
        mov     AL,AH           ; get status
        and     EAX,000000FFh   ; zero top bytes
	pop	EBX		; restore EBX
        ret                     ; return
        endproc __ibm_bios_printer

        defp    __ibm_bios_serialcom
;
	push	EBX		; save EBX
ifdef __STACK__
        mov     EAX,8[ESP]      ; get function code
        mov     EDX,12[ESP]     ; get port number
        mov     EBX,16[ESP]     ; get data
endif
        mov     AH,AL           ; get function code
        mov     AL,BL           ; get data
        int     14h             ; access serialcom services
	pop	EBX		; restore EBX
        ret                     ; return
        endproc __ibm_bios_serialcom


        endmod
        end
