;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;--------------------------------------------------------------------
;  modified:      by:           reason:
;  ---------      ---           -------
;  96/07/15	B.J. Stecher	initial implementation

include mdef.inc
include struct.inc

.8087
        modstart        _7fu8
	
       
      	xdefp	__FSU87
	xdefp	__FDU87
       
defpe __FSU87
	sub	esp,12
	mov	[esp],eax
	fld	dword ptr [esp]
	jmp	short convert
endproc __FSU87	

defpe __FDU87	
	sub	esp,12
	mov	[esp],eax
	mov	4[esp],edx
	fld	qword ptr [esp]
	
       	; fall through
endproc __FDU87	

convert:
	push	ecx
	fstp	tbyte ptr 4[esp]	; get number out in memory
	mov	ax,12[esp]		; pick up sign/exponent
	and	ax,7fffh		; isolate exponent
	sub	ax,16383		; remove bias
	jl	ret_zero		; if less than .5, return zero
	cmp	ax,64			; are we too big?
	jae	ret_inf			; if so, return infinity
	mov	cl,63			; calculate shift count
	sub	cl,al			; ...
	mov	eax,4[esp]		; pick up mantissa
	mov	edx,8[esp]		; ...
	je	negate			; skip out if no shifting
L2:
	shr	edx,1			; shift down one bit
	rcr	eax,1			; ...
	dec	cl			; are we done?
	jne	L2			; do it again if not
negate:
	test	byte ptr 13[esp],80h	; is number negative?
	jns	done			; if not, we're done
	neg	edx			; negate number
	neg	eax			; ...
	sbb	edx,0			; ...
done:
	pop	ecx			; ...
	add	esp,12			; outta here
	ret				; ...
	
ret_zero:
	xor	edx,edx
	xor	eax,eax
	jmp	done
	
ret_inf:
	mov	edx,0ffffffffh
	mov	eax,edx
	jmp	done

        endmod
        end
