;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
;<>
;<> __FDC - floating double comparison
;<>     input:  AX:BX:CX:DX - operand 1
;<>             DS:SI - address of operand 2
;<>       if op1 > op2,  1 is returned in AX
;<>       if op1 < op2, -1 is returned in AX
;<>       if op1 = op2,  0 is returned in AX
;<>
;<>  modified:    by:           reason:
;<>  ---------    ---           -------
;<>  29-sep-86  F.W.Crigger     F8cmp adapted to new code generator
;<>  26-oct-87  John Dahms      Added __EDC
;<>--------------------------------------------------------Version 6.0-----
;<>  15-apr-88  F.W.Crigger     __EDC didn't set si before calling __FDC
;<>  22-may-88  F.W.Crigger     Save some memory references
;<>  27-may-92	F.W.Crigger	EDC - clear overflow flag
;<>------------------------------------------------------Version 11.0-------
;<>  25-nov-95	Greg Bentz	wasm export support
;<>
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
include mdef.inc
include struct.inc

        modstart        fdc

        xdefp   __FDC
        xdefp   __EDC

        defp    __EDC
        push    es:6[si]	; push second operand onto stack
        push    es:4[si]	; ...
        push    es:2[si]	; ...
        push    es:[si]		; ...
        mov     si,sp           ; point to second operand
        docall  __FDC		; do the comparison
        lahf			; save flags
        add     sp,8		; clean up stack
	or	ax,ax		; clear overflow flag
        sahf			; restore flags
        cbw			; sign extend result
        ret			; return
        endproc __EDC

        defpe	__FDC
        push    BP              ; save BP
        push    DI              ; save DI
        test    AX,07ff0h       ; check for zero
        _if     e               ; if it is then
          sub   AX,AX           ; - make whole damn thing a zero
        _endif                  ; endif
        mov     DI,ss:6[SI]     ; get high word of arg2
        test    DI,07ff0h       ; check for zero
        _if     e               ; if it is then
          sub   DI,DI           ; - make whole damn thing a zero
        _endif                  ; endif
        mov     BP,DI           ; save op2 exponent
        xor     BP,AX           ; see about signs of the operands
        mov     BP,0            ; clear result
        js      cmpdone         ; quif arg1 & arg2 have diff signs
        _guess                  ; guess
          cmp   AX,DI           ; - compare high words of arg1, arg2
          _quif ne              ; - quif not equal
          cmp   BX,ss:4[SI]     ; - compare 2nd  words of arg1, arg2
          _quif ne              ; - quif not equal
          cmp   CX,ss:2[SI]     ; - compare 3rd  words of arg1, arg2
          _quif ne              ; - quif not equal
          cmp   DX,ss:[SI]      ; - compare 4th  words of arg1, arg2
        _endguess               ; endguess
        _if     ne              ; if arg1 <> arg2
          rcr   CX,1            ; - save carry in CX
          xor   AX,CX           ; - sign of BX is sign of result

cmpdone:  _shl  AX,1            ; - get sign of result into carry
          sbb   BP,0            ; - BP gets sign of result
          _shl  BP,1            ; - double BP
          inc   BP              ; - make BP -1 or 1
        _endif                  ; endif
        mov     AX,BP           ; get result
        pop     DI              ; restore DI
        pop     BP              ; restore BP
        ret                     ; return to caller
        endproc __FDC

        endmod
        end
