;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
;<>
;<> __FDC - floating double comparison
;<>     input:  EDX:EAX - operand 1
;<>             ECX:EBX - operand 2
;<>       if op1 > op2,  1 is returned in EAX
;<>       if op1 < op2, -1 is returned in EAX
;<>       if op1 = op2,  0 is returned in EAX
;<>
;<>  modified:    by:           reason:
;<>  ---------    ---           -------
;<>  29-sep-86  F.W.Crigger     F8cmp adapted to new code generator
;<>  26-oct-87  John Dahms      Added __EDC
;<>--------------------------------------------------------Version 6.0-----
;<>  15-apr-88  F.W.Crigger     __EDC didn't set si before calling __FDC
;<>  22-may-88  F.W.Crigger     Save some memory references
;<>  10-mar-89  F.W.Crigger     Adapted for 386
;------------------------------------------------------Version 11.0-------
;  25-nov-95	Greg Bentz	wasm export support
;<>
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
include mdef.inc
include struct.inc

        modstart        fdc

        xdefp   __FDC

        defpe	__FDC
        push    EBP             ; save BP
        test    EDX,07ff00000h  ; check for zero
        _if     e               ; if it is then
          sub   EDX,EDX         ; - make whole damn thing a zero
        _endif                  ; endif
        test    ECX,07ff00000h  ; check op2 for zero
        _if     e               ; if it is then
          sub   ECX,ECX         ; - make whole damn thing a zero
        _endif                  ; endif
        mov     EBP,ECX         ; save op2 exponent
        xor     EBP,EDX         ; see about signs of the operands
        mov     EBP,0           ; clear result
        js      short cmpdone   ; quif arg1 & arg2 have diff signs
        _guess                  ; guess
          cmp   EDX,ECX         ; - compare high words of arg1, arg2
          _quif ne              ; - quif not equal
          cmp   EAX,EBX         ; - compare 2nd  words of arg1, arg2
        _endguess               ; endguess
        _if     ne              ; if arg1 <> arg2
          rcr   ECX,1           ; - save carry in CX
          xor   EDX,ECX         ; - sign of BX is sign of result

cmpdone:  _shl  EDX,1           ; - get sign of result into carry
          sbb   EBP,0           ; - BP gets sign of result
          _shl  EBP,1           ; - double BP
          inc   EBP             ; - make BP -1 or 1
        _endif                  ; endif
        mov     EAX,EBP         ; get result
        pop     EBP             ; restore BP
        ret                     ; return to caller
        endproc __FDC

        endmod
        end
