;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
;<>
;<> __FSC compares DX:AX with CX:BX
;<>       if DX:AX > CX:BX,  1 is returned in AX
;<>       if DX:AX = CX:BX,  0 is returned in AX
;<>       if DX:AX < CX:BX, -1 is returned in AX
;<>
;<>  modified:    by:           reason:
;<>  =========    ===           =======
;<>  14-apr-85  F.W.Crigger     initial adaptation from f8cmp by A.Kasapi
;<>  03-feb-86  D.P.Yach        rewritten to preserve SI and DI
;<>------------------------------------------------------Version 11.0-------
;<>  25-nov-95	Greg Bentz	wasm export support
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
include mdef.inc
include struct.inc

        modstart        fsc

        xdefp   __FSC

        defpe	__FSC
        _guess    have_cmp      ; guess - comparison done
          xor     DX,CX         ; - check if signs differ
          _if     ns            ; - if signs are the same
            xor     DX,CX       ; - - restore DX
            sub     DX,CX       ; - - find difference, DX=0 if equal
            _if     e           ; - - if equal
              cmp     AX,BX     ; - - - compare mantissas
              mov     AX,0      ; - - - assume equal
              _quif   e,have_cmp  ; - done if mantissas also equal
            _endif              ; - - endif
                                ; - - carry=1 iff |DX:AX| < |CX:BX|
            rcr     DX,1        ; - - DX sign set iff |DX:AX| < |CX:BX|
            xor     CX,DX       ; - - CX sign set iff DX:AX < CX:BX
            not     CX          ; - - CX sign set iff DX:AX > CX:BX
          _endif                ; - endif
          sub     AX,AX         ; - clear result
          _shl    CX,1          ; - carry=1 iff DX:AX > CX:BX
          adc     AX,AX         ; - AX = 1 iff DX:AX > CX:BX, else AX=0
          _shl    AX,1          ; - AX = 2 iff DX:AX > CX:BX, else AX=0
          dec     AX            ; - AX = 1 iff DX:AX > CX:BX, else AX=-1
        _endguess               ; endguess
        ret                     ; return with sign in AX, conditions set
        endproc __FSC

        endmod
        end
