;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
;<>
;<> __FSC compares EAX with EDX
;<>       if EAX > EDX,  1 is returned in EAX
;<>       if EAX = EDX,  0 is returned in EAX
;<>       if EAX < EDX, -1 is returned in EAX
;<>
;<>  modified:    by:           reason:
;<>  =========    ===           =======
;<>  20-feb-89  F.W.Crigger     initial implementation
;<>------------------------------------------------------Version 11.0-------
;<>  25-nov-95	Greg Bentz	wasm export support
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
include mdef.inc
include struct.inc

        modstart        fsc

        xdefp   __FSC

        defpe	__FSC
        _guess    have_cmp      ; guess - comparison done
          xor     EAX,EDX       ; - check if signs differ
          _if     ns            ; - if signs are the same
            xor     EAX,EDX     ; - - restore EAX
            sub     EAX,EDX     ; - - find difference, EAX=0 if equal
            _quif   e,have_cmp  ; - - done if mantissas also equal
                                ; - - carry=1 iff |EAX| < |EDX|
            rcr     EAX,1       ; - - EAX sign set iff |EAX| < |EDX|
            xor     EDX,EAX     ; - - EDX sign set iff EAX < EDX
            not     EDX         ; - - EDX sign set iff EAX > EDX
          _endif                ; - endif
          sub     EAX,EAX       ; - clear result
          _shl    EDX,1         ; - carry=1 iff EAX > EDX
          adc     EAX,EAX       ; - EAX = 1 iff EAX > EDX, else EAX = 0
          _shl    EAX,1         ; - EAX = 2 iff EAX > EDX, else EAX = 0
          dec     EAX           ; - EAX = 1 iff EAX > EDX, else EAX = -1
        _endguess               ; endguess
        ret                     ; return with sign in EAX, conditions set
        endproc __FSC

        endmod
        end
