;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1989 by WATCOM Systems Inc. All rights	   %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;=========================================================================
;==	Name:		FSFD						==
;==	Operation:	Float single to float double conversion		==
;==	Inputs:		EAX	single precision float			==
;==	Outputs:	EDX:EAX		double precision float		==
;==	Volatile:	none						==
;==	Date:		By:		Reason:				==
;==	21-feb-89	F.W.Crigger	initial implementation for 386	==
;==	15-aug-91	F.W.Crigger	handle -0.0			==
;==	05-nov-92	F.W.Crigger	handle +-infinity		==
;==----------------------------------------------------Version 11.0-----==
;==	25-nov-95	Greg Bentz	wasm export support             ==
;=========================================================================
include mdef.inc
include struct.inc

	modstart	fsfd

	xdefp	__FSFD

	defpe	__FSFD
	_guess			; guess: number is 0.0 or -0.0
	  mov	EDX,EAX		; - get float
	  and	EDX,7fffffffh	; - remove sign
	  _quif ne		; - quit if number is not +0.0 or -0.0
	_admit			; guess: number is +-infinity
	  cmp	EDX,7f800000h	; - quit if not +-infinity
	  _quif ne		; - ...
	  mov	EDX,EAX		; - get sign
	  or	EDX,7ff00000h	; - set double precision infinity
	  sub	EAX,EAX		; - ...
	_admit			; admit: not a special number
	  test	EDX,7f800000h	; - if exponent is 0 (denormal number)
	  _if	e		; - then
	    xor	  EAX,EDX	; - - keep just the sign
	    push  ECX		; - - save ECX
	    sub	  ECX,ECX	; - - exponent adjustment
	    _loop		; - - loop (normalize the fraction)
	      add  ECX,00800000h; - - - subtract 1 from exponent adjustment
	      _shl EDX,1	; - - - shift fraction left
	      test EDX,00800000h; - - - check to see if fraction is normalized
	    _until ne		; - - until normalized
	    or	  EAX,EDX	; - - copy fraction back to EAX
	    sub	  EDX,ECX	; - - adjust the exponent
	    pop	  ECX		; - - restore ECX
	  _endif		; - endif
	  sar	EDX,2		; - shift over 2
	  _shl	EAX,1		; - get sign
	  rcr	EDX,1		; - shift into result
	  and	EAX,0eh		; - get bottom 3 bits of fraction
	  ror	EAX,4		; - shift them to the top
	  add	EDX,(1023-127) shl 20	; - adjust exponent
	_endguess		; endguess
	ret			; return
	endproc __FSFD

	endmod
	end
