;========================================================================
;==     Name:           FSN                                            ==
;==     Operation:      Floating single negate                         ==
;==     Inputs:         DX      high word of float                     ==
;==     Outputs:        DX      new high word of float                 ==
;==     Volatile:       none                                           ==
;==     Date:           By:             Reason:                        ==
;==     10-jan-87       John Dashm      Initial implementation         ==
;==     04-jan-89       F.W.Crigger     Allow for Denormal numbers     ==
;==----------------------------------------------------Version 11.0----==
;==	25-nov-95	Greg Bentz	wasm export support            ==
;========================================================================
include mdef.inc
include struct.inc

        modstart        fsn

        xdefp   __FSN

        defpe	__FSN
        or      ax,ax           ; if number is 0
        _if     e               ; then
          or    dx,dx           ; - check other word
        _endif                  ; endif
        _if     ne              ; if number not zero
        xor     dh,80h          ; - flip the sign bit
        _endif                  ; endif
        ret                     ; and return!!!
        endproc __FSN

        endmod
        end
