;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:	by:		reason:
;  ---------	---		-------
;  04-mar-88	F.W.Crigger	F4Underflow was placing 0 in AX:BX instead
;				of AX:DX
;  18-apr-88	F.W.Crigger	changes to allow SS to be different from DGROUP
;  28-feb-90	F.W.Crigger	Call __set_ERANGE to set errno = ERANGE
;  02-aug-90	F.W.Crigger	call __FPE_handler to raise( SIGFPE )
;  22-may-91	J.B.Schueler	call __FPE_exception to raise( SIGFPE )
;  22-may-91	J.B.Schueler	Added PenPoint support
;  05-nov-92	F.W.Crigger	return true IEEE infinity
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;------------------------------------------------------Version 11.0-------
;  25-nov-95	Greg Bentz	wasm export support
;
include mdef.inc
include struct.inc
include fstatus.inc

        xref    "C",__set_ERANGE
	xref	__FPE_exception_

	modstart   fstatus

	datasegment
	enddata
	assume	ss:nothing


FPS_OK			=	0
FPS_UNDERFLOW		=	1
FPS_OVERFLOW		=	2
FPS_DIVIDE_BY_0 	=	3
FPS_BAD_ARG		=	4

jmps	macro	dsym
	jmp	short dsym
	endm


	xdefp	F8UnderFlow
	xdefp	F4UnderFlow
	xdefp	F8InvalidOp
	xdefp	F8DivZero
	xdefp	F4DivZero
	xdefp	F8OverFlow
	xdefp	F4OverFlow
	xdefp	F8RetInf_
	xdefp	_F8RetInf_

	defpe	F8UnderFlow
	sub	EDX,EDX 	; . . .

	defpe	F4UnderFlow
;;	mov	EAX,FPE_UNDERFLOW; indicate underflow
;;	call	__FPE_exception_;
	sub	EAX,EAX 	; return a zero
	ret			; return
	endproc F4UnderFlow
	endproc F8UnderFlow


	defpe	F8InvalidOp
	mov	EAX,FPE_ZERODIVIDE; indicate divide by 0
	call	__FPE_exception_;
	jmps	F8RetInf9	; return infinity
	endproc F8InvalidOp

	defpe	F8DivZero
	mov	EAX,FPE_ZERODIVIDE; indicate divide by 0
	call	__FPE_exception_;
	jmps	F8RetInf9	; return infinity
	endproc F8DivZero

	defpe	F8OverFlow
;
;	F8RetInf( sign : int ) : reallong
;
	defpe	F8RetInf_
	defpe	_F8RetInf_
	push	EAX		; save sign of result
	call	__set_ERANGE	; errno = ERANGE
	mov	EAX,FPE_OVERFLOW ; indicate overflow
	call	__FPE_exception_;
	pop	EAX		; restore sign of result
F8RetInf9: and	EAX,80000000h	; get sign
	or	EAX,7FF00000h	; set infinity
	mov	EDX,EAX		;
	sub	EAX,EAX		; ...
	ret			; return
	endproc _F8RetInf_
	endproc F8RetInf_
	endproc F8OverFlow


	defpe	F4DivZero
	mov	EAX,FPE_ZERODIVIDE; indicate divide by 0
	call	__FPE_exception_;
	jmps	F4RetInf9	; return infinity
	endproc F4DivZero

	defpe	F4OverFlow
	defp	F4RetInf	; return infinity
	push	EAX		; save sign of result
	call	__set_ERANGE	; errno = ERANGE
	mov	EAX,FPE_OVERFLOW ; indicate overflow
	call	__FPE_exception_;
	pop	EAX		; restore sign of result
F4RetInf9: and	EAX,80000000h	; get sign
	or	EAX,7F800000h
	ret
	endproc F4RetInf
	endproc F4OverFlow


	endmod
	end
