;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;--------------------------------------------------------------------
;  modified:      by:           reason:
;  ---------      ---           -------
;  20-feb-89    F.W.Crigger     initial implementation
;------------------------------------------------------Version 11.0-------
;  25-nov-95	Greg Bentz	wasm export support
;
include mdef.inc
include struct.inc

        modstart        i4fd

        xdefp   __I4FD
        xdefp   __U4FD

;[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]
;[]
;[] __I4FD      convert signed 32-bit integer in EAX into double float
;[] __U4FD      convert unsigned 32-bit integer in EAX into double float
;[]     Input:  EAX         - 32-bit integer
;[]     Output: EDX:EAX     - double precision representation of integer
;[]
;[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]

        defpe	__I4FD
        or      EAX,EAX         ; if number is negative
        _if     s               ; then
          neg   EAX             ; - negate number
          mov   EDX,00000BFFh   ; - set exponent
        _else                   ; else

;       convert unsigned 32-bit integer to double

        defpe	__U4FD
	  mov   EDX,000003FFh   ; - set exponent
        _endif                  ; endif
        or      EAX,EAX         ; if number is not zero
        _if     ne              ; then
          push  ECX             ; - save ECX
          bsr   ECX,EAX         ; - find most significant non-zero bit
          mov   CH,CL           ; - save shift count
          mov   CL,31           ; - calculate # of bits to shift by
          sub   CL,CH           ; - ...
          shl   EAX,CL          ; - shift bits into position
          _shl  EAX,1           ; - one more to get rid of implied 1 bit
          mov   CL,CH           ; - get shift count
          movzx ECX,CH          ; - get shift count
          add   ECX,EDX         ; - calculate exponent
          mov   EDX,EAX         ; - get the bits
          and   EDX,0FFFFF000h  ; - keep 20 bits
          or    EDX,ECX         ; - get exponent in there
          ror   EDX,12          ; - rotate into position
          shl   EAX,20          ; - get last 12 bits into place
          pop   ECX             ; - restore ECX
          ret                   ; - return
        _endif                  ; endif
        sub     EDX,EDX         ; zero EDX
        ret                     ; return

        endproc __U4FD
        endproc __I4FD

        endmod
        end
