;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:	  by:		reason:
;  ---------	  ---		-------
;  24-sep-86	F.W.Crigger	initial implementation
;  26-aug-88	F.W.Crigger	optimized
;  09-sep-91	J.B.Schueler	Added __8087 xref
;------------------------------------------------------Version 11.0-------
;  25-nov-95	Greg Bentz	wasm export support
;
include mdef.inc
include struct.inc

.8087
	xref		__8087	; indicate that NDP instructions are present

	modstart	i4fd

	xdefp	__I4FD
	xdefp	__U4FD
	xdefp	__FDU4

;
; __I4FD      convert signed 32-bit integer in DX:AX into double float
; __U4FD      convert unsigned 32-bit integer in DX:AX into double float
;     Input:  DX:AX	  - 32-bit integer
;     Output: AX BX CX DX - double precision representation of integer
;

	defpe	__I4FD
	or	DX,DX		; if number is negative
	_if	s		; then
	  not	DX		; - negate number
	  neg	AX		; - . . .
	  sbb	DX,-1		; - . . .
	_endif			; endif

;	convert unsigned 32-bit integer to double

	defpe	__U4FD
	push	BP
	sub	SP,4
	push	DX
	push	AX
	mov	BP,SP
	fild	dword ptr 0[BP]
	fstp	qword ptr 0[BP]
	fwait
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	pop	BP
	ret			; return
	endproc __I4FD
	endproc __U4FD


	defpe	__FDU4
	push	BP
	push	AX
	push	BX
	push	CX
	push	DX
	mov	BP,SP
	fld	qword ptr 0[bp]
	fistp	dword ptr 4[BP]
	add	SP,4
	fwait
	pop	AX
	pop	DX
	pop	BP
	ret
	endproc __FDU4

	endmod
	end
