;========================================================================
;==     Name:           I4M,U4M                                        ==
;==     Operation:      integer four byte multiply                     ==
;==     Inputs:         DX;AX   integer M1                             ==
;==                     CX;BX   integer M2                             ==
;==     Outputs:        DX;AX   product                                ==
;==     Volatile:       CX, BX destroyed                               ==
;==     Date:           By:             Reason:                        ==
;==     85-10-02        David Yach      Initial implementation         ==
;==---------------------------------------------------Version 6.5--------
;==     30-aug-88       F.W.Crigger     avoid multiplies by 0          ==
;========================================================================
include mdef.inc
include struct.inc

        modstart        i4m

        xdefp   __I4M
        xdefp   __U4M

        defp    __I4M
        defp    __U4M
        xchg    ax,bx           ; swap low(M1) and low(M2)
        push    ax              ; save low(M2)
        xchg    ax,dx           ; exchange low(M2) and high(M1)
        or      ax,ax           ; if high(M1) non-zero
        _if     ne              ; then
          mul   dx              ; - low(M2) * high(M1)
        _endif                  ; endif
        xchg    ax,cx           ; save that in cx, get high(M2)
        or      ax,ax           ; if high(M2) non-zero
        _if     ne              ; then
          mul   bx              ; - high(M2) * low(M1)
          add   cx,ax           ; - add to total
        _endif                  ; endif
        pop     ax              ; restore low(M2)
        mul     bx              ; low(M2) * low(M1)
        add     dx,cx           ; add previously computed high part
        ret                     ; and return!!!
        endproc __U4M
        endproc __I4M

        endmod
        end
