;========================================================================
;==     Name:           I8LS,U8LS                                      ==
;==     Operation:      integer eight byte left shift                  ==
;==     Inputs:         AX:BX:CX:DX integer M1                         ==
;==                     SI          shift count                        ==
;==     Outputs:        AX:BX:CX:DX result                             ==
;==     Date:           By:             Reason:                        ==
;==     96/07/14	B.J. Stecher	initial implementation	       ==
;========================================================================
include mdef.inc
include struct.inc

        modstart        i8ls

        xdefp   __I8LS
        xdefp   __U8LS
	
        defp    __I8LS
        defp    __U8LS
	test	si,si			; shifting anything?
	_if	ne			; if so then
	  _loop				; - top of loop
	    shl	dx,1			; - - shift one bit
	    rcl cx,1			; - - ...
	    rcl bx,1			; - - ...
	    rcl ax,1			; - - ...
	    dec	si			; - - decrement shift count
	  _until e			; - kick out if done
	_endif				; endif
	ret
        endproc __U8LS
        endproc __I8LS

        endmod
        end
