;========================================================================
;==     Name:           I8M,U8M                                        ==
;==     Operation:      integer eight byte multiply                    ==
;==     Inputs:         EDX;EAX   integer M1                           ==
;==                     ECX;EBX   integer M2                           ==
;==     Outputs:        EDX;EAX   product                              ==
;==     Volatile:       ECX, EBX destroyed                             ==
;==     Date:           By:             Reason:                        ==
;==     28-may-96       B.B.Brisco      created                        ==
;==     30-may-96       G.R.Bentz	claimed ownership              ==
;========================================================================
include mdef.inc
include struct.inc

        modstart        i8m

        xdefp   __I8M
        xdefp   __U8M

        defpe   __I8M
        defpe   __U8M
	
	test	edx,edx		; first check for easy (hiwords == 0) case
	jnz	L1
	test	ecx,ecx
	jnz	L1
	mul	ebx
	ret
	
L1:	push	eax		; save M1.l
	push	edx		; save M1.h
	mul	ecx		; calc M1.l * M2.h -> eax
	mov	ecx,eax		; save M1.l * M2.h in ecx
	pop	eax		; get  M1.h in eax
	mul	ebx		; calc M1.h * M2.l -> eax
	add	ecx,eax		; add  above to previous total
	pop	eax		; get  M1.l in eax
	mul	ebx		; calc M1.l * M2.l -> edx:eax
	add	edx,ecx		; add previous hiword contribs to hiword
        ret                     ; and return!!!
	
        endproc __U8M
        endproc __I8M

        endmod
        end
