;========================================================================
;==     Name:           I8RS                                           ==
;==     Operation:      integer eight byte right shift (signed)        ==
;==     Inputs:         AX:BX:CX:DX integer M1                         ==
;==                     SI          shift count                        ==
;==     Outputs:        AX:BX:CX:DX result                             ==
;==     Date:           By:             Reason:                        ==
;==     96/07/14	B.J. Stecher	initial implementation	       ==
;========================================================================
include mdef.inc
include struct.inc

        modstart        i8rs

        xdefp   __I8RS
	
        defp    __I8RS
	test	si,si			; shifting anything?
	_if	ne			; if so then
	  _loop				; - top of loop
	    sar	ax,1			; - - shift one bit
	    rcr bx,1			; - - ...
	    rcr cx,1			; - - ...
	    rcr dx,1			; - - ...
	    dec	si			; - - decrement shift count
	  _until e			; - kick out if done
	_endif				; endif
	ret
        endproc __I8RS

        endmod
        end
