;========================================================================
;==     Name:           I8S                                            ==
;==     Operation:      integer eight byte shift                       ==
;==     Inputs:         EDX;EAX   integer M1                           ==
;==                     ECX;EBX   integer M2                           ==
;==     Outputs:        EDX;EAX   product                              ==
;==     Volatile:       ECX, EBX destroyed                             ==
;==     Date:           By:             Reason:                        ==
;==     28-may-96       B.B.Brisco      created                        ==
;==     30-may-96       G.R.Bentz	claimed ownership              ==
;========================================================================
include mdef.inc
include struct.inc

        modstart        i8s

        xdefp   __U8RS

        defpe   __U8RS
	
	and	ebx,03fH	; get mod 64 shift count
	test	bl,060H		; see if count > 32
	jnz	L1
	mov	ecx,ebx
	shrd	eax,edx,cl
	shr	edx,cl
        ret                     ; and return!!!
	
L1:
	mov	ecx,ebx		; get shift-count into cl
	mov	eax,edx
	sub	ecx,020H	; knock off 32-bits of shifting
	xor	edx,edx		; zero extend result
	shr	eax,cl
	ret
	
        endproc __U8RS

        xdefp   __I8RS

        defpe   __I8RS
	
	and	ebx,03fH	; get mod 64 shift count
	test	bl,060H		; see if count >= 32
	jnz	L2
	mov	ecx,ebx
	shrd	eax,edx,cl
	sar	edx,cl
        ret                     ; and return!!!
	
L2:
	mov	ecx,ebx		; get shift-count into cl
	mov	eax,edx
	sub	ecx,020H	; knock off 32-bits of shifting
	sar	edx,31		; sign extend hi-word
	sar	eax,cl
	ret
	
        endproc __I8RS

        xdefp   __I8LS
        xdefp   __U8LS

        defpe   __I8LS
        defpe   __U8LS
	
	and	ebx,03fH	; get mod 64 shift count
	test	bl,060H		; see if count > 32
	jnz	L3
	mov	ecx,ebx
	shld	edx,eax,cl
	shl	eax,cl
        ret                     ; and return!!!
	
L3:
	mov	ecx,ebx
	mov	edx,eax
	sub	ecx,020H	; knock off 32-bits of shifting
	xor	eax,eax
	shl	edx,cl
	ret
	
        endproc __U8LS
        endproc __I8LS
        endmod
        end
