;========================================================================
;==     Name:           I4FS, U4FS                                     ==
;==     Operation:      Convert Integer types to single precision      ==
;==     Inputs:         EAX,   unsigned or signed integer              ==
;==     Outputs:        EAX   single precision floating point          ==
;==     Volatile:       none                                           ==
;==                                                                    ==
;==     Date:           By:             Reason:                        ==
;==     20-feb-89       F.W.Crigger     Initial implementation         ==
;==----------------------------------------------------Version 11.0----==
;==	25-nov-95	Greg Bentz	wasm export support            ==
;========================================================================
include mdef.inc
include struct.inc

        modstart        ifs

        xdefp   __I4FS
        xdefp   __U4FS


        defpe	__U4FS
        or      EAX,EAX         ; if number is not zero
        _if     ne              ; then
          push  ECX             ; - save ECX
          bsr   ECX,EAX         ; - find most significant non-zero bit
          mov   CH,CL           ; - save shift count
          neg   CL              ; - calculate # of bits to rotate by
          add   CL,23           ; - ...
          and   CL,1fh          ; - just keep last 5 bits
          rol   EAX,CL          ; - shift bits into position
          and   EAX,007FFFFFh   ; - mask out sign and exponent bits
          mov   CL,CH           ; - get shift count
          add   CL,7Fh          ; - calculate exponent
          and   ECX,0FFh        ; - isolate exponent
          shl   ECX,23          ; - shift exponent into position
          or    EAX,ECX         ; - place into result
          pop   ECX             ; - restore ECX
        _endif                  ; endif
        ret                     ; return

        endproc __U4FS

        defpe	__I4FS
        or      EAX,EAX         ; check sign
        jns     __U4FS          ; if positive, just convert
        neg     EAX             ; take absolute value of number
        call    __U4FS          ; convert to FS
        or      EAX,80000000h   ; set sign bit on
        ret                     ; and return
        endproc __I4FS

        endmod
        end
