;========================================================================
;==     Name:           LDIV                                           ==
;==     Operation:      Signed 4 byte divide                           ==
;==     Inputs:         DX;AX   Dividend                               ==
;==                     CX;BX   Divisor                                ==
;==                     SS:SI   pointer to result structure            ==
;==     Outputs:        DX;AX   Quotient                               ==
;==                     CX;BX   Remainder (same sign as dividend)      ==
;==     Volatile:       none                                           ==
;==     Date:           By:             Reason:                        ==
;==     88-09-22        F.W.Crigger     Initial implementation         ==
;==	95-03-12	Greg Bentz	remove _ from "C" symbols      ==
;==	95-11-25	Greg Bentz	wasm export support	       ==
;========================================================================
include mdef.inc
include struct.inc

        xref    __I4D
	
        modstart        ldiv

        defpe	ldiv
        xdefp   "C",ldiv
        docall  __I4D           ; do the division
    if _MODEL and (_BIG_DATA or _HUGE_DATA)
        mov     ss:[si],ax      ; store quotient
        mov     ss:2[si],dx     ; ...
        mov     ss:4[si],bx     ; store remainder
        mov     ss:6[si],cx     ; ...
    else
        mov     [si],ax         ; store quotient
        mov     2[si],dx        ; ...
        mov     4[si],bx        ; store remainder
        mov     6[si],cx        ; ...
    endif
        ret                     ; return
        endproc ldiv

        endmod
        end
