;========================================================================
;==     Name:           LDIV                                           ==
;==     Operation:      Signed 4 byte divide                           ==
;==     Inputs:         EAX     Dividend                               ==
;==                     EDX     Divisor                                ==
;==                     SS:ESI  pointer to result structure            ==
;==     Volatile:       none                                           ==
;==     Date:           By:             Reason:                        ==
;==     88-09-22        F.W.Crigger     Initial implementation         ==
;==     89-03-10        F.W.Crigger     Adapted for 386                ==
;==	95-03-12	Greg Bentz	remove extra _ from "C" symbols==
;==	95-11-25	Greg Bentz	wasm export support	       ==
;==	97-01-29	Greg Bentz	p5 profiling macros	       ==
;==	97-04-29	Greg Bentz	force recompile		       ==
;========================================================================
include mdef.inc
include struct.inc

ifdef _PROFILE
include p5prof.inc
endif
        modstart        ldiv

	defpe	div
	xdefp	"C",div
        defpe   ldiv
        xdefp   "C",ldiv
    ifdef _PROFILE
	P5Prolog
    endif
    ifdef __STACK__
        mov     EDX,8[ESP]      ; get divisor
        mov     EAX,4[ESP]      ; get numerator
    endif
        push    EBX             ; save EBX
        mov     EBX,EDX         ; get divisor
        cdq                     ; sign extend dividend
        idiv    EBX             ; do the divide
        mov     [ESI],EAX       ; store quotient
        mov     4[ESI],EDX      ; store remainder
        pop     EBX             ; restore EBX
    ifdef _PROFILE
	P5Epilog
    endif
        ret                     ; return
        endproc ldiv
	endproc div

        endmod
        end
