;========================================================================
;==     Name:           PCA PCS                                        ==
;==     Operation:      Pointer plus long integer                      ==
;==     Inputs:         es:bx pointer                                  ==
;==                     ds:ax long int                                 ==
;==     Outputs:        es:bx has es:bx op ds:ax as  pointer           ==
;==     Volatile:       DX:AX and CX:BX                                ==
;==                                                                    ==
;==     Date:           By:             Reason:                        ==
;==     87-09-25        John Dahms      Initial implementation         ==
;==                                                                    ==
;========================================================================
include mdef.inc

        modstart        pca

        xdefp   __PCA
        xdefp   __PCS

        defp    __PCS
        neg     dx              ; negate the 32 bit integer
        neg     ax              ; ...
        sbb     dx,0            ; ...

        defp    __PCA
        push    cx              ; need a register
        add     bx,ax           ; add low part of integer into offset
        adc     dx,0            ; propagate carry into high part of integer
        mov     cl,4            ; adjust high part into segment position
        ror     dx,cl           ; ...
        and     dx,0f000h       ; ...
        mov     ax,es           ; and add to segment
        add     ax,dx           ; ... (new unnormalized pointer is now in ax:bx)
        mov     dx,bx           ; make a copy of the new offset
        shr     dx,cl           ; adjust into segment position
        add     ax,dx           ; add into segment
        and     bx,000fh        ; clear high 12 bits of new offset
        mov     es,ax           ; resulting in normalized pointer in es:bx
        pop     cx              ; restore a register
        ret                     ; ...
        endproc __PCA
        endproc __PCS

        endmod
        end
