;========================================================================
;==     Name:           PIA,PIS                                        ==
;==     Operation:      Pointer integer add and subtract               ==
;==     Inputs:         DX:AX pointer                                  ==
;==                     CX:BX long int                                 ==
;==     Outputs:        DX:AX has DX:AX op CX:BX as  pointer           ==
;==     Volatile:       DX:AX and CX:BX                                ==
;==                                                                    ==
;==     Date:           By:             Reason:                        ==
;==     88-09-20        John Dahms      Initial implementation         ==
;==     10-aug-89       John Dahms      adapted for OS/2               ==
;=	22-sep-92	F.W.Crigger	Don't cause segment fixup in    =
;=					large data models in Windows	=
;==	29-jun-94	Brad Brisco	don't push/pop DS if we don't	=
;==					need to modify it		=
;==                                                                    ==
;========================================================================
include mdef.inc


extrn  __HShift        : byte

        modstart        pia

        xdefp   __PIA
        xdefp   __PIS

        defp    __PIS
        neg     cx              ; negate the 32 bit integer
        neg     bx              ; ...
        sbb     cx,0            ; ...

        defp    __PIA
        add     ax,bx           ; add offsets
        adc     cx,0            ; calculate overflow
        mov     bx,cx           ; shuffle overflow info bx
if (_MODEL and (_BIG_DATA or _HUGE_DATA)) and ((_MODEL and _DS_PEGGED) eq 0)
        push    ds              ; need a segment register
        mov     cx,seg __HShift ; get the huge shift value
        mov     ds,cx           ; ...
        mov     cl,ds:__HShift  ; ...
        pop     ds              ; restore register
else
        mov     cl,__HShift	; get huge shift value
endif
        shl     bx,cl           ; adjust the overflow by huge shift value
        add     dx,bx           ; and add into selector value
        ret                     ; ...
        endproc __PIA
        endproc __PIS

        endmod
        end
