;=========================================================================
;==	Name:		SHLD						==
;==	Operation:	shift left double (long)			==
;==	Inputs: 	DX:AX	long integer to be shifted		==
;==			CX	integer shift count			==
;==	Outputs:	DX:AX	DX:AX << CX 				==
;==	Volatile:	CX destroyed					==
;==	Date:		By:		Reason: 			==
;==	18-dec-91	F.W.Crigger	Initial implementation		==
;=========================================================================
include mdef.inc
include struct.inc

	modstart	shld

	xdefp	__SHLD

	defp	__SHLD
	cmp	CL,16			; if shift count >= 16
	_if	ae			; then
	  mov	DX,AX			; - shift left by 16
	  sub	CL,16			; - adjust shift count
	  sub	AX,AX			; - zero low word
	  shl	DX,CL			; - shift the top word by (count-16)
	  ret				; - return
	_endif				; endif
;
;	CL < 16
;
	push	SI			; save work reg
	shl	DX,CL			; shift top part
	rol	AX,CL			; rotate bottom part
	xor	DX,AX			; merge bottom bits of AX into DX
	mov	SI,0FFFFh		; calc mask of bits to keep
	shl	SI,CL			; ...
	and	AX,SI			; mask off unwanted bits
	xor	DX,AX			; restore top bits of DX
	pop	SI			; restore SI
	ret				; return
	endproc __SHLD

	endmod
	end
