;=========================================================================
;==	Name:		SHRD						==
;==	Operation:	shift right double (long)			==
;==	Inputs: 	DX:AX	long integer to be shifted		==
;==			CX	integer shift count			==
;==	Outputs:	DX:AX	DX:AX >> CX 				==
;==	Volatile:	CX destroyed					==
;==	Date:		By:		Reason: 			==
;==	18-dec-91	F.W.Crigger	Initial implementation		==
;=========================================================================
include mdef.inc
include struct.inc

	modstart	shrd

	xdefp	__SHRD

	defp	__SHRD
	cmp	CL,16			; if shift count >= 16
	_if	ae			; then
	  mov	AX,DX			; - shift right by 16
	  sub	CL,16			; - adjust shift count
	  sub	DX,DX			; - zero high word
	  shr	AX,CL			; - shift the low word by (count-16)
	  ret				; - return
	_endif				; endif
;
;	CL < 16
;
	push	SI			; save work reg
	shr	AX,CL			; shift bottom part
	ror	DX,CL			; rotate top part
	xor	AX,DX			; merge top bits of DX into AX
	mov	SI,0FFFFh		; calc mask of bits to keep
	shr	SI,CL			; ...
	and	DX,SI			; mask off unwanted bits
	xor	AX,DX			; restore bottom bits of AX
	pop	SI			; restore SI
	ret				; return
	endproc __SHRD

	endmod
	end
