/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1995, by WATCOM International Corp. All rights %
 *%       reserved. No part of this software may be reproduced         %
 *%       in any form or by any means - graphic, electronic or         %
 *%       mechanical, including photocopying, recording, taping        %
 *%       or information storage and retrieval systems - except        %
 *%       with the written permission of WATCOM Internation Corp.      %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  95/06/08	B.J. Stecher	created
  96/06/03	Greg Bentz	cloned from \watcom\c\i64.c

	64-bit integer operations
*/

#include "variety.h"
#include "clibi64.h"

/*
	Be careful of overlap between input parameters and output results.
*/

_WCRTLINK void __U64Add( const UINT64_TYPE *a, const UINT64_TYPE *b, UINT64_TYPE *res )
{
    unsigned_32	new;
    
    res->u._32[I64HI32] = a->u._32[I64HI32] + b->u._32[I64HI32];
    new = a->u._32[I64LO32] + b->u._32[I64LO32];
    if( new < a->u._32[I64LO32] ) ++res->u._32[I64HI32];
    res->u._32[I64LO32] = new;
}
