/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1995, by WATCOM International Corp. All rights %
 *%       reserved. No part of this software may be reproduced         %
 *%       in any form or by any means - graphic, electronic or         %
 *%       mechanical, including photocopying, recording, taping        %
 *%       or information storage and retrieval systems - except        %
 *%       with the written permission of WATCOM Internation Corp.      %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  95/06/08	B.J. Stecher	created
  96/06/03	Greg Bentz	cloned from \watcom\c\i64.c

	64-bit integer operations
*/

#include "variety.h"
#include "clibi64.h"

/*
	Be careful of overlap between input parameters and output results.
*/

_WCRTLINK void __U64Mul( const UINT64_TYPE *a, const UINT64_TYPE *b, UINT64_TYPE *res )
{
    UINT64_TYPE		tmp_a;
    UINT64_TYPE		tmp_b;

    tmp_a = *a;
    tmp_b = *b;

    res->u._32[I64LO32] = 0;
    res->u._32[I64HI32] = 0;
    while( tmp_b.u._32[I64LO32] != 0 || tmp_b.u._32[0] != 0 ) {
	if( tmp_b.u._32[I64LO32] & 1 ) __U64Add( &tmp_a, res, res );
	__U64Shift( &tmp_a, -1, &tmp_a );
	__U64Shift( &tmp_b, 1, &tmp_b );
    }
}
