/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1995, by WATCOM International Corp. All rights %
 *%       reserved. No part of this software may be reproduced         %
 *%       in any form or by any means - graphic, electronic or         %
 *%       mechanical, including photocopying, recording, taping        %
 *%       or information storage and retrieval systems - except        %
 *%       with the written permission of WATCOM Internation Corp.      %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  95/06/08	B.J. Stecher	created
  96/06/03	Greg Bentz	cloned from \watcom\c\i64.c

	64-bit integer operations
*/

#include <stddef.h>
#include "variety.h"
#include "clibi64.h"

/*
	Be careful of overlap between input parameters and output results.
*/

_WCRTLINK void __U64Shift( const UINT64_TYPE *a, int shift, UINT64_TYPE *res )
{
    unsigned_32		save;

    if( shift < 0 ) {
	/* left shift */
	shift = -shift;
	save = a->u._32[I64LO32];
	res->u._32[I64LO32] = a->u._32[I64LO32] << shift;
	res->u._32[I64HI32] = a->u._32[I64HI32] << shift;
	res->u._32[I64HI32] |= save >> (32-shift);
    } else {
	/* right shift */
	save = a->u._32[I64HI32];
	res->u._32[I64HI32] = a->u._32[I64HI32] >> shift;
	res->u._32[I64LO32] = a->u._32[I64LO32] >> shift;
	res->u._32[I64LO32] |= save << (32-shift);
    }
}
