;========================================================================
;=	Name:		PTS//PTC					=
;=	Operation:	Pointer subtract				=
;=	Inputs: 	DX:AX pointer					=
;=			CX:BX pointer					=
;=	Outputs:	DX:AX has DX:AX - CX:BX as signed integer (PTS) =
;=				  DX:AX cmp CX:BX as an unsigned  (PTC) =
;=	Volatile:	DX:AX and CX:BX 				=
;=									=
;=	Date:		By:		Reason: 			=
;=	87-09-25	John Dahms	Initial implementation		=
;=	10-aug-89	John Dahms	adapted for OS/2		=
;=	21-jun-91	A.F.Scian	rewritten and included __PTC	=
;=			(and John D.)	^				=
;=	06-nov-91	F.W.Crigger	Don't cause segment fixup in    =
;=					small data models		=
;=	22-sep-92	F.W.Crigger	Don't cause segment fixup in    =
;=					large data models in Windows	=
;=									=
;========================================================================

compare_subtract	macro name

include mdef.inc

extrn	__HShift	: byte

	modstart	&name

	xdefp	&name

	defp	&name

	push	si
	push	di
	push	cx

;
; this code changes the two pointers in dx:ax and cx:bx into representative
; integers in dx:ax and di:bx
;
; a representative integer for seg:off is:
;
; ((long) seg >> hshift ) + off
;
; the trick for getting the long shift to work without any loops is as follows:
;
; lo word = seg << ( 16 - hshift )
; hi word = seg >> hshift
;
; these shifts truncate useless info since they're logical shifts
;

	mov	si,dx
	mov	di,cx

if (_MODEL and (_BIG_DATA or _HUGE_DATA)) and ((_MODEL and _DS_PEGGED) eq 0)
	push	ds		; save segment register
	mov	cx,seg __HShift ; get huge shift value
	mov	ds,cx		; ...
	mov	cl,ds:__HShift	; prepare to shift
	pop	ds		; restore segment register
else
	mov	cl,__HShift	; get huge shift value
endif

	shr	dx,cl
	shr	di,cl

	neg	cl
	add	cl,16

	shl	si,cl

	add	ax,si
	adc	dx,0

	pop	si		; get old cx value

	shl	si,cl

	add	bx,si
	adc	di,0

	do_stuff dx,ax,di,bx

	pop	di
	pop	si
	ret			 ; and return 32 bit integer in dx:ax

	endproc &name		 ;

	endmod
	end
	endm
