/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
  06-mar-95	M. Hildebrand	Initial implementation.
  22-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <ctype.h>
#include <wchar.h>
#include "wctype.h"



/****
***** Determine if the given character is of the specified type.
****/

_WCRTLINK int iswctype( wint_t wc, wctype_t desc )
{
    switch( desc ) {
      case WCTYPE_ALNUM:   return( iswalnum( wc ) );
      case WCTYPE_ALPHA:   return( iswalpha( wc ) );
      case WCTYPE_CNTRL:   return( iswcntrl( wc ) );
      case WCTYPE_DIGIT:   return( iswdigit( wc ) );
      case WCTYPE_GRAPH:   return( iswgraph( wc ) );
      case WCTYPE_LOWER:   return( iswlower( wc ) );
      case WCTYPE_PRINT:   return( iswprint( wc ) );
      case WCTYPE_PUNCT:   return( iswpunct( wc ) );
      case WCTYPE_SPACE:   return( iswspace( wc ) );
      case WCTYPE_UPPER:   return( iswupper( wc ) );
      case WCTYPE_XDIGIT:  return( iswxdigit( wc ) );
      default:		   return( 0 );
    }
}
