/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  24-aug-88     F.W.Crigger     Initial implementation
  27-jan-92	F.W.Crigger	Add 386 specific pragma
  27-jan-94	Kevin Hui	Added default windowing support
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  22-may-95	Greg Bentz	dll linkage
*/

#include "variety.h"
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include "defwin.h"

#ifdef DEFAULT_WINDOWING
    extern int __qread( int, char *, unsigned );
#endif

extern  void    _dos_kb_input();
extern  void    _bd_dos_kb_input();

#if defined(__386__)
#pragma aux     _dos_kb_input =     \
                                    0xb4 0x0a   /* select keyboard input */\
                                    0xcd 0x21   /* int 21h */\
                        parm caller [edx];

#pragma aux     _bd_dos_kb_input =  0x1e        /* push ds */\
                                    0x8e 0xd8   /* mov ds,ax */\
                                    0xb4 0x0a   /* select keyboard input */\
                                    0xcd 0x21   /* int 21h */\
                                    0x1f        /* pop ds */\
                        parm caller [ax] [edx];
#elif defined(M_I86)
#pragma aux     _dos_kb_input =     \
                                    0xb4 0x0a   /* select keyboard input */\
                                    0xcd 0x21   /* int 21h */\
                        parm caller [dx];

#pragma aux     _bd_dos_kb_input =  0x1e        /* push ds */\
                                    0x8e 0xd8   /* mov ds,ax */\
                                    0xb4 0x0a   /* select keyboard input */\
                                    0xcd 0x21   /* int 21h */\
                                    0x1f        /* pop ds */\
                        parm caller [ax] [dx];
#else
#error platform not supported
#endif

_WCRTLINK char *cgets( char *s )
    {
        int len;
        char *p;

	#ifdef DEFAULT_WINDOWING
	    if( _WindowsStdin != 0 ) {	// Default windowing
		__qread( STDIN_FILENO, s + 2, *s - 1 );
		p = s + 2;
		len = *s;
		for(;;) {
		    if( len <= 1 ) break;
		    if( *p == '\r' || *p == '\0' ) break;
		    ++p;
		    --len;
		}
		*p = '\0';
		s[1] = p - s - 2;
		return( s + 2 );
	    }
	#endif
	#if defined(__SMALL_DATA__)
	    _dos_kb_input( s );
	#else
	    _bd_dos_kb_input( FP_SEG(s), FP_OFF(s) );
	#endif
	len = *s;
	p = s + 2;
	for(;;) {
	    if( len <= 1 ) break;
	    if( *p == '\r' ) break;
	    ++p;
	    --len;
	}
	*p = '\0';
	return( s + 2 );
    }
