/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  06-mar-92     Craig Eisler    defined for NT
  21-jan-94	Kevin Hui	fixed bugs; made use of the routines in
  				CONUTWNT.
  24-jan-94	Kevin Hui	default windowing system support.
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage

*/
#include "variety.h"
#include <windows.h>
#include <conio.h>
#include "ntex.h"
#include "fileacc.h"
#include "defwin.h"

#define BACKSPACE	8
#define SPACE		' '
#define CRLF		13

extern int __qread( int, char *, unsigned );

_WCRTLINK char *cgets( char *buff )
{
    char *p;
    char len;
    DWORD n;
    HANDLE h;
    INPUT_RECORD r;

    if( _WindowsStdin != 0 ) {	// Default windowing...
	__qread( STDIN_FILENO, buff + 2, *buff - 1 );
	p = buff + 2;
	len = *buff;
	for(;;) {
	    if( len <= 1 ) break;
	    if( *p == '\r' || *p == '\0' ) break;
	    ++p;
	    --len;
	}
	*p = '\0';
	buff[1] = p - buff - 2;
	return( buff + 2 );
    }
    _AccessFileH( STDIN_FILENO );
    h = __NTConsoleInput();	// obtain a console input handle
    for( p = buff + 2, len = *buff; ; ) {
	ReadConsoleInput( h, &r, 1, &n );
	if( __NTRealKey( &r ) ) {	// Only interested in real keys
	    if( r.Event.KeyEvent.uChar.AsciiChar == CRLF ) {
		*p = '\0';
		break;
	    }
	    for( ; r.Event.KeyEvent.wRepeatCount > 0;
	    	 --r.Event.KeyEvent.wRepeatCount ) {
		// Deal with backspace first...
		if( r.Event.KeyEvent.uChar.AsciiChar == BACKSPACE ) {
		    if( p > buff + 2 ) {
			putch( BACKSPACE );
			putch( SPACE );
			putch( BACKSPACE );
			--p;
			++len;
		    }
		} else if( len > 1 ) { // Other real chars...
		    *p = r.Event.KeyEvent.uChar.AsciiChar;
		    putch( r.Event.KeyEvent.uChar.AsciiChar );
		    ++p;
		    --len;
		} // Otherwise: len <= 1, can't type more.
	    }
	}
    }
    _ReleaseFileH( STDIN_FILENO );
    buff[1] = p - buff - 2;
    return( buff + 2 );
}
