/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1993, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  NT console utility routines

  Modified:     By:             Reason:
  ---------     ---             -------
  22-oct-93	A.F.Scian	defined
  03-mar-95	Greg Bentz	retry next time if open fails
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  13-mar-96	Greg Bentz	tweak typing inconsistencies
*/
#include "variety.h"
#include <io.h>
#include <windows.h>
#include "ntex.h"
#include "rtdata.h"
#include "fileacc.h"

static HANDLE console_in = (HANDLE)-1;
static HANDLE console_out = (HANDLE)-1;

int __NTRealKey( INPUT_RECORD *k )
{
    if( k->EventType == KEY_EVENT ) {
	if( k->Event.KeyEvent.bKeyDown ) {
	    switch( k->Event.KeyEvent.wVirtualKeyCode ) {
	    case VK_SHIFT:
	    case VK_CONTROL:
	    case VK_MENU:	/* Alt */
		return( 0 );
	    }
	    return( 1 );
	}
    }
    return( 0 );
}

static void initConsoleHandles( void )
{
    _AccessFileH( STDIN_FILENO );
    if( console_in == (HANDLE)-1 ) {
	console_in = CreateFile( "conin$",
				 GENERIC_READ, FILE_SHARE_READ, NULL,
				 OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0 );
    }
    if( console_out == (HANDLE)-1 ) {
	console_out = CreateFile( "conout$",
	   			  GENERIC_WRITE, FILE_SHARE_WRITE, NULL,
				  OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0 );
    }
    _ReleaseFileH( STDIN_FILENO );
}

HANDLE __NTConsoleInput( void )
{
    initConsoleHandles();
    return( console_in );
}

HANDLE __NTConsoleOutput( void )
{
    initConsoleHandles();
    return( console_out );
}
