/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1988 by WATCOM Systems Inc. All rights      %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  24-aug-88     F.W.Crigger     Created from sprintf.c
  29-nov-88     F.W.Crigger     vcprintf added
  26-oct-90     B.J.Stecher     Added shared library support
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  03-aug-95	T. Schiller	Updated SPECS references.
  01-nov-95     Greg Bentz	QNX -3s register convention
*/

#include "variety.h"
#include <stdio.h>
#include <conio.h>
#include <stdarg.h>
#include "printf.h"

/*
 * con_putc -- output character to console
 */
static slib_callback_t con_putc; // setup calling convention
static void __SLIB_CALLBACK con_putc( SPECS __SLIB *specs, int op_char )
    {
        putch( op_char );
        specs->_o._output_count++;
    }


_WCRTLINK int vcprintf( const char *format, va_list arg )
    {
	slib_callback_t *tmp;

	#if defined(__386__) && defined(__QNX__)
	    /* avoid some segment relocations for 32-bit QNX */
	    tmp = (void (*)())con_putc;
	#else
	    tmp = con_putc;
	#endif
	return __prtf( NULL, format, arg, tmp );
    }


_WCRTLINK int cprintf( const char *format, ... )
    {
        auto    va_list         args;
	slib_callback_t		*tmp;

        va_start( args, format );
	#if defined(__386__) && defined(__QNX__)
	    /* avoid some segment relocations for 32-bit QNX */
	    tmp = (void (*)())con_putc;
	#else
	    tmp = con_putc;
	#endif
        return __prtf( NULL, format, args, tmp );
    }

