/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  09-aug-89     John Dahms      defined for OS/2
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi       support OS/2 2.0
  15-may-92     D.J.Gaudet      fixed OS/2 2.0 support
  26-aug-92     J.B.Schueler    in DOS mode, use dos call since KbdCharIn uses
                                BIOS calls which don't work on NEC
  26-jan-94	Kevin Hui	added default windowing support
  12-sep-94	Greg Bentz	check for detached processes
--------------------------------------------------------Version-11.0---------
  20-mar-95	M. Hildebrand	Undefine CHAR_TYPE before including rtdata.h, so
				sigdefn.h won't complain.
  22-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <stdio.h>
#include <stdlib.h>
#define INCL_16
#define INCL_SUB
#include <wos2.h>
#include "rtdata.h"
#include "defwin.h"

#if defined(__OS2_286__)
    extern  unsigned char _dos(char);
    #pragma aux _dos = 0xcd 0x21 /* int 21h */ parm caller [ah] value [al];
#endif

_WCRTLINK int getch()
    {
        char c;

        if( ( c = _RWD_cbyte ) != 0 ) {
            _RWD_cbyte = 0;
            return( c );
        }
	if( _WindowsGetch != 0 ) {	// Default windowing
	    LPWDATA	res;
	    res = _WindowsIsWindowedHandle( (int) STDIN_FILENO );
	    return( _WindowsGetch( res ) );
	}
	#if defined(__OS2_286__)
	    if( _RWD_osmode == DOS_MODE ) {
		return( _dos( 8 ) );
	    }
	#endif
	if( ( c = _RWD_cbyte2 ) != 0 ) {
	    _RWD_cbyte2 = 0;
	    return( c );
	}
	{
	    APIRET     rc;
	    KBDKEYINFO info;

	    rc = KbdCharIn( &info, 0, 0 );
	    if( rc == ERROR_KBD_DETACHED ) {
		return( EOF );
	    } else if( info.chChar == 0 || info.chChar == 0xe0 ) {
		_RWD_cbyte2 = info.chScan;
	    }
	    return( info.chChar );
	}
    }
