/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  06-mar-92     Craig Eisler	defined for NT
  27-mar-92	Craig Eisler	default windowing
  16-oct-92	Craig Eisler	protect access to stdin
  21-oct-92	Craig Eisler	ANSI function names for default windowing
  23-oct-93	A.F.Scian	fixed to handle extended keys properly
  25-jan-94	Kevin Hui	fixed bug in default windowing
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage

*/

#include "variety.h"
#include <stdio.h>
#include <windows.h>
#include "ntex.h"
#include "rtdata.h"
#include "fileacc.h"
#include "defwin.h"

enum {
    KS_EMPTY			= 0,
    KS_HANDLE_FIRST_CALL	= 1,
    KS_HANDLE_SECOND_CALL	= 2,
};

static int do_getch( HANDLE console_in )
{
    INPUT_RECORD ir;
    DWORD n;
    static unsigned repeat;
    static int c;
    static int e;
    static int state = KS_EMPTY;

    switch( state ) {
    case KS_HANDLE_FIRST_CALL:
	--repeat;
	if( c != 0 ) {
	    if( repeat == 0 ) {
		state = KS_EMPTY;
	    }
	} else {
	    state = KS_HANDLE_SECOND_CALL;
	}
	return( c );
    case 2:
	if( repeat == 0 ) {
	    state = KS_EMPTY;
	} else {
	    state = KS_HANDLE_FIRST_CALL;
	}
	return( e );
    }
    for(;;) {
	if( ! ReadConsoleInput( console_in, &ir, 1, &n ) ) break;
	if( ! __NTRealKey( &ir ) ) continue;
	repeat = ir.Event.KeyEvent.wRepeatCount - 1;
	c = ir.Event.KeyEvent.uChar.AsciiChar;
	if(( ir.Event.KeyEvent.dwControlKeyState & ENHANCED_KEY ) != 0
	  || c == 0 ) {
	    c = 0;
	    e = ir.Event.KeyEvent.wVirtualScanCode;
	    state = KS_HANDLE_SECOND_CALL;
	} else {
	    if( repeat != 0 ) {
		state = KS_HANDLE_FIRST_CALL;
	    }
	}
	return( c );
    }
    return( -1 );
}

_WCRTLINK int getch( void )
{
    int	c;
    HANDLE h;
    DWORD mode;

    if( ( c = _RWD_cbyte ) != 0 ) {
	_RWD_cbyte = 0;
	return( c );
    }
    if( _WindowsGetch != 0 ) {
	LPWDATA	res;
	res = _WindowsIsWindowedHandle( (int) STDIN_FILENO );
	c = _WindowsGetch( res );
    } else {
	_AccessFileH( STDIN_FILENO );
	h = __NTConsoleInput();
	GetConsoleMode( h, &mode );
	SetConsoleMode( h, 0 );
	c = do_getch( h );
	SetConsoleMode( h, mode );
	_ReleaseFileH( STDIN_FILENO );
    }
    return( c );
}
