/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  06-mar-92     Craig Eisler	defined for NT
  27-mar-92	Craig Eisler	default windowing
  16-oct-92	Craig Eisler	use integer ids for file handles
  21-oct-92	Craig Eisler	ANSI function names for default windowing
  15-oct-93	A.F.Scian	fixed to handle case where there are focus,
  				mouse, and window events in the queue (also
				key up events are ignored)
  18-oct-93	A.F.Scian	tweaked so that depressing the ctrl/alt/shift
  				key doesn't count as a key by itself
  22-oct-93	A.F.Scian	made use of routines in CONUTWNT
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
*/
#include "variety.h"
#include <stdio.h>
#include <dos.h>
#include <windows.h>
#include "ntex.h"
#include "rtdata.h"
#include "fileacc.h"
#include "defwin.h"

_WCRTLINK int kbhit( void )
{
    DWORD n;
    HANDLE h;
    INPUT_RECORD r;

    if( _WindowsKbhit != 0 ) {
	LPWDATA	res;
	res = _WindowsIsWindowedHandle( (int) STDIN_FILENO );
	return( _WindowsKbhit( res ) );
    } 
    _AccessFileH( STDIN_FILENO );
    h = __NTConsoleInput();
    for(;;) {
	PeekConsoleInput( h, &r, 1, &n );
	if( n == 0 ) break;
	if( __NTRealKey( &r ) ) break;
	// flush out mouse, window, and key up events
	ReadConsoleInput( h, &r, 1, &n );
    }
    // n != 0 if there is a key waiting
    _ReleaseFileH( STDIN_FILENO );
    return( n != 0 );
}
