;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1997 by Sybase, Inc. All rights reserved    %
;%       No part of this software may be reproduced in any form    %
;%       or by any means - graphic, electronic or mechanical,      %
;%       including photocopying, recording, taping or information  %
;%       storage and retrieval systems - except with the written   %
;%       permission of Sybase, Inc.                                %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;       Date:           By:             Reason:
;       ??-oct-97	Steve Howe	Original Implementation
;	07-nov-95	Greg Bentz	integrate to C runtime library

include mdef.inc
include struct.inc

                modstart	fsms386

                xdefp	"C",_fieeetomsbin
		defpe	_fieeetomsbin

ifdef __STACK__
                mov     eax,dword ptr +4H[esp]
                mov     edx,dword ptr +8H[esp]
endif

; At this point:
; eax     - ptr to IEEE source float
; edx     - ptr to MBF dest float

                mov     eax,[eax]       ; load IEEE float
                test    eax,7fe00000h   ; IEEE exponent != 0 or convertable
                                        ; denormal ?
                jne     IEEENonZero     ; :

; IEEE Zero or IEEE unconvertable denormal, store MBF Zero
                xor     eax,eax         ; 0
                mov     [edx],eax       ; store MBF 0.0F
                ret                     ; return 0 (no overflow)

; At this point:
; eax     - IEEE source float
; edx     - ptr to MBF dest float

IEEENonZero:    rol     eax,9           ; rotate for exponent analysis
                test    al,al           ; IEEE convertable denormal ?
                je      IEEEDenormal    ; yes, jump
                add     al,2            ; MBF exponent = IEEE exponent + 2
                jc      IEEEOverflow    ; jump if overflow
                shr     eax,1           ; rotate sign bit and exponent
                adc     al,al           ; :
                adc     eax,eax         ; :
                ror     eax,9           ; rotate so MBF float

MBFStore:       mov     [edx],eax       ; store MBF float
                xor     eax,eax         ; 0
                ret                     ; return 0 (no overflow)

; One of leading 2 bits of mantissa is a 1
IEEEDenormal:
ifndef __STACK__
                push    ecx             ; save register
endif
                mov     ecx,eax         ; save sign bit and exponent
                and     ah,0FEh         ; eliminate sign bit
DenormalLoop:   inc     ecx             ; increment count
                add     eax,eax         ; shift mantissa
                jnc     DenormalLoop    ; loop while no implied 1
                xor     ecx,3h          ; invert count (new exponent)
                shr     ecx,1           ; rotate exponent and sign bit
                adc     cl,cl           ; :
                adc     ecx,ecx         ; :
                shrd    eax,ecx,9       ; combine mantissa (eax) and
                                        ; exponent& sign bit (ecx)
ifndef __STACK__
                pop     ecx             ; restore register
endif
                jmp     MBFStore        ; continue

IEEEOverflow:   rol     eax,15          ; rotate sign bit into place
                or      eax,0FF7FFFFFh  ; set MBF exponent and mantissa to
                                        ; maximum but preserve MBF sign
                mov     [edx],eax       ; store MBF float
                and     eax,1           ; 1
                ret                     ; return 1 (overflow)

		endproc	_fieeetomsbin

		endmod
                end
