;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1997 by Sybase, Inc. All rights reserved    %
;%       No part of this software may be reproduced in any form    %
;%       or by any means - graphic, electronic or mechanical,      %
;%       including photocopying, recording, taping or information  %
;%       storage and retrieval systems - except with the written   %
;%       permission of Sybase, Inc.                                %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;       Date:           By:             Reason:
;       ??-oct-97	Steve Howe	Original Implementation
;	07-nov-95	Greg Bentz	integrate to C runtime library

include mdef.inc
include struct.inc

                modstart	mdfd386

                xdefp	"C",_dmsbintoieee
		defpe	_dmsbintoieee

ifdef __STACK__
                mov     eax,dword ptr +4H[esp]
                mov     edx,dword ptr +8H[esp]
else
                push    ecx
endif

; At this point:
; eax     - ptr to MBF source double
; edx     - ptr to IEEE dest double
; ecx     - spare register

; Check for and process MBF 0.0 first
                mov     ecx,+4h[eax]    ; load MBF double (hi)
                test    ecx,0ff000000h  ; MBF exponent = 0 ?
                jne     MBFNonZero      ; no, jump

; MBF 0.0, store IEEE 0.0
                xor     eax,eax         ; make 0
                mov     [edx],eax       ; store IEEE 0.0 (lo)
                mov     +4h[edx],eax    ; store IEEE 0.0 (hi)
ifndef __STACK__
                pop     ecx             ; clean up
endif
                ret                     ; return 0 (no overflow)

MBFNonZero:     mov     eax,[eax]       ; load MBF double (lo)

; At this point:
; ecx:eax - MBF source double
; edx     - ptr to IEEE dest double

                rol     ecx,9           ; rotate exponent & sign bit low
                shr     ecx,1           ; move sign bit before exponent
                rcr     cl,1            ; :
                adc     ecx,ecx         ; :
                ror     ecx,9           ; rotate exponent & sign bit back

; shift mantissa into place
                shrd    eax,ecx,2       ; shift mantissa
                sar     ecx,3           ; shift exponent & mantissa, save sign bit
                rcr     eax,1           ; shift mantissa
                jc      MBFRound        ; jump if rounding up
                and     ecx,8FFFFFFFh   ; mask out surplus sign bits
                add     ecx,37e00000h   ; convert MBF to IEEE exponent

IEEEStore:
                mov     [edx],eax       ; store IEEE double (lo)
                mov     +4h[edx],ecx    ; store IEEE double (hi)
                xor     eax,eax         ; 0
ifndef __STACK__
                pop     ecx             ; clean up
endif
                ret                     ; return 0 (no overflow)

; add rounding bit
MBFRound:       and     ecx,8FFFFFFFh   ; mask out surplus sign bits
                add     eax,1           ; add round bit
                adc     ecx,37e00000h   ; convert MBF to IEEE exponent
                jmp     IEEEStore       ; store result

		endproc	_dmsbintoieee

		endmod
                end
