;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1997 by Sybase, Inc. All rights reserved    %
;%       No part of this software may be reproduced in any form    %
;%       or by any means - graphic, electronic or mechanical,      %
;%       including photocopying, recording, taping or information  %
;%       storage and retrieval systems - except with the written   %
;%       permission of Sybase, Inc.                                %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;       Date:           By:             Reason:
;       ??-oct-97	Steve Howe	Original Implementation
;	07-nov-95	Greg Bentz	integrate to C runtime library

include mdef.inc
include struct.inc

                modstart	msfs386

                xdefp	"C",_fmsbintoieee
		defpe	_fmsbintoieee

ifdef __STACK__
                mov     eax,dword ptr +4H[esp]
                mov     edx,dword ptr +8H[esp]
endif

; At this point:
; eax     - ptr to MBF source float
; edx     - ptr to IEEE dest float

                mov     eax,[eax]       ; load MBF float
                                        ; MBF exponent = 0 ?
                test    eax,0ff000000h
                jne     MBFNonZero      ; yes, jump

                xor     eax,eax         ; IEEE 0.0
                mov     [edx],eax       ; store IEEE float
                ret                     ; return 0 (no overflow)

; At this point:
; eax     - MBF source float
; edx     - ptr to IEEE dest float

MBFNonZero:     rol     eax,9           ; rotate exponent for better analysis
                shr     eax,1           ; shift    out
                rcr     al,1            ; move sign bit
                adc     eax,eax         ; shift back
                sub     al,2            ; convert exponent
                jc      MBFExp1         ; jump if MBF exponent 1
                je      MBFExp2         ; jump if MBF exponent 2
                ror     eax,9           ; rotate so IEEE float
IEEEStore:
                mov     [edx],eax       ; store IEEE float
                xor     eax,eax         ; return 0 (no overflow)
                ret                     ; :

MBFExp1:        and     al,1            ; zero exponent except implied 1
                ror     eax,9           ; rotate so IEEE float
                sar     eax,2           ; convert to IEEE denormal
                adc     eax,0           ; add in round bit
                and     eax,80FFFFFFh   ; zero surplus sign bits
                jmp     short IEEEStore ; continue

MBFExp2:        or      al,1            ; set implied 1
                ror     eax,9           ; rotate so IEEE float
                sar     eax,1           ; convert to IEEE denormal
                adc     eax,0           ; add in round bit
                and     eax,80FFFFFFh   ; zero surplus sign bit
                jmp     short IEEEStore ; continue

		endproc	_fmsbintoieee

		endmod
                end
