/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  17-mar-87     F.W.Crigger     Initial implementation
  10-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  23-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  22-may-95	Greg Bentz	variety.h and dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  03-jun-96	Greg Bentz	cloned from atol
*/

#include "variety.h"
#include "widechar.h"
#include "watcom.h"
#include "clibi64.h"
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

_WCRTLINK void __F_NAME(__clib_atoll,__clib_watoll)( const CHAR_TYPE *p, UINT64_TYPE *pv )  /* convert ASCII string to long integer */
    {
        UINT64_TYPE value;
        UINT64_TYPE radix;
        UINT64_TYPE digit;
        CHAR_TYPE    sign;

        __ptr_check( p, 0 );

        while( __F_NAME(isspace,iswspace)( *p ) ) ++p;
        sign = *p;
        if( sign == '+' || sign == '-' ) ++p;
	_clib_U32ToU64( 0, value );
	_clib_U32ToU64( 10, radix );
	_clib_U32ToU64( 0, digit );
        while( __F_NAME(isdigit,iswdigit)(*p) ) {
	    _clib_U64Mul( value, radix, value );
	    _clib_U32ToU64( *p - '0', digit );
	    _clib_U64Add( value, digit, value );
            ++p;
        }
        if( sign == '-' ) _clib_U64Neg( value, value );
        *pv = value;
    }
