/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  19-dec-86     F.W.Crigger     Initial implementation
  02-aug-90     F.W.Crigger     Moved alphabet to code segment
  10-jun-92	D. Wellstood	-Unicode support
  				-increased size of buf in utoa to accomodate
				 large values possible in 32 bit apps
  26-may-93	A.F.Scian	optimized to use one divide instruction per
  				digit
  02-mar-94	Greg Bentz	added _itoa
--------------------------------------------------------Version-11.0---------
  23-feb-95	Greg Bentz	alpha support
  23-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  22-may-95	Greg Bentz	dll linkage
  15-sep-95	Greg Bentz	ppc support
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  13-aug-96	M. Hildebrand	Renamed _witoa to _itow, _wutoa to _utow.
*/

#include "variety.h"
#include "widechar.h"
#include <stdlib.h>

static const char _WCI86FAR Alphabet[] = "0123456789abcdefghijklmnopqrstuvwxyz";

unsigned __udiv( unsigned, unsigned _WCNEAR * );
#if defined(__386__)
    #pragma aux __udiv = \
	"xor edx,edx" \
	"div dword ptr [ebx]" \
	"mov [ebx],eax" \
	parm caller [eax] [ebx] \
	modify exact [eax edx] \
	value [edx];
#elif defined(M_I86) && defined(__BIG_DATA__)
    #pragma aux __udiv = \
	"xor dx,dx" \
	"div word ptr ss:[bx]" \
	"mov ss:[bx],ax" \
	parm caller [ax] [bx] \
	modify exact [ax dx] \
	value [dx];
#elif defined(M_I86) && defined(__SMALL_DATA__)
    #pragma aux __udiv = \
	"xor dx,dx" \
	"div word ptr [bx]" \
	"mov [bx],ax" \
	parm caller [ax] [bx] \
	modify exact [ax dx] \
	value [dx];
#elif defined(__AXP__)
    // no pragma
#elif defined(__PPC__)
    // no pragma
#else
    #error missing __udiv #pragma
#endif


_WCRTLINK CHAR_TYPE *__F_NAME(utoa,_utow)( unsigned value, CHAR_TYPE *buffer, int radix )
    {
        CHAR_TYPE *p = buffer;
	char *q;
	unsigned rem;
	unsigned quot;
        auto char buf[34];	// only holds ASCII so 'char' is OK

        buf[0] = '\0';
	q = &buf[1];
        do {
	    #if defined(__AXP__) || defined(__PPC__)
		rem = value % radix;
		quot = value / radix;
	    #else
		quot = radix;
		rem = __udiv( value, (unsigned _WCNEAR *) &quot );
	    #endif
            *q = Alphabet[ rem ];
            ++q;
	    value = quot;
        } while( value != 0 );
        while( *p++ = (CHAR_TYPE)*--q );
        return( buffer );
    }


_WCRTLINK CHAR_TYPE *__F_NAME(itoa,_itow)( int value, CHAR_TYPE *buffer, int radix )
    {
        register CHAR_TYPE *p = buffer;

        if( radix == 10 ) {
            if( value < 0 ) {
                *p++ = '-';
                value = - value;
            }
        }
        __F_NAME(utoa,_utow)( value, p, radix );
        return( buffer );
    }
