/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  19-dec-86     F.W.Crigger     Initial implementation
  02-aug-90     F.W.Crigger     Moved alphabet to code segment
  10-jun-92	D. Wellstood	Unicode support
  26-may-93	A.F.Scian	optimized to use one long divide per digit
  02-mar-94	Greg Bentz	added _ltoa
--------------------------------------------------------Version-11.0---------
  23-feb-95	Greg Bentz	alpha support
  23-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  22-may-95	Greg Bentz	dll linkage
  15-sep-95	Greg Bentz	ppc support
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  31-may-96	Greg Bentz	cloned from ltoa
*/

#include "variety.h"
#include "widechar.h"
#include "watcom.h"
#include "clibi64.h"
#include <stdlib.h>

static const char _WCI86FAR Alphabet[] = "0123456789abcdefghijklmnopqrstuvwxyz";


_WCRTLINK CHAR_TYPE *__F_NAME(__clib_ulltoa,__clib_wulltoa)(
        UINT64_TYPE *pv,
        CHAR_TYPE *buffer,
        unsigned radix )
    {
        CHAR_TYPE *p = buffer;
	char *q;
	UINT64_TYPE value;
	UINT64_TYPE divisor;
	UINT64_TYPE rem;
	unsigned index;
        auto char buf[34];	// only holds ASCII so 'char' is OK

	value = *pv;
	_clib_U32ToU64( radix, divisor );
        buf[0] = '\0';
	q = &buf[1];
        do {
	    _clib_U64Div( value, divisor, value, rem );
            _clib_U64ToUInt( rem, index );
            *q = Alphabet[ index ];
            ++q;
        } while( !_clib_U64Zero(value) );
        while( *p++ = (CHAR_TYPE)*--q );
        return( buffer );
    }


_WCRTLINK CHAR_TYPE *__F_NAME(__clib_lltoa,__clib_wlltoa)(
        INT64_TYPE *pv,
        CHAR_TYPE *buffer,
        int radix )
    {
        register CHAR_TYPE *p = buffer;
	UINT64_TYPE value;

	value = *pv;
        if( radix == 10 ) {
            if( _clib_I64Negative(value) ) {
                *p++ = '-';
		_clib_U64Neg( value, value );
            }
        }
        __F_NAME(__clib_ulltoa,__clib_wulltoa)( &value, p, radix );
        return( buffer );
    }
