/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   10-may-94	Alex Brodsky	initial implementation
--------------------------------------------------------Version-11.0---------
   22-may-95	Greg Bentz	variety.h and dll linkage
*/

#define __SW_BW
#include "variety.h"
#include <wdefwin.h>
#include "defwin.h"

_WCRTLINK int	_dwDeleteOnClose( int handle ) {
//==============================================

#ifdef DEFAULT_WINDOWING
    LPWDATA	res;
    
    if( _WindowsDestroyOnClose != 0 ) {
	res = _WindowsIsWindowedHandle( handle );
	if( res ) {
	    return( _WindowsDestroyOnClose( res ) );
	}
    }
#else
    handle = handle;
#endif
    return( 0 );
}
	
        
_WCRTLINK int	_dwSetAboutDlg( const char *title, const char *text ) {
//=====================================================================

#ifdef DEFAULT_WINDOWING
    
    if( _WindowsSetAbout != 0 ) {
	return( _WindowsSetAbout( (char *)title, (char *)text ) );
    }
#else
    text = text;
    title = title;
#endif
    return( 0 );
}

	
_WCRTLINK int	_dwSetAppTitle( const char *title ) {
//===================================================

#ifdef DEFAULT_WINDOWING
    
    if( _WindowsSetAppTitle != 0 ) {
	return( _WindowsSetAppTitle( (char *)title ) );
    }
#else
    title = title;
#endif
    return( 0 );
}

        
_WCRTLINK int	_dwSetConTitle( int handle, const char *title ) {
//===============================================================

#ifdef DEFAULT_WINDOWING
    
    LPWDATA	res;
    
    if( _WindowsSetAppTitle != 0 ) {
	res = _WindowsIsWindowedHandle( handle );
	if( res ) {
	    return( _WindowsSetConTitle( res, (char *)title ) );
	}
    }
#else
    handle = handle;
    title = title;
#endif
    return( 0 );
}


_WCRTLINK int	_dwYield( void ) {
//================================

#ifdef DEFAULT_WINDOWING
    
    if( _WindowsYieldControl != 0 ) {
	return( _WindowsYieldControl() );
    }
#endif
    return( 0 );
}


_WCRTLINK int	_dwShutDown( void ) {
//===================================

#ifdef DEFAULT_WINDOWING
    
    if( _WindowsShutDown != 0 ) {
	return( _WindowsShutDown() );
    }
#endif
    return( 0 );
}
