/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   11-mar-93	Alex Brodsky   	Split this from WinLines.c because its too
   				PM specific.
   12-may-94	Alex Brodksy	Added more functinaly
--------------------------------------------------------Version-11.0---------
*/

#include "variety.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#define INCL_WIN
#include <wos2.h>
#include "win.h"

/*
 * _SaveAllLines - save all lines to a file
 */
void _SaveAllLines( LPWDATA w )
{
    char 		fname[CCHMAXPATH+1];
    FILEDLG     	fdlg;
    HWND		hwmenu;
    FILE		*f;
    LPLDATA		ld;

    /*
     * go get file name
     */
    fname[0] = 0;
    memset( &fdlg, 0, sizeof( FILEDLG ) );
    fdlg.cbSize = sizeof( FILEDLG );
    fdlg.fl = FDS_SAVEAS_DIALOG | FDS_CENTER | FDS_PRELOAD_VOLINFO |
    		FDS_ENABLEFILELB;
    fdlg.pszTitle = "Save File Name Selection";
    fdlg.pszOKButton = "~Save";
    strcpy( fdlg.szFullFile, "*.*" );

    hwmenu = WinWindowFromID( _MainFrameWindow, FID_MENU );
    if ( WinFileDlg( HWND_DESKTOP, hwmenu, &fdlg ) ) {
    	/*
    	 * save lines
    	 */
	if( fdlg.lReturn != DID_OK ) {
	    return;
	}
    	f = fopen( fdlg.szFullFile, "w" );
    	if( f == NULL ) {
	    _Error( hwmenu, fdlg.szFullFile, "Error opening file" );
	    return;
    	}
    	ld = w->LineHead;
    	while( ld != NULL ) {
	    fprintf( f,"%s\n", ld->data );
	    ld = ld->next;
    	}
    	fclose( f );
	_Error( hwmenu, fdlg.szFullFile, "Data saved to file" );
    } else {
	_Error( hwmenu, "Error", "Could not create dialog box" );
    }
    
} /* _SaveAllLines */

#define MAX_BYTES	0xfffeL
/*
 * _CopyAllLines - copy lines to clipboard
 */
void _CopyAllLines( LPWDATA w )
{
    LPLDATA	ld;
    ULONG 	total;
    unsigned	len;
    char	*data;
    char  	*ptr;
    unsigned	slen;
    LONG	rc;

    /*
     * get number of bytes
     */
    ld = w->LineHead;
    total = 0;
    while( ld != NULL ) {
	total += strlen( ld->data ) + 2;
	ld = ld->next;
    }
    if( total > MAX_BYTES ) len = (unsigned) MAX_BYTES;
    else len = total;

    /*
     * get memory block
     */
    rc = PAG_COMMIT | OBJ_GIVEABLE | PAG_WRITE;
    rc = DosAllocSharedMem( &data, NULL, len + 1, rc );
    if( rc ) {
	_Error( NULL, "Copy to Clipboard Error", "Out of Memory" );
	return;
    }

    /*
     * copy data into block
     */
    ld = w->LineHead;
    total = 0;
    ptr = data;
    while( ld != NULL ) {
	slen = FARstrlen( ld->data ) + 2;
	if( total + slen > MAX_BYTES ) break;
	memcpy( &ptr[total], ld->data, slen - 2 );
	ptr[total+slen-2] = 0x0d;
	ptr[total+slen-1] = 0x0a;
	total += slen;
	ld = ld->next;
    }
    ptr[total] = 0;

    /*
     * dump data to the clipboard
     */
    if( WinOpenClipbrd( _AnchorBlock ) ) {
	WinEmptyClipbrd( _AnchorBlock );
	WinSetClipbrdData( _AnchorBlock, (ULONG)data, CF_TEXT, CFI_POINTER );
	WinCloseClipbrd( _AnchorBlock );
    }

} /* _CopyAllLines */

