/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   17-dec-91	Craig Eisler	initial implementation
   27-mar-92	Craig Eisler	changed format of call to NewWindow
   21-oct-92	Craig Eisler	ANSI function names
   12-may-94 	Alex Brodsky	removed close from sys menu
--------------------------------------------------------Version-11.0---------
*/
#include "variety.h"
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <limits.h>
#define	INCL_WIN
#define	INCL_GPI
#include <wos2.h>
#include "win.h"
#include "pmmenu.h"

#define DISPLAY(x)	WinMessageBox( HWND_DESKTOP, NULL, x, "Error", 0, MB_APPLMODAL | MB_NOICON | MB_OK | MB_MOVEABLE );

extern void _CreateFont( LPWDATA w );
static HWND menuHandle;
/*
 * _NewWindow - create a new window
 */
unsigned _NewWindow( char *name, ... )
{
    LPWDATA	w;
    MENUITEM	menus;
    HWND	hwnd,frame,temp;
    char	str[80];
    int		x1,x2,y1,y2;
    ULONG	style;
    RECTL	rcl;
    va_list	al;

    _GetWindowNameAndCoords( name, str, &x1, &x2, &y1, &y2 );

    style = FCF_TITLEBAR | FCF_SYSMENU | FCF_SIZEBORDER | FCF_MINMAX |
	    FCF_VERTSCROLL;
    frame = WinCreateStdWindow( _MainWindow,
    		WS_VISIBLE | WS_CLIPSIBLINGS,
    		&style, _ClassName, str, 0, NULL, 0, &hwnd );
    if( frame == 0 ) return( FALSE );
    WinSetOwner( hwnd, _MainWindow );

    va_start( al, name );
    w = _AnotherWindowData( hwnd, al );
    w->frame = frame;
    w->text_color = CLR_WHITE;
    w->background_color = CLR_BLACK;
    WinSendMsg( frame, WM_SETICON,
    	MPFROMLONG( WinQuerySysPointer( HWND_DESKTOP, SPTR_APPICON, TRUE ) ), 0 );
    WinSetWindowBits( WinWindowFromID( w->frame, FID_VERTSCROLL ), QWL_STYLE,
    			SBS_AUTOTRACK, SBS_AUTOTRACK );
    
    _CreateFont( w );
    _PositionScrollThumb( w );
    WinQueryWindowRect( _MainWindow, &rcl );
    WinSetWindowPos( frame, HWND_TOP, 
    		x1*w->xchar, 
		(rcl.yTop - rcl.yBottom)-y1*w->ychar-y2*w->ychar, 
    		x2*w->xchar, 
		y2*w->ychar,
    		SWP_SIZE | SWP_MOVE | SWP_ZORDER );

    menus.iPosition = _MainWindowData->window_count - 1;
    menus.afStyle = MIS_TEXT;
    menus.afAttribute = 0;
    menus.id = DID_WIND_STDIO + w->handles[0];
    menus.hwndSubMenu = NULL;
    menus.hItem = 0;
    if ( MIT_ERROR == (BOOL)WinSendMsg( menuHandle, ( ULONG )MM_INSERTITEM, MPFROMP( &menus ), MPFROMP( str ) ) ) abort();
    temp = WinWindowFromID( frame, FID_SYSMENU );
    WinSendMsg( temp, MM_QUERYITEM, MPFROM2SHORT(SC_SYSMENU, TRUE),
			       MPFROMP((PSZ)&menus) );
    WinSendMsg( menus.hwndSubMenu, MM_DELETEITEM, MPFROM2SHORT( SC_CLOSE, TRUE ), 0 );
    WinUpdateWindow( hwnd );
    WinSetFocus( HWND_DESKTOP, hwnd );
    return( TRUE );

} /* _NewWindow */

/*
 * _ReleaseWindowResources - get rid of any resources
 */
void _ReleaseWindowResources( LPWDATA w )
{
	w = w;
} /* _ReleaseWindowResources */

/*
 * _SetWinMenuHandle - Sets the internal submenu handle.
 */
void _SetWinMenuHandle( HWND hmenu ) {

    menuHandle = hmenu;
}

HWND _GetWinMenuHandle( void ) {

    return( menuHandle );
}
