/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   08-aug-91	Craig Eisler	initial implementation
---------------------------------------------------------Version 9.0--------
   15-dec-91	Craig Eisler	multiple windowing
---------------------------------------------------------Version 9.x--------
   27-mar-92	Craig Eisler	NT version
   21-oct-92	Craig Eisler	ANSI function names
   12-may-94	Alex Brodksy	moved about to windrvr
--------------------------------------------------------Version-11.0---------
*/
#include "variety.h"
#include <string.h>
#include <stdlib.h>
#include "win.h"

#define MAXDLGITEMDATA  (1)

typedef struct {
   int x, y, cx, cy, id;
   long style;
   char *class, *text;
   BYTE info;
   BYTE data[MAXDLGITEMDATA];
} itemdata;

static itemdata _getint[] = {
{  4,  10, 50, 24, -1, SS_LEFT, "STATIC", "&Enter Number of Lines:", 0, { 0 } },

{ 55,  14, 68, 12, DLG1_EDIT,
  ES_LEFT | WS_BORDER | WS_TABSTOP | WS_GROUP,
  "EDIT", "", 0, { 0 } },

{ 30,  38, 36, 12, IDOK, BS_DEFPUSHBUTTON | WS_TABSTOP | WS_GROUP,
  "BUTTON", "&OK", 0, { 0 } },

{ 84,  38, 36, 12, IDCANCEL, BS_PUSHBUTTON | WS_TABSTOP | WS_GROUP,
  "BUTTON", "&Cancel", 0, { 0 } }
};

#define MAX_INT_ITEMS sizeof( _getint ) / sizeof( itemdata )


char *ultoa( unsigned long int __value, char *__buf, int __radix );
/*
 * _GetIntervalBox - control dialog for getting interval
 */
BOOL CALLBACK _GetIntervalBox( HWND hwnd, unsigned message,
			    UINT wparam, LONG lparam )
{
    char 	tmp[128];

    lparam = lparam;
    switch( message ) {
    case WM_INITDIALOG:
	ultoa( _AutoClearLines, tmp, 10 );
	SendDlgItemMessage( hwnd, DLG1_EDIT, EM_REPLACESEL, 0,
	    (DWORD) (LPSTR) tmp );
	return( TRUE );

    case WM_COMMAND:
	if( LOWORD( wparam ) == IDOK ) {
	    GetDlgItemText( hwnd, DLG1_EDIT, (LPSTR) tmp, 128 );
	    _AutoClearLines = (DWORD) atol( tmp );
	    EndDialog( hwnd, TRUE );
	    return( TRUE );
	} else if( wparam == IDCANCEL ) {
	    EndDialog( hwnd, TRUE );
	    return( TRUE );
	} 
	break;
    case WM_CLOSE:
	EndDialog( hwnd, TRUE );
	return( TRUE );
    } 

    return( FALSE );

} /* _GetIntervalBox */

/*
 * _GetClearInterval - return number of lines between clearing
 */
void _GetClearInterval( void )
{
    GLOBALHANDLE	data,new;
    int			i;

    data = _DialogTemplate( DS_LOCALEDIT | DS_MODALFRAME | WS_CAPTION
		| WS_SYSMENU,
		22, 25, 150, 60, "", "",
		"Set Number of Lines Between Auto-Clears",
		0, "");

    if( data == NULL ) return;
    for( i=0;i<MAX_INT_ITEMS;i++ ) {
	new = _AddControl( data,
		_getint[i].x, _getint[i].y, _getint[i].cx, _getint[i].cy,
		_getint[i].id, _getint[i].style | WS_VISIBLE,
		_getint[i].class, _getint[i].text,
		_getint[i].info, _getint[i].data);
	if( new == NULL  ) {
	    GlobalFree( data );
	    return;
	}
	data = new;
    }

    _DoneAddingControls( data );
    _DynamicDialogBox( (LPVOID) _GetIntervalBox, _MainWindowData->inst,
    				_MainWindow, data );

} /* _GetClearInterval */

