/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  06-aug-91	C.G. Eisler	initial implementation
---------------------------------------------------------Version 9.0--------
  10-oct-91	G. Coschi	modifications for OS/2 PM
  15-dec-91	Craig Eisler	multiple window support
---------------------------------------------------------Version 9.x--------
  27-mar-92	Craig Eisler	NT version
  21-oct-92	Craig Eisler	ANSI function names
--------------------------------------------------------Version-11.0---------
  20-feb-95	M.P.Hildebrand	Added multibyte character support.
  20-feb-95	Alex Brodsky /	Fixed bug which caused the default windowing
  		M.P.Hildebrand	system to eat too much CPU time.
  06-jul-95	Greg Bentz	_DoStdin is in terms of bytes
  30-oct-95	M. Hildebrand	Using read() on fileno(stdin) to read a
				newline now works.
  29-may-97	Alex Brodsky	Kludged above kludge to work properly, i.e.
  				if we can we add crlf otherwise if we cannot
				we add lf, this is not entirely correct IMHO
*/

#include "variety.h"
#if defined( __OS2__ )
  #define INCL_WIN
  #include <wos2.h>
#endif
#include "win.h"
#ifdef _MBCS
    #include <mbstring.h>
#endif

/*
 * _DoStdin - get stuff from stdin
 */
unsigned _DoStdin( LPWDATA w, void *in_buff, unsigned size )
{
    unsigned		rc;
    char *		buff;

    buff = (char *)in_buff;

    if( w == NULL ) return( 0 );
    if( !w->active) _MakeWindowActive( w );
    rc = _GetString( w, buff, size );
    if( _GotEOF ) {
	if( rc < size ) {
	    buff[rc++] = CTRL_Z;
	}
    } else {
	if( (rc+2) < size ) {
	    buff[rc++] = 0x0d;
	    buff[rc++] = 0x0a;
	} else if( ( rc == 0 ) && ( size == 1 ) ) {/* rc==0 ==> key was enter */
	    /* kludge to allow readers to get a single new line from the
	     * system
	     */
	    buff[rc++] = 0x0a;
	}
    }
    return( rc );

} /* _DoStdin */

/*
 * _DoStdout - put stuff to stdout
 */
unsigned _DoStdout( LPWDATA w, const void *buff, unsigned size )
{

    if( w == NULL ) return( 0 );
    if( !w->active) _MakeWindowActive( w );
    _AddLine( w, buff, size );
    _MessageLoop( TRUE );
    return( size );

} /* _DoStdout */

/*
 * _DoKbhit - test if the keyboard has been pressed
 */
unsigned _DoKbhit( LPWDATA w )
{
    if( w == NULL ) return( FALSE );
    if( !w->active) _MakeWindowActive( w );
    return( _KeyboardHit( FALSE ) );

} /* _DoKbhit */

/*
 * _DoGetch - get a character
 */
unsigned _DoGetch( LPWDATA w )
{
    unsigned	ci;

    if( w == NULL ) return( 0 );
    if( !w->active) _MakeWindowActive( w );
    while( !_KeyboardHit( TRUE ) );
    ci = _GetKeyboard( NULL );
    if( ci > 0x80 ) ci -= 0x80;
    return( ci );

} /* _DoGetch */

/*
 * _DoGetche - get a character and echo it
 */
unsigned _DoGetche( LPWDATA w )
{
    unsigned	ci;

    ci = _DoGetch( w );
    if( ci == '\r' ) {
	_DoPutch( w, '\n' );
    } else {
	_DoPutch( w, ci );
    }
    return( ci );

} /* _DoGetche */

/*
 * _DoPutch - put a character to stdout
 */
void _DoPutch( LPWDATA w, unsigned ch )
{
    char tmp[2];

    if( w == NULL ) return;
    if( !w->active) _MakeWindowActive( w );
    tmp[0] = ch;
    tmp[1] = 0;
    _AddLine( w, tmp, 1 );
    _MessageLoop( TRUE );

} /* _DoPutch */
