/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   15-dec-91	Craig Eisler	initial implementation
---------------------------------------------------------Version 9.x--------
   27-mar-92	Craig Eisler	NT version
   21-oct-92	Craig Eisler	ANSI function names
   12-may-94 	Alex Brodsky	Add more funtionality,
--------------------------------------------------------Version-11.0---------
*/
#include "variety.h"
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include "win.h"

/*
 * _NewWindow - create a new window
 */
unsigned _NewWindow( char *name, ... )
{
    HWND	hwnd;
    LPWDATA	w;
    WORD	xchar,ychar;
    HDC		dc;
    TEXTMETRIC	tm;
    char	str[80];
    int		x1,x2,y1,y2;
    va_list 	al;

    _GetWindowNameAndCoords( name, str, &x1, &x2, &y1, &y2 );

    hwnd = CreateWindow(
	_ClassName,			    /* our class		  */
	str,				    /* Text for window title bar. */
	WS_CHILD |  WS_VSCROLL | WS_CAPTION | WS_THICKFRAME |
	WS_CLIPSIBLINGS | WS_SYSMENU | WS_MAXIMIZEBOX |
	WS_MINIMIZEBOX, 		    /* Window style.       */
	0,				    /* horizontal position.       */
	0,				    /* vertical position.         */
	0,				    /* width.                     */
	0,				    /* height.                    */
	_MainWindow,			    /* parent			  */
	NULL,				    /* menu handle		  */
	_MainWindowData->inst,		    /* owner of window		  */
	NULL				    /* extra data pointer	  */
    );

    if( !hwnd ) return( FALSE );
    /*
     * allocate window data area
     */
    va_start( al, name );
    w = _AnotherWindowData( hwnd, al );

    /*
     * set up data
     */
    dc = GetDC( hwnd );
    w->text_color = BLACK;
    w->background_color = BRIGHT_WHITE;
    w->brush = CreateSolidBrush( _ColorMap[BRIGHT_WHITE] );
    _SetMyDC( dc, 0, 0 );
    GetTextMetrics( dc, &tm );
    ReleaseDC( hwnd, dc );
    xchar = tm.tmMaxCharWidth;
    ychar = tm.tmHeight;
    w->xchar = xchar;
    w->ychar = ychar+2;
    w->inst = _MainWindowData->inst;
    _PositionScrollThumb( w );
    AppendMenu( _SubMenuWindows, MF_ENABLED, MSG_WINDOWS+w->handles[0], str );

    MoveWindow( hwnd,x1*xchar,y1*ychar, x2*xchar, y2*ychar, TRUE );
    DeleteMenu( GetSystemMenu( hwnd, 0 ), SC_CLOSE, MF_BYCOMMAND );
    ShowWindow( hwnd, SW_NORMAL );
    UpdateWindow( hwnd );
    _MakeWindowActive( w );
    return( TRUE );

} /* _NewWindow */

/*
 * _ReleaseWindowResources - get rid of any resources
 */
void _ReleaseWindowResources( LPWDATA w )
{
    DeleteObject( w->brush );
    if( w->hascursor ) {
	DestroyCaret();
    }
    DeleteMenu( _SubMenuWindows, MSG_WINDOWS+w->handles[0], MF_BYCOMMAND );

} /* _ReleaseWindowResources */
