/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   01-aug-91	Craig Eisler	initial implementation
---------------------------------------------------------Version 9.0--------
   11-oct-91	G. Coschi	modifications for OS/2 PM
   17-dec-91	Craig Eisler	multiple window support
---------------------------------------------------------Version 9.x--------
   27-mar-92	Craig Eisler	NT version
--------------------------------------------------------Version-11.0---------
   20-feb-95	M.P.Hildebrand	Added multibyte character support.
   10-apr-95	M. Hildebrand	Fixed assorted bugs.
   12-apr-95	M. Hildebrand	Use FAR_mb* rather than redefining _fmb*.
   19-apr-95	Greg Bentz	unify use of near/far modifiers
   15-sep-95	M. Hildebrand	Removed __mbvtop.
*/

#include "variety.h"
#if defined( __OS2__ )
    #define INCL_WIN
    #include <wos2.h>
#endif
#include <string.h>
#include "win.h"

/*
 * _RepaintWindow
*/
#if defined( __OS2__ )
void _RepaintWindow( LPWDATA w, PRECT rcPaint, HPS ph )
#else
void _RepaintWindow( LPWDATA w, PRECT rcPaint, HDC ph )
#endif
{
    int 		i;
    WORD 		ptop,pbot,pleft,pright,poff,pdown;
    WORD		width;
#ifdef _MBCS
    mb_char _WCI86FAR *	image;
    char		mbc[MB_CUR_MAX+1];
#else
    LPSTR		image;
#endif    
#if !defined( __OS2__ )
    HFONT		oldfont;
#endif

    /*
     * get area to redraw
     */
    ptop = rcPaint->top / w->ychar;
    if( ptop != 0 && (rcPaint->top % w->ychar != 0) )  ptop--;
    pbot = rcPaint->bottom / w->ychar ;
    if( pbot == 0 )  return;
    if( pbot >= w->height )  pbot = w->height-1;
    if( rcPaint->bottom % w->ychar == 0 )  pbot--;
    pleft = 0;
    pright = w->width-1;
    width = w->width;
    poff = pleft * w->xchar;
    pdown = ptop * w->ychar;

    /*
     * draw all lines
     */
#if defined( __OS2__ )
#else
    oldfont = SelectObject( (HDC)ph, _FixedFont );
#endif
    for( i=ptop;i<=pbot;i++ ) {
	image = &w->image[i*w->width];
#if defined( __OS2__ )
	{
	    POINTL	ptl;
	    
	    ptl.x = poff;
	    ptl.y = ( w->y2 - w->y1 ) - (pdown + w->ychar) + w->base_offset;
	    #ifdef _MBCS
	    {
		int	    count;
		char _WCI86FAR * buff;

		buff = _MemAlloc( sizeof(mb_char)*(width+1) );
		*buff = '\0';
		for( count=0; count<width; count++ ) {
		    _mbvtop( image[pleft+count], mbc );
		    mbc[_mbclen(mbc)] = '\0';
		    FARstrcat( buff, mbc );
		}
		GpiCharStringAt( (HPS)ph, &ptl, FAR_mbsnbcnt(buff,width), buff );
		_MemFree( buff );
	    }
	    #else
		GpiCharStringAt( (HPS)ph, &ptl, width, &image[pleft] );
	    #endif
	}
#else
	SetBkColor( (HDC)ph, _ColorMap[w->background_color] );
	SetTextColor( (HDC)ph, _ColorMap[w->text_color] );
        #ifdef _MBCS
        {
	    int		count, bytes;
	    char _WCI86FAR *	buff;

	    buff = _MemAlloc( sizeof(mb_char)*(width+1) );
	    *buff = '\0';
	    for( count=0; count<width; count++ ) {
		_mbvtop( image[pleft+count], mbc );
		mbc[_mbclen(mbc)] = '\0';
		FARstrcat( buff, mbc );
	    }
	    bytes = FARstrlen( buff );
	    TextOut( (HDC)ph, poff, pdown, buff, bytes );
	    _MemFree( buff );
	}
	#else
	    TextOut( (HDC)ph, poff, pdown, &image[pleft], width );
	#endif
#endif
	pdown += w->ychar;
    }
#if !defined( __OS2__ )
    SelectObject( (HDC)ph, oldfont );
#endif
	    
} /* _RepaintWindow */
