#ifndef _MBDEFWIN_H_INCLUDED

/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   10-apr-95	M. Hildebrand	Initial implementation.
   12-apr-95	M. Hildebrand	Use FAR_mb* rather than redefining _fmb*.
				Also added Alpha support.
   15-sep-95	M. Hildebrand	Now reflects changes in 11.0 C library.
   15-sep-95	Greg Bentz	ppc support
   04-dec-95	M. Hildebrand	Moved __mbslen and __mbsninc prototypes to
				here from mbstring.h.
   13-dec-95	M. Hildebrand	Changed _mbptov to _mbsnextc.
*/

#include "variety.h"
#include <mbctype.h>
#include <mbstring.h>


typedef unsigned int		mb_char;


_WCRTLINK extern size_t __mbslen( const unsigned char *__string );
_WCRTLINK extern unsigned char *__mbsninc( const unsigned char *__string, size_t __count );

_WCRTLINK extern size_t __fmbslen( const unsigned char _WCFAR *__string );
_WCRTLINK extern unsigned char _WCFAR *__fmbsninc( const unsigned char _WCFAR *__string, size_t __count );


/*** Avoid excessive conditional compilation ***/
#if defined(__386__) || defined(__AXP__) || defined(__PPC__)
    #define FAR_mbsninc		__mbsninc
    #define FAR_mbsnbcnt	_mbsnbcnt
    #define FAR_mbsncpy		_mbsncpy
    #define FAR_mbsnbcpy	_mbsnbcpy
    #define FAR_mbslen		__mbslen
    #define FAR_mbccpy		_mbccpy
    #define FAR_mbsnextc	_mbsnextc
    #define FAR_mbvtop		_mbvtop
#else
    #define FAR_mbsninc		__fmbsninc
    #define FAR_mbsnbcnt	_fmbsnbcnt
    #define FAR_mbsncpy		_fmbsncpy
    #define FAR_mbsnbcpy	_fmbsnbcpy
    #define FAR_mbslen		__fmbslen
    #define FAR_mbccpy		_fmbccpy
    #define FAR_mbsnextc	_fmbsnextc
    #define FAR_mbvtop		_fmbvtop
#endif


#define _MBDEFWIN_H_INCLUDED
#endif
