/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   28-sep-95	M. Hildebrand	Initial implementation.
   20-oct-95	M. Hildebrand	Changed buffer length from int to size_t.
*/

#include "variety.h"
#include "widechar.h"
#include <direct.h>
#include <dos.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include "seterrno.h"


_WCRTLINK CHAR_TYPE *__F_NAME(_getdcwd,_wgetdcwd)( int drive, CHAR_TYPE *buffer, size_t maxlen )
{
    CHAR_TYPE		path[_MAX_PATH];
    unsigned		olddrive, tmpdrive;
    size_t		bytes;

    /*** Change drive if necessary ***/
    if( drive != 0 ) {
	_dos_getdrive( &olddrive );
	_dos_setdrive( drive, &tmpdrive );
	_dos_getdrive( &tmpdrive );
	if( drive != tmpdrive )  return( NULL );
    }

    /*** Get the current directory for the drive ***/
    if( __F_NAME(getcwd,_wgetcwd)( path, _MAX_PATH ) == NULL ) {
	if( drive != 0 )  _dos_setdrive( olddrive, &tmpdrive );
	return( NULL );
    }
    if( drive != 0 )  _dos_setdrive( olddrive, &tmpdrive );

    /*** Allocate memory if necessary ***/
    if( buffer == NULL ) {
	bytes = max( maxlen, __F_NAME(strlen,wcslen)(path)+1 ) * sizeof(CHAR_TYPE);
	buffer = malloc( bytes );
	if( buffer == NULL ) {
	    __set_errno_dos( ENOMEM );
	    return( NULL );
	}
    } else {
	if( __F_NAME(strlen,wcslen)(path)+1 > maxlen ) {
	    __set_errno_dos( ERANGE );
	    return( NULL );
	}
    }
    __F_NAME(strcpy,wcscpy)( buffer, path );

    /*** Copy the path into buffer ***/
    return( buffer );
}
