/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  09-Apr-87	A.C.C.Wai	Initial implementation
  03-dec-87	F.W.Crigger	Don't check range of size variable
				Use strncpy instead of strcpy.
  20-jan-88	F.W.Crigger	Insert drive letter: at front of string
  27-jan-88	F.W.Crigger	add support for large data model
  19-jul-93	J.B.Schueler	changed 68 to _MAX_PATH
				Note: getcwd is called by _fullpath
--------------------------------------------------------Version-11.0---------
  27-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  22-may-95	Greg Bentz	variety.h and dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  20-oct-95	M. Hildebrand	Changed buffer length from int to size_t,
				and use MS-compatible allocation logic.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/

#include "variety.h"
#include "widechar.h"
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "dos.h"
#include "dosfunc.h"
#include "tinyio.h"
#include "liballoc.h"
#include "rtdata.h"
#include "seterrno.h"
#include "variety.h"
#ifdef __WIDECHAR__
    #include <direct.h>
    #include <mbstring.h>
#endif


_WCRTLINK CHAR_TYPE *__F_NAME(getcwd,_wgetcwd)( buf, size )
	CHAR_TYPE *buf;
	size_t size;
    {
	int len;
	tiny_ret_t rc;
    #ifndef __WIDECHAR__
	char cwd[_MAX_PATH];			/* single-byte chars */
    #else
	char cwd[MB_CUR_MAX*_MAX_PATH];		/* multi-byte chars */
    #endif
    
	__null_check( buf, 1 );
	rc = TinyGetCWDir( &cwd[3], 0 );	/* leave space for 'x:\' */
	if( TINY_ERROR( rc ) ) {
	    __set_errno( ENOENT );	 /* noent? */
	    return( NULL );
	}
	
	/* get current drive and insert into cwd[0] */
	cwd[0] = TinyGetCurrDrive() + 'A';
	cwd[1] = ':';
	cwd[2] = '\\';
	len = __F_NAME(strlen,_mbslen)( cwd ) + 1;
	if( buf == NULL ) {
	    if( (buf = lib_malloc( max(size,len)*CHARSIZE )) == NULL ) {
		__set_errno( ENOMEM );
		return( NULL );
	    }
	    size = len;
	}

	/*** Copy the pathname into a buffer and quit ***/
	#ifndef __WIDECHAR__
	    return( strncpy( buf, cwd, size ) );
	#else
	    if( mbstowcs( buf, cwd, size ) != (size_t)-1 )
		return( buf );
	    else
		return( NULL );
	#endif
    }
