/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  09-aug-89	John Dahms	defined for OS/2
--------------------------------------------------Version 8.5----------
  09-jul-91	G. Coschi	support OS/2 2.0
  19-jul-93	J.B.Schueler	changed PATH_MAX+1 to _MAX_PATH
				Note: getcwd is called by _fullpath
--------------------------------------------------------Version-11.0---------
  27-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  22-may-95	Greg Bentz	variety.h and dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  20-oct-95	M. Hildebrand	Changed buffer length from int to size_t,
				and use MS-compatible allocation logic.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/

#include "variety.h"
#include "widechar.h"
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>
#include "dos.h"
#include <wos2.h>
#include "rtdata.h"
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <direct.h>
    #include <mbstring.h>
#endif


#pragma on(stack_check);
_WCRTLINK CHAR_TYPE *__F_NAME(getcwd,_wgetcwd)( buf, size )
	CHAR_TYPE *buf;
	size_t size;
    {
	APIRET		error;
	ULONG		drive_map;
    #ifndef __WIDECHAR__
	char		path[_MAX_PATH];	    /* single-byte chars */
	OS_UINT 	pathlen = _MAX_PATH - 3;
    #else
	char		path[MB_CUR_MAX*_MAX_PATH]; /* multi-byte chars */
	OS_UINT 	pathlen = MB_CUR_MAX * _MAX_PATH - 3;
    #endif
	OS_UINT 	drive;

	error = DosQCurDir( 0, &path[3], &pathlen );
	if( error ) {
	    __set_errno_dos( error );
	    return( NULL );
	}
	DosQCurDisk( &drive, &drive_map );
	path[ 0 ] = drive + 'A' - 1;
	path[ 1 ] = ':';
	path[ 2 ] = '\\';
	if( buf == NULL ) {
	    if( (buf = malloc( max(size,pathlen+4)*CHARSIZE )) == NULL ) {
		__set_errno( ENOMEM );
		return( NULL );
	    }
	    size = pathlen + 3;
	}

	/*** Copy the pathname into a buffer and quit ***/
	#ifndef __WIDECHAR__
	    return( strncpy( buf, path, size ) );
	#else
	    if( mbstowcs( buf, path, size ) != (size_t)-1 )
		return( buf );
	    else
		return( NULL );
	#endif
    }
