/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  06-mar-92     Craig Eisler	defined for NT
--------------------------------------------------------Version-11.0---------
  27-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  22-may-95	Greg Bentz	variety.h and dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  20-oct-95	M. Hildebrand	Changed buffer length from int to size_t,
				and use MS-compatible allocation logic.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  10-jun-96	M. Hildebrand	Win95 doesn't support GetCurrentDirectoryW.
  05-jul-96	M. Hildebrand	Use __lib_ versions of ...W Win32 functions.
*/
#include "variety.h"
#include "widechar.h"
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>
#include "dos.h"
#include <windows.h>
#include "libwin32.h"
#include "rtdata.h"
#include "seterrno.h"
#include "liballoc.h"


_WCRTLINK CHAR_TYPE *__F_NAME(getcwd,_wgetcwd)( CHAR_TYPE *buf, size_t size )
{
    CHAR_TYPE		path[_MAX_PATH];
    DWORD		realsize;

    /*** Get the current directory ***/
    #ifdef __WIDECHAR__
	realsize = __lib_GetCurrentDirectoryW( _MAX_PATH, path );
    #else
	realsize = GetCurrentDirectoryA( _MAX_PATH, path );
    #endif

    if( realsize == 0 ) {
    	__set_errno_nt();
	return( NULL );
    }
    if( buf == NULL ) {
	buf = lib_malloc( max(size,realsize+1) * CHARSIZE );
	if( buf == NULL ) {
	    __set_errno( ENOMEM );
	    return( NULL );
	}
    } else {
	if( realsize > size ) {
	    __set_errno( ERANGE );
	    return( NULL );
	}
    }
    
    memcpy( buf, path, (realsize+1)*CHARSIZE );
    return( buf );
}
