/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  09-aug-89     John Dahms      defined for OS/2
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
--------------------------------------------------------Version-11.0---------
  27-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  22-may-95	Greg Bentz	variety.h and dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/

#include "variety.h"
#include "widechar.h"
#include <wos2.h>
#include <stdlib.h>
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
#endif


_WCRTLINK int __F_NAME(mkdir,_wmkdir)( const CHAR_TYPE *path )
{
#ifndef __WIDECHAR__
    APIRET		rc;

    rc = DosMkDir( (PSZ)path, 0 );
#else
    APIRET		rc;
    size_t		rcConvert;
    char		mbcsPath[MB_CUR_MAX*_MAX_PATH];
    unsigned char *	p;

    /*** Convert the wide character string to a multibyte string ***/
    rcConvert = wcstombs( mbcsPath, path, MB_CUR_MAX*_MAX_PATH );
    p = _mbsninc( mbcsPath, rcConvert );
    *p = '\0';

    rc = DosMkDir( (PSZ)mbcsPath, 0 );
#endif
    
    if( rc != 0 ) {
	return( __set_errno_dos( rc ) );
    }
    return( 0 );            /* indicate no error */
}
