/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  08-oct-93	A.F.Scian	- fixed to transform file time into local time
  				  before converting to a DOS time-stamp
				- added __MakeDOSDT for use by stat/fstat
				- added __ExtractDOSDT for use by _dos_setftime
  10-feb-94	Greg Bentz	fix attribute handling
  22-feb-94	Greg Bentz	fixup attribute handling again
  24-feb-94	A.F.Scian	yet another try at attribute handling
--------------------------------------------------------Version-11.0---------
  27-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  18-apr-95	Greg Bentz	Win95 doesn't seem to support the normal file
  				attribute
  22-may-95	Greg Bentz	variety.h and dll linkage
  02-aug-95	Greg Bentz	another change to attribute handling
  10-jul-96	M. Hildebrand	Use __lib_ versions of ...W Win32 functions.
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <string.h>
#include <direct.h>
#include <windows.h>
#include "libwin32.h"
#include "ntex.h"

#ifndef __WIDECHAR__	/* same for wide char, so only compile this once */
void __MakeDOSDT( FILETIME *NT_stamp, unsigned short *d, unsigned short *t )
{
    FILETIME local_ft;
    
    FileTimeToLocalFileTime( NT_stamp, &local_ft );
    FileTimeToDosDateTime( &local_ft, d, t );
}

void __FromDOSDT( unsigned short d, unsigned short t, FILETIME *NT_stamp )
{
    FILETIME local_ft;
    
    DosDateTimeToFileTime( d, t, &local_ft );
    LocalFileTimeToFileTime( &local_ft, NT_stamp );
}
#endif

void __F_NAME(__GetNTDirInfo,_w__GetNTDirInfo)(DIR_TYPE *dirp, LPWIN32_FIND_DATA ffb )
{
    __MakeDOSDT( &ffb->ftLastWriteTime, &dirp->d_date, &dirp->d_time );
    dirp->d_attr = ffb->dwFileAttributes;
    dirp->d_size = ffb->nFileSizeLow;
    #ifndef __WIDECHAR__
	strncpy( dirp->d_name, ffb->cFileName, NAME_MAX );
    #else
	wcsncpy( dirp->d_name, ffb->cFileName, NAME_MAX );
    #endif
    dirp->d_name[NAME_MAX] = 0;
}

BOOL __F_NAME(__NTFindNextFileWithAttr,_w__NTFindNextFileWithAttr)(
		HANDLE h, DWORD attr, LPWIN32_FIND_DATA ffb )
{
    for(;;) {
	if( ffb->dwFileAttributes == 0 ) {
	    // Win95 seems to return 0 for the attributes sometimes?
	    // In that case, treat as a normal file
	    ffb->dwFileAttributes = FILE_ATTRIBUTE_NORMAL;
	}
	if( attr & ffb->dwFileAttributes ) return ( TRUE );
	#ifdef __WIDECHAR__
	    if( !__lib_FindNextFileW( h, ffb ) )  return( FALSE );
	#else
	    if( !FindNextFileA( h, ffb ) )  return( FALSE );
	#endif
    }
}
