/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  18-mar-87     F.W.Crigger     Initial implementation
  07-apr-87     M.A.Glaum       calls to _DOScall
  13-jan-88     F.W.Crigger     In big data, return regs.x.cflag
--------------------------------------------------Version 6.0----------
  11-apr-88     F.W.Crigger     use tinyio
--------------------------------------------------------Version-11.0---------
  27-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  22-may-95	Greg Bentz	variety.h and dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/

#include "variety.h"
#include "widechar.h"
#include <stdlib.h>
#include "tinyio.h"
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
#endif


_WCRTLINK int __F_NAME(rmdir,_wrmdir)( const CHAR_TYPE *path )
{
#ifndef __WIDECHAR__    
    tiny_ret_t 		rc;

    rc = TinyRemoveDir( path );
#else
    tiny_ret_t 		rc;
    size_t		rcConvert;
    char		mbcsPath[MB_CUR_MAX*_MAX_PATH];
    char *		p;

    /*** Convert the wide character string to a multibyte string ***/
    rcConvert = wcstombs( mbcsPath, path, MB_CUR_MAX*_MAX_PATH );
    p = _mbsninc( mbcsPath, rcConvert );
    *p = '\0';

    rc = TinyRemoveDir( mbcsPath );
#endif
    
    if( TINY_ERROR(rc) ) {
        return( __set_errno_dos( TINY_INFO(rc) ) );
    }
    return( 0 );			    /* indicate no error */
}
