/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  92/12/16	B.J. Stecher	split out from tmpfile/tmpnam
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
*/
#include "variety.h"
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

static char *try_one( char *p, char *buff )
{
    int		fd;
    mode_t	omask;

    if( p == NULL ) return( NULL );
    strcpy( buff, p );
    p = &buff[ strlen( buff ) ];
    if( p[-1] != '/' ) {
	p[0] = '/';
	++p;
    }
    p[0] = '?';
    p[1] = '\0';
    omask = umask( 0 );
    fd = open( buff, O_RDONLY|O_CREAT|O_TEMP, 0666 );
    unlink( buff );
    umask( omask );
    if( fd == -1 ) return( NULL );
    close( fd );
    return( p );
}

char *__tmpdir( char *buff )
{
    char	*p;

    p = try_one( getenv( "TMPDIR" ), buff );
    if( p != NULL ) return( p );
    p = try_one( "/tmp", buff );
    if( p != NULL ) return( p );
    return( buff );
}
