/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  29-dec-86	F.W.Crigger	Initial implementation
  01-nov-87	F.W.Crigger	use same scheme as Microsoft
  23-nov-92	B.J. Stecher	can't check for '=' before names have
  				compared (possible protection exception)
  3-jan-93	B.J. Stecher	QNX should be doing case sensitive compares
  28-jan-93	A. Gupta	Modified for Netware (no environment strings)
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  26-sep-95	M. Hildebrand	Added _wgetenv.
  24-nov-95	Greg Bentz	QNX support doesn't use our mbyte functions
*/
#include "variety.h"
#include "widechar.h"
#include <mbstring.h>
#include <stdlib.h>
#include <string.h>
#include "rtdata.h"
#ifdef __WIDECHAR__
    #include "wenviron.h"
#endif

#if defined(__QNX__)
    #ifdef __WIDECHAR__
	#define CMP_FUNC	wcsncmp
    #else
	#define CMP_FUNC	strncmp
    #endif
#else
    #ifdef __WIDECHAR__
	#define CMP_FUNC	_wcsnicmp
    #else
	#define CMP_FUNC	_mbsnicmp
    #endif
#endif


_WCRTLINK CHAR_TYPE *__F_NAME(getenv,_wgetenv)( const CHAR_TYPE *name )
    {
#ifdef __NETWARE__
	name = name;
#else
	CHAR_TYPE **	envp;
	CHAR_TYPE *	p;
	int		len;

	#ifdef __WIDECHAR__
	    if( _RWD_wenviron == NULL )  __create_wide_environment();
	#endif

	/*** Find the environment string ***/
	__ptr_check( name, 0 );
	envp = __F_NAME(_RWD_environ,_RWD_wenviron);
	if( envp != NULL  &&  name != NULL ) {
	    len = __F_NAME(strlen,wcslen)( name );
	    for( ; p = *envp; ++envp ) {
		if( CMP_FUNC( p, name, len ) == 0 ) {
		    if( p[len] == __F_NAME('=',L'=') )  return( &p[len+1] );
		}
	    }
	}
#endif
	return( NULL ); 		/* not found */
    }
