/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  02-dec-87	F.W.Crigger	Initial implementation
  09-may-91	J.B.Schueler	Removed reference to extern unsigned _psp
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
  28-jan-94	Greg Bentz	added getcmd2
  25-may-94	Greg Bentz	change getcmd2 to _bgetcmd
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  22-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <limits.h>
#include <ctype.h>
#include <dos.h>
#define INCL_DOSMISC
#include <wos2.h>


_WCRTLINK int _bgetcmd( char *buffer, int len )
{
    char _WCI86FAR *cmd;

    #if defined(__386__)
    {
	PTIB		tib;
	PPIB		pib;
	if( DosGetInfoBlocks( &tib, &pib ) != 0 ) {
	    if( buffer && len ) {
		*buffer = '\0';
	    }
	    return( 0 );
	}
	cmd = pib->pib_pchcmd;
    }
    #else
    {
	unsigned short	envseg, cmdoff;
	if( DosGetEnv( &envseg, &cmdoff ) != 0 ) {
	    if( buffer && len ) {
		*buffer = '\0';
	    }
	    return( 0 );
	}
	cmd = MK_FP( envseg, 0 );
	if( !*cmd ) ++cmd;	/* adjust if null environment space */
	while( *cmd ) { 	/* skip over environment space */
	    while( *cmd ) ++cmd;
	    ++cmd;
	}
	++cmd;
	while( *cmd ) ++cmd;/* skip over first copy of program name */
	++cmd;
    }
    #endif
    while( *cmd ) ++cmd;	/* skip over second copy of program name */
    ++cmd;
    while( isspace( *cmd ) ) cmd++; /* trim leading blanks */

    if( buffer == 0 ) {
	int i;
	for( i = 0 ; *cmd ; cmd++, i++ );
	return( i );
    } else if( len == 0 ) {
	return( 0 );
    } else {
	char *p;
	p = buffer;
	for( --len ; len ; --len ) {
	    if( !*cmd ) break;
	    *p++ = *cmd++;
	}
	*p = '\0';
	return( p - buffer );
    }
}


_WCRTLINK char *getcmd( char *buffer )
{
    _bgetcmd( buffer, INT_MAX );
    return( buffer );
}

