/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  14-feb-90	J.B.Schueler	Initial PQNX implementation
  04-nov-92	B.J. Stecher	used _argv rather than __cmd
  28-jan-94	Greg Bentz	added getcmd2
  25-may-94	Greg Bentz	change getcmd2 to _bgetcmd
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	T. Schiller	modified to return total cmd length everytime
				regardless of how many bytes actually get put
				in the buffer
*/

#include "variety.h"
#include <stdio.h>
#include <limits.h>
#include <sys/proc_msg.h>
#include <string.h>

extern	char  	**_argv;		/* argument vector */

_WCRTLINK int (_bgetcmd)(char *buffer, int len)
{
    int    total;
    int    i;
    char  *word;
    char  *p    = NULL;
    char **argv = &_argv[1];

    --len; // reserve space for NULL byte

    if (buffer && (len > 0))
    {
	p  = buffer;
	*p = 0x00;
    }

    /*
     * creates approximation of original command line
     */
    for (word = *argv++, i = 0, total = 0; word; word = *argv++)
    {
	i      = strlen(word);
	total += i;

	if (p)
	{
	    if (i >= len)
	    {
		strncpy(p, word, len);
		p[len] = 0x00;
		p      = NULL;
		len    = 0;
	    }
	    else
	    {
		strcpy(p, word);
		p   += i;
		len -= i;
	    }
	} /* if */

	/*
	 * Account for at least 1 space seperating arguments.
	 */
	if (*argv)
	{
	    if (p)
	    {
		*p++ = ' ';
		--len;
	    }

	    ++total;
	}
    } /* for */

    return total;
}


_WCRTLINK char *(getcmd)( char *buffer )
{
    _bgetcmd( buffer, INT_MAX );
    return( buffer );
}

