/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  09-aug-89     John Dahms      defined for OS/2
  08-jul-91     G. Coschi	include <wos2.h> instead of <os2.h>
  13-feb-92     G. Coschi	mask off network attribute before checking
  				if it's a device
  06-mar-94	Greg Bentz	only devices can be TTYs
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  08-jun-95	Greg Bentz	default windowing system handles are TTYs
*/

#include "variety.h"
#include <wos2.h>
#include "defwin.h"
#include "rtcheck.h"


_WCRTLINK int isatty( int handle ) {

    OS_UINT	handtype, flagword;
    APIRET	rc;

    __handle_check( handle, 0 );
    #ifdef DEFAULT_WINDOWING
	if( _WindowsIsWindowedHandle != 0 ) {
	    if( _WindowsIsWindowedHandle( handle ) ) {
		return( 1 );
	    }
	}
    #endif
    rc = DosQHandType( handle, &handtype, &flagword );
    return( ( handtype & ~HANDTYPE_NETWORK ) == HANDTYPE_DEVICE );
}
