/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  23-nov-87	F.W.Crigger	Initial implementation
  19-may-88	F.W.Crigger	If name found in current directory, use getcwd
  25-may-88	F.W.Crigger	save and restore errno if we find the file.
  30-mar-90	J.B.Schueler	added PQNX support
  30-mar-90	J.B.Schueler	prevent searching root when PATH=path1;;path3
  30-mar-90	J.B.Schueler	prevent applying CWD when path already present
  14-dec-90	J.B.Schueler	QNX version has no direct.h (in unistd.h)
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  26-sep-95	M. Hildebrand	Added _wsearchenv.
*/
#include "variety.h"
#include "widechar.h"
#undef __INLINE_FUNCTIONS__
#include <stdio.h>
#include <stdlib.h>
#if defined(__QNX__)
  #include <unistd.h>
#else
  #include <io.h>
  #include <direct.h>
#endif
#include <string.h>
#include "rtdata.h"
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include "wenviron.h"
#endif

#if defined(__QNX__)
    #ifdef __WIDECHAR__
	#define PATH_SEPARATOR L'/'
	#define LIST_SEPARATOR L':'
    #else
	#define PATH_SEPARATOR '/'
	#define LIST_SEPARATOR ':'
    #endif
#else
    #ifdef __WIDECHAR__
	#define PATH_SEPARATOR L'\\'
	#define LIST_SEPARATOR L';'
    #else
	#define PATH_SEPARATOR '\\'
	#define LIST_SEPARATOR ';'
    #endif
#endif


_WCRTLINK void __F_NAME(_searchenv,_wsearchenv)( const CHAR_TYPE *name, const CHAR_TYPE *env_var, CHAR_TYPE *buffer )
    {
	CHAR_TYPE *p, *p2;
	int prev_errno;

	#ifdef __WIDECHAR__
	    if( _RWD_wenviron == NULL )  __create_wide_environment();
	#endif

	prev_errno = _RWD_errno;
	if( __F_NAME(access,_waccess)( name, 0 ) == 0 ) {
	    p = buffer; 				/* JBS 90/3/30 */
	    for( ;; ) {
		if( name[0] == PATH_SEPARATOR ) break;
		if( name[0] == __F_NAME('.',L'.') ) break;
#ifndef __QNX__
		if( name[0] == __F_NAME('/',L'/') ) break;
		if( name[0] != __F_NAME('\0',L'\0')  &&  name[1] == __F_NAME(':',L':') ) break;
#endif
		__F_NAME(getcwd,_wgetcwd)( buffer, _MAX_PATH );
		p = &buffer[ __F_NAME(strlen,wcslen)( buffer ) ];
		if( p[-1] != PATH_SEPARATOR ) *p++ = PATH_SEPARATOR;
		break;
	    }
	    __F_NAME(strcpy,wcscpy)( p, name );
	    return;
	}
	p = __F_NAME(getenv,_wgetenv)( env_var );
	if( p != NULL ) {
	    for(;;) {
		if( *p == __F_NAME('\0',L'\0') ) break;
		p2 = buffer;
		while( *p ) {
		    if( *p == LIST_SEPARATOR ) break;
		    *p2++ = *p++;
		}
		/* check for zero-length prefix which represents CWD */
		if( p2 != buffer ) {			/* JBS 90/3/30 */
		    if( p2[-1] != PATH_SEPARATOR
#ifndef __QNX__
			&&  p2[-1] != __F_NAME('/','/')
			&&  p2[-1] != __F_NAME(':',':')
#endif
			) {
			*p2++ = PATH_SEPARATOR;
		    }
		    *p2 = '\0';
		    __F_NAME(strcat,wcscat)( p2, name );
		    /* check to see if file exists */
		    if( __F_NAME(access,_waccess)( buffer, 0 ) == 0 ) {
			__set_errno( prev_errno );
			return;
		    }
		}
		if( *p == '\0' ) break;
		++p;
	    }
	}
	buffer[0] = '\0';
    }

