/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987 by WATCOM Systems Inc. All rights	    %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  01-nov-87	F.W.Crigger	Initial implementation
------------------------------------------------------Version 6.0---------
  08-may-88	F.W.Crigger	Use _nmalloc instead of malloc
  03-aug-88	A.F.Scian	fixed
  09-aug-89	John Dahms	adapted for OS/2
  24-aug-89	John Dahms	use malloc under OS/2
  15-nov-89	F.W.Crigger	Add special case for OS386
  17-dec-89	F.W.Crigger	change _nmalloc and _nfree to malloc and free
  28-dec-89	F.W.Crigger	Added conditional call to _nheapgrow()
  10-jun-90	F.W.Crigger	Check to make sure we aren't already initialized
------------------------------------------------------Version 8.0---------
  29-nov-90	F.W.Crigger	Don't call _nheapgrow under Windows
  28-jan-91	C.G.Eisler	Added GetDOSEnvironment for win386
  22-feb-91	F.W.Crigger	Don't call _nheapgrow anymore
  06-mar-91	J.B.Schueler	Set up the initial environment string mask
  13-mar-91	F.W.Crigger	Use global var __Envseg filled in by startup
  03-apr-91	C.G.Eisler	updated for WINDOWS_386 macro
  14-apr-91	F.W.Crigger	Use global var __Envptr filled in by startup
  09-jul-91     G. Coschi	support OS/2 2.0
--------------------------------------------------Version 9.x----------
  06-mar-92	Craig Eisler	support NT
  25-jun-92	Craig Eisler	use GetDosEnvironment for windows
  15-feb-93	Ashish Gupta	Netware support (no environment so setenvp()
  				does nothing)
  18-jun-93	John Dahms  	all library allocations use lib_xxx routines
  28-jul-93	A.F.Scian	fixed for null environments (code assumed at
  				least one environment variable existed)
--------------------------------------------------------Version-11.0---------
  21-feb-95	Greg Bentz	alpha support
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  22-may-95	Greg Bentz	dll linkage
  27-oct-95	M. Hildebrand	Handle C_FILE_INFO environment entry.
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <dos.h>
#include <env.h>
#include "liballoc.h"
#include <string.h>
#include "filestr.h"
#include "rtdata.h"
#if defined(__OS2__)
    #define INCL_DOSMISC
    #include <wos2.h>
#endif
#if defined(__NT__)
    #include <windows.h>
#endif
#if defined(__WINDOWS__)
    extern char _WCI86FAR * _WCI86FAR __pascal GetDOSEnvironment( void );
#elif defined(__DOS_386__)
    extern char _WCFAR *_Envptr;
#elif !defined(__NETWARE__)
    extern char _WCI86FAR *_Envptr;
#endif

#if !defined(__NETWARE__)
static char *_free_ep;

static void * (_WCI86NEAR allocate)( size_t amt ) {
    void *ptr;
    #if defined(__REAL_MODE__) && defined(__BIG_DATA__)
	#if defined(__OS2_286__)
	    if( _osmode == DOS_MODE ) {
		ptr = lib_nmalloc( amt );
		if( (void _WCI86NEAR *) ptr == NULL ) {
		    ptr = lib_malloc( amt );
		}
	    } else {
		ptr = lib_malloc( amt );
	    }
	#else
	    ptr = lib_nmalloc( amt );
	    if( (void _WCI86NEAR *) ptr == NULL ) {
		ptr = lib_malloc( amt );
	    }
	#endif
    #else
	ptr = lib_malloc( amt );
    #endif
    return( ptr );
}
#endif

void __setenvp() {
    #if defined(__NETWARE__)
	// no environment support
    #else
	#if defined(__WINDOWS_386__) || defined(__DOS_386__)
	    char	_WCFAR *startp;
	    char	_WCFAR *p;
	#else
	    char	_WCI86FAR *startp;
	    char	_WCI86FAR *p;
	#endif
	char	*ep;
	char	**my_environ;
	int	count;
	size_t  ep_size;
	size_t  env_size;

	/* if we are already initialized, then return */
	if( _RWD_environ != NULL ) return;	     /* 10-jun-90 */
	#if defined(__WARP__)
	    startp = _Envptr;
	#elif defined(__OS2_286__)
	{
	    unsigned short  seg;

	    DosGetEnv( (PUSHORT)&seg, (PUSHORT)&count );
	    startp = MK_FP( seg, 0 );
	}
	#elif defined(__WINDOWS__)
	{
	    unsigned long tmp;

	    tmp = (unsigned long) GetDOSEnvironment();
	    startp = MK_FP( (unsigned short)(tmp >> 16),
			    (unsigned long) (tmp & 0xFFFF ));
	}
	#elif defined(M_I86)
	    startp = MK_FP( *(unsigned short _WCI86FAR *)(MK_FP(_RWD_psp, 0x2c)), 0 );
	#else
	    startp = _Envptr;					/* 13-mar-91 */
	#endif
	count = 0;
	p = startp;
	while( *p ) {
	    while( *p ) ++p;
	    ++count;
	    ++p;
	}
	ep_size = p - startp;
	if( ep_size == 0 ) {
	    ep_size = 1;
	}
	ep = (char *)allocate( ep_size );
	if( ep ) {
	    _free_ep = ep;
	    env_size = (count+1) * sizeof( char * ) + count * sizeof( char );
	    my_environ = (char **)allocate( env_size );
	    if( my_environ ) {
		_RWD_environ = my_environ;
		count = 0;
		p = startp;
		while( *p ) {
		    _RWD_environ[ count ] = ep;
		    while( *ep++ = *p++ );
		    ++count;
		}
		_RWD_environ[ count ] = NULL;
		_RWD_env_mask = (char *) &_RWD_environ[ count + 1 ];   /* 06-mar-91 */
		memset( _RWD_env_mask, 0, (count) * sizeof(char) );
	    } else {
		lib_free( ep );
	    }
	}

	/*** Handle the C_FILE_INFO entry ***/
	#ifdef __USE_POSIX_HANDLE_STRINGS
	    __ParsePosixHandleStr();
	#endif
    #endif
}

#if !defined(__NETWARE__)
void __freeenvp() {
    clearenv();
    if( _RWD_environ ) {
	lib_free( _RWD_environ );
	_RWD_environ = NULL;
    }
    if( _free_ep ) {
	lib_free( _free_ep );
	_free_ep = NULL;
    }
    #if defined(__NT__)
	if( _Envptr ) {
	    FreeEnvironmentStrings( _Envptr );
	}
    #endif
}
#endif
