/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  31-oct-87     F.W.Crigger     Initial implementation
  14-jan-93	F.W.Crigger	only look at top bit of rc to see if error
  25-feb-94	Greg Bentz	add _access()
--------------------------------------------------------Version-11.0---------
  17-apr-95	M. Hildebrand	Added wide character support.
  22-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	M. Hildebrand	Moved filename_from_wide to another file.
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/

#include "variety.h"
#include "widechar.h"
#include <io.h>
#include <dos.h>
#include "tinyio.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
    #include <stdlib.h>
    #include "mbwcconv.h"
#endif

extern  int           _dosret0(unsigned,unsigned);


_WCRTLINK int __F_NAME(access,_waccess)( const CHAR_TYPE *pathname, int pmode )
    {
	unsigned long	rc;
	unsigned	ax, dx;
#ifdef __WIDECHAR__
	char		mbPath[MB_CUR_MAX*_MAX_PATH]; /* single-byte char */
#endif

    	#ifdef __WIDECHAR__
	    __filename_from_wide( mbPath, pathname );
	    rc = TinyAccess( mbPath, pmode );
	#else
	    rc = TinyAccess( pathname, pmode );
	#endif

        ax = rc & 0xffff;
	dx = rc >> 16;
        return _dosret0( ax, dx );
    }
