/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  08-aug-89     John Dahms      defined for OS2
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
  25-feb-94	Greg Bentz	add _access()
  17-mar-94	Kevin Hui	use ERROR_ACCESS_DENIED for invalid access
--------------------------------------------------------Version-11.0---------
  17-apr-95	M. Hildebrand	Added wide character support.
  22-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	M. Hildebrand	Moved filename_from_wide to another file.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  19-mar-96	Greg Bentz	tweak typing inconsistencies
*/

#include "variety.h"
#include "widechar.h"
#include <io.h>
#include <direct.h>
#define INCL_DOSERRORS
#include <wos2.h>
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
    #include <stdlib.h>
    #include "mbwcconv.h"
#endif


_WCRTLINK int __F_NAME(access,_waccess)( const CHAR_TYPE *path, int pmode )
    {
        USHORT		attr;
#ifdef __WIDECHAR__
	char		mbPath[MB_CUR_MAX*_MAX_PATH]; /* single-byte char */
#endif

#if defined(__WARP__)
	FILESTATUS	fs;
	APIRET		rc;
	
    	#ifdef __WIDECHAR__
	    __filename_from_wide( mbPath, path );
	    rc = DosQueryPathInfo( (PSZ)mbPath, FIL_STANDARD,
	                           &fs, sizeof( FILESTATUS ) );
	#else
	    rc = DosQueryPathInfo( (PSZ)path, FIL_STANDARD,
	                           &fs, sizeof( FILESTATUS ) );
	#endif
	attr = fs.attrFile;
#else
        USHORT		rc;
	
    	#ifdef __WIDECHAR__
	    __filename_from_wide( mbPath, path );
	    rc = DosQFileMode( mbPath, &attr, 0 );
	#else
	    rc = DosQFileMode( (PSZ)path, &attr, 0 );
	#endif
#endif

        if( rc ) {
            __set_errno_dos( rc );
            return( -1 );
        }
        if( ( pmode & ACCESS_WR ) && ( attr & _A_RDONLY ) ) {
            __set_errno_dos( ERROR_ACCESS_DENIED ); /* invalid access mode */
            return( -1 );
        }
        return( 0 );
    }
