/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  25-feb-94	Greg Bentz	add _access()
--------------------------------------------------------Version-11.0---------
  17-apr-95	M. Hildebrand	Added wide character support.
  22-may-95	Greg Bentz	variety.h and dll linkage
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  21-jun-96	M. Hildebrand	Win95 doesn't support GetFileAttributesW.
  05-jul-96	M. Hildebrand	Use __lib_ versions of ...W Win32 functions.
*/

#include "variety.h"
#include "widechar.h"
#include <io.h>
#include <direct.h>
#include <windows.h>
#include "libwin32.h"
#include "seterrno.h"


_WCRTLINK int __F_NAME(access,_waccess)( const CHAR_TYPE *path, int pmode )
{
    LONG		attr;

    #ifdef __WIDECHAR__
	attr = __lib_GetFileAttributesW( path );
    #else
	/*
	 * If we actually want the attributes for the file, we should call
	 * __lib_GetFileAttributesA, which works around a bug in NT's
	 * GetFileAttributesA.  However, we're only concerned about the
	 * existence of the file, and what NT provides is sufficient, so
	 * to minimize executable size, don't call the clib internal smarter
	 * version.
	 */
	attr = GetFileAttributesA( path );
    #endif
    if( attr == -1 ) {
	return( __set_errno_nt() );
    }
 
    if( ( pmode & ACCESS_WR ) && ( attr & FILE_ATTRIBUTE_READONLY ) ) {
	return( __set_errno_dos( ERROR_ACCESS_DENIED ) );
    }
    return( 0 );
}
