/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  31-oct-87	F.W.Crigger	Initial implementation
  06-dec-90	F.W.Crigger	Added "sub eax,eax" for 386 to remove garbage
  28-mar-91	C.G.Eisler	Modified for 32-bit windows
  03-apr-91	C.G.Eisler	updated for WINDOWS_386 flag
  24-jul-91	F.W.Crigger	moved "pop ds" to bottom of _BDchmode pragma
  20-nov-93	F.W.Crigger	use asm mnemonics, removed special case for
  				386 windows
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  22-may-95	Greg Bentz	dll linkage
  27-sep-95	M. Hildebrand	Added _wchmod.
*/
#include "variety.h"
#include "widechar.h"
#include <io.h>
#include <dos.h>
#include "tinyio.h"
#include <errno.h>
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
    #include <stdlib.h>
    #include "mbwcconv.h"
#endif

extern	int	      _dosret0(unsigned,unsigned);
extern	unsigned long _chmode(const char *,unsigned);
extern	unsigned long _BDchmode(const char *,unsigned);

#if defined(__386__)
#pragma aux	_chmode   = "   sub eax,eax" \
			    "   mov ah,43h"  \
				_INT_21      \
			    "   jc  short L3"\
			    "	test bl,80h" \
			    "	je  short L1"\
			    "	and cl,0feh" \
			    "	jmp short L2"\
			    "L1:or  cl,01h"  \
			    "L2:mov ah,43h"  \
			    "	mov al,01h"  \
				_INT_21      \
			    "L3:rcl eax,1"   \
			    "   ror eax,1"   \
			parm caller [edx] [ebx] value [eax] modify [ecx];
#elif defined(M_I86)
#pragma aux	_chmode   = "   mov ax,4300h"\
			    "   int 21h"     \
			    "   jc  short L3"\
			    "	test bl,80h" \
			    "	je  short L1"\
			    "	and cl,0feh" \
			    "	jmp short L2"\
			    "L1:or  cl,01h"  \
			    "L2:mov ax,4301h"\
			    "   int 21h"     \
			    "L3:sbb dx,dx"   \
			parm caller [dx] [bx] value [ax dx] modify [cx];

#pragma aux	_BDchmode = "   mov ax,4300h"\
			    "   push ds"     \
			    "   mov ds,cx"   \
			    "   int 21h"     \
			    "   jc  short L3"\
			    "	test bl,80h" \
			    "	je  short L1"\
			    "	and cl,0feh" \
			    "	jmp short L2"\
			    "L1:or  cl,01h"  \
			    "L2:mov ax,4301h"\
			    "   int 21h"     \
			    "L3:sbb dx,dx"   \
			    "   pop ds"      \
			parm caller [dx cx] [bx] value [ax dx] modify [cx];
#else
#error platform not supported
#endif


_WCRTLINK int __F_NAME(chmod,_wchmod)( const CHAR_TYPE *pathname, int pmode )
{
#if defined(__PENPOINT__)

    pathname = pathname;
    pmode = pmode;

    __set_errno( EACCES );  /* Go will provide their own version of chmod */
    return( -1 );

#else
    unsigned long rc;
    unsigned ax, dx;

#ifdef __WIDECHAR__
    char		mbPath[MB_CUR_MAX*_MAX_PATH];
    __filename_from_wide( mbPath, pathname );
#endif

#if defined(__BIG_DATA__)
    rc = _BDchmode( __F_NAME(pathname,mbPath), pmode );
#else
    rc = _chmode( __F_NAME(pathname,mbPath), pmode );
#endif
    ax = rc & 0xffff;
    dx = rc >> 16;
    return _dosret0( ax, dx );
#endif
}

