/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  09-aug-89     John Dahms      defined for OS/2
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  27-sep-95	M. Hildebrand	Added _wchmod.
  19-mar-96	Greg Bentz	tweak typing inconsistencies
*/

#include "variety.h"
#include "widechar.h"
#include <io.h>
#include <direct.h>
#include <wos2.h>
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
    #include <stdlib.h>
    #include "mbwcconv.h"
#endif


_WCRTLINK int __F_NAME(chmod,_wchmod)( const CHAR_TYPE *pathname, int pmode )
    {
        APIRET	rc;
        USHORT	attr;
#if defined(__WARP__)
	FILESTATUS	fs;
	
	#ifdef __WIDECHAR__
	    char	mbPath[MB_CUR_MAX*_MAX_PATH];
	    __filename_from_wide( mbPath, pathname );
	#endif
	rc = DosQueryPathInfo( (PSZ)__F_NAME(pathname,mbPath), FIL_STANDARD,
	                       &fs, sizeof( FILESTATUS ) );
	attr = fs.attrFile;
#else
	#ifdef __WIDECHAR__
	    char	mbPath[MB_CUR_MAX*_MAX_PATH];
	    __filename_from_wide( mbPath, pathname );
	#endif
        rc = DosQFileMode( (PSZ)__F_NAME(pathname,mbPath), &attr, 0 );
#endif
        if( rc != 0 ) {
            return( __set_errno_dos( rc ) );
        }
        attr &= ~_A_RDONLY;
        if( !( pmode & S_IWRITE ) ) {
            attr |= _A_RDONLY;
        }
#if defined(__WARP__)
	fs.attrFile = attr;
	rc = DosSetPathInfo( (PSZ)__F_NAME(pathname,mbPath), FIL_STANDARD,
	                       &fs, sizeof( FILESTATUS ), 0 );
#else
        rc = DosSetFileMode( (PSZ)__F_NAME(pathname,mbPath), attr, 0 );
#endif
        if( rc != 0 ) {
            return( __set_errno_dos( rc ) );
        }
        return( 0 );
    }
