/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  12-jul-93	F.W.Crigger	changed rc != 0 to rc == 0
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  27-sep-95	M. Hildebrand	Added _wchmod.
  02-oct-95	M. Hildebrand	Don't __F_NAME NT API functions; #define
				UNICODE in uchmdwnt.c instead.
  05-jul-96	M. Hildebrand	Use __lib_ versions of ...W Win32 functions.
  28-aug-96	M. Hildebrand	Work around bug in NT.
*/
#include "variety.h"
#include "widechar.h"
#include <io.h>
#include <direct.h>
#include <windows.h>
#include "libwin32.h"
#include "seterrno.h"

_WCRTLINK int __F_NAME(chmod,_wchmod)( const CHAR_TYPE *pathname, int pmode )
{
    BOOL	rc;
    long	attr;
    
    #ifdef __WIDECHAR__
	attr = __lib_GetFileAttributesW( pathname );
    #else
	attr = __lib_GetFileAttributesA( pathname );
    #endif
    if( attr == 0xFFFFFFFF ) {
	return( __set_errno_nt() );
    }
    attr &= ~FILE_ATTRIBUTE_READONLY;
    if( !( pmode & S_IWRITE ) ) {
	attr |= FILE_ATTRIBUTE_READONLY;
    }
    #ifdef __WIDECHAR__
	rc = __lib_SetFileAttributesW( pathname, attr );
    #else
	rc = SetFileAttributesA( pathname, attr );
    #endif
    if( rc == FALSE ) {
	return( __set_errno_nt() );
    }
    return( 0 );
}
