/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   14-dec-95	M. Hildebrand	Initial implementation.
   25-jun-96	M. Hildebrand	Support platforms other than Win32.
   04-jul-96	M. Hildebrand	Added __int64 support.
   10-jul-96	M. Hildebrand	Use __lib_ versions of ...W Win32 functions.
   10-jul-96	M. Hildebrand	Support __int64 for non-Win32 systems.
*/

#include "variety.h"
#include "int64.h"
#include "widechar.h"
#include <io.h>
#include "find.h"
#include "seterrno.h"
#ifdef __NT__
    #include <windows.h>
    #include "libwin32.h"
    #include "ntex.h"
#else
#endif


#ifdef __WIDECHAR__
 #ifdef __INT64__
  _WCRTLINK int _wfindnexti64( long handle, struct _wfinddatai64_t *fileinfo )
 #else
  _WCRTLINK int _wfindnext( long handle, struct _wfinddata_t *fileinfo )
 #endif
#else
 #ifdef __INT64__
  _WCRTLINK int _findnexti64( long handle, struct _finddatai64_t *fileinfo )
 #else
  _WCRTLINK int _findnext( long handle, struct _finddata_t *fileinfo )
 #endif
#endif
{
    #ifdef __NT__
	WIN32_FIND_DATA	ffb;
	BOOL		rc;
    
	/*** Try to find another matching file ***/
	#ifdef __WIDECHAR__
	    rc = __lib_FindNextFileW( (HANDLE)handle, &ffb );
	#else
	    rc = FindNextFileA( (HANDLE)handle, &ffb );
	#endif
	if( rc == FALSE ) {
	    __set_errno_nt();
	    return( -1 );
	}
	if( !__NTFindNextFileWithAttr( (HANDLE)handle, FIND_ATTR, &ffb ) ) {
	    __set_errno_dos( ERROR_FILE_NOT_FOUND );
	    return( -1 );
	}
	
	/*** Got one! ***/
	#ifdef __INT64__
	    __F_NAME(__nt_finddatai64_cvt,__nt_wfinddatai64_cvt)( &ffb, fileinfo );
	#else
	    __F_NAME(__nt_finddata_cvt,__nt_wfinddata_cvt)( &ffb, fileinfo );
	#endif
	return( 0 );
    #else
	DOSFINDTYPE *	findbuf = (DOSFINDTYPE*) handle;
	unsigned	rc;

	rc = __F_NAME(_dos_findnext,_wdos_findnext)( findbuf );
	if( rc != 0 ) {
	    return( -1L );
	} else {
	    #ifdef __INT64__
		__F_NAME(__dos_finddatai64_cvt,__dos_wfinddatai64_cvt)( findbuf, fileinfo );
	    #else
		__F_NAME(__dos_finddata_cvt,__dos_wfinddata_cvt)( findbuf, fileinfo );
	    #endif
	    return( 0 );
	}
    #endif
}
