/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  17-mar-87     F.W.Crigger     Initial implementation
  07-apr-87     M.A.Glaum       calls to _DOScall
  29-jan-88     F.W.Crigger     return x.cflag in large model
  15-feb-88     A.F.Scian       fixed ES==DS dependency for small data models
                                cleaned up code
--------------------------------------------------Version 6.0----------
  11-apr-88     F.W.Crigger     use tinyio
--------------------------------------------------------Version-11.0---------
  17-apr-95	M. Hildebrand	Added wide character support.
  22-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	M. Hildebrand	Moved filename_from_wide to another file.
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/

#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include "tinyio.h"
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
    #include <stdlib.h>
    #include "mbwcconv.h"
#endif


_WCRTLINK int __F_NAME(rename,_wrename)( const CHAR_TYPE *old, const CHAR_TYPE *new )
    {
	tiny_ret_t  rc;
#ifdef __WIDECHAR__
	char	    mbOld[MB_CUR_MAX*_MAX_PATH];    /* single-byte char */
	char	    mbNew[MB_CUR_MAX*_MAX_PATH];    /* single-byte char */
#endif

    	#ifdef __WIDECHAR__
	    __filename_from_wide( mbOld, old );
	    __filename_from_wide( mbNew, new );
	    rc = TinyRename( mbOld, mbNew );
	#else
	    rc = TinyRename( old, new );
	#endif

        if( TINY_ERROR(rc) ) {
            return( __set_errno_dos( TINY_INFO(rc) ) );
        }
        return( 0 );            /* indicate no error */
    }
