/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  09-aug-89     John Dahms      defined for OS/2
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
--------------------------------------------------------Version-11.0---------
  17-apr-95	M. Hildebrand	Added wide character support.
  22-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	M. Hildebrand	Moved filename_from_wide to another file.
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  19-mar-96	Greg Bentz	tweak typing inconsistencies
*/

#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <wos2.h>
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
    #include <stdlib.h>
    #include "mbwcconv.h"
#endif


_WCRTLINK int __F_NAME(rename,_wrename)( const CHAR_TYPE *old, const CHAR_TYPE *new )
    {
	APIRET	    rc;
#ifdef __WIDECHAR__
	char	    mbOld[MB_CUR_MAX*_MAX_PATH];    /* single-byte char */
	char	    mbNew[MB_CUR_MAX*_MAX_PATH];    /* single-byte char */
#endif
	
    	#ifdef __WIDECHAR__
	    __filename_from_wide( mbOld, old );
	    __filename_from_wide( mbNew, new );
	    #if defined(__WARP__)
		rc = DosMove( (PSZ)mbOld, (PSZ)mbNew );
	    #else
		rc = DosMove( mbOld, mbNew, 0 );
	    #endif
	#else
	    #if defined(__WARP__)
		rc = DosMove( (PSZ)old, (PSZ)new );
	    #else
		rc = DosMove( (PSZ)old, (PSZ)new, 0 );
	    #endif
	#endif

        if( rc != 0  ) {
            return( __set_errno_dos( rc ) );
        }
        return( 0 );            /* indicate no error */
    }
