/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  08-sep-87	A.F.Scian	defined
--------------------------------------------------------------Version 7.0-----
  07-apr-89	F.W.Crigger	Adapted for 386
  11-oct-89	F.W.Crigger	must set es for DOS/16M
--------------------------------------------------------------Version 8.x-----
  26-feb-91	C.G.Eisler	Adapted for 386 windows
  03-apr-91	C.G.Eisler	Updated WINDOWS_386 macro
--------------------------------------------------------------Version 9.0-----
  12-apr-93	A.F.Scian	added sanity check for DOS time-stamps
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  22-may-95	Greg Bentz	dll linkage
  22-sep-95	M. Hildebrand	Added _wutime.
  18-oct-95	M. Hildebrand	Added _utime for MS compatability.
  27-nov-95	Greg Bentz	fixup const in function definition
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <stddef.h>
#include <sys\types.h>
#include <time.h>
#include <dos.h>
#include "dosfunc.h"
#include <sys\stat.h>
#include <errno.h>
#include <sys\utime.h>
#include "rtdata.h"
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
    #include <stdlib.h>
    #include "mbwcconv.h"
#endif
#ifdef __WINDOWS_386__
    #include <windows.h>
#endif


_WCRTLINK int __F_NAME(utime,_wutime)( CHAR_TYPE const *fn, struct utimbuf const *times )
/**********************************************************************************/
{
    unsigned handle;
    struct tm *split;
    union REGS reg_set;
    time_t curr_time;

#if defined(__386__) && !defined(__WINDOWS_386__)
    #ifdef __WIDECHAR__
	char    mbPath[MB_CUR_MAX*_MAX_PATH];   /* single-byte char */
	__filename_from_wide( mbPath, fn );
    #endif
    reg_set.x.edx = (unsigned) __F_NAME(fn,mbPath);
    reg_set.h.ah = DOS_OPEN;
    reg_set.h.al = 0x01;	/* write access */
    (void) intdos( &reg_set, &reg_set );
    if( reg_set.x.cflag != 0 ) {
	switch( reg_set.w.ax ) {
	case 2:
	    __set_errno( ENOENT );
	    break;
	case 4:
	    __set_errno( EMFILE );
	    break;
	case 5:
	    __set_errno( EACCES );
	    break;
	}
	return( -1 );
    }
    if( times == NULL ) {
	curr_time = time( NULL );
	split = localtime( &curr_time );
    } else {
	split = localtime( &(times->modtime) );
    }
    if( split->tm_year < 80 ) {
	/* DOS file-system cannot handle dates before 1980 */
	__set_errno( EINVAL );
	return( -1 );
    }
    handle = reg_set.w.ax;
    reg_set.w.bx = handle;
    reg_set.w.cx = split->tm_hour*2048 + split->tm_min*32 +
		   (split->tm_sec >> 1);
    reg_set.w.dx = (split->tm_year-80)*512 + ( split->tm_mon + 1 )*32 +
		   split->tm_mday;
    reg_set.h.ah = DOS_FILE_DATE;
    reg_set.h.al = 1;		/* set date & time */
    (void) intdos( &reg_set, &reg_set );
    if( reg_set.x.cflag != 0 ) {
	__set_errno( EACCES );
	return( -1 );
    }
    reg_set.w.bx = handle;
    reg_set.h.ah = DOS_CLOSE;
    (void) intdos( &reg_set, &reg_set );
    if( reg_set.x.cflag != 0 ) {
	__set_errno( EACCES );
	return( -1 );
    }
    return( 0 );
    
#elif defined(__BIG_DATA__) || defined(__386__)

    struct SREGS sregs;
    #ifdef __WIDECHAR__
	char    mbPath[MB_CUR_MAX*_MAX_PATH];   /* single-byte char */
    #endif
#if defined(__386__)
    unsigned long alias;
    #ifdef __WIDECHAR__
	__filename_from_wide( mbPath, fn );
    #endif
    alias = AllocAlias16( (void *)__F_NAME(fn,mbPath) );
    reg_set.x.dx = alias & 0xffff;
    sregs.ds = alias >> 16;
#else
    #ifdef __WIDECHAR__
	__filename_from_wide( mbPath, fn );
    #endif
    reg_set.x.dx = FP_OFF( __F_NAME(fn,mbPath) );
    sregs.ds = FP_SEG( __F_NAME(fn,mbPath) );
#endif
    sregs.es = sregs.ds;			/* for DOS/16M */
    reg_set.h.ah = DOS_OPEN;
    reg_set.h.al = 0x01;	/* write access */
    (void) intdosx( &reg_set, &reg_set, &sregs );
#if defined(__386__)
    FreeAlias16( alias );
#endif
    if( reg_set.x.cflag != 0 ) {
	switch( reg_set.x.ax ) {
	case 2:
	    __set_errno( ENOENT );
	    break;
	case 4:
	    __set_errno( EMFILE );
	    break;
	case 5:
	    __set_errno( EACCES );
	    break;
	}
	return( -1 );
    }
    if( times == NULL ) {
	curr_time = time( NULL );
	split = localtime( &curr_time );
    } else {
	split = localtime( &(times->modtime) );
    }
    if( split->tm_year < 80 ) {
	/* DOS file-system cannot handle dates before 1980 */
	__set_errno( EINVAL );
	return( -1 );
    }
    handle = reg_set.x.ax;
    reg_set.x.bx = handle;
    reg_set.x.cx = split->tm_hour*2048 + split->tm_min*32 +
		   (split->tm_sec >> 1);
    reg_set.x.dx = (split->tm_year-80)*512 + ( split->tm_mon + 1 )*32 +
		   split->tm_mday;
    reg_set.h.ah = DOS_FILE_DATE;
    reg_set.h.al = 1;		/* set date & time */
    (void) intdos( &reg_set, &reg_set );
    if( reg_set.x.cflag != 0 ) {
	__set_errno( EACCES );
	return( -1 );
    }
    reg_set.x.bx = handle;
    reg_set.h.ah = DOS_CLOSE;
    (void) intdos( &reg_set, &reg_set );
    if( reg_set.x.cflag != 0 ) {
	__set_errno( EACCES );
	return( -1 );
    }
    return( 0 );

#else

    #ifdef __WIDECHAR__
	char    mbPath[MB_CUR_MAX*_MAX_PATH];   /* single-byte char */
	__filename_from_wide( mbPath, fn );
    #endif
    reg_set.x.dx = (unsigned) __F_NAME(fn,mbPath);
    reg_set.h.ah = DOS_OPEN;
    reg_set.h.al = 0x01;	/* write access */
    (void) intdos( &reg_set, &reg_set );
    if( reg_set.x.cflag != 0 ) {
	switch( reg_set.x.ax ) {
	case 2:
	    __set_errno( ENOENT );
	    break;
	case 4:
	    __set_errno( EMFILE );
	    break;
	case 5:
	    __set_errno( EACCES );
	    break;
	}
	return( -1 );
    }
    if( times == NULL ) {
	curr_time = time( NULL );
	split = localtime( &curr_time );
    } else {
	split = localtime( &(times->modtime) );
    }
    if( split->tm_year < 80 ) {
	/* DOS file-system cannot handle dates before 1980 */
	__set_errno( EINVAL );
	return( -1 );
    }
    handle = reg_set.x.ax;
    reg_set.x.bx = handle;
    reg_set.x.cx = split->tm_hour*2048 + split->tm_min*32 +
		   (split->tm_sec >> 1);
    reg_set.x.dx = (split->tm_year-80)*512 + ( split->tm_mon + 1 )*32 +
		   split->tm_mday;
    reg_set.h.ah = DOS_FILE_DATE;
    reg_set.h.al = 1;		/* set date & time */
    (void) intdos( &reg_set, &reg_set );
    if( reg_set.x.cflag != 0 ) {
	__set_errno( EACCES );
	return( -1 );
    }
    reg_set.x.bx = handle;
    reg_set.h.ah = DOS_CLOSE;
    (void) intdos( &reg_set, &reg_set );
    if( reg_set.x.cflag != 0 ) {
	__set_errno( EACCES );
	return( -1 );
    }
    return( 0 );
#endif
}
