/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  11-aug-89	John Dahms	defined for OS/2
  05-apr-90	Dean Gaudet	fixed for early versions of OS/2
  30-jan-91	John Dahms	field name acctime -> actime
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  22-sep-95	M. Hildebrand	Added _wutime.
  18-oct-95	M. Hildebrand	Added _utime for MS compatability.
  27-nov-95	Greg Bentz	fixup const in function definition
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <stddef.h>
#include <sys\types.h>
#include <time.h>
#include <dos.h>
#include <wos2.h>
#include <sys\stat.h>
#include <errno.h>
#include <direct.h>
#include <sys\utime.h>
#include "openmode.h"
#include "rtdata.h"
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
    #include <stdlib.h>
    #include "mbwcconv.h"
#endif


_WCRTLINK int __F_NAME(utime,_wutime)( CHAR_TYPE const *fn, struct utimbuf const *times )
/***************************************************************************************/
{
    APIRET	error;
    OS_UINT	actiontaken;
    FILESTATUS	stat;
    HFILE	handle;
    struct tm	*split;
    time_t	curr_time;
    struct	utimbuf time_buf;
#ifdef __WIDECHAR__
    char    mbPath[MB_CUR_MAX*_MAX_PATH]; /* single-byte char */
    __filename_from_wide( mbPath, fn );
#endif

    error = DosOpen( (PSZ)__F_NAME(fn,mbPath), &handle, &actiontaken, 0ul, _A_NORMAL,
		     OPENFLAG_FAIL_IF_NOT_EXISTS | OPENFLAG_OPEN_IF_EXISTS,
		     OPENMODE_DENY_NONE | OPENMODE_ACCESS_RDWR,
		     0ul );
    if( error != 0 ) {
	__set_errno_dos( error );
	return( -1 );
    }
    if( DosQFileInfo( handle, 1, (PBYTE)&stat, sizeof( FILESTATUS ) ) != 0 ) {
	DosClose( handle );
	__set_errno( EACCES );
	return( -1 );
    }
    if( times == NULL ) {
	curr_time = time( NULL );
	time_buf.modtime = curr_time;
	time_buf.actime = curr_time;
	times = &time_buf;
    }
    split = localtime( &(times->modtime) );
    stat.fdateLastWrite.year	 = split->tm_year - 80;
    stat.fdateLastWrite.month	 = split->tm_mon + 1;
    stat.fdateLastWrite.day	 = split->tm_mday;
    stat.ftimeLastWrite.hours	 = split->tm_hour;
    stat.ftimeLastWrite.minutes  = split->tm_min;
    stat.ftimeLastWrite.twosecs  = split->tm_sec >> 1;

/*  5-Apr-90 DJG
 *  Early versions of OS/2 (1.10) do not support this fields properly.
 *  We'll assume that if OS/2 returned a value here that we can set it
 *  ourselves.	Day has to be non-zero if the date is valid.
 */
    if( stat.fdateLastAccess.day != 0 ) {
	split = localtime( &(times->actime) );
	stat.fdateLastAccess.year    = split->tm_year - 80;
	stat.fdateLastAccess.month   = split->tm_mon + 1;
	stat.fdateLastAccess.day     = split->tm_mday;
	stat.ftimeLastAccess.hours   = split->tm_hour;
	stat.ftimeLastAccess.minutes = split->tm_min;
	stat.ftimeLastAccess.twosecs = split->tm_sec >> 1;
    }

    if( DosSetFileInfo( handle, 1, (PBYTE)&stat, sizeof( FILESTATUS ) ) != 0 ) {
	DosClose( handle );
	__set_errno( EACCES );
	return( -1 );
    }
    if( DosClose( handle ) != 0 ) {
	__set_errno( EACCES );
	return( -1 );
    }
    return( 0 );
}
