/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  08-sep-87	A.F.Scian	defined
--------------------------------------------------------------Version 7.0-----
  07-apr-89	F.W.Crigger	Adapted for 386
  11-oct-89	F.W.Crigger	must set es for DOS/16M
--------------------------------------------------------------Version 8.x-----
  26-feb-91	C.G.Eisler	Adapted for 386 windows
  03-apr-91	C.G.Eisler	Updated WINDOWS_386 macro
--------------------------------------------------------------Version 9.0-----
  12-apr-93	A.F.Scian	added sanity check for DOS time-stamps
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  22-may-95	Greg Bentz	dll linkage
  02-jun-95	F.W.Crigger	adapted from utime.c for OSI library
  18-oct-95	M. Hildebrand	Added _utime for MS compatability.
  27-nov-95	Greg Bentz	fixup const in function definition
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include <stddef.h>
#include <sys\types.h>
#include <time.h>
#include "tinyio.h"
#include <sys\utime.h>


int utime( char const *fn, struct utimbuf const *times )
/******************************************************/
{
    int		handle;
    int		rc;
    struct tm	*split;
    time_t	curr_time;
    tiny_ftime_t ftime;
    tiny_fdate_t fdate;

    handle = TinyOpen( fn, TIO_READ_WRITE );
    if( handle < 0 ) {
	return( -1 );
    }
    if( times == NULL ) {
	curr_time = time( NULL );
	split = localtime( &curr_time );
    } else {
	split = localtime( &(times->modtime) );
    }
    if( split->tm_year < 80 ) {
	/* DOS file-system cannot handle dates before 1980 */
	TinyClose( handle );
	return( -1 );
    }
    ftime.hours   = split->tm_hour;
    ftime.minutes = split->tm_min;
    ftime.twosecs = split->tm_sec >> 1;
    fdate.year    = split->tm_year - 80;
    fdate.month   = split->tm_mon + 1;
    fdate.day     = split->tm_mday;
    rc = TinySetFileStamp( handle, ftime, fdate );
    TinyClose( handle );
    if( rc < 0 ) return( -1 );
    return( 0 );
}
