/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  06-mar-92     Craig Eisler	defined for NT
  07-oct-93	A.F.Scian	fixed to convert file times from local to GMT
  				before setting file time
--------------------------------------------------------Version-11.0---------
  22-may-95	Greg Bentz	variety.h and dll linkage
  22-sep-95	M. Hildebrand	Added _wutime.
  02-oct-95	M. Hildebrand	Don't __F_NAME NT API functions; #define
				UNICODE in uutimwnt.c instead.
  18-oct-95	M. Hildebrand	Added _utime for MS compatability.
  27-nov-95	Greg Bentz	fixup const in function definition
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  05-jul-96	M. Hildebrand	Use __lib_ versions of ...W Win32 functions.
*/
#include "variety.h"
#include "widechar.h"
#include <stddef.h>
#include <sys\types.h>
#include <time.h>
#include <dos.h>
#include <windows.h>
#include <sys\stat.h>
#include <errno.h>
#include <direct.h>
#include <sys\utime.h>
#include "libwin32.h"
#include "openmode.h"
#include "rtdata.h"
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
    #include <stdlib.h>
    #include "mbwcconv.h"
#endif


_WCRTLINK int __F_NAME(utime,_wutime)( CHAR_TYPE const *fn, struct utimbuf const *times )
/**********************************************************************************/
{
    HANDLE		h;
    struct tm		*split;
    time_t		curr_time;
    struct utimbuf	time_buf;
    FILETIME		fctime,fatime,fwtime;
    FILETIME		local_ft;
    SYSTEMTIME		atime,wtime;
    
    #ifdef __WIDECHAR__
	h = __lib_CreateFileW( fn, GENERIC_READ | GENERIC_WRITE, 0, NULL,
			       OPEN_EXISTING, 0, NULL );
    #else
	h = CreateFileA( fn, GENERIC_READ | GENERIC_WRITE, 0, NULL,
			 OPEN_EXISTING, 0, NULL );
    #endif
    if( h == (HANDLE)-1 ) {
    	return( __set_errno_nt() );
    }
    if( !GetFileTime( h, &fctime, &fatime, &fwtime ) ) {
	CloseHandle( h );
    	return( __set_errno_nt() );
    }
    if( times == NULL ) {
	curr_time = time( NULL );
	time_buf.modtime = curr_time;
	time_buf.actime = curr_time;
	times = &time_buf;
    }
    split = localtime( &(times->modtime) );
    wtime.wYear = atime.wYear = 1900 + split->tm_year;
    wtime.wMonth = atime.wMonth = split->tm_mon + 1;
    wtime.wDay = atime.wDay = split->tm_mday;
    wtime.wHour = atime.wHour = split->tm_hour;
    wtime.wMinute = atime.wMinute = split->tm_min;
    wtime.wSecond = atime.wSecond = split->tm_sec;
    wtime.wMilliseconds = atime.wMilliseconds = 0;
    SystemTimeToFileTime( &wtime, &local_ft );
    LocalFileTimeToFileTime( &local_ft, &fwtime );
    SystemTimeToFileTime( &atime, &local_ft );
    LocalFileTimeToFileTime( &local_ft, &fatime );

    if( !SetFileTime( h, &fctime, &fatime, &fwtime ) ) {
	CloseHandle( h );
    	return( __set_errno_nt() );
    }

    CloseHandle( h );
    return( 0 );
}
