;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1990, by WATCOM Systems Inc. All rights	   %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
; date		by		reason
; ====		==		======
; 25-oct-89	John Dahms	created
; 18-apr-90	F.W.Crigger	check for 8087, 287, 387
; 19-apr-90	F.W.Crigger	placed chk8087 in initializer segment
; 27-jul-90	F.W.Crigger	Load control word from __8087cw
; 25-oct-90	J.B.Schueler	Added conditionals for QNX
; 11-sep-91	J.B.Schueler	Pared down code to just __init_80x87
; 28-nov-95	Greg Bentz	wasm export support
;
;
include struct.inc
include mdef.inc

	xref	__init_8087_		; in chk8087.c

	modstart init8087

	xdefp	__init_8087_emu
	defn	__init_8087_emu
	call	__init_8087_
	ret				; return
	endproc __init_8087_emu

	xdefp	__init_80x87
	defpe	__init_80x87		; called from chk8087.c
	push	BP			; save BP
	mov	BP,SP			; get access to stack
	push	AX			; save initial control word value
	push	AX			; allocate space for status word
;--------------------------------------- Check if 80287 or 80387
	finit				; use default infinity mode
	fld1				; generate infinity by
	fldz				;   dividing 1 by 0
	fdiv				; ...
	fld	st			; form negative infinity
	fchs				; ...
	fcompp				; compare +/- infinity
	fstsw	word ptr -4[BP] 	; equal for 87/287
	fwait				; wait fstsw to complete
	mov	AX,-4[BP]		; get NDP status word
	mov	AL,2			; assume 80287
	sahf				; store condition bits in flags
	jz	not387			; it's 287 if infinities equal
;---------------------------------------  It is an 80387
	mov	AL,3			; indicate 80387
not387: finit				; re-initialize the 8087
	fldcw	word ptr -2[BP] 	; .(affine,round nearest,64-bit prec)
	mov	SP,BP			; clean up stack
	pop	BP			; restore BP
	ret				; return
	endproc	__init_80x87
	
	endmod
	end
