/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  10-dec-87	F.W.Crigger	Initial implementation
------------------------------------------------------------Version 7.0-----
  27-jul-89	F.W.Crigger	adapted for 386
  11-jul-90	F.W.Crigger	added float prefix for 8087 fixups
  02-jul-91	J.B.Schueler	macrotized read/write data reference
  17-sep-91	J.B.Schueler	reload current control word setting and return
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  01-jun-95	T. Schiller	Modified _control87 to also update win87em.dll
  				when running under Win 16.
  26-jul-96	T. Schiller	Removed accidental reference to _fpmath for
				Win386
*/
#include "variety.h"
#include <math.h>
#include "rtdata.h"

extern	void	__fstcw();
extern	void	__fldcw();

#if defined(__WINDOWS__) && !defined(__WINDOWS_386__)

extern __far _fpmath;

void __win87em_fldcw(unsigned int);
#pragma aux __win87em_fldcw = \
	"push	bx"					\
	"mov	bx, 4h"					\
	"call	far _fpmath"				\
	"pop	bx"					\
	parm [ax]

unsigned int __win87em_fstcw(void);
#pragma aux __win87em_fstcw = \
	"push	bx"					\
	"mov	bx, 5h"					\
	"call	far _fpmath"				\
	"pop	bx"					\
	value [ax]

#endif

#if defined(__386__)
#pragma aux	__fstcw = 0x36 0xd9 0x3f 0x9b parm caller [edi];
			/* fstcw ss:[edi] */
			/* fwait	 */
#pragma aux	__fldcw = 0x36 0xd9 0x2f 0x9b parm caller [edi];
			/* fldcw ss:[edi] */
			/* fwait	 */
#else
#pragma aux	__fstcw = 0x95			/* xchg ax,bp */\
			  float 0x9b 0xd9 0x7e 0x00  /* fstcw 0[bp]*/\
			  float 0x9b 0xd9 0xd0	/* fnop       */\
			  0x95			/* xchg ax,bp */\
			  parm caller [ax];
#pragma aux	__fldcw = 0x95			/* xchg ax,bp */\
			  float 0x9b 0xd9 0x6e 0x00  /* fldcw 0[bp]*/\
			  float 0x9b 0xd9 0xd0	/* fnop       */\
			  0x95			/* xchg ax,bp */\
			  parm caller [ax];
#endif

_WCRTLINK unsigned _control87( unsigned new, unsigned mask )
/**********************************************************/
{
    auto short unsigned int control_word;

    control_word = 0;
    if( _RWD_8087 ) {
	__fstcw( &control_word );
#if defined(__WINDOWS__) && !defined(__WINDOWS_386__)
	control_word = __win87em_fstcw();
#endif
	if( mask != 0 ) {
	    control_word = (control_word & ~mask) | (new & mask);
	    __fldcw( &control_word );
	    __fstcw( &control_word );		    /* 17-sep-91 */
#if defined(__WINDOWS__) && !defined(__WINDOWS_386__)
	    __win87em_fldcw(control_word);
#endif
	}
    }
    return( control_word );
}
