#define _ValidFile( fp, retval )        /* make sure fp is a valid pointer */
#define SetupTGCSandNCS( x )            /* initialization for Netware/386 */

#if defined(__SW_BM)
    #if defined(__NETWARE__)
	extern int *__FileHandles;
	extern int __FHandles[];
	#undef fileno
	#define fileno( fp )	    ( __FileHandles[ (fp)->_handle ] )
	#define NULLHANDLE	    -1
    #endif
    
    #define _AccessFile( fp )	    _AccessFileH( (fp)->_handle )
    #define _ReleaseFile( fp )	    _ReleaseFileH( (fp)->_handle )
    #define _InitAccess( fp )
    #define _FiniAccess( fp )	    _FiniAccessH( (fp)->_handle )

    #if defined(__386__) || defined(__AXP__) || defined(__PPC__)
	extern void (*_AccessFileH)( int );
	extern void (*_ReleaseFileH)( int );
	extern int  (*_InitAccessH)( int );
	extern void (*_FiniAccessH)( int );
	extern void (*_AccessIOB)( void );
	extern void (*_ReleaseIOB)( void );
    #else
	// 16bit OS/2 multi-thread is different
	extern void __AccessFileH( int );
	extern void __ReleaseFileH( int );
	extern void __InitAccessH( int );
	extern void __FiniAccessH( int );
	extern void __AccessIOB( void );
	extern void __ReleaseIOB( void );

	// define macros to call the access routines directly for OS/2 1.x
	#define _AccessFileH( hdl )	__AccessFileH( hdl )
	#define _ReleaseFileH( hdl )    __ReleaseFileH( hdl )
	#define _InitAccessH( hdl )	__InitAccessH( hdl )
	#define _FiniAccessH( hdl )	__FiniAccessH( hdl )
	#define _AccessIOB()		__AccessIOB()
	#define _ReleaseIOB()		__ReleaseIOB()
    #endif

#else
    /* these are for multi thread support */
    /* they are not required if not building multi-thread library */
    /* note: 32 bit NETWARE, OS/2, NT, QNX libraries are always multi-thread */
    #define _AccessFile( fp )           /* gain access to the FILE* pointer */
    #define _ReleaseFile( fp )          /* release access */
    #define _InitAccess( fp )           /* initialize for FILE* access */
    #define _FiniAccess( fp )           /* finalize FILE* access stuff */
    
    #define _AccessFileH( hdl )         /* gain access to the file handle */
    #define _ReleaseFileH( hdl )        /* release access */
    #define _InitAccessH( hdl )     	/* initialize for handle access */
    #define _FiniAccessH( hdl )     	/* finalize handle access stuff */
    
    #define _AccessIOB()                /* gain access to array of __iob's */
    #define _ReleaseIOB()               /* release access */
#endif
