/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1989, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  16-mar-89	F.W.Crigger	Initial implementation
  09-nov-92	F.W.Crigger	Check to make sure write wrote desired amount
--------------------------------------------------------Version-11.0---------
  06-jan-95	M.P.Hildebrand	Improved logic for setting errno if necessary.
  28-may-95	Greg Bentz	variety.h and dll linkage
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include "tinyio.h"
#include <errno.h>
#include <string.h>
#include "rtcheck.h"
#include "rtdata.h"
#include "seterrno.h"

_WCRTLINK int chsize( int handle, long size )
    {
	int ret_code = 0;
	long current_offset, diff;
	unsigned amount;
	auto char buff[512];
	long status;

	__handle_check( handle, -1 );

	current_offset = lseek( handle, 0L, SEEK_CUR ); /* remember current */
	if( current_offset == -1 )  return( -1 );
	diff = size - lseek( handle, 0L, SEEK_END );

	if( diff > 0 ) {
	    /*** Increase file size ***/
	    memset( buff, 0, 512 );
	    do {
		amount = 512;
		if( diff < 512 ) amount = diff;
		ret_code = write( handle, buff, amount );
		if( ret_code != amount ) {		/* 09-nov-92 */
		    if( _RWD_doserrno == 5 )  __set_errno( ENOSPC );
		    ret_code = -1;
		    break;
		}
		diff -= amount;
	    } while( diff != 0 );

	} else {
	    /*** Shrink the file ***/
	    status = lseek( handle, size, SEEK_SET );
	    if( status != -1 ) {
	    	status = TinyWrite( handle, buff, 0 );
		if( TINY_ERROR(status) ) {
		    ret_code = -1;
		    __set_errno_dos( TINY_INFO(status) );
	    	}
	    } else {
	    	ret_code = -1;
	    }
	    if( current_offset > size ) current_offset = size;
	}
	
	status = lseek( handle, current_offset, SEEK_SET );
	if( status == -1)  ret_code = -1;
	if( ret_code != -1 )  ret_code = 0;
	return( ret_code );
    }
