/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1989, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  16-mar-89	F.W.Crigger	Initial implementation
  07-mar-90	J.B.Schueler	Adapted for PQNX, needs truncate facility
  18-may-90	J.B.Schueler	Added truncate capability
  25-may-94	B.J. Stecher	let Fsys grow the file
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  11-apr-96	B.J. Stecher	can't let Fsys grow file if opened O_APPEND
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/

#include "variety.h"
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include "rtcheck.h"
#include "seterrno.h"

_WCRTLINK int chsize( int handle, long size )
{
    long 	current_offset;
    long	diff;
    int 	flags;
    unsigned	amount;
    char 	buff[512];

    __handle_check( handle, -1 );

    current_offset = lseek( handle, 0L, SEEK_CUR ); /* remember current */
    if( current_offset == -1 ) return( -1 );
    diff = size - lseek( handle, 0L, SEEK_END );
    if( diff > 0 ) {
	/* pad file */
	if( (flags = fcntl( handle, F_GETFL )) == -1 ) {
	    return( -1 );
	}
	if( flags & O_APPEND ) {
	    memset( buff, 0, sizeof( buff ) );
	    while( diff > sizeof( buff ) ) {
		amount = write( handle, buff, sizeof( buff ) );
		switch( amount ) {
		case -1:
		    return( -1 );
		case 0:
		    __set_errno( ENOSPC );
		    return( -1 );
		}
		diff -= amount;
	    } 
	    amount = diff;
	} else {
	    if( lseek( handle, (size-1), SEEK_SET ) != (size-1) ) {
		return( -1 );
	    }
	    buff[0] = 0;
	    amount = 1;
	}
	if( write( handle, &buff, amount ) != amount ) return( -1 );
    } else {
	/* truncate file */
	if( ltrunc( handle, size, SEEK_SET ) != size ) return( -1 );
	if( current_offset > size ) current_offset = size;
    }
    lseek( handle, current_offset, SEEK_SET );
    return( 0 );
}
