/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  16-oct-92	Craig Eisler	use integer ids for file handles
  06-mar-95	Greg Bentz	restore original file position
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  20-jun-96	Greg Bentz	Windows 95, win32s don't zero pad files
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include "fileacc.h"
#include "osver.h"
#include <windows.h>
#include <unistd.h>
#include "ntex.h"
#include "rtcheck.h"
#include "seterrno.h"

// pad with zero bytes
void static __padfile( int hid, long offset, long diff ) {
    int rc;
    unsigned amount;
    auto char buff[512];

    rc = lseek( hid, offset, SEEK_SET );
    if( rc != offset ) {
	// run away
	return;
    }
    memset( buff, 0, 512 );
    do {
	amount = 512;
	if( diff < 512 ) amount = diff;
	rc = write( hid, buff, amount );
	if( rc != amount ) {
	    // run away
	    return;
	}
	diff -= amount;
    } while( diff != 0 );
}

_WCRTLINK int chsize( int hid, long size )
{
    long	curOffset;
    long	oldSize;
    long	rc;
    HANDLE	h;

    __handle_check( hid, -1 );
    h = __FileHandleIDs[ hid ];

    _AccessFileH( hid );
    curOffset = lseek( hid, 0L, SEEK_CUR );	/* get current offset */

    // if windows 95 or win32s
    if( !WIN32_IS_NT ) {
	oldSize = lseek( hid, 0L, SEEK_END );
    }

    rc = SetFilePointer( h, size, 0, FILE_BEGIN );
    if( rc == -1 ) {
	_ReleaseFileH( hid );
	return( __set_errno_nt() );
    }
    if( !SetEndOfFile( h ) ) {
	_ReleaseFileH( hid );
	return( __set_errno_nt() );
    }

    // if windows 95 or win32s
    if( !WIN32_IS_NT ) {
	// if extending file length
	if( size > oldSize ) {
	    __padfile( hid, oldSize, size-oldSize );
	}
    }

    if( curOffset > size ) curOffset = size;
    curOffset = lseek( hid, curOffset, SEEK_SET );
    _ReleaseFileH( hid );
    if( curOffset==-1 ) {
	return( __set_errno_nt() );
    }
    return( 0 );
}
