/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  27-dec-85     F.W.Crigger     Initial implementation
----------------------------------------------------------Version 6.0-------
  11-apr-88     A.F.Scian       used tinyio
  17-may-88     F.W.Crigger     Added call to _set_errno
----------------------------------------------------------Version 6.5-------
  16-nov-88     F.W.Crigger     changed to call open, so that _fmode and
                                binary files are handled correctly
  09-aug-89     John Dahms      removed some commented code
  16-feb-90     J.B.Schueler    added parens around (creat), const and mode_t
                                to plist
  13-dec-90     John Dahms      taint no such thing as mode_t exept in qnx.
  08-feb-93	Ashish Gupta	modified for Netware
--------------------------------------------------------Version-11.0---------
  03-mar-95	M. Hildebrand	Added _wopen and _wsopen.
  28-may-95	Greg Bentz	variety.h and dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <errno.h>
#include <io.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include "seterrno.h"


/* file attributes */

#define _A_RDONLY       0x01

#ifndef __QNX__
    typedef int mode_t;
#endif


_WCRTLINK int __F_NAME(creat,_wcreat)( const CHAR_TYPE *name, mode_t pmode )
    {
#ifndef __NETWARE__
        return( __F_NAME(open,_wopen)( name, O_RDWR|O_CREAT|O_TRUNC, pmode ) );
#else
	int 		acc;

	acc = O_CREAT | O_TRUNC; 
	if( ( pmode & S_IWRITE ) && ( pmode & S_IREAD ) ) {
	    acc |= O_RDWR;
	} else if( pmode & S_IWRITE ) {
	    acc |= O_WRONLY;
	} else if( pmode & S_IREAD ) {
	    acc |= O_RDONLY;
	} else if( !pmode ) {
	    acc |= O_RDWR;
	}
	if( __F_NAME(access,_waccess)( name, 0 ) ) { /* Delete the file if it exists so that the 
	    __F_NAME(remove,_wremove)( name ); 	     creation date and time will be reset. */
	}
        return( __F_NAME(open,_wopen)( name, acc, pmode ) );
#endif
    }

