/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  07-Apr-87     A.C.C.Wai       Initial implementation
-------------------------------------------------------Version 6.0--------
  13-apr-88     F.W.Crigger     fill in struct tm and call mktime instead
                                of duplicating logic here.
  26-may-88     F.W.Crigger     set t.tm_isdst to -1
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <time.h>


/* date extraction macros */
#define day( x )        (x & 0x001f)
#define month( x )      ((x & 0x01e0) >> 5)
#define year( x )       ((x & 0xfe00) >> 9)

/* time extraction macros */
#define sec2( x )       (x & 0x001f)
#define min( x )        ((x & 0x07e0) >> 5)
#define hour( x )       ((x & 0xf800) >> 11)



_WCRTLINK time_t _d2ttime( date, time )
        unsigned int date, time;
    {
        auto struct tm t;

        t.tm_year = year( date ) + 80;
        t.tm_mon  = month( date ) - 1;
        t.tm_mday = day( date );
        t.tm_hour = hour( time );
        t.tm_min  = min( time );
        t.tm_sec  = sec2( time ) * 2;
        t.tm_isdst = -1;
        return( mktime( &t ) );
    }
