/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   27-oct-95	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#include "widechar.h"
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include "filestr.h"
#include "iomode.h"
#include "ntex.h"


/*
 * Parse the C_FILE_INFO environment variable created by the parent process.
 * If C_FILE_INFO isn't in the environment, don't do anything; if it is,
 * create the POSIX-level file handles accordingly.
 */
_WCRTLINK void __F_NAME(__ParsePosixHandleStr,__wParsePosixHandleStr)( void )
/***************************************************************************/
{
    CHAR_TYPE *		envp;
    CHAR_TYPE *		p;
    int			posixHandle, osHandle, mode;
    int			len;
    CHAR_TYPE		buf[9];

    /*** Get the environment variable ***/
    envp = __F_NAME(getenv,_wgetenv)( __F_NAME("C_FILE_INFO",L"C_FILE_INFO") );
    if( envp == NULL )  return;

    /*** Process the items, one by one ***/
    while( *envp != '\0' ) {
	p = envp;

	/*** Extract the three data fields ***/
	p = __F_NAME(strchr,wcschr)( p, ':' );	    /* POSIX handle field */
	len = p - envp;
	__F_NAME(strncpy,wcsncpy)( buf, envp, len );
	buf[len] = '\0';
	posixHandle = (int)__F_NAME(strtol,wcstol)( buf, NULL, 16 );
	p++;

	envp = p;				    /* OS handle field */
	p = __F_NAME(strchr,wcschr)( p, ':' );
	len = p - envp;
	__F_NAME(strncpy,wcsncpy)( buf, envp, len );
	buf[len] = '\0';
	osHandle = (int)__F_NAME(strtol,wcstol)( buf, NULL, 16 );
	p++;

	envp = p;				    /* file mode field */
	p = __F_NAME(strchr,wcschr)( p, '*' );
	len = p - envp;
	__F_NAME(strncpy,wcsncpy)( buf, envp, len );
	buf[len] = '\0';
	mode = (int)__F_NAME(strtol,wcstol)( buf, NULL, 16 );
	p++;

	/*** Create the corresponding file ***/
	__NTAddSpecificFileHandle( (HANDLE)osHandle, posixHandle );
	__SetIOMode( posixHandle, mode );

	envp = p;
    }

    /*** Delete the environment variable ***/
    __F_NAME(putenv,_wputenv)( __F_NAME("C_FILE_INFO=",L"C_FILE_INFO=") );
}
