/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  23-aug-87     F.W.Crigger     Initial implementation
--------------------------------------------------Version 6.0----------
  11-apr-88     F.W.Crigger     use tinyio
  22-nov-92	F.W.Crigger	change reference to _iomode array
  06-oct-93	A.F.Scian	added POSIX semantics for identical handles
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stdio.h>
#include "tinyio.h"
#include "iomode.h"
#include "rtcheck.h"
#include "seterrno.h"



_WCRTLINK int dup2( int handle1, int handle2 )
    {
        tiny_ret_t rc;

	__handle_check( handle1, -1 );

	if( handle1 == handle2 ) {
	    return( handle2 );
	}
        rc = TinyDup2( handle1, handle2 );
        if( TINY_ERROR(rc) ) {
            return( __set_errno_dos( TINY_INFO(rc) ) );
        }
	__SetIOMode( handle2, __IOMode( handle1 ) );
        return( 0 );    /* indicate success */
    }
