/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  09-aug-89     John Dahms      defined for OS/2
  22-nov-92	F.W.Crigger	change reference to _iomode array
  06-oct-93	A.F.Scian	added POSIX semantics for identical handles
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stdio.h>
#include "fileacc.h"
#include "iomode.h"
#include <wos2.h>
#include "rtcheck.h"
#include "seterrno.h"



_WCRTLINK int dup2( int handle1, int handle2 )
    {
        APIRET  rc;

	__handle_check( handle1, -1 );

	if( handle1 == handle2 ) {
	    return( handle2 );
	}
        _AccessFileH( handle1 );
        rc = DosDupHandle( handle1, (PHFILE)&handle2 );
        if( rc != 0 ) {
            _ReleaseFileH( handle1 );
            return( __set_errno_dos( rc ) );
        }
        _InitAccessH( handle2 );
	__SetIOMode( handle2, __IOMode( handle1 ) );
        _ReleaseFileH( handle1 );
        return( 0 );    /* indicate success */
    }
