/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  22-nov-92	F.W.Crigger	change reference to _iomode array
  29-sep-93	A.F.Scian	duplicate handle should be inheritable
  06-oct-93	A.F.Scian	- dup2 is supposed to close the destination
  				  handle before aliasing it
				- added POSIX semantics for identical file
				  handles
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stdio.h>
#include <unistd.h>
#include "fileacc.h"
#include "iomode.h"
#include <windows.h>
#include "ntex.h"
#include "rtcheck.h"
#include "seterrno.h"

_WCRTLINK int dup2( int hid1, int hid2 )
{
    HANDLE	ph;
    HANDLE	fh;
    HANDLE	fh2;
    
    __handle_check( hid1, -1 );

    if( hid1 == hid2 ) {
	return( hid2 );
    }
    ph = GetCurrentProcess();
    fh = __FileHandleIDs[ hid1 ];
    
    _AccessFileH( hid1 );
    
    if( !DuplicateHandle( ph, fh, ph, &fh2, 0, TRUE, DUPLICATE_SAME_ACCESS ) ) {
	_ReleaseFileH( hid1 );
	return( __set_errno_nt() );
    }
    close( hid2 );
    __NTAddSpecificFileHandle( fh2, hid2 );
    __SetIOMode( hid2, __IOMode( hid1 ) );
    _ReleaseFileH( hid1 );
    return( 0 );
}
