/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  15-oct-92	Craig Eisler	should pass current process to DuplicateHandle
  22-nov-92	F.W.Crigger	change reference to _iomode array
  13-jan-93	Craig Eisler	check __NTAtMaxFiles to make sure
  				we don't go past the end of _iomode
  29-sep-93	A.F.Scian	duplicated handles should be inheritable
  03-mar-94	Greg Bentz	add _dup
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include "fileacc.h"
#include "iomode.h"
#include <windows.h>
#include "ntex.h"
#include "rtcheck.h"
#include "seterrno.h"


_WCRTLINK int dup( int hid )
{
    HANDLE	new_handle=(HANDLE)-1;
    int		nhid;
    HANDLE	cprocess;
    HANDLE	h;

    __handle_check( hid, -1 );

    if( __NTAtMaxFiles() ) {
	__set_errno( EMFILE );
	return( -1 );
    }

    h = __FileHandleIDs[ hid ];
    
    cprocess = GetCurrentProcess();
    _AccessFileH( hid );
    if( !DuplicateHandle( cprocess,  h, cprocess, &new_handle,
    			0, TRUE, DUPLICATE_SAME_ACCESS ) ) {
	_ReleaseFileH( hid );
	return( __set_errno_nt() );
    }
    nhid = _InitAccessH( (int) new_handle );
    __SetIOMode( nhid, __IOMode( hid ) );
    _ReleaseFileH( hid );
    return( nhid );
}
