/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  23-aug-87	F.W.Crigger	Initial implementation
  13-oct-87	F.W.Crigger	preserve current location
  16-aug-89	John Dahms	Added multi-thread & OS/2 support
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  04-jul-96	M. Hildebrand	Added __int64 support.
  11-jul-96	M. Hildebrand	Support __int64 for non-Win32 systems.
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/

#include "variety.h"
#include "int64.h"
/* gross hack for building 11.0 libraries with 10.6 compiler */
#ifndef __WATCOM_INT64__
    #include <limits.h>		/* a gross hack to make a gross hack work */
    #define __WATCOM_INT64__
    #define __int64		double
#endif
/* most includes should go after this line */
#include <stdio.h>
#ifdef __QNX__
    #include <unistd.h>
#else
    #include <io.h>
#endif
#include "fileacc.h"
#include "rtcheck.h"


#if defined(__INT64__) && !defined(__NT__)


_WCRTLINK __int64 _filelengthi64( int handle )
{
    INT_TYPE		retval;
    long		size;

    __handle_check( handle, -1 );
    size = filelength( handle );
    if( size != -1 ) {
	_clib_U32ToU64( size, retval );	/* retval = (__int64)size */
    } else {
	_clib_I32ToI64( -1L, retval );	/* retval = (__int64)-1 */
    }
    RETURN_INT64(retval);
}


#else	/* defined(__INT64__) && !defined(__NT__) */


#ifdef __NETWARE__
 _WCRTLINK unsigned long filelength( int handle )
#else
 #ifdef __INT64__
  _WCRTLINK __int64 _filelengthi64( int handle )
 #else
  _WCRTLINK long filelength( int handle )
 #endif
#endif
    {
	LONG_TYPE		current_posn, file_len;
	#ifdef __INT64__
	    INT_TYPE		zero, minusone;
	    REAL_INT_TYPE	retval;
	#endif

	__handle_check( handle, -1 );
	_AccessFileH( handle );

	#ifdef __INT64__
	    _clib_I32ToI64( 0L, zero );
	    retval = _lseeki64( handle, GET_REALINT64(zero), SEEK_CUR );
	    current_posn = GET_INT64(retval);
	    _clib_I32ToI64( -1L, minusone );
	    if( !_clib_U64Cmp(current_posn,minusone) ) {
		_ReleaseFileH( handle );
		RETURN_INT64(minusone);
	    }

	    retval = _lseeki64( handle, GET_REALINT64(zero), SEEK_END );
	    file_len = GET_INT64(retval);

	    _lseeki64( handle, GET_REALINT64(current_posn), SEEK_SET );

	    _ReleaseFileH( handle );
	    RETURN_INT64(file_len);
	#else
	    current_posn = lseek( handle, 0L, SEEK_CUR );
	    if( current_posn == -1L ) {
		_ReleaseFileH( handle );
		return( -1L );
	    }
	    file_len = lseek( handle, 0L, SEEK_END );
	    lseek( handle, current_posn, SEEK_SET );

	    _ReleaseFileH( handle );
	    return( file_len );
	#endif
    }


#endif	/* defined(__INT64__) && !defined(__NT__) */
