/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987 by WATCOM Systems Inc. All rights	    %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  09-aug-89	John Dahms	defined for OS/2
  25-aug-90	F.W.Crigger	Add call to DosQHandType to determine if device
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
--------------------------------------------------Version 9.0----------
  02-mar-92     G. Coschi	mask off network attribute before checking
  				if it's a disk file
  08-mar-93	A. Gupta	changed our stat struct (in stat.h)
  03-mar-94	Greg Bentz	add _fstat()
  31-aug-94	Alex Brodsky	Fill in additional information in stat struct
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  24-nov-95	M. Hildebrand	Added _wfstat.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  24-jul-96	M. Hildebrand	Fixed handling of st_mode.
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include "widechar.h"
#include <stddef.h>
#include <stdio.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <errno.h>
#include <direct.h>
#include <wos2.h>
#include "iomode.h"
#include "rtcheck.h"
#include "seterrno.h"

extern time_t _d2ttime();


static unsigned short at2mode( int attr )
/***************************************/
    {
	register unsigned short 	mode;

	if( attr & _A_SUBDIR ) {
	    mode = S_IFDIR | S_IXUSR | S_IXGRP | S_IXOTH;
	} else {
	    mode = S_IFREG;
	}
	mode |= S_IRUSR | S_IRGRP | S_IROTH;
	if( !(attr & (_A_SYSTEM|_A_RDONLY ) ) ) {
	    mode |= S_IWUSR | S_IWGRP | S_IWOTH;
	}
	return( mode );
    }


#ifdef __WIDECHAR__
_WCRTLINK int _wfstat( int handle, struct _wstat *buf )
#else
_WCRTLINK int fstat( int handle, struct stat *buf )
#endif
    {
	APIRET		error;
	OS_UINT		hand_type;
	OS_UINT		device_attr;
	FILESTATUS 	info;
	unsigned	iomode_flags;

	__handle_check( handle, -1 );

	buf->st_mode = 0;
	iomode_flags = __IOMode( handle );
	if( iomode_flags & _READ ) {
	    buf->st_mode |= S_IRUSR | S_IRGRP | S_IROTH;
	}
	if( iomode_flags & _WRITE ) {
	    buf->st_mode |= S_IWUSR | S_IWGRP | S_IWOTH;
	}

	error = DosQHandType( handle, &hand_type, &device_attr );/* 25-aug-90 */
	if( error ) {
	    return( __set_errno_dos( error ) );
	}
	if( ( hand_type & ~HANDTYPE_NETWORK ) == HANDTYPE_FILE ) {
	    error = DosQFileInfo( handle, 1, (PBYTE)&info, sizeof( FILESTATUS ) );
	    if( error ) {
		return( __set_errno_dos( error ) );
	    }
	    buf->st_ctime = _d2ttime( info.fdateCreation, info.ftimeCreation );
	    buf->st_atime = _d2ttime( info.fdateLastAccess, info.ftimeLastAccess );
	    buf->st_mtime = _d2ttime( info.fdateLastWrite, info.ftimeLastWrite );
	    buf->st_size = info.cbFile;
	    buf->st_mode |= at2mode( info.attrFile );
	    buf->st_dev = buf->st_rdev = 0;
	    buf->st_attr = info.attrFile;
	} else {			/* it is a device, 25-aug-90 */
	    buf->st_size = 0;
	    buf->st_atime = buf->st_ctime = buf->st_mtime = 0;
	    buf->st_mode |= S_IRUSR | S_IRGRP | S_IROTH;
	    if( ( hand_type & ~HANDTYPE_NETWORK ) == HANDTYPE_DEVICE ) {
		buf->st_mode |= S_IFCHR;
	    } else if( ( hand_type & ~HANDTYPE_NETWORK ) == HANDTYPE_PIPE ) {
		buf->st_mode |= S_IFFIFO;
	    }
	    buf->st_dev = buf->st_rdev = 1;
    	    buf->st_attr = 0;
	}
	buf->st_nlink = 1;
	buf->st_ino = handle;
	buf->st_uid = buf->st_gid = 0;

	buf->st_btime = buf->st_mtime;
    	buf->st_archivedID = 0;
    	buf->st_updatedID = 0;
    	buf->st_inheritedRightsMask = 0;
    	buf->st_originatingNameSpace = 0;
    	buf->st_name[0] = '\0';
	return( 0 );
    }

