/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   26-jun-96	M. Hildebrand	Initial implementation.
   26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <errno.h>
#if defined(__DOS__) || defined(__WINDOWS__)
    #include <dos.h>
#elif defined(__NT__)
    #include <windows.h>
    #include "ntex.h"
#elif defined(__OS2__)
    #include <os2.h>
#elif defined(__NETWARE__)
    #include <fileengd.h>
#endif
#include "fileacc.h"
#include "rtcheck.h"
#include "seterrno.h"


_WCRTLINK int fsync( int handle )
/*******************************/
{
    #if defined(__NT__)
	HANDLE		h;
    #elif defined(__NETWARE__)
	int		h;
    #endif
    int			ret = 0;

    __handle_check( handle, -1 );
    _AccessFileH( handle );

    #if defined(__DOS__) || defined(__WINDOWS__)
	ret = _dos_commit( handle );
    #elif defined(__NT__)
	h = __FileHandleIDs[handle];
	if( FlushFileBuffers( h ) == FALSE ) {
	    ret = -1;
	    __set_errno_nt();
	}
    #elif defined(__OS2__)
	if( DosBufReset( handle ) != 0 ) {
	    ret = -1;
	    __set_errno( EBADF );
	}
    #elif defined(__NETWARE__)
	h = __FileHandles[handle];
	if( FEFlushWrite( h ) != 0 ) {
	    ret = -1;
	    __set_errno( EBADF );
	}
    #else
	#error Unknown target system
    #endif
    _ReleaseFileH( handle );

    return( ret );
}
