/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  04-mar-88     F.W.Crigger     Initial implementation
---------------------------------------------------------------Version 7.0-----
  07-apr-89     F.W.Crigger     Adapted for 386
---------------------------------------------------------------Version 8.0-----
  21-nov-90	A.F.Scian	converted to use TINYIO & added OS/2 support
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stddef.h>
#include <io.h>

#ifdef __OS2__
#include <wos2.h>
#else
#include "tinyio.h"
#endif
#include "rtcheck.h"
#include "seterrno.h"


_WCRTLINK int lock( int handle, unsigned long offset, unsigned long nbytes )
    {
#if defined(__WARP__)
	APIRET		rc;
	FILELOCK	lock_block;

	__handle_check( handle, -1 );
	lock_block.lOffset = offset;
	lock_block.lRange = nbytes;
	/* last 2 arguments are not documented */
	rc = DosSetFileLocks( handle, NULL, &lock_block, 0, 0 );
	if( rc != 0 ) {
            return( __set_errno_dos( rc ) );
	}
	return( 0 );
#elif defined(__OS2_286__)
	APIRET		rc;
	LONG lock_block[2];

	__handle_check( handle, -1 );
	lock_block[0] = offset;
	lock_block[1] = nbytes;
	rc = DosFileLocks( handle, NULL, &lock_block );
	if( rc != 0 ) {
            return( __set_errno_dos( rc ) );
	}
	return( 0 );
#else
	tiny_ret_t rc;
        
	__handle_check( handle, -1 );
	rc = TinyLock( handle, offset, nbytes );
	if( TINY_ERROR(rc) ) {
	    return( __set_errno_dos( TINY_INFO(rc) ) );
	}
	return( 0 );
#endif
    }
