/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  18-aug-87     F.W.Crigger     Initial implementation
--------------------------------------------------Version 6.0----------
  11-apr-88     F.W.Crigger     use tinyio
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
  03-mar-94	Greg Bentz	add _lseek
--------------------------------------------------------Version-11.0---------
  09-jan-95	M.P.Hildebrand	New _iomode bit set when lseek() done with
				positive offset, so that write() can pad
				with zero bytes if lseek() done past EOF.
  28-may-95	Greg Bentz	variety.h and dll linkage
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/

#include "variety.h"
#include <stdio.h>
#include <unistd.h>
#include "fileacc.h"
#include <wos2.h>
#include "iomode.h"
#include "rtcheck.h"
#include "seterrno.h"


_WCRTLINK long lseek( int handle, long offset, int origin )
    {
        APIRET		rc;
    	unsigned	_iomode;
	long		out_offset;

	__handle_check( handle, -1 );

        /*** Set the _FILEEXT _iomode bit if positive offset ***/
        _AccessFileH( handle );
        _iomode = __IOMode( handle );
        if( offset>0 && !(_iomode&_APPEND) )
	    __SetIOMode( handle, _iomode | _FILEEXT );
	    
        rc = DosChgFilePtr( handle, offset, origin, (PULONG)&out_offset );
        if( rc != 0 ) {
            __set_errno_dos( rc );
            out_offset = -1;
        }

        _ReleaseFileH( handle );
        return( out_offset );  /* return seek position */
    }
