/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  06-mar-92     Craig Eisler	defined for NT
  16-oct-92	Craig Eisler	use integer ids for file handles
  03-mar-94	Greg Bentz	add _lseek
--------------------------------------------------------Version-11.0---------
  09-jan-95	M.P.Hildebrand	New _iomode bit set when lseek() done with
				positive offset, so that write() can pad
				with zero bytes if lseek() done past EOF.
  28-may-95	Greg Bentz	variety.h and dll linkage
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  04-jul-96	M. Hildebrand	Added __int64 support.
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/

#include "variety.h"
#include "int64.h"
#include <stdio.h>
#include <unistd.h>
#include <windows.h>
#include "fileacc.h"
#include "iomode.h"
#include "ntex.h"
#include "rtcheck.h"
#include "seterrno.h"


#ifdef __INT64__
 _WCRTLINK __int64 _lseeki64( int hid, __int64 _offset, int origin )
#else
 _WCRTLINK long lseek( int hid, long offset, int origin )
#endif
{
    DWORD		rc;
    HANDLE		h;
    unsigned	    	_iomode;
#ifdef __INT64__
    LONG		loworder, highorder;
    INT_TYPE		offset = GET_INT64(_offset);
    INT_TYPE		minusone;
    INT_TYPE		retval;
#endif

    __handle_check( hid, -1 );
    _AccessFileH( hid );

    /*** Set the _FILEEXT _iomode bit if positive offset ***/
    _iomode = __IOMode( hid );
    #ifdef __INT64__
	if( _clib_I64Positive(offset)  &&  !( _iomode & _APPEND ) ) {
	    __SetIOMode( hid, _iomode | _FILEEXT );
	}
    #else
	if( offset > 0  &&  !( _iomode & _APPEND ) ) {
	    __SetIOMode( hid, _iomode | _FILEEXT );
	}
    #endif

    h = __FileHandleIDs[ hid ];
    #ifdef __INT64__
	HIGHWORD(highorder,offset);
	LOWWORD(loworder,offset);
	rc = SetFilePointer( h, loworder, &highorder, origin );
	_ReleaseFileH( hid );
	if( rc == -1 ) {
	    __set_errno_nt();
	    _clib_I32ToI64( -1L, minusone );
	    RETURN_INT64(minusone);
	}
	MAKE_INT64(retval,highorder,rc);
	RETURN_INT64(retval);
    #else
	rc = SetFilePointer( h, offset, 0, origin );
	_ReleaseFileH( hid );
	if( rc == -1 ) {
	    __set_errno_nt();
	    return( -1 );
	}
	return( rc );
    #endif
}
