/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  07-dec-87	F.W.Crigger	Initial implementation
  03-feb-88	A.F.Scian	simplified handle check
------------------------------------------------------------Version 6.5--------
  24-oct-88	F.W.Crigger	__NFiles introduced to replace _NFILES constant
------------------------------------------------------------Version 7.0--------
  16-aug-89	John Dahms	Added multi-thread & OS/2 support
  17-oct-89	F.W.Crigger	find corresponding _iob entry and change flag
				in the FILE struct for this file as well
  27-apr-90	F.W.Crigger	check to see if mode != old_mode
--------------------------------------------------Version 9.x----------
  06-mar-92	C.G.Eisler	support NT
  15-oct-92	Craig Eisler	use iomode array indices as handles
  22-nov-92	F.W.Crigger	change reference to _iomode array
   3-jan-93	B.J. Stecher	all systems use linked FILE structs
  19-jan-93	A.Gupta		modified for netware
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stdio.h>
#include <errno.h>
#include "fcntl.h"
#include "dos.h"
#include "dosfunc.h"
#include "fileacc.h"
#include "rtcheck.h"
#include "rtdata.h"
#include "iomode.h"
#include "seterrno.h"
#if defined(__NT__)
    #include <windows.h>
    #include "ntex.h"
#endif

_WCRTLINK int setmode( int handle, int mode )
    {
	int	 	old_mode;
	FILE	 	*fp;
	__stream_link	*link;
	unsigned 	iomode_flags;

	__handle_check( handle, -1 );

	iomode_flags = __IOMode( handle );	
	if( iomode_flags == 0 ) {
	    __set_errno( EBADF );
	    return( -1 );
	}
	_AccessFileH( handle );
	old_mode = (iomode_flags & _BINARY) ? O_BINARY : O_TEXT;
	if( mode != old_mode ) {
	    if( mode == O_BINARY  ||  mode == O_TEXT ) {
		iomode_flags &= ~ _BINARY;
		if( mode == O_BINARY ) {
		    iomode_flags |= _BINARY;
		}
		__SetIOMode( handle, iomode_flags );
		for( link = _RWD_ostream; link != NULL; link = link->next ) {
		    fp = link->stream;
		    if( fp->_flag != 0 ) {	/* if file is open */
			if( fileno( fp ) == handle ) {
			    fp->_flag &= ~ _BINARY;
			    if( mode == O_BINARY ) {
				fp->_flag |= _BINARY;
			    }
			    break;
			}
		    }
		}
	    } else {
		__set_errno( EINVAL );
		_ReleaseFileH( handle );
		return( -1 );
	    }
	}
	_ReleaseFileH( handle );
	return( old_mode );
    }
