/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  06-mar-92     Craig Eisler	defined for NT
  16-oct-92	Craig Eisler	use integer ids for file handles
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  04-jul-96	M. Hildebrand	Added __int64 support.
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include "int64.h"
#include <stdio.h>
#include "fileacc.h"
#include <windows.h>
#include "ntex.h"
#include "rtcheck.h"
#include "seterrno.h"

#ifdef __INT64__
 _WCRTLINK __int64 _telli64( int hid )
#else
 _WCRTLINK long int tell( int hid )
#endif
{
    DWORD		pos;
    HANDLE		h;
#ifdef __INT64__
    LONG		highorder = 0;
    INT_TYPE		minusone;
    INT_TYPE		retval;
#endif

    __handle_check( hid, -1 );
    h = __FileHandleIDs[ hid ];
    _AccessFileH( hid );

    #ifdef __INT64__
	pos = SetFilePointer( h, 0, &highorder, FILE_CURRENT );
	_ReleaseFileH( hid );
	if( pos == -1 ) {
	    __set_errno_nt();
	    MAKE_INT64(minusone,-1,-1);
	    RETURN_INT64(minusone);
	}
	MAKE_INT64(retval,highorder,pos);
	RETURN_INT64(retval);
    #else
	pos = SetFilePointer( h, 0, 0, FILE_CURRENT );
	_ReleaseFileH( hid );
	if( pos == -1 ) {
	    __set_errno_nt();
	    return( -1 );
	}
	return( pos );
    #endif
}
