/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  27-dec-85     F.W.Crigger     Initial implementation
  13-jan-88     F.W.Crigger     In big data, return regs.x.cflag
--------------------------------------------------Version 6.0----------
  11-apr-88     F.W.Crigger     use tinyio
--------------------------------------------------------Version-11.0---------
  03-mar-95	M. Hildebrand	Added _wunlink.
  28-may-95	Greg Bentz	variety.h and dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/

#include "variety.h"
#include "widechar.h"
#include "mbwcconv.h"
#include <stdlib.h>
#include "tinyio.h"
#include "seterrno.h"
#ifdef __WIDECHAR__
    #include <mbstring.h>
#endif


_WCRTLINK int __F_NAME(unlink,_wunlink)( CHAR_TYPE *filename ) {
    tiny_ret_t	rc;
#ifdef __WIDECHAR__
    char	mbFilename[MB_CUR_MAX*_MAX_PATH];   /* single-byte char */
#endif

    #ifdef __WIDECHAR__
	__filename_from_wide( mbFilename, filename );
	rc = TinyDelete( mbFilename );
    #else
	rc = TinyDelete( filename );
    #endif

    if( TINY_ERROR(rc) ) {
	return( __set_errno_dos( TINY_INFO(rc) ) );
    }
    return( 0 );            /* indicate no error */
}
