/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  27-dec-85	F.W.Crigger	Initial implementation
--------------------------------------------------Version 6.0----------
  11-apr-88	F.W.Crigger	use tinyio
  22-nov-92	F.W.Crigger	change reference to _iomode array
  12-may-94	Alex Brodksy	Added defwin hooks 
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  11-jun-96	M. Hildebrand	Call _WindowsRemoveWindowedHandle only if
				it is a windowed handle.
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stdio.h>
#include <errno.h>
#include "tinyio.h"
#include "rtcheck.h"
#include "rtdata.h"
#include "iomode.h"
#include "seterrno.h"
#include "defwin.h"


int __close( int handle )
    {
	tiny_ret_t rc;
#ifdef DEFAULT_WINDOWING
	LPWDATA res;
#endif

	__handle_check( handle, -1 );
	rc = TinyClose( handle );
	if( TINY_OK(rc) ) {
#ifdef DEFAULT_WINDOWING
            if( _WindowsCloseWindow != 0 ) {
		res = _WindowsIsWindowedHandle( handle );
		if( res != NULL ) {
		    _WindowsRemoveWindowedHandle( handle );
		    _WindowsCloseWindow( res );
		}
	    }
#endif
	    __SetIOMode( handle, 0 );
	    return( 0 );
	}
	__set_errno( EBADF );
	return( -1 );
    }
