/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  27-dec-85	F.W.Crigger	Initial implementation
--------------------------------------------------Version 6.0----------
  11-apr-88	F.W.Crigger	use tinyio
  09-aug-89	John Dahms	defined for OS/2
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
  22-nov-92	F.W.Crigger	change reference to _iomode array
  12-may-94	Alex Brodksy	Added defwin hooks 
--------------------------------------------------------Version-11.0---------
  20-mar-95	M. Hildebrand	Undefine CHAR_TYPE before including rtdata.h, so
				sigdefn.h won't complain.
  28-may-95	Greg Bentz	variety.h and dll linkage
  11-jun-96	M. Hildebrand	Call _WindowsRemoveWindowedHandle only if
				it is a windowed handle.
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stdio.h>
#include <errno.h>
#include "fileacc.h"
#include <wos2.h>
#include "rtcheck.h"
#include "rtdata.h"
#include "iomode.h"
#include "seterrno.h"
#include "defwin.h"


int __close( int handle )
    {
	APIRET	    rc;
	int	    rv;
#ifdef DEFAULT_WINDOWING
	LPWDATA res;
#endif

	__handle_check( handle, -1 );
	rc = DosClose( handle );
	if( rc != 0 ) {
	    __set_errno( EBADF );
	    rv = -1;
	} else {
#ifdef DEFAULT_WINDOWING
            if( _WindowsCloseWindow != 0 ) {
		res = _WindowsIsWindowedHandle( handle );
		if( res != NULL ) {
		    _WindowsRemoveWindowedHandle( handle );
		    _WindowsCloseWindow( res );
		}
	    }
#endif
	    __SetIOMode( handle, 0 );
	    rv = 0;
	}
	return( rv );
    }

