/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  15-oct-92	Craig Eisler	use iomode array indices as handles
  22-nov-92	F.W.Crigger	change reference to _iomode array
  12-may-94	Alex Brodsky	Add Default windowing hook
  12-aug-94	Alex Brodsky	don't close default windowing handles
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  26-jul-96	M. Hildebrand	Use rtcheck.h support.
*/
#include "variety.h"
#include <stdio.h>
#include <errno.h>
#include "fileacc.h"
#include <windows.h>
#include "rtcheck.h"
#include "rtdata.h"
#include "iomode.h"
#include "ntex.h"
#include "seterrno.h"
#include "defwin.h"


int __close( int hid )
{
    int		is_closed;
    int		rc;
    HANDLE	h;
#ifdef DEFAULT_WINDOWING
    LPWDATA res;
#endif

    __handle_check( hid, -1 );

    is_closed = 0;
    rc = 0;
    h = __FileHandleIDs[ hid ];

    #ifdef DEFAULT_WINDOWING
	if( _WindowsCloseWindow != 0 ) {
	    res = _WindowsIsWindowedHandle( hid );
	    if( res != NULL ) {
		_WindowsRemoveWindowedHandle( hid );
		_WindowsCloseWindow( res );
		is_closed = 1;
	    }
	}
    #endif
    if( !is_closed && !CloseHandle( h ) ) {
	__set_errno( EBADF );
	rc = -1;
    } else {
	__SetIOMode( hid, 0 );
    }
    return( rc );
}
