/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  20-sep-89     F.W.Crigger     _amblksiz moved from nmalloc.c to here
  22-feb-91     A.F.Scian       changed initial value to 16
                                - amblksiz is set to the application default
                                  of 8k before main() is called and after
                                  everything else has been done so that the
                                  setup functions can assume they won't grow
                                  segments too quickly (i.e., in 8k chunks)
  21-may-91	C.G.Eisler	- amblksiz 32K for 32-bit Windows
  30-may-91	A.F.Scian	- amblksiz 8K for 16-bit Windows
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
  30-jan-97	T. Schiller	change _amblksiz to 64K for win32 since
				VirtualAlloc() always reserves that large
				a range
*/
#include "variety.h"
#include <stdlib.h>

#if defined(__NT__)
_WCRTLINK unsigned _WCNEAR _amblksiz = 64*1024;
#elif defined(__WINDOWS_386__)
_WCRTLINK unsigned _WCNEAR _amblksiz = 32*1024;
#elif defined(__WINDOWS__)
_WCRTLINK unsigned _WCNEAR _amblksiz = 8*1024;
#else
_WCRTLINK unsigned _WCNEAR _amblksiz = 16;
#endif
