/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  24-oct-91     F.W.Crigger     Initial implementation
  14-feb-94	Kevin Hui	Extracted the common code in _bexpand() and
  				_nexpand() to form __HeapManager_expand()
				(in nexpand.c)
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "dll.h"	// needs to be first
#include "variety.h"
#include <malloc.h>
#include "heap.h"
#include "heapacc.h"

// From: nexpand.c
extern int __HeapManager_expand( __segment seg,
				 unsigned offset,
				 size_t req_size,
				 size_t *growth_size );

_WCRTLINK void __based(void) *_bexpand( __segment seg,
			      void __based(void) *mem,
			      size_t req_size )
    {
        struct {
            unsigned expanded : 1;
        } flags;
	int retval;
	size_t growth_size;

	flags.expanded = 0;
	_AccessFHeap();
	for( ;; ) {
	    retval = __HeapManager_expand( seg, (unsigned)mem,
					   req_size, &growth_size );
	    if( retval == __HM_SUCCESS ) {
		_ReleaseFHeap();
		return( mem );
	    }
	    if( retval == __HM_FAIL ) break;
	    if( retval == __HM_TRYGROW ) {
		if( flags.expanded ) break;
		if( __GrowSeg( seg, growth_size ) == 0 ) break;
		flags.expanded = 1;
	    }
	}
	_ReleaseFHeap();
	return( _NULLOFF );
    }
