/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1991 by WATCOM Systems Inc. All rights      %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  26-oct-91	F.W.Crigger	Initial implementation (cloned from fheapchk)
  25-feb-94	Kevin Hui	Use _nheapchk if seg is _DGroup
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <malloc.h>
#include <i86.h>
#include "heap.h"
#include "heapacc.h"

static int checkFreeList( unsigned long *free_size, __segment req_seg )
{
    farfrlptr curr;
    unsigned short seg;
    struct heapblk _WCFAR *p;
    unsigned long total_size;

    total_size = 0;
    seg = req_seg;
    if( seg == _NULLSEG )  seg = __bheap;
    for( ; seg ;) {
	p = MK_FP( seg, 0 );
	curr = MK_FP( seg, p->freehead.next );
	for(;;) {
	    if( FP_OFF(curr) == offsetof(struct heapblk, freehead) ) break;
	    total_size += curr->len;
	    curr = MK_FP( seg, curr->next );
	}
	if( req_seg != _NULLSEG )  break;
	seg = p->nextseg;
    }
    *free_size = total_size;
    return( _HEAPOK );
}

static int checkFree( farfrlptr p )
{
    unsigned short seg;
    farfrlptr prev;
    farfrlptr next;
    farfrlptr prev_prev;
    farfrlptr next_next;

    seg = FP_SEG( p );
    prev = MK_FP( seg, p->prev );
    next = MK_FP( seg, p->next );
    if( prev->next != FP_OFF(p) || next->prev != FP_OFF(p) ) {
	return( _HEAPBADNODE );
    }
    prev_prev = MK_FP( seg, prev->prev );
    next_next = MK_FP( seg, next->next );
    if( prev_prev->next != FP_OFF(prev) || next_next->prev != FP_OFF(next) ) {
	return( _HEAPBADNODE );
    }
    return( _HEAPOK );
}

_WCRTLINK int _bheapchk( __segment seg )
{
    struct _heapinfo	hi;
    int			heap_status;
    unsigned long	free_size;

    if( seg == _DGroup() ) return( _nheapchk() );
    _AccessFHeap();
    heap_status = checkFreeList( &free_size, seg );
    if( heap_status == _HEAPOK ) {
	hi._pentry = NULL;
	for(;;) {
	    heap_status = __HeapWalk( &hi, seg==_NULLSEG ? __bheap:seg, seg);
	    if( heap_status != _HEAPOK ) break;
	    if( hi._useflag == _FREEENTRY ) {
		heap_status = checkFree( hi._pentry );
		if( heap_status != _HEAPOK ) break;
		free_size -= hi._size;
	    }
	}
	if( free_size != 0 ) {
	    heap_status = _HEAPBADNODE;
	} else if( heap_status == _HEAPBADPTR ) {
	    heap_status = _HEAPBADNODE;
	} else {
	    if( heap_status == _HEAPEND ) {
		heap_status = _HEAPOK;
	    }
	}
    }
    _ReleaseFHeap();
    return( heap_status );
}
