/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  24-oct-91     F.W.Crigger     Initial implementation
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
*/

#include "dll.h"	// needs to be first
#include "variety.h"
#include <malloc.h>
#include <string.h>
#include "heap.h"

_WCRTLINK void __based(void) *_brealloc( __segment seg,
			       		void __based(void) *mem,
			       		size_t size )
{
    void __based(void)	*p;
    size_t		old_size;

    if( mem == _NULLOFF )  return( _bmalloc( seg, size ) );
    if( size == 0 ) {
	_bfree( seg, mem );
	return( _NULLOFF );
    }
    old_size = _bmsize( seg, mem );
    p = _bexpand( seg, mem, size );
    if( p == _NULLOFF ) {		/* if it couldn't be expanded */
	p = _bmalloc( seg, size );	/* - allocate new block */
	if( p != _NULLOFF ) {		/* - if we got one */
	    _fmemcpy( (void _WCFAR *)(seg :> p),
		      (void _WCFAR *)(seg :> mem),
		      old_size );
	    _bfree( seg, mem );
	} else {
	    _bexpand( seg, mem, old_size );
	}
    }
    return( p );
}
