/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985-1990 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  27-dec-90     F.W.Crigger     initial implementation
  09-feb-91     F.W.Crigger     Check to see if rover pointing at memory block
  03-may-91	A.F.Scian	added check for a near pointer
  14-may-91	A.F.Scian	fixed return of NULL near pointer
  08-jul-91	D.J.Gaudet	_ffree of partial block left over from a shrink
  				was never malloced so we have to fake free out
-------------------------------------------------------Version 8.5-----------
  03-nov-91	F.W.Crigger	Make use of _bexpand function
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <malloc.h>
#include "heap.h"
#include "heapacc.h"

#if defined(__BIG_DATA__)

_WCRTLINK void *_expand( void *stg, size_t amount )
{
    return( _fexpand( stg, amount ) );
}

#endif

_WCRTLINK void _WCFAR *_fexpand( void _WCFAR *stg, size_t req_size )
{
    __segment	seg;
    void _WCNEAR	*tmp;

    seg = FP_SEG( stg );
    if( seg == _DGroup() ) {
	tmp = _nexpand( (void _WCNEAR *) stg, req_size );
	if( tmp == NULL )  return( NULL );
#if __WATCOMC__ >= 900
    } else if( _bexpand( seg,(void __based(void) *)FP_OFF(stg), req_size )
				== _NULLOFF ) {
	return( NULL );
#else
	return( NULL );
#endif
    }
    return( stg );
}
