/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  18-Feb-87     A.C.C.Wai       From older free.c, but free list goes down
  10-jan-88     F.W.Crigger     adapted from free.c
-----------------------------------------------------------Version 6.0-------
  03-apr-88     F.W.Crigger     implement new doubly linked free list.
  12-apr-88     F.W.Crigger     Make sure block is not already marked as free
  29-apr-88     F.W.Crigger     Check against DGroup instead of SS register
-----------------------------------------------------------Version 6.5------
  09-jun-88     A.F.Scian       try to keep the free list ordered
-----------------------------------------------------------Version 7.0------
  21-mar-89     F.W.Crigger     Update __num_ffrees variable
                                Use different strategy if allocs/(frees+1)>frees
  16-aug-89     John Dahms      Added multi-thread & OS/2 support
  03-sep-89     F.W.Crigger     Coalesce with next free block
  09-apr-91     A.F.Scian       made _ffree call _nfree instead of duplicating
                                _nfree in here (people may want to write their
                                own _nmalloc/_nfree code!)
  02-dec-92	F.W.Crigger	Added code to keep __LargestBlockB4Rover
				up to date
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <malloc.h>
#include <i86.h>
#include "heap.h"
#include "heapacc.h"


#if defined(__BIG_DATA__)

_WCRTLINK void free( void *stg )
{
    _ffree( stg );
}

#endif

_WCRTLINK void _ffree( void _WCFAR *stg )
{
    struct heapblk _WCFAR *p;
    unsigned seg;

    seg = FP_SEG( stg );
    if( seg == 0 ) {
	return;
    }
    if( seg == _DGroup() ) {
        _nfree( (void _WCNEAR *) stg );
        return;
    }
    _AccessFHeap();
    __MemFree( FP_OFF( stg ), seg, 0 );
    if( seg != __fheapRover ) {				/* 02-dec-92 */
	// seg might be after the __fheapRover, but we don't know that
	// and it might be expensive to find out. We will just update
	// __LargestSizeB4Rover anyway. The worst that will happen is
	// that _fmalloc will start searching from __fheap when it could
	// have started at __fheapRover.
	p = MK_FP( seg, 0 );
	if( p->largest_blk > __LargestSizeB4Rover ) {
	    __LargestSizeB4Rover = p->largest_blk;
	}
    }
    __fheap_clean = 0;
    _ReleaseFHeap();
}
