/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1990 by WATCOM Systems Inc. All rights      %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  27-dec-90     F.W.Crigger     initial implementation
  24-feb-94	Kevin Hui	Adapted for new data structure
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <malloc.h>
#include "heap.h"
#include "heapacc.h"

/* return the number of times that _nmalloc can be called to allocate
   and item "size" bytes from the near heap. */

_WCRTLINK unsigned int _freect( size_t size )
    {
        unsigned int count;
        size_t memsize;
        size_t size_of_chunk;
        frlptr pnext;
	mheapptr mhp;

        count = 0;
        size_of_chunk = (size + TAG_SIZE + ROUND_SIZE) & ~ROUND_SIZE;
        if( size_of_chunk < size )  return( 0 );
	if( size_of_chunk < FRL_SIZE ) {
	    size_of_chunk = FRL_SIZE;
	}
        _AccessNHeap();
	for( mhp = __nheapbeg; mhp != NULL; mhp = mhp->next ) {
	    pnext = mhp->freehead.next;
	    while( pnext != (frlptr) &mhp->freehead ) {
		memsize = pnext->len;
		count += memsize / size_of_chunk;
		pnext = pnext->next;
	    }
	}
        _ReleaseNHeap();
        return( count );
    }
