/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  14-feb-90	J.B.Schueler	Initial PQNX version
  13-feb-92	B.J. Stecher	check for zero sized allocations
   8-may-93	B.J. Stecher	free all of the selectors
  28-sep-93	A.F.Scian	return NULL if final size > 64k and size isn't
  				a power of 2
--------------------------------------------------------Version-11.0---------
  16-may-95     T. Schiller     Added reference to crwd.h.
  28-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <malloc.h>
#include <sys/types.h>
#include <sys/seginfo.h>
#include <i86.h>
#include "crwd.h"

extern 	pid_t  		_my_pid;

static int only_one_bit( size_t x )
{
    if( x == 0 ) {
	return 0;
    }
    /* turns off lowest 1 bit and leaves all other bits on */
    if(( x & ( x - 1 )) != 0 ) {
	return 0;
    }
    /* only one bit was on! */
    return 1;
}

_WCRTLINK void _WCHUGE * (halloc)( long n, size_t size )
{
    short seg;

    n *= size;
    if( n == 0 ) return( 0 );
    if( n > 65536 && ! only_one_bit( size ) ) return( 0 );
    seg = qnx_segment_huge( n );
    if( seg == -1 ) seg = 0;
    return( (void _WCHUGE *)MK_FP( seg , 0 ) );
}

_WCRTLINK void (hfree)( void _WCHUGE *ptr )
{
    unsigned		seg;
    unsigned		incr;
    struct _seginfo	info;

    if( ptr != NULL ) {
	incr = 1 << _HShift;
	seg = FP_SEG( ptr );
	for( ;; ) {
	    if( qnx_segment_info( 0, _my_pid, seg, &info ) != seg ) break;
	    qnx_segment_free( seg );
	    if( !(info.flags & _PMF_HUGE) ) break;
	    seg += incr;
	}
    }
}
