/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1991 by WATCOM Systems Inc. All rights      %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  26-dec-91	F.W.Crigger	Initial implementation for Ergo 286 Extender
  24-feb-94	Kevin Hui	Adapted for new near heap data structure
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stdlib.h>
#include <malloc.h>
#include "heap.h"

void _WCFAR __HeapInit( void _WCNEAR *start, unsigned int amount )
{
        mheapptr p1;
        tag *last_tag;

	p1 = start;
	amount -= sizeof( struct miniheapblkp ) + TAG_SIZE;
	__nheapbeg = p1;
	p1->len  = amount + sizeof( struct miniheapblkp );
	p1->prev = NULL;
	p1->next = NULL;
	p1->rover = &p1->freehead;
	p1->freehead.prev = &p1->freehead;
	p1->freehead.next = &p1->freehead;
	p1->numalloc = 0;
	p1->numfree = 0;
	++p1;
	/* fix up end of heap links */
	last_tag = (tag *) ( (PTR)p1 + amount );
	last_tag[0] = END_TAG;
        /* build a block for _nfree() */
        ((frlptr)p1)->len = amount | 1;
        ++__nheapbeg->numalloc;                             /* 28-dec-90 */
        __nheapbeg->largest_blk = ~0;    /* set to largest value to be safe */
        _nfree( (PTR)p1 + TAG_SIZE );
}
