/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  10-jun-88     A.F.Scian       defined
  28-sep-88     A.F.Scian       fixed modify exact in pragma to contain cx
                                fixed fill address by parenthesizing
                                curr + 1 (used to add 1, now adds sizeof(FRL))
  16-aug-89     John Dahms      Added multi-thread & OS/2 support
  30-dec-90     F.W.Crigger     Adapted for new memory manager
  24-oct-91	F.W.Crigger	split out from _fheapset
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <malloc.h>
#include <string.h>
#include <i86.h>
#include "heap.h"
#include "heapacc.h"


#if defined(__386__)
#define STOSW	0x66 0xab
#define _DI	edi
#define _CX	ecx
#else
#define STOSW	0xab
#define _DI	di
#define _CX	cx
#endif

extern  void    far_memset(void _WCFAR *,int,unsigned);
#pragma aux     far_memset = \
	0xd1 0xe9	/* shr cx,1 */\
        0xf3 STOSW      /* rep stosw */\
	0x11 0xc9	/* adc cx,cx */\
	0xf3 0xaa	/* rep stosb */\
        parm caller [es _DI] [ax] [_CX] \
        modify exact [_DI _CX];



int __HeapSet( __segment seg, unsigned int fill )
    {
        farfrlptr  curr;
        struct heapblk _WCFAR *p;

	fill |= fill << 8;
        _AccessFHeap();
        while( seg != 0 ) {
            p = MK_FP( seg, 0 );
            curr = MK_FP( seg, p->freehead.next );
            for(;;) {
                if( FP_OFF(curr) == offsetof(struct heapblk, freehead) ) break;
                far_memset( (void _WCFAR *)(curr + 1), fill,
                            curr->len - sizeof(frl) );
                curr = MK_FP( seg, curr->next );
            }
            seg = p->nextseg;
        }
        _ReleaseFHeap();
        return( _HEAPOK );
    }
