/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1990 by WATCOM Systems Inc. All rights      %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  27-dec-90     F.W.Crigger     initial implementation
  24-jan-94	Kevin Hui	Adapted for new near heap structure
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <malloc.h>
#include "heap.h"
#include "heapacc.h"


/* Return the amount of memory available in the near heap. */
/* Best done at start of program and after _nheapgrow() has been called. */

_WCRTLINK size_t _memavl( void )
    {
        size_t length;
        frlptr pnext;
	mheapptr mhp;

        length = 0;
        _AccessNHeap();
	for( mhp = __nheapbeg; mhp != NULL; mhp = mhp->next ) {
	    pnext = mhp->freehead.next;
	    while( pnext != (frlptr) &mhp->freehead ) {
		length += ( (pnext->len - TAG_SIZE) & ~ROUND_SIZE );
		pnext = pnext->next;
	    }
	}
        _ReleaseNHeap();
        return( length );
    }
