/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  18-Feb-87     A.C.C.Wai       From older free.c, but free list goes down
-----------------------------------------------------------Version 6.0------
  08-may-88     F.W.Crigger     split away from nmalloc.c
-----------------------------------------------------------Version 6.5------
  09-jun-88     A.F.Scian       try to keep the free list ordered
-----------------------------------------------------------Version 7.0------
  20-mar-89     F.W.Crigger     Update __num_frees variable
                                Use different strategy if allocs/(frees+1)>frees
  16-aug-89     John Dahms      Added multi-thread & OS/2 support
  03-sep-89     F.W.Crigger     Coalesce with next free block
  25-jan-90     F.W.Crigger     if block being freed < DynRover, set DynRover
                                to that block
  24-feb-94	Kevin Hui	Adapted for new near heap structure
--------------------------------------------------------Version-11.0---------
  22-feb-95	Greg Bentz	alpha support
  06-mar-95	Greg Bentz	bugs in MiniHeapRover code
  07-mar-95	Greg Bentz	improve search for relevant miniheap
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
  14-nov-95	Greg Bentz	make sure to release heap semaphore
*/

#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <malloc.h>
#include "heap.h"
#include "heapacc.h"


#if defined(__SMALL_DATA__)

_WCRTLINK void free( void *stg ) {
    _nfree( stg );
}

#endif

struct miniheapblkp _WCNEAR	*__MiniHeapFreeRover;

_WCRTLINK void _nfree( void _WCNEAR *stg ) {
    mheapptr		p1,p2;

    if( !stg ) return;

    _AccessNHeap();
    do {
	// first try some likely locations
	p1 = __MiniHeapFreeRover;
	if( p1 ) {
	    if( (PTR)p1 <= (PTR)stg && (PTR)p1+p1->len > (PTR)stg ) {
		break;
	    }
	    p2 = p1;
	    p1 = p1->prev;
	    if( p1 ) {
		if( (PTR)p1 <= (PTR)stg && (PTR)p1+p1->len > (PTR)stg ) {
		    break;
		}
	    }
	    p1 = p2->next;
	    if( p1 ) {
		if( (PTR)p1 <= (PTR)stg && (PTR)p1+p1->len > (PTR)stg ) {
		    break;
		}
	    }
	}
	p1 = __MiniHeapRover;
	if( p1 ) {
	    if( (PTR)p1 <= (PTR)stg && (PTR)p1+p1->len > (PTR)stg ) {
		break;
	    }
	    p2 = p1;
	    p1 = p1->prev;
	    if( p1 ) {
		if( (PTR)p1 <= (PTR)stg && (PTR)p1+p1->len > (PTR)stg ) {
		    break;
		}
	    }
	    p1 = p2->next;
	    if( p1 ) {
		if( (PTR)p1 <= (PTR)stg && (PTR)p1+p1->len > (PTR)stg ) {
		    break;
		}
	    }
	}

	// not found near rover, so search the list
	for( p1 = __nheapbeg; p1; p1 = p1->next ) {
	    if( (PTR)p1 <= (PTR)stg && (PTR)p1+p1->len > (PTR)stg ) {
		// break twice!
		goto found_it;
	    }
	}

	// this pointer is not in the heap
	_ReleaseNHeap();
	return;
    } while(0);

found_it:
    // we found the miniheap, free the storage
    __MemFree( (unsigned)stg, _DGroup(), (unsigned) p1 );
    __MiniHeapFreeRover = p1;
    if( p1 < __MiniHeapRover ) {
	if( p1->largest_blk > __LargestSizeB4MiniHeapRover ) {
	    __LargestSizeB4MiniHeapRover = p1->largest_blk;
	}
    }
    __nheap_clean = 0;
    _ReleaseNHeap();
}
