/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  14-jun-88     A.F.Scian       defined
  03-aug-88     A.F.Scian       removed large data restrictions on DS=64k
  16-aug-89     John Dahms      Added multi-thread & OS/2 support
  10-oct-89     F.W.Crigger     change 0xffff to ~0u for 386
  02-dec-89     F.W.Crigger     __DynRover added
-------------------------------------------------------------Version 8.0-----
  20-dec-90     F.W.Crigger     brk changed to __brk
  26-mar-91	A.F.Scian	added 16-bit Windows support
  02-apr-91	A.F.Scian	added 32-bit Rational support
  03-apr-91	C.G.Eisler	updated for WINDOWS_386 macro
  15-apr-91	A.F.Scian	added 32-bit Intel CodeBuilder support
  08-jul-91	G. Coschi	added OS/2 2.0 support
--------------------------------------------------------Version 9.x--------
  06-mar-92	Craig Eisler	NT support
  30-jun-92 	B.J.Stecher 	used __DOS_EXT__ macro
  01-dec-93	F.W.Crigger	_nheapshrink can't call __brk for Win386
  24-feb-04	Kevin Hui	improved support for the 32-bit platforms;
  				added support for Rationals for both zero and
				non-zero based data pages
  11-may-94	A.F.Scian	fixed problem when sbrk() or some other
  				external force extends _curbrk (everything
				checks out with the heap except that the
				end tag isn't the end of the heap!)
  17-jan-95	F.W.Crigger	Added call to DPMIFree for windows extender
--------------------------------------------------------Version-11.0---------
  22-feb-95	Greg Bentz	alpha support
  06-mar-95	Greg Bentz	bugs in MiniHeapRover code
  20-mar-95	Greg Bentz	must update free rover too
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
  08-aug-95	T. Schiller	modified to use VirtualFree() instead of
				LocalFree()
  07-nov-95	Greg Bentz	when freeing storage for Pharlap, always move
  				to a 4k boundary
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <stdlib.h>
#include <malloc.h>
#include "heap.h"
#include "heapacc.h"
#if defined(__DOS_EXT__)
 #include "extender.h"
 extern void __FreeDPMIBlocks( void );
#endif
#if defined(__WINDOWS_286__) || defined(__NT__)
 #include "windows.h"
#endif
#if defined(__OS2__)
 #include <wos2.h>
#endif
#if defined(__WINDOWS_386__)
 extern int __pascal DPMIFree(unsigned long);	// windows extender function
#endif
#if defined(__CALL21__)
 #include "tinyio.h"
#endif

#if defined(__SMALL_DATA__)

_WCRTLINK int _heapshrink( void )
    {
        return( _nheapshrink() );
    }
_WCRTLINK int _heapmin( void )
    {
        return( _nheapshrink() );
    }

#endif

_WCRTLINK int _nheapmin( void )
    {
        return( _nheapshrink() );
    }

#if defined(__WARP__)        || \
    defined(__WINDOWS_286__) || \
    defined(__WINDOWS_386__) || \
    defined(__NT__)	     || \
    defined(__CALL21__)
static int __ReturnMemToSystem( mheapptr mhp )
{
        mheapptr pnext;

	pnext = mhp->next;
#if defined(__WARP__)
	if( DosFreeMem( (PBYTE)mhp ) ) return( -1 );
#elif defined(__NT__)
        //if( LocalFree( (HLOCAL)mhp ) != NULL ) return( -1 );
        if (!VirtualFree(mhp, 0, MEM_RELEASE))
	    return -1;
#elif defined(__WINDOWS_386__)
	if( DPMIFree( (unsigned long)mhp ) != 0 ) return( -1 );
#elif defined(__WINDOWS_286__)
        if( LocalFree( (HLOCAL)mhp ) != NULL ) return( -1 );
#elif defined(__CALL21__)
	// No way to free storage under OSI
	if( mhp ) return( -1 );
#endif
	if( __MiniHeapRover == mhp ) {	// Update rovers
	    if( pnext ) {
		__MiniHeapRover = pnext;
	    } else {
		__MiniHeapRover = __nheapbeg;
		__LargestSizeB4MiniHeapRover = 0;
	    }
	}
	if( __MiniHeapFreeRover == mhp ) {
	    __MiniHeapFreeRover = 0;
	}
	return( 0 ); // success
}

static void __ReleaseMiniHeap( mheapptr mhp )
{
    mheapptr pprev;
    mheapptr pnext;

    pprev = mhp->prev;
    pnext = mhp->next;
    if( __ReturnMemToSystem( mhp ) == 0 ) {
	if( pprev == NULL ) {
	    __nheapbeg = pnext;
	} else {
	    pprev->next = pnext;
	}
	if( pnext != NULL )  pnext->prev = pprev;
    } //else: do not unlink if the memory cannot be freed successfully
}

#endif

_WCRTLINK int _nheapshrink( void )
{
    mheapptr mhp;
#if !defined(__WARP__)        && \
    !defined(__WINDOWS_286__) && \
    !defined(__WINDOWS_386__) && \
    !defined(__CALL21__)      && \
    !defined(__NT__) 
    // Shrink by adjusting _curbrk

    frlptr last_free;
    frlptr end_tag;
    unsigned new_brk;

    _AccessNHeap();
    #if defined(__DOS_EXT__)
    if( !_IsRationalZeroBase() && !_IsCodeBuilder() ) {
    #endif
	if( __nheapbeg == NULL ) {
	    _ReleaseNHeap();
	    return( 0 ); // No near heap, can't shrink
	}
	/* Goto the end of miniheaplist (if there's more than 1 blk) */
	for( mhp = __nheapbeg; mhp->next; mhp = mhp->next );
	/* check that last free block is at end of heap */
	last_free = mhp->freehead.prev;
	end_tag = (frlptr) ( (PTR)last_free + last_free->len );
	if( end_tag->len != END_TAG ) {
	    _ReleaseNHeap();
	    return( 0 );
	}
	if( end_tag != (frlptr) ((PTR)mhp + mhp->len ) ) {
	    _ReleaseNHeap();
	    return( 0 );
	}
	#if defined(__DOS_EXT__)
	// only shrink if we can shave off at least 4k
	if( last_free->len < 0x1000 ) {
	    _ReleaseNHeap();
	    return( 0 );
	}
	#else
	if( last_free->len <= sizeof( frl ) ) {
	    _ReleaseNHeap();
	    return( 0 );
	}
	#endif
	/* make sure there hasn't been an external change in _curbrk */
	if( sbrk( 0 ) != &(end_tag->prev) ) {
	    _ReleaseNHeap();
	    return( 0 );
	}
	/* calculate adjustment factor */
	if( mhp->len-last_free->len > sizeof( struct miniheapblkp ) ) {
	    // this miniheapblk is still being used
	    #if defined(__DOS_EXT__)
		frlptr new_last_free;
		new_last_free = (frlptr)((((unsigned)last_free + 0xfff) & ~0xfff) - TAG_SIZE);
		if( new_last_free == last_free ) {
	    #endif
		    // remove entire entry
		    mhp->len -= last_free->len;
		    --mhp->numfree;
		    // Relink the freelist entries, and update the rover
		    mhp->freehead.prev = last_free->prev;
		    last_free->prev->next = &mhp->freehead;
		    if( mhp->rover == last_free ) mhp->rover = last_free->prev;
	    #if defined(__DOS_EXT__)
		} else {
		    // just shrink the last free entry
		    mhp->len -= last_free->len;
		    last_free->len = (PTR)new_last_free - (PTR)last_free;
		    mhp->len += last_free->len;
		    last_free = new_last_free;
		}
	    #endif
	    last_free->len = END_TAG;
	    new_brk = (unsigned) ((PTR)last_free + TAG_SIZE );
	} else {
	    // we can remove this miniheapblk
	    if( mhp->prev ) { // Not the first miniheapblk
		mhp->prev->next = NULL;
		new_brk = (unsigned)mhp;//->prev + (unsigned)mhp->prev->len;
	    } else { // Is the first miniheapblk
		new_brk = (unsigned)__nheapbeg;
		__nheapbeg = NULL;
	    }
	    // Update rover info
	    if( __MiniHeapRover == mhp ) {
		__MiniHeapRover = __nheapbeg;
		__LargestSizeB4MiniHeapRover = 0;
	    }
	}
	__nheap_clean = 0;
    
	if( __brk( new_brk ) == (void _WCNEAR *) -1 ) {
	    _ReleaseNHeap();
	    return( -1 );
	}
	_ReleaseNHeap();
	return( 0 );
    #if defined(__DOS_EXT__)
    }
    __FreeDPMIBlocks(); // For RSI/zero-base and Intel CB
    _ReleaseNHeap();
    return( 0 );
    #endif
#else
    // Shrink by releasing mini-heaps
    {
	mheapptr pnext;

	_AccessNHeap();
	for( mhp = __nheapbeg; mhp; mhp = pnext ) {
	    pnext = mhp->next;
	    if( mhp->len - sizeof(struct miniheapblkp) ==
		(mhp->freehead.prev)->len ) __ReleaseMiniHeap( mhp );
	}
	_ReleaseNHeap();
	return( 0 );
    }
#endif
}
