/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  10-jun-88     A.F.Scian       defined
  28-sep-88     A.F.Scian       fixed modify exact in pragma to contain cx
                                fixed fill address by parenthesizing
                                curr + 1 (used to add 1, now adds sizeof(FRL))
  16-aug-89     John Dahms      Added multi-thread & OS/2 support
  30-dec-90     F.W.Crigger     Adapted for new memory manager
--------------------------------------------------Version 8.5----------
  16-jul-91     G. Coschi	called _inline__fmemset instead of using a pragma
  13-mar-93	B.J. Stecher	use #pragma intrinsic for above
  24-feb-94	Kevin Hui	Adapted for new data structure
--------------------------------------------------------Version-11.0---------
  22-feb-95	Greg Bentz	alpha support
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <malloc.h>
#include <string.h>
#include "heap.h"
#include "heapacc.h"


#if defined(__SMALL_DATA__)
_WCRTLINK int _heapset( unsigned int fill )
    {
        return( _nheapset( fill ) );
    }
#endif

#if defined(_M_IX86)
 #if __WATCOMC__ < 950
  #define _fmemset(p,c,n)	_inline__fmemset(p,c,n)
  extern void _WCFAR *_fmemset( void _WCFAR *, int, size_t );
 #else
  #pragma intrinsic(_fmemset)
 #endif
#endif

_WCRTLINK int _nheapset( unsigned int fill )
    {
	mheapptr mhp;
        frlptr  curr;
        int test_heap;

        test_heap = _heapchk();
        if( test_heap != _HEAPOK ) {
            return( test_heap );
        }
	fill |= fill << 8;
        _AccessNHeap();

	for( mhp = __nheapbeg; mhp != NULL; mhp = mhp->next ) {
	    curr = mhp->freehead.next;
	    for(;;) {
		if( curr == (frlptr) &mhp->freehead ) break;
		#if defined(_M_IX86)
		    _fmemset( (void _WCFAR *)(curr + 1), fill, curr->len - sizeof(frl) );
		#else
		    memset( (void *)(curr + 1), fill, curr->len - sizeof(frl) );
		#endif
		curr = curr->next;
	    }
        }
        _ReleaseNHeap();
        return( _HEAPOK );
    }
