/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985-1990 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  10-jun-88     A.F.Scian       defined
  16-aug-89     John Dahms      Added multi-thread & OS/2 support
  31-dec-90     F.W.Crigger     New implementation for new memory manager
  28-nov-91	A.F.Scian	removed an infinite loop problem
  27-nov-92	Craig Eisler	_heapwalk not defined for 32-bit libraries
  18-feb-94	Kevin Hui	Modified to walk all mini-heaps
--------------------------------------------------------Version-11.0---------
  06-mar-95	Greg Bentz	miniheaps may not be in order
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stddef.h>
#include <malloc.h>
#include "heap.h"
#include "heapacc.h"

#if defined(__SMALL_DATA__)
_WCRTLINK int _heapwalk( struct _heapinfo *entry )
    {
        return( _nheapwalk( entry ) );
    }
#endif

int __NHeapWalk( struct _heapinfo *entry, mheapptr heapbeg )
    {
        frlptr p;
	frlptr q;

        if( heapbeg == NULL ) {
            return( _HEAPEMPTY );
        }
        p = (frlptr)(entry->_pentry);
        if( p == NULL ) {
            p = (frlptr)(heapbeg + 1);
        } else {    /* advance to next entry */
	    for( heapbeg = __nheapbeg;; heapbeg = heapbeg->next ) {
		if( heapbeg->next == NULL ) break;
		if( (PTR)heapbeg <= (PTR)p &&
		    (PTR)heapbeg+heapbeg->len > (PTR)p ) break;
	    }
	    q = (frlptr)((PTR)p + (p->len & ~1));
	    if( q <= p ) {
		return( _HEAPBADNODE );
	    }
	    p = q;
        }
	for( ;; ) {
	    if( p->len == END_TAG ) {
		if( heapbeg->next == NULL ) {
		    entry->_useflag = _USEDENTRY;
		    entry->_size    = 0;
		    entry->_pentry  = NULL;
		    return( _HEAPEND );
		} else { // We advance to next miniheapblk
		    heapbeg = heapbeg->next;
		    p = (frlptr)(heapbeg + 1);
		}
	    } else {
		break;
	    }
	}
        entry->_pentry  = p;
        entry->_useflag = _FREEENTRY;
        entry->_size    = p->len & ~1;
        if( p->len & 1 ) {
            entry->_useflag = _USEDENTRY;
        }
        return( _HEAPOK );
    }

_WCRTLINK int _nheapwalk( struct _heapinfo *entry )
    {
        int     heap_status;

        _AccessNHeap();
        heap_status = __NHeapWalk( entry, __nheapbeg );
        _ReleaseNHeap();
        return( heap_status );
    }

