/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights	    %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping	    %
 *%	  or information storage and retrieval systems - except	    %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  31-jul-87	A.F.Scian	defined
  21-nov-87	F.W.Crigger	_amblksiz variable introduced
-----------------------------------------------------------Version 6.0-------
  03-apr-88	F.W.Crigger	allow signed input argument. Also added brk().
  17-apr-88	F.W.Crigger	make sure value is not less than _STACKTOP.
  03-aug-88	A.F.Scian	removed large data restrictions on DS=64k
-----------------------------------------------------------Version 7.0-------
  25-apr-89	F.W.Crigger	Check for Phar Lap vs A.I.A. OS/386
  13-jul-89	John Dahms	Check for parent segment in A.I.A. Restructured
  26-sep-89	F.W.Crigger	check for overflow on segment calculation
  27-sep-89	F.W.Crigger	set _curbrk to brk_value instead of rounded val
  08-aug-90	F.W.Crigger	Use new _Extender variable
-----------------------------------------------------------Version 8.0-------
  19-dec-90	F.W.Crigger	Windows 3.0 support added
  20-dec-90	F.W.Crigger	change brk to __brk
  13-jan-90	John Dahms	use _IsOS386 macro
  21-mar-91	C.G.Eisler	changed	 Win32Realloc prototype
  03-apr-91	C.G.Eisler	updated for WINDOWS_386 macro
  09-apr-91	C.G.Eisler	made Win32Realloc do something
  15-apr-91	A.F.Scian	added Rational and CodeBuilder support
  16-may-91	A.F.Scian	fixed sbrk for Rational and CodeBuilder
  21-may-91	C.G.Eisler	fixed __brk for 32 bit Windows
  08-jul-91	G. Coschi	added OS/2 2.0 support
--------------------------------------------------------Version 9.x--------
  06-mar-92	Craig Eisler	NT support
--------------------------------------------------------Version 9.5--------
  17-sep-93	F.W.Crigger	Added support for TNT DOS Extender v6.0
  01-dec-93	F.W.Crigger	Removed __brk routine for __WINDOWS_386__
  11-feb-94	Greg Bentz	support Rationals non-zero based data
  				pages that allow the segment to grow
  25-feb-94	Kevin Hui	modified the pragma for SegmentLimit
  04-may-94	Greg Bentz	add version checking to lsl instruction
  				because inline assembler is different between
				version 9.5 and 10.0
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <stddef.h>
#include <stdlib.h>
#include <errno.h>
#include <dos.h>
#ifdef __WINDOWS_386__
 #include "tinyio.h"
#else
 #include "extender.h"
 #if defined(__OS2__)
  #include <wos2.h>
 #else
  #include "tinyio.h"
 #endif
#endif

extern	unsigned		_curbrk;
extern	unsigned		_STACKTOP;

#ifdef __WINDOWS_386__
 extern void * pascal DPMIAlloc(unsigned long);
#else
extern	int			SetBlock();

extern	int			SetBlock( unsigned short selector, int size );
#pragma aux SetBlock		= \
	"mov	ah,04ah"	\
	"int	021h"		\
	"rcl	eax,1"		\
	"ror	eax,1"		\
	parm caller		[es] [ebx] \
	value			[eax];

extern	int			SegInfo( unsigned short selector );
#pragma aux SegInfo		= \
	"mov	ah,0edH"	\
	"int	021h"		\
	"shl	eax,31"		\
	"and	edi,0000FFFFh"	\
	"or	edi,eax"	\
	parm caller		[ebx] \
	value			[edi] \
	modify exact		[eax ecx edx esi ebx edi];

extern	int			SegmentLimit( void );
#if __WATCOMC__ > 950
#pragma aux SegmentLimit	= \
	"xor    eax,eax"	\
	"mov	ax,ds"		\
	"lsl	eax,ax"		\
	"inc	eax"		\
	value			[eax] \
	modify exact		[eax];
#else
#pragma aux SegmentLimit	= \
	"xor    eax,eax"	\
	"mov	ax,ds"		\
	"lsl	eax,eax"	\
	"inc	eax"		\
	value			[eax] \
	modify exact		[eax];
#endif
#endif

extern	unsigned short		GetDS();
#pragma aux GetDS		= \
	"mov	ax,ds"		\
	value			[ax];

_WCRTLINK void _WCNEAR *__brk( unsigned brk_value );

_WCRTLINK void _WCNEAR *sbrk( int increment )
    {
#if defined(__OS2__)
	if( increment > 0 ) {
	    PBYTE	p;
	    
	    increment = ( increment + 0x0fff ) & ~0x0fff;
	    if( !DosAllocMem( &p, increment, PAG_COMMIT|PAG_READ|PAG_WRITE ) ) {
		return( p );
	    }
	    errno = ENOMEM;
	} else {
	    errno = EINVAL;
	}
	return( (void _WCNEAR *) -1 );
#elif defined(__WINDOWS_386__)				/* 26-may-93 */
	increment = ( increment + 0x0fff ) & ~0x0fff;
	return DPMIAlloc( increment );
#elif defined(__CALL21__)				/* 10-aug-93 */
	increment = ( increment + 0x0fff ) & ~0x0fff;
	return (void *)TinyMemAlloc( increment );
#else
	if( _IsRationalZeroBase() || _IsCodeBuilder() ) {
	    void _WCNEAR *p;

	    if( increment > 0 ) {
		increment = ( increment + 0x0fff ) & ~0x0fff;
		if( _IsRational() ) {
		    p = TinyDPMIAlloc( increment );
		} else {
		    p = TinyCBAlloc( increment );
		}
		if( p == NULL ) {
		    errno = ENOMEM;
		    p = (void _WCNEAR *) -1;
		}
	    } else {
		errno = EINVAL;
		p = (void _WCNEAR *) -1;
	    }
	    return( p );
	} else if( _IsPharLap() ) {		/* 17-sep-93 */
	    _curbrk = SegmentLimit();
	}
	return( __brk( _curbrk + increment ) );
#endif
    }


#if !defined(__OS2__) && !defined(__WINDOWS_386__)
_WCRTLINK void _WCNEAR *__brk( unsigned brk_value )
    {
	unsigned	old_brk_value;
#if !defined(__CALL21__)
	unsigned	seg;
	int		parent;
#endif

	if( brk_value < _STACKTOP ) {
	    errno = ENOMEM;
	    return( (void _WCNEAR *) -1 );
	}
#if !defined(__CALL21__)
	if( _IsOS386() ) {
	    seg = ( brk_value + 15U ) / 16U;
	    if( seg == 0 ) seg = 0x0FFFFFFF;		/* 26-sep-89 */
	    parent = SegInfo( GetDS() );
	    if( parent < 0 ) {
		if( SetBlock( parent & 0xffff, seg ) < 0 ) {
		    errno = ENOMEM;
		    return( (void _WCNEAR *) -1 );
		}
	    }
	    if( SetBlock( GetDS(), seg ) < 0 ) {
		errno = ENOMEM;
		return( (void _WCNEAR *) -1 );
	    }
	} else {	/* _IsPharLap() || IsRationalNonZeroBase() */
	    seg = ( brk_value + 4095U ) / 4096U;
	    if( seg == 0 ) seg = 0x000FFFFF;		/* 26-sep-89 */
	    if( _IsRationalNonZeroBase() ) {
		// convert from 4k pages to paragraphs
		seg = seg * 256U;
	    }
	    if( SetBlock( GetDS(), seg ) < 0 ) {
		errno = ENOMEM;
		return( (void _WCNEAR *) -1 );
	    }
	}
#endif
	old_brk_value = _curbrk;	/* return old value of _curbrk */
	_curbrk = brk_value;		/* set new break value */
	return( (void _WCNEAR *) old_brk_value );
    }
#endif
