/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986,1994 by WATCOM International Inc. All rights %
 *%       reserved. No part of this software may be reproduced            %
 *%       in any form or by any means - graphic, electronic or            %
 *%       mechanical, including photocopying, recording, taping           %
 *%       or information storage and retrieval systems - except           %
 *%       with the written permission of WATCOM International Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  94/12/10	B.J. Stecher	initial implementation
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
  13-dec-95	M. Hildebrand	Added __ to verify_pentium_fdiv_bug.
*/

#include "variety.h"
#include <rtinit.h>
#include "rtdata.h"

extern unsigned _WCNEAR __chipbug;

enum {
    PROB_P5_DIV	= 0x0001
};

_WCRTLINK void __verify_pentium_fdiv_bug()
{
    /*
    	Verify we have got the Pentium FDIV problem.
	The volatiles are to scare the optimizer away.
    */
    volatile double	num 	= 4195835;
    volatile double	denom	= 3145727;

    if( _RWD_real87 >= 3 ) {
	if( (num - (num/denom)*denom) > 1.0e-8 ) {
	    __chipbug |= PROB_P5_DIV;
	}
    }
}

AXI( __verify_pentium_fdiv_bug, INIT_PRIORITY_FPU+1 );
