/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  11-may-90	F.W.Crigger	split out of sigsys.c
  11-jun-90	F.W.Crigger	Added __FAR__ to __sigfpe_handler for 8086
  13-jul-90	F.W.Crigger	Added call to __Enable_FPE to enable exceptions
  06-aug-90	F.W.Crigger	Can't use our exception handler for Windows
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
  09-aug-95	T. Schiller	added page locking for interrupt functions
				under DOS/4G.
*/
#include "variety.h"
#include <signal.h>
#include "rtdata.h"

#ifndef __WINDOWS__
    #include "extender.h"
    #include "dpmi.h"
#endif

extern	void	__Init_FPE_handler();
extern	void	__Fini_FPE_handler();
extern	void	__Enable_FPE();
extern	void	_WCI86FAR __sigfpe_handler();
#ifdef __DOS_386__
extern     __FPEHandlerStart_;
extern     __FPEHandlerEnd_;
extern int __DPMI_hosted(void);
#endif

void __GrabFP87()
    {
#ifndef __WINDOWS__
	if( _RWD_FPE_hl_exit != __Fini_FPE_handler ) {
#ifdef __DOS_386__
	    if (!_IsPharLap() && (__DPMI_hosted() == 1))
	    {
		DPMILockLinearRegion((long)&__FPEHandlerStart_,
		    ((long)&__FPEHandlerEnd_ - (long)&__FPEHandlerStart_));
	    }
#endif
	    _RWD_FPE_handler = __sigfpe_handler;
	    __Init_FPE_handler();
	    _RWD_FPE_hl_exit = __Fini_FPE_handler;
	}
#if !defined(__WARP__)
	__Enable_FPE();
#endif
#endif
    }
