/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   05-oct-95	M. Hildebrand	Initial implementation.
   20-jun-86	M. Hildebrand	Avoid tests on unsupported platforms.
*/

/*
 *  INTLTEST.C
 *  Currently, this program only tests the sound() and nosound() functions.
 *  They now decide at run-time whether or not they're on an IBM or a NEC
 *  machine; this program is to ensure they still work.
 *
 */

#include <conio.h>
#include <i86.h>
#include <stdio.h>
#include <string.h>

#if defined(__DOS__) || defined(__QNX__) || defined(__WINDOWS__)
    #define TEST_SOUND
#endif

extern int	__NonIBM;


char ProgramName[128];                          /* executable filename */


#ifdef TEST_SOUND

void TestSound( void )
/********************/
{
    static char *	    notenames[] = {
	"B", "C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "B"
    };
    static unsigned short   notes[] = {
	19327, 18242, 17218, 16252, 15340, 14479, 13666, 12899,
	12175, 11492, 10847, 10238,  9664,     0
    };
    int			    i;

    for( i=0; notes[i]; i++ ) {
	sound( 1193180 / (notes[i]/(1<<4)) );
	printf( "%s: Now playing %s\n", ProgramName, notenames[i] );
	fgetc( stdin );
	nosound();
    }
}

#endif


void main( int argc, char *argv[] )
/*********************************/
{
    strcpy( ProgramName, strlwr( argv[0] ) ); /* store executable filename */

    printf( "%s: Machine type is %s.\n", ProgramName,
	    __NonIBM ? "NEC" : "IBM" );

    #ifdef TEST_SOUND
	TestSound();
    #else
	printf( "%s: Skipping sound() and nosound() tests.\n", ProgramName );
    #endif

    printf( "%s: Done\n", ProgramName );
}
