/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1994, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  27-apr-94	Greg Bentz	defined stub
  28-apr-94	Greg Bentz	swore to maintain
  15-feb-95	F.W.Crigger	output numbers in decimal rather than hex
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  28-may-95	Greg Bentz	dll linkage
  18-jul-95	F.W.Crigger	check semaphore and adjust cycle time with
				final Time Stamp Counter value
  28-oct-96	Greg Bentz	fixup next advance for packing issues
*/
#include "variety.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include "rtinit.h"
#include "p5prof.h"

extern  void _Bin2String(short int _WCNEAR *, char _WCNEAR *, int);
#if defined(__386__)
 #pragma aux _Bin2String     "_*" parm routine [eax] [edx] [ebx];
#elif defined(M_I86)
 #pragma aux _Bin2String     "_*" parm routine [ax] [dx] [bx];
#else
 #error unsupported platform
#endif

union tsc {
	short int	bigint[4];
	struct {
	    reg_32	lo_cycle;
	    reg_32	hi_cycle;
	};
};

extern	void	_RDTSC( union tsc * );
#pragma	aux	_RDTSC = \
	".586" \
	"rdtsc" \
	"mov	[ebx],eax" \
	"mov	4[ebx],edx" \
	parm [ebx] modify [eax edx];

extern	void    *_Start_TI;
extern	void    *_End_TI;
extern	char	**_argv;

static void fini( void ) {
    P5_timing_info	*curr;
    P5_timing_info	*last;
    FILE		*out;
    unsigned		len;
    int			i;
    char		*drive;
    char		*dir;
    char		*name;
    char		fname[ _MAX_PATH2 ];
    char		pname[ _MAX_PATH2 ];
    char		stkbuf[24];
    union tsc		final_tsc;
    union tsc		u;

    _RDTSC( &final_tsc );
    curr = (void *)&_Start_TI;
    last = (void *)&_End_TI;
    strcpy( pname, "results.prf" );
    if( *_argv != NULL ) {
	_splitpath2( *_argv, &fname, &drive, &dir, &name, NULL );
	_makepath( pname, drive, dir, name, ".prf" );
    }
    out = fopen( pname, "wt+" );
    if( out == NULL ) return;
    while( (void *)( (char *)curr + offsetof( P5_timing_info, name ) ) < last ) {
//	fprintf( out, "%20.20s\t%08x\t%08x%08x\n", curr->name, curr->count, curr->hi_cycle, curr->lo_cycle );
//	fprintf( out, "%08lx%08lx%11lu\t%s\n", curr->hi_cycle, curr->lo_cycle, curr->count, curr->name );
	u.lo_cycle = curr->lo_cycle;
	u.hi_cycle = curr->hi_cycle;
	if( curr->semaphore != ~0ul ) {		// if semaphore still open
	    u.lo_cycle += final_tsc.lo_cycle;	// - adjust cycle time
	    if( u.lo_cycle < final_tsc.lo_cycle ) {
		++u.hi_cycle;
	    }
	    u.hi_cycle += final_tsc.hi_cycle;
	}
        _Bin2String((short int _WCNEAR *)&u.bigint[0],(char _WCNEAR *)stkbuf,20 );
	for( i = 0; stkbuf[i+1] != '\0'; i++ ) {
	    if( stkbuf[i] != '0' ) break;
	    stkbuf[i] = ' ';
	}
	fprintf( out, "%s%11lu  %s\n", stkbuf, curr->count, curr->name );
	len = strlen( curr->name ) + 1;
	len = (len + 3) & ~3;
	curr = (void *)( (char *)curr + ( offsetof( P5_timing_info, name ) + len ) );
    }
    fclose( out );
}

#if defined(_M_IX86)
 #pragma aux __p5_profile "*";
#endif
YI( __p5_profile, fini, INIT_PRIORITY_LIBRARY )
