/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  23-jan-90     F.W.Crigger     Initial implementation
--------------------------------------------------------Version-11.0---------
  28-may-95	Greg Bentz	variety.h and dll linkage
  05-oct-95	M. Hildebrand	Chooses between NEC & IBM support at runtime.
*/

#include "variety.h"
#include <conio.h>
#ifndef __QNX__
    #include <dos.h>
#endif
#include "extender.h"
#include "nonibm.h"

#define _LOCATION	0x501


_WCRTLINK void sound( unsigned frequency )
    {
#if !(defined(__QNX__)||defined(__WARP__))
	if( !__NonIBM ) {
#endif
	    unsigned	    x;
	    unsigned char   mask;
    
	    if( frequency > 18 ) {
		x = 1193180 / frequency;
		mask = inp( 0x61 );
		if( (mask & 3) == 0 ) {
		    outp( 0x61, mask | 3 );
		    outp( 0x43, 0xB6 );
		}
		outp( 0x42, x );
		outp( 0x42, x >> 8 );
	    }
#if !(defined(__QNX__)||defined(__WARP__))
	} else {
	    unsigned		    x;
	    unsigned long	    parm;
	    unsigned		    modeport, counterport;
	    unsigned char _WCFAR *  ptr;
	    
	    #ifdef __386__
		ptr = MK_FP( _ExtenderRealModeSelector, _LOCATION );
	    #else
		ptr = MK_FP( 0, _LOCATION );
	    #endif
	    if( *ptr & 0x80 ) {	    // 8 MHz
		parm = 1996800;
	    } else {		    // 10 MHz
		parm = 2457600;
	    }
	    if( *ptr & 0x08 ) {	    // High-resolution
		modeport = 0x77;
		counterport = 0x73;
	    } else {		    // Normal resolution
		modeport = 0x3FDF;
		counterport = 0x3FDB;
	    }
	    x = parm / frequency;
	    outp( modeport, 0x76 );
	    outp( counterport, x & 0xFF );
	    outp( counterport, (x>>8) & 0xFF );
	    outp( 0x37, 6 );
	}
#endif
    }


_WCRTLINK void nosound(void)
    {
#if !(defined(__QNX__)||defined(__WARP__))
	if( !__NonIBM ) {
#endif
	    outp( 0x61, inp(0x61) & 0xFC );
#if !(defined(__QNX__)||defined(__WARP__))
	} else {
	    outp( 0x37, 7 );
	}
#endif
    }
