/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
  30-sep-92	J.B.Schueler	Input string no longer modified,
				invalid double-byte no longer returned
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jctype.h>
#include <jstring.h>

/**
*
*  Name:	_fjgetmoji	Po
*
*  Synopsis:	newp = _fjgetmoji( p, moji );
*
*		FJSTRING newp;	̃|C^
*		FJSTRING p;	
*		JMOJI __far *moji;	
*
*  Description: 񂩂擪̂PoB
*		PoCgR[hőQoCgk̎
*		kƂ݂ȂAPoCgkɏB
*
*  Returns:	̃̕|C^ԂB
*		k̎̓k̂̃|C^ԂB
*
*
*  Name:	_fjgetmoji	Get one character
*
*  Synopsis:	newp = _fjgetmoji( p, moji );
*
*		FJSTRING newp;	Pointer to the next character to
*				gotten character
*		FJSTRING p;	String
*		JMOJI *moji;	Character
*
*  Description: Get one character from the head of the string
*		If the first byte is KANJI code and ythe second is NULL,
*		this function treats it as NULL character and changes the
*		fist byte to NULL. This function is a data independent form
*		that accept far pointer argunments. It is most useful in mix
*		memory model applications.
*
*  Return:	Return a pointer to the next character to the gotten
*		character. If the head of the string is NULL, return a pointer
*		to the NULL character.
*
**/

_WCRTLINK FJSTRING _WCI86FAR _fjgetmoji( const JCHAR _WCFAR *p, JMOJI _WCFAR *moji )
{
    if( *moji = *p ) {
	p++;
	if( iskanji( *moji ) ) {
	    if( *p )
		*moji = ( *moji << 8 ) | *p++;
	    else
//		*--p = '\0';	    // JBS 92/09/30
		*moji = '\0';	    // JBS 92/09/30
	}
    }
    return( (FJSTRING) p );
}
