/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>


/**
*
*  Name:	_fjstrcat		
*		_fjstrncat
*
*  Synopsis:	p = _fjstrncat( to, from, n );
*		p = _fjstrcat( to, from );
*
*		FJSTRING p;	Ɠl
*		FJSTRING to;	镶
*		FJSTRING from;	镶
*		int n;		
*
*  Description: 񂔂̌ɕ񂆂̐擪
*		B
*
*  Returns:	PƓ̂ԂB
*
*
*  Name:	_fjstrcat		 concatenate KANJI strings
*		_fjstrncat
*
*  Synopsis:	p = _fjstrncat( to, from, n );
*		p = _fjstrcat( to, from );
*
*		FJSTRING	p;	same value as argument "to"
*		FJSTRING	to;	distination KANJI string pointer.
*		FJSTRING	from;	KANJI string pointer for appendage
*		int		n;	number of letters should be appended
*
* Description:	The jstrcat and jstrncat functions append a copy of the KANJI
*		string pointed to by "from" to the end of the KANJI string
*		pointed to by "to".  The first letter of "from" overwrite the
*		null character at the end of "to", and jstrncat appends only
*		"n" number of letters. This function is a data independent
*		form that accept far pointer argunments. It is most useful
*		in mix memory model applications.
*
*  Returns:	The value of "to" is returned.
*
**/

_WCRTLINK FJSTRING _WCI86FAR _fjstrncat( JCHAR _WCFAR *to, const JCHAR _WCFAR *from, size_t n )
{
    JCHAR _WCFAR *p;
    size_t m;
    JMOJI mm;

    p = to;
    while( p = _fjgetmoji( p, (JMOJI _WCFAR *)&mm ), mm );
    m = _fmtob( from, n );
    while( m-- > 0 ) *p++ = *from++;
    *p = '\0';
    return( to );
}

_WCRTLINK FJSTRING _WCI86FAR _fjstrcat( JCHAR _WCFAR * to, const JCHAR _WCFAR * from )
{
    return _fjstrncat( to, from, _fjstrlen( from ) );
}
