/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>
#include <ctype.h>

/**
*
*  Name:	_fjstricmp		r
*
*  Synopsis:	x = _fjstricmp( a, b );
*
*		int x;		
*		FJSTRING a, b;	
*
*  Description: Q̕rB啶A͖܂B
*		`mj@@Ji@@@̑召֌W
*		ɂȂĂB
*
*  Returns:	񂁂̕ꍇ͕A傫ꍇ
*		͐ԂAƂƂ͂OԂB
*
*
*  Name:	_fjstricmp	compare strings with mixed KANJI letters
*
*  Synopsis:	x = _fjstricmp( a, b );
*
*		int x;		resoult as compared
*		FJSTRING a, b;	two strings for compare each other
*
*  Description: The _fjstricmp function compares the string pointed to by a
*		to the string pointed to by b with case insensitivity.
*		All upper-case characters from a and b are mapped to
*		lower-case for the purposes of doing the comparison.
*		The rule of comparison is as below.
*		  Ascii and numeric letter < KATAKANA letter < KANJI letter
*		This function is a data independent form that accept far
*		pointer argunments. It is most useful in mix memory model
*		applications.
*
*  Returns:	The jstricmp function returns an integer less than, equal to
*		or greater than zero, indicating that the string pointed
*		to by a is less than, equal to, or greater than the string
*		pointed to by b.
*
**/

_WCRTLINK int _WCI86FAR _fjstricmp( const JCHAR _WCFAR *a, const JCHAR _WCFAR *b )
{
    JMOJI aa, bb;

    while( 1 ) {
	a = _fjgetmoji( a, (JMOJI _WCFAR *)&aa );
	b = _fjgetmoji( b, (JMOJI _WCFAR *)&bb );
	if( aa & 0xff00 )
	    aa = jtoupper( aa );
	else
	    aa = toupper( aa );
	if( bb & 0xff00 )
	    bb = jtoupper( bb );
	else
	    bb = toupper( bb );
	if( aa != bb ) return( ( aa < bb ) ? -1 : 1 );
	if( aa == 0 ) return( 0 );
    }
}
