/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>


/**
*
*  Name:	_fjstrlen		𓾂
*
*  Synopsis:	nm = _fjstrlen( s );
*
*		int nm; 	
*		FJSTRING s;	
*
*  Description: ̕𓾂B
*
*
*  Name:	_fjstrlen		compute the length of KANJI string
*
*  Synopsis:	nm = _fjstrlen( s );
*
*		int	nm;	length of KANJI string
*		FJSTRING	s;	pointer to the KANJI string
*
*  Description: The _fjstrlen function compute the length of string pointed to
*		by s with in KANJI letter. This function is a data independent
*		form that accept far pointer argunments. It is most useful
*		in mix memory model applications.
*
*  Returns:	The _fjstrlen function returns the number of letters that
*		precede the terminating null character.
*
**/

_WCRTLINK size_t _WCI86FAR _fjstrlen( const JCHAR _WCFAR *s )
{
    size_t count = 0;
    JMOJI m;

    while( s = _fjgetmoji( s, (JMOJI _WCFAR *)&m ), m ) count++;
    return count;
}
