/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>

/**
*
*  Name:	_fjstrlwr		Spɕϊ
*
*  Synopsis:	s2 = _fjstrlwr( s1 );
*
*		JSTRING s1;	ϊSp
*		JSTRING s2;	ϊꂽSp
*
*  Description: ^ꂽSp̑啶ϊB
*
*  Returns:	ϊs\̕ɂ͂ȂɂȂB
*
*
*  Name:	_fjstrlwr		Convert string to lower case 2-byte KANJI code
*
*  Synopsis:	s2 = _fjstrlwr( s1 );
*
*		JSTRING s1;	2-byte KANJI code string
*		JSTRING s2;	lower case 2-byte KANJI code string
*
*  Description: Convert upper case characters of given 2-byte KANJI string to
*		lower case. This function is a data independent form that
*		accept far pointer argunments. It is most useful in mix memory
*		model applications.
*
*  Returns:	If some characters in given string are not able to be
*		converted, they are not changed.
*
**/

_WCRTLINK FJSTRING _WCI86FAR _fjstrlwr( JCHAR _WCFAR *str )
{
    JCHAR _WCFAR *dest, _WCFAR *keep = str;
    JMOJI c;

    for( dest = str; str = _fjgetmoji( str, (JMOJI _WCFAR *)&c ), c; ) {
	dest = _fjputmoji( dest, jtolower( c ) );
    }
    return keep;
}
