/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>


/**
*
*  Name:	_fjstrmatch	w蕶
*
*  Synopsis:	p = _fjstrmatch( s, b );
*
*		FJSTRING p;	̃|C^
*		FJSTRING s;	
*		FJSTRING b;	w蕶̕
*
*  Description: Q́A񂓂PÂ
*		ŏɕ񂂂Ɋ܂܂镶ƈvʒũ|C
*		^ԂBQ͔΂ɁAŏɕ
*		Ɋ܂܂Ȃꂽʒũ|C^ԂB
*
*  Returns:	ɃkȉI[jɒBꍇ̓k|
*		C^ԂB
*
*
*  Name:	_fjstrmatch	compute the initial position where searching
*				letters occur in string
*
*  Synopsis:	p = _fjstrmatch( s, b );
*
*		FJSTRING	p;	pointer to the initial position of
*					searching letter occurrence
*		FJSTRING	s;	pointer to the string for reference
*		FJSTRING	b;	pointer to the searching letters
*
*  Description: The jstrmatch function compute the initial position of the
*		string pointed to by s where occur the letters from the string
*		pointed to by b.  jstrskip function have the opposite
*		specification to jstrmatch, at the view of initial position
*		where not occur the searching letter. This function is
*		a data independent form that accept far pointer argunments.
*		It is most useful in mix memory model applications.
*
*  Returns:	This function will return the NULL pointer if it not occured
*		the letters from string pointed to by b.
*
**/

_WCRTLINK FJSTRING _WCI86FAR _fjstrmatch( const JCHAR _WCFAR *s, const JCHAR _WCFAR *b )
{
    const JCHAR _WCFAR *st, _WCFAR *bt;
    JMOJI ss, bb;

    for( ; st = _fjgetmoji( s, (JMOJI _WCFAR *)&ss ), ss; s = st )
	for( bt = b; bt = _fjgetmoji( bt, (JMOJI _WCFAR *)&bb ), bb; )
	    if( ss == bb ) return( (FJSTRING) s );
    return( (FJSTRING) NULL );
}
