/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>


/**
*
*  Name:	_fjstrncmp
*
*  Synopsis:	x = _fjstrncmp( a, b, n );
*
*		int x;		
*		FJSTRING a, b;	
*		int n;		
*
*  Description: Q̕rB͐擪
*		݂̂̔rB
*		`mj@@Ji@@@̑召֌W
*		ɂȂĂB
*
*  Returns:	񂁂̕ꍇ͕A傫ꍇ
*		͐ԂAƂƂ͂OԂB
*
*
*  Name:	_fjstrncmp	compare strings with in KANJI letters
*
*  Synopsis:	x = _fjstrncmp( a, b, n );
*
*		int	x;	resoult as compared
*		FJSTRING	a, b;	two strings for compare each other
*		int	n;	length for comparison
*
*  Description: The _fjstrncmp function compares the KANJI string pointed to
*		by "a" to the string pointed to by "b".
*		This function compares only "n" letters from top of the strings.
*		The rule of comparison is as below.
*		  ASCII and numeric letter < KATAKANA letter < KANJI letter
*		This function is a data independent form that accept far
*		pointer argunments. It is most useful in mix memory model
*		applications.
*
*  Returns:	The _fjstrncmp function returns an integer less than, equal to,
*		or greater than zero, indicating that the string pointed to
*		by "a" is less than, equal to, or greater than the string
*		pointed to by "b".
*
**/


_WCRTLINK int _WCI86FAR _fjstrncmp( const JCHAR _WCFAR *a, const JCHAR _WCFAR *b, size_t n )
{
    JMOJI aa, bb;

    while( n-- ) {
	a = _fjgetmoji( a, (JMOJI _WCFAR *)&aa );
	b = _fjgetmoji( b, (JMOJI _WCFAR *)&bb );
	if( aa != bb ) return( ( aa < bb ) ? -1 : 1 );
	if( aa == 0 ) break;
    }
    return( 0 );
}
