/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>


/**
*
*  Name:	_fjstrrchr
*
*  Synopsis:	p = _fjstrrchr( s, c );
*
*		FJSTRING p;	̃|C^
*		FJSTRING s;	
*		JMOJI c;	
*
*  Description: 񂓂ɌAŏɕƈv
*		ʒũ|C^ԂB͐擪
*		A͍Ōォ猟B
*
*  Returns:	vȂꍇ̓k|C^ԂB
*
*
*  Name:	_fjstrrchr	search out specified letter from the string
*
*  Synopsis:	p = _fjstrrchr( s, c );
*
*		FJSTRING	p;	return value which point to the
*					searched out letter
*		JSTRING s;	pointer to the string which is referenced
*		JMOJI	c;	the value of searching letter
*
*  Description: The _fjstrrchr function locates the final occurrence of "c"
*		in the string pointed to by "s". _fstrrchr function start to
*		search out from the end of string, and jstrchr function
*		start to search out from the top of string.
*		If you specify "c" with KANJI letter, JMOJI consist with 16
*		bit and its' high byte consist with first byte code of KANJI
*		letter, and low byte consist with second byte code of KANJI
*		letter. If second byte code is NULL then the first byte code
*		also consider to NULL. If you specify "c" with 1 byte character
*		then, it must be in the low byte of JMOJI and the high byte of
*		JMOJI has to NULL. This function is a data independent form
*		that accept far pointer argunments. It is most useful in mix
*		memory model applications.
*
*  Returns:	This function returns a pointer to the located letter, or NULL
*		if the letter does not occur in the string.
*
**/


_WCRTLINK FJSTRING _WCI86FAR _fjstrrchr( const JCHAR _WCFAR *s, JMOJI c )
{
    const JCHAR _WCFAR *p, _WCFAR *ss;
    JMOJI cc;

    p = (FJSTRING) NULL;
    while( 1 ) {
	ss = _fjgetmoji( s, (JMOJI _WCFAR *)&cc );
	if( cc == 0 ) break;
	if( cc == c ) p = s;
	s = ss;
    }
    return( (FJSTRING) p );
}
