/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>
#include <jctype.h>
#include <string.h>

/**
*
*  Name:	_fjstrrev -- 𔽓]
*
*  Synopsis:	p = _fjstrrev( s );
*
*		FJSTRING p,s;	
*
*  Description: ̊֐͕𔽓]܂B܂A̒_ɊւāA
*		]֐̊łłB͂PƂĈA
*		̒̊̑PoCgƑQoCg͕̏ۂB
*
*  Returns:	_fjstrrev ֐́A s ƓlԂB
*
*
*  Name:	_fjstrrev -- reverse a character string
*
*  Synopsis:	p = _fjstrrev( s );
*
*		FJSTRING p,s;	string pointer
*
*  Description: This function reverses a character string.  That is, it
*		"rotates" the string about its mid-point (KANJI version).
*		So the KANJI letter consider to 1 character, it to be kept
*		the order for the first byte code and second byte code of
*		a KANJI letter inward string. This function is a data
*		independent form that accept far pointer argunments.
*		It is most useful in mix memory model applications.
*
*  Returns:	The _fjstrrev function returns the same value of argument "s".
*
**/

_WCRTLINK FJSTRING _WCI86FAR _fjstrrev( JCHAR _WCFAR *s )
{
    JCHAR _WCFAR *p, _WCFAR *q, _WCFAR *r;

    p = s;
    q = p + _fstrlen( p );
    while( p < q ) {
	if( iskanji( *p ) ) {
	    if( iskanji2( *( r = p + 1 ) ) ) {
		*p ^= *r;
		*r ^= *p;
		*p++ ^= *r;
	    }
	}
	p++;
    }
    p = s;
    while( p < --q ) {
	*p ^= *q;
	*q ^= *p;
	*p++ ^= *q;
    }
    return( s );
}
