/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>


/**
*
*  Name:	_fjstrskip	w蕶ȊO
*
*  Synopsis:	p = _fjstrskip( s, b );
*
*		FJSTRING p;	̃|C^
*		FJSTRING s;	
*		FJSTRING b;	w蕶̕
*
*  Description: Q́A񂓂PÂ
*		ŏɕ񂂂Ɋ܂܂镶ƈvʒũ|C
*		^ԂBQ͔΂ɁAŏɕ
*		Ɋ܂܂Ȃꂽʒũ|C^ԂB
*
*  Returns:	ɃkȉI[jɒBꍇ̓k|
*		C^ԂB
*
*
*  Name:	_fjstrskip	compute the initial position of searching
*				letter not occur in string
*
*  Synopsis:	p = _fjstrskip( s, b );
*
*		FJSTRING	p;	pointer to the initial position of
*				searching letter not occur in string
*		FJSTRING	s;	pointer to the string for reference
*		FJSTRING	b;	pointer to the searching letters
*
*  Description: The _fjstrmatch function compute the initial position of the
*		string pointed to by s where occur the letters from the string
*		pointed to by b.  _fjstrskip function have the opposite
*		specification to _fjstrmatch, at the view of initial position
*		where not occur the searching letter. This function is
*		a data independent form that accept far pointer argunments.
*		It is most useful in mix memory model applications.
*
*  Returns:	This function will return the NULL pointer if there is no the
*		other letters in the string "s".
*
**/


_WCRTLINK FJSTRING _WCI86FAR _fjstrskip( const JCHAR _WCFAR *s, const JCHAR _WCFAR *b )
{
    const JCHAR _WCFAR *st, _WCFAR *bp;	/* add "bp" by M/M Mar/15/87 */
    JMOJI ss, bb;

    for( ; st = _fjgetmoji( s, (JMOJI _WCFAR *)&ss ), ss; s = st )
	for( bp = b;; ) {  /* reset the head pointer of character-set */
	    bp = _fjgetmoji( bp, (JMOJI _WCFAR *)&bb ); /* by M/M Mar/15/87 */
	    if( ss == bb ) break;
	    if( bb == 0 ) return( (FJSTRING) s );
	}
    return( (FJSTRING) NULL );
}
