/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>

/**
*
*  Name:	_fjstrspn
*
*  Synopsis:	unsigned int _fjstrspn( JSTRING str1, JSTRING str2 );
*
*		JSTRING str1;	T[`镶
*		JSTRING str2;	str1 ̒T[`镶̏W
*		unsigned ret;	str2 Ŏw肵ɈvȂŏ̕
*				wCfbNX
*
*  Description: _fjstrspn ֐,  str1 ̒A str2 Ŏw肵
*		񒆂̂̕ƂvȂAŏ̕w
*		CfbNXԂ܂Bstr1 ̐擪߂loCg
*		́Astr2 Ŏw肵񒆂̕ō\Ă邱Ƃ
*		Ӗ܂Bstr1  str2 Ŏw肵ȊOŎn܂Ă
*		Ƃ́A0 Ԃ܂B
*
*  Name:	_fjstrspn
*
*  Synopsis:	ret = _fjstrspn( str1, str2 );
*
*		JSTRING str1;	2-byte KANJI string
*		JSTRING str2;	2-byte KANJI characters
*		unsigned ret;	Index to the first character in string str1
*				which does not consist of string str2.
*
*  Description: _fjstrspn function returns the index to the first character in
*		thestrinf str1 which is not included in the string str2.
*		In the other words, The string from the head of the string
*		str1 through the ret bytes is consists of the characters in
*		the string str2. This function is a data independent form
*		that accept far pointer argunments. It is most useful in mix
*		memory model applications.
*
*  Return:	If the string str1 starts with a character which is not
*		included in the string str2, this function returns 0.
*
**/

_WCRTLINK size_t _WCI86FAR _fjstrspn( const JCHAR _WCFAR *str1, const JCHAR _WCFAR *str2 )
{
    const JCHAR _WCFAR *s2;
    JMOJI c1, c2;
    size_t count;

    for( count = 0;
	str1 = _fjgetmoji( str1, ( JMOJI _WCFAR * )&c1 ), c1;
	++count ) {
	for( s2 = str2;
	    ( s2 = _fjgetmoji( s2, ( JMOJI _WCFAR * )&c2 ), c2 ) && ( c1 != c2 );
	    );
	if( !c2 ) break;
    }
    return count;
}
