/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage

*/

#include "variety.h"
#include <jstring.h>

/**
*
*  Name:	_fjstrstr		񂩂̂镶̃T[`
*
*  Synopsis:	s3 = _fjstrstr( s1, s2 );
*
*		JSTRING s1;	T[`镶
*		JSTRING s2;	string1̒猩
*		JSTRING s3;	string1̒Ōꂽ
*
*  Description:  s1 ̒當 s2 {Aꂽւ
*		|C^Ԃ܂BȂꍇɂ́Ak|C^
*		Ԃ܂B
*
*  Name:	_fjstrstr		Search a substring in a string
*
*  Synopsis:	s3 = _fjstrstr( s1, s2 );
*
*		JSTRING s1;	2-byte KANJI string
*		JSTRING s2;	2-byte KANJI substring
*		JSTRING s3;	Ponter to found string
*
*  Description: The _fjstrstr function locate the first occurrence in the
*		2-byte KANJI string pointed to by s1 of sequence of characters
*		(excluding the terminating null character) un the 2-byte KANJI
*		string pointed to s2. This function is a data independent
*		form that accept far pointer argunments. It is most useful
*		in mix memory model applications.
*
*  Return:	The _fjstrstr function returns a pointer to the located 2-byte
*		KANJI string, or NULL if the string is not found.
*
**/

_WCRTLINK FJSTRING _WCI86FAR _fjstrstr( const JCHAR _WCFAR *s1, const JCHAR _WCFAR *s2 )
{
     JMOJI c1, c2;
     const JCHAR _WCFAR *sp2, _WCFAR *n;

     sp2 = _fjgetmoji( s2, (JMOJI _WCFAR *)&c2 );
     if( c2 == '\0' ) return( (FJSTRING) s1 );
loop1:
     n = s1;
     s1 = _fjgetmoji( s1, (JMOJI _WCFAR *)&c1 );
     if( c1 == '\0' ) return( (FJSTRING) NULL );
loop1a:
    if( c1 != c2 ) {
	  goto loop1;
    } else {
loop2:
	s1 = _fjgetmoji( s1, (JMOJI _WCFAR *)&c1 );
	sp2 = _fjgetmoji( sp2, (JMOJI _WCFAR *)&c2 );
	if( c2 == '\0' ) return( (FJSTRING) n );
	if( c1 == '\0' ) return( (FJSTRING) NULL );
	if( c2 == c1 ) {
	    goto loop2;
	}
	s1 = _fjgetmoji( ++n, (JMOJI _WCFAR *)&c1 );
	sp2 = _fjgetmoji( s2, (JMOJI _WCFAR *)&c2 );
	goto loop1a;
    }
}
