/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage
  29-may-96	M. Hildebrand	Changed __HanZen to __HanZen1.
*/

#include "variety.h"
#include <jstring.h>
#include "hanzentb.h"


/**
*
*  Name:	hantozen	Spɕϊ
*		zentohan	AXL[ɕϊ
*
*  Synopsis:	nc = hantozen( c );
*		nc = zentohan( c );
*
*		JMOJI nc;	ϊ
*		JMOJI c;	ϊ镶
*
*  Description: hantozen̓AXL[ɑΉSp
*		ϊBzentohan͋tɑSpAXL[
*		ϊBϊ\ȕ͈̔͂́AAXL[ER[h
*		̂OQOOVɑΉ镶łB
*
*  Returns:	ϊs\̏ꍇ͂Ȃɂc ̒lԂB
*
*
*  Name:	hantozen	Change ASCII character to 2-byte KANJI 
*				character
*		zentohan	Change 2-byte KANJI character to ASCII
*				character
*
*  Synopsis:	nc = hantozen( c );
*		nc = zentohan( c );
*
*		JMOJI nc;	Changed result character
*		JMOJI c;	Source character
*
*  Description: Hantozen changes ASCII character to 2-byte KANJI character 
*		corresponding to it. Oppositly zentohan changes 2-byte KANJI 
*		character to ASCII character corresponding to it. The range of 
*		changable character set is more than or equal to 0x20 and less 
*		than or equal to 0x7e.
*
*  Returns:	Return c if c is unchangable.
*
**/

_WCRTLINK JMOJI hantozen( c )
JMOJI c;
{
    return( ( c >= 0x20 && c <= 0x7e ) ? __HanZen1[c - 0x20] : c );
}



_WCRTLINK JMOJI zentohan( c )
JMOJI c;
{
    JMOJI i;

    for( i = 0; i <= 0x5e; i++ )
	if( c == __HanZen1[i] ) return( i + 0x20 );
    return( c );
}
