/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
  16-mar-92	J.B.Schueler	Increased TMSZ from 26 to 37
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

*/

#include "variety.h"
#include <stdio.h>
#include <jtime.h>

#define TMSZ 37

static const char *dtbl[] = {"","","","","","","y"};

static unsigned char s[TMSZ];
/**
*
*  Name:	jasctime
*
*  Synopsis:	s = jasctime( t )
*
*		unsigned char *s;	ASCII 
*		struct tm *t;		͂ tm \
*
*  Description: tm \̂̒lȉ̌`̕ɕϊB
*
*			YYYY N MM  dd   (DD)  hh:mm:ss\n\0
*
*		DD ͗jAMM ͌Add ͓tAhh:mm:ss ͎FFbA
*		YYYY ͔NłB
*
*
*  Name:	jasctime
*
*  Synopsis:	s = jasctime( t )
*
*		unsigned char *s;	ASCII string returned
*		struct tm *t;		input tm structure
*
*  Description: Represent the tm structure as a string in the form
*
*			YYYY N MM  dd   (DD)  hh:mm:ss\n\0
*
*		where DD is the day of the week, MM is the month, dd is
*		the day of the month, hh:mm:ss is the hour:minute:seconds,
*		and YYYY is the year.
*
**/

_WCRTLINK unsigned char *jasctime( const struct tm *t )
{
    /*		 1234567890 123456 7890123456789  012  345  6 7*/
    sprintf( s, "%04d N %2d  %2d  i%sj %02d:%02d:%02d\n",
	t->tm_year+1900,
	t->tm_mon+1,
	t->tm_mday,
	dtbl[t->tm_wday],
	t->tm_hour,
	t->tm_min,
	t->tm_sec );
    return( s );
}
