/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage
  25-sep-95	M. Hildebrand	Split jmstojis to another file, and added
				_mbcjistojms.
*/

#include "variety.h"
#include <jstring.h>

/**
*
*  Name:	jistojms		JISR[hVtgJISR[hɕϊ
*		jmstojis		VtgJISR[hJISR[hɕϊ
*
*  Synopsis:	sc = jistojms( jc );
*		jc = jmstojis( sc );
*
*		unsigned short sc;	VtgJISR[h
*		unsigned short jc;	JISR[h
*
*  Description: jistojms ֐́AJISR[hVtgJISR[hɕϊB
*		jmstojis ֐́AVtgJISR[hJISR[hɕϊB
*		͈͊ȌꍇA0 ԂB
*
*
*  Name:	jistojms		Convert JIS code to shift-JIS code
*		jmstojis		Convert shift-JIS code to JIS code
*
*  Synopsis:	ret = jistojms( c );
*		ret = jmstojis( c);
*
*		unsigned short sc;	Shift-JIS code
*		unsigned short jc;	JIS code
*
*  Description: Jistomsj converts JIS code to shift-JIS code and msjtojis
*		converts shift-JIS code to JIS code. If argument is out of
*		range, they return 0.
*
*  Note:	JIS code is a kind of KANJI character set. It is defined
*		by JIS, Japan Industrial Standard Institutes. Shift-JIS is
*		another KANJI character set. It is defined by Microsoft for
*		MS-DOS which is based on JIS code. The first byte and the
*		second byte of JIS code are less than 0x80. Microsoft has
*		designed shift-JIS code can be mixed in string with
*		alpha-numeric. Thus shift-JIS code is more than or equal to
*		0x8140.
*
**/

_WCRTLINK unsigned int _mbcjistojms( unsigned int ch )
{
    return( jistojms( ch ) );
}


_WCRTLINK unsigned short jistojms( unsigned short c )
{
    unsigned char u, l;

    l = c;
    u = c >> 8;

    if( u < 0x21 || u > 0x7e || l < 0x21 || l >0x7e ) return 0;

    l += (u % 2) ? ((l < 0x60) ? 0x1f : 0x20) : 0x7e;
    u = (u - 1) / 2 + ((u < 0x5f) ? 0x71 : 0xb1);

    return( ( (unsigned short)u << 8 ) + l);
}
