/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

*/

#include "variety.h"
#include <jstring.h>


/**
*
*  Name:	jstrcat 	
*		jstrncat
*
*  Synopsis:	p = jstrncat( to, from, n );
*		p = jstrcat( to, from );
*
*		JSTRING p;	Ɠl
*		JSTRING to;	镶
*		JSTRING from;	镶
*		int n;		
*
*  Description: 񂔂̌ɕ񂆂̐擪
*		B
*
*  Returns:	PƓ̂ԂB
*
*
*  Name:	jstrcat 	 concatenate KANJI strings
*		jstrncat
*
*  Synopsis:	p = jstrncat( to, from, n );
*		p = jstrcat( to, from );
*
*		JSTRING p;	same value as argument "to"
*		JSTRING to;	distination KANJI string pointer.
*		JSTRING from;	KANJI string pointer for appendage
*		int	n;	number of letters should be appended
*
* Description:	The jstrcat and jstrncat functions append a copy of the KANJI
*		string pointed to by "from" to the end of the KANJI string
*		pointed to by "to".  The first letter of "from" overwrite the
*		null character at the end of "to", and jstrncat appends only
*		"n" number of letters.
*
*  Returns:	The value of "to" is returned.
**/

_WCRTLINK JSTRING jstrncat( JCHAR *to, const JCHAR *from, size_t n )
{
    JCHAR *p;
    size_t m;
    JMOJI mm;

    p = to;
    while( p = jgetmoji( p, &mm ), mm );

    m = mtob( from, n );
    while( m-- > 0 ) *p++ = *from++;
    *p = '\0';
    return( to );
}

_WCRTLINK JSTRING jstrcat( JCHAR *to, const JCHAR *from )
{
    return jstrncat( to, from, jstrlen( from ) );
}
