/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

*/

#include "variety.h"
#include <jstring.h>


/**
*
*  Name:	jstrchr 	
*
*  Synopsis:	p = jstrchr( s, c );
*
*		JSTRING p;	̃|C^
*		JSTRING s;	
*		JMOJI c;	
*
*  Description: 񂓂ɌAŏɕƈv
*		ʒũ|C^ԂB͐擪
*		A͍Ōォ猟B
*
*  Returns:	vȂꍇ̓k|C^ԂB
*
*
*  Name:	jstrchr 	search out specified KANJI letter from string
*
*  Synopsis:	p = jstrchr( s, c );
*
*		JSTRING p;	a pointer located to the specified letter
*		JSTRING s;	a pointer to the KANJI string for reference
*		JMOJI	c;	KANJI letter for search out
*
*  Description: The jstrchr function locates the first occurrence of "c" in
*		the KANJI string pointed to by "s". Jstrchr function starts to
*		search out from the top of string , and jstrrchr function starts
*		to search out from the end of string.
*
*  Returns:	This function returns a pointer to the located letter, or NULL
*		if the letter does not occur in the string.
**/

_WCRTLINK JSTRING jstrchr( const JCHAR *s, JMOJI c )
{
    JMOJI cc;
    const JCHAR *ss;

    do {
	ss = jgetmoji( s, &cc );
	if( c == cc ) return( (JSTRING) s );
	s = ss;
    } while( cc );
    return( (JSTRING) NULL );
}
