/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

*/

#include "variety.h"
#include <jstring.h>

/******************************************************************************
*
*  Name:	jstrcspn	̐擪猟܂ł̕𓾂
*
*  Synopsis:	c = jstrcspn( str1, str2 );
*
*		int	c;	̐擪猟܂ł̕
*		JSTRING str1;	팟
*		JSTRING str2;	̃Zbg
*
*  Description: jstrcspn ֐ strcspn ֐R[hɑΉłB
*		str1 Ŏw肵񒆂ŁAstr2 Ŏw肵̂ꂩP*		ŏɌ܂ł̕Ԃ܂B
*
*  Returns:	str2 Ŏw肵ȂAstr1 ̐擪̕*		̕AlŕԂ܂B
*
*
*  Name:	jstrcspn	compute the length of the initial segment of
*				the string consists letters not from the
*				array of the searching letters.
*
*  Synopsis:	c = jstrcspn( str1, str2 );
*		int	c;	resoult length of computing
*		JSTRING str1;	pointer to be referenced string
*		JSTRING str2;	pointer to the array of searching letters
*
*  Description: jstrcspn function has same specification as strcspn function
*		except having advantage point for correspond to KANJI letters.
*		The jstrcspn function computes the length of the initial segment
*		of the string pointed to by str1 which consists entirely of
*		letters not from the string pointed to by str2. Japanese 2 byte
*		code letter is considered one character.
*
*  Returns:	The length of the initial segment is returned.
*/

_WCRTLINK size_t jstrcspn( const JCHAR *str1, const JCHAR *str2 )
{
    const JCHAR *s2;
    JMOJI c1, c2;
    size_t count;

    for( count = 0; str1 = jgetmoji( str1, &c1 ), c1; ++count ) {
	for( s2 = str2; s2 = jgetmoji( s2, &c2 ), c2; ) {
	    if( c1 == c2 ) return count;
	}
    }
    return count;
}
