/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

*/

#include "variety.h"
#include <jstring.h>

/**
*
*  Name:	jstrspn
*
*  Synopsis:	unsigned int jstrspn( JSTRING str1, JSTRING str2 );
*
*		JSTRING str1;	T[`镶
*		JSTRING str2;	str1 ̒T[`镶̏W
*		unsigned ret;	str2 Ŏw肵ɈvȂŏ̕
*				wCfbNX
*
*  Description: jstrspn ֐,  str1 ̒A str2 Ŏw肵
*		񒆂̂̕ƂvȂAŏ̕w
*		CfbNXԂ܂Bstr1 ̐擪߂loCg
*		́Astr2 Ŏw肵񒆂̕ō\Ă邱Ƃ
*		Ӗ܂Bstr1  str2 Ŏw肵ȊOŎn܂Ă
*		Ƃ́A0 Ԃ܂B
*
*  Name:	jstrspn
*
*  Synopsis:	ret = jstrspn( str1, str2 );
*
*		JSTRING str1;	2-byte KANJI string
*		JSTRING str2;	2-byte KANJI characters
*		unsigned ret;	Index to the first character in string str1
*				which does not consist of string str2.
*
*  Description: Jstrspn function returns the index to the first character in
*		the string str1 which is not included in the string str2.
*		In the other words, The string from the head of the string
*		str1 through the ret bytes is consists of the characters in
*		the string str2.
*
*  Return:	If the string str1 starts with a character which is not
*		included in the string str2, this function returns 0.
*
**/

_WCRTLINK size_t jstrspn( const JCHAR *str1, const JCHAR *str2 )
{
    const JCHAR *s1, *next_s1, *s2;
    JMOJI c1, c2;

    for( s1 = str1; next_s1 = jgetmoji( s1, &c1 ), c1; s1 = next_s1) {
	for( s2 = str2;
	    ( s2 = jgetmoji( s2, &c2 ), c2 ) && ( c1 != c2 );
		);
	if( !c2 ) break;
    }
    return ( s1 - str1 );
}
