/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

*/

#include "variety.h"
#include <string.h>
#include <jstring.h>

/**
*
*  Name:	jstrstr 	񂩂̂镶̃T[`
*
*  Synopsis:	s3 = jstrstr( s1, s2 );
*
*		JSTRING s1;	T[`镶
*		JSTRING s2;	string1̒猩
*		JSTRING s3;	string1̒Ōꂽ
*
*  Description:  s1 ̒當 s2 {Aꂽւ
*		|C^Ԃ܂BȂꍇɂ́Ak|C^
*		Ԃ܂B
*
*  Name:	jstrstr 	Search a substring in a string
*
*  Synopsis:	s3 = jstrstr( s1, s2 );
*
*		JSTRING s1;	2-byte KANJI string
*		JSTRING s2;	2-byte KANJI substring
*		JSTRING s3;	Ponter to found string
*
*  Description: The jstrstr function locate the first occurrence in the 2-byte
*		KANJI string pointed to by s1 of sequence of characters
*		(excluding the terminating null character) un the 2-byte KANJI
*		string pointed to s2.
*
*  Return:	The jstrstr function returns a pointer to the located 2-byte
*		KANJI string, or NULL if the string is not found.
*
**/

_WCRTLINK JSTRING jstrstr( const JCHAR *s1, const JCHAR *s2 )
{
    JMOJI c1, c2;
    const JCHAR *sp2, *n;

    sp2 = jgetmoji( s2, &c2 );
    if( c2 == '\0' ) return( (JSTRING) s1 );
loop1:
    n = s1;
    s1 = jgetmoji( s1, &c1 );
    if ( c1 == '\0' ) return( (JSTRING) NULL );
loop1a:
    if( c1 != c2 ) {
	goto loop1;
    } else {
loop2:
	s1 = jgetmoji( s1, &c1 );
	sp2 = jgetmoji( sp2, &c2 );
	if( c2 == '\0' ) return( (JSTRING) n );
	if( c1 == '\0' ) return( (JSTRING) NULL );
	if ( c2 == c1 ) goto loop2;
	s1 = jgetmoji( ++n, &c1 );
	sp2 = jgetmoji( s2, &c2 );
	goto loop1a;
    }
}
