/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
  22-feb-93	J.B.Schueler	Must check for NULL ptr from jstrskip
				Must check for NULL ptr from jstrmatch
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

*/

#include "variety.h"
#include <jctype.h>
#include <jstring.h>


/**
*
*  Name:	jstrtok 	ؕŕ
*
*  Synopsis:	sp = jstrtok( targ, brk );
*
*		JSTRING sp;	
*		JSTRING targ;	
*		JSTRING brk;	ؕ
*
*  Description: 񂔂𕶎񂂂ɂ镶ؕ
*		ƂĕBŏ̌ĂяołPڂ̕
*		ւ̃|C^ԂBQڂ͂
*		mtkkɂČĂяoƂɂAɕ
*		ւ̃|C^ԂB
*
*  Returns:	kɒBꍇ̓kE|C^ԂB
*
*  Caution:	́̕Ak㏑鎖ɂ菑
*		B
*
*
*  Name:	jstrtok 	Break 2-byte KANJI string into tokens of KANJI
*
*  Synopsis:	sp = jstrtok( targ, brk );
*
*		JSTRING sp;	Broken string
*		JSTRING targ;	2-byte KANJI string
*		JSTRING brk;	Sequence of 2-byte KANJI delimiters
*
*  Description: Break the 2-byte KANJI string pointed to by targ into a
*		sequence of tokens of 2-byte KANJI, each of which is delimited
*		by a character from the string pointed to by brk. The first
*		call to jstrtok will return a pointer to the first token in the
*		string pointed to by targ. Subsequence calls to jstrtok must
*		pass a NULL pointer as the first argument, in order to get the
*		next token in the string.
*
*  Returns:	jstrtok function returns a pointer to the first character of
*		token or NULL if there is no token found.
*
*  Caution:	The given string is overwritten by NULL character.
*
**/

_WCRTLINK JSTRING jstrtok( JCHAR *targ, const JCHAR *brk )
{
    static JCHAR *sp;
    JCHAR *p, *q, *r;

    p = ( targ == NULL ) ? sp : targ;
    if( p == NULL ) return( NULL );
    q = jstrskip( p, brk );
    if( q == NULL ) return( NULL );
    if( *q == '\0' || ( iskanji( *q ) && q[1] == '\0' ) )
	return( NULL );
    r = jstrmatch( q, brk );
    if( r == NULL ) return( NULL );
    if( *r == '\0' ) {
	sp = NULL;
    } else {
	if( iskanji( *r ) ) *r++ = '\0';
	*r = '\0';
	sp = ++r;
    }
    return( q );
}
