/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-mar-92	J.B.Schueler	Adapted from LifeBoat code
  01-oct-92	J.B.Schueler	Revised code after changing nbyte to unsigned
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

*/

#include "variety.h"
#include <jstring.h>

/**
*
*  Name:	nthctype
*
*  Synopsis:	ret = nthctype( s, b );
*
*		int ret;	^Cv
*		JSTRING s;	
*		int b;		ʒu
*
*  Description: oCgPʂ̃^Cv𒲂ׂBł
*		ɂPȊO̒l^ƁȂPoCg
*		ǂ𒲂ׁAPoCgȂbsQjiPԂ
*		ȊOȂ΂bsQ`mjԂBɂP
*		^Ɗ̑QoCgǂ𒲂ׁAQoC
*		gȂ΂bsQjiQԂȊOȂ΂bsQh
*		kfkԂB
*		͕̐擪OƂʒu
*		oCgɂă^Cv𒲂ׂB
*
*  Returns:	k̏ꍇ͂bsQhkfkԂB
*		ł͈ʒu܂ł̊ԂɃk
*		ꍇbsQhkfkԂB
*		߂l		l	Ӗ
*		CT_ANK		0	ANKiȊOj
*		CT_KJ1		1	̑PoCg
*		CT_KJ2		2	̑QoCg
*		CT_ILGL 	-1	s
*
*
*  Name:	nthctype
*
*  Synopsis:	ret = nthctype( s, b );
*
*		int ret;	Type
*		JSTRING s;	String
*		int b;		Location (The b th byte from the head of s)
*
*  Description: Check the type of the b th byte of string s.
*		Nthctype uses chkctype which checks whether argument is the
*		first byte of KANJI code if mode is except 1. If argument is
*		the first byte of KANJI, chkctype returns CT_KJ1, otherwise
*		it returns CT_ANK. If mode is 1, chkctype checks whether
*		argument is the second byte of KANJI code. If it is the
*		second byte, chkctype returns CT_KJ2, otherwise it returns
*		CT_ILGL.
*		Nthctype checks the b th byte of string.
*
*  Returns:	If checked character is NULL character, it returns CT_ILGL.
*		If nthctype finds NULL character until the b th byte,
*		it returns CT_ILGL, too.
*		Retrun symbol	Value	Meanings
*		CT_ANK		0	ANK(Except KANJI)
*		CT_KJ1		1	The first byte of KANJI
*		CT_KJ2		2	The second byte of KANJI
*		CT_ILGL 	-1	Illegal
*
**/


_WCRTLINK int nthctype( const JCHAR *string, size_t nbyte )
{
    int ctype;

    ctype = CT_ILGL;
/*
    // nbyte is now unsigned so following code does not work	JBS 92/10/01
    while( nbyte-- >= 0 ) {
	if( *string == '\0' ) return( CT_ILGL );
	ctype = chkctype( *string++, ctype );
    }
    // following is revised to preserve the sense of the above code
    // (i.e., if nbyte==0 we go through the loop once)
*/
    do {
	if( *string == '\0' ) return( CT_ILGL );
	ctype = chkctype( *string++, ctype );
    } while( nbyte-- != 0 );
    return( ctype );
}
