/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   03-jul-96	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#include <mbstring.h>
#include <windows.h>
#include "liballoc.h"
#include "libwin32.h"
#include "osver.h"


HANDLE __lib_CreateFileW( LPCWSTR lpFileName,
			  DWORD dwDesiredAccess,
			  DWORD dwShareMode,
			  LPSECURITY_ATTRIBUTES lpSecurityAttributes,
			  DWORD dwCreationDisposition,
			  DWORD dwFlagsAndAttributes,
			  HANDLE hTemplateFile )
/*******************************************************************/
{
    if( WIN32_IS_NT ) {					/* NT */
	return( CreateFileW( lpFileName, dwDesiredAccess, dwShareMode,
			     lpSecurityAttributes, dwCreationDisposition,
			     dwFlagsAndAttributes, hTemplateFile ) );
    } else {						/* Win95 or Win32s */
	char *		mbFileName;
	HANDLE		osrc;
	size_t		cvt;
	size_t		len;

	/*** Allocate some memory ***/
	len = wcslen( lpFileName ) * MB_CUR_MAX + 1;
	mbFileName = lib_malloc( len );
	if( mbFileName == NULL ) {
	    return( INVALID_HANDLE_VALUE );
	}

	/*** Prepare to call the OS ***/
	cvt = wcstombs( mbFileName, lpFileName, len );
	if( cvt == (size_t)-1 ) {
	    lib_free( mbFileName );
	    return( INVALID_HANDLE_VALUE );
	}

	/*** Call the OS ***/
	osrc = CreateFileA( mbFileName, dwDesiredAccess, dwShareMode,
			    lpSecurityAttributes, dwCreationDisposition,
			    dwFlagsAndAttributes, hTemplateFile );
	lib_free( mbFileName );
	return( osrc );
    }
}
