/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   03-jul-96	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#include <mbstring.h>
#include <windows.h>
#include "liballoc.h"
#include "libwin32.h"
#include "osver.h"


HANDLE __lib_FindFirstFileW( LPCWSTR lpFileName,
			     LPWIN32_FIND_DATAW lpFindFileData )
/**************************************************************/
{
    if( WIN32_IS_NT ) {					/* NT */
	return( FindFirstFileW( lpFileName, lpFindFileData ) );
    } else {						/* Win95 or Win32s */
	char *		    mbFileName;
	HANDLE		    osrc;
	WIN32_FIND_DATAA    mbFindFileData;
	size_t		    cvt;
	size_t		    len;

	/*** Allocate some memory ***/
	len = wcslen( lpFileName ) * MB_CUR_MAX + 1;
	mbFileName = lib_malloc( len );
	if( mbFileName == NULL ) {
	    return( INVALID_HANDLE_VALUE );
	}

	/*** Prepare to call the OS ***/
	cvt = wcstombs( mbFileName, lpFileName, len );
	if( cvt == (size_t)-1 ) {
	    lib_free( mbFileName );
	    return( INVALID_HANDLE_VALUE );
	}

	/*** Call the OS ***/
	osrc = FindFirstFileA( mbFileName, &mbFindFileData );
	lib_free( mbFileName );
	if( osrc == INVALID_HANDLE_VALUE ) {
	    return( INVALID_HANDLE_VALUE );
	}

	/*** Convert the WIN32_FIND_DATAA info to WIN32_FIND_DATAW info ***/
	lpFindFileData->dwFileAttributes = mbFindFileData.dwFileAttributes;
	lpFindFileData->ftCreationTime = mbFindFileData.ftCreationTime;
	lpFindFileData->ftLastAccessTime = mbFindFileData.ftLastAccessTime;
	lpFindFileData->ftLastWriteTime = mbFindFileData.ftLastWriteTime;
	lpFindFileData->nFileSizeHigh = mbFindFileData.nFileSizeHigh;
	lpFindFileData->nFileSizeLow = mbFindFileData.nFileSizeLow;
	lpFindFileData->dwReserved0 = mbFindFileData.dwReserved0;
	lpFindFileData->dwReserved1 = mbFindFileData.dwReserved1;
	cvt = mbstowcs( lpFindFileData->cFileName, mbFindFileData.cFileName,
			MAX_PATH );
	if( cvt == (size_t)-1 ) {
	    return( INVALID_HANDLE_VALUE );
	}
	cvt = mbstowcs( lpFindFileData->cAlternateFileName,
			mbFindFileData.cAlternateFileName,
			MAX_PATH );
	if( cvt == (size_t)-1 ) {
	    return( INVALID_HANDLE_VALUE );
	}

	return( osrc );
    }
}
