/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   27-aug-96	M. Hildebrand	Initial implementation.
   07-jan-98	Greg Bentz	free the handle allocated by find first
*/

#include "variety.h"
#include "widechar.h"
#include <string.h>
#include <windows.h>
#include "libwin32.h"


/*
 * Apparently GetFileAttributes 3.51 sometimes gets confused when the
 * file in question is on a FAT drive.  Since FindFirstFile seems to
 * work, use it instead.
 */

#ifdef __WIDECHAR__
 DWORD __fixed_GetFileAttributesW( LPCWSTR lpFileName )
#else
 DWORD __fixed_GetFileAttributesA( LPCSTR lpFileName )
#endif
/*****************************************************/
{
    HANDLE		    handle;
    #ifdef __WIDECHAR__
	WIN32_FIND_DATAW    finddata;
    #else
	WIN32_FIND_DATAA    finddata;
    #endif

    /*** Fail if the filename contains a wildcard ***/
    #ifdef __WIDECHAR__
	if( wcschr( lpFileName, L'*' ) != NULL  ||
	    wcschr( lpFileName, L'?' ) != NULL ) {
	    return( 0xFFFFFFFF );
	}
    #else
	if( strchr( lpFileName, '*' ) != NULL  ||
	    strchr( lpFileName, '?' ) != NULL ) {
	    return( 0xFFFFFFFF );
	}
    #endif

    /*** Ok, use FindFirstFile to get the file attribute ***/
    #ifdef __WIDECHAR__
	handle = __lib_FindFirstFileW( lpFileName, &finddata );
    #else
	handle = FindFirstFileA( lpFileName, &finddata );
    #endif
    if( handle == INVALID_HANDLE_VALUE ) {
	return( 0xFFFFFFFF );
    } else {
	FindClose( handle );
    }
    return( finddata.dwFileAttributes );
}
