/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   03-jul-96	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#include <mbstring.h>
#include <windows.h>
#include "liballoc.h"
#include "libwin32.h"
#include "osver.h"


DWORD __lib_GetCurrentDirectoryW( DWORD nBufferLength, LPWSTR lpBuffer )
/**********************************************************************/
{
    if( WIN32_IS_NT ) {					/* NT */
	return( GetCurrentDirectoryW( nBufferLength, lpBuffer ) );
    } else {						/* Win95 or Win32s */
	char *		mbBuffer;
	BOOL		osrc;
	size_t		cvt;
	size_t		len;

	/*** Allocate some memory ***/
	len = _MAX_PATH*MB_CUR_MAX + 1;
	mbBuffer = lib_malloc( len );
	if( mbBuffer == NULL ) {
	    return( FALSE );
	}

	/*** Call the OS ***/
	osrc = GetCurrentDirectoryA( len, mbBuffer );
	if( osrc == 0 ) {
	    lib_free( mbBuffer );
	    return( 0 );
	}

	/*** If buffer too small, return required size ***/
	if( _mbslen( mbBuffer ) + 1  >  nBufferLength ) {
	    lib_free( mbBuffer );
	    return( osrc );
	}

	/*** Convert returned info ***/
	cvt = mbstowcs( lpBuffer, mbBuffer, nBufferLength );
	if( cvt == (size_t)-1 ) {
	    lib_free( mbBuffer );
	    return( 0 );
	}

	return( osrc );
    }
}
