/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   03-jul-96	M. Hildebrand	Initial implementation.
   27-aug-96	M. Hildebrand	Work around a bug in NT.
*/

#include "variety.h"
#include <mbstring.h>
#include <windows.h>
#include "liballoc.h"
#include "libwin32.h"
#include "osver.h"


DWORD __lib_GetFileAttributesW( LPCWSTR lpFileName )
/**************************************************/
{
    if( WIN32_IS_NT ) {					/* NT */
	return( __fixed_GetFileAttributesW( lpFileName ) );
    } else {						/* Win95 or Win32s */
	char *		mbFileName;
	DWORD		osrc;
	size_t		cvt;
	size_t		len;

	/*** Allocate some memory ***/
	len = wcslen( lpFileName ) * MB_CUR_MAX + 1;
	mbFileName = lib_malloc( len );
	if( mbFileName == NULL ) {
	    return( 0xFFFFFFFF );
	}

	/*** Prepare to call the OS ***/
	cvt = wcstombs( mbFileName, lpFileName, len );
	if( cvt == (size_t)-1 ) {
	    lib_free( mbFileName );
	    return( 0xFFFFFFFF );
	}

	/*** Call the OS ***/
	osrc = __fixed_GetFileAttributesA( mbFileName );
	lib_free( mbFileName );
	return( osrc );
    }
}
