/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   03-jul-96	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#include <mbstring.h>
#include <windows.h>
#include "liballoc.h"
#include "libwin32.h"
#include "osver.h"


BOOL __lib_MoveFileW( LPCWSTR lpExistingFileName, LPCWSTR lpNewFileName )
/***********************************************************************/
{
    if( WIN32_IS_NT ) {					/* NT */
	return( MoveFileW( lpExistingFileName, lpNewFileName ) );
    } else {						/* Win95 or Win32s */
	char *		mbExistingFileName;
	char *		mbNewFileName;
	BOOL		osrc;
	size_t		cvt;
	size_t		lenExisting;
	size_t		lenNew;

	/*** Allocate some memory ***/
	lenExisting = wcslen( lpExistingFileName ) * MB_CUR_MAX + 1;
	mbExistingFileName = lib_malloc( lenExisting );
	if( mbExistingFileName == NULL ) {
	    return( FALSE );
	}
	lenNew = wcslen( lpNewFileName ) * MB_CUR_MAX + 1;
	mbNewFileName = lib_malloc( lenNew );
	if( mbNewFileName == NULL ) {
	    lib_free( mbExistingFileName );
	    return( FALSE );
	}

	/*** Prepare to call the OS ***/
	cvt = wcstombs( mbExistingFileName, lpExistingFileName, lenExisting );
	if( cvt == (size_t)-1 ) {
	    lib_free( mbExistingFileName );
	    lib_free( mbNewFileName );
	    return( FALSE );
	}
	cvt = wcstombs( mbNewFileName, lpNewFileName, lenNew );
	if( cvt == (size_t)-1 ) {
	    lib_free( mbExistingFileName );
	    lib_free( mbNewFileName );
	    return( FALSE );
	}

	/*** Call the OS ***/
	osrc = MoveFileA( mbExistingFileName, mbNewFileName );
	lib_free( mbExistingFileName );
	lib_free( mbNewFileName );
	return( osrc );
    }
}
