/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   03-jul-96	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#include <mbstring.h>
#include <windows.h>
#include "liballoc.h"
#include "libwin32.h"
#include "osver.h"


BOOL __lib_SetFileAttributesW( LPCWSTR lpFileName, DWORD dwFileAttributes )
/*************************************************************************/
{
    if( WIN32_IS_NT ) {					/* NT */
	return( SetFileAttributesW( lpFileName, dwFileAttributes ) );
    } else {						/* Win95 or Win32s */
	char *		mbFileName;
	BOOL		osrc;
	size_t		cvt;
	size_t		len;

	/*** Allocate some memory ***/
	len = wcslen( lpFileName ) * MB_CUR_MAX + 1;
	mbFileName = lib_malloc( len );
	if( mbFileName == NULL ) {
	    return( FALSE );
	}

	/*** Prepare to call the OS ***/
	cvt = wcstombs( mbFileName, lpFileName, len );
	if( cvt == (size_t)-1 ) {
	    lib_free( mbFileName );
	    return( FALSE );
	}

	/*** Call the OS ***/
	osrc = SetFileAttributesA( mbFileName, dwFileAttributes );
	lib_free( mbFileName );
	return( osrc );
    }
}
