/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  17-mar-87	F.W.Crigger	Initial implementation
--------------------------------------------------------Version 7.0-------
  21-mar-89	F.W.Crigger	use high part of next instead of low part
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <stdio.h>
#include "randnext.h"
#include "rtdata.h"

static unsigned long *initrandnext()
    {
	_INITRANDNEXT( RETURN_ARG( unsigned long *, NULL ) );
	return( (unsigned long *)&_RWD_randnext );
    }

_WCRTLINK int rand(void)
    {
	unsigned long	  *randptr;

	randptr = initrandnext();
	if( randptr == NULL ) return( 0 );
	*randptr = *randptr * 1103515245 + 12345;
	return( (int)( (*randptr >> 16) & 0x7FFF ) );
    }


_WCRTLINK void srand( unsigned int seed )
    {
	unsigned long *randptr;

	randptr = initrandnext();
	if( randptr != NULL ) {
	    *randptr = seed;
	}
    }
