/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-10.5---------
  20-jun-95	Greg Bentz	defined for QNX
  28-jul-95	Greg Bentz	fixup check for null string
  06-dec-95	M. Hildebrand	Use new code from Quantum.
*/
#include <stdlib.h>
#include "mbqnx.h"


#define MY_MB_CUR_MAX   ( sizeof(wchar_t) * 3 / 2 )
/*  If wchar_t is long,  MY_MB_CUR_MAX will be 6.
 *  If wchar_t is short, MY_MB_CUR_MAX will be 3.
 *  It should be equal to MB_CUR_MAX anyway.
 */


int mbtowc( wchar_t *pwc, const char *s, size_t n )
{
    unsigned char	c;

    if( s != NULL ) {
        if( ( c = *s ) != '\0' ) {
            if( n > 0 ) {
                if( (signed char)( c = *s ) > 0 ) {
                    if( pwc != NULL ) *pwc = c;
                    return( 1 );
		}
                if( sizeof(wchar_t) == 2 ) {
                    /* Explicitly optimised for 16-bit wchar_t */
                    if( ( c & 0xE0 ) == 0xC0 ) {
                        unsigned char	d;
                        if( n < 2  ||  ((d=s[1]^0x80)&0xC0) != 0 ) {
                            /* return -1; */
                            goto neg1;
			}
			if( pwc != NULL ) *pwc = ((c&0x1F) << 6) | d;
                        return( 2 );
		    }
                    if( ( c & 0xF0 ) == 0xE0 ) {
                        unsigned char	d, e;
			if( n < 3				    ||
			    ( (d = *++s^0x80) & 0xC0 ) != 0	    ||
                            ( (e = *++s^0x80) & 0xC0 ) != 0 ) {
                            /* return -1; */
                            goto neg1;
			}
			if( pwc != NULL ) *pwc = ( ( ((c&0x1F) << 6)|d ) << 6)|e;
                        return( 3 );
                    }
		} else {
#if 0
    /* this section won't compile with 16-bit wchar_t */
                    /* wchar_t is 32 bit wide (this would also work with 16 bits) */
		    int		nb;
		    wchar_t	val;
                    if( n > MY_MB_CUR_MAX ) {
                        n = MY_MB_CUR_MAX;
		    }
                    nb = 0;
                    val = c;
                    while( c & 0x40 ) {
			unsigned char	b;
                        if( ( (b=*++s^0x80) & 0xC0 ) != 0 ) {
                            /* return -1; */
                            goto neg1;
			}
                        val = val << 6|b;
                        if( ++nb > n ) {
                            /* return -1; */
                            goto neg1;
			}
                        c <<= 1;
		    }
                    if( nb == 0 ) { /* Valid values for nb are 1...5 */
                        /* return -1; */
                        goto neg1;
		    }
                    if( pwc != NULL ) {
                        #define MASK( nb ) ~( ~0uL << 5 * nb + 6 )
                        static const wchar_t masks[5] = {
                            MASK( 1 ),  MASK( 2 ),
                            MASK( 3 ),  MASK( 4 ),
                            MASK( 5 )
			};
                        *pwc = val & masks[ nb - 1 ];
		    }
                    return nb+1;
#endif
                }
	    }
            neg1: return( -1 );
	}
        if( pwc != NULL ) {
            *pwc = c;
	}
    }
    return( 0 ); /* Not state dependent encoding */
}
