/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   06-mar-95	M.P.Hildebrand	Minimal support for OSs without DBCS support.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   30-may-95	Greg Bentz	variety.h and dll linkage
   15-sep-95	M. Hildebrand	Removed __mbvtop.
   04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
   08-dec-95	M. Hildebrand	Use jtoupper in code page 932.
   13-dec-95	M. Hildebrand	Use new _mbdtoupper, not jtoupper, to avoid
				cluttering user's namespace.
   13-dec-95	M. Hildebrand	Changed _mbptov to _mbsnextc.
*/

#include "variety.h"
#ifdef __NT__
    #include <windows.h>
    #include <winnls.h>
#else
    #include <ctype.h>
#endif
#include "mbchar.h"
#include <mbstring.h>



/****
***** Convert a single character to uppercase.  Equivalent to toupper().
****/

_WCRTLINK unsigned int _mbctoupper( unsigned int ch )
{
    char		mbc[MB_CUR_MAX+1];
#ifndef __NT__
    unsigned char	buff[MB_CUR_MAX+1];
#endif

    _mbvtop( ch, mbc );
    mbc[_mbclen(mbc)] = '\0';

    if( __MBCodePage == 932 ) {
	if( _ismbblead( *mbc ) ) {
	    return( _mbdtoupper( ch ) );
	}
    }
    
    #ifdef __NT__
	CharUpperBuff( (LPTSTR)mbc, 1 );
	return( _mbsnextc(mbc) );
    #else				/* OS/2 and others */
	if( !_ismbblead(*mbc) ) {
	    buff[0] = toupper( *mbc );
	    buff[1] = '\0';
	    return( _mbsnextc(buff) );
	} else {
	    return( ch );
	}
    #endif
}
