/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   02-mar-95	M.P.Hildebrand	If _mbislead() is ever called, an _mbinit(0)
   				call will be made at startup.
   03-mar-95	M.P.Hildebrand	Minimal support for OSs without DBCS support.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   11-apr-95	M. Hildebrand	Added lead byte range detection for DOS
				and Windows.
   11-apr-95	M. Hildebrand	To support EOF, changed __IsLeadTable[256] to
				__MBCSIsTable[257].  Also added __IsDBCS.
   30-may-95	Greg Bentz	variety.h and dll linkage
   09-jun-95	Greg Bentz	move __IsDBCS to mbisdbcs.c
   13-sep-95	M. Hildebrand	Added _ismbblead.
   04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
*/

#include "variety.h"
#include <mbstring.h>
#include "mbchar.h"
#include "rtinit.h"


_WCRTLINK unsigned char		__MBCSIsTable[257];



/****
***** Determine whether or not the specified byte is a lead byte.
****/

_WCRTLINK int (_ismbblead)( const unsigned int ch )
{
    return( __MBCSIsTable[ch+1] & _MB_LEAD );
}



/****
***** If this module is linked in, the startup code will call this function,
***** which will initialize the default multibyte code page.
****/

static __mbInitOnStartup( void )
{
    __mbinit( 0 );
}


AXI( __mbInitOnStartup, INIT_PRIORITY_LIBRARY )
