/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   06-mar-95	M.P.Hildebrand	Minimal support for OSs without DBCS support.
   08-mar-95	M.P.Hildebrand	Renamed from isprint.c to mbisprin.c.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   30-may-95	Greg Bentz	variety.h and dll linkage
   12-sep-95	M. Hildebrand	Added _ismbd version, which calls _ismbc one.
   15-sep-95	M. Hildebrand	Removed __mbvtop.
   12-dec-95	M. Hildebrand	Improved 932-specific handling.
   29-may-96	M. Hildebrand	Fixed handling of single-byte characters.
   11-oct-96	Greg Bentz	fixup parm that indicates byte count,
   				formerly documented as char count
*/

#include "variety.h"
#ifdef __NT__
    #include <windows.h>
    #include <winnls.h>
#else
    #include <ctype.h>
#endif
#include <mbctype.h>
#include <mbstring.h>
#include "mbchar.h"



/****
***** Determine if a multibyte character is printable.
****/

_WCRTLINK int _ismbcprint( unsigned int ch )
{
#ifdef __NT__    
    BOOL		rc;
    WORD		char_type[MB_CUR_MAX];
    char		mbc[MB_CUR_MAX+1];
    int			len;
#endif

    if( __MBCodePage == 932  &&  !SINGLE_BYTE_CHAR(ch) ) {
	return( _ismbdprint( ch ) );
    }

#ifdef __NT__    
    _mbvtop( ch, mbc );
    len = _mbclen(mbc);
    mbc[len] = '\0';
    rc = GetStringTypeA( LOCALE_USER_DEFAULT, CT_CTYPE1, mbc, len, char_type );
    if( rc == TRUE ) {
        return( ! (char_type[0] & C1_CNTRL) );
    } else {
	return( 0 );
    }
#else					/* OS/2 and others */
    if( !SINGLE_BYTE_CHAR(ch) ) {
	return( 0 );
    } else {
	return( isprint( ch&0xFF ) );
    }
#endif
}
