/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   13-sep-95	M. Hildebrand	Adapted from Lifeboat code.
   12-dec-95	M. Hildebrand	Use iskanji2 to check for trail byte.
*/

#include "variety.h"
#include <jctype.h>
#include <mbctype.h>
#include "mbchar.h"



/****
***** Determine if a given byte is a legal trail byte.
****/

_WCRTLINK int (_ismbbtrail)( unsigned int ch )
{
    if( __IsDBCS ) {
	if( __MBCodePage != 932 ) {
	    if( ch != 0 ) {
		return( 1 );	/* can't be sure, so assume it's valid */
	    } else {
		return( 0 );	/* a null byte is never a valid trail byte */
	    }
	} else {
	    return( iskanji2( ch ) );
	}
    } else {
	return( 0 );
    }
}
