/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   06-mar-95	M. Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Use mbstring.h, not mbchar.h.
   30-may-95	Greg Bentz	variety.h and dll linkage
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   27-nov-95	Greg Bentz	fixup types in function definition
   04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
   08-dec-95	M. Hildebrand	Make smarter use of mbtowc return value.
*/

#include "variety.h"
#include <errno.h>
#include <mbstring.h>
#include <wchar.h>
#include "farfunc.h"
#include "seterrno.h"


_WCRTLINK int _NEARFAR(mbrtowc,_fmbrtowc)( wchar_t _FFAR *pwc, const char _FFAR *s, size_t n, mbstate_t _FFAR *ps )
{
    int			rc;
    
    /*** Check the simple cases ***/
    if( s == NULL )  return( 0 );	    /* always in initial state */
    if( n <= 0 )  return( -2 );		    /* can't process nothing */

    /*** Check for a valid multibyte character ***/
    rc = _NEARFAR(mbtowc,_fmbtowc)( pwc, s, n );
    if( rc != -1 ) {
	return( rc );
    } else if( n < MB_CUR_MAX  &&  _ismbblead( *s ) ) {
	return( -2 );			    /* incomplete, possibly valid */
    } else {
	__set_errno( EILSEQ );		    /* encoding error */
	return( -1 );
    }
}
