/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   08-apr-96	Greg Bentz	unsigned char for subtraction
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Compare two strings.  Equivalent to strcmp().
****/

_WCRTLINK int _NEARFAR(_mbscmp,_fmbscmp)( const unsigned char _FFAR *s1, const unsigned char _FFAR *s2 )
{
    int			status;

//    if( !__IsDBCS )  return( strcmp( s1, s2 ) );

    /*** Compare characters, one by one ***/ 
    while( !_NEARFAR(_mbterm,_fmbterm)(s1) && !_NEARFAR(_mbterm,_fmbterm)(s2) ) {
	status = _NEARFAR(_mbccmp,_fmbccmp)( s1, s2 ); /* compare chars */
	if( status != 0 )  return( status );	    /* if error, return */
	s1 = _NEARFAR(_mbsinc,_fmbsinc)( s1 );/* skip over character */
	s2 = _NEARFAR(_mbsinc,_fmbsinc)( s2 );/* skip over character */
    }

    if( _NEARFAR(_mbterm,_fmbterm)(s1) && _NEARFAR(_mbterm,_fmbterm)(s2) )
	return( 0 );
    else
	return( *s1 - *s2 );
}
