/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   24-apr-95	M. Hildebrand	Use faster method.
   24-apr-95	M. Hildebrand	Return NULL if would decrement past start.
   30-may-95	Greg Bentz	variety.h and dll linkage
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Return the address of the previous character in a string.  If
***** stringStart>=ch, returns NULL.
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsdec,_fmbsdec)( const unsigned char _FFAR *str, const unsigned char _FFAR *ch )
{
    unsigned char _FFAR *p;

    if( str >= ch )  return( NULL );
//    if( !__IsDBCS )  return( (unsigned char*)ch - 1 );

    p = (unsigned char _FFAR*)ch - 1;	    /* address of previous byte */
    if( _ismbblead( *p ) )  return( p - 1 );

    while( str <= --p  &&  _ismbblead( *p ) )
	;
    return( (unsigned char _FFAR*) ch - 1 - (ch-p)%2 );
}
