/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   05-apr-95	M. Hildebrand	If the last byte of s1 is a lead byte, it
				will be overwritten by the first byte of s2.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
   06-dec-95	M. Hildebrand	MS-style behaviour.
*/

#include "variety.h"
#include <mbstring.h>
#include <string.h>
#include "farfunc.h"



/****
***** Append one string to another, up to a specified maximum number of
***** bytes.  Equivalent to strncat().
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsnbcat,_fmbsnbcat)( unsigned char _FFAR *s1, const unsigned char _FFAR *s2, size_t n )
{
    unsigned char _FFAR *   string_start = s1;
    unsigned char _FFAR *   p1;
    unsigned char _FFAR *   p2;
    size_t		    bytes;

//    if( !__IsDBCS )  return( strncat( s1, s2, n ) );

    /*** Abort if n<=0 ***/
    if( n <= 0 )  return( s1 );

    /*** Determine where to begin copying ***/
    if( *s1 != '\0' ) {
	p2 = _NEARFAR(strchr,_fstrchr)( s1, '\0' ) - 1;	/* find null byte */
	p1 = s1;				/* start at string start */
	while( *p1 != '\0' ) {			/* until last character */
	    if( p1 == p2  &&  _ismbblead(*p1) ) {/* s1 ends in a lead byte? */
		s1 = p2;			/* yes, smite last byte */
		break;
	    }
	    p1 = _NEARFAR(_mbsinc,_fmbsinc)( p1 );
	}
	if( s1 != p2 )  s1 = p2+1;		/* no, point at null byte */
    }

    /*** Copy up to 'n' characters ***/
    while( *s2 != '\0' ) {
	bytes = _NEARFAR(_mbclen,_fmbclen)( s2 ); /* char size in bytes */
	if( n >= bytes ) {
	    _NEARFAR(_mbccpy,_fmbccpy)( s1, s2 ); /* copy a character */
	    s1 = _NEARFAR(_mbsinc,_fmbsinc)( s1 );/* skip over character */
	    s2 = _NEARFAR(_mbsinc,_fmbsinc)( s2 );/* skip over character */
	    n -= bytes;				  /* update counter */
	} else {
	    while( n-- > 0 ) {			/* partial char */
		*s1++ = '\0';
	    }
	    break;
	}
    }

    /*** Pad with a terminating NULL character ***/
    *s1 = '\0';					/* append NULL char */

    return( string_start );
}
