/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   05-dec-95	M. Hildebrand	Can now compare parts of characters.
*/

#include "variety.h"
#include <mbstring.h>
#include <string.h>
#include "farfunc.h"



/****
***** Compare two strings, up to a specified maximum number of bytes.
***** Equivalent to strncmp().
****/

_WCRTLINK int _NEARFAR(_mbsnbcmp,_fmbsnbcmp)( const unsigned char _FFAR *s1, const unsigned char _FFAR *s2, size_t n )
{
    int			status = 0;
    size_t		bytes;

//    if( !__IsDBCS )  return( strncmp( s1, s2, n ) );

    /*** Compare characters, one by one ***/ 
    while( n>0 && !_NEARFAR(_mbterm,_fmbterm)(s1) && !_NEARFAR(_mbterm,_fmbterm)(s2) ) {
	if( n >= MB_CUR_MAX ) {
	    status = _NEARFAR(_mbccmp,_fmbccmp)( s1, s2 );	/* compare */
	} else {
	    status = _NEARFAR(strncmp,_fstrncmp)( s1, s2, n );	/* compare */
	}
	if( status != 0 )  break;		    /* if error, exit loop */
	bytes = _NEARFAR(_mbclen,_fmbclen)( s1 );   /* char size in bytes */
	n = n>bytes ? n-bytes : 0;		    /* update counter */
	s1 = _NEARFAR(_mbsinc,_fmbsinc)( s1 );	    /* skip over character */
	s2 = _NEARFAR(_mbsinc,_fmbsinc)( s2 );	    /* skip over character */
    }

    return( status );
}
