/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Return the number of bytes in the first 'n' multibyte characters
***** of 'string', excluding the terminating NULL.
****/

_WCRTLINK size_t _NEARFAR(_mbsnbcnt,_fmbsnbcnt)( const unsigned char _FFAR *string, size_t n )
{
    size_t		bytes = 0;

    /*** Count the number of bytes ***/
    while( !_NEARFAR(_mbterm,_fmbterm)(string) && n>0 ) { /* cook until done */
	if( _ismbblead(*string) ) {		/* is it a lead byte? */
	    if( string[1] != '\0' )		/* yes, is next char NULL? */
		bytes += _NEARFAR(_mbclen,_fmbclen)( string );	/* no, update 'bytes' */
	    else
		return( bytes );		/* yes, return */
	}
	else
	    bytes++;				/* just single byte char */
	string = _NEARFAR(_mbsinc,_fmbsinc)( string );	/* next char */
	n--;					/* update counter */
    }

    return( bytes );
}
