/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Recoded to use memcpy and memset.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
   07-feb-97	T. Schiller	Old code made false assumption that all source
				strings would be null-terminated.
*/

#include "variety.h"
#include <mbstring.h>
#include <string.h>
#include "farfunc.h"



/****
***** Copy one string over another, up to a specified number of
***** bytes.  Equivalent to strncpy().
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsnbcpy,_fmbsnbcpy)( unsigned char _FFAR *dst, const unsigned char _FFAR *src, size_t n )
{
    //int   len;
    unsigned char _FFAR *d = dst;

//    if( !__IsDBCS )  return( strncpy( dst, src, n ) );

    //len = _NEARFAR(strlen,_fstrlen)( src );
    //if( _ismbblead(*(src+n)) && n<len )  n--;	    /* only whole chars */

    while (n > 0) {
	if (*src == 0x00) {
	    break;
	}

	*d++ = *src++;
	--n;
    }

    if (*src && (d > dst)) {          // only whole chars
	if (_ismbblead(src[-1])) {
	    d[-1] = 0x00;
	}
    }

    if (n > 0) {
	_NEARFAR(memset, _fmemset)(d, 0, n);
    }

    return dst;
}
