/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   05-dec-95	M. Hildebrand	Works when n / _mbclen(mbc) is fractional.
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Set all characters in 'string' to 'ch', overwriting any partial bytes
***** at the end with ' '.  Equivalent to strnset().
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsnbset,_fmbsnbset)( unsigned char _FFAR *string, unsigned int ch, size_t n )
{
    size_t		    char_size;
    unsigned char _FFAR *   string_start;
    unsigned char	    mbc[MB_CUR_MAX+1];

//    if( !__IsDBCS && !ch&0xFF00 )  return( strnset( string, ch, n ) );
    
    /*** Set every character in the string to 'ch' ***/
    _NEARFAR(_mbvtop,_fmbvtop)( ch, mbc );  /* convert from unsigned int */
    char_size = _NEARFAR(_mbclen,_fmbclen)( mbc );    /* get char size */
    string_start = string;			      /* save string start */
    while( n >= char_size ) {
	_NEARFAR(_mbccpy,_fmbccpy)( string, mbc );    /* copy the character */
	string = _NEARFAR(_mbsinc,_fmbsinc)( string );/* point to next spot */
	n -= char_size;				      /* update counter */
    }

    /*** Pad any remaining bytes with blanks ***/
    while( n-- > 0 ) {
	*(string++) = ' ';
    }

    return( string_start );
}
