/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Recoded to use _mbsnbcnt and memcpy.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
*/

#include "variety.h"
#include <mbstring.h>
#include <string.h>
#include "farfunc.h"



/****
***** Append one string to another, up to a specified maximum number of
***** characters.  Equivalent to strncat().
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsncat,_fmbsncat)( unsigned char _FFAR *s1, const unsigned char _FFAR *s2, size_t n )
{
    unsigned char _FFAR *   string_start = s1;
    size_t		    bytes;

//    if( !__IsDBCS )  return( strncat( s1, s2, n ) );

    bytes = _NEARFAR(_mbsnbcnt,_fmbsnbcnt)( s2, n );/* bytes in src */
    s1 += _NEARFAR(strlen,_fstrlen)( s1 );	    /* point to end of string */
    _NEARFAR(memcpy,_fmemcpy)( s1, s2, bytes );	    /* copy the data */
    *(s1+bytes) = '\0';				    /* add terminating null */
    return( string_start );
}
