/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Return the number of multibytes characters from the beginning of the
***** string to byte 'n'.  The terminating NULL is not counted.
****/

_WCRTLINK size_t _NEARFAR(_mbsnccnt,_fmbsnccnt)( const unsigned char _FFAR *string, size_t n )
{
    size_t		num_chars = 0;
    size_t		char_len;

    /*** Count the number of characters ***/
    while( !_NEARFAR(_mbterm,_fmbterm)(string) && n>0 ) { /* cook until done */
	char_len = _NEARFAR(_mbclen,_fmbclen)( string );  /* get char size */
	if( n >= char_len )			/* is char too big? */
	    n -= char_len;			/* no, update 'n' */
	else
	    return( num_chars );		/* yes, return */
	string += char_len;			/* point to next char */
	num_chars++;				/* increment counter */
    }

    return( num_chars );
}
