/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Use _mbsnbcpy to do copying.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Copy one string over another, up to a specified number of
***** characters.  Equivalent to strncpy().
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsncpy,_fmbsncpy)( unsigned char _FFAR *s1, const unsigned char _FFAR *s2, size_t n )
{
//    if( !__IsDBCS )  return( strncpy( s1, s2, n ) );

    #ifdef __FARFUNC__
	_fmbsnbcpy( s1, s2, _fmbsnbcnt( s2, n ) + 1 );
    #else
	_mbsnbcpy( s1, s2, _mbsnbcnt( s2, n ) + 1 );
    #endif
    return( s1 );
}
