/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   12-apr-95	M. Hildebrand	Avoid conflict with _mbccmp macro.  Also
				will now correctly handle empty strings.
   12-apr-95	M. Hildebrand	Fix previous fix.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   08-apr-96	Greg Bentz	unsigned char for subtraction
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Compare two strings, without case sensitivity, up to a specified
***** Maximum number of characters.  Equivalent to strnicmp().
****/

_WCRTLINK int _NEARFAR(_mbsnicmp,_fmbsnicmp)( const unsigned char _FFAR *s1, const unsigned char _FFAR *s2, size_t n )
{
    int			status = 0;

//    if( !__IsDBCS )  return( strnicmp( s1, s2, n ) );

    /*** Compare characters, one by one ***/ 
    while( n>0 && !_NEARFAR(_mbterm,_fmbterm)(s1) && !_NEARFAR(_mbterm,_fmbterm)(s2) ) {
	status = _NEARFAR((_mbcicmp),(_fmbcicmp))( s1, s2 ); /* compare chars */
	if( status != 0 )  return( status );	/* if error, break from loop */
	s1 = _NEARFAR(_mbsinc,_fmbsinc)( s1 );	/* skip over character */
	s2 = _NEARFAR(_mbsinc,_fmbsinc)( s2 );	/* skip over character */
	n--;					/* update counter */
    }

    if( n > 0  &&  ( _NEARFAR(_mbterm,_fmbterm)(s1) || _NEARFAR(_mbterm,_fmbterm)(s2) ) )
	return( *s1 - *s2 );
    else
	return( status );
}
