/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   01-mar-95	M.P.Hildebrand	Minimal support for OSs without DBCS support.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   11-apr-95	M. Hildebrand	DOS and Windows now know about lead bytes.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Return a pointer to 'count' multibyte characters past 'string', or
***** NULL if 'string' is NULL.  Results are undefined if 'count' is
***** greater than or equal to the number of characters in 'string'.
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsninc,_fmbsninc)( const unsigned char _FFAR *string, size_t count )
{
    if( string != NULL ) {
//	if( !__IsDBCS )  return( (unsigned char*)string + count );
	for( ; count>0; count-- )
	    string = _NEARFAR(_mbsinc,_fmbsinc)( string );
	return( (unsigned char _FFAR*) string );
    }
    else
	return( NULL );
}
