/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   18-sep-95	M. Hildebrand	Fixed near/far bug.
   13-dec-95	M. Hildebrand	Changed _mbptov to _mbsnextc.
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Find the last occurrence of 'ch' in 'string'.  Equivalent to strrchr().
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsrchr,_fmbsrchr)( const unsigned char _FFAR *string, unsigned int ch )
{
    unsigned char _FFAR *   p = NULL;
    unsigned int	    chTemp;

//    if( !__IsDBCS && !ch&0xFF00 )  return( strrchr( string, ch ) );
    
    /*** Search for the specified character ***/
    while( !_NEARFAR(_mbterm,_fmbterm)(string) ) {
	chTemp = _NEARFAR(_mbsnextc,_fmbsnextc)( string ); /* get character */
	if( chTemp == ch )			/* is it the search char? */
	    p = (unsigned char _FFAR*) string;	/* yes, store this address */
	string = _NEARFAR(_mbsinc,_fmbsinc)( string );	/* skip character */
    }

    if( ch != 0 )				/* looking for NULL? */
        return( p );				/* no, return last address */
    else
	return( (unsigned char _FFAR*) string );/* yes, return its address */
}
