/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   13-dec-95	M. Hildebrand	Changed _mbptov to _mbsnextc.
*/

#include "variety.h"
#include <malloc.h>
#include <mbstring.h>
#include <string.h>
#include "farfunc.h"



/****
***** Reverse the order of characters in a string.  Equivalent to strrev().
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsrev,_fmbsrev)( unsigned char _FFAR *string )
{
    size_t		    bytes_left, char_bytes;
    unsigned int	    ch;
    unsigned char _FFAR *   start;
    unsigned char _FFAR *   end;
    unsigned char _FFAR *   endMarker;
    unsigned char	    mbc[MB_CUR_MAX+1];

//    if( !__IsDBCS )  return( strrev( string ) );

    /*** Handle the empty string case ***/
    if( _NEARFAR(_mbterm,_fmbterm)(string) )  return( string );

    /*** Determine the size of the string in bytes ***/
    for( end=string; !_NEARFAR(_mbterm,_fmbterm)(end); end=_NEARFAR(_mbsinc,_fmbsinc)(end) )
	;
    bytes_left = end - string;			/* determine string size */
    endMarker = end;				/* point to NULL char */
    
    /*** Move the characters from the end to the start, one by one ***/
    start = string;				/* get string start */
    while( bytes_left > 0 ) {
        end = _NEARFAR(_mbsdec,_fmbsdec)( string, endMarker ); /* back up */
        ch = _NEARFAR(_mbsnextc,_fmbsnextc)( end ); /* get the character */
        _NEARFAR(_mbvtop,_fmbvtop)( ch, mbc );	 /* convert from unsigned int */
        char_bytes = _NEARFAR(_mbclen,_fmbclen)( mbc ); /* get char size in bytes */
        bytes_left -= char_bytes;		 /* update remaining bytes */
        _NEARFAR(memmove,_fmemmove)( start+char_bytes, start, bytes_left ); /* shift chars */
	_NEARFAR(_mbccpy,_fmbccpy)( start, mbc );/* copy the character */
        start += char_bytes;			 /* update start pointer */
    }

    return( string );
}
