/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   06-mar-95	M. Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Use mbstring.h, not mbchar.h.
   30-may-95	Greg Bentz	variety.h and dll linkage
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   08-dec-95	M. Hildebrand	Corrected handling of src and dst.
   12-jun-96	M. Hildebrand	Made src a far pointer to a far pointer
				for _fmbsrtowcs.
*/

#include "variety.h"
#include <mbstring.h>
#include <wchar.h>
#include "farfunc.h"


_WCRTLINK size_t _NEARFAR(mbsrtowcs,_fmbsrtowcs)( wchar_t _FFAR *dst, const char _FFAR * _FFAR *src, size_t len, mbstate_t _FFAR *ps )
{
    wchar_t		wc;
    int			charsConverted = 0;
    const char _FFAR *	mbcPtr = *src;
    int			rc;

    /*** Process the characters, one by one ***/
    if( dst != NULL ) {
	while( len-- > 0 ) {
	    rc = _NEARFAR(mbrtowc,_fmbrtowc)( &wc, mbcPtr, MB_CUR_MAX, ps );
	    if( rc > 0 ) {
		*dst++ = wc;
		mbcPtr += rc;
		charsConverted++;
	    } else if( rc == 0 ) {
		break;
	    } else {
		return( (size_t)-1 );
	    }
	}
	if( rc == 0 ) {
	    *src = NULL;
	} else {
	    *src = mbcPtr;
	}
    } else {
	for( ;; ) {
	    rc = _NEARFAR(mbrtowc,_fmbrtowc)( &wc, mbcPtr, MB_CUR_MAX, ps );
	    if( rc > 0 ) {
		mbcPtr += rc;
		charsConverted++;
	    } else if( rc == 0 ) {
		break;
	    } else {
		return( (size_t)-1 );
	    }
	}
    }
    return( charsConverted );
}
