/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
   13-dec-95	M. Hildebrand	Changed _mbptov to _mbsnextc.
*/

#include "variety.h"
#include <mbstring.h>
#include <string.h>
#include "farfunc.h"



/****
***** Return a pointer to the first character in 'string' that is not
***** present in 'charset'.  Returns NULL if no such character exists.
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsspnp,_fmbsspnp)( const unsigned char _FFAR *string, const unsigned char _FFAR *charset )
{
//    if( !__IsDBCS )  return( (unsigned char*)string + strspn( string, charset ) );
    
    while( !_NEARFAR(_mbterm,_fmbterm)(string) ) {
	#ifdef __FARFUNC__
	    if( _fmbschr(charset,_fmbsnextc(string)) == NULL )
		return( (unsigned char _FFAR*) string );
	#else
	    if( _mbschr(charset,_mbsnextc(string)) == NULL )
		return( (unsigned char _FFAR*) string );
	#endif
	string = _NEARFAR(_mbsinc,_fmbsinc)( string );
    }

    return( NULL );
}
