/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   11-sep-95	M. Hildebrand	Conditional far/near compilation.
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Find the first occurrence of 'substring' in 'string'.  If 'substring'
***** has zero length, return 'string'.  Equivalent to strstr().
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbsstr,_fmbsstr)( const unsigned char _FFAR *string, const unsigned char _FFAR *substring )
{
    size_t		length;

//    if( !__IsDBCS )  return( strstr( string, substring ) );

    length = _NEARFAR(_mbslen,_fmbslen)( substring ); /* substring length */
    
    for( ; !_NEARFAR(_mbterm,_fmbterm)(string); string=_NEARFAR(_mbsinc,_fmbsinc)(string) ) {
	if( _NEARFAR(_mbsncmp,_fmbsncmp)(string,substring,length) == 0 )
	    return( (unsigned char _FFAR*) string );
    }

    return( NULL );
}
