/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Changed all char * to unsigned char *, and
				included mbstring.h.
   17-apr-95	M. Hildebrand	If !__IsDBCS, do SBCS behaviour for speed.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   12-sep-95	M. Hildebrand	Conditional far/near compilation.
   26-sep-95	M. Hildebrand	Use _RWD_nextmbtok and _RWD_nextmbftok,
				not _RWD_nexttok and _RWD_nextftok.
   13-dec-95	M. Hildebrand	Changed _mbptov to _mbsnextc.
   26-jun-96	M. Hildebrand	Was mishandling last token.
*/

#include "variety.h"
#include <mbstring.h>
#include <stdio.h>
#include "farfunc.h"
#include "rtdata.h"
#ifdef __FARFUNC__
    #include "nextftok.h"
#else
    #include "nexttok.h"
#endif



/****
***** Tokenize a string.  Equivalent to strtok().
****/

_WCRTLINK unsigned char _FFAR *_NEARFAR(_mbstok,_fmbstok)( unsigned char _FFAR *str, const unsigned char _FFAR *delim )
{
    unsigned char _FFAR *   string_start;
    int			    count;
    int			    char_len;

//    if( !__IsDBCS )  return( strtok( str, delim ) );
    
    /*** Initialize ***/
    #ifdef __FARFUNC__
	_INITNEXTMBFTOK
    #else
	_INITNEXTMBTOK
    #endif
    if( str == NULL ) {
	str = _NEARFAR(_RWD_nextmbtok,_RWD_nextmbftok);
	if( str == NULL )
	    return( NULL );
    }

    /*** Skip characters until we reach one not in 'delim' ***/
    #ifdef __FARFUNC__
	while( !_fmbterm(str) && _fmbschr(delim,_fmbsnextc(str))!=NULL )
	    str = _fmbsinc( str );
    #else
	while( !_mbterm(str) && _mbschr(delim,_mbsnextc(str))!=NULL )
	    str = _mbsinc( str );
    #endif
    if( _NEARFAR(_mbterm,_fmbterm)(str) )  return( NULL );
    string_start = str;

    /*** Skip characters until we reach one in 'delim' ***/
    #ifdef __FARFUNC__
	while( !_fmbterm(str) && _fmbschr(delim,_fmbsnextc(str))==NULL )
	    str = _fmbsinc( str );
    #else
	while( !_mbterm(str) && _mbschr(delim,_mbsnextc(str))==NULL )
	    str = _mbsinc( str );
    #endif

    /*** Handle the next token ***/
    if( !_NEARFAR(_mbterm,_fmbterm)(str) ) {
	char_len = _NEARFAR(_mbclen,_fmbclen)( str ); /* get char length */
	for( count=0; count<char_len; count++ )
	    str[count] = '\0';			/* replace delim with NULL */
	str += char_len;			/* start of next token */
	_NEARFAR(_RWD_nextmbtok,_RWD_nextmbftok) = str; /* save next start */
	return( string_start );			/* return next token start */
    } else {
	_NEARFAR(_RWD_nextmbtok,_RWD_nextmbftok) = NULL;/* no more tokens */
	return( string_start );			/* return same token */
    }
}
