/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   01-mar-95	M.P.Hildebrand	Minimal support for OSs without DBCS support.
   15-mar-95	M. Hildebrand	Included mbstring.h.
   15-mar-95	M. Hildebrand	Fixed a bug which caused conversion to be
				done incorrectly at times under NT.
   11-apr-95	M. Hildebrand	DOS and Windows now know about lead bytes.
   30-may-95	Greg Bentz	variety.h and dll linkage
   08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
   12-sep-95	M. Hildebrand	Conditional far/near compilation.
   04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
  07-dec-95	M. Hildebrand	Rewrote to call mbtowc.
*/

#include "variety.h"
#include <mbstring.h>
#include "farfunc.h"



/****
***** Convert a multibyte character string to a wide character string.
***** Returns the number of wide characters written (excluding NULL if
***** one was encountered) on success, or -1 on error.
****/

_WCRTLINK size_t _NEARFAR(mbstowcs,_fmbstowcs)( wchar_t _FFAR *pwcs, const char _FFAR *s, size_t n )
{
    int			numChars = 0;
    int			rc;

    if( pwcs != NULL ) {		/* convert the string */
	while( n > 0 ) {
	    if( *s != '\0' ) {
		rc = _NEARFAR(mbtowc,_fmbtowc)( pwcs, s, MB_CUR_MAX );
		if( rc == -1 )  return( -1 );
		n--;
		s = _NEARFAR(_mbsinc,_fmbsinc)( s );
		pwcs++;
		numChars++;
	    } else {
		*pwcs = L'\0';
		break;
	    }
	}
    } else {				/* get required size */
	for( ;; ) {
	    if( *s != '\0' ) {
		rc = _NEARFAR(mbtowc,_fmbtowc)( NULL, s, MB_CUR_MAX );
		if( rc == -1 )  return( -1 );
		s = _NEARFAR(_mbsinc,_fmbsinc)( s );
		numChars++;
	    } else {
		break;
	    }
	}
    }
    return( numChars );
}
