/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-11.0---------
  15-feb-95	M.P.Hildebrand	Initial implementation.
  01-mar-95	M.P.Hildebrand	Minimal support for OSs without DBCS support.
  15-mar-95	M. Hildebrand	Included mbstring.h.
  11-apr-95	M. Hildebrand	DOS and Windows now know about lead bytes.
  30-may-95	Greg Bentz	variety.h and dll linkage
  08-sep-95	M. Hildebrand	Handle lead byte followed by null byte.
  12-sep-95	M. Hildebrand	Conditional far/near compilation.
  27-nov-95	M. Hildebrand	Return 0 if ch==NULL or if *ch=='\0'.
  27-nov-95	Greg Bentz	fixup types in function definition
  04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
  07-dec-95	M. Hildebrand	Fixed handling of some special cases.
*/

#include "variety.h"
#ifdef __NT__
    #include <stdlib.h>
    #include <windows.h>
    #include <winnls.h>
    #include "mbchar.h"
#endif
#include <mbstring.h>
#include "farfunc.h"



/****
***** Convert a multibyte character to a wide character.
****/

_WCRTLINK int _NEARFAR(mbtowc,_fmbtowc)( wchar_t _FFAR *pwc, const char _FFAR *ch, size_t n )
{
#ifdef __NT__
    int			rc;
    int			len;
    wchar_t		wch;
#endif

    /*** Catch special cases ***/
    if( ch == NULL )  return( 0 );
    if( n <= 0 )  return( -1 );
    if( *ch == '\0' ) {
	if( pwc != NULL )  *pwc = L'\0';
	return( 0 );
    }
    if( _ismbblead( ch[0] )  &&  ch[1] == '\0' )  return( -1 ); /* invalid */

    /*** Convert the character ***/
    #ifdef __NT__
	len = _NEARFAR(_mbclen,_fmbclen)( ch );
	rc = MultiByteToWideChar( __MBCodePage, MB_ERR_INVALID_CHARS,
				  (LPCSTR)ch, min(n,len), (LPWSTR)&wch, 1 );
	if( rc != 0 ) {
	    if( pwc != NULL )  *pwc = wch;
	    return( len );			/* return mbchar size */
	} else {
	    return( -1 );			/* cannot convert */
	}
    #else
	if( _ismbblead(*ch) && n>=2 ) { 	/* lead byte present? */
	    if( pwc != NULL ) {
		*pwc = (((wchar_t)ch[0])<<8) |	/* convert to lead:trail */
			(wchar_t)ch[1];
	    }
 	    return( 2 );			/* return char size */
	} else if( !_ismbblead(*ch) ) {
	    if( pwc != NULL ) {
		*pwc = (wchar_t)ch[0];		/* convert to 00:byte */
	    }
	    return( 1 );			/* return char size */
	} else {
	    return( -1 );			/* n==1, but char 2 bytes */
	}
    #endif
}
