/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-10.5---------
  20-jun-95	Greg Bentz	defined for QNX
  06-dec-95	M. Hildebrand	Use new code from Quantum.
*/
#include <stdlib.h>
#include "mbqnx.h"


#define MY_MB_CUR_MAX   ( sizeof(wchar_t) * 3 / 2 )
/*  If wchar_t is long,  MY_MB_CUR_MAX will be 6.
 *  If wchar_t is short, MY_MB_CUR_MAX will be 3.
 *  It should be equal to MB_CUR_MAX anyway.
 */


int wctomb( char *s, wchar_t wc )
{
    if( s != NULL ) {
        if( wc < 0x80 ) {
            *s = wc;
            return( 1 );
	} else {
            if( sizeof(wchar_t) == 2 ) {
                /* Explicitly optimised for 16-bit wchar_t */
                if( wc < 0x800 ) {
                    s[0] = 0xC0 | wc >> 6;
                    s[1] = 0x80 | wc & 0x3F;
                    return( 2 );
		} else {
                    s[2] = 0x80 | wc & 0x3F;
                    s[1] = 0x80 | ( wc >>= 6 ) & 0x3F;
                    s[0] = 0xE0 | wc >> 6;
                    return( 3 );
		}
            } else {
                /* wchar_t is 32 bit wide (this would also work with 16 bits) */
                char *	dst = s;
		int	rv;
                {   /* The block seems to help the compiler optimise */
                    wchar_t mask = ~0ul << 5+6;
                    while( mask & wc ) {
                        mask <<= 5;
                        ++dst;
                    }
		}
                if( ( rv = ++dst - s ) < MY_MB_CUR_MAX ) {
                    wchar_t	mask;
                    do {
                        *dst = 0x80 | ( wc & 0x3F );
                        wc >>= 6;
		    } while( --dst != s );
                    mask = 0x7F >> ++rv;
                    *dst = wc & mask | ( ~mask << 1 );
                    return( rv );
		}
                return( -1 );
	    }
	}
    } else {
	return( 0 ); /* Not state dependent encoding */
    }
}   
