/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   06-mar-95	M. Hildebrand	Initial implementation.
   15-mar-95	M. Hildebrand	Use mbstring.h, not mbchar.h.
   30-may-95	Greg Bentz	variety.h and dll linkage
   12-sep-95	M. Hildebrand	Conditional far/near compilation.
   08-dec-95	M. Hildebrand	Corrected handling of src and dst.
   12-jun-96	M. Hildebrand	Made src a far pointer to a far pointer
				for _fwcsrtombs.
*/

#include "variety.h"
#include <mbstring.h>
#include <wchar.h>
#include "farfunc.h"


_WCRTLINK size_t _NEARFAR(wcsrtombs,_fwcsrtombs)( char _FFAR *dst, const wchar_t _FFAR * _FFAR *src, size_t len, mbstate_t _FFAR *ps )
{
    int			    bytesConverted = 0;
    const wchar_t _FFAR *   wcPtr = *src;
    char		    mbc[MB_CUR_MAX+1];
    int			    rc;

    /*** Process the characters, one by one ***/
    if( dst != NULL ) {
	while( len > 0 ) {
	    rc = _NEARFAR(wcrtomb,_fwcrtomb)( mbc, *wcPtr, ps );
	    if( rc > 0 ) {
		if( *mbc != '\0' ) {
		    if( len >= rc ) {
			_NEARFAR(_mbccpy,_fmbccpy)( dst, mbc );
			dst = _NEARFAR(_mbsinc,_fmbsinc)( dst );
			wcPtr++;
			bytesConverted += rc;
			len -= rc;
		    } else {
			len = 0;
		    }
		} else {
		    break;
		}
	    } else {
		return( (size_t)-1 );
	    }
	}
	if( *dst == '\0' ) {
	    *src = NULL;
	} else {
	    *src = wcPtr;
	}
    } else {
	for( ;; ) {
	    rc = _NEARFAR(wcrtomb,_fwcrtomb)( mbc, *wcPtr, ps );
	    if( rc > 0 ) {
		if( *mbc != '\0' ) {
		    wcPtr++;
		    bytesConverted += rc;
		} else {
		    break;
		}
	    } else {
		return( (size_t)-1 );
	    }
	}
    }
    return( bytesConverted );
}
