/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-11.0---------
  15-feb-95	M.P.Hildebrand	Initial implementation.
  01-mar-95	M.P.Hildebrand	Minimal support for OSs without DBCS support.
  15-mar-95	M. Hildebrand	Included mbstring.h.
  30-may-95	Greg Bentz	variety.h and dll linkage
  12-sep-95	M. Hildebrand	Conditional far/near compilation.
  27-nov-95	Greg Bentz	fixup types in function definition
  07-dec-95	M. Hildebrand	Rewrote to call wctomb.
*/

#include "variety.h"
#include <mbstring.h>
#include <string.h>
#include "farfunc.h"



/****
***** Convert a wide character string to a multibyte character string.
****/

_WCRTLINK size_t _NEARFAR(wcstombs,_fwcstombs)( char _FFAR *s, const wchar_t _FFAR *pwcs, size_t n )
{
    char		mbc[MB_CUR_MAX+1];
    size_t		numBytes = 0;
    size_t		rc;

    if( s != NULL ) {
	while( n > 0 ) {		/* convert the string */
	    if( *pwcs != L'\0' ) {
		rc = wctomb( mbc, *pwcs );
		if( rc == -1 )  return( -1 );
		if( rc > n )  break;
		_NEARFAR(memcpy,_fmemcpy)( s, mbc, rc );
		s += rc;
		n -= rc;
		numBytes += rc;
		pwcs++;
	    } else {
		*s = '\0';
		break;
	    }
	}
    } else {				/* get required size */
	for( ;; ) {
	    if( *pwcs != L'\0' ) {
		rc = wctomb( mbc, *pwcs );
		if( rc == -1 )  return( -1 );
		numBytes += rc;
		pwcs++;
	    } else {
		break;
	    }
	}
    }
    return( numBytes );
}
