/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-11.0---------
  15-feb-95	M.P.Hildebrand	Initial implementation.
  01-mar-95	M.P.Hildebrand	Minimal support for OSs without DBCS support.
  15-mar-95	M. Hildebrand	Included mbstring.h.
  15-mar-95	M. Hildebrand	Fixed a bug which caused conversion to be
				done incorrectly at times under NT.
  30-may-95	Greg Bentz	variety.h and dll linkage
  12-sep-95	M. Hildebrand	Conditional far/near compilation.
  13-mar-96	Greg Bentz	tweak typing inconsistencies
*/

#include "variety.h"
#ifdef __NT__
    #include <windows.h>
    #include <winnls.h>
    #include "mbchar.h"
#endif
#include <mbstring.h>
#include "farfunc.h"



/****
***** Convert a wide character to a multibyte character.
****/

_WCRTLINK int _NEARFAR(wctomb,_fwctomb)( char _FFAR *ch, wchar_t wchar )
{
#ifdef __NT__
    int			rc;
#endif

    /*** Catch special cases ***/
    if( ch == 0 )  return( 0 );

    /*** Convert the character ***/
    #ifdef __NT__
	rc = WideCharToMultiByte( __MBCodePage, WC_COMPOSITECHECK,
				  (LPCWSTR)&wchar, 1, (LPSTR)ch,
				  MB_CUR_MAX, NULL, NULL );
        if( rc != FALSE )
	    return( rc );
	else
	    return( -1 );
    #else				/* OS/2 and others */
	if( wchar & 0xFF00 ) {
	    ch[0] = (wchar&0xFF00) >> 8;	/* store lead byte */
	    ch[1] = wchar & 0x00FF;		/* store trail byte */
	    return( 2 );			/* return size in bytes */
	} else {
	    ch[0] = wchar & 0x00FF;		/* store char byte */
	    return( 1 );			/* return size in bytes */
	}
    #endif
}
