/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-11.0---------
  13-sep-95	M. Hildebrand	Adapted from Lifeboat code.
  27-nov-95	Greg Bentz	fixup types in function definition
   04-dec-95	M. Hildebrand	Changed _mbislead to _ismbblead.
*/

#include "variety.h"
#include <mbstring.h>
#include "string.h"
#include "farfunc.h"



/****
***** Count the characters in a string.  Differs from _mbslen in that a lead
***** byte followed by a null byte is counted as a valid character.
****/

_WCRTLINK size_t _NEARFAR(__mbslen,__fmbslen)( unsigned char const _FFAR *s )
{
    size_t		count = 0;

    if( __IsDBCS ) {
	while( *s != '\0' ) {
	    s += _ismbblead(*s) ? 2 : 1;/* point to next char */
	    count++;			/* update count */
	}
	return( count );
    } else {
	return( _NEARFAR(strlen,_fstrlen)( s ) );
    }
}
