/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   15-feb-95	M.P.Hildebrand	Initial implementation.
   03-mar-95	M.P.Hildebrand	Fixed _mbinit prototype.
   14-mar-95	M. Hildebrand	Removed prototypes, which are now in
				mbstring.h.
   11-apr-95	M. Hildebrand	Added lead byte range detection for DOS
				and Windows.
   11-apr-95	M. Hildebrand	To support EOF, changed __IsLeadTable[256] to
				__MBCSIsTable[257] and moved its declaration
				to MBSTRING.H.  Also added __IsDBCS.
   13-sep-95	M. Hildebrand	Defined __MBCodePage for DOS and Windows.
   29-may-96	M. Hildebrand	Added SINGLE_BYTE_CHAR macro.
*/

#if !defined(MBCHARdotH)
#define MBCHARdotH


/* Prototype for initialization function */
extern int	__mbinit( int codepage );

#define _MBINIT_CP_ANSI		(-1)
#define _MBINIT_CP_OEM		(-2)
#define _MBINIT_CP_SBCS		(-3)
#define _MBINIT_CP_932		(-4)


/* Current code page */
#if !defined(__QNX__)
    extern unsigned int	__MBCodePage;
    #define _MB_CODE_PAGE_DEFINED
#endif


/* See if a packed DBCS char has no lead byte, i.e. is a skinny char */
#define SINGLE_BYTE_CHAR(__c)	( !( (__c)&0xFF00 ) )


#endif
