/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  31-dec-86     F.W.Crigger     Initial implementation
---------------------------------------------------------Version 6.0-------
  12-apr-88     F.W.Crigger     use _inline_ support
  09-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  22-apr-95	Greg Bentz	alpha support
  02-mar-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  30-may-95	Greg Bentz	variety.h and dll linkage
  15-sep-95	Greg Bentz	ppc support
  13-mar-96	Greg Bentz	tweak typing inconsistencies
  30-may-96	M. Hildebrand	Removed wide character version.
*/
#include "variety.h"
#include <string.h>
#include "xstring.h"
#undef  memcmp

_WCRTLINK int memcmp( const void *in_s1, const void *in_s2, size_t len )
    {
#if defined(__INLINE_FUNCTIONS__) && !defined(__WIDECHAR__) && defined(_M_IX86)
        return( _inline_memcmp( in_s1, in_s2, len ) );
#else
	const char *s1 = (const char *)in_s1;
	const char *s2 = (const char *)in_s2;
        for( ; len; --len )  {
            if( *s1 != *s2 ) return( *s1 - *s2 );
            ++s1;
            ++s2;
        }
        return( 0 );    /* both operands are equal */
#endif
    }
