/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  02-dec-87     F.W.Crigger     Initial implementation
  10-Jun-92	D. Wellstood	Unicode support
  27-feb-94	Greg Bentz	add _memicmp
--------------------------------------------------------Version-11.0---------
  02-mar-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  30-may-95	Greg Bentz	variety.h and dll linkage
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  13-mar-96	Greg Bentz	tweak typing inconsistencies
  30-may-96	M. Hildebrand	Removed wide character version.
*/
#include "variety.h"
#include <string.h>
#include <ctype.h>

_WCRTLINK int memicmp( const void *in_s1, const void *in_s2, size_t len )
    {
	const unsigned char *	s1 = (const unsigned char *)in_s1;
	const unsigned char *	s2 = (const unsigned char *)in_s2;
	unsigned char		c1;
	unsigned char		c2;

        for( ; len; --len )  {
            c1 = *s1;
	    c2 = *s2;
	    if( c1 >= 'A'  &&  c1 <= 'Z' )  c1 += 'a' - 'A';
	    if( c2 >= 'A'  &&  c2 <= 'Z' )  c2 += 'a' - 'A';
            if( c1 != c2 ) return( c1 - c2 );
            ++s1;
            ++s2;
        }
        return( 0 );    /* both operands are equal */
    }
