/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   21-may-96	M. Hildebrand	Initial implementation.
*/

#include <string.h>
#include "riscstr.h"

        
void *memmove( void *dest, const void *src, size_t n )
/****************************************************/
{
    const char *	from = src;
    char *		to = dest;

    if( from == to )  return( dest );

    if( ( to<from && to+n<from )  ||  ( from<to && from+n<to ) ) {
	memcpy( to, from, n );		/* no overlap between regions */
    } else if( from < to  &&  from + n > to ) {
	to += n;
	from += n;
	while( n != 0 ) {		/* tread softly */
	    *--to = *--from;
	    n--;
	}
    } else {
	memcpy( to, from, n );		/* permissible overlap */
    }
    return( to );
}
