/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   06-may-96    M. Hildebrand	Adapted from strset code.
*/

#include <string.h>
#include "riscstr.h"


void *memset( void *buf, int c, size_t n )
/****************************************/
{
#if USE_INT64
    RISC_DATA_LOCALREF;
#endif
    char *		bufStart = buf;
    char *		dest = buf;
    UINT *		dw;
    UINT		dword, cdword;
    int			offset = OFFSET(dest);

    /*** Set any bytes up to a 4-byte alignment ***/
    while( offset > 0 ) {
	if( n >= 1 ) {
	    *dest++ = c;
	    n--;
	} else {
	    return( bufStart );
	}
	offset = (offset + 1) & (sizeof(UINT) - 1);
    }

    /*** Initialize locals ***/
    c &= BYTE1;
    cdword = (c<<24) | (c<<16) | (c<<8) | c;
    dw = (UINT*)dest;				/* already rounded */

    /*** Write in aligned 4-byte groups ***/
    for( ;; ) {
	if( n < BYTES_PER_WORD )  break;
	*dw++ = cdword;
	n -= BYTES_PER_WORD;

	if( n < BYTES_PER_WORD )  break;
	*dw++ = cdword;
	n -= BYTES_PER_WORD;
    }

    /*** Write in last dword ***/
    if( n == 1 ) {				/* copy 1 byte */
	dword = *dw & ~(BYTE1);
	cdword &= (BYTE1);
	*dw = dword | cdword;
    } else if( n == 2 ) {			/* copy 2 bytes */
	dword = *dw & ~(BYTE1|BYTE2);
	cdword &= (BYTE1|BYTE2);
	*dw = dword | cdword;
    } else if( n == 3 ) {			/* copy 3 bytes */
	dword = *dw & ~(BYTE1|BYTE2|BYTE3);
	cdword &= (BYTE1|BYTE2|BYTE3);
	*dw = dword | cdword;
    }

    return( bufStart );
}
