/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   23-may-96	M. Hildebrand	Initial implementation.
*/

#include <stdlib.h>
#include "riscstr.h"

        
void swab( char *src, char *dest, int n )
/***************************************/
{
    UINT *		dwSrc = ROUND(src);
    UINT *		dwDest = ROUND(dest);
    int			shlSrc, shrSrc, shlDest, shrDest;
    UINT		dwordSrc, tmpdwordSrc, dwordDest, tmpdwordDest;
    int			leftovers;
    char		ch;

    /*** Initialize locals ***/
    n = n / 2;				/* number of pairs to process */
    if( n <= 0 )  return;
    shrSrc = OFFSET(src) * 8;		/* shift right = offset * 8 */
    shrDest = OFFSET(dest) * 8;
    shlSrc = INT_SIZE - shrSrc;		/* shift left = 32 - shift right */
    shlDest = INT_SIZE - shrDest;
    
    if( shrSrc != 0 ) {
	dwordSrc = *dwSrc++;
    }
    if( shrDest != 0 ) {
	dwordDest = *dwDest;
    }

    /*** Swap in 4-byte groups ***/
    for( leftovers=0; n>=BYTES_PER_WORD/2; n-=BYTES_PER_WORD/2 ) {
	/*** Extract the next few characters from the source string ***/
        if( shrSrc == 0 ) {
            tmpdwordSrc = *dwSrc++;
        } else {
            tmpdwordSrc = dwordSrc >> shrSrc;
            dwordSrc = *dwSrc++;
            tmpdwordSrc |= (dwordSrc << shlSrc);
        }
	tmpdwordSrc = SWAP_BYTES(tmpdwordSrc);

	/*** Write out the bytes, swapped ***/
	if( shrDest == 0 ) {
	    *dwDest++ = tmpdwordSrc;
	} else {
	    tmpdwordDest = (dwordDest<<shlDest) >> shlDest;
	    dwordDest = tmpdwordSrc;
	    tmpdwordDest |= dwordDest << shrDest;
	    *dwDest++ = tmpdwordDest;
	    dwordDest >>= shlDest;
	    leftovers = 1;
	}

	src += CHARS_PER_WORD;
	dest += CHARS_PER_WORD;
    }

    /*** Handle any leftovers from the previous loop ***/
    if( leftovers ) {
	tmpdwordDest = ((*dwDest)>>shrDest) << shrDest;
	tmpdwordDest |= dwordDest;
	*dwDest = tmpdwordDest;
    }

    /*** Handle any trailing bytes ***/
    while( n > 0 ) {
	ch = src[0];
	dest[0] = src[1];
	dest[1] = ch;
	src += 2;
	dest += 2;
	n--;
    }
}
