/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   16-jul-96	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#define _DEBUG			/* so prototypes are included */
#include <crtdbg.h>
#include <stddef.h>
#ifdef __NT__
    #include <windows.h>
#else
    #ifdef __QNX__
	#include <unistd.h>
    #else
	#include <io.h>
    #endif
#endif
#ifdef __OS2__
    #define INCL_WIN
    #include <os2.h>
#endif
#include "dbgdata.h"
#include "rtinit.h"


int			__DbgReportModes[3] = {
    _CRTDBG_MODE_FILE,		/* _CRT_WARN */
    _CRTDBG_MODE_WNDW,		/* _CRT_ERROR */
    _CRTDBG_MODE_WNDW		/* _CRT_ASSERT */
};

_HFILE			__DbgReportFiles[3] = {
    _CRTDBG_INVALID_HFILE,	/* _CRT_WARN */
    _CRTDBG_INVALID_HFILE,	/* _CRT_ERROR */
    _CRTDBG_INVALID_HFILE	/* _CRT_ASSERT */
};

_CRT_REPORT_HOOK	__DbgReportHook = NULL;



#if defined(__NT__) || defined(__OS2__)

static int is_windowed_app( void )
/********************************/
{
    #ifdef __NT__
	return( GetActiveWindow() != NULL );
    #elif defined(__OS2__)
	int		retval = 0;
	int		rc;
	HMQ		hMessageQueue = 0;
	HAB		AnchorBlock = 0;

	AnchorBlock = WinInitialize( 0 );
	if( AnchorBlock != 0 ) {
	    hMessageQueue = WinCreateMsgQueue( AnchorBlock, 0 );
	    if( hMessageQueue == 0 ) {
		rc = WinGetLastError( AnchorBlock );
		if( (rc & 0xFFFF) == PMERR_MSG_QUEUE_ALREADY_EXISTS ) {
		    retval = 1;
		}
	    }
	}
	if( hMessageQueue != 0 ) {
	    WinDestroyMsgQueue( hMessageQueue );
	}
	if( AnchorBlock != 0 ) {
	    WinTerminate( AnchorBlock );
	}
	return( retval );
    #endif
}

#endif	/* defined(__NT__) || defined(__OS2__) */


static void do_it( void )
/***********************/
{
    #ifdef __NT__
	if( is_windowed_app() ) {
	    __DbgReportModes[_CRT_WARN] = _CRTDBG_MODE_DEBUG;
	} else {
	    __DbgReportFiles[_CRT_WARN] = GetStdHandle( STD_ERROR_HANDLE );
	}
    #elif defined(__WINDOWS__)
	__DbgReportModes[_CRT_WARN] = _CRTDBG_MODE_DEBUG;
    #elif defined(__OS2__)
	if( is_windowed_app() ) {
	    __DbgReportModes[_CRT_WARN] = _CRTDBG_MODE_DEBUG;
	} else {
	    __DbgReportFiles[_CRT_WARN] = STDERR_FILENO;
	}
    #else
	__DbgReportFiles[_CRT_WARN] = STDERR_FILENO;
    #endif
}

AXI( do_it, INIT_PRIORITY_LIBRARY )
