/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   15-jul-96	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#define _DEBUG			/* so prototypes are included */
#include <crtdbg.h>
#ifdef __NT__
    #include <windows.h>
#else
    #ifdef __QNX__
	#include <unistd.h>
    #else
	#include <io.h>
    #endif
#endif
#include "dbgdata.h"


_WCRTLINK _HFILE _CrtSetReportFile( int reporttype, _HFILE reportfile )
/*********************************************************************/
{
    _HFILE		prevfile;
    int			reportmode;

    /*** Ensure reporttype is valid ***/
    if( reporttype < _CRT_WARN  ||  reporttype > _CRT_ASSERT ) {
	return( _CRTDBG_HFILE_ERROR );
    }

    /*** Ok, now do something useful ***/
    prevfile = __DbgReportFiles[reporttype];
    if( reportfile != _CRTDBG_REPORT_FILE ) {
	if( reportfile == _CRTDBG_FILE_STDOUT ) {
	    #ifdef __NT__
		__DbgReportFiles[reporttype] = GetStdHandle( STD_OUTPUT_HANDLE );
	    #else
		__DbgReportFiles[reporttype] = STDOUT_FILENO;
	    #endif
	} else if( reportfile == _CRTDBG_FILE_STDERR ) {
	    #ifdef __NT__
		__DbgReportFiles[reporttype] = GetStdHandle( STD_ERROR_HANDLE );
	    #else
		__DbgReportFiles[reporttype] = STDERR_FILENO;
	    #endif
	} else {
	    __DbgReportFiles[reporttype] = reportfile;
	}

	reportmode = _CrtSetReportMode( reporttype, _CRTDBG_REPORT_MODE );
	_CrtSetReportMode( reporttype, reportmode|_CRTDBG_MODE_FILE );
    }

    return( prevfile );
}
