/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   15-jul-96	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#define _DEBUG			/* so prototypes are included */
#include <crtdbg.h>
#include "dbgdata.h"


_WCRTLINK int _CrtSetReportMode( int reporttype, int reportmode )
/***************************************************************/
{
    int			prevmode;

    /*** Ensure reporttype is valid ***/
    if( reporttype < _CRT_WARN  ||  reporttype > _CRT_ASSERT ) {
	return( -1 );
    }

    /*** Ok, now do something useful ***/
    prevmode = __DbgReportModes[reporttype];
    if( reportmode != _CRTDBG_REPORT_MODE ) {
	if( reportmode & ~( _CRTDBG_MODE_DEBUG|_CRTDBG_MODE_FILE|_CRTDBG_MODE_WNDW ) ) {
	    return( -1 );
	}
	#if !defined(__NT__) && !defined(__WINDOWS__) && !defined(__OS2__)
	    /* do we want to return -1 if _CRTDBG_MODE_WNDW is on? */
	    reportmode &= ~_CRTDBG_MODE_WNDW;
	#endif
	__DbgReportModes[reporttype] = reportmode;
    }

    return( prevmode );
}
