/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%   Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%   reserved. No part of this software may be reproduced      %
 *%   in any form or by any means - graphic, electronic or      %
 *%   mechanical, including photocopying, recording, taping     %
 *%   or information storage and retrieval systems - except     %
 *%   with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  05-jan-90	J.B.Schueler    Initial implementation
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  30-may-95	Greg Bentz	dll linkage
  22-apr-96	Greg Bentz	tweak typing inconsistencies
*/
#include "variety.h"
#include <sys/kernel.h>
#include <i86.h>

#if defined(__386__)
#define _CONST32 const
#else
#define _CONST32
#endif

_WCRTLINK int (__send)( pid, msg1, msg2, nbytes1, nbytes2 )
pid_t			pid;
_CONST32 void _WCI86FAR	*msg1;
void _WCI86FAR		*msg2;
unsigned		nbytes1;
unsigned		nbytes2;
{
    struct _mxfer_entry xmsg1;
    struct _mxfer_entry xmsg2;

    _setmx(&xmsg1, msg1, nbytes1);
    _setmx(&xmsg2, msg2, nbytes2);

    return( __sendmx( pid, 1, 1, &xmsg1, &xmsg2 ) );
}

_WCRTLINK int (__sendfd)( fd, msg1, msg2, nbytes1, nbytes2 )
unsigned		fd;
_CONST32 void _WCI86FAR	*msg1;
void _WCI86FAR		*msg2;
unsigned		nbytes1;
unsigned		nbytes2;
{
    struct _mxfer_entry xmsg1;
    struct _mxfer_entry xmsg2;

    _setmx(&xmsg1, msg1, nbytes1);
    _setmx(&xmsg2, msg2, nbytes2);

    return( __sendfdmx( fd, 1, 1, &xmsg1, &xmsg2 ) );
}

_WCRTLINK pid_t (__receive)( pid, msg, nbytes )
pid_t		pid;
void _WCI86FAR	*msg;
unsigned	nbytes;
{
    struct _mxfer_entry xmsg;

    _setmx(&xmsg, msg, nbytes);

    return( __receivemx( pid, 1, &xmsg ) );
}

_WCRTLINK int (__reply)( pid, msg, nbytes )
pid_t			pid;
_CONST32 void _WCI86FAR	*msg;
unsigned		nbytes;
{
    struct _mxfer_entry xmsg;

    _setmx(&xmsg, msg, nbytes);

    return( __replymx( pid, 1, &xmsg ) );
}

_WCRTLINK pid_t (__creceive)( pid, msg, nbytes )
pid_t		pid;
void _WCI86FAR	*msg;
unsigned	nbytes;
{
    struct _mxfer_entry xmsg;

    _setmx(&xmsg, msg, nbytes);

    return( __creceivemx( pid, 1, &xmsg ) );
}

_WCRTLINK unsigned (__readmsg)( pid, offset, msg, nbytes )
pid_t		pid;
unsigned	offset;
void _WCI86FAR	*msg;
unsigned	nbytes;
{
    struct _mxfer_entry xmsg;

    _setmx(&xmsg, msg, nbytes);

    return( __readmsgmx( pid, offset, 1, &xmsg ) );
}

_WCRTLINK unsigned (__writemsg)( pid, offset, msg, nbytes )
pid_t			pid;
unsigned		offset;
_CONST32 void _WCI86FAR	*msg;
unsigned		nbytes;
{
    struct _mxfer_entry xmsg;

    _setmx(&xmsg, msg, nbytes);

    return( __writemsgmx( pid, offset, 1, &xmsg ) );
}
