/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  26-feb-88     F.W.Crigger     Initial implementation
-----------------------------------------------------------Version 7.0-----
  22-feb-89     F.W.Crigger     386 version added
  21-mar-90     F.W.Crigger     faster sequence using adc vs shl,rcl
-----------------------------------------------------------Version 8.5-----
  06-dec-91	F.W.Crigger	top bit of input was being ignored
  27-jan-93	F.W.Crigger	Use new assembler support
--------------------------------------------------------Version-11.0---------
  22-feb-95	Greg Bentz	alpha support
  30-may-95	Greg Bentz	variety.h and dll linkage
  15-sep-95	Greg Bentz	ppc support
*/

#include "variety.h"
#include <stdlib.h>
#include <limits.h>

#undef _lrotl

extern  unsigned long __lrotl(unsigned long,unsigned);

#if defined(__AXP__)
#elif defined(__PPC__)
#elif defined(__386__)
#pragma aux __lrotl = "rol eax,cl" parm [eax] [ecx] value [eax] modify [ecx];
#else
#pragma aux __lrotl =	"    and cx,31"\
			"    je  short L2"\
			"L1: adc ax,ax"\
			"    adc dx,dx"\
			"    adc ax,0"\
			"    dec cx"\
			"    jne L1"\
			"L2:" \
                        parm [ax dx] [cx] value [ax dx];
#endif


_WCRTLINK unsigned long _lrotl( unsigned long value, unsigned int shift )
{
    #if defined(__AXP__) || defined(__PPC__)
	unsigned long tmp;
	tmp = value;
	value = value << shift;
	tmp = tmp >> ((sizeof(tmp)*CHAR_BIT)-shift);
	value = value | tmp;
	return( value );
    #else
	return( __lrotl( value, shift ) );
    #endif
}
