/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  17-jul-87	F.W.Crigger	Initial implementation
  19-jan-88	F.W.Crigger	Check for bad category
-----------------------------------------------------------Version 6.5------
  09-aug-88	F.W.Crigger	Added LC_MONETARY
  06-dec-88	F.W.Crigger	Added NATIVE_LOCALE ""
  20-feb-91	J.B.Schueler	Added LC_MESSAGES for POSIX QNX
				Fixed range check for QNX
  21-jan-92	B.J. Stecher	DOS and QNX are now the same
--------------------------------------------------------Version-11.0---------
  30-may-95	Greg Bentz	variety.h and dll linkage
  28-sep-95	M. Hildebrand	Added _wsetlocale.
  27-nov-95	Greg Bentz	fixup const in function definition
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <string.h>
#include <locale.h>
#include "locales.h"
#include "localset.h"

#ifdef __WIDECHAR__
static wchar_t *ValidLocales[] = {
	L"C",		/* C_LOCALE */
	L"",		/* NATIVE_LOCALE */
	NULL		/* INVALID_LOCALE */
};
#else
static char *ValidLocales[] = {
	"C",		/* C_LOCALE */
	"",		/* NATIVE_LOCALE */
	NULL		/* INVALID_LOCALE */
};
#endif


_WCRTLINK CHAR_TYPE *__F_NAME(setlocale,_wsetlocale)( int category, CHAR_TYPE const *locale )
    {
	register int i;

	_INITLOCALESETTING
	if( category < LC_CTYPE  ||  category > LC_ALL ) {
	    return( NULL );
	}
	if( locale == NULL ) {
	    i = _LOCALESETTING[category];
	} else {
	    i = C_LOCALE;
	    if( *locale != __F_NAME('\0',L'\0') ) {
		for( ; ValidLocales[i]; ++i ) {
		    if( __F_NAME(strcmp,wcscmp)( locale, ValidLocales[i] ) == 0 )  break;
		}
	    }
	    if( i != INVALID_LOCALE ) {
		_LOCALESETTING[category] = i;
		if( category == LC_ALL ) {
		    _LOCALESETTING[LC_COLLATE]	= i;
		    _LOCALESETTING[LC_CTYPE]	= i;
		    _LOCALESETTING[LC_NUMERIC]	= i;
		    _LOCALESETTING[LC_TIME]	= i;
		    _LOCALESETTING[LC_MONETARY] = i;
#if defined( __QNX__ )
		    _LOCALESETTING[LC_MESSAGES] = i;
#endif
		}
	    }
	}
	return( ValidLocales[ i ] );
    }

