/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  10-nov-92	F.W.Crigger	defined
  20-dec-92	F.W.Crigger	_ThreadExitRtn defined
  20-jan-93	A.Gupta		extended for Netware
  17-feb-93	F.W.Crigger	use modulus of handle to map all possible
				file handles onto limited # of semaphores
				Close file semaphores in __FiniSema4s
  04-mar-93	A.Gupta		modified Netware code - now allocates a
                                thread data struct for use when _threadid
				returns 0
  18-jun-93	John Dahms  	all library allocations use lib_xxx routines
  04-may-94	Greg Bentz	improve allocation failure checking
--------------------------------------------------------Version-11.0---------
  18-jan-95	Greg Bentz	support QNX multi-threading
  22-feb-95	Greg Bentz	alpha support
  30-may-95	Greg Bentz	variety.h and dll linkage
  25-aug-95     T. Schiller     Added code to preserve NT last error code
                                when retrieving thread information.
  15-sep-95	Greg Bentz	ppc support
  21-sep-95	Alex Brodsky	Fixed syntax error so that it can be compiled.
  13-nov-95	Greg Bentz	change WIN32 support to use critical sections
  				ensured that at shutdown, thread storage is
				released before heap semaphores are closed
*/
#include "variety.h"
#include "stacklow.h"
#include <stdio.h>
#include <stdlib.h>
#include "liballoc.h"
#include "thread.h"
#include "trdlist.h"
#include "mthread.h"
#include "rtdata.h"
#include "rtinit.h"
#include "exitwmsg.h"

extern	int		__Is_DLL;

void __InitThreadData( thread_data *tdata )
/*****************************************/
{
    if( tdata != NULL ) {
	tdata->__randnext = 1;
	#if defined( __OS2__ )
	    if( !__Is_DLL ) {
		tdata->__stklowP = __threadstack();
	    }
	#elif defined( __NT__ )
	    __init_stack_limits( &tdata->__stklowP, 0 );
	    tdata->thread_id = GetCurrentThreadId();
	#elif defined( __QNX__ )
	    tdata->thread_id = GetCurrentThreadId();
	#endif
    }
}
