/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
--------------------------------------------------------Version-11.0---------
  07-nov-94	Greg Bentz	cloned from thredwnt.c for MFC 3.0 support
  30-may-95	Greg Bentz	variety.h and dll linkage
  15-sep-95	Greg Bentz	ppc support
*/
#include "variety.h"
#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <malloc.h>
#include <errno.h>
#include "liballoc.h"
#include "ntex.h"
#include "stacklow.h"
#include "sigtab.h"
#include "thread.h"
#include "trdlist.h"
#include "mthread.h"
#include "rtdata.h"
#include "extfunc.h"
#include "seterrno.h"

extern	void		__InitMultipleThread( void );

extern	DWORD		__TlsIndex;
extern	int		__Is_DLL;

extern	void		(*__sig_init_rtn)(void);
extern	void		(*__sig_fini_rtn)(void);

extern	void		_endthreadex(unsigned);

typedef struct thread_args {
    thread_fnex	*rtn;
    void	*argument;
    HANDLE	parent;
} thread_args;

static unsigned WINAPI begin_thread_helper( thread_args *td )
/***********************************************************/
{
    thread_fnex		*rtn;
    void		*arg;
    REGISTRATION_RECORD	rr;
    thread_data		*tdata;

    rtn = td->rtn;
    arg = td->argument;

    if( !__Is_DLL ) {					/* 15-feb-93 */
	#if defined(__AXP__) || defined(__PPC__)
	    tdata = alloca( __ThreadDataSize );
	#else
	    tdata = __alloca( __ThreadDataSize );
	#endif
	memset( tdata, 0, __ThreadDataSize );
	// tdata->__allocated = 0;
	tdata->__data_size = __ThreadDataSize;
	if( !__NTAddThread( tdata ) ) {
	    return( 0 );
	}
    }
    free( td );

    __NewExceptionHandler( &rr );
    __sig_init_rtn();
    (*rtn)( arg );
    _endthreadex( 0 );
    return( 0 );
}

int __CBeginThreadEx(
    void *security,
    unsigned stack_size,
    thread_fnex start_addr,
    void *arglist,
    unsigned initflag,
    unsigned *thrdaddr )
{

    thread_args	*td;
    HANDLE	th;
	
    td = malloc( sizeof( *td ) );
    if( td == NULL ) {
	__set_errno( ENOMEM );
	return( 0 );
    }

    if( __TlsIndex == NO_INDEX ) {
	if( __NTThreadInit() == FALSE )  return( 0 );
	__InitMultipleThread();
    }
    
    stack_size = __Align4K( stack_size );
    
    td->rtn = start_addr;
    td->argument = arglist;
    td->parent = GetCurrentThread();
    
    th = CreateThread(
	(LPSECURITY_ATTRIBUTES)security,
	(DWORD)stack_size,
	(LPTHREAD_START_ROUTINE)&begin_thread_helper,
	(LPVOID) td,
	(DWORD)initflag,
	(LPDWORD)thrdaddr );
    return( (unsigned long)th );
}

void __CEndThreadEx( unsigned retval )
{
    __sig_fini_rtn();
    __DoneExceptionHandler();
    if( ! __Is_DLL ) {
	__NTRemoveThread( TRUE );
    }
    ExitThread( retval );
}
