/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1989, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  22-aug-89	John Dahms	defined
----------------------------------------------------------Version 8.0------
  21-dec-90	F.W.Crigger	do DosSemClear in helper routine
--------------------------------------------------Version 8.5----------
  12-nov-91     G. Coschi	support OS/2 2.0
  24-sep-92	A.F.Scian	added __outside_CLIB pragma to fn ptrs
  07-nov-92	F.W.Crigger	cleaned up thread support
  28-jan-94	Greg Bentz	change exit_with_msg to __fatal_runtime_error
--------------------------------------------------------Version-11.0---------
  19-jan-95	Greg Bentz	better failure checking
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  30-may-95	Greg Bentz	dll linkage
*/

#include "variety.h"
#define INCL_DOSSEMAPHORES
#define INCL_DOSPROCESS
#include <wos2.h>

#include <dos.h>
#include <process.h>
#include <string.h>
#include "exitwmsg.h"
#include "stacklow.h"
#include "sigtab.h"
#include "thread.h"
#include "rtdata.h"
#include "extfunc.h"

typedef void (_WCFAR thread_fn)(void _WCFAR *);
#if defined(_M_IX86)
    #pragma aux (__outside_CLIB) thread_fn;
#endif

extern	unsigned	__MaxThreads;
extern	int		_WCFAR *_threadid;		// OS/2 1.x

static	HSEM 		data_sem = 0;

static	thread_fn	*Routine;
static	void		_WCFAR *Argument;
static	void		_WCFAR *StackBottom;


static void _WCFAR begin_thread_helper() {
/**************************************/

    thread_fn	*_rtn;
    void	_WCFAR *_arg;
    thread_data	my_thread_data;
    
    if( *_threadid > __MaxThreads ) return;
    /* save a copy of the global variables so we can clear the semaphore */
    _rtn = Routine;
    _arg = Argument;
    memset( &my_thread_data, 0, sizeof( thread_data ) );
    my_thread_data.__randnext = 1;
    __ThreadData[*_threadid] = &my_thread_data;
    _STACKLOW = FP_OFF( StackBottom );
    DosSemClear( &data_sem );
    (*_rtn)( _arg );
    _endthread();
}


_WCRTLINK int _WCFAR _beginthread( thread_fn *start_address,
			    void _WCFAR *stack_bottom,
			    unsigned stack_size,
			    void _WCFAR *arglist ) {
/*****************************************************/

    TID		tid;
    APIRET	rc;
    
    DosSemRequest( &data_sem, -1L );
    Routine = start_address;
    Argument = arglist;
    StackBottom = stack_bottom;
    rc = DosCreateThread( begin_thread_helper, (PTID)&tid,
			  (char *)stack_bottom + stack_size );
    if( rc != 0 ) {
	DosSemClear( &data_sem );
	return( -1 );
    }
    if( tid > __MaxThreads ) {
	return( -1 );
    }
    return( tid );
}

void _WCFAR *__chkstack( void _WCFAR *ptr ) {
/***************************************/
    if( FP_SEG( ptr ) != FP_SEG( &Routine ) ) {
	__fatal_runtime_error( "thread stack not in DGROUP", 1 );
    }
    return( ptr );
}

_WCRTLINK void _WCFAR _endthread() {
/**********************/

    __ThreadData[*_threadid] = NULL;
    DosExit( EXIT_THREAD, 0 );
}
