/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1989, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  22-aug-89	John Dahms	defined
----------------------------------------------------------Version 8.0------
  21-dec-90	F.W.Crigger	do DosSemClear in helper routine
--------------------------------------------------Version 8.5----------
  12-nov-91     G. Coschi	support OS/2 2.0
  04-sep-92     G. Coschi	called _fpreset() to in begin_thread_helper()
  				to initialize math coprocessor for threads
  07-nov-92	F.W.Crigger	cleaned up thread support
  16-feb-93     G. Coschi	check if in a DLL in begin_thread_helper()
  29-jul-93	F.W.Crigger	introduced __BeginThread, __EndThread vars so
				FORTRAN can change it to point to a FORTRAN
				specific _beginthread, _endthread functions
  21-oct-93     G. Coschi	add thread stack overhead since __TNC
  				assumes that there is at least 8K of stack
				(Note: this overhead will only be added if
				required - done with initializers)
  16-aug-94	Greg Bentz	change alloca() to __alloca()
--------------------------------------------------------Version-11.0---------
  30-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#define INCL_DOSSEMAPHORES
#define INCL_DOSPROCESS
#define INCL_DOSEXCEPTIONS
#include <wos2.h>

#include <string.h>
#include <dos.h>
#include <float.h>
#include "liballoc.h"
#include "osthread.h"
#include "stacklow.h"
#include "sigtab.h"
#include "rtdata.h"
#include "extfunc.h"
#include "trdlist.h"
#include "mthread.h"

#pragma aux __threadstksize "*"
extern	unsigned	__threadstksize;

extern	int		__Is_DLL;

extern	thread_data	**__InitThreadProcessing(void);
extern	void		__InitMultipleThread(void);
extern	unsigned	__threadstack(void);
extern	void		(*__sig_init_rtn)(void);
extern	void		(*__sig_fini_rtn)(void);

extern	void		_endthread( void );

typedef struct thread_args {
    thread_fn	*rtn;
    void	*argument;
    HEV		event;
} thread_args;


static APIENTRY begin_thread_helper( thread_args *td )
/****************************************************/
{
    thread_fn			*rtn;
    void			*arg;
    EXCEPTIONREGISTRATIONRECORD	xcpt;
    thread_data 		*tdata;
    
    rtn = td->rtn;
    arg = td->argument;

    tdata = __alloca( __ThreadDataSize );
    memset( tdata, 0, __ThreadDataSize );
    // tdata->__allocated = 0;
    tdata->__data_size = __ThreadDataSize;
    if( !__Is_DLL ) {
	if( !__OS2AddThread( *_threadid, tdata ) ) return;
    }

    DosPostEventSem( td->event );
    _fpreset();
    __XCPTHANDLER = &xcpt;
    __sig_init_rtn();
    (*rtn)( arg );
    _endthread();
}

int __CBeginThread( thread_fn *start_addr, void *stack_bottom,
		    unsigned stack_size, void *arglist )
/******************************************************/
{
    TID		tid;
    APIRET	rc;
    thread_args	td;
	
    if( __ThreadData == NULL ) {
	if( __InitThreadProcessing() == NULL )  return( -1 );
	__InitMultipleThread();
    }
    stack_bottom = stack_bottom;
    td.rtn = start_addr;
    td.argument = arglist;
    rc = DosCreateEventSem( NULL, &td.event, 0, 0 );
    if( rc != 0 ) return( -1 );
    rc = DosCreateThread( &tid, (PFNTHREAD)begin_thread_helper, (ULONG)&td,
                          0, stack_size + __threadstksize );
    if( rc != 0 ) {
	tid = -1;
    } else {
	/*
	   suspend parent thread so that it can't call _beginthread() again
	   before new thread extracts data from "td" (no problem if new
	   thread calls _beginthread() since it has its own stack)
	*/
	DosWaitEventSem( td.event, SEM_INDEFINITE_WAIT );
    }
    DosCloseEventSem( td.event );
    return( tid );
}

void __CEndThread( void )
/***********************/
{
    __sig_fini_rtn();
    __OS2RemoveThread();
    DosExit( EXIT_THREAD, 0 );
}
