/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  05-jul-90	F.W.Crigger	defined
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
--------------------------------------------------------Version-11.0---------
  30-may-95	Greg Bentz	variety.h and dll linkage
*/
#include "variety.h"
#include <stddef.h>
#include <process.h>
#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#include <wos2.h>
#include <errno.h>
#include "rtdata.h"
#include "seterrno.h"

_WCRTLINK int cwait( int *status, int process_id, int action )
    {
	APIRET	retcode;
	RESULTCODES rc;
	PID	pid;
	#pragma pack(__push,1);
	union {
	    int 	stat;
	    struct {
		unsigned char al, ah;
	    } s;
	} u;
	#pragma pack(__pop);

	retcode = DosCwait( action, 0, &rc, &pid, process_id );
	if( retcode != 0 ) {
	    __set_errno( retcode == ERROR_WAIT_NO_CHILDREN ? ECHILD : EINVAL );
	    return( -1 );
	} else {
	    u.stat = retcode;
	    u.s.al = rc.codeTerminate;
	    if( u.s.al == 0 )  u.s.ah = rc.codeResult;
	    if( status != NULL )  *status = u.stat;
	    if( u.s.al != 0 ) {
		__set_errno( EINTR );
		return( -1 );
	    }
	}
	return( pid );
    }
