/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1995, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  19-jun-95	T. Schiller	defined
  11-sep-95     T. Schiller     plugged file handle leak
  19-oct-95	M. Hildebrand	Process ID is now a process HANDLE.
*/
#include "variety.h"
#include <windows.h>
#include <stddef.h>
#include <process.h>
#include <errno.h>
#include "rtdata.h"
#include "seterrno.h"


_WCRTLINK int cwait(int *status, int process_id, int action)
{
	DWORD  rc;
	HANDLE p = (HANDLE)process_id;

	if (action != WAIT_CHILD)
	{
		__set_errno(EINVAL);
		return -1;
	}

	if (WaitForSingleObject(p, -1) != 0)
	{
		CloseHandle(p);
		__set_errno(EINVAL);
		return -1;
	}

	GetExitCodeProcess(p, &rc);
	CloseHandle(p);

	*status = (rc << 8) & 0xff00;

	return process_id;
} /* cwait() */
