/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  09-aug-89     John Dahms      defined for OS/2
--------------------------------------------------Version 9.x----------
  13-nov-92     G. Coschi	don't check return code from spawnve() to
  				determine whether to exit current process
				since it may be return code from spawned
				program
  23-nov-92	F.W.Crigger	return the return code from spawnve
  19-apr-93	G. Coschi	call spawnve() with P_NOWAIT instead of P_WAIT
--------------------------------------------------------Version-11.0---------
  30-may-95	Greg Bentz	variety.h and dll linkage
  21-jun-95	T. Schiller	Added __p_overlay
  22-apr-96	Greg Bentz	tweak typing inconsistencies
*/

#undef __INLINE_FUNCTIONS__
#include "variety.h"
#define INCL_DOSPROCESS
#include <wos2.h>
#include <process.h>
#include <errno.h>
#include "rtdata.h"
#include "seterrno.h"

extern void (*__int23_exit)(void);

int __p_overlay = 2;

_WCRTLINK int execve( const char *path, const char *const argv[],
    const char *const envp[] )
{
    int		rc;
    
    rc = spawnve( P_NOWAIT, path, argv, envp );
    if( _RWD_errno != 0 ) return( -1 );
    __int23_exit();
    DosExit( EXIT_PROCESS, rc );
    return( 0 );
}
