/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  18-mar-87	F.W.Crigger	Initial implementation
---------------------------------------------------------Version 8.0-------
  30-mar-90	J.B.Schueler	Removed __ptr_check
  14-may-90	J.B.Schueler	ANSI'fied processing of parms
  23-dec-90	John Dahms	add arg0 to match header file.
--------------------------------------------------------Version-11.0---------
  14-mar-95	Greg Bentz	alpha support
  30-may-95	Greg Bentz	variety.h and dll linkage
  15-jun-95	T. Schiller	Fixed varargs handling for axp
  15-sep-95	Greg Bentz	ppc support
  02-oct-95	M. Hildebrand	Added _wspawnl.
  27-nov-95	Greg Bentz	fixup const in function definition
  24-jun-96	M. Hildebrand	Fixed problems in the use of _RWD_wenviron.
*/
#include "variety.h"
#include "widechar.h"
#include <stdlib.h>
#include <stdarg.h>
#include <process.h>
#include <malloc.h>
#include <memory.h>
#include <errno.h>
#include "seterrno.h"
#include "rtdata.h"
#include "wenviron.h"

_WCRTLINK int __F_NAME(spawnl,_wspawnl)( int mode, const CHAR_TYPE *path, const CHAR_TYPE *arg0, ... )
    {
	va_list		    ap;
#if defined(__AXP__) || defined(__PPC__)
	va_list		    bp;
	CHAR_TYPE const **  a;
	CHAR_TYPE const **  tmp;
	int		    num;
#endif

	arg0 = arg0;
	va_start(ap, path);

#if defined(__AXP__) || defined(__PPC__)
	memcpy(&bp, &ap, sizeof(ap));

	for(num = 1; va_arg(ap, CHAR_TYPE*); ++num)
		;

	a = (const CHAR_TYPE**) alloca(num * sizeof(CHAR_TYPE*));
	if (!a)
	{
		__set_errno(ENOMEM);
		return -1;
	}

	for(tmp = a; num > 0; --num)
		*tmp++ = (CHAR_TYPE*)va_arg(bp, CHAR_TYPE*);

	#ifdef __WIDECHAR__
	    if( _RWD_wenviron == NULL )  __create_wide_environment();
	    return( _wspawnve( mode,
			       path,
			       a,
			       (wchar_t const * const *)_RWD_wenviron ) );
	#else
	    return( spawnve( mode,
			     path,
			     a,
			     (char const * const *)_RWD_environ ) );
	#endif
#else
	#ifdef __WIDECHAR__
	    if( _RWD_wenviron == NULL )  __create_wide_environment();
	    return( _wspawnve( mode,
			       path,
			       (wchar_t const * const *)ap[0],
			       (wchar_t const * const *)_RWD_wenviron ) );
	#else
	    return( spawnve( mode,
			     path,
			     (char const * const *)ap[0],
			     (char const * const *)_RWD_environ ) );
	#endif
#endif
    }
