/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  23-aug-87     F.W.Crigger     Initial implementation
  14-may-90     J.B.Schueler    ANSI'fied processing of parms
  23-dec-90     John Dahms      add arg0 to match header file.
--------------------------------------------------------Version-11.0---------
  14-mar-95	Greg Bentz	alpha support
  30-may-95	Greg Bentz	variety.h and dll linkage
  15-jun-95	T. Schiller	Fixed varargs handling for axp
  15-sep-95	Greg Bentz	ppc support
  02-oct-95	T. Schiller	for char*'s we can use intel-like vararg
				handling
  02-oct-95	M. Hildebrand	Added _wspawnlp.
  27-nov-95	Greg Bentz	fixup const in function definition
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdarg.h>
#include <process.h>
#include <malloc.h>
#include <memory.h>
#include <errno.h>
#include "seterrno.h"


_WCRTLINK int __F_NAME(spawnlp,_wspawnlp)( int mode, const CHAR_TYPE *path, const CHAR_TYPE *arg0, ... )
{
        va_list   ap;
	int	  rc;
#if defined(__AXP__)
        va_list   bp;
	const CHAR_TYPE **a;
	const CHAR_TYPE **tmp;
	int       num;
#endif

        arg0 = arg0;
	va_start(ap, path);

#if defined(__AXP__)
	memcpy(&bp, &ap, sizeof(ap));

	for(num = 1; va_arg(ap, CHAR_TYPE*); ++num)
		;

	a = (const CHAR_TYPE**) alloca(num * sizeof(CHAR_TYPE*));
	if (!a)
	{
		__set_errno(ENOMEM);
		return -1;
	}

	for(tmp = a; num > 0; --num)
		*tmp++ = (CHAR_TYPE*)va_arg(bp, CHAR_TYPE*);

	rc = __F_NAME(spawnvp,_wspawnvp)( mode, path, a );
#else
	rc = __F_NAME(spawnvp,_wspawnvp)( mode, path, (const CHAR_TYPE**)ap[0] );
	va_end( ap );
#endif
	return( rc );
} /* spawnlp() */
