/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  01-nov-87	F.W.Crigger	Initial implementation
  14-may-90	J.B.Schueler	ANSI'fied processing of parms
--------------------------------------------------Version 9.0----------
  20-jul-92	D.J.Gaudet	removed manifest constant for path length
--------------------------------------------------------Version-11.0---------
  30-may-95	Greg Bentz	variety.h and dll linkage
  02-oct-95	M. Hildebrand	Added _wspawnvpe.
  27-nov-95	Greg Bentz	fixup const in function definition
  13-mar-96	Greg Bentz	tweak typing inconsistencies
*/
#undef __INLINE_FUNCTIONS__
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <dos.h>
#include <process.h>
#include "msdos.h"
#include "rtdata.h"
#include "seterrno.h"

#pragma on(check_stack);

_WCRTLINK int __F_NAME(spawnvpe,_wspawnvpe)( int mode, const CHAR_TYPE *file, const CHAR_TYPE * const *argv, const CHAR_TYPE * const *envp )
    {
	register CHAR_TYPE *p;
	register CHAR_TYPE *p2;
	register int retval;
	auto CHAR_TYPE buffer[_MAX_PATH];
	size_t file_len;
	CHAR_TYPE *end;

	retval = __F_NAME(spawnve,_wspawnve)( mode, file, argv, envp );
	if( retval != -1  ||
	    (_RWD_errno != ENOENT && _RWD_errno != EINVAL)) return( retval );
	if( *file == '\\' || *file == '\0' || file[1] == ':' ) return( retval );
	p = __F_NAME(getenv,_wgetenv)( __F_NAME("PATH",L"PATH") );
	if( p == NULL ) return( retval );
	file_len = __F_NAME(strlen,wcslen)( file ) + 1;
	for(;;) {
	    if( *p == '\0' ) break;
	    end = __F_NAME(strchr,wcschr)( p, ';' );
	    if( end == NULL ) {
		end = p + __F_NAME(strlen,wcslen)( p );	/* find null-terminator */
	    }
	    if( end - p > _MAX_PATH - file_len ) {
		__set_errno( E2BIG );
		__set_doserrno( E_badenv );
		return( -1 );
	    }
	    memcpy( buffer, p, (end-p)*sizeof(CHAR_TYPE) );
	    p2 = buffer + ( end - p );
	    if( p2[-1] != '\\' ) {
		*p2++ = '\\';
	    }
	    memcpy( p2, file, file_len*sizeof(CHAR_TYPE) );
	    retval = __F_NAME(spawnve,_wspawnve)( mode, buffer, argv, envp );
	    if( retval != -1 ) break;
	    if(_RWD_errno != ENOENT && _RWD_errno != EINVAL) break;
	    if( *end != ';' ) break;
	    p = end + 1;
	}
	return( retval );
    }
