/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  18-mar-87	F.W.Crigger	Initial implementation
  19-jan-88	F.W.Crigger	Add support for cmd == NULL
------------------------------------------------------------Version 6.5-----
  20-sep-88	F.W.Crigger	DOS_Switch_Char support added
  20-jan-89	F.W.Crigger	Always say that a command processor exists
				added "if( name == NULL ) name = "COMMAND.COM";
				Use spawnlp instead of spawnl
  16-aug-89	John Dahms	Added multi-thread & OS/2 support
  05-feb-91	C.G. Eisler	Windows 386 support (do nothing)
  03-apr-91	C.G. Eisler	updated for WINDOWS_386 macro
--------------------------------------------------Version 8.5----------
  09-jul-91     G. Coschi	support OS/2 2.0
--------------------------------------------------Version 9.x----------
  14-mar-92     Craig Eisler	NT support
--------------------------------------------------------Version-11.0---------
  30-may-95	Greg Bentz	variety.h and dll linkage
  04-oct-95	M. Hildebrand	Added _wsystem.
  08-jul-97	Alex Brodsky	Disable file handle inheritance for the call
  				to prevent bad things from happening.
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <process.h>
#include <errno.h>
#if defined(__OS2__)
    #define INCL_DOSMISC
    #include <wos2.h>
#endif
#include "rtdata.h"
#include "seterrno.h"

extern CHAR_TYPE *__F_NAME(__Slash_C,__wSlash_C)( CHAR_TYPE *, CHAR_TYPE );

_WCRTLINK int __F_NAME(system,_wsystem)( const CHAR_TYPE *cmd )
{
    #if defined(__WINDOWS__)
	if( cmd == NULL ) {
	    return( 0 );
	} else {
	    __set_errno( ENOENT );
	    return( -1 );
	}
    #else
	register CHAR_TYPE *name;
	auto CHAR_TYPE switch_c[4];
	char prot_mode286;
	int ret_code;
	#if defined( __NT__ )
	    int tmp_fileinfo;
	#endif

	#if defined( __NT__ )
	    name = __F_NAME(getenv,_wgetenv)( __F_NAME("ComSpec",L"ComSpec") );
	#else
	    name = __F_NAME(getenv,_wgetenv)( __F_NAME("COMSPEC",L"COMSPEC") );
	#endif
	if( cmd == NULL ) {
	    #if 1
		return( 1 );	/* COMMAND.COM is available */
	    #else
		if( name != NULL ) {
		    if( __F_NAME(access,_waccess)( name, 0 ) == 0 ) {
			return( 1 );	/* COMMAND.COM is available */
		    }
		}
		__set_errno( ENOENT );
		return( 0 );	/* indicate no COMMAND.COM available */
	    #endif
	}
	#if defined( __NT__ )
	    prot_mode286 = 1;
	#elif defined( __WARP__ )
	    prot_mode286 = 1;
	#elif defined( __OS2_286__ )
	    prot_mode286 = _RWD_osmode;
	#else
	    prot_mode286 = 0;
	#endif
	if( name == NULL ) {
	    #ifdef __WIDECHAR__
		name = prot_mode286 ? L"CMD.EXE" : L"COMMAND.COM";
	    #else
		name = prot_mode286 ? "CMD.EXE" : "COMMAND.COM";
	    #endif
	}

	/* 08-jul-97 */
	#if defined( __NT__ )
	    /* disable file handle inheritance for a system call */
	    tmp_fileinfo = _fileinfo;
	    _fileinfo = 0;
	#endif

        /* 20-jan-89 */
	#ifdef __WIDECHAR__
	    ret_code = _wspawnlp( 0, name, prot_mode286 ? L"CMD" : L"COMMAND",
			      __wSlash_C(switch_c, prot_mode286), cmd, NULL );
	#else
	    ret_code = spawnlp( 0, name, prot_mode286 ? "CMD" : "COMMAND",
			    __Slash_C(switch_c, prot_mode286), cmd, NULL );
	#endif

	/* 08-jul-97 */
	#if defined( __NT__ )
	    /* set file handle inheritance to what it was */
	    _fileinfo = tmp_fileinfo;
	#endif

	return( ret_code );
    #endif
}
