/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-11.0---------
  02-oct-95	M. Hildebrand	Initial implementation.
  27-nov-95	Greg Bentz	fixup const in function definition
  22-apr-96	Greg Bentz	tweak typing inconsistencies
*/

#ifdef __NT__

// NT can handle wide character strings directly, so don't bother converting
// path, arguments, and environment to MBCS.
#define __WIDECHAR__
#define UNICODE
#include "spve.c"


#else


#include "variety.h"
#include <process.h>
#include <stdlib.h>
#include "rtdata.h"
#include "exwc2mb.h"


_WCRTLINK int _wspawnve( unsigned mode, const wchar_t *path,
/**********************************************************/
    const wchar_t *const argv[], const wchar_t *const envp[] )
{
    char *		mbPath;
    char **		mbArgv;
    char **		mbEnvp;
    int			rc;
    int			sameEnv = 0;

    /*** Convert wide strings to MBCS ***/
    if( envp == NULL || envp == (const wchar_t **)_RWD_wenviron ) {
	sameEnv = 1;
	rc = __exec_wide_to_mbcs( path, argv, NULL, &mbPath, &mbArgv, NULL );
	mbEnvp = _RWD_environ;
    } else {
	rc = __exec_wide_to_mbcs( path, argv, envp, &mbPath, &mbArgv, &mbEnvp );
    }
    if( rc == 0 )  return( -1 );

    /*** Call MBCS version, free converted strings, and return ***/
    rc = spawnve( mode, mbPath, (const char **)mbArgv, (const char **)mbEnvp );
    if( sameEnv ) {
	__exec_wide_to_mbcs_cleanup( mbPath, mbArgv, NULL );
    } else {
	__exec_wide_to_mbcs_cleanup( mbPath, mbArgv, mbEnvp );
    }
    return( rc );
}

#endif
