/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  26-aug-86	F.W.Crigger	Initial implementation
  15-may-91	A.F.Scian	handled case where nmemb == 0
  24-sep-92	A.F.Scian	fixed up call to compare routine to use pragma
  01-oct-93	J.B.Schueler	implemented changes to algorith to fix segment
				violation when search element is below or above
				table
--------------------------------------------------------Version-11.0---------
  22-feb-95	Greg Bentz	alpha support
  30-may-95	Greg Bentz	variety.h and dll linkage
  15-sep-95	Greg Bentz	ppc support
*/
#include "variety.h"
#undef __INLINE_FUNCTIONS__
#include <stddef.h>
#include <stdlib.h>
#include "extfunc.h"

/*
    The old bsearch could SIGSEGV if the compare is done on elements
    which are not within the given segment.  The error occurs if the search
    key is larger than the 'high' element (or lower than the 'low' member)
    and 'low','mid' and 'high' are all equal (either from the start or
    after several iterations).
*/

typedef int bcomp();
#if defined(_M_IX86)
    #pragma aux (__outside_CLIB) bcomp;
#endif

_WCRTLINK void * bsearch( const void * key,
		const void * base,
		size_t nmemb,
		size_t size,
		int (*cmp)() )
    {
	char *low;
	char *high;
	char *mid;
	int cond;
	bcomp *compar = cmp;

	if( nmemb == 0 ) {
	    return( NULL );
	}
	low = (char *) base;
	high = low + (nmemb-1) * size;
// JBS	while( low <= high ) {
	while( low < high ) {
	    mid = low + ( (high-low)/size/2 ) * size;
	    cond = (*compar)( key, mid );
	    if( cond == 0 ) return( mid );
	    if( cond < 0 ) {	/* key < mid */
// JBS		high = mid - size;
		high = mid;
	    } else {		/* key > mid */
		low = mid + size;
	    }
	}
	if (low == high) return( (*compar)(key, low) ? NULL : low );
	return( NULL );
    }
