;========================================================================
;==	Name:		STK					       ==
;==	Operation:	Check for stack overflow
;==	Inputs: 	AX	amount of stack space required
;==	Volatile:	none					       ==
;==	Date:		By:		Reason: 		       ==
;==	15-sep-87	F.W.Crigger	Initial implementation	       ==
;==-------------------------------------------------Version 6.0----------
;==	15-apr-88	F.W.Crigger	ref __STACKLOW thru DS instead SS
;==	22-may-88	F.W.Crigger	Added __STKOVERFLOW_ label     ==
;==-------------------------------------------------Version 8.5----------
;==	10-sep-91	F.W.Crigger	Added _init_stk and SS_seg     ==
;==	23-sep-91	C.G.Eisler      use __exit_with_msg_           ==
;==	18-oct-91	C.G.Eisler	chg ? to 1 dup(?) in _BSS (MASM bug)
;==					change '$' to 0
;==	07-nov-91	F.W.Crigger	Use xinit macro		       ==
;==-------------------------------------------------Version 9.0----------
;==	22-sep-92	F.W.Crigger	Don't load DS if _DS_PEGGED (Windows)
;==	11-nov-93	Greg Bentz	rationalize exit_with_msg      ==
;==	28-jan-94	Greg Bentz	change to __fatal_runtime_error==
;==	07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;==	12-mar-95	Greg Bentz	remove _ from "C" symbols      ==
;==	28-nov-95	Greg Bentz	wasm export support	       ==
;========================================================================
include mdef.inc
include struct.inc
include exitwmsg.inc

	modstart	stk

_DATA	segment word public 'DATA'
	extrn	"C",_STACKLOW : word
SS_seg	dw	0
_DATA	ends

include xinit.inc

        xinit	_init_stk,DEF_PRIORITY

	assume	ds:DGROUP

	xdefp	__STK
	if __WASM__ ge 100
	    xdefp	"C",__STKOVERFLOW
	else
	    xdefp	<"C",__STKOVERFLOW>
	endif

	defp	_init_stk
	mov	SS_seg,SS	; save original SS value
	ret			; return
_init_stk endp

	defpe	__STK
	_guess			; guess: no overflow
	  cmp	ax,sp		; - quit if user asking for too much
	  _quif ae		; - . . .
	  sub	ax,sp		; - calculate new low point
if (_MODEL and (_BIG_DATA or _HUGE_DATA)) and ((_MODEL and _DS_PEGGED) eq 0)
	  push	ds		; - save DS
	  push	ax		; - save AX
	  mov	ax,DGROUP	; - get access to DGROUP
	  mov	ds,ax		; - . . .
	  pop	ax		; - restore AX
endif
	  neg	ax		; - calc what new SP would be
	  cmp	ax,_STACKLOW	; - if too much
	  _if	be		; - then

;	We could have reached this point because we are in an interrupt
;	routine or DLL with different SS:SP values from our DGROUP.

	    mov	  ax,ss		; - - get ss
	    cmp	  ax,SS_seg	; - - see if SS has been changed
	    je	  __STKOVERFLOW ; - - stack overflow if same
	  _endif		; - endif

if (_MODEL and (_BIG_DATA or _HUGE_DATA)) and ((_MODEL and _DS_PEGGED) eq 0)
	  pop	ds		; - restore DS
endif
	  ret			; - return
	_endguess		; endguess

__STKOVERFLOW:
        push    cs              ; set dx=cs
        pop     dx              ; . . .
        mov     ax,offset msg   ; get msg
	mov	bx,1		; error code
	call	__fatal_runtime_error
	endproc __STK

msg	db	"Stack Overflow!", 0dh, 0ah, 0
	endmod
	end
