;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	Copyright (C) 1991 by WATCOM Systems Inc. All rights	%
;%	reserved. No part of this software may be reproduced	%
;%	in any form or by any means - graphic, electronic or	%
;%	mechanical, including photocopying, recording, taping	%
;%	or information storage and retrieval systems - except	%
;%	with the written permission of WATCOM Systems Inc.	%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
; Ensure the stack of a routine that calls 16 bit code doesn't
; cross a 64K boundary
;
; date          by              reason
; ====          ==              ======
; 30-nov-91     John Dahms      created
; 02-nov-94	Brad Brisco	decreased stack requirements
; 28-nov-95	Greg Bentz	wasm export support
; 29-jan-96	Greg Bentz	setup initializer for thread stack space
;

		name	thunk
	
.386p

		assume	nothing

extrn __STK			: near
extrn "C",__init_threadstksize	: near

dgroup	group	stack

stack   segment para stack 'STACK'
        db      8192 dup(?)
stack   ends

_TEXT		segment use32 word public 'CODE'

		assume		cs:_TEXT


;
;		generated code sequence
;		- push	esp
;		- push	parm_size
;		- push	local_size
;		- call  __TNK
;		- .... normal prolog
;		- .... .... insert favorite routine here
;		- .... normal epilog
;		- pop   esp
;		- ret
;
		public	__TNK
		public	__TNC			; thunk with stack check

__TNC		proc	near export
		push	eax			; save register
		mov	eax,8[esp]		; get local size
		add	eax,12[esp]		; add parm size
		add	eax,8*1024		; add 8k
		call	__STK			; check the stack
		pop	eax			; ...
__TNK		proc	near export
		push	eax			; ...
		push	ebx			; ...
		push	ecx			; ...
		push	esi			; ...
		push	edi			; ...
		lea	edi,[9*4+esp]		; point to fn return addr
		mov	eax,-8[edi]		; get size of parms
		mov	ebx,-12[edi]		; get local size
		add	ebx,2000H		; plus an extra 8k
		lea	esi,[edi+eax]		; point at the first parm
		mov	ecx,esi			; ...
		sub	cx,bx      		; subtract locals required
		jae	stackok			; if stack will cross 64K bdry
		xor	di,di			; round edi down to crossed bdry
		mov	esi,esp			; esi -> stuff we want to copy
		lea	ecx,[10*4+eax] 		; - parms + save area
		sub	edi,ecx			; - new stack area - below bdry
		sub	esp,4			; - bump down stack pointer
		and	sp,0f000H		; - round down to 4K bdry

loop64k:	cmp	esp,edi			; - while esp > edi 
		jbe	end64k			; - - ...
		mov	[esp],eax		; - - touch the page
		sub	esp,1000H		; - - down another 4K
		jmp	short loop64k		; - endwhile
end64k:						; - ...
		mov	esp,edi			; - use the new location as stk
		shr	ecx,2			; - adjust for dword move
		rep	movsd			; - ...
stackok:					; endif
		pop	edi			; restore regs
		pop	esi			; ...
		pop	ecx			; ...
		pop	ebx			; ...
		pop	eax			; ...
		ret	8
__TNK   	endp
__TNC   	endp

_TEXT		ends

		end
