/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  12-dec-87	F.W.Crigger	Initial implementation
---------------------------------------------------------Version 6.5--------
  16-aug-88	F.W.Crigger	abort changed to go indirect thru __abort.
				If signal is used, it will change it to
				point to a rtn that issues a "raise(SIGABRT)".
---------------------------------------------------------Version 7.0--------
  30-mar-89	F.W.Crigger	Prototype changed for 386
  23-may-90	F.W.Crigger	call __terminate in case raise(SIGABRT) returns
  12-jul-91	J.B.Schueler	macrotized references to R/W data
  28-jan-91	J.B.Schueler	added aborts pragma to prevent bug in stack
				model
  25-oct-92	B.J. Stecher	POSIX says that abort() should do a clean
  				shutdown on the stream I/O system, so added
				call through __ioexit.
  16-dec-92	B.J. Stecher	use POSIX compliant abort code for QNX
  13-feb-93	B.J. Stecher	ioexit done through a finalizer
  25-apr-93	B.J. Stecher	explicitly call finializers to get a clean
  				shutdown on the stream I/O system (again)!
  11-nov-93	Greg Bentz	rationalize exit_with_msg
  28-jan-94	Greg Bentz	change exit_with_msg to __fatal_runtime_error
--------------------------------------------------------Version-11.0---------
  01-jun-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <stdio.h>
#include <stdlib.h>
#include "rtdata.h"
#include "exitwmsg.h"
#include <signal.h>
#if defined(__QNX__)
#include <unistd.h>
#endif

void __terminate();

#if !defined(__PENPOINT__)
void	(*_RWD_abort)() = __terminate;
#endif

#if defined(__QNX__)
/*
 * abort() the u**x way
 */
#include "initfini.h"

_WCRTLINK void abort(void)
{
    struct sigaction    oact;
    sigset_t            mask;

    sigaction(SIGABRT,NULL,&oact);
    if( oact.sa_handler == SIG_DFL ) {
				/* '0' is not the right value here */
	__FiniRtns( 0, 255 );	/* get the I/O system shut down */
    }
    sigfillset(&mask);
    sigdelset(&mask,SIGABRT);
    sigprocmask(SIG_SETMASK,&mask,(sigset_t *)NULL);
    raise(SIGABRT);
    signal(SIGABRT,SIG_DFL);
    raise(SIGABRT);
    __terminate();
}
#else

_WCRTLINK void abort()
{
    (*_RWD_abort)();
    __terminate();			    /* 23-may-90 */
}

#endif

void __terminate()
{
    __fatal_runtime_error( "ABNORMAL TERMINATION\r\n", EXIT_FAILURE );
}
