/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  22-nov-86	F.W.Crigger	Initial implementation
  13-dec-87	A.F.Scian	made atexit fail to add more functions
				if exit handling has been initiated
---------------------------------------------------------Version 6.0--------
  25-apr-88	F.W.Crigger	split off from cmain.c
---------------------------------------------------------Version 7.0--------
  08-may-89	F.W.Crigger	_full_at_exit_rtn moved here from exit.c
  19-jun-91	F.W.Crigger	_Full_at_exit_rtn made global for overlays
  12-jul-91	J.B.Schueler	macrotized R/W data references
  24-sep-92	A.F.Scian	added __outside_CLIB pragma to fn ptrs
--------------------------------------------------------Version-11.0---------
  22-feb-95	Greg Bentz	alpha support
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  01-jun-95	Greg Bentz	dll linkage
  27-oct-95	Alex Brodsky	Full_at_exit_rtn will now only execute once
  				avoiding possible crahses if called twice.
  01-dec-95	Greg Bentz	drive atexit() processing with a fini routine
*/
#include "variety.h"
#include <stdio.h>
#include <stdlib.h>
#include "rtdata.h"
#include "extfunc.h"
#include "rtinit.h"

#define EXIT_LIMIT	32

static	void    (* _HUGEDATA _ExitList[EXIT_LIMIT])();
static	int	_ExitCount;

int atexit( void (*func)(void) )
    {
	if( _ExitCount < EXIT_LIMIT ) {
	    _ExitList[ _ExitCount++ ] = func;
	    return( 0 );		/* indicate added successfully */
	}
	return( -1 );			/* indicate no room */
    }

typedef void exit_fn();
#if defined(_M_IX86)
    #pragma aux (__outside_CLIB) exit_fn;
#endif

static void _Full_at_exit_rtn()
    {
	int count;
	exit_fn *func;

	count = _ExitCount;
	if( count == ( EXIT_LIMIT + 1 ) ) return;/*already done once*/
	_ExitCount = EXIT_LIMIT + 1;/* prevent others being registered */
	/* call functions in reverse order of their registration */
	while( count != 0 ) {
	    --count;
	    func = _ExitList[ count ];
	    (*func)();		       /* invoke user exit routine */
	}
    }

AYI( _Full_at_exit_rtn, INIT_PRIORITY_PROGRAM+32 );
