/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986,1991 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  22-nov-86     F.W.Crigger     Initial implementation
  16-feb-87     M.Glaum         Fix Command Line
  14-sep-87     F.W.Crigger     Don't remove quotes from parms
  21-oct-87     F.W.Crigger     Added fcloseall routine
  02-nov-87     A.F.Scian       made quoted parms like Microsoft and Turbo
  12-nov-87     F.W.Crigger     Added call to _setenvp()
  16-nov-87     F.W.Crigger     added fflush for stdxxx in exit.
  02-dec-87     F.W.Crigger     added call to _clock_init().
  08-dec-87     M.Glaum         added big data code
  13-dec-87     A.F.Scian       made atexit fail to add more functions
                                if exit handling has been initiated
  04-jan-88     F.W.Crigger     Allow '\\' in _SplitParms
  04-feb-88     F.W.Crigger     Added _init_files routine
---------------------------------------------------------Version 6.0--------
  03-apr-88     F.W.Crigger     set _amblksiz to 1 for memory allocations
                                done during initialization, then 8K for user.
  25-may-88     F.W.Crigger     _init_files exported for Express
  03-aug-88     A.F.Scian       moved DS expansion from CSTART to here
---------------------------------------------------------Version 6.5--------
  24-oct-88     F.W.Crigger     _init_files - add logic for _NFILES > 20
                                _iomode array moved to this file
  07-dec-88     F.W.Crigger     clock initialization done by cstart now
                                Do indirect call through _main_entry_ to
                                get to user's program instead of always
                                calling _init_argv and then main
  19-dec-88     F.W.Crigger     __Null_argv() defined so main works in overlay
  18-jan-89     F.W.Crigger     parms added to prototype for _main_entry
---------------------------------------------------------Version 7.0--------
  17-apr-89     F.W.Crigger     Adapted for 386
  89-05-25      John Dahms      split out _NFiles and iomode variables
  13-jul-89     John Dahms      Added call to brk( _STACKTOP )
  15-jan-91     F.W.Crigger     Must set _curbrk in cstart to _STACKTOP
  03-apr-91     A.F.Scian       changed initial setting of _amblksiz to 32k
---------------------------------------------------------Version 8.5--------
  03-dec-91	G. Coschi	support for OS/2 2.0
---------------------------------------------------------Version 9.0--------
  04-mar-92	F.W.Crigger	___Argc, ___Argv moved to separate module
  22-mar-92	Craig Eisler	NT support
  19-may-92	F.W.Crigger	Added code to handle > 20 files in Windows
  21-oct-92	Craig Eisler	ANSI function names for default windowing
  11-nov-92	F.W.Crigger	DLL specific code moved to dllmain.c
  17-nov-92	F.W.Crigger	made _CMain conditional
  22-nov-92	F.W.Crigger	change reference to _iomode array
  12-jan-93	B.J. Stecher	don't need _init_files anymore
  12-jan-93	B.J. Stecher	moved #pragma library statements here
  09-feb-93	A. Gupta	#ifdef'd out _amblksiz for Netware
  11-mar-93	G. Coschi	for OS/2, set maximum handle count to what the
  				system says it is
  01-oct-93	A.F.Scian	move initialization of NT file handles to
  				a spot where it will happen before the
				init routines start executing (C++ code
				may do some I/O!)
  17-nov-94	Greg Bentz	add NT default COFF import libraries
  20-dec-94	D. Wellstood	add more NT default COFF import libraries
  09-feb-95	Greg Bentz	change mfcans32 to mfwans32
--------------------------------------------------------Version-11.0---------
  01-jun-95	Greg Bentz	variety.h and dll linkage
  05-jul-95	Greg Bentz	Alpha doesn't need all the libraries
  09-aug-95	T. Schiller	added page locking support for interrupt
				functions under DOS/4G
  23-aug-95	A.F.Scian	removed reference to nt.lib for 11.0
  15-sep-95	Greg Bentz	ppc support
  18-nov-96	Greg Bentz	removed reference to psxdll.lib
  30-jan-97	T. Schiller	turned off setting _amblksiz to 32K for
				Win32 since we like the value coming out
				of amblksiz.c
*/

#include "variety.h"
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#if defined(__DOS_386__)
    #include "extender.h"
    #include "dpmi.h"
#elif defined(__OS2__)
    #define INCL_DOSFILEMGR
    #include <wos2.h>
#elif defined(__WINDOWS_386__) || defined(__NT__)
    #include <windows.h>
#endif

#if defined(__NT__)
    #pragma library("advapi32")
    #pragma library("comdlg32")
    #pragma library("gdi32")
    #pragma library("kernel32")
    #pragma library("user32")
    #pragma library("winspool")
    #pragma library("shell32")
    #pragma library("version")
    #pragma library("netapi32")
    #pragma library("dlcapi")
    #pragma library("lz32")
    #pragma library("mpr")
    #pragma library("ole32")
    #pragma library("rpcns4")
    #pragma library("rpcrt4")
    #pragma library("vdmdbg")
    #pragma library("win32spl")
    #pragma library("winmm")
    #pragma library("winstrm")
    #pragma library("wsock32")
#elif defined(__OS2__)
    #if defined(__PPC__)
    #else
	#pragma library("os2386")
    #endif
    unsigned		__hmodule;
#endif

#ifdef __DOS_386__
    extern     __GETDSStart_;
    extern     __GETDSEnd_;
    extern int __DPMI_hosted(void);
#endif

void	__CommonInit()
/********************/
{
#if !defined(__NETWARE__) && !defined(__NT__)
    _amblksiz = 32 * 1024;	/* set minimum memory block allocation */
#endif

#ifdef __DOS_386__
    /*
     * If we are running under DOS/4G then we need to page lock interrupt
     * handlers (since we could be running under VMM).
     */
    if (!_IsPharLap() && (__DPMI_hosted() == 1))
    {
	DPMILockLinearRegion((long)&__GETDSStart_,
	    ((long)&__GETDSEnd_ - (long)&__GETDSStart_));
    }
#endif
}
