/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  26-oct-92	J.B.Schueler	Added dynamic allocation for cvt buffer
  23-nov-92	F.W.Crigger	moved to here from efcvt.c
  18-jun-93	John Dahms  	all library allocations use lib_xxx routines
  11-nov-93	Greg Bentz	rationalize exit_with_msg
  28-jan-94	Greg Bentz	change exit_with_msg to __fatal_runtime_error
--------------------------------------------------------Version-11.0---------
  02-mar-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  01-jun-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include "widechar.h"
#include <stdlib.h>
#include "liballoc.h"
#include "rtdata.h"
#include "exitwmsg.h"
#if defined(__SW_BM)
#include "thread.h"
#endif

#ifndef __PENPOINT__
    #ifndef __SW_BM
	static CHAR_TYPE	cvt_buffer[20];
    #endif
#endif

_WCRTLINK CHAR_TYPE *__CVTBuffer()
{
#if defined(__PENPOINT__)
    if( _RWD_cvtbuf == NULL ) {
	_RWD_cvtbuf = lib_malloc( 20 * sizeof( wchar_t ) );
	if( _RWD_cvtbuf == NULL ) {
	    __fatal_runtime_error(
		"Not enough memory to allocate cvt buffer\r\n", 1 );
	}
    }
#endif
    return( (CHAR_TYPE *)_RWD_cvtbuf );
}
