/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1995, by WATCOM International Inc. All rights %
 *%       reserved. No part of this software may be reproduced        %
 *%       in any form or by any means - graphic, electronic or        %
 *%       mechanical, including photocopying, recording, taping       %
 *%       or information storage and retrieval systems - except       %
 *%       with the written permission of WATCOM International Inc.    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  03-mar-95	Greg Bentz	defined
--------------------------------------------------------Version-11.0---------
*/
#include "variety.h"
#define	INCL_WIN
#define	INCL_DOSFILEMGR
#define INCL_DOSMODULEMGR
#include <os2.h>
#include <stdlib.h>
#include <string.h>

#define message \
    "This Dynamic Link Library is already in use.\n\n" \
    "The Watcom OS/2 32bit runtime library does not support "\
    "attaching more than one process to a Dynamic Link Library "\
    "that does not have a separate data space for each attached process.\n"

static char dllname[_MAX_PATH];
static char buf[sizeof(message)+sizeof(dllname)+6];

static char *my_strcat( char *p, char *msg ) {
    while( *msg ) {
	*p = *msg;
	if( *p == '\n' ) {
	    *p = '\r';
	    p++;
	    *p = '\n';
	}
	p++;
	msg++;
    }
    return( p );
}

int __disallow_single_dgroup( unsigned hmod ) {

    int		use_pm = 0;
    HMQ		hMessageQueue = 0;
    HAB		AnchorBlock = 0;

    DosQueryModuleName( hmod, sizeof( dllname ), dllname );

    AnchorBlock = WinInitialize( 0 );
    if( AnchorBlock != 0 ) {
	hMessageQueue = WinCreateMsgQueue( AnchorBlock, 0 );
	if( hMessageQueue != 0 ) {
	    use_pm = 1;
	} else {
	    int rc;
	    rc = WinGetLastError( AnchorBlock );
	    if( (rc & 0xffff) == PMERR_MSG_QUEUE_ALREADY_EXISTS ) {
		use_pm = 1;
	    }
	}
    }
    if( use_pm ) {
	WinMessageBox( HWND_DESKTOP, 0, message, dllname, 0, MB_NOICON | MB_OK );
    } else {
	HFILE file;
	ULONG written;
	ULONG action;
	char *p = buf;
	p = my_strcat( p, dllname );
	p = my_strcat( p, "\n" );
	p = my_strcat( p, message );
	*p = 0;
	DosOpen( "CON", &file, &action, 0, 0, 0, OPEN_ACCESS_WRITEONLY, 0 );
	if( file != -1 ) {
	    DosWrite( file, buf, strlen( buf ), &written );
	    DosClose( file );
	}
    }
    if( hMessageQueue != 0 ) {
	WinDestroyMsgQueue( hMessageQueue );
    }
    if( AnchorBlock != 0 ) {
	WinTerminate( AnchorBlock );
    }
    return( 1 );
}
