/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  30-jul-87	A.F.Scian	defined
  16-aug-89	John Dahms	Added multi-thread & OS/2 support
  07-may-90	J.B.Schueler	Added QNX specific code (leave out DOSERRNO)
  21-may-91	J.B.Schueler	Added PENPOINT code (leave out DOSERRNO)
  30-nov-91	G. Coschi	support for unlimited threads in OS/2
   9-oct-93	B.J. Stecher	QNX magic memory changes
--------------------------------------------------------Version-11.0---------
  01-jun-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include "rtdata.h"

#if defined(__QNX__)

#include <sys/magic.h>
#include <errno.h>

_WCRTLINK int *__get_errno_ptr()
{
#if defined(__386__)
    void	*err_ptr;

    __getmagicvar( &err_ptr, _m_errno_ptr );
    return( err_ptr );
#else
    return( (int *)&__MAGIC.Errno );
#endif
}

#elif defined(__PENPOINT__)

_WCRTLINK int *__get_errno_ptr()
{
    return( &_RWD_errno );
}

#else

#include "errorno.h"

#if !defined( __SW_BM )
    _WCRTLINK int		errno;
    _WCRTLINK int		_doserrno;
#endif

_WCRTLINK int *__get_errno_ptr()
{
    return( &_RWD_errno );
}

_WCRTLINK int *__get_doserrno_ptr()
{
    return( &_RWD_doserrno );
}

#endif
