/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  22-nov-86     F.W.Crigger     Initial implementation
  21-oct-87     F.W.Crigger     Added fcloseall routine
  16-nov-87     F.W.Crigger     added fflush for stdxxx in exit.
  13-dec-87     A.F.Scian       made atexit fail to add more functions
                                if exit handling has been initiated
---------------------------------------------------------Version 6.0--------
  25-apr-88     F.W.Crigger     split off from cmain.c
  08-may-88     F.W.Crigger     _ioexit introduced
  19-may-88     F.W.Crigger     _int23_exit introduced
---------------------------------------------------------Version 7.0--------
  08-may-89     F.W.Crigger     atexit handling moved to atexit.c
  31-jul-89     F.W.Crigger     __FPE_handler_exit added
  25-jul-90     B.J.Stecher     commented out include of io.h
  13-aug-90     F.W.Crigger     Added pragma for __exit to force parm into AL
  25-oct-90     J.B.Schueler    QNX version does not support int23 or FPE
                                handler exits
  30-jan-91     C.G.Eisler      Windows 386 can do without the above, either
  03-apr-91     C.G.Eisler      updated for WINDOWS_386 macro
  12-apr-91     G. Coschi       added call to exit routine for default
                                windowing environment
  23-sep-91	C.G.Eisler	added __exit_with_msg for windows
  04-dec-91	G. Coschi	changes for OS/2 2.0
  10-apr-92	John Dahms	call int23_exit before calling ioexit! This
  				solves the infamous crash on control break
				problem.
  21-oct-92	Craig Eisler	ANSI function names for default windowing
  29-oct-92	Craig Eisler	__exit should not be pragma'ed if it is
  				implemented in C (OS2 2.0 and NT)
  28-jan-92	Ashish Gupta	modified for Netware
  13-feb-93	B.J. Stecher	ioexit done through a finializer
  04-oct-93	A.F.Scian	#include "rtdata.h" to get prototype for
  				__exit
  10-nov-93	Greg Bentz	make sure copy in __exit_with_msg will stop
  11-nov-93	Greg Bentz	move exit_with_msg to xmsgwin.c
--------------------------------------------------------Version-11.0---------
  01-jun-95	Greg Bentz	variety.h and dll linkage
  01-dec-95	Greg Bentz	drive atexit() processing with a fini routine
  05-jan-95	Greg Bentz	Win386 doesn't invoke finirtns in exit when
  				running in a DLL
  09-may-97	Alex Brodsky	Added _UnloadCLib so that 16 bit OS/2 DLLs
  				can be notified that they are about to die
				and hence release their memory.
  14-nov-97	Greg Bentz	make sure exit runs the right number
  				of FiniRtns() in a parent exe image
*/

#include "variety.h"
#include "rtdata.h"
#include "exitwmsg.h"
#include "initfini.h"
#include "rtinit.h"
#include <stdio.h>
#include <stdlib.h>
#if defined(__WINDOWS__) || defined(__WINDOWS_386__)
#include <windows.h>
#endif

/*
  __int23_exit is used by OS/2 as a general termination routine which unhooks
  exception handlers.  A better name for this variable is __sig_exit.
  __sig_exit should be the system dependent signal termination routine and
  should replace the calls to __int23_exit and __FPE_handler_exit.
  Each OS should define its own __sig_exit and do the appropriate thing (for
  example, DOS version would call __int23_exit and __FPE_handler_exit)
*/

#ifdef __NETWARE__
extern  void 		_exit( int );
#endif

#if defined(__WINDOWS_386__)
extern  char 		__Is_DLL;
#endif

#if defined(__NT__) || defined(__WARP__)
extern  char 		__Is_DLL;
_WCRTLINK extern void (*__process_fini)(unsigned,unsigned);
#endif


#if !defined(__QNX__) && !defined(__WINDOWS_386__)
void	__null_int23_exit() {}              /* SIGNAL needs it */
void    (*__int23_exit)() = __null_int23_exit;
static void _null_exit_rtn() {}
void    (*__FPE_handler_exit)() = _null_exit_rtn;
#endif

#if defined( __WINDOWS__ ) || defined( __WINDOWS_386__ ) || defined( __OS2__ ) || defined(__NT__)
#define DEFAULT_WINDOWING
extern  void            (*_WindowExitRtn)();
#endif


_WCRTLINK void exit( int status )
    {
#if !defined(__QNX__) && !defined(__WINDOWS_386__)
        (*__int23_exit)();
#endif
#if defined(__QNX__)
	__FiniRtns( 0, 255 );
#elif defined(__WINDOWS_386__)
	if( !__Is_DLL ) {
	    __FiniRtns( FINI_PRIORITY_EXIT, 255 );
	}
#elif defined(__NT__) || defined(__WARP__)
	if( __Is_DLL ) {
	    if( __process_fini != 0 ) {
		(*__process_fini)( FINI_PRIORITY_EXIT, 255 );
	    }
	} else {
	    __FiniRtns( FINI_PRIORITY_EXIT, 255 );
	}
#else
	__FiniRtns( FINI_PRIORITY_EXIT, 255 );
#endif
        _exit( status );
    }


#if defined(__OS2_286__) && defined(__SW_BD)
_WCRTLINK void _UnloadCLib( void )
    {
        (*__int23_exit)();
	__FiniRtns( FINI_PRIORITY_EXIT, 255 );
        (*__int23_exit)();
        (*__FPE_handler_exit)();
        __FiniRtns( 0, FINI_PRIORITY_EXIT-1 );
    }
#endif


#ifndef __NETWARE__

_WCRTLINK void _exit( int status )
    {
#if !defined(__QNX__) && !defined(__WINDOWS_386__) 
        (*__int23_exit)();
        (*__FPE_handler_exit)();
#endif
#ifdef DEFAULT_WINDOWING
        if( _WindowExitRtn != NULL ) {
            _WindowExitRtn();
        }
#endif
        __exit( status );
    }

#endif
