/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1994, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
  16-feb-94	Greg Bentz	Defined
  14-jul-94	B.J. Stecher	set priv level to same as DS for PharLap
--------------------------------------------------------Version-11.0---------
  01-jun-95	Greg Bentz	variety.h and dll linkage
  20-jun-96	M. Hildebrand	Win386 support.
*/
#include "variety.h"
#include "watcom.h"
#include "extender.h"
#include "dpmi.h"
#include "exitwmsg.h"
#include "rtinit.h"

_WCRTLINK unsigned short   _ExtenderRealModeSelector;

#ifndef __WINDOWS_386__

extern short __get_ds( void );
#pragma aux __get_ds = "mov ax,ds" value[ax];

static void init( void ) {
    if( _IsFlashTek() ) {
	_ExtenderRealModeSelector = __x386_zero_base_selector;
    } else if( _IsPharLap() || _IsOS386() ) {
	/* use same priv level as DS register */
	_ExtenderRealModeSelector = 0x34 | (__get_ds() & 0x03);
    } else if( _IsRationalZeroBase() || _IsCodeBuilder() ) {
	_ExtenderRealModeSelector = __get_ds();
    } else if( _IsRationalNonZeroBase() ) {
	long    result;
	result = DPMIAllocateLDTDescriptors( 1 );
	if( result < 0 ) {
	    __fatal_runtime_error( "Unable to allocate real mode selector", -1 );
	}
	_ExtenderRealModeSelector = result & 0xffff;
	if( DPMISetSegmentLimit( _ExtenderRealModeSelector, 0xfffff ) ) {
	    __fatal_runtime_error( "Unable to set limit of real mode selector", -1 );
	}
    } else {
	_ExtenderRealModeSelector = 0;
    }
}

static void fini( void ) {
    if( _IsRationalNonZeroBase() ) {
	DPMIFreeLDTDescriptor( _ExtenderRealModeSelector );
    }
}

#else

static void init( void )
{
    long		result;

    result = DPMIAllocateLDTDescriptors( 1 );
    if( result < 0 ) {
	__fatal_runtime_error( "Unable to allocate real mode selector", -1 );
    }
    _ExtenderRealModeSelector = result & 0xffff;
    if( DPMISetSegmentLimit( _ExtenderRealModeSelector, 0xfffff ) ) {
	__fatal_runtime_error( "Unable to set limit of real mode selector", -1 );
    }
}

static void fini( void )
{
    DPMIFreeLDTDescriptor( _ExtenderRealModeSelector );
}

#endif

AXI( init, INIT_PRIORITY_RUNTIME )
AYI( fini, INIT_PRIORITY_RUNTIME )
