/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986,1991 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  22-nov-86     F.W.Crigger     Initial implementation
  16-feb-87     M.Glaum         Fix Command Line
  14-sep-87     F.W.Crigger     Don't remove quotes from parms
  02-nov-87     A.F.Scian       made quoted parms like Microsoft and Turbo
  04-jan-88     F.W.Crigger     Allow '\\' in _SplitParms
---------------------------------------------------------Version 6.0--------
  25-apr-88     F.W.Crigger     split off from cmain.c
  08-may-88     F.W.Crigger     Use _nmalloc instead of malloc
---------------------------------------------------------Version 6.5--------
  07-dec-88     F.W.Crigger     __Init_Argv routine added
---------------------------------------------------------Version 7.0--------
  25-jul-89     F.W.Crigger     _Not_Enough_Memory check added
---------------------------------------------------------Version 8.0--------
  28-jan-91     F.W.Crigger     Added check for TAB ('\t') characters
  12-feb-91     A.F.Scian       fixed 25-jul-89 change for big data models
  04-jun-91	J.B.Schueler	use malloc rather than _nmalloc for 386 code
  12-jun-91	F.W.Crigger	added support for _argc, _argv for Windows
  14-sep-91	F.W.Crigger	added ___Argc, ___Argv
---------------------------------------------------------Version 9.0--------
  23-jul-92	F.W.Crigger	Make copy of command line so that _LpCmdLine
				continues to point to the raw command line
  15-jan-93	A.F.Scian	large model 'cmdline' pointer has to be a
  				near pointer so that the NULL check works
  18-jun-93	John Dahms  	all library allocations use lib_xxx routines
--------------------------------------------------------Version-11.0---------
  22-feb-95	Greg Bentz	alpha support
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  01-jun-95	Greg Bentz	dll linkage
  27-oct-95	M. Hildebrand	MS-style processing of \ on command line.
  13-dec-95	Greg Bentz	MS-style " processing
  13-dec-95	Greg Bentz	allow for historical behaviour
  16-May-96	A.F.Scian	fixed cast of pointer to (unsigned) to be a cast
  				to char * since the segment will be lost in large
				data models
*/
#ifdef __NETWARE__
    void __Init_Argv( void ) { }
#else
#include "dll.h"	// needs to be first
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include "liballoc.h"

extern	int	    __historical_splitparms;
extern	void	    _Not_Enough_Memory( void );             /* 25-jul-89 */
static	unsigned    _SplitParms( CHAR_TYPE *, CHAR_TYPE **, CHAR_TYPE ** );
_WCRTLINK extern CHAR_TYPE  *__F_NAME(_LpCmdLine,_LpwCmdLine);
_WCRTLINK extern CHAR_TYPE  *__F_NAME(_LpPgmName,_LpwPgmName);
extern	int	    __F_NAME(_argc,_wargc);		/* argument count  */
extern	int	    __F_NAME(__argc,__wargc);		/* argument count  */
extern	CHAR_TYPE **__F_NAME(_argv,_wargv);		/* argument vector */
extern	CHAR_TYPE **__F_NAME(__argv,__wargv);		/* argument vector */
_WCRTLINK extern int	    __F_NAME(___Argc,___wArgc);	/* argument count */
_WCRTLINK extern CHAR_TYPE**__F_NAME(___Argv,___wArgv);	/* argument vector */

void __F_NAME(__Init_Argv,__wInit_Argv)() {
    unsigned	argc;		/* argument count */
    CHAR_TYPE	*endptr;	/* ptr to end of command line */
    unsigned	len;		/* length of command line */
    CHAR_TYPE	*cmdline;	/* copy of command line */
    unsigned	size;		/* amount to allocate */
    unsigned	argv_offset;	/* offset of argv in storage */

    argc = _SplitParms( __F_NAME(_LpCmdLine,_LpwCmdLine), NULL, &endptr ) + 1;
    len = endptr - __F_NAME(_LpCmdLine,_LpwCmdLine) + 1;
    argv_offset = __ALIGN_SIZE(len * sizeof(CHAR_TYPE));
    size = argv_offset + (argc+1) * sizeof(CHAR_TYPE *);
    // round up size for alignment of argv pointer
    size = __ALIGN_SIZE( size );

    #if defined(__REAL_MODE__) && defined(__BIG_DATA__)
	#if defined(__OS2_286__)
	    if( _osmode == DOS_MODE ) {
		cmdline = lib_nmalloc( size );
		if( (void _WCI86NEAR *) cmdline == NULL ) {
		    cmdline = lib_malloc( size );
		}
	    } else {
		cmdline = lib_malloc( size );
	    }
	#else
	    cmdline = lib_nmalloc( size );
	    if( (void _WCI86NEAR *) cmdline == NULL ) {
		cmdline = lib_malloc( size );
	    }
	#endif
    #else
	cmdline = lib_malloc( size );
    #endif

    if( cmdline ) {
	__F_NAME(_argv,_wargv) = (CHAR_TYPE **)(((char*)cmdline) + argv_offset);
	memcpy( cmdline, __F_NAME(_LpCmdLine,_LpwCmdLine), len*sizeof(CHAR_TYPE) );
	__F_NAME(_argv,_wargv)[0] = __F_NAME(_LpPgmName,_LpwPgmName);
	_SplitParms( cmdline, &__F_NAME(_argv,_wargv)[1], &endptr );
	__F_NAME(_argv,_wargv)[argc] = NULL;
	__F_NAME(_argc,_wargc) = argc;
    } else {
	__F_NAME(_argv,_wargv) = NULL;
	__F_NAME(_argc,_wargc) = 0;
    }
    __F_NAME(___Argc,___wArgc) = __F_NAME(_argc,_wargc);
    __F_NAME(___Argv,___wArgv) = __F_NAME(_argv,_wargv);
    __F_NAME(__argc,__wargc) = __F_NAME(___Argc,___wArgc);
    __F_NAME(__argv,__wargv) = __F_NAME(___Argv,___wArgv);
}
	    

static unsigned _SplitParms( CHAR_TYPE *p, CHAR_TYPE **argv, CHAR_TYPE **endptr ) {
    register unsigned argc;
    register CHAR_TYPE *start;
    register CHAR_TYPE *new;
    enum QUOTE_STATE {
	QUOTE_NONE,		/* no " active in current parm */
	QUOTE_DELIMITER,	/* " was first char and must be last */
	QUOTE_STARTED	/* " was seen, look for a match */
    };
    register enum QUOTE_STATE state;

    argc = 0;
    for(;;) {
	while( *p == ' ' || *p == '\t' ) {
	    ++p; /* skip over blanks or tabs */
	}
	if( *p == '\0' ) break;
	/* we are at the start of a parm */
	state = QUOTE_NONE;
	if( *p == '\"' ) {
	    p++;
	    state = QUOTE_DELIMITER;
	}
	new = start = p;
	for(;;) {
	    if( *p == '\"' ) {
		if( !__historical_splitparms ) {
		    p++;
		    if( state == QUOTE_NONE ) {
			state = QUOTE_STARTED;
			continue;
		    } else if( state != QUOTE_NONE ) {
			state = QUOTE_NONE;
			continue;
		    }
		} else {
		    if( state == QUOTE_DELIMITER ) {
			break;
		    }
		}
	    }
	    if( *p == ' ' || *p == '\t' ) {
		if( state == QUOTE_NONE ) {
		    break;
		}
	    }
	    if( *p == '\0' ) break;
	    if( *p == '\\' ) {
		if( !__historical_splitparms ) {
		    if( p[1] == '\"' ) {
			++p;
			if( p[-2] == '\\' ) {
			    continue;
			}
		    }
		} else {
		    if( state == QUOTE_DELIMITER ) {
			if( p[1] == '\"' || p[1] == '\\' ) {
			    ++p;
			}
		    } else {
			if( p[1] == '\"' ) {
			    ++p;
			}
		    }
		}
	    }
	    if( argv ) {
		*(new++) = *(p++);
	    } else {
		++p;
	    }
	}
	if( argv ) {
	    argv[ argc ] = start;
	    ++argc;

	    /*
	      The *new = '\0' is req'd in case there was a \" to "
	      translation. It must be after the *p check against
	      '\0' because new and p could point to the same char
	      in which case the scan would be terminated too soon.
	    */

	    if( *p == '\0' ) {
		*new = '\0';
		break;
	    }
	    *new = '\0';
	    ++p;
	} else {
	    ++argc;
	    if( *p == '\0' ) {
		break;
	    }
	    ++p;
	}
    }
    *endptr = p;
    return( argc );
}
#endif
