/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  08-may-88	F.W.Crigger	split away from exit.c
------------------------------------------------------------Version 6.5--------
  24-oct-88	F.W.Crigger	__NFiles introduced to replace _NFILES constant
  16-feb-90	J.B.Schueler	for QNX, added conditional for stdaux, stdprn
   2-Dec-90	B.J. Stecher	for QNX, allow any number of FILE structures
  27-may-91	J.B.Schueler	support for PENPOINT added
  28-dec-92	B.J. Stecher	call __flush for better modularity
   3-jan-93	B.J. Stecher	all systems use linked FILE structs
   3-feb-93	A. Gupta	added _FiniAccess() calls for standard files
   				to deallocate their semaphores (Netware only)
  13-feb-93	B.J. Stecher	__full_io_exit is called as a finializer
   9-apr-93	B.J. Stecher	added call to __purgefp in full_io_exit
  25-apr-93	B.J. Stecher	fake things out so that non-NETWARE systems
  				don't close their standard IO handles
--------------------------------------------------------Version-11.0---------
  15-may-95     T. Schiller     Fixed bug where temporary files would not
                                be closed if a call to freopen() would close
				one of the standard file handles.
  01-jun-95	Greg Bentz	variety.h and dll linkage
*/
#include "variety.h"
#include <stdio.h>
#include "rtdata.h"

extern void	__purgefp(void);
extern int	__shutdown_stream( FILE *fp, int );

void __full_io_exit()
{
    docloseall( 0 );
    __purgefp();
}

_WCRTLINK int fcloseall()
{
    return( docloseall( NUM_STD_STREAMS ) );
}

static int docloseall( unsigned dont_close )
{
    FILE	    *fp;
    int		    number_of_files_closed;
    __stream_link   *link;
    __stream_link   *next;
    FILE	    *bottom;
    FILE	    *standards;
    int		    close_handle;

    bottom = &_RWD_iob[dont_close];
    standards = &_RWD_iob[NUM_STD_STREAMS];
    number_of_files_closed = 0;
    for( link = _RWD_ostream; link != NULL; link = next ) {
	next = link->next;
	fp = link->stream;
	close_handle = 1;
	if ((fp->_flag & _DYNAMIC) || (fp->_flag & _TMPFIL))
	{
	    __shutdown_stream( fp, close_handle );
	    ++number_of_files_closed;
	}
	else if( fp >= bottom ) {
#ifndef __NETWARE__
	    /* close the file, but leave the handle open */
	    if( fp < standards ) {
		close_handle = 0;
	    }
#endif
	    __shutdown_stream( fp, close_handle );
	    ++number_of_files_closed;
	}
    }
    return( number_of_files_closed );
}
