/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1996, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-11.0---------
  04-jan-96	T. Schiller	initial implementation
 */
#include <windows.h>
#include <setjmpex.h>

extern int _ProcSetsFP(void *);
extern void *RtlLookupFunctionEntry(unsigned long);
extern void  RtlUnwind(unsigned long, unsigned long, void *, unsigned long);
extern void  RtlUnwindRfp(unsigned long, unsigned long, void *, unsigned long);

typedef struct
{
    unsigned long sp;
    unsigned long pc;
    unsigned long seb;
    unsigned long type;
    unsigned long notused[2];
    unsigned long fp;
} _JUMPEXDATA;

void longjmpex(jmp_buf jb, int ret)
{
    EXCEPTION_RECORD  er;
    _JUMPEXDATA      *jd = (_JUMPEXDATA *)jb;

    er.ExceptionCode           = 0xE5670123;
    er.ExceptionFlags          = 0x00000002;
    er.ExceptionRecord         = 0L;
    er.ExceptionAddress        = 0L;
    er.NumberParameters        = 1L;
    er.ExceptionInformation[0] = jd->sp;

    if (!_ProcSetsFP(RtlLookupFunctionEntry(jd->pc)))
	RtlUnwind(jd->sp, jd->pc, &er, ret);
    else
	RtlUnwindRfp(jd->fp, jd->pc, &er, ret);
} /* longjmp() */
