/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  91/07/03	G. Coschi	initial implementation
  ----------------------------------------------- Version 9.0 -------
  92/08/04	D.J.Gaudet	make argv[0] the path to the executable
  92/10/26	Greg Bentz	make InitRtns() come after InitThreadProc
  92/11/07	F.W.Crigger	cleaned up thread support
  93/02/16	G. Coschi	__OS2Init() takes argument indicating if in
  				a DLL
--------------------------------------------------------Version-11.0---------
  97/11/14	Greg Bentz	make sure __exit runs the right number
  				of FiniRtns() in a parent exe image
*/
#include "variety.h"
#define INCL_DOSMISC
#define INCL_DOSSEMAPHORES
#define INCL_DOSPROCESS
#define INCL_DOSEXCEPTIONS
#include <wos2.h>

#include <stdio.h>
#include <io.h>
#include <i86.h>
#include <stdlib.h>
#include <string.h>

#include "osthread.h"
#include "stacklow.h"
#include "sigtab.h"
#include "rtdata.h"
#include "exitwmsg.h"
#include "initfini.h"
#include "rtinit.h"
#include "liballoc.h"

extern unsigned		__hmodule;
unsigned short		__saved_CS;

thread_data		*__AllocInitThreadData( thread_data * );
thread_data		*__FirstThreadData;

static void *__SingleThread()
{
    return( __FirstThreadData );
}

static int  __NullInitAccessRtn( int hdl ) { return hdl; }
static void __NullAccessRtn( int hdl ) { hdl = hdl; }
static void __NullAccIOBRtn(void) {}
static void __NullAccHeapRtn(void) {}
static void __NullAccTDListRtn(void) {}

_WCRTLINK void	*(*__GetThreadPtr)() = &__SingleThread;
void	(*_AccessFileH)(int)	 = &__NullAccessRtn;
void	(*_ReleaseFileH)(int)	 = &__NullAccessRtn;
int	(*_InitAccessH)(int)	 = &__NullInitAccessRtn;
void	(*_FiniAccessH)(int)	 = &__NullAccessRtn;
void	(*_AccessIOB)(void)	 = &__NullAccIOBRtn;
void	(*_ReleaseIOB)(void)	 = &__NullAccIOBRtn;
void	(*_AccessNHeap)(void)	 = &__NullAccHeapRtn;
void	(*_AccessFHeap)(void)	 = &__NullAccHeapRtn;
void	(*_ReleaseNHeap)(void)	 = &__NullAccHeapRtn;
void	(*_ReleaseFHeap)(void)	 = &__NullAccHeapRtn;
void	(*_AccessTDList)(void)	 = &__NullAccTDListRtn;
void	(*_ReleaseTDList)(void)  = &__NullAccTDListRtn;

#if defined(_M_IX86)
extern	unsigned short	GetCS(void);
#pragma aux GetCS modify exact [ax] value [ax] = "mov ax,cs";
extern	unsigned short	GetFS(void);
#pragma aux GetFS modify exact [ax] value [ax] = "mov ax,fs";
extern	int	*GetTIDp(void);
#pragma aux GetTIDp = "mov eax,fs:[12]" value [eax];
extern	unsigned GetThreadStack(void);
#pragma aux GetThreadStack = "mov eax,fs:[4]" value [eax];
#endif

unsigned __threadstack()
/**********************/
{
//    return( (unsigned)__TIBAddr()->tib_pstack );
    return( GetThreadStack() );
}

_WCRTLINK int *__threadid()
/***************/
{
//    return( (int *)(&__TIBAddr()->tib_ptib2->tib2_ultid) );
    return( GetTIDp() );
}

static	void	NullSigInit() {}
static	void	NullSigFini() {}

void	(*__sig_init_rtn)(void) = { &NullSigInit };
void	(*__sig_fini_rtn)(void) = { &NullSigFini };

#if defined(_M_IX86)
#pragma aux _end "*"
#endif
extern	char		_end;

extern	char 		*_Envptr;

_WCRTLINK extern char	    *_LpCmdLine;    /* pointer to command line */
_WCRTLINK extern char	    *_LpPgmName;    /* pointer to program name */
_WCRTLINK extern wchar_t    *_LpwCmdLine;   /* pointer to wide command line */
_WCRTLINK extern wchar_t    *_LpwPgmName;   /* pointer to wide program name */


int			__Is_DLL;	/* TRUE => DLL, else not a DLL */

#if defined(_M_IX86)
#pragma aux __threadstksize "*"
#endif
unsigned	__threadstksize = { 0 };

typedef struct sys_info {
    unsigned long	version_major;
    unsigned long	version_minor;
} sys_info;

void __OS2Init( int, thread_data * );
void __OS2MainInit( EXCEPTIONREGISTRATIONRECORD *xcpt, void *ptr,
		    unsigned hmod, char *env, char *cmd )
/*******************************************************/
{
    thread_data			*tdata;
    char			*args;
    char 			*cmd_path;

    tdata = ptr;
    for( args = cmd; *args != '\0'; ++args ); /* skip over program name */
    ++args;

    _Envptr = env;
    _LpCmdLine = args;
    _LpwCmdLine = lib_malloc( (strlen( _LpCmdLine ) + 1) * sizeof( wchar_t ) );
    _atouni( _LpwCmdLine, _LpCmdLine );
    for( cmd_path = cmd - 2; *cmd_path != '\0'; --cmd_path );
    ++cmd_path;
    _LpPgmName = cmd_path;
    _LpwPgmName = lib_malloc( (strlen( _LpPgmName ) + 1) * sizeof( wchar_t ) );
    _atouni( _LpwPgmName, _LpPgmName );

    __hmodule = hmod;
    __OS2Init( FALSE, tdata );
    /*
      initializers must be executed before signals initialized since
      __sig_init_rtn may get set by an initializer
    */
    __InitRtns( 32 );
    __XCPTHANDLER = xcpt;
    __sig_init_rtn();
    _STACKLOW = (unsigned)&_end;
    __InitRtns( 255 );
}

// this definition needs to occur after __OS2MainInit() so that
// the #undef of _STACKLOW doesn't break things
void __OS2Init( int is_dll, thread_data *tdata )
/**********************************************/
{
    sys_info			_sysinfo;

    __Is_DLL = is_dll;

    tdata = __AllocInitThreadData( tdata );
    __FirstThreadData = tdata;

    DosQuerySysInfo( QSV_VERSION_MAJOR, QSV_VERSION_MINOR,
                     &_sysinfo, sizeof( sys_info )  );
    _osmajor = _sysinfo.version_major;
    _osminor = _sysinfo.version_minor;
    __saved_CS = GetCS();
    {
        #undef _STACKLOW
	extern  unsigned        _STACKLOW;
	_STACKLOW = (unsigned)&_end;		// cortns in F77
    }
    {
	// make sure the iomode array is of the proper length
	// this needs to be done before the InitRtns
	extern	void	__grow_iomode(int);

	LONG	req_count;
	ULONG	curr_max_fh;
	APIRET	rc;

	req_count = 0;
	rc = DosSetRelMaxFH( &req_count, &curr_max_fh );
	if( rc == 0 ) {
	    __grow_iomode( curr_max_fh );
	}
    }
}

_WCRTLINK void (*__process_fini)(unsigned,unsigned) = 0;

void __shutdown_stack_checking( void ) {
    static thread_data dummy_stacklow;

    // make sure we are using the single thread data area
    // this is incase there is a DosExitList active
    __GetThreadPtr = &__SingleThread;
    __FirstThreadData = &dummy_stacklow;
}

_WCRTLINK void __exit( unsigned ret_code )
{
    if( __Is_DLL ) {
	if( __process_fini != 0 ) {
	    (*__process_fini)( 0, FINI_PRIORITY_EXIT-1 );
	}
    } else {
	__FiniRtns( 0, FINI_PRIORITY_EXIT-1 );
	__shutdown_stack_checking();
    }

    DosExit( EXIT_PROCESS, ret_code );
}

