/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1995, by WATCOM International Inc. All rights %
 *%       reserved. No part of this software may be reproduced        %
 *%       in any form or by any means - graphic, electronic or        %
 *%       mechanical, including photocopying, recording, taping       %
 *%       or information storage and retrieval systems - except       %
 *%       with the written permission of WATCOM International Inc.    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  18-jan-95	Greg Bentz	defined for multi-threading support
--------------------------------------------------------Version-11.0---------
  28-may-96	Greg Bentz	make startup behaviour more robust
*/

// these appear ahead of the include files to avoid collisions
// between the _STACKLOW variable and the _STACKLOW macro

extern unsigned _STACKLOW;
struct thread_data *__FirstThreadData = (struct thread_data *)&_STACKLOW;

#include "osthread.h"
#include "stacklow.h"
#include "rtdata.h"

extern void __InitThreadData( thread_data * );

int *__threadid( void )
{
    return( (int *) &(__THREADDATAPTR->thread_id) );
}

static void *__SingleThread()
{
    return( __FirstThreadData );
}

static int  __NullInitAccessRtn( int hdl ) { return hdl; }
static void __NullAccessRtn( int hdl ) { hdl = hdl; }
static void __NullAccIOBRtn(void) {}
static void __NullAccHeapRtn(void) {}
static void __NullAccTDListRtn(void) {}

void	*(*__GetThreadPtr)()	 = &__SingleThread;
void	(*_AccessFileH)(int)	 = &__NullAccessRtn;
void	(*_ReleaseFileH)(int)	 = &__NullAccessRtn;
int	(*_InitAccessH)(int)	 = &__NullInitAccessRtn;
void	(*_FiniAccessH)(int)	 = &__NullAccessRtn;
void	(*_AccessIOB)(void)	 = &__NullAccIOBRtn;
void	(*_ReleaseIOB)(void)	 = &__NullAccIOBRtn;
void	(*_AccessNHeap)(void)	 = &__NullAccHeapRtn;
void	(*_AccessFHeap)(void)	 = &__NullAccHeapRtn;
void	(*_ReleaseNHeap)(void)	 = &__NullAccHeapRtn;
void	(*_ReleaseFHeap)(void)	 = &__NullAccHeapRtn;
void	(*_AccessTDList)(void)	 = &__NullAccTDListRtn;
void	(*_ReleaseTDList)(void)	 = &__NullAccTDListRtn;

void __QNXInit( void *ptr )
/*************************/
{
    unsigned *tmp;

    __InitThreadData( ptr );
    __FirstThreadData = ptr;

    // following is very tricky _STACKLOW intialization
    tmp = &_STACKLOW;
    #undef _STACKLOW
    *tmp = _STACKLOW;
}
