/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  18-aug-92     A.F.Scian       defined
  10-oct-93	B.J. Stecher	handle bound applications
--------------------------------------------------------Version-11.0---------
  17-apr-95	B.J. Stecher	handle Windows & Win386
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  01-jun-95	Greg Bentz	dll linkage
  05-oct-95	M. Hildebrand	Added __NonIBM global variable, initialized
				at startup.
  24-oct-95	M. Hildebrand	Fixed GP fault under 16-bit Windows with
				small data models.
  19-jun-96	M. Hildebrand	Renamed __nonIBM to __is_nonIBM to avoid
				namespace conflict with __NonIBM global.
  19-jun-96	M. Hildebrand	Win386 stack model referenced wrong symbol.
*/
#include "variety.h"
#include <i86.h>
#include <stdlib.h>
#ifdef __WINDOWS_386__
    #include <windows.h>
#endif
#include "extender.h"
#include "nonibm.h"
#include "rtinit.h"

#define is_date_char( c )       (( c >= '0' && c <= '9' ) || c == '/' )
#define BIOS_DATE_LEN           (2+1+2+1+2) /* yy-mm-dd */

#define CHECK_IT						\
    {								\
        int i;							\
        unsigned num_ok;					\
								\
        /* check for IBM BIOS revsion date in ROM */		\
        num_ok = 0;						\
        for( i = 0; i < BIOS_DATE_LEN; ++i ) {			\
            if( is_date_char( p[i] ) ) {			\
                ++num_ok;					\
            }							\
        }							\
        /* wishy-washy test for BIOS dates that */		\
	/* contain some garbage chars. */			\
        /* Commodore PC60-40 has BIOS date "02/0(/88"). */	\
        return( num_ok < (BIOS_DATE_LEN / 2) );			\
    }								


int __is_nonIBM( void )
{
#if defined(__WARP__) || defined(__NT__)
    return( 0 );
#elif defined(__WINDOWS_386__)
    extern	unsigned short	__F000;
    char 	_WCFAR *p;

    p = MK_FP( __F000, 0xfff5 );
    CHECK_IT
#elif defined(__WINDOWS__)
    extern char _WCFAR	_F000h[];
    char _WCFAR *	p;

    p = MK_FP( _F000h, 0xfff5 );
    CHECK_IT
#elif defined(__OS2_286__)
    char _WCFAR *p;

    if( _osmode != DOS_MODE ) return( 0 );
    p = MK_FP( 0xf000, 0xfff5 );
    CHECK_IT
#elif defined(__386__)
    char _WCFAR *p;

    if( _ExtenderRealModeSelector == 0 ) return( 0 );
    p = MK_FP( _ExtenderRealModeSelector, 0xffff5 );
    CHECK_IT
#elif defined(__DOS__)
    char _WCFAR *p;

    p = MK_FP( 0xf000, 0xfff5 );
    CHECK_IT
#else
    #error __is_nonIBM not configured for system
#endif
}



/****
***** If this module is linked in, the startup code will call this function,
***** which will initialize the __NonIBM global variable.
****/

_WCRTLINK int		__NonIBM = -1;	// start at -1 for debugging purposes
					// (-1 ==> not yet initialized)

static init_on_startup( void )
{
    __NonIBM = __is_nonIBM();
}


AXI( init_on_startup, INIT_PRIORITY_LIBRARY )
