/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  28-jan-93	Ashish Gupta	Modified version of Netware's prelude.c
  04-mar-93	John Dahms	don't free __ASTACKPTR -- it's alloca'd
  18-jun-93	John Dahms  	all library allocations use lib_xxx routines
  11-nov-93	Greg Bentz	move exit_with_msg to xmsgnov.c
  26-jul-94	Greg Bentz	make init & fini rtns track level of execution
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  07-jun-95	T. Schiller	Created __FiniMultipleThread() to avoid
                                possible deadlocks during atexit() processing.
*/

#include "variety.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <process.h>
#include <io.h>
#include "liballoc.h"
#include "stacklow.h"
#include "rtdata.h"
#include "exitwmsg.h"
#include "fileacc.h"
#include "initfini.h"

#define MAX_CMDLINE	500

static void		    __NullAccessRtn( int );
static int		    __NullInitAccessRtn( int );
static void		    __NullRtn( void );
extern void		    *__InitThreadProcessing( void );
extern void		    __InitMultipleThread( void );
extern int		    main( int argc, char **argv );

extern void		    ExitThread( int,int );
extern void		    __Must_Have_Three_One_Or_Greater( void );
extern int		    _TerminateNLM( void *, void *, int );
extern int		    _SetupArgv( int (*)( int, char ** ) );
extern long		    _StartNLM( void *, void *, unsigned char *,
				       unsigned char *, long, long,
				       long cdecl (*)(), long, long, void **,
				       void (*)() );
static void		    InitStackLow( void );

extern char		    *_LpPgmName;
extern char		    *_LpCmdLine;
extern int		    _edata;
extern int		    _end;
extern unsigned		    __ASTACKSIZ;
extern char		    *__ASTACKPTR;

void			    (*_AccessFileH)( int ) = &__NullAccessRtn;
void			    (*_ReleaseFileH)( int ) = &__NullAccessRtn;
int			    (*_InitAccessH)( int ) = &__NullInitAccessRtn;
void			    (*_FiniAccessH)( int ) = &__NullAccessRtn;
void			    (*_AccessIOB)( void ) = &__NullRtn;
void			    (*_ReleaseIOB)( void ) = &__NullRtn;
void			    (*_AccessTDList)( void ) = &__NullRtn;
void			    (*_ReleaseTDList)( void ) = &__NullRtn;
int			    __ReturnCode = 5; /* TERM_BY_UNLOAD */
int			    _argc;
char			    **_argv;
extern	unsigned _HUGEDATA  __init_mode[];
extern	unsigned	    *_iomode;

static void		    *NCSp;
static unsigned short	    _saved_DS;
static char		    CommandLine[ MAX_CMDLINE ];
static int		    InitFiniLevel = 0;

#define AllocSignature	    0x54524C41

long AllocRTag;

extern void *Alloc( long __numberOfBytes, long __resourceTag );
extern long SizeOfAllocBlock( void* );

extern void Free( void *__address );

extern long AllocateResourceTag( void *__NLMHandle,
				 char *__descriptionString,
				 long  __resourceType );

#pragma	aux __ASTACKPTR "*"
#pragma	aux __ASTACKSIZ "*"


extern unsigned __SP( void );
#pragma aux __SP = 	\
    "mov eax, esp"	\
    value [ eax ];

extern unsigned short __DS( void );
#pragma aux __DS = 	\
    "mov ax, ds"	\
    value [ ax ];

static void __NullSema4Rtn(void *p) { p = p; }

static void __FiniMultipleThread(void)
{
	_AccessFileH   = &__NullAccessRtn;
	_ReleaseFileH  = &__NullAccessRtn;
	_InitAccessH   = &__NullInitAccessRtn;
	_FiniAccessH   = &__NullAccessRtn;
	_AccessIOB     = &__NullRtn;
	_ReleaseIOB    = &__NullRtn;
	__AccessSema4  = &__NullSema4Rtn;
	__ReleaseSema4 = &__NullSema4Rtn;
	__CloseSema4   = &__NullSema4Rtn;
} /* FiniMultipleThread() */


extern void *_NW_calloc( size_t num,size_t size )
{
    void *ptr;
    long to_alloc;

    to_alloc = num * size;
    ptr = Alloc( to_alloc, AllocRTag );
    if( ptr != NULL ) memset( ptr, 0, to_alloc );
    return( ptr );
}

void *_NW_malloc( size_t size )
{
    return( Alloc( size, AllocRTag ) );
}

void *_NW_realloc( void *old, size_t size, size_t mem_size )
{
    void *new;

    if( old == NULL ) {
       return( _NW_malloc( size ) );
    }
    if( size == 0 ) {
       _NW_free( old );
       return( NULL );
    }
    if( size <= mem_size ) {
        return( old );
    }

    new = _NW_malloc( size );
    if (new == NULL) {
       return( NULL );
    }
    if( size < mem_size ) {
	mem_size = size;
    }
    memcpy( new, old, mem_size );
    _NW_free( old );
    return( new );
}

void _NW_free( void *chunk )
{
    Free( chunk ); // this might call CLIB and might call OS free. Either ok.
}

static int pre_main( int argc, char **argv )
{
    _argc = argc;
    _argv = argv;
    _LpPgmName = lib_malloc( strlen( argv[ 0 ] ) + 1 );
    if( _LpPgmName == NULL ) {
	return( -1 );
    }
    strcpy( _LpPgmName, argv[ 0 ] );
    return( main( argc, argv ) );
}

static void MyExitRtn( void )
{
    __FiniMultipleThread();
    __FiniRtns( 0, InitFiniLevel );
    lib_free( _LpPgmName );
    if( _iomode != __init_mode ) lib_free( _iomode );
    if( __FileHandles != __FHandles ) lib_free( __FileHandles );
    _LpPgmName = NULL;
}

extern int _cstart_( void )
{
    int		retcode;

    _saved_DS = __DS();
    atexit( MyExitRtn );
    if( __InitThreadProcessing() == NULL ) {
	retcode = -1;
    } else {
	__InitRtns( 1 );
	InitFiniLevel = 1;
	__InitMultipleThread();
	_RWD_stacktop = __SP();
	_RWD_stacklow = _RWD_stacktop - stackavail();
	InitStackLow();
	__InitRtns( 255 );
	InitFiniLevel = 255;
	__ASTACKPTR = (char *)alloca( __ASTACKSIZ ) + __ASTACKSIZ;
	retcode = _SetupArgv( pre_main );
    }
    ExitThread( 0, retcode );
    return( 0 );
}

static void InitStackLow( void )
{
    #undef _STACKLOW
    extern unsigned _STACKLOW;

    _STACKLOW = (unsigned)&_end;
}

extern long _Prelude( void *NLMHandle, void *initializationErrorScreenID,
		      unsigned char *cmdLineP,
		      unsigned char *loadDirectoryPath,
	       	      long uninitializedDataLength, long NLMfileHandle,
		      long cdecl ( *readRoutineP )(), long customDataOffset,
		      long customDataSize )
{
    /* make sure that the BSS is set to zero. This overwrites our data too!*/
    memset( (void *)&_edata, 0, (size_t)&_end - (size_t)&_edata );
    AllocRTag = AllocateResourceTag( NLMHandle, "WATCOM static CLIB",
				     AllocSignature );
    _LpCmdLine = CommandLine;
    if( cmdLineP != NULL ) {
	strcpy( _LpCmdLine, cmdLineP );
    }
    return( _StartNLM( NLMHandle, initializationErrorScreenID, cmdLineP,
		      loadDirectoryPath, uninitializedDataLength,
		      NLMfileHandle, readRoutineP, customDataOffset,
		      customDataSize, &NCSp, _cstart_ ) );
}

/* _Stop is the exit procedure for an NLM that uses the C Lib */
extern void _Stop( void )
{
    _TerminateNLM( NCSp, NULL, __ReturnCode );
}

extern void __WATCOM_Prelude( void )
{
}

/* The function __Must_Have_Three_One_Or_Greater is not in CLIB v1.0a
   but is in CLIB v3.1, therefore programs linked with this prelude will
   only run with CLIB v3.1 */
extern void __VersionEnforcement( void )
{
    __Must_Have_Three_One_Or_Greater();
}

static int  __NullInitAccessRtn( int hdl ) { return hdl; }
static void __NullAccessRtn( int hdl ) { hdl = hdl; }
static void __NullRtn( void ) {}

extern void __exit( int rc )
{
    __FiniRtns( 0, InitFiniLevel );
    _exit( rc );
}

extern unsigned short __GETDS( void )
{
    return( _saved_DS );
}
