/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
--------------------------------------------------------Version-11.0---------
  24-may-96	Greg Bentz	defined
*/

#include "variety.h"
#include "osver.h"
#include <stdlib.h>
#include <windows.h>

void __init_stack_limits( unsigned *stacklow, unsigned *stacktop ) {

    unsigned low;
    unsigned top;

    int dummy;
    MEMORY_BASIC_INFORMATION	mbi;
    VirtualQuery( &dummy, &mbi, sizeof( mbi ) );

    top = ((unsigned)mbi.BaseAddress) + mbi.RegionSize;
    low = (unsigned)mbi.AllocationBase;

    if( WIN32_IS_NT ) {
	low += 4096 * 3;
    } else if( WIN32_IS_WIN32S ) {
	low += 4096 * (16 + 2);
    } else {
	// Win 95
	low += 4096 * (16 + 3);
    }
    if( stacklow ) {
	*stacklow = low;
    }
    if( stacktop ) {
	*stacktop = top;
    }
}
