/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  92/06/27	B.J. Stecher	split out from NTMAIN.C
  93/10/01	A.F.Scian	#include "rtdata.h" so that __exit_with_msg
  				compiles as an aborts function
  93/11/11	Greg Bentz	rationalize exit_with_msg
  28-jan-94	Greg Bentz	add __fatal_runtime_error
  13-Dec-94	A.F.Scian	message should go to stderr
--------------------------------------------------------Version-11.0---------
  01-jun-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <windows.h>
#include <io.h>
#include "ntex.h"
#include "rtdata.h"
#include "exitwmsg.h"

_WCRTLINK void __exit_with_msg( char *msg, unsigned retcode )
{
	
    unsigned	len;
    char 	*end;
    ULONG	written;

    end = msg;
    for( len = 0; *end++ != '\0'; len++ );
    WriteFile( NT_STDERR_FILENO, msg, len, &written, NULL );
    __exit( retcode );
}

_WCRTLINK void __fatal_runtime_error( char *msg, unsigned retcode )
{
    if( !__EnterWVIDEO( msg ) ) {
	__exit_with_msg( msg, retcode );
    }
}
