/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  27-may-87	J.Trabandt	split from fclose; proper file positioning added
  14-aug-87	F.W.Crigger	comment out setting of errno; reset buffer
  09-oct-87	F.W.Crigger	change fseek parm from -fp->_cnt to 0L
  09-nov-87	F.W.Crigger	check for NULL fp value
  05-feb-88	F.W.Crigger	change fseek to use SEEK_SET instead of SEEK_CUR
----------------------------------------------------------Version 6.0--------
  02-may-88	F.W.Crigger	No need to do fseek(...) if no read been done
----------------------------------------------------------Version 6.5--------
  17-aug-88	A.F.Scian	new buffered I/O scheme used
  12-nov-88	F.W.Crigger	added "errno = ENOSPC"
----------------------------------------------------------Version 7.0--------
  26-may-89	John Dahms	use posix instead of tinyio for portability
  30-may-89	John Dahms	Added multi-thread support
  24-jun-89	F.W.Crigger	save flags and turn on _BINARY for the write
  29-jun-89	John Dahms	Call setmode instead of using _iomode directly
				for portability (NETWARE 386)
  26-jul-89	John Dahms	Added FILE pointer validation
  10-aug-89	John Dahms	DOS didn't mind if you did a seek of zero bytes
				on a device handle. OS2 does!
  02-aug-90	F.W.Crigger	Call __qwrite instead of setmode and write
  02-jan-91	B.J. Stecher	report error if file not open for writing
  13-feb-92	B.J. Stecher	changed _ERR to _SFERR (IBM used it too)
  13-dec-92	B.J. Stecher	POSIX conformance
  28-dec-92	B.J. Stecher	moved guts to FLUSH.C -- all internal calls
  				should be to __flush, not fflush
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

*/
#include "variety.h"
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include "fileacc.h"
#include "rtdata.h"

extern int	__flush( FILE * );

_WCRTLINK int fflush( FILE *fp )
{
    if( fp == NULL ) {
	flushall();
	return( 0 );
    }
    _ValidFile( fp, EOF );
    return( __flush( fp ) );
}
