/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  27-dec-85	F.W.Crigger	Initial implementation from K. & R.
  12-jan-88	F.W.Crigger	return NULL if EOF and buffer empty
				without modifying the user's buffer.
-------------------------------------------------------------Version 7.0-----
  30-may-89	John Dahms	Added multi-thread support
  26-jul-89	John Dahms	Added FILE pointer validation
  06-sep-91	J.B.Schueler	Proper ANSI specs when EOF encountered
  06-sep-91	J.B.Schueler	Proper ANSI handling of error flags
  13-feb-92	B.J. Stecher	changed _ERR to _SFERR (IBM used it too)
  11-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  23-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  29-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	M. Hildebrand	fgetws checks fo WEOF, not EOF.
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include "fileacc.h"


_WCRTLINK CHAR_TYPE *__F_NAME(fgets,fgetws)( CHAR_TYPE *s, int n, FILE *fp )
{
#ifdef __WIDECHAR__
    wint_t 	c;
#else
    int 	c;
#endif
    CHAR_TYPE       *cs;
    unsigned	oflag;

    _ValidFile( fp, 0 );
    _AccessFile( fp );

    oflag = fp->_flag & (_SFERR|_EOF);			/* 06-sep-91 */
    fp->_flag &= ~(_SFERR|_EOF);
    cs = s;
    
    /* don't use macro version of getc: multi-threading issues */
    #ifdef __WIDECHAR__
	while( --n > 0  &&  (c = fgetwc(fp)) != WEOF ) {
	    if( (*cs++ = c) == L'\n' )  break;
	}
    #else
	while( --n > 0  &&  (c = fgetc(fp)) != EOF ) {
	    if( (*cs++ = c) == '\n' )  break;
	}
    #endif

    if( c == __F_NAME(EOF,WEOF)  &&  (cs == s  ||  ferror(fp) ) ) {
	s = NULL;
    } else {
	*cs = NULLCHAR;
    }
    fp->_flag |= oflag; 				/* 06-sep-91 */
    _ReleaseFile( fp );
    return( s );
}
