/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  21-oct-87	F.W.Crigger	Initial implementation
-----------------------------------------------------------Version 6.5--------
  24-oct-88	F.W.Crigger	__NFiles introduced to replace _NFILES constant
  20-aug-90	F.W.Crigger	created __flushall so that __fill_buffer can
				call it to flush all TTY output buffers
   2-dec-90	B.J. Stecher	for QNX, allow any number of FILE structures
  28-dec-92	B.J. Stecher	call __flush for better modularity
   3-jan-93	B.J. Stecher	all systems used linked FILE structs
--------------------------------------------------------Version-11.0---------
  13-mar-95	M. Hildebrand	Renamed stream_link to __stream_link, added
  				some new fields to it, and modified __iobuf.
  29-may-95	Greg Bentz	variety.h and dll linkage
*/
#include "variety.h"
#include <stdio.h>
#include "rtdata.h"
#include "fileacc.h"

extern	int	__flush( FILE * );

_WCRTLINK int flushall( void )
    {
	return( __flushall( ~0 ) );	/* flush all files */
    }

/* __fill_buffer calls this routine with _ISTTY mask */

int __flushall( int mask )
    {
	__stream_link	*link;
	FILE 		*fp;
	int 		number_of_open_files;

	_AccessIOB();
	number_of_open_files = 0;
	for( link = _RWD_ostream; link != NULL; link = link->next ) {
	    fp = link->stream;
	    if( fp->_flag & mask ) {	  /* if file is a candidate */
		++number_of_open_files;
		if( fp->_flag & _DIRTY ) {
		    __flush( fp );
		}
	    }
	}
	_ReleaseIOB();
	return( number_of_open_files );
    }
