/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  17-mar-87     F.W.Crigger     Initial implementation
  08-dec-87     A.F.Scian       added vfscanf
-----------------------------------------------------------Version 6.5------
  24-aug-88     F.W.Crigger     cget, uncget rtns added
-----------------------------------------------------------Version 7.0------
  30-may-89     John Dahms      Added multi-thread support
  12-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  23-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  09-mar-95	M. Hildebrand	Implemented Normative Addendum:  Changed to
  				reflect stream orientation (wide/byte/none).
  29-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	M. Hildebrand	Check for WEOF in wide char version.
  27-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  05-jun-96	Greg Bentz	fixup some semaphores
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdarg.h>
#include "rtdata.h"
#include "scanf.h"
#include "fileacc.h"


static int cget_file( PTR_SCNF_SPECS specs )
    {
        int c;

        if( (c = __F_NAME(getc,getwc)( (FILE *)specs->ptr )) == __F_NAME(EOF,WEOF) ) {
            specs->eoinp = 1;
        }
        return( c );
    }


static void uncget_file( int c, PTR_SCNF_SPECS specs )
    {
        __F_NAME(ungetc,ungetwc)( c, (FILE *)specs->ptr );
    }


_WCRTLINK int __F_NAME(vfscanf,vfwscanf)( FILE *io, const CHAR_TYPE *format, va_list args )
    {
	int rc;
        auto SCNF_SPECS specs;

        _AccessFile( io );
	/*** Deal with stream orientation ***/
	#ifndef __NETWARE__
	    #ifdef __WIDECHAR__
		if( _FP_ORIENTATION(io) != _WIDE_ORIENTED ) {
		    if( _FP_ORIENTATION(io) == _NOT_ORIENTED ) {
			_FP_ORIENTATION(io) = _WIDE_ORIENTED;
		    } else {
			_ReleaseFile( io );
			return( 0 );	/* closest we have to error return */
		    }
		}
	    #else
		if( _FP_ORIENTATION(io) != _BYTE_ORIENTED ) {
		    if( _FP_ORIENTATION(io) == _NOT_ORIENTED ) {
			_FP_ORIENTATION(io) = _BYTE_ORIENTED;
		    } else {
			_ReleaseFile( io );
			return( 0 );	/* closest we have to error return */
		    }
		}
	    #endif
	#endif

        specs.ptr = (CHAR_TYPE *) io;
        specs.cget_rtn = cget_file;
        specs.uncget_rtn = uncget_file;
        rc = __F_NAME(__scnf,__wscnf)( (PTR_SCNF_SPECS)&specs, format, args );
        _ReleaseFile( io );
	return( rc );
    }


_WCRTLINK int __F_NAME(fscanf,fwscanf)( FILE *io, const CHAR_TYPE *format, ... )
    {
        auto va_list args;

        va_start( args, format );
        return( __F_NAME(vfscanf,vfwscanf)( io, format, args ) );
    }
