/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  23-feb-87	F.W.Crigger	Initial implementation
  07-apr-87	M.A.Glaum	calls to _DOScall
  27-may-87	J.Trabandt	return correct file position, taking current
				state of buffer into account
  04-feb-88	F.W.Crigger	position is affected by _UNGET flag
  05-feb-88	F.W.Crigger	adjust position by # of newlines in text buf
  25-feb-88	F.W.Crigger	counting of '\n' was using _ptr not _base
------------------------------------------------------Version 6.0---------
  23-mar-88	F.W.Crigger	counting of '\n's for TEXT file was looking
				at wrong part of buffer
  11-apr-88	F.W.Crigger	use tinyio
				use memchr function to locate '\n' chars
  02-may-88	F.W.Crigger	Check to see if something in buffer
------------------------------------------------------Version 6.5---------
  17-aug-88	A.F.Scian	new buffered I/O scheme used
------------------------------------------------------Version 7.0---------
  26-may-89	John Dahms	call tell() instead of TinyTell for portability
  30-may-89	John Dahms	Added multi-thread support
  26-jul-89	John Dahms	Added FILE pointer validation
  19-jan-93	A. Gupta	Modified for Netware
  05-feb-93	A. Gupta	changed location of _AccessFile() call to
  				avoid semaphore problems when an invalid
				pointer is passed in 
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage
  16-oct-95	M. Hildebrand	Bugfix: If file pointer not at EOF, and data
				written in append mode, gave wrong result.
*/
#include "variety.h"
#include <stdio.h>
#include <string.h>
#if defined(__PENPOINT__)  ||  defined(__QNX__)
#include <unistd.h>
#else
#include <io.h>
#endif
#include "fileacc.h"


_WCRTLINK long int ftell( FILE *fp )
    {
	long pos;

	_ValidFile( fp, -1 );
	if( fp->_flag & _APPEND  &&  fp->_flag & _DIRTY ) {
	    fflush( fp );   /* if data written in append mode, OS must know */
	}
	pos = tell( fileno( fp ) );
	if( pos == -1 ) {
	    return( -1L );
	}
	_AccessFile( fp );
	if( fp->_cnt != 0 ) {			/* if something in buffer */
	    if( fp->_flag & _DIRTY ) {		/* last operation was a put */
		pos += fp->_cnt;
	    } else {				/* last operation was a get */
		pos -= fp->_cnt;
	    }
	}
	_ReleaseFile( fp );
	return( pos );
    }
