/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  14-Feb-87	A.C.C.Wai	Initial implementation
  31-jul-91	F.W.Crigger	Proper ANSI specs when EOF encountered
  06-sep-91	J.B.Schueler	Proper ANSI handling of error flags
  13-feb-92	B.J. Stecher	changed _ERR to _SFERR (IBM used it too)
  11-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  23-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  29-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	M. Hildebrand	getws checks for WEOF, not EOF.
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/

#include "variety.h"
#include "widechar.h"
#include <stdio.h>


_WCRTLINK CHAR_TYPE *__F_NAME(gets,getws)( CHAR_TYPE *s )
{
#ifdef __WIDECHAR__
    wint_t 	c;
#else
    int 	c;
#endif
    CHAR_TYPE       *cs;
    unsigned	oflag;

    oflag = stdin->_flag & (_SFERR|_EOF); 		/* 06-sep-91 */
    stdin->_flag &= ~(_SFERR|_EOF);
    cs = s;
    #ifdef __WIDECHAR__
	while( (c=(getwc)(stdin)) != WEOF  &&  c != L'\n' )  *cs++ = c;
    #else
	while( (c=(getc)(stdin)) != EOF  &&  c != '\n' )  *cs++ = c;
    #endif
    if( c == __F_NAME(EOF,WEOF)  &&  (cs == s  ||  ferror(stdin) ) ) {
	s = NULL;
    } else {
	*cs = NULLCHAR;
    }
    stdin->_flag |= oflag;				/* 06-sep-91 */
    return( s );
}
