/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986,1993 by WATCOM International Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
   3-jan-93	B.J. Stecher	split out from initfile.c
   9-feb-93	A. Gupta	modified for Netware
  18-jun-93	John Dahms  	all library allocations use lib_xxx routines
   1-feb-94	Greg Bentz	improve OS/2 support
   4-jan-95	Greg Bentz	enable early dos support
--------------------------------------------------------Version-11.0---------
  22-feb-95	Greg Bentz	alpha support
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage
  15-sep-95	Greg Bentz	ppc support
*/
#include "variety.h"
#include <stdio.h>
#include <stdlib.h>
#include "liballoc.h"
#include <string.h>
#ifdef _M_IX86
 #include <i86.h>
#endif
#include <unistd.h>
#include <errno.h>
#include "iomode.h"
#include "fileacc.h"
#include "seterrno.h"

#if defined(__OS2__)
 #define INCL_DOSFILEMGR
 #include <wos2.h>
#elif defined(__WINDOWS__) || defined(__NT__)
 #include <windows.h>
#endif

extern		unsigned	    __NFiles;
extern		void		    __grow_iomode( int num );

#if !defined(__QNX__)
  extern	unsigned _HUGEDATA  __init_mode[];
  extern	unsigned	    *_iomode;
#endif

#if !defined(__NETWARE__) && !defined(__QNX__)
static int sys_grow_handles( int num )
{
    #if defined( __WARP__ )
    {
	LONG	req_count;
	ULONG	curr_max_fh;
	APIRET	rc;

	req_count = num;
	rc = DosSetRelMaxFH( &req_count, &curr_max_fh );
	num = curr_max_fh;
    }
    #elif defined( __OS2_286__ )
    {
	int	rc;

	rc = DosSetMaxFH( num );
	if( rc != 0 ) {
	    if( rc == ERROR_NOT_ENOUGH_MEMORY ) {
		__set_errno_dos( rc );
		return( __NFiles );
	    } else {
		int i = num;
		for( ;; ) {
		    rc = DosSetMaxFH( i );
		    if( rc == ERROR_NOT_ENOUGH_MEMORY ) break;
		    if( rc == 0 ) break;
		    if( i > (num+256) ) break;
		    i++;
		}
		if( rc != 0 ) {
		    __set_errno_dos( rc );
		    return( __NFiles );
		} else {
		    num = i;
		}
	    }
	}
    }
    #elif defined(__WINDOWS__) || defined(__NT__)
	num = SetHandleCount( num );
    #elif defined(MSDOS)
        /* increase the number of file handles beyond 20 */

        if( _osmajor > 3 || ( _osmajor == 3 && _osminor >= 30 ) ) {
	    extern long _Set_File_Handle_Count( char, unsigned );
	    #if defined(__386__)
		#pragma aux _Set_File_Handle_Count = \
		    "int	0x21"			\
		    "rcl	eax,1"			\
		    "ror	eax,1"			\
		    value [eax]			\
		    parm caller [ah] [ebx]
	    #else
		#pragma aux _Set_File_Handle_Count = \
		    "int	0x21"			\
		    "sbb	dx,dx"			\
		    value [dx ax]			\
		    parm caller [ah] [bx]
	    #endif
            long rc;

	    /* may allocate a segment of memory! */
	    num = (num+1) & ~1; /* make even */
            rc = _Set_File_Handle_Count( 0x67, num );
            if( rc < 0 ) {
                __set_errno_dos( (unsigned)rc );
		return( __NFiles );
            }
        } else {
	    /* code for pre DOS 3.3 */
	    /* makes use of undocumented area of the psp */
	    char	     *new_handles;
	    char _WCFAR * _WCFAR *psp_handles;
	    char	_WCFAR *psp_num_handles;

	    new_handles = (char *)lib_nmalloc( num );
	    if( new_handles == 0 ) {
                __set_errno( ENOMEM );
		return( __NFiles );
	    }
	    _fmemset( new_handles, 0xff, num );

	    psp_num_handles = MK_FP( _psp, 0x32 );
	    psp_handles = MK_FP( _psp, 0x34 );
	    _fmemcpy( new_handles, *psp_handles, *psp_num_handles );

	    _disable();
	    psp_handles = MK_FP( _psp, 0x34 );
	    *psp_handles = new_handles;
	    psp_num_handles = MK_FP( _psp, 0x32 );
	    *psp_num_handles = num;
	    _enable();
        }
    #endif
    return( num );
}
#endif

_WCRTLINK int _grow_handles( int num )
{
    #if defined(__NETWARE__)
	int		*new2;
    #endif

    _AccessIOB();
    if( num > __NFiles ) {
	#if defined(__QNX__)
	    __NFiles = num;
	#else
	    #if !defined(__NETWARE__)
		num = sys_grow_handles( num );
	    #endif
	    if( num > __NFiles ) {
		#if defined(__NETWARE__)
		    if( __FileHandles == __FHandles ) {
			new2 = lib_malloc( num * sizeof( int ) );
			if( new2 != NULL ) {
			    memcpy( new2, __FileHandles, __NFiles * sizeof( int ) );
			}
		    } else {
			new2 = lib_realloc( __FileHandles, num * sizeof( int ), __NFiles * sizeof( int ) );
		    }
		    if( new2 == NULL ) {
			__set_errno( ENOMEM );
		    } else {
			int i;
	
			for( i = __NFiles; i < num; ++i ) {
			    new2[ i ] = NULLHANDLE;
			}
			__FileHandles = new2;
		    }
		#endif
		if( errno != ENOMEM ) {
		    __grow_iomode( num );
		}
	    }
	#endif
    }
    _ReleaseIOB();
    return( __NFiles );
}
