/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986,1993 by WATCOM International Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  23-nov-93	B.J. Stecher	split out from growhdl.c
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage
  12-may-97	Alex Brodsky	Added __shrink_iomode

*/
#include "variety.h"
#include "liballoc.h"
#include <string.h>
#include <errno.h>
#include "iomode.h"
#include "fileacc.h"
#include "rtinit.h"

extern	unsigned	    __NFiles;
extern	unsigned _HUGEDATA  __init_mode[];
extern	unsigned	    *_iomode;
static	unsigned            _init_NFiles;

void __grow_iomode( int num )
{
    unsigned	*new;

    _AccessIOB();
    if( _iomode == __init_mode ) {
	_init_NFiles = __NFiles;
	#ifdef __NETWARE__
	    new = lib_malloc( num * sizeof( unsigned ) );
	#else
	    new = lib_realloc( NULL, num * sizeof( unsigned ) );
	#endif
	if( new != NULL ) {
	    memcpy( new, __init_mode, __NFiles * sizeof(unsigned) );
	}
    } else {
	#ifdef __NETWARE__
	    new = lib_realloc( _iomode, num * sizeof( unsigned ), __NFiles * sizeof( unsigned ) );
	#else
	    new = lib_realloc( _iomode, num * sizeof( unsigned ) );
	#endif
    }
    if( new == NULL ) {
	errno = ENOMEM;
    } else {
	memset( &new[__NFiles], 0, (num-__NFiles)*sizeof(unsigned) );
	_iomode = new;
	__NFiles = num;
    }
    _ReleaseIOB();
}


void __shrink_iomode( void )
{
    _AccessIOB();
    if( _iomode != __init_mode ) {
	lib_free( _iomode );
        _iomode = __init_mode;
	__NFiles = _init_NFiles;
    }
    _ReleaseIOB();
}

AYI(__shrink_iomode,INIT_PRIORITY_IOSTREAM);
