/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%     Copyright (C) 1990, 1992 by WATCOM International. All rights  %
 *%     reserved. No part of this software may be reproduced        %
 *%     in any form or by any means - graphic, electronic or        %
 *%     mechanical, including photocopying, recording, taping       %
 *%     or information storage and retrieval systems - except       %
 *%     with the written permission of WATCOM Systems Inc.          %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  20-sep-92	B.J. Stecher	split out from CMAIN.C
   2-jan-93	B.J. Stecher	use for everybody
   4-jan-93	B.J. Stecher	don't call __chktty -- happens latter
  20-jan-93	A. Gupta	added InitHandles and changed _nmalloc to
  				malloc, for Netware
  10-jun-93	John Dahms	pre-allocate stdio buffers (__ioalloc) for
  				netware, since the memory HAS to be allocated
				by THIS NLM. Memory gets freed when the
				allocating NLM terminates, so if another NLM
				calls printf, our stdout points to HIS memory.
  18-jun-93	John Dahms  	all library allocations use lib_xxx routines
--------------------------------------------------------Version-11.0---------
  13-mar-95	M. Hildebrand	Renamed stream_link to __stream_link, added
  				some new fields to it, and modified __iobuf.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage
0001
*/
#include "dll.h"	// needs to be first
#include "variety.h"
#include <stdio.h>
#include <stdlib.h>
#include "liballoc.h"
#include "rtdata.h"
#include "exitwmsg.h"

#ifdef __NETWARE__

#include "fileacc.h"
extern void __ioalloc( FILE* );

extern unsigned __NFiles;

static void InitHandles( void )
{
    int		j;

    for( j = 0; j < NUM_STD_STREAMS; ++j ) {
	__FileHandles[ j ] = _RWD_iob[ j ]._handle;
    }
    for( ; j < __NFiles; ++j ) {
	__FileHandles[ j ] = NULLHANDLE;
    }
}

#endif

void __InitFiles()
{
    __stream_link _WCI86NEAR *    ptr;
    __stream_link *		link;
    FILE *			fp;

    fp = _RWD_iob;
    #ifdef __NETWARE__
	stdout->_flag &= ~( _IONBF | _IOLBF | _IOFBF );
	stdout->_flag |= _IONBF;
    #endif
    stderr->_flag &= ~( _IONBF | _IOLBF | _IOFBF );
    stderr->_flag |= _IONBF;
    for( fp = _RWD_iob; fp->_flag != 0; ++fp ) {
	#ifdef __NETWARE__
	    ptr = lib_malloc( sizeof( __stream_link ) );
	    __ioalloc( fp );
	#else
	    ptr = lib_nmalloc( sizeof( __stream_link ) );
	#endif
	if( ptr == NULL ) {
	    link = lib_malloc( sizeof( __stream_link ) );
	    if( link == NULL ) {
		__fatal_runtime_error(
		    "Not enough memory to allocate file structures\r\n", 1 );
	    }
	} else {
	    link = ptr;
	}
	link->stream = fp;
	link->next = _RWD_ostream;
	_RWD_ostream = link;
	#ifndef __NETWARE__
	    fp->_link = link;
	    fp->_link->_base = NULL;
	    fp->_link->_tmpfchar = 0;
	    fp->_link->_orientation = _NOT_ORIENTED;
	#endif
    }
    _RWD_cstream = NULL;
    #ifdef __NETWARE__
	InitHandles();
    #endif
}
