/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  04-Jun-86	A.C.C.Wai	taken from putc.c
  27-may-87	J.Trabandt	moved initialization of fp->_ptr to fputc.c
				to avoid redundancy
  14-jul-87	F.W.Crigger	Added call to _IsDevice
  15-oct-87	F.W.Crigger	Added call to isatty
---------------------------------------------------------Version 6.0--------
  26-apr-88	F.W.Crigger	Always allocate big buffer even for devices
				set fp->_ptr = fp->_base
  08-may-88	F.W.Crigger	_ioexit introduced
  21-may-88	F.W.Crigger	Removed calls to _IsDevice and isatty.
				Done by cmain, open, creat.
---------------------------------------------------------Version 7.0--------
  26-may-89	John Dahms	replace _iomode by call to isatty()
  17-apr-90	F.W.Crigger	For TTY, use _IOLBF instead of _IONBF
				For _IOLBF, use 134 as default buffer size
				For _IONBF, use 1 as default buffer size
  09-jul-90	F.W.Crigger	look at _IONBF flag in _iomode (for stdout)
  20-aug-90	F.W.Crigger	Comment out 09-jul-90 change
  28-aug-90	J.B.Schueler	Placed tty buffering check into separate rtn
  12-jul-91	J.B.Schueler	macrotized references to R/W data
  30-aug-91	J.B.Schueler	Added shared memory support for files under
				PenPoint
  17-jul-92	D. Wellstood	Unicode support
  18-jun-93	John Dahms  	all library allocations use lib_xxx routines
--------------------------------------------------------Version-11.0---------
  23-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  14-mar-95	M. Hildebrand	Modified to reflect changes in __iobuf.
  29-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <stdio.h>
#include "liballoc.h"
#if defined(__PENPOINT__)  ||  defined(__QNX__)
#include <unistd.h>
#else
#include <io.h>
#endif
#include "rtdata.h"

extern  void	__chktty(FILE *);


void __ioalloc( fp )
    register FILE *fp;
    {
	__chktty( fp ); 				/* JBS 28-aug-90 */
	if( fp->_bufsize == 0 ) {
	    if( fp->_flag & _IOLBF ) {
		fp->_bufsize = 134;
	    } else if( fp->_flag & _IONBF ) {
		/* note that this is big enough for UNICODE due to */
		/* heap manager rounding up of size */
		fp->_bufsize = 1;
	    } else {
		fp->_bufsize = BUFSIZ;
	    }
	}
#if defined(__PENPOINT__)
	if( fp->_flag & _SHRMEM ) {
	    _FP_BASE(fp) = _smalloc( fp->_bufsize );
	} else {
	    _FP_BASE(fp) = lib_malloc( fp->_bufsize );
	}
#else
	_FP_BASE(fp) = lib_malloc( fp->_bufsize );
#endif
	if( _FP_BASE(fp) == NULL ) {
	    fp->_flag &= ~ ( _IONBF | _IOLBF | _IOFBF );
	    fp->_flag |= _IONBF;	/* can't get big buffer */
	    _FP_BASE(fp) = (char*) &(fp->_ungotten);
	    fp->_bufsize = 1;
	} else {
	    fp->_flag |= _BIGBUF;	/* got big buffer */
	}
	fp->_ptr = _FP_BASE(fp);
	fp->_cnt = 0;
    }
