/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  05-Jan-93	Greg Bentz	defined
  04-Mar-93	Ashish Gupta	added __get_stdin(), __get_stdout(),
  			        __get_stderr() for Netware
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage

    This file is to support the platform independent nature of the C++
    libraries.  Since IOB structures vary in size, we need a method to
    obtain the address of the standard stream __iob structures that doesn't
    rely on the stdin,stdout,stderr macros.
*/

#include "variety.h"
#include <stdio.h>
#include "rtdata.h"

_WCRTLINK FILE *__get_std_stream( unsigned handle ) {
    if( handle > NUM_STD_STREAMS ) {
	return NULL;
    } else {
	return &_RWD_iob[handle];
    }
}


#ifdef __NETWARE__

#include <io.h>

FILE **__get_stdin( void )
{
    static FILE		*stdin_ptr;

    stdin_ptr = __get_std_stream( STDIN_HANDLE );
    return( &stdin_ptr );
}

FILE **__get_stdout( void )
{
    static FILE		*stdout_ptr;

    stdout_ptr = __get_std_stream( STDOUT_HANDLE );
    return( &stdout_ptr );
}

FILE **__get_stderr( void )
{
    static FILE		*stderr_ptr;

    stderr_ptr = __get_std_stream( STDERR_HANDLE );
    return( &stderr_ptr );
}

#endif
