/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1986,1988 by WATCOM Systems Inc. All rights %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  89-05-25	John Dahms	split out of cmain
  90/10/25	J.B.Schueler	Conditional on __iomode array
  90/12/02	B.J. Stecher	Conditional on __NFiles
  92/11/22	F.W.Crigger	Added __IOMode() and __SetIOMode()
  93/01/03	B.J. Stecher	allow iomode to grow
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  29-may-95	Greg Bentz	dll linkage
  14-jul-95	T. Schiller	Fixed check to see if a handle is a std
  				handle.
  27-oct-95	M. Hildebrand	When calling __SetIOMode(handle,0), store 0
				as the flags so _INITIALIZED bit goes away.
*/
#include "variety.h"
#include <stdio.h>
#include <unistd.h>
#include "rtdata.h"

unsigned __NFiles = _NFILES;		/* maximum # of files we can open */

#ifndef __QNX__
unsigned _HUGEDATA __init_mode[_NFILES] = { /* file mode information (flags) */
	_READ,		/* stdin */
	_WRITE, 	/* stdout */
	_WRITE, 	/* stderr */
	_READ|_WRITE,	/* stdaux */
	_WRITE		/* stdprn */
};

unsigned *_iomode = __init_mode;

#define _INITIALIZED	_DYNAMIC

unsigned __IOMode( int handle )
{
    if( handle >= __NFiles ) return( 0 );
    if( handle < NUM_STD_STREAMS && !(_iomode[handle] & _INITIALIZED) ) {
	_iomode[handle] |= _INITIALIZED;
	if( isatty( handle ) ) {
	    _iomode[handle] |= _ISTTY;
	}
    }
    return( _iomode[ handle ] );
}

void __SetIOMode( int handle, unsigned value )
{
    if( value != 0 ) {
	_iomode[handle] = value | _INITIALIZED;
    } else {
	_iomode[handle] = value;    /* we're closing it; smite _INITIALIZED */
    }
}
#endif
