/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  03-apr-92	Craig Eisler	added __GetNTCreateAttr
--------------------------------------------------------Version-11.0---------
  29-may-95	Greg Bentz	variety.h and dll linkage
  25-sep-95	Greg Bentz	fixup share mode handling
  14-jun-96	M. Hildebrand	Fixed above fix.
*/

#include "variety.h"
#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <share.h>
#include "fileacc.h"
#include "openmode.h"
#include <windows.h>

void __GetNTCreateAttr( int mode, LPDWORD desired_access, LPDWORD attr )
{
    if( mode & _A_RDONLY ) {
	*desired_access = GENERIC_READ;
	*attr = FILE_ATTRIBUTE_READONLY;
    } else {
    	*desired_access = GENERIC_READ | GENERIC_WRITE;
	*attr = FILE_ATTRIBUTE_NORMAL;
    }
    if( mode & _A_HIDDEN ) {
	*attr |= FILE_ATTRIBUTE_HIDDEN;
    }
    if( mode & _A_SYSTEM ) {
	*attr |= FILE_ATTRIBUTE_SYSTEM;
    }

}

void __GetNTAccessAttr( int rwmode, LPDWORD desired_access, LPDWORD attr )
{
    if( rwmode == O_RDWR ) {
	*desired_access = GENERIC_READ | GENERIC_WRITE;
	*attr = FILE_ATTRIBUTE_NORMAL;
    } else if( rwmode == O_WRONLY ) {
	*desired_access = GENERIC_WRITE;
	*attr = FILE_ATTRIBUTE_NORMAL;
    } else {
	*desired_access = GENERIC_READ;
	*attr = FILE_ATTRIBUTE_READONLY;
    }
}

void __GetNTShareAttr( int mode, LPDWORD share_mode )
{
    int share;
    int rwmode;

    share = mode&OPENMODE_SHARE_MASK;
    rwmode = mode&OPENMODE_ACCESS_MASK;

    switch( share ) {
    case OPENMODE_DENY_COMPAT:
	/*
	 * Always allow reopening for read.  Since we don't want the same
	 * file opened twice for writing, only allow the file to be opened
	 * for writing hereafter if we're opening it now in read-only mode.
	 *			-- M. Hildebrand, 14-jun-96
	 */
	*share_mode = FILE_SHARE_READ;	/* can always open again for read */
	if( rwmode == OPENMODE_ACCESS_RDONLY ) {
	    *share_mode |= FILE_SHARE_WRITE;	/* can open again for write */
	}
	break;
    case OPENMODE_DENY_ALL:
	*share_mode = 0;
	break;
    case OPENMODE_DENY_READ:
	*share_mode = FILE_SHARE_WRITE;
	break;
    case OPENMODE_DENY_WRITE:
	*share_mode = FILE_SHARE_READ;
	break;
    case OPENMODE_DENY_NONE:
	*share_mode = FILE_SHARE_READ|FILE_SHARE_WRITE;
	break;
    };
}
