/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   17-oct-95	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#include <process.h>
#include <stdio.h>
#include "rtdata.h"


_WCRTLINK int _pclose( FILE *fp )
/*******************************/
{
    int			status;

    /*** Get the return code of the process ***/
    if( _FP_PIPEDATA(fp).isPipe == 0 )	return( -1 );	/* must be a pipe */
    if( fclose( fp ) )	return( -1 );	/* must close pipe before cwait */
    if( cwait( &status, _FP_PIPEDATA(fp).pid, WAIT_CHILD ) == -1 ) {
	return( -1 );
    }

    /*** Handle the return code ***/
    if( (status&0x00FF) == 0 ) {
	return( (status&0xFF00) >> 8 );	/* normal termination */
    } else {
	return( status >> 8 );		/* abnormal termination */
    }
}
