/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  14-Feb-87	A.C.C.Wai	Initial implementation
  06-sep-91	J.B.Schueler	Proper ANSI handling of error flags
  11-Jun-92	D. Wellstood	Unicode support
  				fixed bug where return value was
				incorrect when no error had occurred
  29-Apr-94	Greg Bentz	convention says to return # chars written,
  				this is consistent with ANSI
--------------------------------------------------------Version-11.0---------
  23-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  29-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	M. Hildebrand	putws checks for WEOF, not EOF.
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  27-nov-95	Greg Bentz	fixup const in function definition
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/

#include "variety.h"
#include "widechar.h"
#include <stdio.h>


_WCRTLINK int __F_NAME(puts,putws)( const CHAR_TYPE * s )
{
#ifdef __WIDECHAR__
    wint_t		rc;
    wint_t		result;
#else
    int			rc;
    int			result;
#endif

    rc = __F_NAME(fputs,fputws)( s, stdout );
    if( rc != __F_NAME(EOF,WEOF) ) {
	/* don't use macro version of putc: multi-threading issues */
	#ifdef __WIDECHAR__
	    result = (fputwc)( L'\n', stdout );
	#else
	    result = (fputc)( '\n', stdout );
	#endif
	if( result == __F_NAME('\n',L'\n') ) {
	    rc++;
	} else {
	    rc = result;
	}
    }
    return( rc );
}
