/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  08-dec-87     A.F.Scian       added vscanf
-----------------------------------------------------------Version 6.5------
  24-aug-88     F.W.Crigger     cget, uncget rtns added
  12-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  23-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  29-may-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	M. Hildebrand	Wide char version checks for WEOF, not EOF.
  27-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdarg.h>
#include "scanf.h"


static int cget_stdin( PTR_SCNF_SPECS specs )
    {
        int c;

        if( (c = __F_NAME(getc,getwc)( stdin )) == __F_NAME(EOF,WEOF) ) {
            specs->eoinp = 1;
        }
        return( c );
    }


static void uncget_stdin( int c, PTR_SCNF_SPECS specs )
    {
        __F_NAME(ungetc,ungetwc)( c, stdin );
    }


_WCRTLINK int __F_NAME(vscanf,vwscanf)( const CHAR_TYPE *format, va_list args )
    {
        auto SCNF_SPECS specs;

        specs.cget_rtn = cget_stdin;
        specs.uncget_rtn = uncget_stdin;
        return( __F_NAME(__scnf,__wscnf)( (PTR_SCNF_SPECS)&specs, format, args ) );
    }


_WCRTLINK int __F_NAME(scanf,wscanf)( const CHAR_TYPE *format,... )
    {
        va_list args;

        va_start( args, format );
        return( __F_NAME(vscanf,vwscanf)( format, args ) );
    }
