/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  17-mar-87	F.W.Crigger	Initial implementation
--------------------------------------------------------Version 6.0-------
  08-may-88	F.W.Crigger	_ioexit introduced
--------------------------------------------------------Version 7.0-------
  30-may-89	John Dahms	Added multi-thread support
  26-jul-89	John Dahms	Added FILE pointer validation
  27-aug-90	J.B.Schueler	Added check for non-null buf ptr to size == 0
				check
				Added check for size!=0 when assigning bufsize
  28-aug-90	J.B.Schueler	Added check for tty default buffering
  12-jul-91	J.B.Schueler	macrotized references to R/W data
  21-aug-92	A.F.Scian	check for size > MAX_INT
  13-feb-93	B.J. Stecher	ioexit done through a finalizer
  16-mar-93	F.W.Crigger	call __ioalloc if buffer is NULL so inline
				macros for getc and putc will work
--------------------------------------------------------Version-11.0---------
  14-mar-95	M. Hildebrand	Modified to reflect changes in __iobuf.
  29-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <stdio.h>
#include <stddef.h>
#include <limits.h>
#include "fileacc.h"
#include "rtdata.h"


extern	void	__chktty( FILE *fp );
extern	void	__ioalloc( FILE * );
extern	void	__full_io_exit();


_WCRTLINK int setvbuf( FILE *fp, char *buf, int mode, size_t size )
    {
	__stream_check( fp, 1 );
	__null_check( buf, 2 );
	if( size > INT_MAX ) {
	    /* filling the buffer code can't handle >32k (-ve size) */
	    return( -1 );
	}
	/* check for allowable values for mode */
	switch( mode ) {
	case _IOFBF:
	case _IOLBF:
	case _IONBF:
	    break;
	default:
	    return( -1 );
	}
	if( buf != NULL && size == 0 ) {		/* JBS 27-aug-90 */
	    return( -1 );
	}
	_ValidFile( fp, -1 );
	_AccessFile( fp );
	__chktty( fp ); 				/* JBS 28-aug-90 */
	if( size != 0 ) fp->_bufsize = size;		/* JBS 27-aug-90 */
	_FP_BASE(fp) = buf;
	fp->_ptr  = buf;
	fp->_flag &= ~ (_IONBF | _IOLBF | _IOFBF);	/* FWC 14-jul-87 */
	fp->_flag |= mode;
	if( buf == NULL ) {				/* FWC 16-mar-93 */
	    __ioalloc( fp );
	}
	_ReleaseFile( fp );
	return( 0 );
    }
