/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  18-mar-87	F.W.Crigger	Initial implementation
-------------------------------------------------------------Version 7.0-----
  27-may-89	John Dahms	got rid of _tmpfname variable
  02-aug-90	F.W.Crigger	Moved __remove_tmpfile logic back to fclose
  16-oct-90	J.B.Schueler	rewrote for QNX, always start with 'a'
  30-jan-91	B.J. Stecher	more mods for QNX, delete name immediately
  25-apr-92	B.J. Stecher	put file in TMPDIR, or /tmp.
  16-dec-92	B.J. Stecher	use __tmpdir function
--------------------------------------------------------Version-11.0---------
  14-mar-95	M. Hildebrand	Modified to reflect changes in __iobuf.
  29-may-95	Greg Bentz	variety.h and dll linkage
*/

#include "variety.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include "rtdata.h"
#include "tmpfname.h"

char	*__tmpdir( char * );

#define _TMPFNAME	"__C_TMPx__"
#define _TMPFCHAR	7

_WCRTLINK FILE *tmpfile(void)		/* create a temporary file */
    {
	char	tmpfnext;
	int	fd;
	FILE	*fp;
	char	name[L_tmpnam];
	char	*ptr;

        ptr = __tmpdir( name );
	strcpy( ptr, _TMPFNAME );
	for( tmpfnext = 'a'; ; tmpfnext++ ) {
	    ptr[_TMPFCHAR] = tmpfnext;
	    fd = open( name, O_RDWR|O_CREAT|O_EXCL|O_TEMP, 0666 );
	    if( fd != -1 ) break;
	    if( errno != EEXIST ) return( NULL );
	    if( tmpfnext == 'z' ) tmpfnext = 'A' - 1;
	    if( tmpfnext == 'Z' ) return( NULL );
	}
	fp = fdopen( fd, "wb+" );
	if( fp != NULL ) {
	    /* fp->_flag |= _TMPFIL;
	       -- Don't turn the TMPFIL bit on... we're going to
		  remove the filename from the file system right away.
		  This is allowed under POSIX. The file will be deleted
		  as soon as it's closed */
	    _FP_TMPFCHAR(fp) = tmpfnext;
	} else {
	    close( fd );
	}
	remove( name );
	return( fp );
    }
