/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1991 by WATCOM Systems Inc. All rights      %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-jun-91	F.W.Crigger	Initial implementation (cloned from sprintf)
  10-jul-92	D. Wellstood	Unicode Support
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  31-may-95	Greg Bentz	variety.h and dll linkage
  01-nov-95     Greg Bentz	QNX -3s register convention
*/

#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdarg.h>
#include "printf.h"

struct	buf_limit {
	CHAR_TYPE	*bufptr;
	size_t		bufsize;
};

/*
 * buf_putc -- append a character to a string in memory
 */
static slib_callback_t buf_putc; // setup calling convention
static void __SLIB_CALLBACK buf_putc( SPECS __SLIB *specs, int op_char )
    {
	struct buf_limit *bufinfo;
	
	bufinfo = (struct buf_limit *)specs->_o._dest;
	if( specs->_o._output_count < bufinfo->bufsize ) {
	    *( bufinfo->bufptr++ ) = op_char;
	    specs->_o._output_count++;
	}
    }


_WCRTLINK int __F_NAME(_vbprintf,_vbwprintf) ( CHAR_TYPE *s, size_t bufsize,
		const CHAR_TYPE *format, va_list arg)
    {
        register int len;
	auto	struct buf_limit bufinfo;
	slib_callback_t *tmp;

	bufinfo.bufptr  = s;
	bufinfo.bufsize = bufsize - 1;
#if defined(__386__) && defined(__QNX__)
	/* avoid some segment relocations for 32-bit QNX */
	tmp = (void (*)())buf_putc;
#else
	tmp = buf_putc;
#endif
        len = __F_NAME(__prtf,__wprtf)( &bufinfo, format, arg, tmp );
        s[len] = '\0';
        return( len );
    }


_WCRTLINK int __F_NAME(_bprintf,_bwprintf) ( CHAR_TYPE *dest, size_t bufsize,
    		const CHAR_TYPE *format, ... )
    {
        auto    va_list         args;

        va_start( args, format );
	return( __F_NAME(_vbprintf,_vbwprintf)( dest, bufsize, format, args ) );
    }
