/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  21-apr-90	F.W.Crigger	Initial implementation
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  31-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <string.h>

#ifdef	M_I86

extern int _fast_strncmp( const char _WCFAR *, const char _WCFAR *, size_t );

#pragma aux    _fast_strncmp = \
	0x1e		/* push ds   */ \
	0x96		/* xchg si,ax */\
	0x8e 0xd8	/* mov ds,ax  */\
	0x89 0xfa	/* mov dx,di */ \
	0x30 0xc0	/* xor al,al */ \
	0xf2 0xae	/* repne scasb */ \
	0x89 0xf9	/* mov cx,di */ \
	0x89 0xd7	/* mov di,dx */ \
	0x29 0xf9	/* sub cx,di */ \
	0xf3 0xa6	/* repe cmpsb */ \
	0x74 0x05	/* je L1 */ \
	0x19 0xc9	/* sbb cx,cx */ \
	0x83 0xd9 0xff	/* sbb cx,ffffh */ \
			/* L1: */ \
	0x1f		/* pop ds */\
	parm caller [si ax] [es di] [cx] \
	value [cx] \
	modify exact [dx ax di cx si];
#endif

/* return <0 if s<t, 0 if s==t, >0 if s>t */

_WCRTLINK int _fstrncmp( const char _WCFAR *s, const char _WCFAR *t, size_t n )
    {
#if defined(M_I86)
	if( n ) {
	    return( _fast_strncmp( s, t, n ) );
	}
	return( 0 );
#else
	for(;;) {
	    if( n == 0 )     return( 0 );	/* equal */
	    if( *s != *t )   return( *s - *t ); /* less than or greater than */
	    if( *s == '\0' ) return( 0 );	/* equal */
	    ++s;
	    ++t;
	    --n;
	}
#endif
    }
