/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  21-apr-90	F.W.Crigger	Initial implementation
  30-aug-91	J.B.Schueler	Added "const" attribute to Bits vector
  23-sep-92	F.W.Crigger	declared _Bits vector to be near to avoid
				segment fixups under Windows
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  31-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <stddef.h>
#include <string.h>

/*  The strpbrk function locates the first occurrence in the string pointed
    to by str of any character from the string pointed to by charset.
*/

extern void __fsetbits(unsigned char _WCFAR *vec,const char _WCFAR *charset );

extern const unsigned char _HUGEDATA _Bits[8];

_WCRTLINK char _WCFAR *_fstrpbrk( const char _WCFAR *str, const char _WCFAR *charset )
{
    unsigned char tc;
    unsigned char vector[32];

    __fsetbits( vector, charset );
    for( ; tc = *str; ++str ) {
	/* quit when we find any char in charset */
	if( ( vector[ tc >> 3 ] & _Bits[ tc & 0x07 ] ) != 0 )
	     return( (char _WCFAR *)str );
    }
    return( NULL );
}
