/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  21-apr-90	F.W.Crigger	Initial implementation
   2-dec-90	B.J. Stecher	include i86.h for QNX
  28-jan-92	J.B.Schueler	include i86.h for PenPoint (should we ever
				include fstrstr in the PenPoint library)
  24-Oct-94	John Dahms	use size_t instead of int for string lengths
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  31-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <stddef.h>
#include <string.h>
#if defined(__PENPOINT__)  ||  defined(__QNX__)
#include <i86.h>
#else
#include <dos.h>
#endif

#ifdef M_I86

extern	int	i86_memeq( const char _WCFAR *, const char _WCFAR *, int );

#define _ZFLAG		(INTR_ZF<<8)

#pragma aux	i86_memeq = \
	0x1e		/* push ds */\
	0x96		/* xchg si,ax */\
	0x8e 0xd8	/* mov ds,ax  */\
	0xf3 0xa6	/* rep cmpsb */\
	0x9f		/* lahf */\
	0x1f		/* pop ds */\
	parm caller	[si ax] [es di] [cx]\
	value		[ax] \
	modify exact	[si di cx ax];

#define memeq( p1, p2, len )	( i86_memeq((p1),(p2),(len)) & _ZFLAG )

#else

#define memeq( p1, p2, len )	( _fmemcmp((p1),(p2),(len)) == 0 )

#endif

/* Locate the first occurrence of the string pointed to by s2 in the
   string pointed to by s1.
   The strstr function returns a pointer to the located string, or a
   null pointer if the string is not found.
*/

_WCRTLINK char _WCFAR *_fstrstr( const char _WCFAR *s1, const char _WCFAR *s2 )
    {
	char _WCFAR *end_of_s1;
	size_t s1len, s2len;

	if( s2[0] == '\0' ) {
	    return( (char _WCFAR *)s1 );
	} else if( s2[1] == '\0' ) {
	    return( _fstrchr( s1, s2[0] ) );
	}
	end_of_s1 = _fmemchr( s1, '\0', ~0u );
	s2len = _fstrlen( s2 );
	for(;;) {
	    s1len = end_of_s1 - s1;
	    if( s1len < s2len ) break;
	    s1 = _fmemchr( s1, *s2, s1len ); /* find start of possible match */
	    if( s1 == NULL ) break;
	    if( memeq( s1, s2, s2len ) ) return( (char _WCFAR *)s1 );
	    ++s1;
	}
	return( NULL );
    }
