/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  21-apr-90	F.W.Crigger	Initial implementation
  30-aug-91	J.B.Schueler	Added "const" attribute to Bits vector
  23-sep-92	F.W.Crigger	declared _Bits vector to be near to avoid
				segment fixups under Windows
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  31-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <stdio.h>
#include <string.h>
#include "rtdata.h"
#include "nextftok.h"

extern void __fsetbits(unsigned char _WCFAR *vec,const char _WCFAR *charset );

extern const unsigned char _HUGEDATA _Bits[8];


_WCRTLINK char _WCFAR *_fstrtok( char _WCFAR *str, const char _WCFAR *charset )
{
    unsigned /*char*/ tc;
    unsigned char vector[32];
    unsigned char _WCFAR *p1;

    _INITNEXTFTOK
    if( str == NULL ) {
	str = _RWD_nextftok;		/* use previous value	*/
	if( str == NULL ) return( NULL );
    }
    __fsetbits( vector, charset );
    for( ; tc = (unsigned char) *str; ++str ) {
	/* quit if we find any char not in charset */
	if( ( vector[ tc >> 3 ] & _Bits[ tc & 0x07 ] ) == 0 )  break;
    }
    if( tc == '\0' ) return( NULL );
    p1 = str;
    for( ; tc = *p1; ++p1 ) {
	/* quit when we find any char in charset */
	if( ( vector[ tc >> 3 ] & _Bits[ tc & 0x07 ] ) != 0 ) {
	    *p1 = '\0'; 	    /* terminate the token  */
	    p1++;		    /* start of next token  */
	    _RWD_nextftok = p1;
	    return( str );
	}
    }
    _RWD_nextftok = NULL;
    return( str );
}
