/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   20-sep-95	M. Hildebrand	Adapted from existing Watcom code.
   25-apr-96	A. Kucharczyk	Introduced macros.
   14-may-96	M. Hildebrand	Wasn't handling short unaligned strings.
   24-may-96	M. Hildebrand	Added wide character support.
*/

#include "widechar.h"
#include <string.h>
#include "riscstr.h"

        
size_t __F_NAME(strlen,wcslen)( const CHAR_TYPE *s )
/**************************************************/
{
    RISC_DATA_LOCALREF;
    int			offset = OFFSET(s);
    UINT *		dw = ROUND(s);		/* round down to dword */
    UINT		dword;
    size_t		len = 0;

    #ifdef __WIDECHAR__
	if( offset % 2 )  return( __simple_wcslen( s ) );
    #endif

    /*** Scan until s is aligned ***/
    dword = *dw++;
    if( OFFSET_GOT_NIL(dword,offset) ) {
	#if USE_INT64
	    switch( offset ) {
	      case 0:
		if( !CHR1(dword) )  break;
		len++;
		/* fall through */
	      case 1:
		if( !CHR2(dword) )  break;
		len++;
		/* fall through */
	      case 2:
		if( !CHR3(dword) )  break;
		len++;
		/* fall through */
	      case 3:
		if( !CHR4(dword) )  break;
		len++;
		/* fall through */
	      case 4:
		if( !CHR5(dword) )  break;
		len++;
		/* fall through */
	      case 5:
		if( !CHR6(dword) )  break;
		len++;
		/* fall through */
	      case 6:
		if( !CHR7(dword) )  break;
		len++;
		/* fall through */
	      default:
		break;
	    }
	#else
	    #ifdef __WIDECHAR__
		switch( offset ) {
		  case 0:
		    if( !CHR1(dword) )  break;
		    len++;
		    /* fall through */
		  default:		/* offset==2 (no odd offsets) */
		    break;
		}
	    #else
		switch( offset ) {
		  case 0:
		    if( !CHR1(dword) )  break;
		    len++;
		    /* fall through */
		  case 1:
		    if( !CHR2(dword) )  break;
		    len++;
		    /* fall through */
		  case 2:
		    if( !CHR3(dword) )  break;
		    len++;
		    /* fall through */
		  default:
		    break;
		}
	    #endif
	#endif
	return( len );
    } else {
	len += ( BYTES_PER_WORD - offset ) / CHARSIZE;
    }

    /*** Scan one word at a time until a null char is found ***/
    for( ;; ) {
	dword = *dw++;
	if( GOT_NIL(dword) )  break;

	dword = *dw++;
	if( GOT_NIL(dword) )  break;
    }

    /*** Locate the null char within the offending word ***/
    len = (CHAR_TYPE*)dw - s;
    #if USE_INT64
	if( !CHR1(dword) ) {
	    len -= 8;
	} else if( !CHR2(dword) ) {
	    len -= 7;
	} else if( !CHR3(dword) ) {
	    len -= 6;
	} else if( !CHR4(dword) ) {
	    len -= 5;
	} else if( !CHR5(dword) ) {
	    len -= 4;
	} else if( !CHR6(dword) ) {
	    len -= 3;
	} else if( !CHR7(dword) ) {
	    len -= 2;
	} else {
	    len -= 1;
	}
    #else
	#ifdef __WIDECHAR__
	    if( !CHR1(dword) ) {
		len -= 2;
	    } else {
		len -= 1;
	    }
	#else
	    if( !CHR1(dword) ) {
		len -= 4;
	    } else if( !CHR2(dword) ) {
		len -= 3;
	    } else if( !CHR3(dword) ) {
		len -= 2;
	    } else {
		len -= 1;
	    }
	#endif
    #endif

    return( len );
}
