/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1996, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date         By              Reason
   ----         --              ------
--------------------------------------------------------Version-11.0---------
   15-apr-96    A. Kucharczyk   Initial implementation.
   25-apr-96    A. Kucharczyk   Introduced macros.
   24-may-96	M. Hildebrand	Added wide character support.
*/

#include "widechar.h"
#include <string.h>
#include "riscstr.h"


#ifdef __WIDECHAR__
 wchar_t *_wcsset( wchar_t *s, wchar_t c )
#else
 char *strset( char *s, int c )
#endif
/****************************************/
{
    RISC_DATA_LOCALREF;
    UINT *	     dw = ROUND(s);		/* round down to dword */
    UINT             dword, cdword, tmpdword;
    INT              offset = OFFSET(s);

    #ifdef __WIDECHAR__
	if( offset % 2 )  return( __simple__wcsset( s, c ) );
    #endif

    /*** Initialize locals ***/
    c &= CHR1MASK;
    #ifdef __WIDECHAR__
	cdword = (c<<16) | c;
    #else
	cdword = (c<<24) | (c<<16) | (c<<8) | c;
    #endif
    dword = *dw;

    /*** Set any bytes up to a 4-byte alignment ***/
    tmpdword = FRONT_CHRS(dword,offset);
    #ifdef __WIDECHAR__
	switch( offset ) {              
	  case 0:
	    if( CHR1(dword) ) {
		tmpdword |= CHR1(cdword);
	    } else {
		return( s );
	    }
	    /* fall through */
	  default:		/* offset must equal 2 (no odd offsets) */
	    if( CHR2(dword) ) {
		tmpdword |= CHR2(cdword);
		*dw = tmpdword;
	    } else {
		*dw = tmpdword;
		return( s );
	    }
	}
    #else
	switch( offset ) {              
	  case 0:
	    if( CHR1(dword) ) {
		tmpdword |= CHR1(cdword);
	    } else {
		return( s );
	    }
	    /* fall through */
	  case 1:
	    if( CHR2(dword) ) {
		tmpdword |= CHR2(cdword);
	    } else {
		tmpdword |= SKIP_CHRS(dword,2);
		*dw = tmpdword;
		return( s );
	    }
	    /* fall through */
	  case 2:
	    if( CHR3(dword) ) {
		tmpdword |= CHR3(cdword);
	    } else {
		tmpdword |= SKIP_CHRS(dword,3);
		*dw = tmpdword;
		return( s );
	    }
	    /* fall through */
	  default:
	    if( CHR4(dword) ) {
		tmpdword |= CHR4(cdword);
		*dw = tmpdword;
	    } else {
		*dw = tmpdword;
		return( s );
	    }
	}
    #endif
    
    dw++;

    /*** Write in aligned 4-byte groups ***/
    for( ;; ) {
        dword = *dw;
        if( GOT_NIL(dword) )  break;
        *dw++ = cdword;

        dword = *dw;
        if( GOT_NIL(dword) )  break;
        *dw++ = cdword;
    }

    /*** Write in last dword ***/
    #ifdef __WIDECHAR__
	if( !CHR1(dword) ) {
	    return( s );
	} else {
	    *dw = ( SKIP_CHRS(dword,1) | FRONT_CHRS(cdword,1) );
	    return( s );
	}
    #else
	if( !CHR1(dword) ) {
	    return( s );
	} else if( !CHR2(dword) ) {
	    *dw = ( SKIP_CHRS(dword,1) | FRONT_CHRS(cdword,1) );
	    return( s );
	} else if( !CHR3(dword) ) {
	    *dw = ( SKIP_CHRS(dword,2) | FRONT_CHRS(cdword,2) );
	    return( s );
	} else {
	    *dw = ( SKIP_CHRS(dword,3) | FRONT_CHRS(cdword,3) );
	    return( s );
	}
    #endif
}
