/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  14-Jul-86     A.C.C.Wai       Separated from printf.c
  23-feb-87     F.W.Crigger     Added vsprintf
  26-oct-90     B.J.Stecher     Added shared library support
  12-Jun-92	D. Wellstood	Unicode support
  11-aug-92	A.F.Scian	moved vsprintf to its own module
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  25-apr-95	M. Hildebrand	Use Normative Addendum parameter list for
				swprintf (new parameter added).
  25-apr-95	M. Hildebrand	Fixed multithreading issues in above fix.
  31-may-95	Greg Bentz	variety.h and dll linkage
  27-sep-95	M. Hildebrand	Added _u version, which calls wide version.
				Also, swprintf now calls vswprintf.
*/

#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdarg.h>
#include <limits.h>
#include "printf.h"


#ifdef __WIDECHAR__
_WCRTLINK int _usprintf( wchar_t *dest, const wchar_t *format, ... )
{
    va_list		args;

    va_start( args, format );
    return( vswprintf( dest, INT_MAX, format, args ) );
}
#endif


#ifdef __WIDECHAR__
 _WCRTLINK int swprintf( CHAR_TYPE *dest, size_t n, const CHAR_TYPE *format, ... )
#else
 _WCRTLINK int sprintf( CHAR_TYPE *dest, const CHAR_TYPE *format, ... )
#endif
    {
        auto    va_list         args;

        va_start( args, format );
	#ifdef __WIDECHAR__
	    return( vswprintf( dest, n, format, args ) );
	#else
	    return( vsprintf( dest, format, args ) );
	#endif
    }
