/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  08-dec-87     A.F.Scian       added vsscanf
-----------------------------------------------------------Version 6.5------
  24-aug-88     F.W.Crigger     cget, uncget rtns added
  12-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  31-may-95	Greg Bentz	variety.h and dll linkage
  27-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdarg.h>
#include "scanf.h"


static int cget_string( PTR_SCNF_SPECS specs )
    {
        int c;

        if( (c = *(specs->ptr)) != NULLCHAR ) {
            ++(specs->ptr);
        } else {
            c = EOF;
            specs->eoinp = 1;
        }
        return( c );
    }


static void uncget_string( int c, PTR_SCNF_SPECS specs )
    {
        --specs->ptr;
    }


_WCRTLINK int __F_NAME(vsscanf,vswscanf) ( const CHAR_TYPE *dest, const CHAR_TYPE *format, va_list args )
    {
        auto SCNF_SPECS specs;

        specs.ptr = (CHAR_TYPE *)dest;
        specs.cget_rtn = cget_string;
        specs.uncget_rtn = uncget_string;
        return( __F_NAME(__scnf,__wscnf)( (PTR_SCNF_SPECS)&specs, format, args ) );
    }


_WCRTLINK int __F_NAME(sscanf,swscanf) ( const CHAR_TYPE *dest, const CHAR_TYPE *format, ... )
    {
        va_list args;

        va_start( args, format );
        return( __F_NAME(vsscanf,vswscanf)( dest, format, args ) );
    }
