/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  17-mar-87	F.W.Crigger	Initial implementation
  12-apr-88	A.F.Scian	used inline code
   2-dec-90	B.J. Stecher	don't include dos.h for QNX
  28-jan-92	J.B.Schueler	don't include dos.h for anybody
  10-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  04-May-95	A.F.Scian	added conversion to 'char' in case 0x3131 is
  				passed as the 'char' value
  31-may-95	Greg Bentz	dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  23-nov-95	T. Schiller	Disabled i86 scan pragmas since it was
				possible for them to overrun the end of
				a selector when doing word-wise comps
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  31-may-96	M. Hildebrand	Support RISC-oriented code.
*/
#include "variety.h"
#include "widechar.h"
#include <stddef.h>
#include <string.h>
#include "riscstr.h"

#if defined(M_I86) && !defined(__WIDECHAR__)

extern	char * _scan1();

/* use scan1 to find the char we are looking for */

#if defined(__SMALL_DATA__)
#pragma aux    _scan1 = 0xad		/* L1:lodsw  */\
			0x38 0xd0	/* cmp al,dl */\
			0x74 0x20	/* je L3     */\
			0x84 0xc0	/* test al,al*/\
			0x74 0x19	/* je L2     */\
			0x38 0xd4	/* cmp ah,dl */\
			0x74 0x19	/* je L4     */\
			0x84 0xe4	/* test ah,ah*/\
			0x74 0x11	/* je L2     */\
			0xad		/* lodsw     */\
			0x38 0xd0	/* cmp al,dl */\
			0x74 0x0f	/* je L3     */\
			0x84 0xc0	/* test al,al*/\
			0x74 0x08	/* je L2     */\
			0x38 0xd4	/* cmp ah,dl */\
			0x74 0x08	/* je L4     */\
			0x84 0xe4	/* test ah,ah*/\
			0x75 0xde	/* jne L1    */\
			0x31 0xf6	/* L2:xor si,si */\
			0xa9		/* test ax,... */\
			0x4e		/* L3:dec si */\
			0x4e		/* L4:dec si */\
			parm caller [si] [dl]\
			value [si]\
			modify [ax si];
#else
#pragma aux    _scan1 = \
			0x1e		/* push ds */ \
			0x8e 0xd9	/* mov ds,cx */ \
			0x8c 0xda	/* mov dx,ds */\
			0xad		/* L1:lodsw  */\
			0x38 0xd8	/* cmp al,bl */\
			0x74 0x22	/* je L3     */\
			0x84 0xc0	/* test al,al*/\
			0x74 0x19	/* je L2     */\
			0x38 0xdc	/* cmp ah,bl */\
			0x74 0x1b	/* je L4     */\
			0x84 0xe4	/* test ah,ah*/\
			0x74 0x11	/* je L2     */\
			0xad		/* lodsw     */\
			0x38 0xd8	/* cmp al,bl */\
			0x74 0x11	/* je L3     */\
			0x84 0xc0	/* test al,al*/\
			0x74 0x08	/* je L2     */\
			0x38 0xdc	/* cmp ah,bl */\
			0x74 0x0a	/* je L4     */\
			0x84 0xe4	/* test ah,ah*/\
			0x75 0xde	/* jne L1    */\
			0x31 0xf6	/* L2:xor si,si*/\
			0x89 0xf2	/* mov dx,si */\
			0xa9		/* test ax,... */\
			0x4e		/* L3:dec si */\
			0x4e		/* L4:dec si */\
			0x1f		/* pop ds */ \
			parm caller [cx si] [bl]\
			value [dx si]\
			modify [ax dx si];
#endif
#endif


/* locate the first occurrence of c in the initial n characters of the
   string pointed to by s. The terminating null character is considered
   to be part of the string.
   If the character c is not found, NULL is returned.
*/
#undef	strchr


#if defined(__RISCSTR__) && defined(__WIDECHAR__)
 _WCRTLINK CHAR_TYPE *__simple_wcschr( const CHAR_TYPE *s, int c )
#else
 _WCRTLINK CHAR_TYPE *__F_NAME(strchr,wcschr)( const CHAR_TYPE *s, int c )
#endif
    {
//#if defined(M_I86) && !defined(__WIDECHAR__)
	//return( _scan1( (char _WCFAR *)s, c ) );
//#else
	CHAR_TYPE cc = c;
	do {
	    if( *s == cc ) return( (CHAR_TYPE *)s );
	} while( *s++ != NULLCHAR );
	return( NULL );
//#endif
    }
