/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  17-mar-87     F.W.Crigger     Initial implementation
---------------------------------------------------------Version 6.0-------
  12-apr-88     F.W.Crigger     use _inline_ function support
  08-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  22-feb-95	Greg Bentz	alpha support
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  31-may-95	Greg Bentz	dll linkage
  15-sep-95	Greg Bentz	ppc support
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  31-may-96	M. Hildebrand	Support RISC-oriented code.
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <string.h>
#include "riscstr.h"

#undef  strcpy

extern CHAR_TYPE *__strcpy( CHAR_TYPE *dst, const CHAR_TYPE *src );
#if defined(__386__)
 #pragma aux __strcpy = \
 	"	push	eax"	  \
	"L1:	mov	cl,[edx]" \
	"	mov	[eax],cl" \
	"	cmp	cl,0"	  \
	"	je	L2"	  \
	"	mov	cl,1[edx]"\
	"	add	edx,2"	  \
	"	mov	1[eax],cl"\
	"	add	eax,2"	  \
	"	cmp	cl,0"	  \
	"	jne	L1"	  \
	"L2:	pop	eax"	  \
	parm [eax] [edx] value [eax] modify exact [eax edx ecx];
#elif defined(M_I86)
 #if defined(__SMALL_DATA__)
  #pragma aux __strcpy = \
 	"	push	di"	  \
	"	test	si,1"	  \
	"	je	L1"	  \
	"	lodsb"		  \
	"	mov	[di],al"  \
	"	inc	di"	  \
	"	cmp	al,0"	  \
	"	je	L3"	  \
	"L1:	mov	ax,[si]"  \
	"	test	al,al"	  \
	"	je	L2"	  \
	"	mov	[di],ax"  \
	"	add	di,2"	  \
	"	test	ah,ah"	  \
	"	je	L3"	  \
	"	mov	ax,2[si]" \
	"	test	al,al"	  \
	"	je	L2"	  \
	"	mov	[di],ax"  \
	"	add	si,4"	  \
	"	add	di,2"	  \
	"	test	ah,ah"	  \
	"	jne	L1"	  \
	"	je	L3"	  \
	"L2:	mov	[di],al"  \
	"L3:	pop	ax"	  \
	parm [di] [si] value [ax] modify exact [si di];
 #else	// compact, large, or huge
  #pragma aux __strcpy = \
	"	push	ds"	  \
 	"	push	di"	  \
	"	mov	ds,dx"	  \
	"	test	si,1"	  \
	"	je	L1"	  \
	"	lodsb"		  \
	"	stosb"		  \
	"	cmp	al,0"	  \
	"	je	L3"	  \
	"L1:	mov	ax,[si]"  \
	"	test	al,al"	  \
	"	je	L2"	  \
	"	stosw"		  \
	"	test	ah,ah"	  \
	"	je	L3"	  \
	"	mov	ax,2[si]" \
	"	test	al,al"	  \
	"	je	L2"	  \
	"	stosw"		  \
	"	add	si,4"	  \
	"	test	ah,ah"	  \
	"	jne	L1"	  \
	"	je	L3"	  \
	"L2:	stosb"		  \
	"L3:	pop	ax"	  \
	"	mov	dx,es"	  \
	"	pop	ds"	  \
	parm [es di] [dx si] value [dx ax] modify exact [si di];
 #endif
#elif defined(__AXP__)
 // no pragma
#elif defined(__PPC__)
 // no pragma
#else
 #error platform not supported
#endif


/* copy string t to string s */

#if defined(__RISCSTR__) && defined(__WIDECHAR__)
 _WCRTLINK CHAR_TYPE *__simple_wcscpy( CHAR_TYPE *s, const CHAR_TYPE *t )
#else
 _WCRTLINK CHAR_TYPE *__F_NAME(strcpy,wcscpy)( CHAR_TYPE *s, const CHAR_TYPE *t )
#endif
    {

#if !defined(__WIDECHAR__) && defined(_M_IX86)
        return( __strcpy( s, t ) );
#else
        CHAR_TYPE *dst;
        dst = s;
        while( *dst++ = *t++ );
        return( s );
#endif
    }
