/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  13-Mar-87     A.C.C.Wai       Initial implementation
  13-Jul-92	D. Wellstood	unicode support
  17-Dec-92	G. Coschi	added "unknown error" message
  08-Feb-93	A. Gupta	modified for Netware
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  31-may-95	Greg Bentz	variety.h and dll linkage
  10-jul-96	M. Hildebrand	Added more error strings.
*/

#include "variety.h"
#include "widechar.h"
#include <errno.h>

#define MAX_ERROR	sys_nerr
#define	UNKNOWN_ERROR	"unknown error"

#if defined(__NETWARE__) || defined(__WIDECHAR__)

extern int _WCNEAR	sys_nerr;
extern char		*sys_errlist[];

#else

int _WCNEAR sys_nerr = EILSEQ;

char *sys_errlist[] = {
    /* 0    EZERO	    */	"No error",
    /* 1    ENOENT	    */	"No such file or directory",
    /* 2    E2BIG	    */	"Arg list too big",
    /* 3    ENOEXEC	    */	"Exec format error",
    /* 4    EBADF	    */	"Bad file number",
    /* 5    ENOMEM	    */	"Not enough memory",
    /* 6    EACCES	    */	"Permission denied",
    /* 7    EEXIST	    */	"File exists",
    /* 8    EXDEV	    */	"Cross-device link",
    /* 9    EINVAL	    */	"Invalid argument",
    /* 10   ENFILE	    */	"File table overflow",
    /* 11   EMFILE	    */	"Too many open files",
    /* 12   ENOSPC	    */	"No space left on device",
    /* 13   EDOM	    */	"Argument too large",
    /* 14   ERANGE	    */	"Result too large",
    /* 15   EDEADLK	    */	"Resource deadlock would occur",
    /* 16   EINTR	    */	"System call interrupted",
    /* 17   ECHILD	    */	"Child does not exist",
    /* 18   EAGAIN	    */	"Resource unavailable, try again",
    /* 19   EBUSY	    */	"Device or resource busy",
    /* 20   EFBIG	    */	"File too large",
    /* 21   EIO		    */	"I/O error",
    /* 22   EISDIR	    */	"Is a directory",
    /* 23   ENOTDIR	    */	"Not a directory",
    /* 24   EMLINK	    */	"Too many links",
    /* 25   ENOTBLK	    */	"Block device required",
    /* 26   ENOTTY	    */	"Not a character device",
    /* 27   ENXIO	    */	"No such device or address",
    /* 28   EPERM	    */	"Not owner",
    /* 29   EPIPE	    */	"Broken pipe",
    /* 30   EROFS	    */	"Read-only file system",
    /* 31   ESPIPE	    */	"Illegal seek",
    /* 32   ESRCH	    */	"No such process",
    /* 33   ETXTBSY	    */	"Text file busy",
    /* 34   EFAULT	    */	"Bad address",
    /* 35   ENAMETOOLONG    */	"Filename too long",
    /* 36   ENODEV	    */	"No such device",
    /* 37   ENOLCK	    */	"No locks available in system",
    /* 38   ENOSYS	    */	"Unknown system call",
    /* 39   ENOTEMPTY	    */	"Directory not empty",
    /* 40   EILSEQ	    */	"Illegal multibyte sequence"
    /* if more are added, be sure to update sys_nerr accordingly */
};
#endif

_WCRTLINK CHAR_TYPE *__F_NAME(strerror,wcserror) ( int errnum )
{
    #if defined(__WIDECHAR__ )
	static wchar_t Wide_Error_String[40];
    #endif
    char	*msg;

    if( errnum < 0 || errnum > MAX_ERROR ) {
	msg = UNKNOWN_ERROR;
    } else {
	msg = sys_errlist[ errnum ];
    }
    return( _AToUni( Wide_Error_String, msg ) );
}
