/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  23-aug-87     F.W.Crigger     Initial implementation
----------------------------------------------------------Version 6.0------
  18-apr-88     F.W.Crigger     use inline code instead of calling tolower
  16-mar-90     F.W.Crigger     strcmpi added to match Microsoft
  08-Jun-92	D. Wellstood	Unicode support
  02-mar-94	Greg Bentz	added _stricmp
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  31-may-95	Greg Bentz	variety.h and dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  31-may-96	M. Hildebrand	Support RISC-oriented code.
*/
#include "variety.h"
#include "widechar.h"
#include <ctype.h>
#include <string.h>
#include "riscstr.h"

/* return <0 if s<t, 0 if s==t, >0 if s>t */

#if defined(__RISCSTR__) && defined(__WIDECHAR__)
 _WCRTLINK int __simple__wcsicmp( const CHAR_TYPE *s, const CHAR_TYPE *t ) {
#else
 _WCRTLINK int __F_NAME(stricmp,_wcsicmp)( const CHAR_TYPE *s, const CHAR_TYPE *t ) {
#endif
    UCHAR_TYPE c1;
    UCHAR_TYPE c2;

    for(;;) {
	c1 = *s;
	c2 = *t;
	if( IS_ASCII( c1 ) && IS_ASCII( c2 ) ) {
	    if( c1 >= 'A'  &&  c1 <= 'Z' )  c1 += 'a' - 'A';
	    if( c2 >= 'A'  &&  c2 <= 'Z' )  c2 += 'a' - 'A';
	}
	if( c1 != c2 ) break;
	if( c1 == NULLCHAR ) break;
	++s;
	++t;
    }
    return( c1 - c2 );
}
