/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  17-mar-87	F.W.Crigger	Initial implementation
---------------------------------------------------------Version 6.5-------
  27-jun-88	A.F.Scian	optimized for i86
  09-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  31-may-95	Greg Bentz	dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  31-may-96	M. Hildebrand	Removed _wmem... functions.
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <string.h>

#if defined(M_I86) && !defined(__WIDECHAR__)

extern char *_fast_strncat( char _WCFAR *, const char *, size_t );

#if defined(__SMALL_DATA__)

#pragma aux _fast_strncat = \
	0x57		/* push di */\
	0xb9 0xff 0xff	/* mov cx,ffffh */\
	0x31 0xc0	/* xor ax,ax */\
	0xf2 0xae	/* repne scasb */\
	0x4f		/* dec di */\
	0x89 0xd1	/* mov cx,dx */\
	0xac		/* L1: lodsb */\
	0xaa		/* stosb */\
	0x84 0xc0	/* test al,al */\
	0xe0 0xfa	/* loopne L1 */\
	0x74 0x03	/* je L2 */\
	0x26 0x88 0x25	/* mov es:[di],ah */\
	0x58		/* L2: pop ax */\
	parm caller	[es di] [si] [dx]\
	value		[ax] \
	modify exact	[ax cx si di];

#else

#pragma aux _fast_strncat = \
	0x1e		/* push ds */ \
	0x8e 0xd9	/* mov ds,cx */ \
	0x57		/* push di */\
	0xb9 0xff 0xff	/* mov cx,ffffh */\
	0x31 0xc0	/* xor ax,ax */\
	0xf2 0xae	/* repne scasb */\
	0x4f		/* dec di */\
	0x89 0xd1	/* mov cx,dx */\
	0xac		/* L1: lodsb */\
	0xaa		/* stosb */\
	0x84 0xc0	/* test al,al */\
	0xe0 0xfa	/* loopne L1 */\
	0x74 0x03	/* je L2 */\
	0x26 0x88 0x25	/* mov es:[di],ah */\
	0x58		/* L2: pop ax */\
	0x1f		/* pop ds */ \
	parm caller	[es di] [cx si] [dx]\
	value		[es ax] \
	modify exact	[ax cx si di];
#endif

#endif


/* concatenate t to the end of dst */

_WCRTLINK CHAR_TYPE *__F_NAME(strncat,wcsncat) ( CHAR_TYPE *dst, const CHAR_TYPE *t, size_t n )
    {
#if defined(M_I86) && !defined(__WIDECHAR__)
	if( n ) {
	    return( _fast_strncat( dst, t, n ) );
	}
	return( dst );
#else
	CHAR_TYPE *s;

	#ifdef __WIDECHAR__
	    s = dst + wcslen( dst );
	#else
	    s = memchr( dst, NULLCHAR, ~0u );
	#endif
	while( n != 0 ) {
	    *s = *t;
	    if( *s == NULLCHAR ) break;
	    ++s;
	    ++t;
	    --n;
	}
	*s = NULLCHAR;
	return( dst );
#endif
    }
