/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  17-mar-87     F.W.Crigger     Initial implementation
  06-may-87     F.W.Crigger     return 0 when n reaches 0
---------------------------------------------------------Version 6.5-------
  27-jun-88     A.F.Scian       optimized for i86
  10-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  31-may-95	Greg Bentz	dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  31-may-96	M. Hildebrand	Support RISC-oriented code.
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <string.h>
#include "riscstr.h"

#if defined(M_I86) && !defined(__WIDECHAR__)

extern int _fast_strncmp( const char *, const char _WCFAR *, size_t );

#if defined(__SMALL_DATA__)
#pragma aux    _fast_strncmp = \
        0x89 0xfa       /* mov dx,di */ \
        0x30 0xc0       /* xor al,al */ \
        0xf2 0xae       /* repne scasb */ \
        0x89 0xf9       /* mov cx,di */ \
        0x89 0xd7       /* mov di,dx */ \
        0x29 0xf9       /* sub cx,di */ \
        0xf3 0xa6       /* repe cmpsb */ \
        0x74 0x05       /* je L1 */ \
        0x19 0xc9       /* sbb cx,cx */ \
        0x83 0xd9 0xff  /* sbb cx,ffffh */ \
                        /* L1: */ \
        parm caller [si] [es di] [cx] \
        value [cx] \
        modify exact [dx ax di cx si];
#else
#pragma aux    _fast_strncmp = \
        0x1e            /* push ds */ \
        0x8e 0xda       /* mov ds,dx */ \
        0x89 0xfa       /* mov dx,di */ \
        0x30 0xc0       /* xor al,al */ \
        0xf2 0xae       /* repne scasb */ \
        0x89 0xf9       /* mov cx,di */ \
        0x89 0xd7       /* mov di,dx */ \
        0x29 0xf9       /* sub cx,di */ \
        0xf3 0xa6       /* repe cmpsb */ \
        0x74 0x05       /* je L1 */ \
        0x19 0xc9       /* sbb cx,cx */ \
        0x83 0xd9 0xff  /* sbb cx,ffffh */ \
                        /* L1: */ \
        0x1f            /* pop ds */ \
        parm caller [dx si] [es di] [cx] \
        value [cx] \
        modify exact [dx ax di cx si];
#endif
#endif

/* return <0 if s<t, 0 if s==t, >0 if s>t */

#if defined(__RISCSTR__) && defined(__WIDECHAR__)
 _WCRTLINK int __simple_wcsncmp( const CHAR_TYPE *s, const CHAR_TYPE *t, size_t n )
#else
 _WCRTLINK int __F_NAME(strncmp,wcsncmp)( const CHAR_TYPE *s, const CHAR_TYPE *t, size_t n )
#endif
    {
#if defined(M_I86) && !defined(__WIDECHAR__)
        if( n ) {
            return( _fast_strncmp( s, t, n ) );
        }
        return( 0 );
#else
        for(;;) {
            if( n == 0 )     return( 0 );       /* equal */
            if( *s != *t )   return( *s - *t ); /* less than or greater than */
            if( *s == NULLCHAR ) return( 0 );       /* equal */
            ++s;
            ++t;
            --n;
        }
#endif
    }
