/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  17-mar-87     F.W.Crigger     Initial implementation
  04-nov-87     F.W.Crigger     re-implemented to fix bugs
---------------------------------------------------------Version 6.5-------
  27-jun-88     A.F.Scian       optimized for i86
  10-Jun-92	D. Wellstood	Unicode support
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  31-may-95	Greg Bentz	dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
  31-may-96	M. Hildebrand	Support RISC-oriented code.
*/
#include "variety.h"
#include "widechar.h"
#include <string.h>
#include "riscstr.h"

#if defined(M_I86) & !defined(__WIDECHAR__)

extern char *fast_strncpy( char _WCFAR *, const char *, size_t );

#if defined(__SMALL_DATA__)

#pragma aux fast_strncpy = \
        0x57            /* push di */\
        0xac            /* L1: lodsb */\
        0xaa            /* stosb */\
        0x84 0xc0       /* test al,al */\
        0xe0 0xfa       /* loopne L1 */\
        0x31 0xc0       /* xor ax,ax */\
        0xd1 0xe9       /* shr cx,1 */\
        0xf3 0xab       /* rep stosw */\
        0x11 0xc9       /* adc cx,cx */\
        0xf3 0xaa       /* rep stosb */\
        0x58            /* pop ax */\
        parm caller     [es di] [si] [cx]\
        value           [ax] \
        modify exact    [ax cx si di];

#else

#pragma aux fast_strncpy = \
        0x1e            /* push ds */ \
        0x8e 0xda       /* mov ds,dx */ \
        0x57            /* push di */\
        0xac            /* L1: lodsb */\
        0xaa            /* stosb */\
        0x84 0xc0       /* test al,al */\
        0xe0 0xfa       /* loopne L1 */\
        0x31 0xc0       /* xor ax,ax */\
        0xd1 0xe9       /* shr cx,1 */\
        0xf3 0xab       /* rep stosw */\
        0x11 0xc9       /* adc cx,cx */\
        0xf3 0xaa       /* rep stosb */\
        0x58            /* pop ax */\
        0x1f            /* pop ds */ \
        parm caller     [es di] [dx si] [cx]\
        value           [es ax] \
        modify exact    [ax cx si di];

#endif

#endif


#if defined(__RISCSTR__) && defined(__WIDECHAR__)
 _WCRTLINK CHAR_TYPE *__simple_wcsncpy( CHAR_TYPE *dst, const CHAR_TYPE *src, size_t len )
#else
 _WCRTLINK CHAR_TYPE *__F_NAME(strncpy,wcsncpy)( CHAR_TYPE *dst, const CHAR_TYPE *src, size_t len )
#endif
    {
#if defined(M_I86) && !defined(__WIDECHAR__)
        if( len ) {
            return( fast_strncpy( dst, src, len ) );
        }
        return( dst );
#else
        CHAR_TYPE *ret;

        ret = dst;
        for(;len; --len ) {
            if( *src == NULLCHAR ) break;
            *dst++ = *src++;
        }
        while( len != 0 ) {
            *dst++ = NULLCHAR;      /* pad destination string with null chars */
            --len;
        }
        return( ret );
#endif
    }
