/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  17-mar-87	F.W.Crigger	Initial implementation
------------------------------------------------------------Version 6.0-----
  11-may-88	A.F.Scian	Optimized using bit vector
  30-aug-91	J.B.Schueler	Added "const" attribute to Bits vector
  09-Jun-92	D. Wellstood	Unicode support
  23-sep-92	F.W.Crigger	declared _Bits vector to be near to avoid
				segment fixups under Windows
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  31-may-95	Greg Bentz	dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <stddef.h>
#include <string.h>

/*  The strpbrk function locates the first occurrence in the string pointed
    to by str of any character from the string pointed to by charset.
*/


extern	void	__setbits();		/* bits.c */

extern const unsigned char _HUGEDATA _Bits[8];


_WCRTLINK CHAR_TYPE *__F_NAME(strpbrk,wcspbrk) ( const CHAR_TYPE *str, const CHAR_TYPE *charset )
{
#if defined(__WIDECHAR__)

    const CHAR_TYPE		*p1;
    const CHAR_TYPE		*p2;
    CHAR_TYPE		tc1;
    CHAR_TYPE		tc2;
    size_t		len;

    len = 0;
    for( p1 = str; tc1 = *p1; p1++, len++ ) {
	for( p2 = charset; tc2 = *p2; p2++ ) {
	    if( tc1 == tc2 ) break;
	}
	if( tc2 != NULLCHAR ) return( (CHAR_TYPE *)p1 );
    }
    return( NULL );

#else
    unsigned char tc;
    unsigned char vector[32];

    __setbits( vector, charset );
    for( ; tc = *str; ++str ) {
	/* quit when we find any char in charset */
	if( ( vector[ tc >> 3 ] & _Bits[ tc & 0x07 ] ) != 0 )
	     return( (char *)str );
    }
    return( NULL );
#endif
}
