/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  20-mar-87	F.W.Crigger	Initial implementation
------------------------------------------------------------Version 6.0-----
  11-may-88	A.F.Scian	Optimized using bit vector
  30-aug-91	J.B.Schueler	Added "const" attribute to Bits vector
  09-Jun-92	D. Wellstood	Unicode support
  23-sep-92	F.W.Crigger	declared _Bits vector to be near to avoid
				segment fixups under Windows
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  25-apr-95	M. Hildebrand	Use Normative Addendum parameter list for
				wcstok (new parameter added).
  31-may-95	Greg Bentz	dll linkage
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  07-oct-95	M. Hildebrand	wcstok uses thread-specific data if ptr==NULL.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <string.h>
#include "rtdata.h"
#ifdef __WIDECHAR__
    #include "nextwtok.h"
#else
    #include "nexttok.h"
#endif

#if !defined(__WIDECHAR__)
extern	void	__setbits();		/* bits.c */

extern const unsigned char _HUGEDATA _Bits[8];
#endif


#ifdef __WIDECHAR__
_WCRTLINK wchar_t *_ustrtok( wchar_t *str, const wchar_t *charset )
{
    return( wcstok( str, charset, NULL ) );
}
#endif


#ifdef __WIDECHAR__
 _WCRTLINK wchar_t *wcstok( wchar_t *str, const wchar_t *charset, wchar_t **ptr )
#else
 _WCRTLINK char *strtok( char *str, const char *charset )
#endif
{
#if defined(__WIDECHAR__)
    CHAR_TYPE		*p1;
    const CHAR_TYPE		*p2;
    CHAR_TYPE		tc1;
    CHAR_TYPE		tc2;
#else
    unsigned /*char*/ tc;
    unsigned char vector[32];
    unsigned char *p1;
#endif

#if defined(__WIDECHAR__)
    /* if necessary, continue from where we left off */
    if( str == NULL ) {
	if( ptr == NULL ) {
	    str = _RWD_nextwtok;
	} else {
	    str = *ptr;			/* use previous value */
	}
	if( str == NULL )  return( NULL );
    }

    /* skip characters until we reach one not in charset */
    for( ; tc1 = *str; str++ ) {
	for( p2 = charset; tc2 = *p2; p2++ ) {
	    if( tc1 == tc2 ) break;
	}
	if( tc2 == NULLCHAR ) break;
    }
    if( tc1 == NULLCHAR ) return( NULL );
    /* skip characters until we reach one in charset */ 
    for( p1 = str; tc1 = *p1; p1++ ) {
	for( p2 = charset; tc2 = *p2; p2++ ) {
	    if( tc1 == tc2 ) break;
	}
	if( tc2 != NULLCHAR ){
	    *p1 = NULLCHAR; 	    /* terminate the token  */
	    p1++;		    /* start of next token  */
	    if( ptr == NULL ) {
		_RWD_nextwtok = p1;
	    } else {
		*ptr = p1;
	    }
	    return( str );
	}
    }
    if( ptr == NULL ) {
	_RWD_nextwtok = NULL;
    } else {
	*ptr = NULL;
    }
#else
    /* if necessary, continue from where we left off */
    _INITNEXTTOK
    if( str == NULL ) {
	str = (CHAR_TYPE*)_RWD_nexttok;	/* use previous value */
	if( str == NULL ) return( NULL );
    }

    __setbits( vector, charset );
    for( ; tc = (unsigned char) *str; ++str ) {
	/* quit if we find any char not in charset */
	if( ( vector[ tc >> 3 ] & _Bits[ tc & 0x07 ] ) == 0 )  break;
    }
    if( tc == '\0' ) return( NULL );
    p1 = str;
    for( ; tc = *p1; ++p1 ) {
	/* quit when we find any char in charset */
	if( ( vector[ tc >> 3 ] & _Bits[ tc & 0x07 ] ) != 0 ) {
	    *p1 = '\0'; 	    /* terminate the token  */
	    p1++;		    /* start of next token  */
	    _RWD_nexttok = p1;
	    return( str );
	}
    }
    _RWD_nexttok = NULL;
#endif

    return( str );
}
