/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985,1992 by WATCOM Systems Inc. All rights %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  11-aug-92     A.F.Scian       Separated from sprintf.c
--------------------------------------------------------Version-11.0---------
  22-feb-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  25-apr-95	M. Hildebrand	Use Normative Addendum parameter list for
				vswprintf (new parameter added).
  25-apr-95	M. Hildebrand	Fixed multithreading issues in above fix.
  31-may-95	Greg Bentz	variety.h and dll linkage
  27-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  01-nov-95     Greg Bentz	QNX -3s register convention
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <stdarg.h>
#include <limits.h>
#include "printf.h"


/*
 * mem_putc -- append a character to a string in memory
 */
#ifdef __WIDECHAR__

struct vswprtf_buf {
    CHAR_TYPE *		bufptr;
    int			chars_output;
    int			max_chars;
};

static slib_callback_t mem_putc; // setup calling convention
static void __SLIB_CALLBACK mem_putc( SPECS __SLIB *specs, int op_char )
{
    struct vswprtf_buf *info;

    info = (struct vswprtf_buf*) specs->_o._dest;
    if( info->chars_output+1 <= info->max_chars ) {
	*( info->bufptr++ ) = op_char;
	specs->_o._output_count++;
	info->chars_output++;
    }
}

#else

static slib_callback_t mem_putc; // setup calling convention
static void __SLIB_CALLBACK mem_putc( SPECS __SLIB *specs, int op_char )
    {
        *( specs->_o._dest++ ) = op_char;
        specs->_o._output_count++;
    }

#endif


#ifdef __WIDECHAR__
_WCRTLINK int _uvsprintf( wchar_t *dest, const wchar_t *format, va_list arg )
{
    return( vswprintf( dest, INT_MAX, format, arg ) );
}
#endif


#ifdef __WIDECHAR__
 _WCRTLINK int vswprintf( CHAR_TYPE *dest, size_t n, const CHAR_TYPE *format, va_list arg )
#else
 _WCRTLINK int vsprintf( CHAR_TYPE *dest, const CHAR_TYPE *format, va_list arg )
#endif
    {
	slib_callback_t *tmp;
	#ifndef __WIDECHAR__
	    register int len;
	#else
	    auto struct vswprtf_buf info;
	#endif

#if defined(__386__) && defined(__QNX__)
	/* avoid some segment relocations for 32-bit QNX */
	tmp = (void (*)())mem_putc;
#else
	tmp = mem_putc;
#endif
	#ifdef __WIDECHAR__
	    if( n != 0 ) {
		info.bufptr = dest;
		info.chars_output = 0;
		info.max_chars = n - 1;
		__wprtf( &info, format, arg, tmp );
		dest[info.chars_output] = NULLCHAR;
	    }
	    return( info.chars_output );
	#else
	    len = __prtf( dest, format, arg, tmp );
	    dest[len] = NULLCHAR;
	    return( len );
	#endif
    }
