/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  17-mar-87	F.W.Crigger	Initial implementation
  ---		---		Version 8.0
  11-oct-90	D.Gaudet	rewritten so that sprintf isn't used
  02-nov-90	J.B.Schueler	changed offset for final blank from 18 to 19
---------------------------------------------------------Version 8.5--------
  18-dec-91	F.W.Crigger	Added _asctime and _ctime
  11-jun-92	D. Wellstood	Unicode support
  26-oct-92	J.B.Schueler	added "const" keyword to static arrays
  23-sep-92 G.Turcotte (Quantum) No leading zero on single digit day of month
--------------------------------------------------------Version-11.0---------
  02-mar-95	M. Hildebrand	Changed from UNICODE.H to WIDECHAR.H.
  18-may-95	Greg Bentz	use variety.h and _WCRTLINK
  21-sep-95	M. Hildebrand	Added _u version, which calls wide version.
  03-jan-96	Greg Bentz	remove stubs that are now aliases
*/
#include "variety.h"
#include "widechar.h"
#include <time.h>
#include <stdlib.h>
#include "rtdata.h"
#include "asctime.h"

static void convDec( int num, int off, CHAR_TYPE *buf )
{
    div_t tens_units;

    tens_units = div( num, 10 );
    buf[off] = tens_units.quot + '0';
    buf[off+1] = tens_units.rem + '0';
}


_WCRTLINK CHAR_TYPE *__F_NAME(_asctime,__wasctime)( const struct tm *tm, CHAR_TYPE *buf )
{
    static const char months[] = {
	'J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D',
	'a', 'e', 'a', 'p', 'a', 'u', 'u', 'u', 'e', 'c', 'o', 'e',
	'n', 'b', 'r', 'r', 'y', 'n', 'l', 'g', 'p', 't', 'v', 'c'
    };
    static const char weekdays[] = {
	'S', 'M', 'T', 'W', 'T', 'F', 'S',
	'u', 'o', 'u', 'e', 'h', 'r', 'a',
	'n', 'n', 'e', 'd', 'u', 'i', 't'
    };
    div_t hundreds_units;
    int i;

    i = tm->tm_wday;
    buf[0] = weekdays[ i ];
    buf[1] = weekdays[ i + 7 ];
    buf[2] = weekdays[ i + 14 ];
    buf[3] = ' ';
    i = tm->tm_mon;
    buf[4] = months[ i ];
    buf[5] = months[ i + 12 ];
    buf[6] = months[ i + 24 ];
    buf[7] = ' ';
    convDec( tm->tm_mday, 8, buf );			/* 8-9 */
    if (buf[8]=='0') buf[8]=' ';     /* space padding for day of month */
    buf[10] = ' ';
    convDec( tm->tm_hour, 11, buf );			/* 11-12 */
    buf[13] = ':';
    convDec( tm->tm_min, 14, buf );			/* 14-15 */
    buf[16] = ':';
    convDec( tm->tm_sec, 17, buf );			/* 17-18 */
    buf[19] = ' ';					/* 02-nov-90 */
    hundreds_units = div( tm->tm_year, 100 );
    convDec( hundreds_units.quot + 19, 20, buf );	/* 20-21 */
    convDec( hundreds_units.rem, 22, buf );		/* 22-23 */
    buf[24] = '\n';
    buf[25] = NULLCHAR;

    return( buf );
}

#ifndef __NETWARE__
_WCRTLINK CHAR_TYPE *__F_NAME(asctime,_wasctime)( const struct tm *tm )
{
    _INITRESULT
    return(__F_NAME(_asctime,__wasctime)( tm, (CHAR_TYPE*)_RWD_asctime ) );
}


_WCRTLINK CHAR_TYPE *__F_NAME(_ctime,__wctime)( const time_t *timer, CHAR_TYPE *buf )
{
    struct tm	tm;

    return( __F_NAME(_asctime,__wasctime)( _localtime( timer, &tm ), buf ) );
}


_WCRTLINK CHAR_TYPE *__F_NAME(ctime,_wctime)( const time_t *timer )
{
    return( __F_NAME(asctime,_wasctime)( localtime( timer ) ) );
}
#endif
