/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  20-dec-90	J.B.Schueler	Initial implementation
  06-apr-92	B.J. Stecher	timezone calc must be a signed division
--------------------------------------------------------Version-11.0---------
  18-may-95	Greg Bentz	use variety.h and _WCRTLINK
  13-mar-96	Greg Bentz	make return values and prototype match doc
*/

#include "variety.h"
#include <time.h>
#include <sys/timers.h>
#include <sys/timeb.h>

_WCRTLINK int ftime( struct timeb *timeptr )
{
    struct timespec ts;
    time_t	    timer;
    struct tm	    *tm_ptr;


    if( getclock( TIMEOFDAY, &ts ) == -1 ) return( -1 );

    timer = (time_t) ts.tv_sec;
    if( ts.tv_nsec >=  500000000L ) timer++;

    tm_ptr = localtime( &timer );

    timeptr->dstflag  = tm_ptr->tm_isdst;
    timeptr->time     = (time_t) ts.tv_sec;
    timeptr->millitm  = ts.tv_nsec / 1000000;
    timeptr->timezone = timezone / 60L;
    return( 1 );
}
