/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  18-jan-87     F.W.Crigger     Initial implementation
  04-feb-88     F.W.Crigger     Check for rolling over midnight
----------------------------------------------------------Version 6.0-------
  13-apr-88     F.W.Crigger     use intdos instead of _DOSCall
  26-may-88     F.W.Crigger     set t->tm_isdst to -1
----------------------------------------------------------Version 8.0-------
  19-dec-90     F.W.Crigger     return milliseconds rather than updating tm_sec
                                Also changed name from _getctime to __getctime
  30-jan-91     C.G.Eisler      re-written to use tinyio.
  10-feb-93	A. Gupta	Netware support
--------------------------------------------------------Version-11.0---------
  18-may-95	Greg Bentz	use variety.h and _WCRTLINK
 *
 *      Get Current Time and Date
 *
 */

#include "variety.h"
#include <time.h>
#ifndef __NETWARE__
 #include <dos.h>
 #include "dosfunc.h"
 #include "tinyio.h"
#endif
#include "timedata.h"


#ifdef __NETWARE__

#define BUFF_SIZE	8

extern void		GetFileServerDateAndTime( void * );


int __getctime( struct tm *ti )
{
    char	buff[ BUFF_SIZE	];

    GetFileServerDateAndTime( buff );
    ti->tm_year = buff[ 0 ];
    ti->tm_mon = buff[ 1 ];
    ti->tm_mday = buff[ 2 ];
    ti->tm_hour = buff[ 3 ];
    ti->tm_min  = buff[ 4 ];
    ti->tm_sec  = buff[ 5 ];
    ti->tm_wday = buff[ 6 ];
    ti->tm_isdst = -1;
    return( 0 );
}

#else

int __getctime( struct tm *ti )
    {
        int  milliseconds;
        tiny_date_t d,tmp;
        tiny_time_t t;

        d = TinyGetDate();
        ti->tm_year = d.year;
        ti->tm_mon  = d.month - 1;
        ti->tm_mday = d.day_of_month;
        t = TinyGetTime();
        ti->tm_hour = t.hour;
        ti->tm_min  = t.minutes;
        ti->tm_sec  = t.seconds;
        milliseconds = t.hundredths * 10;    /* 19-dec-90 */
        
        tmp = TinyGetDate();
        /* check for midnight rollover */
        if( tmp.day_of_month != d.day_of_month && ti->tm_hour != 23 ) {
            ti->tm_year = tmp.year;
            ti->tm_mon  = tmp.month - 1;
            ti->tm_mday = tmp.day_of_month;
        }
        ti->tm_isdst = -1;
        return( milliseconds );
    }

#endif
