/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  25-may-89	John Dahms	split out of gmtime
  17-aug-90	B.J. Stecher	added __dst_adjust variable
  01-nov-90	J.B.Schueler	Removed daylight check since it's in isindst()
  12-jul-91	J.B.Schueler	Macrotized references to R/W data
----------------------------------------------------------Version 8.5------
  18-dec-91	F.W.Crigger	Added _localtime
----------------------------------------------------------Version 9.5------
  17-jun-93	J.B.Schueler	corrected for fringe case (the 12 hours after
				Thu Jan  1 00:00:00 1970) for time zones west
				of UTC like EST, PST.
--------------------------------------------------------Version-11.0---------
  18-may-95	Greg Bentz	use variety.h and _WCRTLINK
*/

/*
 *	Convert time_t into struct tm
 */

#include "variety.h"
#include <time.h>
#include "rtdata.h"
#include "thetime.h"
#include "timedata.h"

_WCRTLINK struct tm *_localtime( const time_t *timer, struct tm *t )
{
    auto time_t tod;

    tzset();
    tod = *timer;
    __brktime( DAYS_FROM_1900_TO_1970, tod, _RWD_timezone, t );

    if( __isindst( t ) ) {
	__brktime( DAYS_FROM_1900_TO_1970, tod,
		   _RWD_timezone - _RWD_dst_adjust, t );
    }
    return( t );
}

_WCRTLINK struct tm *localtime( const time_t *timer )
{
    _INITTHETIME;
    return _localtime( timer, &_THE_TIME );
}
