/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  18-jan-87     F.W.Crigger     initial implementation
  04-feb-88     F.W.Crigger     added call to tzset.
----------------------------------------------------------Version 6.0------
  13-apr-88     F.W.Crigger     time changed to call mktime.
----------------------------------------------------------Version 8.0------
  01-nov-90     J.B.Schueler    removed redundant line of code
  19-dec-90     F.W.Crigger     __getctime now returns milliseconds, so we
                                use that to update t.tm_sec instead of
                                __getctime doing that
--------------------------------------------------------Version-11.0---------
  18-may-95	Greg Bentz	use variety.h and _WCRTLINK
*/
/*
 *      Get Current Time and Date
 *
 */

#include "variety.h"
#include <stdio.h>
#include <time.h>
#include "timedata.h"


_WCRTLINK time_t time( time_t *timer )
    {
        auto struct tm t;
        time_t seconds;
        int    milliseconds;

        milliseconds = __getctime( &t );        /* get raw time and date */
        if( milliseconds >= 500 )  t.tm_sec++;
#if 0
        t.tm_isdst = -1;        /* 01-nov-90 getctime sets isdst to -1 */
#endif
        seconds = mktime( &t );
        if( timer != NULL )  *timer = seconds;
        return( seconds );
    }
