;****************************************************************************
;***									  ***
;*** WINCB32.ASM - callback handling for 32 bit windows			  ***
;***									  ***
;***	Date		By		Reason				  ***
;***	====		==		======				  ***
;***	31-may-93	F.W.Crigger	New implementation		  ***
;***									  ***
;****************************************************************************
.386p

DGROUP group _DATA

_TEXT segment word public 'CODE'
_TEXT ends

_DATA segment word public 'DATA'
_DATA ends

;*
;*** callback data defined here
;*
_DATA segment

extrn _CBJumpTable : dword

_DATA ends

_TEXT segment
assume cs:_TEXT
;****************************************************************************
;***									  ***
;*** __32BitCallBack - invoke a specified call back function.		  ***
;***									  ***
;***   Incoming registers : DX - callback routine number		  ***
;***   Outgoing registers : DL - amount to pop from stack		  ***
;***									  ***
;****************************************************************************

	public	__32BitCallBack
__32BitCallBack proc	far
	push	ESI			; save ESI
	push	EDI			; save EDI
	push	ECX			; save ecx
	push	EBX			; save ebx
	movzx	ECX,BP			; get access to 16-bit stack
	mov	DI,DS			; save 16-bit DS
	mov	DS,AX			; get 16-bit stack selector
	movzx	EDX,DX			; zero high part
	mov	EDX,ES:_CBJumpTable[EDX]; get address of callback rtn
	call	EDX			; call the generated callback
	mov	DS,DI			; restore 16-bit DS
	pop	EBX			; restore EBX
	pop	ECX			; restore ECX
	pop	EDI			; restore EDI
	pop	ESI			; restore ESI
	ret				; return
__32BitCallBack endp

_TEXT	ends
	end
