/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ====		==		======
   13-jan-92	Craig Eisler	initial implementation
   19-apr-92	Craig Eisler	Windows 3.1 extensions
   20-mar-93	Craig Eisler	toolhelp
*/
#include <windows.h>

extern void *UserProcs[];

CALLBACKPTR GetProc16( PROCPTR pp, long type )
{
    CALLBACKPTR	ptr;

    switch( type ) {
    case GETPROC_CALLBACK:
//  case GETPROC_SETTIMER:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_WORD, GCB_WORD,
					GCB_DWORD, GCB_ENDLIST );
	break;

    case GETPROC_ABORTPROC:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_WORD, GCB_ENDLIST );
	break;

    case GETPROC_ENUMFONTS:
    	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_WORD,
					GCB_DWORD, GCB_ENDLIST );
	break;

    case GETPROC_ENUMMETAFILE:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_DWORD, GCB_DWORD,
					GCB_WORD, GCB_DWORD, GCB_ENDLIST );
	break;

    case GETPROC_ENUMOBJECTS:
    	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;

    case GETPROC_ENUMPROPS_FIXED_DS:
//  case GETPROC_GRAYSTRING:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;

    case GETPROC_ENUMPROPS_MOVEABLE_DS:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_WORD, GCB_WORD, GCB_WORD,
					GCB_ENDLIST );
	break;

    case GETPROC_ENUMTASKWINDOWS:
//  case GETPROC_ENUMWINDOWS:
//  case GETPROC_ENUMCHILDWINDOWS:
//  case GETPROC_TOOLHELP_NOTIFY:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_DWORD, GCB_ENDLIST );
	break;

    case GETPROC_GLOBALNOTIFY:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_ENDLIST );
	break;

    case GETPROC_LINEDDA:
//  case GETPROC_SETWINDOWSHOOK:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_WORD, GCB_DWORD,
					GCB_ENDLIST );
	break;

    case GETPROC_SETRESOURCEHANDLER:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_WORD, GCB_WORD,
					GCB_ENDLIST );
	break;

    case GETPROC_DDEMLCALLBACK:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_WORD, GCB_DWORD,
					GCB_DWORD, GCB_DWORD, GCB_DWORD,
					GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_PENWIN_RCYIELDPROC:
    	ptr = GetCallbackRoutine( pp, GCB_ENDLIST );
	break;
    case GETPROC_PENWIN_LPDF:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_DWORD, GCB_DWORD,
				GCB_WORD, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_PENWIN_LPFNRAWHOOK:
    	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_PENWIN_ENUMPROC:
    	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_MMSYSTEM_MMIOPROC:
    	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_DWORD,
			GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_MMSYSTEM_YIELDPROC:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_DWORD, GCB_ENDLIST );
	break;
#if 0
    case GETPROC_MMSYSTEM_TIMECALLBACK:
    	ptr = GetCallbackRoutine( pp, GCB_WORD, GCB_WORD, GCB_DWORD,
			GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
#endif
#if 0
    case GETPROC_OLE_OV_QUERYPROTOCOL:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_RELEASE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_SHOW:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_DOVERB:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_WORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_GETDATA:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_SETDATA:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_SETTARGETDEVICE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_SETBOUNDS:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_ENUMFORMATS:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_SETCOLORSCHEME:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_DELETE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_SETHOSTNAMES:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_SAVETOSTREAM:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_CLONE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD,
					GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_COPYFROMLINK:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD,
					GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_EQUAL:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_COPYTOCLIPBOARD:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_DRAW:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_DWORD,
				GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_ACTIVATE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_WORD, GCB_WORD,
				  GCB_WORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_EXECUTE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_CLOSE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_UPDATE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_RECONNECT:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_OBJECTCONVERT:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD,
			GCB_DWORD, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_GETLINKUPDATEOPTIONS:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_SETLINKUPDATEOPTIONS:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_RENAME:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_QUERYNAME:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_QUERYTYPE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_QUERYBOUNDS:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_QUERYSIZE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_QUERYOPEN:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_QUERYOUTOFDATE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_QUERYRELEASESTATUS:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_QUERYRELEASEERROR:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_QUERYRELEASEMETHOD:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_REQUESTDATA:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_OBJECTLONG:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_OV_CHANGEDATA:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_DWORD,
				GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SDV_SAVE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SDV_CLOSE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SDV_SETHOSTNAMES:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SDV_SETDOCDIMENSIONS:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SDV_GETOBJECT:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD,
				GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SDV_RELEASE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SDV_SETCOLORSCHEME:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SDV_EXECUTE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SV_OPEN:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD,
			GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SV_CREATE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD,
			GCB_DWORD, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SV_CREATEFROMTEMPLATE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD,
			GCB_DWORD, GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SV_EDIT:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_DWORD, GCB_DWORD,
			GCB_DWORD, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SV_EXIT:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SV_RELEASE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_ENDLIST );
	break;
    case GETPROC_OLE_SV_EXECUTE:
	ptr = GetCallbackRoutine( pp, GCB_DWORD, GCB_WORD, GCB_ENDLIST );
	break;
#endif
    default:
    	if( type >= GETPROC_USERDEFINED_1 && type <= GETPROC_USERDEFINED_32 ) {
	    ptr = UserProcs[ type - GETPROC_USERDEFINED_1 ];
	}
    	break;
    }
    return( ptr );

} /* GetProc16 */
