/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ====		==		======
   20-mar-91	Craig Eisler	defined
   23-may-91	Craig Eisler	didn't return anything on success!
   04-jun-91	Craig Eisler	free old entries
   15-aug-91	Craig Eisler	SetDLLEntry for -3s wrong prototype
---------------------------------------------------------Version 9.0--------
   02-nov-91	Craig Eisler	cleaned up
   17-nov-92	Craig Eisler	allow 512 DLL entries
*/
#include <windows.h>
#include <dos.h>
#include <malloc.h>
#include <stdarg.h>

typedef struct libent {
    void	*proc;
    short	num;
    short	bytes;
    short	lens[1];
} libent;

#define	MAX_DLL_ENTRIES	512

extern	DWORD far *_DLLEntryAddr;
libent	*__DLLEntries[MAX_DLL_ENTRIES];	// DLL entry points

/*
 * DefineDLLEntry - define an entry point to a 32-bit dll
 *                  variable parms are either DLL_CHAR, DLL_WORD, DLL_DWORD,
 *                  or DLL_ENDLIST
 */
int DefineDLLEntry( int entnum, void *routine, ... )
{
    va_list	al;
    libent	*curr;
    int		bytecount=0,num=0,i=0,len;

    if( entnum >= MAX_DLL_ENTRIES ) {
	return( -1 );
    }
    va_start( al, routine );
    for(;;) {
	len = va_arg( al, int );
	if( len == DLL_ENDLIST ) break;
	if( len == DLL_WORD || len == DLL_DWORD ) {
	    if( len == DLL_DWORD ) bytecount += 4;
	    else bytecount += 2;
	    num++;
	} else {
	    return( -1 );
	}
	if( num > 512 ) {
	    return( NULL ); /* ya, so its arbitrary */
	}
	
    }
    va_end( al );
    
    curr = malloc( sizeof( libent ) + num * sizeof( short ) );
    if( curr == NULL ) {
	return( -1 );
    }
    curr->num = num;
    curr->bytes = bytecount;
    curr->proc = routine;
    
    /*
     * add all lengths
     */
    va_start( al, routine );
    while( num > 0 ) {
	len = va_arg( al, short );
	curr->lens[i++] = len;
	num--;
    }
    free( __DLLEntries[entnum] );	// free old entry
    __DLLEntries[entnum] = curr;	// set new entry
    *_DLLEntryAddr = (DWORD) &__DLLEntries[0];
    
    va_end( al );
    return( 0 );
        
} /* DefineDLLEntry */
