/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ====		==		======
   02-nov-91	C.G.Eisler	split from mproc.c
   12-nov-91	C.G.Eisler	new SetProc
   03-nov-93	F.W.Crigger	Added GetWindowLong to record values gotten
				so that SetWindowLong can determine if we
				need to do a SetProc. We don't want to
				generate a thunk for a 16:16 pointer when
				we are trying to restore an old 16:16 value
				saved by GetWindowLong.
  22-jun-94	F.W.Crigger	_Cover_SetWindowLong wasn't calling SetProc
  				after adding a new entry to the list
*/
#include "cover.h"
#include <stdlib.h>

struct wndprocs	*WndProcList = 0;

LONG PASCAL _Cover_GetWindowLong( HWND wnd, int what )
{
    LONG	value;
    struct wndprocs *list;

    value = GetWindowLong( wnd, what );
    if( what == GWL_WNDPROC ) {
	for( list = WndProcList; ; list = list->next ) {
	    if( list == NULL ) {
		list = malloc( sizeof( struct wndprocs ) );
		if( list != NULL ) {
		    list->next = WndProcList;
		    list->hwnd = wnd;
		    list->procaddr = value;
		    list->proctype = PROC_16;
		    WndProcList = list;
		}
		break;
	    }
	    if( list->hwnd == wnd  &&  list->procaddr == value )  break;
	}
    }
    return( value );
}

LONG PASCAL _Cover_SetWindowLong( HWND wnd, int what, LONG value )
{
    struct wndprocs *list;

    if( what == GWL_WNDPROC ) {
	for( list = WndProcList; ; list = list->next ) {
	    if( list == NULL ) {
		list = malloc( sizeof( struct wndprocs ) );
		if( list == NULL ) return( 0 );
		list->next = WndProcList;
		list->hwnd = wnd;
		list->procaddr = value;
		list->proctype = PROC_32;
		WndProcList = list;
	    }
	    if( list->hwnd == wnd  &&  list->procaddr == value ) {
		if( list->proctype == PROC_32 ) {
		    value = (LONG)SetProc( (FARPROC)value, GETPROC_CALLBACK );
		}
		break;
	    }
	}
    }
    return( SetWindowLong( wnd, what, value ) );
}
