/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ====		==		======
   02-nov-91	Craig Eisler	split from cover.c
   01-jun-92	Craig Eisler	do not test hwnd == -1
   10-may-95	F.W.Crigger	don't call GetClassName if hwnd == 0
*/
#include "cover.h"
#include <string.h>
#define MAX_CNAME	10

BOOL TryAlias( HWND hwnd, WORD msg, LONG *lparam )
{
    DWORD		alias;
    MDICREATESTRUCT	*mcs;
    char		class[MAX_CNAME];

    if( hwnd == (HWND)~0 ) return( FALSE );

    /*
     * misc. messages
     */
    switch( msg ) {
    case WM_NCCALCSIZE:
	alias = AllocAlias16( (LPSTR) *lparam );
	*lparam = alias;
	return( TRUE );
    case WM_MDICREATE:
	mcs = (MDICREATESTRUCT *) *lparam;
	mcs->szClass = (LPSTR) AllocAlias16( (LPSTR)mcs->szClass );
	mcs->szTitle = (LPSTR) AllocAlias16( (LPSTR)mcs->szTitle );
	alias = AllocAlias16( (LPSTR) *lparam );
	*lparam = alias;
	return( TRUE );
    }

    /*
     * try class specific messages
     */
    if( hwnd == 0 ) return( FALSE );		/* 10-may-95 */
    class[0] = 0;
    GetClassName( hwnd, class, MAX_CNAME );
    class[MAX_CNAME-1] = 0;

    /*
     * combo box messages
     */
    if( !stricmp( class,"COMBOBOX" ) ) {
	switch( msg ) {
	case CB_ADDSTRING:
	case CB_DIR:
	case CB_FINDSTRING:
	case CB_GETLBTEXT:
	case CB_INSERTSTRING:
	case CB_SELECTSTRING:
	    alias = AllocAlias16( (LPSTR) *lparam );
	    *lparam = alias;
	    return( TRUE );
	}
    }

    /*
     * edit control messages
     */
    if( !stricmp( class,"EDIT" ) ) {
	switch( msg ) {
	case EM_GETLINE:
	case EM_GETRECT:
	case EM_REPLACESEL:
	case EM_SETRECT:
	case EM_SETRECTNP:
	case EM_SETTABSTOPS:
	    alias = AllocAlias16( (LPSTR) *lparam );
	    *lparam = alias;
	    return( TRUE );
	}
    }

    /*
     * list box messages
     */
    if( !stricmp( class,"LISTBOX" ) ) {
	switch( msg ) {
	case LB_ADDSTRING:
	case LB_DIR:
	case LB_FINDSTRING:
	case LB_GETITEMRECT:
	case LB_GETSELITEMS:
	case LB_GETTEXT:
	case LB_INSERTSTRING:
	case LB_SELECTSTRING:
	case LB_SETTABSTOPS:
	    alias = AllocAlias16( (LPSTR) *lparam );
	    *lparam = alias;
	    return( TRUE );
	}
    }

    return( FALSE );
}
