;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  03-dec-89    F.W.Crigger     Initial implementation
;  02-jun-90    F.W.Crigger     Added Windows support
;  01-mar-91    F.W.Crigger     Windows conventions now same as DOS
;  09-jan-92	C.G.Eisler	save/restore DX
;  12-sep-94	Greg Bentz	check for _HUGE_DATA with _BIG_DATA
;  07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;
include mdef.inc
include struct.inc

	if __WASM__ ge 100
	    xref    "C",__set_EINVAL
	else
	    xref    <"C",__set_EINVAL>
	endif
        modstart dosdisk

        defp    _dos_getdiskfree
	if __WASM__ ge 100
	    xdefp   "C",_dos_getdiskfree
	else
	    xdefp   <"C",_dos_getdiskfree>
	endif
;
;       unsigned _dos_getdiskfree( unsigned drive,
;                                  struct diskfree_t *diskspace)
;       struct diskfree_t {
;               unsigned total_clusters;
;               unsigned avail_clusters;
;               unsigned sectors_per_cluster;
;               unsigned bytes_per_sector;
;       };
;
        push    DI              ; save DI
        push    CX              ; save CX
        push    BX              ; save BX
        push    DX              ; save DX
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,CX           ; get FP_SEG(diskspace)
        mov     DI,BX           ; get FP_OFF(diskspace)
else
        mov     DI,DX           ; get address of diskfree_t structure
endif
        mov     DX,AX           ; get drive number
        mov     AH,36h          ; get disk free space
        int     21h             ; ...
        cmp     AX,0FFFFh       ; if valid drive number
        _if     ne              ; then
          mov   [DI],DX         ; - save total # of clusters
          mov   2[DI],BX        ; - save available number of clusters
          mov   4[DI],AX        ; - save number of sectors per cluster
          mov   6[DI],CX        ; - save number of bytes per sector
          sub   AX,AX           ; - indicate no errors
        _else                   ; else
	  call	__set_EINVAL	; - set errno = EINVAL
        _endif                  ; endif
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
	pop	DX              ; restore DX
	pop	BX              ; restore BX
	pop	CX              ; restore CX
	pop	DI              ; restore DI
        ret                     ; return to caller
        endproc _dos_getdiskfree

        endmod
        end
