;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  03-dec-89    F.W.Crigger     Initial implementation
;  02-jun-90    F.W.Crigger     Added Windows support
;  01-mar-91    F.W.Crigger     Windows conventions now same as DOS
;  12-sep-94	Greg Bentz	check for _HUGE_DATA with _BIG_DATA
;  07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;
include mdef.inc
include struct.inc

        modstart dosdrive

        defp    _dos_getdrive
	if __WASM__ ge 100
	    xdefp   "C",_dos_getdrive
	else
	    xdefp   <"C",_dos_getdrive>
	endif
;
;       unsigned _dos_getdrive( unsigned *drive );
;
        push    BX              ; save BX
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,DX           ; point to drive
endif
        mov     BX,AX           ; get address of drive
        mov     AH,19h          ; get current drive
        int     21h             ; ...
        inc     AX              ; increment drive #
        mov     AH,0            ; zero high part
        mov     [BX],AX         ; store drive #
        sub     AX,AX           ; set return code
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        pop     BX              ; restore BX
        ret                     ; return to caller
        endproc _dos_getdrive
;-----------------------------------------------------------------------
        defp    _dos_setdrive
	if __WASM__ ge 100
	    xdefp   "C",_dos_setdrive
	else
	    xdefp   <"C",_dos_setdrive>
	endif
;
;       void _dos_setdrive( unsigned drivenum, unsigned *drives )
;
        push    BX              ; save BX
        push    DX              ; save DX
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,CX           ; point to drive
else
        mov     BX,DX           ; get address of drive
endif
        mov     DX,AX           ; get drive number
        dec     DX              ; ...
        mov     AH,0Eh          ; set current drive
        int     21h             ; ...
        mov     AH,0            ; zero high part of return
        mov     [BX],AX         ; store total # of drives
        sub     AX,AX           ; set return code
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        pop     DX              ; restore DX
        pop     BX              ; restore BX
        ret                     ; return to caller
        endproc _dos_setdrive

        endmod
        end
