;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  03-dec-89    F.W.Crigger     Initial implementation
;  03-jun-90    F.W.Crigger     Added Windows Support
;  01-mar-91    F.W.Crigger     Windows conventions now same as DOS
;  10-feb-94	Greg Bentz	add _dos_findclose stub
;  12-sep-94	Greg Bentz	check for _HUGE_DATA with _BIG_DATA
;  07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;
include mdef.inc
include struct.inc

        xref    __doserror_
        modstart dosfind

        defp    _dos_findfirst
	if __WASM__ ge 100
	    xdefp   "C",_dos_findfirst
	else
	    xdefp   <"C",_dos_findfirst>
	endif
;
;       unsigned _dos_findfirst( char *path, unsigned attr, struct find_t *buf)
;       struct find_t {
;               char reserved[21];              reserved for use by DOS
;               char attribute;                 attribute byte for matched path
;               unsigned short wr_time;         time of last write to file
;               unsigned short wr_date;         date of last write to file
;               unsigned long  size;            length of file in bytes
;               char name[13];                  null-terminated name of file
;       };
;
        push    BP              ; save BP
        mov     BP,SP           ; get access to stack
        push    BX              ; save BX
        push    CX              ; save CX
        push    DX              ; save DX
  if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        push    DX              ; get FP_SEG(path)
        push    AX              ; get FP_OFF(path)
        mov     CX,BX           ; get attr
    if _MODEL and _BIG_CODE
          lds   DX,6[BP]        ; - get pointer to buffer
    else
          lds   DX,4[BP]        ; - get pointer to buffer
    endif
  else
        push    DS              ; push address of path
        push    AX              ; ...
        mov     CX,DX           ; get attr
        mov     DX,BX           ; get address of buffer
  endif
        mov     AH,1Ah          ; set Disk Transfer Address
        int     21h             ; ...
        pop     DX              ; get pointer to path
        pop     DS              ; ...
        mov     AH,4Eh          ; findfirst file
        int     21h             ; ...
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        call    __doserror_     ; set return code
        pop     DX              ; restore DX
        pop     CX              ; restore CX
        pop     BX              ; restore BX
        pop     BP              ; restore BP
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        ret     4               ; return to caller
else
        ret                     ; return to caller
endif
        endproc _dos_findfirst
;-----------------------------------------------------------------------
        defp    _dos_findnext
	if __WASM__ ge 100
	    xdefp   "C",_dos_findnext
	else
	    xdefp   <"C",_dos_findnext>
	endif
;
;       unsigned _dos_findnext( struct find_t *buf)
;
        push    DX              ; save DX
  if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,DX           ; get FP_SEG(buf)
  endif
        mov     DX,AX           ; get FP_OFF(buf)
        mov     AH,1Ah          ; set Disk Transfer Address
        int     21h             ; ...
        mov     AH,4Fh          ; findnext file
        int     21h             ; ...
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        call    __doserror_     ; set return code
        pop     DX              ; restore DX
        ret                     ; return to caller
        endproc _dos_findnext
;-----------------------------------------------------------------------
	defp	_dos_findclose
	if __WASM__ ge 100
	    xdefp   "C",_dos_findclose
	else
	    xdefp   <"C",_dos_findclose>
	endif
;
;       unsigned _dos_findclose( struct find_t *buf)
;
	xor	AX,AX 		; stub program under MS-DOS
        ret                     ; return to caller
        endproc _dos_findclose

        endmod
        end
