;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1989 by WATCOM Systems Inc. All rights	   %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:	  by:		reason:
;  ---------	  ---		-------
;  31-dec-89	F.W.Crigger	Initial implementation for 386
;  02-dec-92	F.W.Crigger	Intel CodeBuilder does not support Set DTA
;  16-sep-93	F.W.Crigger	int21 added
;  10-feb-94	Greg Bentz	add _dos_findclose stub
;  03-mar-94	Greg Bentz	merge with osi file
;  02-may-94	A.F.Scian	fixed set DTA call for non-OSI
;  03-may-94	Greg Bentz	fixed another set DTA call for OSI
;  07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;
include mdef.inc
include struct.inc
include extender.inc
include int21.inc

	xref	__doserror_
	modstart dosfind

	datasegment
	extrn	"C",_Extender : byte
	enddata

	defp	_dos_findfirst
	if __WASM__ ge 100
	    xdefp	"C",_dos_findfirst
	else
	    xdefp	<"C",_dos_findfirst>
	endif
;
;	unsigned _dos_findfirst( char *path, unsigned attr, struct find_t *buf)
;	struct find_t {
;		char reserved[21];		reserved for use by DOS
;		char attribute;			attribute byte for matched path
;		unsigned short wr_time;		time of last write to file
;		unsigned short wr_date;		date of last write to file
;		unsigned long  size;		length of file in bytes
;		char name[13];			null-terminated name of file
;	};
DTA_SIZE equ	43
;
ifdef __STACK__
	push	EBX
	push	EDX
	mov	EAX,12[ESP]	; get path
	mov	EDX,16[ESP]	; attr
	mov	EBX,20[ESP]	; buf
endif
	push	ECX		; save ECX
	push	EAX		; save pointer to path
	push	EDX		; save attribute
ifndef __OSI__
	mov	EDX,EBX		; get buffer address
	mov	AH,1Ah		; set Disk Transfer Address
	int21h			; ...
endif
	pop	ECX		; get attribute for search
	pop	EDX		; get pointer to path
	mov	AH,4Eh		; findfirst file
	int21h			; ...
	call	__doserror_	; set return code
ifndef __OSI__
	mov	EDX,EBX		; get buffer address
	call	__CopyDTA	; copy DTA to EDX under Intel CodeBuilder
endif
	pop	ECX		; restore ECX
ifdef __STACK__
	pop	EDX
	pop	EBX
endif
	ret			; return to caller
	endproc _dos_findfirst
;-----------------------------------------------------------------------
	defp	_dos_findnext
	if __WASM__ ge 100
	    xdefp	"C",_dos_findnext
	else
	    xdefp	<"C",_dos_findnext>
	endif
;
;	unsigned _dos_findnext( struct find_t *buf)
;
ifdef __STACK__
	mov	EAX,4[ESP]	; get parm
endif
	push	EDX		; save EDX
	mov	EDX,EAX		; get buffer address
ifndef __OSI__
	mov	AH,1Ah		; set Disk Transfer Address
	int21h			; ...
	call	__SetDTA	; set DTA for Intel CodeBuilder
endif
	mov	AH,4Fh		; findnext file
ifdef __OSI__
	mov	AL,0		; indicate findnext vs findclose
endif
	int21h			; ...
	call	__doserror_	; set return code
ifndef __OSI__
	call	__CopyDTA	; copy DTA to EDX under Intel CodeBuilder
endif
	pop	EDX		; restore EDX
	ret			; return to caller
	endproc _dos_findnext
;-----------------------------------------------------------------------
        defp    _dos_findclose
	if __WASM__ ge 100
	    xdefp	"C",_dos_findclose
	else
	    xdefp	<"C",_dos_findclose>
	endif
;
;       unsigned _dos_findclose( struct find_t *buf)
;
	;	stub program under MS-DOS, doesn't do anything
	;	under OSI, makes call to loader
ifdef __OSI__
	push	EDX		; save edx
	mov	EDX,EAX		; pass in buffer addr
	mov	AH,4Fh		; find next
	mov	AL,1		; indicate CLOSE function
	int21h			; ...
	pop	EDX		; restore edx
endif
	xor	EAX,EAX		; indicate no error
        ret                     ; return to caller
        endproc _dos_findclose

ifndef __OSI__
__CopyDTA proc	near
	cmp byte ptr _Extender,X_INTEL	; if Intel CodeBuilder
	_if	e			; then
	  push	EAX			; - save EAX (return code)
	  push	EBX			; - save EBX
	  push	ECX			; - save ECX
	  push	ESI			; - save ESI
	  push	EDI			; - save EDI
	  mov	AH,2Fh			; - get Disk Transfer Address
	  int21h			; - ... comes back in EBX
	  mov	ESI,EBX			; - get Intel CB's DTA
	  mov	EDI,EDX			; - get user's find_t struct
	  mov	ECX,DTA_SIZE		; - get size of struct
	  rep	movsb			; - copy the struct
	  pop	EDI			; - restore EDI
	  pop	ESI			; - restore ESI
	  pop	ECX			; - restore ECX
	  pop	EBX			; - restore EBX
	  pop	EAX			; - restore EAX
	_endif				; endif
	ret				; return
__CopyDTA endp

__SetDTA proc	near
	cmp byte ptr _Extender,X_INTEL	; if Intel CodeBuilder
	_if	e			; then
	  push	EAX			; - save EAX (return code)
	  push	EBX			; - save EBX
	  push	ECX			; - save ECX
	  push	ESI			; - save ESI
	  push	EDI			; - save EDI
	  mov	AH,2Fh			; - get Disk Transfer Address
	  int21h			; - ... comes back in EBX
	  mov	EDI,EBX			; - get Intel CB's DTA
	  mov	ESI,EDX			; - get user's find_t struct
	  mov	ECX,DTA_SIZE		; - get size of struct
	  rep	movsb			; - copy the struct
	  pop	EDI			; - restore EDI
	  pop	ESI			; - restore ESI
	  pop	ECX			; - restore ECX
	  pop	EBX			; - restore EBX
	  pop	EAX			; - restore EAX
	_endif				; endif
	ret				; return
__SetDTA endp
endif

	endmod
	end
