;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  03-dec-89    F.W.Crigger     Initial implementation
;  03-jun-90    F.W.Crigger     Added Windows Support
;  06-feb-90    A.F.Scian       fixed problem with getting handle into
;                               correct register for DOS large data models
;  01-mar-91    F.W.Crigger     Windows conventions now same as DOS
;  10-apr-91    F.W.Crigger     _dos_getftime in large data model did not
;                               keep the segment registers separate
;  12-sep-94	Greg Bentz	check for _HUGE_DATA with _BIG_DATA
;  07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;
include mdef.inc
include struct.inc

        xref    __doserror_
        modstart dosftime

        defp    _dos_getftime
	if __WASM__ ge 100
	    xdefp   "C",_dos_getftime
	else
	    xdefp   <"C",_dos_getftime>
	endif
;
;       unsigned _dos_getftime( int handle,
;                               unsigned short *date,
;                               unsigned short *time );
;
        push    BP              ; save BP
        mov     BP,SP           ; get access to parms
        push    DI              ; save DI
        push    DX              ; save DX
        push    CX              ; save CX
        push    BX              ; save BX
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,CX           ; get FP_SEG(date)
        mov     DI,BX           ; get FP_OFF(date)
else
        push    BX              ; push address of time
        mov     DI,DX           ; get address of date
endif
        mov     BX,AX           ; get handle
        mov     AX,5700h        ; get file's date and time
        int     21h             ; ...
if _MODEL and (_BIG_DATA or _HUGE_DATA)
else
        pop     BX              ; get pointer to time
endif
        _if     nc              ; if no error
          mov   [DI],DX         ; - store date
if _MODEL and (_BIG_DATA or _HUGE_DATA)
 if _MODEL and _BIG_CODE
          lds   BX,6[BP]        ; - get pointer to time
 else
          lds   BX,4[BP]        ; - get pointer to time
 endif
endif
          mov   [BX],CX         ; - store time
        _endif                  ; endif
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        call    __doserror_     ; set return code
        pop     BX              ; restore BX
        pop     CX              ; restore CX
        pop     DX              ; restore DX
        pop     DI              ; restore DI
        pop     BP              ; restore BP
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        ret     4               ; return to caller
else
        ret                     ; return to caller
endif
        endproc _dos_getftime
;-----------------------------------------------------------------------
        defp    _dos_setftime
	if __WASM__ ge 100
	    xdefp   "C",_dos_setftime
	else
	    xdefp   <"C",_dos_setftime>
	endif
;
;       unsigned _dos_setftime( int handle,
;                               unsigned short date,
;                               unsigned short time );
;
        push    CX              ; save CX
        mov     CX,BX           ; get time
        mov     BX,AX           ; get file handle
        mov     AX,5701h        ; set file's date and time
        int     21h             ; ...
        call    __doserror_     ; set return code
        pop     CX              ; restore CX
        ret                     ; return to caller
        endproc _dos_setftime

        endmod
        end
