;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  03-dec-89    F.W.Crigger     Initial implementation
;  03-jun-90    F.W.Crigger     Added Windows support
;  01-mar-91    F.W.Crigger     Windows conventions now same as DOS
;  12-sep-94	Greg Bentz	check for _HUGE_DATA with _BIG_DATA
;  07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;
include mdef.inc
include struct.inc

        xref    __doserror_
        modstart dosio

get_parms macro
        push    BP              ; save BP
        mov     BP,SP           ; get access to parms
        push    DS              ; save DS
        mov     DS,CX           ; get FP_SEG(buf)
        mov     CX,DX           ; get count
        mov     DX,BX           ; get FP_OFF(buf)
        mov     BX,AX           ; get handle
if _MODEL and _BIG_CODE
        bytes = 6
else
        bytes = 4
endif
        endm

        defp    _dos_read
	if __WASM__ ge 100
	    xdefp   "C",_dos_read
	else
	    xdefp   <"C",_dos_read>
	endif
;
;       unsigned _dos_read( int handle,
;                           void far *buf,
;                           unsigned count,
;                           unsigned *bytes );
;
        get_parms
        mov     AH,3Fh          ; read file
_do_io: int     21h             ; ...
        pop     DS              ; restore DS
        push    DS              ; save it again
        _if     nc              ; if no error
 if _MODEL and (_BIG_DATA or _HUGE_DATA)
          lds   BX,bytes[BP]    ; - get pointer to number of bytes
 else
          mov   BX,bytes[BP]    ; - get pointer to number of bytes
 endif
          mov   [BX],AX         ; - store number of bytes transferred
        _endif                  ; endif
        pop     DS              ; restore DS
        call    __doserror_     ; set return code
        pop     BP              ; restore BP
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        ret     4               ; return to caller
else
        ret     2               ; return to caller
endif
        endproc _dos_read
;-----------------------------------------------------------------------
        defp    _dos_write
	if __WASM__ ge 100
	    xdefp   "C",_dos_write
	else
	    xdefp   <"C",_dos_write>
	endif
;
;       unsigned _dos_write( int handle,
;                           void far *buf,
;                           unsigned count,
;                           unsigned *bytes );
;
        get_parms
        mov     AH,40h          ; write file
        jmp     _do_io          ; ...
        endproc _dos_write

        endmod
        end
