;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  03-dec-89    F.W.Crigger     Initial implementation
;  12-sep-94	Greg Bentz	check for _HUGE_DATA with _BIG_DATA
;  07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;
include mdef.inc
include struct.inc

        xref    __doserror_
        modstart dosmem

        defp    _dos_allocmem
	if __WASM__ ge 100
	    xdefp   "C",_dos_allocmem
	else
	    xdefp   <"C",_dos_allocmem>
	endif
;
;       unsigned _dos_allocmem( unsigned size, unsigned short *segment );
;
        push    BX              ; save BX
        push    DX              ; save DX
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,CX           ; get segment part of pointer to segment
        mov     DX,BX           ; get offset part of pointer
endif
        mov     BX,AX           ; get # of paragraphs wanted
        mov     AH,48h          ; allocate memory
        int     21h             ; ...
        xchg    BX,DX           ; get pointer for result
        _if     nc              ; if no error
          mov   DX,AX           ; - get segment of allocated memory
          sub   AX,AX           ; - indicate no error
        _else                   ; else
          call  __doserror_     ; - set error code
        _endif                  ; endif
        mov     [BX],DX         ; store size of largest block or segment
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        pop     DX              ; restore DX
        pop     BX              ; restore BX
        ret                     ; return to caller
        endproc _dos_allocmem
;-----------------------------------------------------------------------
        defp    _dos_freemem
	if __WASM__ ge 100
	    xdefp   "C",_dos_freemem
	else
	    xdefp   <"C",_dos_freemem>
	endif
;
;       unsigned _dos_freemem( unsigned short segment );
;
        push    ES              ; save ES
        mov     ES,AX           ; get segment to be freed
        mov     AH,49h          ; free allocated memory
        int     21h             ; ...
        call    __doserror_     ; set return code
        pop     ES              ; restore ES
        ret                     ; return to caller
        endproc _dos_freemem
;-----------------------------------------------------------------------
        defp    _dos_setblock
	if __WASM__ ge 100
	    xdefp   "C",_dos_setblock
	else
	    xdefp   <"C",_dos_setblock>
	endif
;
;       unsigned _dos_setblock( unsigned size,
;                               unsigned short segment,
;                               unsigned  *maxsize );
;
;
        push    ES              ; save ES
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,CX           ; get segment part of pointer to segment
endif
        push    BX              ; save pointer to maxsize
        mov     ES,DX           ; get segment to be modified
        mov     BX,AX           ; get new size
        mov     AH,4Ah          ; modify allocated memory
        int     21h             ; ...
        mov     DX,BX           ; get maximum block size if failure
        pop     BX              ; restore pointer to maxsize
        _if     c               ; if error
          mov   [BX],DX         ; - store the maxsize
        _endif                  ; endif
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        call    __doserror_     ; set return code
        pop     ES              ; restore ES
        ret                     ; return to caller
        endproc _dos_setblock

        endmod
        end
