;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  03-dec-89    F.W.Crigger     Initial implementation
;  07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;
include mdef.inc
include struct.inc

        xref    __doserror_
        modstart dosmem

        defp    _dos_allocmem
	if __WASM__ ge 100
	    xdefp   "C",_dos_allocmem
	else
	    xdefp   <"C",_dos_allocmem>
	endif
;
;       unsigned _dos_allocmem( unsigned size, unsigned short *segment );
;
        push    EBX             ; save EBX
        push    EDX             ; save EDX
ifdef __STACK__
        mov     EAX,12[ESP]     ; get size
        mov     EDX,16[ESP]     ; get pointer to segment
endif
        mov     EBX,EAX         ; get # of paragraphs wanted
        mov     AH,48h          ; allocate memory
        int     21h             ; ...
        xchg    EBX,EDX         ; get pointer for result
        _if     nc              ; if no error
          mov   EDX,EAX         ; - get segment of allocated memory
          sub   EAX,EAX         ; - indicate no error
        _else                   ; else
          call  __doserror_     ; - set error code
        _endif                  ; endif
        mov     [EBX],EDX       ; store size of largest block or segment
        pop     EDX             ; restore EDX
        pop     EBX             ; restore EBX
        ret                     ; return to caller
        endproc _dos_allocmem
;-----------------------------------------------------------------------
        defp    _dos_freemem
	if __WASM__ ge 100
	    xdefp   "C",_dos_freemem
	else
	    xdefp   <"C",_dos_freemem>
	endif
;
;       unsigned _dos_freemem( unsigned short segment );
;
ifdef __STACK__
        mov     EAX,4[ESP]      ; get segment
endif
        push    ES              ; save ES
        mov     ES,AX           ; get segment to be freed
        mov     AH,49h          ; free allocated memory
        int     21h             ; ...
        call    __doserror_     ; set return code
        pop     ES              ; restore ES
        ret                     ; return to caller
        endproc _dos_freemem
;-----------------------------------------------------------------------
        defp    _dos_setblock
	if __WASM__ ge 100
	    xdefp   "C",_dos_setblock
	else
	    xdefp   <"C",_dos_setblock>
	endif
;
;       unsigned _dos_setblock( unsigned size,
;                               unsigned short segment,
;                               unsigned  *maxsize );
;
;
ifdef __STACK__
        push    EDX
        push    EBX
        mov     EAX,12[ESP]
        mov     EDX,16[ESP]
        mov     EBX,20[ESP]
endif
        push    ES              ; save ES
        push    EBX             ; save pointer to maxsize
        mov     ES,DX           ; get segment to be modified
        mov     EBX,EAX         ; get new size
        mov     AH,4Ah          ; modify allocated memory
        int     21h             ; ...
        mov     EDX,EBX         ; get maximum block size if failure
        pop     EBX             ; restore pointer to maxsize
        _if     c               ; if error
          mov   [EBX],EDX       ; - store the maxsize
        _endif                  ; endif
        call    __doserror_     ; set return code
        pop     ES              ; restore ES
ifdef __STACK__
        pop     EBX
        pop     EDX
endif
        ret                     ; return to caller
        endproc _dos_setblock

        endmod
        end
