;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  modified:      by:           reason:
;  ---------      ---           -------
;  03-dec-89    F.W.Crigger     Initial implementation
;  02-jun-90    F.W.Crigger     Added Windows support
;  01-mar-91    F.W.Crigger     Windows conventions now same as DOS
;  12-sep-94	Greg Bentz	check for _HUGE_DATA with _BIG_DATA
;  07-mar-95	M. Hildebrand	Deal with different versions of WASM.
;  12-mar-95	Greg Bentz	remove extra _ from "C" symbols
;
include mdef.inc
include struct.inc

	if __WASM__ ge 100
	    xref    "C",__set_EINVAL
	else
	    xref    <"C",__set_EINVAL>
	endif
        modstart dosstime

        defp    _dos_setdate
	if __WASM__ ge 100
	    xdefp   "C",_dos_setdate
	else
	    xdefp   <"C",_dos_setdate>
	endif
;
;       unsigned _dos_setdate( struct dosdate_t *date );
;       struct dosdate_t {
;               unsigned char day;      1-31
;               unsigned char month;    1-12
;               unsigned int year;      1980-2099
;               unsigned char dayofweek; 0-6 (0=Sunday)
;       };
;
        push    DX              ; save DX
        push    CX              ; save CX
        push    BX              ; save BX
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,DX           ; point to struct
endif
        mov     BX,AX           ; get address of dosdate_t structure
        mov     CX,2[BX]        ; get the year
        mov     DH,1[BX]        ; get the month
        mov     DL,[BX]         ; get the day
        mov     AL,4[BX]        ; get the day of the week
        mov     AH,2Bh          ; set date
        int     21h             ; ...
        mov     AH,AL           ; set return code
        cmp     AL,0FFh         ; if error
        _if     e               ; then
	  call	__set_EINVAL	; - set errno = EINVAL
        _endif                  ; endif
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        pop     BX              ; restore BX
        pop     CX              ; restore CX
        pop     DX              ; restore DX
        ret                     ; return to caller
        endproc _dos_setdate
;-----------------------------------------------------------------------
        defp    _dos_settime
	if __WASM__ ge 100
	    xdefp   "C",_dos_settime
	else
	    xdefp   <"C",_dos_settime>
	endif
;
;       unsigned _dos_settime( struct dostime_t *time );
;       struct dostime_t {
;               unsigned char hour;     0-23
;               unsigned char minute;   0-59
;               unsigned char second;   0-59
;               unsigned char hsecond;  1/100 second; 0-99
;       };
;
        push    DX              ; save DX
        push    CX              ; save CX
        push    BX              ; save BX
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        push    DS              ; save DS
        mov     DS,DX           ; point to struct
endif
        mov     BX,AX           ; get address of dostime_t structure
        mov     CH,[BX]         ; get the hour
        mov     CL,1[BX]        ; get the minute
        mov     DH,2[BX]        ; get the second
        mov     DL,3[BX]        ; get the hundredths of seconds
        mov     AH,2Dh          ; set time
        int     21h             ; ...
        mov     AH,AL           ; set return code
        cmp     AL,0FFh         ; if error
        _if     e               ; then
          call  __set_EINVAL	; - set errno = EINVAL
        _endif                  ; endif
if _MODEL and (_BIG_DATA or _HUGE_DATA)
        pop     DS              ; restore DS
endif
        pop     BX              ; restore BX
        pop     CX              ; restore CX
        pop     DX              ; restore DX
        ret                     ; return to caller
        endproc _dos_settime

        endmod
        end
