/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  03-apr-92	Craig Eisler	wasn't setting attributes correctly
  16-oct-92	Craig Eisler	use integer ids for file handles
  22-nov-92	F.W.Crigger	change reference to _iomode array
  13-jan-93	Craig Eisler	check __NTAtMaxFiles to make sure
  				we don't go past the end of _iomode
--------------------------------------------------------Version-11.0---------
  19-may-95	Greg Bentz	dll linkage
*/

#include "variety.h"
#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <errno.h>
#include <fcntl.h>
#include "fileacc.h"
#include <windows.h>
#include "openmode.h"
#include "iomode.h"
#include "ntex.h"
#include "seterrno.h"


_WCRTLINK unsigned _dos_creat( const char *name, unsigned mode, int *handle )
{
    HANDLE	h;
    DWORD	desired_access;
    DWORD	attr;
    int		hid;
    unsigned	iomode_flags;

    if( __NTAtMaxFiles() ) {
	__set_errno( EMFILE );
	return( -1 );
    }
    
    __GetNTCreateAttr( mode, &desired_access, &attr );
    h = CreateFile( (LPTSTR) name, desired_access, 0, 0, CREATE_ALWAYS,
		    attr, NULL );
    if( h == (HANDLE)-1 ) {
	return( __set_errno_nt() );
    }
    hid = _InitAccessH( (int) h );
    *handle = hid;

    iomode_flags = _READ;
    if( !(mode & _A_RDONLY) ) iomode_flags |= _WRITE;
    __SetIOMode( hid, iomode_flags );
    return( 0 );
}
