/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  28-apr-91	F.W.Crigger	Initial implementation for OS/2
  12-nov-91     G. Coschi	support OS/2 2.0
  22-nov-92	F.W.Crigger	change reference to _iomode array
  01-feb-94	Greg Bentz	fixup attribute translation
  07-mar-94	Kevin Hui	use a constant open mode
--------------------------------------------------------Version-11.0---------
  19-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include "fileacc.h"
#include <wos2.h>
#include "openmode.h"
#include "iomode.h"
#include "seterrno.h"



_WCRTLINK unsigned _dos_creatnew( const char *name, unsigned attribute, int *handle )
    {
	OS_UINT	error, actiontaken;
        HFILE	fhandle;
    
        while( *name == ' ' ) ++name;
        error = DosOpen( (PSZ)name, 
			 &fhandle, 
			 &actiontaken, 
			 0ul,
        		 attribute, 
			 OPENFLAG_FAIL_IF_EXISTS |
			 OPENFLAG_CREATE_IF_NOT_EXISTS,
			 OPENMODE_ACCESS_RDWR | OPENMODE_DENY_NONE,
			 0ul );
        if( error ) {
            __set_errno_dos( error );
	    return( error );
        }
	*handle = fhandle;
	__SetIOMode( fhandle, _READ | _WRITE );
        _InitAccessH( fhandle );
	return( 0 );
    }
