/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1985, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  16-jul-87     J.Trabandt      Initial implementation
-----------------------------------------------------------Version 7.0------
  30-mar-89     F.W.Crigger     386 support added
-----------------------------------------------------------Version 8.x------
  26-feb-91     C.G.Eisler      Updated for 386 windows
  03-apr-91     C.G.Eisler      Updated for WINDOWS_386 macro
--------------------------------------------------------Version-11.0---------
  19-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <dos.h>

#define DOS_EXT_ERR     0x59


_WCRTLINK int dosexterr( struct DOSERROR *doserr )
    {
        auto union REGS regs;

#if defined(__386__) && !defined(__WINDOWS_386__)
        regs.h.ah = DOS_EXT_ERR;
        regs.x.ebx = 0;                 /* DOS version 3.00 */
        intdos( &regs, &regs );         /* get extended error */
        doserr->class = regs.h.bh;
        doserr->action = regs.h.bl;
        doserr->locus = regs.h.ch;
        return( doserr->exterror = regs.x.eax );
#else
        regs.h.ah = DOS_EXT_ERR;
        regs.x.bx = 0;                  /* DOS version 3.00 */
        intdos( &regs, &regs );         /* get extended error */
        doserr->class = regs.h.bh;
        doserr->action = regs.h.bl;
        doserr->locus = regs.h.ch;
        return( doserr->exterror = regs.x.ax );
#endif
   }

