/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1993, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-may-93     Craig Eisler	initial implementation
--------------------------------------------------------Version-11.0---------
  03-may-95	Greg Bentz	OS/2 32bit support
  19-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <stdio.h>
#include <dos.h>
#include "seterrno.h"
#if defined(__NT__)
    #include <windows.h>
#elif defined(__OS2__)
    #define INCL_DOS
    #include <wos2.h>
#endif

_WCRTLINK unsigned _dos_getdiskfree( int dnum, struct diskfree_t *df )
{
    #if defined(__NT__)
	DWORD	spc;
	DWORD	bps;
	DWORD	nfc;
	DWORD	tnc;
	char	path[4];
	char	*pname;
    
	if( dnum != 0 ) {
	    path[0] = 'A' + dnum - 1;
	    path[1] = ':';
	    path[2] = '\\';
	    path[3] = 0;
	    pname = path;
	} else {
	    pname = NULL;
	}
    
	if( !GetDiskFreeSpace( pname, &spc, &bps, &nfc, &tnc ) ) {
	    return( __set_errno_nt() );
	}
	df->total_clusters = tnc;
	df->avail_clusters = nfc;
	df->sectors_per_cluster = spc;
	df->bytes_per_sector = bps;
    #elif defined(__OS2__)
	FSALLOCATE fsinfo;
	APIRET rc;
	rc = DosQFSInfo( dnum, FSIL_ALLOC, (PVOID)&fsinfo, sizeof( fsinfo ) );
	if( rc ) {
	    __set_errno_dos( rc );
	    return( rc );
	}
	df->total_clusters = fsinfo.cUnit;
	df->avail_clusters = fsinfo.cUnitAvail;
	df->sectors_per_cluster = fsinfo.cSectorUnit;
	df->bytes_per_sector = fsinfo.cbSector;
    #endif
    return( 0 );
}
