/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  24-may-88     F.W.Crigger     Initial implementation
-----------------------------------------------------------Version 7.0------
  31-mar-89     F.W.Crigger     386 support added
  13-jul-89     F.W.Crigger     pragma changed to also support A.I.Architects
  04-feb-91     C.G.Eisler      updated for Windows 386
  08-feb-91     F.W.Crigger     Check _Extender variable
  10-mar-91     F.W.Crigger     DOS4G uses same logic as OS386
  03-apr-91	C.G.Eisler	updated for WINDOWS_386 macro
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  19-may-95	Greg Bentz	dll linkage
*/

#include "variety.h"
#include <stddef.h>
#include <dos.h>
#if defined(__386__)
 #if defined(__WINDOWS_386__)
  #include "tinyio.h"
 #else
  #include "extender.h"
  extern  void (interrupt _WCFAR *_getvect())();
  #pragma aux  _getvect = \
                        0x06            /* push es*/\
                        0xcd 0x21       /* int 21h    */\
                        0x8c 0xc2       /* mov dx,es  */\
                        0x07            /* pop es     */\
                        parm [ax] [cl] value [dx ebx];
 #endif
#else
 extern  void (interrupt _WCFAR *_getvect())();
 #pragma aux  _getvect = 0xb4 0x35       /* mov ah,35h */\
                         0xcd 0x21       /* int 21h    */\
                         parm [ax] value [es bx];
#endif

_WCRTLINK void (interrupt _WCFAR *_dos_getvect(int intnum))()
    {
#if defined(__386__)
 #if defined(__WINDOWS_386__)
        return( TinyGetVect(intnum) );
 #else
        if( _IsPharLap() ) {
            return( _getvect( 0x2502, intnum ) );
        } else {        /* OS386 or DOS4G */
            return( _getvect( 0x3500 | (intnum & 0xff), 0 ) );
        }
 #endif
#else
        return( _getvect(intnum) );
#endif
    }
