/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  24-may-88     F.W.Crigger     Initial implementation
-----------------------------------------------------------Version 7.0------
  31-mar-89     F.W.Crigger     386 support added
  13-jul-89     F.W.Crigger     pragma changed to also support A.I.Architects
  04-feb-91     C.G.Eisler      updated for Windows 386
  08-feb-91     F.W.Crigger     Check _Extender variable
  10-mar-91     F.W.Crigger     DOS4G uses same logic as OS386
  03-apr-91	C.G.Eisler	updated for WINDOWS_386 macro
--------------------------------------------------------Version-11.0---------
  21-apr-95	Greg Bentz	variety.h for near/far and composite macros
  19-may-95	Greg Bentz	dll linkage
*/

#include "variety.h"
#include <stddef.h>
#include <dos.h>
#if defined(__386__)
 #if defined(__WINDOWS_386__)
  #include "tinyio.h"
 #else
  #include "extender.h"
  extern  void pharlap_setvect( unsigned, void (interrupt _WCFAR *)());
  #pragma aux  pharlap_setvect =  0x1e   /* push ds   */\
                               0x8e 0xd9 /* mov ds,cx */\
                               0x88 0xc1 /* mov cl,al */\
                               0xb0 0x04 /* mov al,04 */\
                               0xb4 0x25 /* mov ah,25 */\
                               0xcd 0x21 /* int 21h   */\
                               0x1f      /* pop ds    */\
                        parm caller [al] [cx edx];

  extern  void os386_setvect( unsigned, void (interrupt _WCFAR *)());
  #pragma aux  os386_setvect =  0x1e      /* push ds   */\
                               0x8e 0xd9 /* mov ds,cx */\
                               0xb4 0x25 /* mov ah,25 */\
                               0xcd 0x21 /* int 21h   */\
                               0x1f      /* pop ds    */\
                        parm caller [al] [cx edx];
 #endif
#else
 extern  void _setvect( unsigned, void (interrupt _WCFAR *)());
 #pragma aux     _setvect =    0x1e      /* push ds   */\
                               0x8e 0xd9 /* mov ds,cx */\
                               0xb4 0x25 /* mov ah,25 */\
                               0xcd 0x21 /* int 21h   */\
                               0x1f      /* pop ds    */\
                        parm caller [ax] [cx dx];
#endif

_WCRTLINK void _dos_setvect( int intnum, void (interrupt _WCFAR *func)() )
    {
#if defined(__WINDOWS_386__)
        TinySetVect( intnum, (void _WCNEAR *) func );
#elif defined(__386__)
        if( _IsPharLap() ) {
            pharlap_setvect( intnum, func );
        } else {        /* os386 or DOS4G */
            os386_setvect( intnum, func );
        }
#else
        _setvect( intnum, func );
#endif
    }
