/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  27-apr-91	F.W.Crigger	Initial implementation for OS/2
--------------------------------------------------Version 8.5----------
  11-nov-91     G. Coschi	support OS/2 2.0
  22-nov-92	F.W.Crigger	change reference to _iomode array
  12-may-94	Greg Bentz	add _dos_commit
--------------------------------------------------------Version-11.0---------
  19-may-95	Greg Bentz	dll linkage
*/

#include "variety.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <share.h>
#include <direct.h>
#include "fileacc.h"
#include <wos2.h>
#include "openmode.h"
#include "iomode.h"
#include "rtdata.h"
#include "seterrno.h"



_WCRTLINK unsigned _dos_open( const char *name, unsigned mode, int *handle )
    {
	OS_UINT rwmode, error, actiontaken, openmode;
	HFILE fhandle;
	int   share;
	unsigned iomode_flags;

	while( *name == ' ' ) ++name;
	rwmode = mode & OPENMODE_ACCESS_MASK;
	if( rwmode == OPENMODE_ACCESS_WRONLY
#if defined(__OS2_286__)
	    && !_RWD_osmode
	    /* Can't open WRONLY file in bound application under DOS */
#endif
	    ) {
	    rwmode = OPENMODE_ACCESS_RDWR;
	}
	share = mode & OPENMODE_SHARE_MASK;
	if( share == SH_COMPAT ) {
	    share = SH_DENYNO;
	}
	openmode = share+rwmode;
	error = DosOpen( (PSZ)name, &fhandle, &actiontaken, 0ul,
	    _A_NORMAL, OPENFLAG_OPEN_IF_EXISTS, openmode, 0ul );
	if( error ) {
	    __set_errno_dos( error );
	    return( error );
	}
	*handle = fhandle;
	if( rwmode == O_RDWR )	iomode_flags = _READ | _WRITE;
	if( rwmode == O_RDONLY) iomode_flags = _READ;
	if( rwmode == O_WRONLY) iomode_flags = _WRITE;
	__SetIOMode( fhandle, iomode_flags );
	_InitAccessH( fhandle );
	return( 0 );
    }

unsigned _dos_close( int handle )
    {
	return( close( handle ) );
    }

unsigned _dos_commit( int handle )
    {
	OS_UINT error;
	error = DosBufReset( handle );
	if( error ) {
	    __set_errno_dos( error );
	    return( error );
	}
	return( 0 );
    }
