/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  16-oct-92	Craig Eisler	use integer ids for file handles
  22-nov-92	F.W.Crigger	change reference to _iomode array
  13-jan-93	Craig Eisler	check __NTAtMaxFiles to make sure
  				we don't go past the end of _iomode
  12-may-94	Greg Bentz	add _dos_commit
--------------------------------------------------------Version-11.0---------
  19-may-95	Greg Bentz	dll linkage
  25-sep-95	Greg Bentz	fixup share mode handling
  29-aug-96	M. Hildebrand	Use rtcheck.h support.
*/

#include "variety.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <share.h>
#include <direct.h>
#include "fileacc.h"
#include <windows.h>
#include "openmode.h"
#include "iomode.h"
#include "rtdata.h"
#include "ntex.h"
#include "rtcheck.h"
#include "seterrno.h"


_WCRTLINK unsigned _dos_open( const char *name, unsigned mode, int *handle )
{
    HANDLE	h;
    DWORD	rwmode,share_mode;
    DWORD	desired_access,attr;
    unsigned	iomode_flags;
    int		hid;

    if( __NTAtMaxFiles() ) {
	__set_errno( EMFILE );
	return( -1 );
    }

    rwmode = mode & OPENMODE_ACCESS_MASK;

    __GetNTAccessAttr( rwmode, &desired_access, &attr );
    __GetNTShareAttr( mode & (OPENMODE_SHARE_MASK|OPENMODE_ACCESS_MASK),
    		      &share_mode );

    h = CreateFile( (LPTSTR) name, desired_access, share_mode, 0,
    		OPEN_EXISTING, attr, NULL );
    
    if( h == (HANDLE)-1 ) {
	return( __set_errno_nt() );
    }

    hid = _InitAccessH( (int) h );
    *handle = hid;
    if( rwmode == O_RDWR )  iomode_flags = _READ | _WRITE;
    if( rwmode == O_RDONLY) iomode_flags = _READ;
    if( rwmode == O_WRONLY) iomode_flags = _WRITE;
    __SetIOMode( hid, iomode_flags );
    return( 0 );
}

_WCRTLINK unsigned _dos_close( int handle )
{
    return( close( handle ) );
}

_WCRTLINK unsigned _dos_commit( int handle )
    {
	int 	rc;
	HANDLE	h;

	__handle_check( handle, EBADF );
	h = __FileHandleIDs[ handle ];
	rc = FlushFileBuffers( h );
	if( !rc ) {
	    return( __set_errno_nt() );
	}
	return( 0 );
    }
