/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-92     Craig Eisler	defined for NT
  08-oct-93	A.F.Scian	fixed prototype for __NTGetDirInfo and
  				noticed that this module depends on find_t
				being the same layout as a struct dirent
				(it is for now)
  10-feb-94	Greg Bentz	fix attribute handling
--------------------------------------------------Version 9.5----------
  15-feb-94     G. Coschi	don't call FindClose() if DosFindFirstFile()
  				fails
  12-apr-95	Greg Bentz	make sure to call FindClose() for all calls to
  				FindFirstFile()
--------------------------------------------------------Version-11.0---------
  19-may-95	Greg Bentz	dll linkage
  02-aug-95	Greg Bentz	another change to attribute handling
*/
#include "variety.h"
#include <errno.h>
#include <stddef.h>
#include <stdlib.h>
#include <direct.h>
#include <dos.h>
#include <windows.h>
#include "rtdata.h"
#include "ntex.h"
#include "seterrno.h"


_WCRTLINK unsigned _dos_findfirst( const char *path, unsigned attr, struct find_t *buf )
{
    WIN32_FIND_DATA	ffb;
    HANDLE		h;

    h = FindFirstFile( (LPTSTR)path, &ffb );
    
    if( h == (HANDLE)-1 ) {
	HANDLE_OF( buf ) = BAD_HANDLE;
	return( __set_errno_nt() );
    }
    if( attr == _A_NORMAL ) {
	attr = ~(_A_SUBDIR|_A_VOLID);
    }
    if( !__NTFindNextFileWithAttr( h, attr, &ffb ) ) {
	HANDLE_OF( buf ) = BAD_HANDLE;
	FindClose( h );
    	return( __set_errno_dos( ERROR_FILE_NOT_FOUND ) );
    }
    HANDLE_OF( buf ) = h;
    ATTR_OF( buf ) = attr;
    __GetNTDirInfo( (struct dirent *) buf, &ffb );

    return( 0 );
}


_WCRTLINK unsigned _dos_findnext( struct find_t *buf )
{
    WIN32_FIND_DATA	ffd;

    if( !FindNextFile( HANDLE_OF( buf ), &ffd ) ) {
	return( __set_errno_nt() );
    }
    if( !__NTFindNextFileWithAttr( HANDLE_OF( buf ), ATTR_OF( buf ), &ffd ) ) {
	return( __set_errno_nt() );
    }
    __GetNTDirInfo( (struct dirent *) buf, &ffd );

    return( 0 );
}


_WCRTLINK unsigned _dos_findclose( struct find_t *buf )
{

    if( HANDLE_OF( buf ) != BAD_HANDLE ) {
	if( !FindClose( HANDLE_OF( buf ) ) ) {
	    return( __set_errno_nt() );
	}
    }
    return( 0 );

}
