/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1987, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  30-jul-87     A.F.Scian       defined
  06-aug-87     F.W.Crigger     Used doscall to create intdos
  25-nov-87     M.Glaum         Added big data code
------------------------------------------------------------Version 6.5-----
  21-sep-88     F.W.Crigger     re-coded small data model pragma so that
                                it will work with /zu option
------------------------------------------------------------Version 7.0-----
  08-feb-89     F.W.Crigger     Added "clc" before "int 21"
  26-feb-89     F.W.Crigger     Adapted for 386
------------------------------------------------------------Version 8.x-----
  22-feb-91     C.G.Eisler      Modified for Windows/386
  03-apr-91	C.G.Eisler	Updated for WINDOWS_386 macro
------------------------------------------------------------Version 9.5-----
  12-aug-93	F.W.Crigger	use _INT_21 from tinyio.h
--------------------------------------------------------Version-11.0---------
  19-may-95	Greg Bentz	dll linkage
*/
#include "variety.h"
#include <dos.h>
#include "tinyio.h"

#if !defined(__WINDOWS_386__)
extern  int                     DoDosCall();
extern  int                     _dosretax();


#pragma aux                     DoDosCall = \
	"push ebp"	\
	"push edx"	\
	"mov eax,[edi]" \
	"mov ebx,4[edi]"\
	"mov ecx,8[edi]"\
	"mov edx,12[edi]"\
	"mov esi,16[edi]"\
	"mov edi,20[edi]"\
	"clc"		\
	_INT_21		\
	"mov ebp,edi"	\
	"pop edi"	\
	"mov [edi],eax"	\
	"mov 4[edi],ebx"\
	"mov 8[edi],ecx"\
	"mov 12[edi],edx"\
	"mov 16[edi],esi"\
	"mov 20[edi],ebp"\
	"sbb eax,eax"	\
	"pop ebp"	\
        parm caller     [edi] [edx] \
        value           [eax] \
        modify          [ebx ecx edx esi edi];

#else
#include <stddef.h>
extern int pascal _clib_intdos( union REGS *, union REGS * );
#endif

_WCRTLINK int intdos( union REGS *inregs, union REGS *outregs )
{
#if !defined(__WINDOWS_386__)
    int	status;

    status = DoDosCall( inregs, outregs );
    outregs->x.cflag = status;
    _dosretax( outregs->x.eax, status );
    return( outregs->x.eax );
#else
    return( _clib_intdos( inregs, outregs ) );
#endif
}
