/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1991 by WATCOM Systems Inc. All rights      %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  28-apr-91	F.W.Crigger	Initial implementation for OS/2
--------------------------------------------------Version 8.5----------
  12-nov-91     G. Coschi	support OS/2 2.0
--------------------------------------------------------Version-11.0---------
  19-may-95	Greg Bentz	dll linkage
  15-mar-96	Greg Bentz	tweak typing inconsistencies
*/
#include "variety.h"
#include <dos.h>
#include <wos2.h>
#include "seterrno.h"


_WCRTLINK unsigned _dos_setfileattr( const char *path, unsigned attribute )
    {
	APIRET	rc;

#if defined(__WARP__)
	FILESTATUS	fs;
	
	rc = DosQueryPathInfo( (PSZ)path, FIL_STANDARD,
	                       &fs, sizeof( FILESTATUS ) );
        if( rc != 0 ) {
	    __set_errno_dos( rc );
	    return( rc );
        }
	fs.attrFile = attribute;
	rc = DosSetPathInfo( (PSZ)path, FIL_STANDARD,
	                       &fs, sizeof( FILESTATUS ), 0 );
#else
	rc = DosSetFileMode( (PSZ)path, attribute, 0ul );
#endif
        if( rc != 0 ) {
	    __set_errno_dos( rc );
        }
	return( rc );
    }
