/*
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
  %       reserved. No part of this software may be reproduced      %
  %       in any form or by any means - graphic, electronic or      %
  %       mechanical, including photocopying, recording, taping     %
  %       or information storage and retrieval systems - except     %
  %       with the written permission of WATCOM Systems Inc.        %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  06-mar-92     Craig Eisler	defined for NT
  08-mar-94	Kevin Hui	not possible to set date without getting the
  				right privilege before; also fixed calculation
				of hsecond
--------------------------------------------------------Version-11.0---------
  19-may-95	Greg Bentz	dll linkage
  29-aug-96	M. Hildebrand	Was using unsupported API call under Win95.
*/
#include "variety.h"
#include <dos.h>
#include <windows.h>
#include "osver.h"
#include "seterrno.h"

_WCRTLINK unsigned _dos_settime( struct dostime_t *time )
{
    SYSTEMTIME		st;
    HANDLE		htoken;
    TOKEN_PRIVILEGES	tp;
    unsigned		rc;

    if( WIN32_IS_NT ) {
	if( !OpenProcessToken( GetCurrentProcess(),
			       TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY,
			       &htoken ) ) {
	    return( __set_errno_nt() );
	}
	LookupPrivilegeValue( NULL, SE_SYSTEMTIME_NAME,
			      &tp.Privileges[0].Luid );
	tp.PrivilegeCount = 1;
	tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	AdjustTokenPrivileges( htoken, FALSE, &tp, 0, (PTOKEN_PRIVILEGES)NULL,
			       NULL );
    }

    GetLocalTime( &st );
    st.wHour = time->hour;
    st.wMinute = time->minute;
    st.wSecond = time->second;
    st.wMilliseconds = time->hsecond/10;
    if( SetLocalTime( &st ) ) {
	rc = 0;
    } else {
	rc = __set_errno_nt();
    }

    if( WIN32_IS_NT ) {
	tp.Privileges[0].Attributes = 0;
	AdjustTokenPrivileges( htoken, FALSE, &tp, 0, (PTOKEN_PRIVILEGES)NULL,
			       NULL );
    }

    return( rc );
}
