/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
--------------------------------------------------------Version-11.0---------
   29-sep-95	M. Hildebrand	Initial implementation.
*/

#include "variety.h"
#include <dos.h>
#include <errno.h>
#include <mbstring.h>
#include <stdlib.h>
#include <string.h>
#include "mbwcconv.h"
#include "seterrno.h"


_WCRTLINK unsigned _wdos_findfirst( const wchar_t *path, unsigned attr, struct _wfind_t *buf )
{
    int			rc;
    struct find_t	mbBuf;
    char		mbPath[MB_CUR_MAX*_MAX_PATH];

    /*** Find using MBCS buffer ***/
    __filename_from_wide( mbPath, path );
    rc = _dos_findfirst( mbPath, attr, &mbBuf );

    /*** Transfer returned info to _wfind_t buffer ***/
    memcpy( buf, &mbBuf, sizeof(struct find_t) );
    if( mbstowcs( buf->name, mbBuf.name, _MAX_PATH )  ==  -1 )  return( ENOENT );

    if( rc != 0 )  __set_errno_dos( ENOENT );
    return( rc );
}


_WCRTLINK unsigned _wdos_findnext( struct _wfind_t *buf )
{
    int			rc;
    struct find_t	mbBuf;

    /*** Find using MBCS buffer ***/
    memcpy( &mbBuf, buf, sizeof(struct find_t) );
    if( wcstombs( mbBuf.name, buf->name, _MAX_PATH*MB_CUR_MAX )  ==  -1 )  return( ENOENT );
    rc = _dos_findnext( &mbBuf );

    /*** Transfer returned info to _wfind_t buffer ***/
    memcpy( buf, &mbBuf, sizeof(struct find_t) );
    if( mbstowcs( buf->name, mbBuf.name, _MAX_PATH )  ==  -1 )  return( ENOENT );

    if( rc != 0 )  __set_errno_dos( ENOENT );
    return( rc );
}


_WCRTLINK unsigned _wdos_findclose( struct _wfind_t *buf )
{
    return( _dos_findclose( (struct find_t*)buf ) );
}
