/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

    Complex class functions and operators

   The formula for some of these algorithms was found in:
     "Complex Variables and Applications, 2nd Edition",
     Ruel V. Churchill,
     McGraw-Hill, 1960
   (Look in Jim Welch's office)
   These formulae include:
     acos, asin, atan,
     cosh, sinh, tanh

    Modified    By              Reason
    ========    ==              ======
    92/01/09    Steve McDowell  Initial implementation.
    92/10/09	Greg Bentz	Cleanup.
    93/02/16	Greg Bentz	Removed some numerical instability.
    93/10/19    Raymond Tang    Split into separate files.
    95/05/19	Greg Bentz	dll linkage
*/

#include "variety.h"
#include <complex>

_WPRTLINK istream &operator >> ( istream &strm, Complex &z ) {
/***********************************************************/
    int  parens;
    char c;

    strm >> c;
    if( strm.eof() ) {
        strm.clear( ios::failbit );
        return( strm );
    }
    if( c == '(' ) {
	parens = 1;
    } else {
	parens = 0;
        strm.putback( c );
    }
    strm >> z.__r;
    if( !strm.good() ) {
        return( strm );
    }
    strm >> c;
    if( !strm.good() ) {
        z.__i = 0.0;
        return( strm );
    }
    if( c != ',' ) {
	z.__i = 0.0;
	if( !parens || c != ')' ) {
	    strm.putback( c );
	}
	return( strm );
    }
    strm >> z.__i;
    if( !strm.good() ) {
	return( strm );
    }
    if( parens ) {
	strm >> c;
	if( strm.eof() ) {
	    return( strm );
	}
	if( c != ')' ) {
	    strm.putback( c );
	}
    }
    return( strm );
}
