// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/02/19    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/08/03	Greg Bentz	make the attach() and open() member functions
//				clear ios::eofbit on success.
//  93/10/20	Raymond Tang	Split into separate files.
//  94/04/06	Greg Bentz	combine header files
//  93/04/23	Greg Bentz	make the attach() and open() member functions
//				clear all ios::iostate bits on success.

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <fstream.h>
#endif

void fstreambase::attach( filedesc fd ) {
/***************************************/
// Attach the file associated with "fd" to the fstreambase object.
// If something goes wrong, set "ios::failbit | ios::badbit".

    filebuf *fb;

    __lock_it( __i_lock );
    fb = rdbuf();
    if( fb == NULL ) {
	setstate( ios::failbit );
    } else {
	__lock_it( fb->__b_lock );
	if( fb->attach( fd ) == NULL ) {
	    setstate( ios::failbit );
	} else {
	    clear();
	}
    }
}
