// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/02/19    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/08.03	Greg Bentz	make the attach() and open() member functions
//				clear ios::eofbit on success.
//  93/10/20	Raymond Tang	Split into separate files.
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <stdio.h>
#include <fstream.h>
#endif
#include "ioutil.h"

fstreambase::fstreambase( filedesc fd, char *buf, int len ) {
/***********************************************************/
// Construct an fstreambase that is initialized and attached to the
// specified file, using the specified buf.
// No point in calling non-default constructors since there are
// multiply-inherited derived classes that will only call the default
// constructors anyway.

    ios::init( &__flbuf );
    if( __flbuf.attach( fd ) == NULL ) {
        ios::setstate( ios::failbit | ios::badbit );
    }
    setbuf( buf, len );
}
