// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  93/05/26	Greg Bentz	pull floating point out of istream/ostream
//  93/10/08	Greg Bentz	make LDFloatToString set scale_factor to 1
//				for _Ftos when 'G' format
//  93/10/25	Raymond Tang	Split into separate files.
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <iostream.h>
#endif
#include "ioutil.h"
#include "lock.h"
#include "iofhdr.h"

ostream &ostream::__outfloat( long double const &f ) {
/****************************************************/
// Write a "long double" floating-point value.

    int	  digit_offset;
    char  buf[LONGEST_FLOAT+1];

    ::memset( buf, 0, sizeof( buf ) );
    __lock_it( __i_lock );
    __LDFloatToString( buf, (double const *)&f, this->precision(), this->flags() );
    if( buf[0] == '-' || buf[0] == '+' ) {
	digit_offset = 1;
    } else {
	digit_offset = 0;
    }
    if( opfx() ) {
        setstate( __WATCOM_ios::writeitem( *this, buf, ::strlen(buf), digit_offset ) );
        osfx();
    }
    return( *this );
}

