// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/22    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/03/05	Greg Bentz	added exception handling
//  93/03/15	Greg Bentz	fix ios::clear() mistake during exceptions
//  93/10/29	Raymond Tang	Split into separate files.
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <iostream.h>
#endif
#include "ioutil.h"
#include "lock.h"

ios &ios::operator = ( const ios &is ) {
/**************************************/
// Construct an "ios" and initialize it.
// New "ios" gets all fields of "is" except streambuf.

    __lock_it( __lock_first( __i_lock, is.__i_lock ) );
    __lock_it( __lock_second( __i_lock, is.__i_lock ) );
    __lock_it( __x_lock );
    __error_state 	 = is.__error_state;
    __format_flags 	 = is.__format_flags;
    __enabled_exceptions = is.__enabled_exceptions;
    __float_precision 	 = is.__float_precision;
    __field_width 	 = is.__field_width;
    __fill_character 	 = is.__fill_character;
    __tied_stream 	 = is.__tied_stream;


    // copy over the xalloc vector
    if( __xalloc_index > 0 ) {
	// make sure that 'this' has enough entries in it
	(void)__WATCOM_ios::find_user_word( this, __xalloc_index-1 );
    
	int index = 0;
	ios_word_values *src_word;
	src_word = (ios_word_values *)is.__xalloc_list;
	for( ; src_word != NULL; src_word = src_word->next ) {
	    ipvalue *src, *tgt;
	    for( int i = 0 ; i < src_word->count ; i++ ) {
		src = (ipvalue *)&(src_word->values[i]);
		tgt = (ipvalue *)__WATCOM_ios::find_user_word( this, index );
		if( tgt == NULL ) {
		    setstate( ios:: failbit );
		    return( *this );
		}
		*tgt = *src;
		index++;
	    }
	}
    }
    return( *this );
}
