// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/22    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/03/05	Greg Bentz	added exception handling
//  93/03/15	Greg Bentz	fix ios::clear() mistake during exceptions
//  93/10/29	Raymond Tang	Split into separate files.
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <iostream.h>
#endif
#include "lock.h"
#include "ioshdr.h"

ios::ios( const ios &is ) {
/*************************/
// Construct an "ios" and initialize it.
// New "ios" gets all fields of "is" except streambuf.

    __lock_it( is.__i_lock );
    #ifdef __MT__
	__i_lock =  __get_next_ios_lock();
    #else
	__i_lock = NULL;
    #endif
    __error_state 	 = is.__error_state;
    __format_flags 	 = is.__format_flags;
    __enabled_exceptions = is.__enabled_exceptions;
    __float_precision 	 = is.__float_precision;
    __field_width 	 = is.__field_width;
    __fill_character 	 = is.__fill_character;
    __tied_stream 	 = is.__tied_stream;
    __xalloc_list	 = NULL;
    __strmbuf		 = NULL;
}
