// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/22    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/03/05	Greg Bentz	added exception handling
//  93/03/15	Greg Bentz	fix ios::clear() mistake during exceptions
//  93/10/29	Raymond Tang	Split into separate files.
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <iostream.h>
#endif
#include "lock.h"
#include "ioshdr.h"

void ios::init( streambuf *sb ) {
/*******************************/
// Initialize the ios, including a streambuf pointer.
// If the streambuf pointer is NULL, mark the stream as currently invalid.

    #ifdef __MT__
	__i_lock = __get_next_ios_lock();
    #else
	__i_lock = NULL;
    #endif
    __error_state = 0;
    __format_flags = 0;
    __enabled_exceptions = 0;
    __float_precision = 6;
    __field_width = 0;
    __fill_character = ' ';
    __tied_stream = NULL;
    __xalloc_list = NULL;

    if( sb == NULL ) {
	__error_state = ios::badbit;
    }
    __strmbuf = sb;
}
