// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/28    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/03/05	Greg Bentz	added exception handling
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <iostream.h>
#endif
#include "lock.h"

void ios::setstate( ios::iostate on_bits ) {
/*********************************************************************/
// Set __error_state and throw an exception, if enabled.
    ios::iostate state;

    __lock_it( __i_lock );
    __error_state |= on_bits;
    state = __error_state & __enabled_exceptions;
    if( state ) {
	ios::failure f( state );
	#ifdef __SW_XS
	    // if not building exception handling library then don't
	    // throw exception
	    throw( f );
	#endif
    }
}
