// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/03/03    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/10/20	Raymond Tang	Split into separate files.
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <iostream.h>
#endif
#include "lock.h"

iostream &iostream::operator = ( ios const &strm ) {
/****************************************************/
// *this is an iostream that has been initialized, and may or may not
// have a streambuf associated with it.
// Associate the streambuf found in "strm" with the ios.
// Takes an ios so that it can be used with istream and ostream.

    streambuf *sb;

    __lock_it( __lock_first( __i_lock, strm.__i_lock ) );
    __lock_it( __lock_second( __i_lock, strm.__i_lock ) );
    sb = strm.rdbuf();
    ios::init( sb );
    return( *this );
}
