// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/28    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/03/05	Greg Bentz	added exception handling
//  93/10/25	Raymond Tang	Split into seperate files.
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <iostream.h>
#endif
#include "ioutil.h"
#include "liballoc.h"

void *__WATCOM_ios::find_user_word( ios *pios, int index ) {
/**********************************************************/

    ios_word_values *wptr;
    ios_word_values *last_wptr;
    ipvalue	    *user_word_ptr;

    if( (index < 0) || (index >= ios::__xalloc_index) ) {
	return( NULL );
    }
    last_wptr = NULL;
    wptr = (ios_word_values *) pios->__xalloc_list;
    for( ; wptr != NULL; wptr = wptr->next ) {
	if( wptr->count > index ) {
	    return( &(wptr->values[index]) );
	}
	index    -= wptr->count;
	last_wptr = wptr;
    }

// "index" now contains 1 less than the number of (long) or (void *)
// values we need.
// "last_wptr" points at the last group of values.

    wptr = (ios_word_values *) _plib_malloc( sizeof( ios_word_values )
				   + index * sizeof( ipvalue ) );
    if( wptr == NULL ) {
	return( NULL );
    }
    if( last_wptr == NULL ) {
	pios->__xalloc_list = wptr;
    }  else {
	last_wptr->next = wptr;
    }
    wptr->next  = NULL;
    wptr->count = (short)(index + 1);
    user_word_ptr = &(wptr->values[0]);
    for( int i = 0 ; i <= index ; i++ ) {
	user_word_ptr->iword = 0L;
	user_word_ptr++;
    }
    return( &(wptr->values[index]) );
}
