// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/30    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/07/29	Greg Bentz	Change ostream::op<<(streambuf &) to
//				ostream::op<<( streambuf * )
//  93/10/26	Raymond Tang	Split into separate files.
//  94/04/06	Greg Bentz	combine header files
//  94/11/01	Greg Bentz	make sure uppercase is used for hex letters

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <stdlib.h>
#include <iostream.h>
#endif
#include "ioutil.h"
#include "lock.h"
#include "osthdr.h"

ostream &ostream::operator << ( void *p ) {
/*****************************************/
// Write the value of a pointer (the address contained in the pointer).

    char buf[LONGEST_INTEGER + 1];

    __lock_it( __i_lock );

    // Prefix:
    buf[0] = '0';
    buf[1] = (char) ((flags() & ios::uppercase) ? 'X' : 'x');

    // Digits:
    ultoa( (long) p, buf + 2, 16 );
    if( flags() & ios::uppercase ) {
	strupr( buf );
    }

    // Write the number:
    if( opfx() ) {
        setstate( __WATCOM_ios::writeitem( *this, buf, ::strlen( buf ), 2 ) );
	osfx();
    }
    return( *this );
}
