// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/02/10    Steve McDowell  Initial implementation.
//  92/02/28    ...             Modified to delay allocation of buffers
//                              until overflow/underflow called.
//  92/09/08	Greg Bentz	Cleanup.
//  93/10/21	Raymond Tang 	Split into separate files.
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <strstrea.h>
#endif

int strstreambuf::underflow() {
/*****************************/
// The streambuf has decided that it needs more characters for input.
// If a put area is present, extend the get area into it.
// Otherwise, fail.

    __lock_it( __b_lock );
    if( __unlimited ) {
	// adjust end pointer
	setg( eback(), gptr(), egptr() + DEFAULT_MAINBUF_SIZE );
        return( *gptr() );
    }
    if( pptr() > egptr() ) {
        if( gptr() == NULL ) {              // currently no get area?
            setg( pbase(), pbase(), pptr() );
        } else {
            setg( eback(), gptr(), pptr() );
        }
        return( *gptr() );
    }
    return( EOF );
}
