// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/02/28    Steve McDowell  Initial implementation.
//  92/09/08	Greg Bentz	Cleanup.
//  93/10/29	Raymond Tang 	Split into separate files.
//  94/04/06	Greg Bentz	combine header files

#ifdef __SW_FH
#include "iost.h"
#else
#include "variety.h"
#include <string.h>
#include <iostream.h>
#include <streambu.h>
#endif
#include "ioutil.h"
#include "lock.h"

int streambuf::do_sputn( char const *buf, int len ) {
/***************************************************/
// Write the "len" characters starting at "buf" into the put area.
// Return 0 if not possible.
// Return the number of characters successfully put.

    int waiting;
    int written;

    written = 0;
    __lock_it( __b_lock );
    while( len > 0 ) {
        if( pbase() != NULL ) {
	    // # chars available in put area
	    waiting = (__huge_ptr_int)(epptr() - pptr());
            if( waiting <= 0 ) {            // full or not there?
                if( overflow( EOF ) == EOF ) {
                    return( written );
                }
                waiting = (__huge_ptr_int)(epptr() - pptr());
            }
            if( waiting > len ) {           // more than we have to sputn?
                waiting = len;
            }
            ::memcpy( pptr(), buf, waiting );
	    pbump( waiting );
        } else {
            if( overflow( *buf ) == EOF ) {
                return( written );
            }
            waiting = 1;
        }
        written += waiting;
        buf     += waiting;
        len     -= waiting;
    }
    return( written );
}
