// This file contains prototypes and #defines used by the implementation
// of the iostream library.
// This file is not for distribution.
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/08/29	Greg Bentz	Initial implementation.
//
#ifndef _IOUTIL_H_INCLUDED

// function should be inlined
#pragma warning 656 9

#include "variety.h"
#include <stdio.h>
#include "xfloat.h"

#define TRUE  1
#define FALSE 0

typedef int __huge_ptr_int;

union ipvalue {
    void *pword;
    long  iword;
};

struct ios_word_values {
    ios_word_values *next;       // next group of values
    short            count;      // how many values are here?
    ipvalue	     values[1];  // "count" iterations
};

extern int __FlagsToBase( long __format_flags );

class __WATCOM_ios {
public:
    static void *find_user_word( ios *pios, int index );
    static void free_xalloc_storage( ios *pios );
    static ios::iostate writeitem( ostream &ostrm, char const *buffer, int size, int fill_offset );
};

// defined in CLIB
extern "C" {
_WCRTLINK extern int __plusplus_fstat( int handle, int *ios_mode );
_WCRTLINK extern int __plusplus_open( const char *name, int *ios_mode, int prot );
_WCRTLINK extern FILE *__get_std_stream( unsigned handle );
_WCRTLINK extern int __flush( FILE *fp );
_WCRTLINK extern char *__clib_lltoa( signed __int64 *pv, char *buf, unsigned radix );
_WCRTLINK extern char *__clib_ulltoa( unsigned __int64 *pv, char *buf, unsigned radix );
};

#define _IOUTIL_H_INCLUDED
#endif
