;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1992, by WATCOM Systems Inc. All rights     %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
; PRWDATA.ASM -- System and Process specific data for PLIB.
;
;	Thread specific data is allocated by cppdata.c for non multi-thread
;	libraries.  For multi-thread libraries, the data is allocated by
;	the BeginThread() c library function.
;
; date          by              reason
; ====          ==              ======
; 92/10/22      Greg Bentz	Initial implementation
; 93/03/04	Greg Bentz	Added wcpp_undef_vfun_flag
; 93/11/16	Greg Bentz	convert to wasm
; 93/12/07	Greg Bentz	- remove unneeded items
;				- change wcpp to wint
;				- add _wint_module_init
; 94/02/07	Greg Bentz	fix size of wint_module_init for 386
; 94/02/15	Greg Bentz	fix size of wint_module_init for huge
;

        ;name    prwdata
	assume	nothing

        include mdef.inc

DGROUP	group	_DATA

_DATA	segment word public 'DATA'
	assume	DS:DGROUP

;_wint_new_handler		dd 0
;_wint_terminate_handler	dd 0
;_wint_unexpected_handler	dd 0
ifdef __MT__
    _wint_static_init_sema	dd 0
ifdef __QNX__
				dd 0	; QNX has an 8-byte semaphore object!!!
endif
				dd 0
				dd 0
endif
_wint_pure_error_flag		dw 0
_wint_undef_vfun_flag		dw 0
if _MODEL and ( _BIG_DATA or _HUGE_DATA or _USE_32_SEGS )
    _wint_module_init		dd 0
else
    _wint_module_init		dw 0
endif

;	public		"C",_wint_new_handler
;	public		"C",_wint_terminate_handler
;	public		"C",_wint_unexpected_handler
	ifdef __MT__
	    public	"C",_wint_static_init_sema
	endif
	public		"C",_wint_pure_error_flag
	public		"C",_wint_undef_vfun_flag
	public		"C",_wint_module_init

_DATA	ends

        end
