/*

**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************


This module allocates an area to be sub-allocated for exception handling.

This module can be re-compiled for an application with an appropriate
value for EXC_SIZE.

*/
#include "cpplib.h"

#include <stddef.h>
#include <limits.h>

#if INT_MAX == SHRT_MAX
#define EXC_SIZE 1024
#else
#define EXC_SIZE 4096           // size of exception area
#endif

struct exc_area
{
    size_t  area_size;
    char    work_area[ EXC_SIZE - sizeof( size_t ) ];
};

extern "C"
struct exc_area __EXC_AREA = { EXC_SIZE };
