// ARRASSGN.CPP -- support to call operator= for each element of an array
//
// 92/11/30 -- J.W.Welch        -- defined
// 94/12/12 -- J.W.Welch        -- moved to CPP
// 95/06/14 -- Greg Bentz	-- dll linkage

#include "cpplib.h"


extern "C"
_WPRTLINK
void * CPPLIB(assign_array)(        // CALL OPERATOR= FOR ARRAY
    void *tgt_array,                // - target array
    void *src_array,                // - source array
    unsigned count,                 // - number of elements
    unsigned size,                  // - size of one element
    pFUNcopy opeq )                 // - operator= for an element
{
    void *retn;                     // - return: NULL or first element

    retn = tgt_array;
    while( count > 0 ) {
        (*opeq)( tgt_array, src_array );
        tgt_array = (void *)( ((char*)tgt_array) + size );
        src_array = (void *)( ((char*)src_array) + size );
        -- count;
    }
    return( retn );
}

