/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

ARRDELX.CPP -- support to retrieve count and then call destructor for each
               element of the array from last to first
            -- after array destructor-ed, storage is free'd

Note: this routine must have the same semantics as ARRDEL.CPP; it is called
      when exceptions are enabled for the compiled program


Modified        By              Reason
--------        --              ------
92/10/02        Greg Bentz      Initial version, shipped as "alpha"
                Jim Randall
                Anthony Scian
                Jim Welch

93/02/02        J.W.Welch       Extracted from ARRDEL.CPP

94/01/19        J.W.Welch       Test for NULL passed
*/

#include <cpplib.h>


extern "C"
void CPPLIB(dtor_del_array_x)(  // CALL DTORS FOR ARRAY ELEMENTS AND DELETE
    void *array,                // - array
    RT_TYPE_SIG sig )           // - type signature for array type
{
    ARRAY_STORAGE *base;

    if( array != 0 ) {
        base = ArrayStorageFromArray( array );
        try {
            CPPLIB(dtor_array)( array, base->element_count, sig );
        } catch( ... ) {
            delete base;
            throw;
        }
        delete base;
    }
}
