// ARRNEW.CPP -- support to call constructor for each element in a newly
//               allocated array
//            -- and set count field
//
// 91/11/07 -- J.W.Welch        -- defined
// 92/12/02 -- J.W.Welch        -- adapt to type signatures
// 94/12/12 -- J.W.Welch        -- moved to CPP

#include "cpplib.h"


extern "C"
void * CPPLIB(new_array)(           // CALL CONSTRUCTORS FOR NEW ARRAY ELEMENTS
    ARRAY_STORAGE *new_alloc,       // - what was allocated
    unsigned count,                 // - number of elements
    RT_TYPE_SIG sig )               // - type signature for array type
{
    void *retn;                     // - return: NULL or first element

    if( new_alloc == NULL ) {
        retn = NULL;
    } else {
        new_alloc->element_count = count;
        retn = new_alloc->apparent_address;
        retn = CPPLIB(ctor_array)( retn, count, sig );
    }
    return( retn );
}

