/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1993.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

BITTEST.C -- generalized bit-test routine

Modified        By              Reason
--------        --              ------

93/09/01        J.W.Welch       Defined

94/11/29        J.W.Welch       Defined bit_off
*/

#include "cpplib.h"

static uint_8 mask_on[]         // bits mask for byte (set,test)
    = { 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80 };

static uint_8 mask_off[]        // bits mask for byte (reset)
    = { 0xFE, 0xFD, 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F };


extern "C"
uint_8 CPPLIB( bit_test )(      // TEST IF BIT IS ON
    uint_8* bits,               // - bits
    offset_t bit_no )           // - bit_no
{
    size_t offset;              // - offset within "bits"

    offset = bit_no / 8;
    bit_no -= ( offset * 8 );
    return (uint_8)( mask_on[ bit_no ] & bits[ offset ] );
} 


extern "C"
void CPPLIB( bit_off )(         // TURN BIT OFF
    uint_8* bits,               // - bits
    offset_t bit_no )           // - bit_no
{
    size_t offset;              // - offset within "bits"

    offset = bit_no / 8;
    bit_no -= ( offset * 8 );
    bits[ offset ] &= mask_off[ bit_no ];
} 
