/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

CALLTERM -- call the "terminate" function
         -- this function is required to avoid name-mangling complications
            from the "C" code

Modified        By              Reason
--------        --              ------
92/11/11        J.W.Welch       Defined
93/07/29        A.F.Scian       added aborts pragma using __pragma to remove
                                kludgey previous method that broke when prefix
                                changed


94/01/28        J.W.Welch       Remove aborts

95/09/05        J.W.Welch       Check for return from terminate
                                Move "corrupted_stack" here
*/

#include "cpplib.h"
#include <except.h>
#include "rtexcept.h"
#include "rtmsgs.h"


extern "C"
void CPPLIB( corrupted_stack )( // TERMINATE, WITH CORRUPTED STACK MSG
    void )
{
    CPPLIB( call_terminate )( RTMSG_CORRUPT_STK, PgmThread() );
}


extern "C"
void CPPLIB( call_terminate )(  // CALL "terminate" SET BY "set_terminate"
    char* abort_msg,            // - abortion message
    THREAD_CTL *thr )           // - thread-specific data
{
    ACTIVE_EXC *exc;            // - active exception

    thr->abort_msg = abort_msg;
    exc = thr->excepts;
    if( exc != NULL ) {
        exc->state = EXCSTATE_TERMINATE;
    }
    thr->flags.terminated = TRUE;
    terminate();
    CPPLIB(fatal_runtime_error)( RTMSG_RET_TERMIN, 1 );
}
