
/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1994.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

CPPDATA -- global data for C++ Run-time system

Modified        By              Reason
--------        --              ------
92/10/02        Greg Bentz      Initial version, shipped as "alpha"
                Jim Randall
                Anthony Scian
                Jim Welch
93/05/01        Greg Bentz      Version 9.5 shipped
                Anthony Scian
                Jim Welch
93/08/31        Greg Bentz      Version 9.5 patch level A
                Anthony Scian
                Jim Welch
94/02/04        Greg Bentz      Version 9.5 patch level B
                Anthony Scian
                Jim Welch
94/03/21        Greg Bentz      Version 10.0 LA Version
                Anthony Scian
                Jim Welch
94/05/31        Greg Bentz      Version 10.0 GA Version
                Anthony Scian
                Jim Welch

94/10/31        J.W.Welch       moved to cpp directory
                                added definitions of __compiled_under..

95/06/14        Greg Bentz      dll linkage
*/

#define GBL _WPRTLINK
#include "cpplib.h"
#include "rtexcept.h"

#if defined(__MT__) && defined(__386__)
#include "rtinit.h"
AXI( CPPLIB(multi_thread_init), INIT_PRIORITY_THREAD )
#endif

#ifndef NDEBUG

    extern "C" {

        // THESE CAUSE THE DEBUGGING ROUTINES TO BE FORCED INTO MODULES
    
        extern void CPPLIB( DbgRtDumpAutoDtor )( void );
        extern void CPPLIB( DbgRtDumpModuleDtor )( void );
    
        #pragma extref ( CPPLIB( DbgRtDumpAutoDtor ) );
        #pragma extref ( CPPLIB( DbgRtDumpModuleDtor ) );

    };

#endif

#if defined( M_PC_INTEL )
extern "C" {

    // Note: these have _WRTLINK because they are used only to check
    //       consistency. Linker must resolve references to them.

    #pragma aux no_extra_underscores "*";

    #if defined( FS_REGISTRATION_NT )
        _WPRTLINK int __pragma("no_extra_underscores") __compiled_under_NT;
    #elif defined( FS_REGISTRATION_OS2 )
        _WPRTLINK int __pragma("no_extra_underscores") __compiled_under_OS2;
    #else
        _WPRTLINK int __pragma("no_extra_underscores") __compiled_under_generic;
    #endif

};
#elif defined( M_ALPHA )
extern "C" {

        _WPRTLINK int __compiled_under_generic;

};
#endif
