/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

DTORARST.CPP -- support to retrieve count and then call destructor for each
                element of the array from last to first

             -- the array is a new[]'ed array which is found in ARRAY_STORAGE

             -- the address of the ARRAY_STORAGE is RETURNED

Modified        By              Reason
--------        --              ------
93/12/17        J.W.Welch       Defined

94/01/19        J.W.Welch       Check for NULL passed
*/

#include <cpplib.h>


extern "C"
_WPRTLINK
ARRAY_STORAGE* CPPLIB(dtor_array_store)(  // CALL DTORS FOR ARRAY_STORAGE
    void *array,                    // - array
    RT_TYPE_SIG sig )               // - type signature for array type
{
    ARRAY_STORAGE *base;

    if( array == 0 ) {
        base = 0;
    } else {
        base = ArrayStorageFromArray( array );
        CPPLIB( dtor_array )( array, base->element_count, sig );
    }
    return base;
}
