/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1994.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

EXNONSYS -- Exception support, when no system-dependent support is
            provided by the operating system

Modified        By              Reason
--------        --              ------
92/10/02        Greg Bentz      Initial version, shipped as "alpha"
                Jim Randall
                Anthony Scian
                Jim Welch
93/05/01        Greg Bentz      Version 9.5 shipped
                Anthony Scian
                Jim Welch
93/08/31        Greg Bentz      Version 9.5 patch level A
                Anthony Scian
                Jim Welch
94/02/04        Greg Bentz      Version 9.5 patch level B
                Anthony Scian
                Jim Welch
94/03/21        Greg Bentz      Version 10.0 LA Version
                Anthony Scian
                Jim Welch
94/05/31        Greg Bentz      Version 10.0 GA Version
                Anthony Scian
                Jim Welch
94/08/31        Greg Bentz      Version 10.0 patch level A
                Anthony Scian
                Jim Welch

95/03/27        J.W.Welch       Defined
*/

#include "cpplib.h"
#include "rtexcept.h"

void CPPLIB( raise_exception )  // RAISE EXCEPTION
    ( FsExcRec* excrec )        // - exception record
{
    RW_DTREG* rw;
    THREAD_CTL *thr;            // - thread control
    thr = PgmThread();
    for( rw = thr->registered; ; rw = rw->base.prev ) {
        auto unsigned FS_REGISTRATION_CONVENTION (*handler)
            ( FsExcRec*, RW_DTREG*, FsCtxRec*, unsigned );
        handler = rw->base.handler;
        unsigned retn = (*handler)( excrec, rw, NULL, 0 );
        if( retn != EXC_HAND_CONTINUE ) break;
    }
}


void CPPLIB( unwind_global )    // GLOBAL UNWIND
    ( RW_DTREG* bound           // - bounding R/W entry
    , void (*)( void )          // - code address (ignored)
    , FsExcRec* excrec )        // - exception record
{
    RW_DTREG* rw;
    THREAD_CTL *thr;            // - thread control
    thr = PgmThread();
    excrec->flags |= EXC_TYPE_UNWIND_NORMAL;
    for( rw = thr->registered; rw != bound; rw = rw->base.prev ) {
        auto unsigned FS_REGISTRATION_CONVENTION (*handler)
            ( FsExcRec*, RW_DTREG*, FsCtxRec*, unsigned );
        handler = rw->base.handler;
        unsigned retn = (*handler)( excrec, rw, NULL, 0 );
        if( retn != EXC_HAND_CONTINUE ) break;
    }
    excrec->flags &= ~EXC_TYPE_UNWIND_NORMAL;
}
