/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1994.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

EXSTRING -- implementation of __ExcString
         -- this class is temporary
         -- used only to implement StdException

Modified        By              Reason
--------        --              ------
92/10/02        Greg Bentz      Initial version, shipped as "alpha"
                Jim Randall
                Anthony Scian
                Jim Welch
93/05/01        Greg Bentz      Version 9.5 shipped
                Anthony Scian
                Jim Welch
93/08/31        Greg Bentz      Version 9.5 patch level A
                Anthony Scian
                Jim Welch
94/02/04        Greg Bentz      Version 9.5 patch level B
                Anthony Scian
                Jim Welch
94/03/21        Greg Bentz      Version 10.0 LA Version
                Anthony Scian
                Jim Welch
94/05/31        Greg Bentz      Version 10.0 GA Version
                Anthony Scian
                Jim Welch
94/08/31        Greg Bentz      Version 10.0 patch level A
                Anthony Scian
                Jim Welch

95/10/02        J.W.Welch       Defined
*/

#include "cpplib.h"
#include <exstring.h>
#include <string.h>


__ExcString::__ExcString        // CONSTRUCTOR
    ( char const * val )
{
    strncpy( _value, val, sizeof( _value ) - 1 );
}


__ExcString::__ExcString        // CONSTRUCTOR
    ( void )
{
    _value[0] = '\0';
}


__ExcString::__ExcString        // CONSTRUCTOR
    ( __ExcString const & src )
{
    strncpy( _value, src._value, sizeof( _value ) - 1 );
}


__ExcString::operator char const * // RETRIEVE C-STRING VALUE FOR CLASS
    ( void )
    const
{
    return _value;
}
