/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1993.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

FSROOT -- registration support for root fs entry when fs registeration used
       -- module cannot occur in DLL

Modified        By              Reason
--------        --              ------

94/10/13        J.W.Welch       Defined
94/11/15        Greg Bentz      change init priority
95/03/24        J.W.Welch       Change naming convention
95/06/14        Greg Bentz      dll linkage
95/09/27        J.W.Welch       Removed dll linkage
*/

#include "cpplib.h"
#include "rtexcept.h"
#include "rtinit.h"

#if 0


static unsigned fs_root_handler // HANDLER FOR FS ROOT
    ( FsExcRec* rec_exc         // - exception record
    , RW_DTREG*                 // - current R/W block
    , FsCtxRec*                 // - context record
    , unsigned                  // - dispatch context
    ... )
{
    unsigned retn;              // - return code
    if( rec_exc->flags & EXC_TYPE_UNWINDING ) {
        retn = EXC_HAND_CONTINUE;
    } else if( EXCREC_CODE_WATCOM != ( EXCREC_CODE_WATCOM & rec_exc->code ) ) {
        rec_exc->dispatch->system_exc = rec_exc->code;
        rec_exc->dispatch->type = DISPATCHABLE_SYS_EXC;
        retn = EXC_HAND_CATCH;
    } else {
        rec_exc->dispatch->type = DISPATCHABLE_NO_CATCH;
        retn = EXC_HAND_CATCH;
    }
    return retn;
}


// This entry is located on the FS chain before any others linked on by
// the C++ run-time system
//
static RW_DTREG_ROOT root_entry =// ROOT FS ENTRY
    {   0
    ,   &fs_root_handler
    ,   &fs_root_handler
    ,   0
    };

#endif


// assumptions: the following have occurred by the time fs_root is
//              invoked:
//
//  (1) fs has been set up by operating system
//  (2) thread-ctl stuff has been set up by CLIB initialization
//  (3) executes only in .EXE (not in .DLL)
//  (4) C++ run-time has not linked any others onto the chain
//


static void fs_root             // ESTABLISH ROOT ENTRY
    ( void )
{
    THREAD_CTL* thr = &_RWD_ThreadData;
    thr->flags.executable = TRUE;
}


extern "C" XI( CPPDATA( init_fs_root ), fs_root, INIT_PRIORITY_RUNTIME+1 )

#ifdef M_PC_INTEL
#pragma aux CPPDATA(init_fs_root) "_*";
#endif
