/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

LOCK -- implementation of __lock class

Modified        By              Reason
--------        --              ------
92/10/21        Greg Bentz      Initial Implementation
92/10/27        Greg Bentz      Moved from iostream to plib

*/

#ifdef __MT__

#include <cpplib.h>
#include <string.h>
#include <lock.h>
#include <rtinit.h>

__lock::__lock() {
/*****************/
    ::memset( &locksem, 0, sizeof( locksem ) );
}

__lock::~__lock() {
/*****************/
    _CloseSemaphore( &locksem );
}

void __lock::p( void ) {
/**********************/
    _AccessSemaphore( &locksem );
}

void __lock::v( void ) {
/**********************/
    _ReleaseSemaphore( &locksem );
}

__fn_lock::__fn_lock( __lock *fn_lock )
    : fn_lock(fn_lock)
{
    fn_lock->p();
}

__fn_lock::~__fn_lock()
{
    fn_lock->v();
}

static void fini(                       // FINALIZE STATIC INIT SEMAPHORE
    void )
{
    _RWD_StaticInitSema.~__lock();
}

YI( CPPDATA( fini_sisema ), fini, INIT_PRIORITY_RUNTIME );

#endif
