// OPDEL.CPP - default ::delete operator definition
//
// 92/05/15  -- G.R.Bentz       -- defined
// 93/09/22  -- A.F.Scian	-- some CAD/CAM packages (like AutoCad) do not
//				   implement free() properly so that it can
//				   accept NULL pointers
// 95/08/12  -- Greg Bentz	-- add _WPRTLINK
// 96/04/10  -- Greg Bentz	-- add layer of indirection for DLL library
//
// Note: _WPRTLINK is present here so that the entry point is
//	exported, but it is not present in new.h so that
//	the entry point can be replaced in the user code

#include "cpplib.h"
#include "lock.h"
#include <malloc.h>
#if defined(__MAKE_DLL_CPPLIB)
  #define __SW_BR
#endif
#include <new.h>
#if defined(__MAKE_DLL_CPPLIB)
  #undef __SW_BR
#endif

#if defined(__MAKE_DLL_CPPLIB)
static void __do_delete( void *p )
#else
_WPRTLINK void operator delete(	// RELEASE STORAGE
    void *p )			// -- storage to release
#endif
{
    if( p != NULL ) {
	free( p );
    }
}

#if defined(__MAKE_DLL_CPPLIB)
static _PVV __pfn_delete = &__do_delete;

_WPRTLINK extern _PVV _set_op_delete( _PVV od ) {
    _PVV old;
    _RWD_StaticInitSema.p();
    old = __pfn_delete;
    __pfn_delete = od;
    _RWD_StaticInitSema.v();
    return( old );
}

_WPRTLINK void operator delete(	// RELEASE STORAGE
    void *p )			// -- storage to release
{
    (*__pfn_delete)( p );
}
#endif
