// OPDELARR.CPP - default ::delete[] operator definition
//
// 93/12/16  -- J.W.Welch       -- Define delete[]
// 95/08/12  -- Greg Bentz	-- add _WPRTLINK
// 96/04/10  -- Greg Bentz	-- add layer of indirection for DLL library
//
// Note: _WPRTLINK is present here so that the entry point is
//	exported, but it is not present in new.h so that
//	the entry point can be replaced in the user code

#include "cpplib.h"
#include "lock.h"
#include <malloc.h>
#if defined(__MAKE_DLL_CPPLIB)
  #define __SW_BR
#endif
#include <new.h>
#if defined(__MAKE_DLL_CPPLIB)
  #undef __SW_BR
#endif

#if defined(__MAKE_DLL_CPPLIB)
static void __do_delete_array( void *p )
#else
_WPRTLINK void operator delete[](// RELEASE STORAGE FOR NEW[]
    void *p )                   // -- storage to release
#endif
{
    ::delete( p );
}

#if defined(__MAKE_DLL_CPPLIB)
static _PVV __pfn_delete_array = &__do_delete_array;

_WPRTLINK extern _PVV _set_op_delete_array( _PVV oda ) {
    _PVV old;
    _RWD_StaticInitSema.p();
    old = __pfn_delete_array;
    __pfn_delete_array = oda;
    _RWD_StaticInitSema.v();
    return( old );
}

_WPRTLINK void operator delete[](// RELEASE STORAGE FOR NEW[]
    void *p )                   // -- storage to release
{
    (*__pfn_delete_array)( p );
}
#endif
