// OPNEWARR.CPP -- ::operator new[] default definition
//
// 93/12/16  -- J.W.Welch        -- defined
// 95/08/12  -- Greg Bentz	 -- add _WPRTLINK
// 96/04/10  -- Greg Bentz	-- add layer of indirection for DLL library
//
// Note: _WPRTLINK is present here so that the entry point is
//	exported, but it is not present in new.h so that
//	the entry point can be replaced in the user code


#include "cpplib.h"
#include "lock.h"
#include <stddef.h>
#if defined(__MAKE_DLL_CPPLIB)
  #define __SW_BR
#endif
#include <new.h>
#if defined(__MAKE_DLL_CPPLIB)
  #undef __SW_BR
#endif


#if defined(__MAKE_DLL_CPPLIB)
static void* __do_new_array( unsigned size )
#else
_WPRTLINK void* operator new[](  // ALLOCATE STORAGE FOR NEW[]
    size_t size )               // - size required
#endif
{
    return ::operator new( size );
}

#if defined(__MAKE_DLL_CPPLIB)
static _PUP __pfn_new_array = &__do_new_array;

_WPRTLINK extern _PUP _set_op_new_array( _PUP ona ) {
    _PUP old;
    _RWD_StaticInitSema.p();
    old = __pfn_new_array;
    __pfn_new_array = ona;
    _RWD_StaticInitSema.v();
    return( old );
}

_WPRTLINK void* operator new[](  // ALLOCATE STORAGE FOR NEW[]
    size_t size )               // - size required
{
    return (*__pfn_new_array)( size );
}
#endif
