/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1994.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

PGMTHRD.CPP -- locate thread data to be used for exceptions

Modified        By              Reason
--------        --              ------
92/10/02        Greg Bentz      Initial version, shipped as "alpha"
                Jim Randall
                Anthony Scian
                Jim Welch
93/05/01        Greg Bentz      Version 9.5 shipped
                Anthony Scian
                Jim Welch
93/08/31        Greg Bentz      Version 9.5 patch level A
                Anthony Scian
                Jim Welch
94/02/04        Greg Bentz      Version 9.5 patch level B
                Anthony Scian
                Jim Welch
94/03/21        Greg Bentz      Version 10.0 LA Version
                Anthony Scian
                Jim Welch
94/05/31        Greg Bentz      Version 10.0 GA Version
                Anthony Scian
                Jim Welch
94/08/31        Greg Bentz      Version 10.0 patch level A
                Anthony Scian
                Jim Welch
*/

#include "cpplib.h"
#include "rtexcept.h"


extern "C"
THREAD_CTL* CPPLIB( pgm_thread )// LOCATE THREAD_CTL FOR PROGRAM (.EXE)
    ( void )
{
    THREAD_CTL* retn;           // PGM THREAD (first WATCOM .EXE, .DLL active)

//
// is thread_data offset from fs ?
//
    retn = &_RWD_ThreadData;
    if( ! retn->flags.executable ) {
        retn = retn->call_base;
        if( retn == 0 || ! retn->flags.executable ) {
            RW_DTREG* not_used;
            retn = ThreadLookup( &not_used );
        }
    }
    return retn;
}
