/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

RTTIDYNC -- RTTI dynamic_cast support

Modified        By              Reason
--------        --              ------
95/12/14	A.F.Scian	defined
95/12/21	A.F.Scian	compressed the size of the RTTI structures
*/
#include <stddef.h>
#include <stdio.h>
#include <string.h>

#include "cpplib.h"
#include "rt_rtti.h"


extern "C"
void *__DoDynamicCast( rtti_exec *data ) {
    unsigned **vbptr;
    rtti_leap const *base_leap;
    rtti_class const *md_class;
    type_info const *to_tid;
    rtti_bad throw_except;
    char *return_value;
    auto rtti_leap leap_storage;

    data->ok = 0;
    if( __CalcMostDerived( data ) != NULL ) {
	if( __MakeSureTidIsPresent( data, data->from_tid, &leap_storage ) != NULL ) {
	    to_tid = data->to_tid;
	    if( to_tid != NULL ) {
		base_leap = __MakeSureTidIsPresent( data, to_tid, &leap_storage );
		if( base_leap != NULL ) {
		    if(( base_leap->control & RL_BAD_BASE ) == 0 ) {
			return_value = (char *) data->md_addr;
			if( base_leap->control & RL_VIRTUAL ) {
			    md_class = data->md_class;
			    return_value += md_class->vbptr;
			    vbptr = (unsigned **) return_value;
			    return_value += (*vbptr)[ base_leap->vb_index ];
			}
			return_value += base_leap->offset;
			data->ok = 1;
		    }
		}
	    } else {
		/* cast to 'void cv *' */
		return_value = (char *) data->md_addr;
		data->ok = 1;
	    }
	}
    }
    if( ! data->ok ) {
	throw_except = data->throw_except;
	if( throw_except != NULL ) {
	    throw_except();
	    /* may return */
	}
	return_value = NULL;
    }
    return( return_value );
}
