/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

RTTIREF -- dynamic_cast< ? cv & >( r ) support

Modified        By              Reason
--------        --              ------
95/12/14	A.F.Scian	defined
*/
#include <stddef.h>
#include <stdio.h>
#include <string.h>

#include "cpplib.h"
#include "rt_rtti.h"

#include <typeinfo>
// works around an EH problem
#pragma inline_depth(0)

static void referenceBadCast( void )
{
#ifdef RT_EXC_ENABLED
    throw bad_cast( "dynamic_cast" );
#endif
}


extern "C"
_WPRTLINK
void * CPPLIB(dcref)( void *p, unsigned delta, type_info const *from, type_info const *to ) {
    rtti_exec data;

    if( p == NULL ) {
	referenceBadCast();
	return( p );
    }
    _INIT_EXEC( data, ((char*)p) + delta, from, to, referenceBadCast );
    return( __DoDynamicCast( &data ) );
}
