/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

RTTITID -- typeid( p ) support

Modified        By              Reason
--------        --              ------
96/01/14	A.F.Scian	defined
*/
#include <stddef.h>
#include <stdio.h>
#include <string.h>

#include "cpplib.h"
#include "rt_rtti.h"

#include <typeinfo>
// works around an EH problem
#pragma inline_depth(0)

static void foundNoTypeid( void )
{
#ifdef RT_EXC_ENABLED
    throw bad_typeid( "typeid" );
#endif
}

extern "C"
_WPRTLINK
void const * CPPLIB(gettid)( void *p, unsigned delta, type_info const *from ) {
    auto rtti_leap leap_storage;
    auto rtti_exec data;

    if( p == NULL ) {
	foundNoTypeid();
	/* may return */
	return( NULL );
    }
    _INIT_EXEC( data, ((char*)p) + delta, from, NULL, NULL );
    if( __CalcMostDerived( &data ) != NULL ) {
	if( __MakeSureTidIsPresent( &data, data.from_tid, &leap_storage ) != NULL ) {
	    return( data.md_class->id );
	}
    }
    foundNoTypeid();
    /* may return */
    return( NULL );
}
