// OPNEW.CPP -- operator ::new default definition
//           -- set operator new handler, this routine is used to set the
//              handler to deal with allocation failure during operator new
//           -- the default new handler is NULL
//
// 92/05/15  -- G.R.Bentz        -- defined

#include <cpplib.h>
#include <stddef.h>
#include <malloc.h>
#include <new>


_WPRTLINK
PFV set_new_handler(            // SET HANDLER FOR NEW FAILURE
    PFV handler )               // - new handler to be used
{
    THREAD_CTL *thr;            // - thread control
    PFV previous_handler;

    thr = &_RWD_ThreadData;
    previous_handler = thr->new_handler;
    thr->new_handler = handler;
    return( previous_handler );
}
