// UNEXPECT.CPP -- default definition for unexpected()
//              -- set_unexpected(), this routine is used to set the
//                 handler to deal with unexpected exceptions
//              -- the default handler is terminate()
//
// 92/07/20     -- Greg Bentz        -- defined
// 92/11/13     -- J.W.Welch        -- use thread-specific data

#include <cpplib.h>
#include <stddef.h>
#include <except>


_WPRTLINK
PFV set_unexpected(                 // SET HANDLER FOR UNEXPECTED EXCEPTION
    PFV handler )                   // - handler to be used
{
    THREAD_CTL *thr;            // - thread control
    PFV previous_handler;       // - previous handler

    thr = &_RWD_ThreadData;
    previous_handler = thr->unexpected;
    thr->unexpected = handler;
    return( previous_handler );
}
