/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1993.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

STABACP.C -- support to call copy constructor for each element in a newly
             allocated array

Modified        By              Reason
--------        --              ------

92/10/02        Greg Bentz      Initial version, shipped as "alpha"
                Jim Randall
                Anthony Scian
                Jim Welch

92/11/29        J.W.Welch       No longer called to assign array

92/12/02        J.W.Welch       Add exceptions

93/05/01        Greg Bentz      Version 9.5 shipped
                Anthony Scian
                Jim Welch

93/09/01        J.W.Welch       Adapt for 10.0

94/10/17        J.W.Welch       Adapt for fs registration

95/05/25        J.W.Welch       Use RTARCTOR
*/

#include "cpplib.h"
#include "rtexcept.h"
#include "rtarctor.h"


extern "C"
_WPRTLINK
void * CPPLIB(copy_array)(      // CALL COPY CONSTRUCTORS FOR ARRAY
    void *tgt_array,            // - target array
    void *src_array,            // - source array
    unsigned count,             // - number of elements
    RT_TYPE_SIG sig )           // - signature of array
{
    pFUNcopy ctor;              // - constructor for an element
    size_t size;                // - size of an array element
    _RTARCTOR ar_ctor           // - array-ctor control
        ( 0, sig, tgt_array );

    ctor = sig->clss.copyctor;
    size = sig->clss.size;
    while( count > 0 ) {
        (*ctor)( tgt_array, src_array );
        ++ ar_ctor;
        tgt_array = (void *)( ((char*)tgt_array) + size );
        src_array = (void *)( ((char*)src_array) + size );
        -- count;
    }
    ar_ctor.complete();
    return ar_ctor._array;
}

