/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

VARRCTOR.C -- support to call constructor for each element in a newly
              allocated array
           -- each element in array has a virtual base

Modified        By              Reason
--------        --              ------
92/10/02        Greg Bentz      Initial version, shipped as "alpha"
                Jim Randall
                Anthony Scian
                Jim Welch

92/12/02        J.W.Welch       Added exceptions

93/05/01        Greg Bentz      Version 9.5 shipped
                Anthony Scian
                Jim Welch

93/09/01        J.W.Welch       Adapt for 10.0

94/10/18        J.W.Welch       Adapt for fs registration

95/05/25        J.W.Welch       Use RTARCTOR
*/

#include "cpplib.h"
#include "rtexcept.h"
#include "rtarctor.h"


extern "C"
_WPRTLINK
void * CPPLIB(ctor_varray)(     // CALL CONSTRUCTORS FOR ARRAY ELEMENTS
    void *array,                // - array
    unsigned count,             // - number of elements
    RT_TYPE_SIG sig )           // - signature of array
{
    unsigned size;              // - size of one element
    pFUNctorV ctor;             // - constructor for an element
    _RTARCTOR ar_ctor           // - array-ctor control
        ( 0, sig, array );

    ctor = sig->clss_v.ctor;
    size = sig->clss_v.size;
    while( ar_ctor._count < count ) {
        (*ctor)( array, CTOR_NULL );
        array = (void *)( ((char*)array) + size );
        ++ ar_ctor;
    }
    ar_ctor.complete();
    return ar_ctor._array;
}
