#error obsolete
/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1993.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

STABARR -- support for state table and arrays

Modified        By              Reason
--------        --              ------
93/09/01        J.W.Welch       Defined
*/

#include "cpplib.h"
#include "rtexcept.h"
#include "rtinit.h"


static RO_STATE* arr_state_table( // POINT AT STATE TABLE
    RO_DTREG* ro )              // - R/O entry
{
    return ro->array.state_table;
}


static void* arr_point_object(  // POINT AT OBJECT FOR ENTRY
    RW_DTREG* rw,               // - R/W entry
    RT_STATE_VAR state_var )    // - state variable
{
    size_t size = CPPLIB( ts_size )( rw->base.ro->array.sig );
    return (void*)( (char*)rw->array.array + ( state_var - 1 ) * size );
}


static void arr_init_traverse(  // INITIALIZE TRAVERSAL DATA STRUCTURE
    STAB_TRAVERSE* traverse,    // - traversal information
    RW_DTREG*  )                // - read/write data
{
    traverse->obj_type = OBT_OBJECT;
}

static DTREG_VFTBL arr_vftable =// virtual functions for DTRG_ARRAY
{   &arr_state_table
,   &arr_point_object
,   &arr_init_traverse
};


static void init(               // PROGRAM INITIALIZATION
    void )
{
    CPPDATA( dtreg_vfptrs )[ DTRG_ARRAY ] = &arr_vftable;
}

XI( CPPDATA( stab_init_arr ), init, INIT_PRIORITY_RUNTIME )


extern "C"
THREAD_CTL* CPPLIB( arr_register )( // REGISTER ARRAY BLOCKS
    void* array,                // - array pointer
    INT_DTREG_ARRAY* icb,       // - R/O block
    RT_TYPE_SIG sig )           // - type signature of element
{
    icb->ro.base.reg_type = DTRG_ARRAY;
    icb->ro.sig = sig;
    icb->ro.state_table[0].dtor = sig->clss.dtor;
    icb->ro.state_table[0].u.data_offset = 0;
#ifndef NDEBUG
    icb->ro.state_table[1].dtor = 0;
    icb->ro.state_table[1].u.data_offset = 0;
#endif
    icb->rw.array = array;
    icb->rw.base.ro = (RO_DTREG*)&icb->ro;
    return CPPLIB( base_register )( (RW_DTREG*)&icb->rw
                                  , (RO_DTREG*)&icb->ro
                                  , 0 );
}
