/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1993.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

STABFUNC -- support for state table and functions

Modified        By              Reason
--------        --              ------
93/09/01        J.W.Welch       Defined
95/05/24        J.W.Welch       Change naming convention
95/06/14        Greg Bentz      dll linkage
95/06/16        Greg Bentz      update revision count in symbol name
95/09/27        J.W.Welch       Remove virtual functions
*/

#include "cpplib.h"
#include "rtexcept.h"

#if 0
#include "rtinit.h"


static RO_STATE* fun_state_table( // POINT AT STATE TABLE
    RO_DTREG* ro )              // - R/O entry
{
    return ro->fun.state_table;
}


static void* fun_point_object(  // POINT AT OBJECT FOR ENTRY
    RW_DTREG* rw,               // - R/W entry
    RT_STATE_VAR state_var )    // - state variable
{
    return (void*)( rw->base.ro
                      ->fun.state_table[ state_var - 1 ].u.data_offset
                  + (char*)rw );
}


static void fun_init_traverse(  // INITIALIZE TRAVERSAL DATA STRUCTURE
    STAB_TRAVERSE* traverse,    // - traversal information
    RW_DTREG* )                 // - read/write data
{
    traverse->obj_type = OBT_OBJECT;
}

static DTREG_VFTBL fun_vftable =// virtual functions for DTRG_FUN
{   &fun_state_table
,   &fun_point_object
,   &fun_init_traverse
};


static void init(               // PROGRAM INITIALIZATION
    void )
{
    CPPDATA( dtreg_vfptrs )[ DTRG_FUN ] = &fun_vftable;
}

extern "C" XI( CPPDATA( stab_init_fun ), init, INIT_PRIORITY_RUNTIME )

#ifdef M_PC_INTEL
    #pragma aux CPPDATA(stab_init_fun) "_*";
#endif

#endif

extern "C"
_WPRTLINK
void CPPLIB( fun_register )(    // REGISTRATION FOR FUNCTION
    RW_DTREG* rw,               // - R/W block
    RO_DTREG* ro )              // - R/O block
{
    CPPLIB( base_register )( rw, ro, 0 );
}
