/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

STABMOD -- DTOR function statics (state-variable implementation)

Modified        By              Reason
--------        --              ------
93/09/01        J.W.Welch       Defined
94/10/21        J.W.Welch       Removed lcl_register locking (mod_register
                                    does it)
95/09/27        J.W.Welch       Removed virtual support
*/

#include "cpplib.h"
#include "rtexcept.h"

#if 0
#include "rtinit.h"


static RO_STATE* ls_state_table( // POINT AT STATE TABLE
    RO_DTREG* ro )              // - R/O entry
{
    return ro->init_ls.state_table;
}


static void* ls_point_object(   // POINT AT OBJECT FOR ENTRY
    RW_DTREG* rw,               // - R/W entry
    RT_STATE_VAR )              // - state variable
{
    return rw->init_ls.object;
}


static void ls_init_traverse(   // INITIALIZE TRAVERSAL DATA STRUCTURE
    STAB_TRAVERSE* traverse,    // - traversal information
    RW_DTREG* )                 // - read/write data
{
    traverse->obj_type = OBT_OBJECT;
}


static DTREG_VFTBL ls_vftable =// virtual functions for DTRG_STATIC_INITLS
{   &ls_state_table
,   &ls_point_object
,   &ls_init_traverse
};


static void init(               // PROGRAM INITIALIZATION
    void )
{
    CPPDATA( dtreg_vfptrs )[ DTRG_STATIC_INITLS ] = &ls_vftable;
}

XI( CPPDATA( stab_init_lcl ), init, INIT_PRIORITY_RUNTIME )

#endif

extern "C"
void CPPLIB( lcl_register )(    // REGISTRATION OF LOCAL INITIALIZATION
    RW_DTREG RT_FAR *rw )       // - read/write block
{
    CPPLIB( mod_register )( rw );
}
