/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1993.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

STABREG -- registration support

Modified        By              Reason
--------        --              ------
93/09/01        J.W.Welch       Defined

94/10/13        J.W.Welch       FS registration
95/05/17        J.W.Welch       System-independent re-implementation
*/

#include "cpplib.h"
#include "rtexcept.h"


extern "C"
THREAD_CTL* CPPLIB( base_register )( // REGISTRATION OF BASE
    RW_DTREG* rw,               // - R/W element
    RO_DTREG* ro,               // - R/O element
    RT_STATE_VAR state_var )    // - initial state variable
{
    THREAD_CTL *thr;            // - thread control

    rw->base.ro = ro;
    rw->base.state_var = state_var;
    thr = PgmThread();
#ifdef RW_REGISTRATION
    rw->base.handler = & CPPLIB( fs_handler_rtn );
#endif
    return RwRegister( thr, rw );
}


extern "C"
_WPRTLINK
#if 0
THREAD_CTL* CPPLIB( base_deregister )( // DE-REGISTRATION OF BASE
#else
void CPPLIB( base_deregister )( // DE-REGISTRATION OF BASE
#endif
    void )
{
#ifdef FS_REGISTRATION
    FsPop();
#else
    THREAD_CTL *thr;            // - thread control

    thr = PgmThread();
    (void) (RwDeregister( thr ));
#endif
}
