/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1995.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

Modified        By              Reason
--------        --              ------
96/01/10	A.F.Scian	defined
96/07/08	A.F.Scian	added full demangled name support

00000 -- increment to force compile
*/
#include "cpplib.h"
#include "rtexcept.h"
#include "lock.h"
#define __LIB__
#include "demangle.h"

#include <new>
#include <typeinfo>

#pragma initialize 19;

struct __TID_NAME {
    __TID_NAME	*next;
    char	name[1];
};

#ifdef __MT__
static __lock semaphore;
#endif
static __TID_NAME *listNames;

namespace {
    struct __INITFINI {
	~__INITFINI() {
	    __TID_NAME *p;
	    __TID_NAME *n;
#ifdef __MT__
	    __fn_lock lock( &semaphore );
#endif

	    p = listNames;
	    listNames = NULL;
	    for( ; p != NULL; p = n ) {
		n = p->next;
		char *t = (char*) p;
		delete [] t;
	    }
	}
    };
}

const char *type_info::name() const {
    const char *ret_name;
    unsigned len;
    __TID_NAME *name;
#ifdef __MT__
    __fn_lock lock( &semaphore );
#endif

    ret_name = __raw;
    name = (__typeof(name)) __data;
    if( name != NULL ) {
	ret_name = name->name;
    } else {
	len = __demangle_t( __raw, 0, NULL, 0 );
	if( len != 0 ) {
	    name = (__typeof(name)) new char[ sizeof( __TID_NAME ) + len ];
	    if( name != NULL ) {
		__demangle_t( __raw, 0, name->name, len + 1 );
		name->next = listNames;
		listNames = name;
		__data = name;
		ret_name = name->name;
	    }
	}
    }
    return( ret_name );
}
