/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1993.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

TSSIZE.C -- determine size of element for type signature

Modified        By              Reason
--------        --              ------

93/09/01        J.W.Welch       Defined
94/10/11        J.W.Welch       Support for throwing function ptr.
95/03/21        J.W.Welch       Support new type signatures
*/

#include "cpplib.h"
#include "rtexcept.h"


extern "C"
size_t CPPLIB( ts_size )(       // GET SIZE OF ELEMENT FROM TYPE SIGNATURE
    RT_TYPE_SIG sig )           // - type signature
{
    size_t size;                // - size of an element
    
    sig = CPPLIB( ts_refed )( sig );
    switch( sig->hdr.type ) {
      case THROBJ_SCALAR :
      case THROBJ_PTR_FUN :
        size = sig->scalar.size;
        break;
      case THROBJ_CLASS :
      case THROBJ_CLASS_VIRT :
        size = sig->clss.size;
        break;
      case THROBJ_VOID_STAR :
      case THROBJ_PTR_SCALAR :
      case THROBJ_PTR_CLASS :
        size = sizeof( void* );
        break;
      default:
        GOOF_EXC( "unexpected type signature" );
    }
    return size;
} 
