// VARRNEW.CPP -- support to call constructor for each element in a newly
//                allocated array
//             -- each element in array has a virtual base
//
// 92/04/20 -- J.W.Welch        -- defined
// 94/12/12 -- J.W.Welch        -- moved to CPP

#include "cpplib.h"


extern "C"
void * CPPLIB(new_varray)(          // CALL CONSTRUCTORS FOR NEW ARRAY ELEMENTS
    ARRAY_STORAGE *new_alloc,       // - what was allocated
    unsigned count,                 // - number of elements
    RT_TYPE_SIG sig )               // - type signature for array type
{
    void *retn;                     // - return: NULL or first element

    if( new_alloc == NULL ) {
        retn = NULL;
    } else {
        new_alloc->element_count = count;
        retn = new_alloc->apparent_address;
        retn = CPPLIB(ctor_varray)( retn, count, sig );
    }
    return( retn );
}

