// OPNEW.CPP -- operator ::new default definition
//           -- set operator new handler, this routine is used to set the
//              handler to deal with allocation failure during operator new
//           -- the default new handler is NULL
//
// 94/02/27  -- G.R.Bentz        -- defined for MFC
// 94/10/14  -- J.W.Welch        -- use PgmThread
// 94/11/18  -- J.W.Welch        -- include rtexcept

#include "cpplib.h"
#include <stddef.h>
#include <malloc.h>
#include "rtexcept.h"
#include <new>


_WPRTLINK
PFU _set_new_handler(           // SET HANDLER FOR NEW FAILURE
    PFU handler )               // - new handler to be used
{
    THREAD_CTL *thr;            // - thread control
    PFU previous_handler;

    thr = PgmThread();
    previous_handler = thr->_new_handler;
    thr->_new_handler = handler;
    return( previous_handler );
}
