#ifndef ___EXC_PR_H__
#define ___EXC_PR_H__
/*
**********************************************************************
*       Copyright by WATCOM International Corporation, 1987, 1992.   *
*       All rights reserved. No part of this software may be         *
*       reproduced in any form or by any means - graphic, electronic,*
*       mechanical or otherwise, including, without limitation,      *
*       photocopying, recording, taping or information storage and   *
*       retrieval systems - except with the written permission of    *
*       WATCOM International Corporation.                            *
**********************************************************************

EXC_PR.H -- run-time exception-processing control

See EXC_PR.CPP for more details



Modified        By              Reason
--------        --              ------
95/09/14        J.W.Welch       Defined

*/


#ifndef NDEBUG

enum EXCPR_TYPE
{   EXCPR_BASIC
,   EXCPR_FREE
,   EXCPR_DTOR
,   EXCPR_FNEXC
};

#endif


struct _EXC_PR                  // _EXC_PR -- basic processing
{
    RW_DTREG* _rw;              // - R/W block
    _RTCTL* _rtc;               // - run-time control
    _EXC_PR* _prev;             // - previous control entry
    EXCSTATE _state;            // - state for abort
#ifndef NDEBUG
    EXCPR_TYPE _type;           // - debug: type of entry
#endif

    _EXC_PR                     // - constructor
        ( _RTCTL* rtc           // - - run-time control
        , RW_DTREG *rw          // - - current read/write
        , EXCSTATE state )      // - - state
    ;
    ~_EXC_PR                    // - destructor
        ( void )
    ;
};

struct _EXC_PR_FREE             // _EXC_PR_FREE - basic processing, free exc.
    : public _EXC_PR
{
    ACTIVE_EXC* _exc;           // - exception to be destructed

    _EXC_PR_FREE                // - constructor
        ( _RTCTL* rtc           // - - run-time control
        , RW_DTREG *rw          // - - current read/write
        , EXCSTATE state        // - - state
        , ACTIVE_EXC* exc )     // - - exception to be destructed
    ;
    ~_EXC_PR_FREE               // - destructor
        ( void )
    ;
};

struct _EXC_PR_DTOR             // _EXC_PR_DTOR - basic processing, dtor exc.
    : public _EXC_PR_FREE
{
    _EXC_PR_DTOR                // - constructor
        ( _RTCTL* rtc           // - - run-time control
        , RW_DTREG *rw          // - - current read/write
        , EXCSTATE state        // - - state
        , ACTIVE_EXC* exc )     // - - exception to be destructed
    ;
    ~_EXC_PR_DTOR               // - destructor
        ( void )
    ;
};

struct _EXC_PR_FNEXC            // _EXC_PR_FNEXC -- fnexc processing
    : public _EXC_PR_DTOR
{
    RW_DTREG* _fnexc_skip;      // - R/W block skipped until

    _EXC_PR_FNEXC               // - constructor
        ( _RTCTL* rtc           // - - run-time control
        , RW_DTREG *rw          // - - current read/write
        , RW_DTREG *sk          // - - skipping read/write
        , ACTIVE_EXC* exc )     // - - exception to be destructed
    ;
    ~_EXC_PR_FNEXC              // - destructor
        ( void )
    ;
};


#endif
