#ifndef __PDITER_H__
#define __PDITER_H__

// PDITER -- structure used to iterate through calls, on alpha


typedef void (*code_ptr)( void );
typedef void* data_ptr;

struct _UINT64                  // 64-bit number
{   unsigned w0;                // - word[0]
    unsigned w1;                // - word[1]
};

struct _PDITER                  // Iteration structure
{   data_ptr SP_reg;            // - SP register contents
    code_ptr RA_reg;            // - RA (return register) register
    unsigned SP_decrement;      // - amount SP decremented by in routine
    unsigned RA_offset;         // - offset from SP where RA stored
    ProcDesc* procDescr;        // - procedure descriptor (or NULL)
    RW_DTREG* rw;               // - R/W block (or NULL)
    RO_DTREG* ro;               // - R/O block (or NULL)
};


// Prototypes

extern "C" {

code_ptr CPPLIB( alpha_get_ra ) // GET RA register
    ( void )
;
data_ptr CPPLIB( alpha_get_sp ) // GET SP register
    ( void )
;
int CPPLIB( PditerInit )        // START THE ITERATION
    ( _PDITER* pdit             // - iteration block
    , void* SP_reg              // - SP register contents
    , void (*RA_reg)( void ) )  // - RA (return register) register
;
int CPPLIB( PditerUnwind )      // UNWIND ONE PROCEDURE CALL
    ( _PDITER* pdit )           // - iteration block
;


};


#endif
