#ifndef __RTARCTOR_H_
#define __RTARCTOR_H_

// RTARCTOR -- run-time array ctoring/dtoring control
//
// Destructor is defined in STABADT.CPP.
//
// There is no destructor when exceptions are disabled.
//

// 95/05/25 -- J.W.Welch        -- defined

#include "rtdtor.h"


struct _RTARCTOR
    : public _RTDTOR
{
    unsigned _count;            // - # elements ctored
    RT_TYPE_SIG _sig;           // - type signature for an element
    void* _array;               // - array memory

    _RTARCTOR                   // - constructor
        ( unsigned count        // - - # elements
        , RT_TYPE_SIG sig       // - - type signature
        , void *array )         // - - array
        : _count( count )
        , _sig( sig )
        , _array( array )
    {
    }

#ifdef RT_EXC_ENABLED
    ~_RTARCTOR                  // - destructor
        ( void )
    ;
#endif
#ifndef NDEBUG
    _RTARCTOR                   // - copy ctor
        ( _RTARCTOR const & )
    ;
#endif

    void operator++             // - used to increment # elements
        ( void )
    {
        ++ _count;
    }

    void operator--             // - used to decrement # elements
        ( void )
    {
        -- _count;
    }
};



#endif
