#ifndef __RTCTL_H__
#define __RTCTL_H__

//************************************************************************
// _RTCTL -- run-time control information
//************************************************************************

struct _RTCTL                   // RUN-TIME CONTROL
{   THREAD_CTL* thr;            // - thread pointer
    RW_DTREG* rw;               // - R/W block
    RO_DTREG* ro;               // - R/O block

    _RTCTL()                    // - default constructor
        : thr( PgmThread() )
    {
    }

    _RTCTL( THREAD_CTL* thrp )  // - constructor( thread-ptr )
        : thr( thrp )
    {
    }

    _RTCTL* setRwRo             // - set RW, RO fields
        ( RW_DTREG* rwp )       // - - initial RW ptr.
    {
        rw = rwp;
        ro = rwp->base.ro;
        return this;
    }
};


#endif
