#ifndef __RTDTOR_H__
#define __RTDTOR_H__

// _RTDTOR -- R/T Destructor (used as base for specialized destructors
//            in C++ run-time system
//
// The base has no effect when exceptions are not enabled.


struct _RTDTOR                  // _RTDTOR -- destructor base
{
#ifdef RT_EXC_ENABLED
    unsigned _alive;            // - true ==> needs destruction

    _RTDTOR()                   // - default constructor
        :_alive( true )
    {
    }

    unsigned alive() const      // - test if alive
    {
        return _alive;
    }

    void complete()             // - complete operation ( alive is dead)
    {
        _alive = false;
    }
#else
    _RTDTOR()                   // - default constructor
    {
    }

    unsigned alive() const      // - test if alive
    {
        return true;
    }

    void complete() const       // - complete operation ( alive is dead)
    {
    }
#endif
};

#endif
