// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/09    Steve McDowell  Initial simple implementation using C library
//                              string functions wherever possible.
//  92/01/20    ...             Added checking for invalid Strings, including
//                              adding the ! operator, the == and !=
//                              operators with integer arguments, and the
//                              "valid" member and friend functions.
//  92/03/11    ...             Re-implemented using StringReps (reference
//                              counts, offset and length).
//  92/10/08	Greg Bentz	Cleanup.
//  93/08/31	Greg Bentz	- make extractor skip whitespace if
//				  ios::skipws is set
//				- correct offset computation in substring
//  93/10/07	Greg Bentz	- alloc_mult_size() not setting new value right
//  93/10/19	Raymond Tang	split into separate files
//  94/04/06	Greg Bentz	combine header files

#include "strng.h"

int String::alloc_mult_size( int mult ) {
/***************************************/
// Set "string_mult_size" to "mult".
// Since the code in AllocStringRep assumes string_mult_size is a multiple
// of 8, enforce that here.
// Round down to the nearest multiple of 8.
    int old_string_mult_size = String::__string_mult_size;

    String::__string_mult_size = 1;
    for( ;; ) {
        mult >>= 1;
        if( mult == 0 ) break;
        String::__string_mult_size <<= 1;
    }
    return( old_string_mult_size );
}
