// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/09    Steve McDowell  Initial simple implementation using C library
//                              string functions wherever possible.
//  92/01/20    ...             Added checking for invalid Strings, including
//                              adding the ! operator, the == and !=
//                              operators with integer arguments, and the
//                              "valid" member and friend functions.
//  92/03/11    ...             Re-implemented using StringReps (reference
//                              counts, offset and length).
//  92/10/08	Greg Bentz	Cleanup.
//  93/08/31	Greg Bentz	- make extractor skip whitespace if
//				  ios::skipws is set
//				- correct offset computation in substring
//  93/10/07	Greg Bentz	- alloc_mult_size() not setting new value right
//  93/10/19	Raymond Tang	split into separate files
//  94/04/06	Greg Bentz	combine header files

#include "strng.h"

int __CompareChars( const char *l, long p_llen,
                    const char *r, long p_rlen ) {
/*****************************************************/
// Compare the strings specified by l/p_llen and r/p_rlen.
// Return -1, 0 or 1 depending on whether the relation is <, == or >.
// If either length < 0, then use ::strlen to find the length.
    int     ret;
    size_t  llen;
    size_t  rlen;

    if( l == NULL ) {
        llen = 0;
    } else if( p_llen < 0 ) {
        llen = ::strlen( l );
    } else {
        llen = (size_t)p_llen;
    }
    if( r == NULL ) {
        rlen = 0;
    } else if( p_rlen < 0 ) {
        rlen = ::strlen( r );
    } else {
        rlen = (size_t)p_rlen;
    }
    if( llen == rlen ) {
        return( ::memcmp( l, r, llen ) );
    }
    if( llen < rlen ) {
        ret = ::memcmp( l, r, llen );
        return( ret == 0 ? -1 : ret );
    }
    ret = ::memcmp( l, r, rlen );
    return( ret == 0 ? 1 : ret );
}

