// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/09    Steve McDowell  Initial simple implementation using C library
//                              string functions wherever possible.
//  92/01/20    ...             Added checking for invalid Strings, including
//                              adding the ! operator, the == and !=
//                              operators with integer arguments, and the
//                              "valid" member and friend functions.
//  92/03/11    ...             Re-implemented using StringReps (reference
//                              counts, offset and length).
//  92/10/08	Greg Bentz	Cleanup.
//  93/08/31	Greg Bentz	- make extractor skip whitespace if
//				  ios::skipws is set
//				- correct offset computation in substring
//  93/10/07	Greg Bentz	- alloc_mult_size() not setting new value right
//  93/10/19	Raymond Tang	split into separate files
//  94/04/06	Greg Bentz	combine header files
//  94/04/21	Kevin Hui	extending constructor definition

#include "strng.h"

String::String( const char *cstr, size_t n )
/******************************************/
	: __offset( 0 ), __c_string( NULL ) {
// Constructor: make a String from a C string.
// If cstr is NULL, then make an empty String.
// If n is NPOS (default arg), we copy the whole string.
// Otherwise, we just take the first n characters.
    if( cstr == NULL ) {
	n = 0;
    } else if( n == NPOS ) {
	n = ::strlen( cstr );
    }
    __srep = __AllocStringRep( NULL, n );
    if( __srep == NULL ) {
        __slength = 0;
    } else {
        if( n > 0 ) {
            ::memcpy( __srep->__value, cstr, n );
        }
        __slength = n;
    }
}
