// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/09    Steve McDowell  Initial simple implementation using C library
//                              string functions wherever possible.
//  92/01/20    ...             Added checking for invalid Strings, including
//                              adding the ! operator, the == and !=
//                              operators with integer arguments, and the
//                              "valid" member and friend functions.
//  92/03/11    ...             Re-implemented using StringReps (reference
//                              counts, offset and length).
//  92/10/08	Greg Bentz	Cleanup.
//  93/08/31	Greg Bentz	- make extractor skip whitespace if
//				  ios::skipws is set
//				- correct offset computation in substring
//  93/10/07	Greg Bentz	- alloc_mult_size() not setting new value right
//  93/10/19	Raymond Tang	split into separate files
//  94/04/06	Greg Bentz	combine header files
//  94/04/21	Kevin Hui	extending contructor definition

#include "strng.h"

String::String( const String &s, size_t pos, size_t n )
/*****************************************************/
	: __c_string( NULL ) {
// Copy constructor: make a String from another String
    if( pos > s.__slength ) {
	__srep = NULL; // exception: out-of-range error
    } else {
	__srep = s.__srep;
    }
    if( __srep == NULL ) { // also handles the exception (for now)
        __slength = 0;
        __offset  = 0;
    } else {
	if( n == NPOS ) n = s.__slength;
	size_t rlen = s.__slength - pos;
	if( rlen > n ) rlen = n;
        __srep->__refcount++;
        __slength = rlen;
        __offset  = s.__offset + pos;
    }
}
