// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/09    Steve McDowell  Initial simple implementation using C library
//                              string functions wherever possible.
//  92/01/20    ...             Added checking for invalid Strings, including
//                              adding the ! operator, the == and !=
//                              operators with integer arguments, and the
//                              "valid" member and friend functions.
//  92/03/11    ...             Re-implemented using StringReps (reference
//                              counts, offset and length).
//  92/10/08	Greg Bentz	Cleanup.
//  93/08/31	Greg Bentz	- make extractor skip whitespace if
//				  ios::skipws is set
//				- correct offset computation in substring
//  93/10/07	Greg Bentz	- alloc_mult_size() not setting new value right
//  93/10/19	Raymond Tang	split into separate files
//  94/04/06	Greg Bentz	combine header files
//  94/04/11	Greg Bentz	make left arg to op+ const
//  95/05/19	Greg Bentz	dll linkage

#include "strng.h"

_WPRTLINK String operator + ( const String &l, const char *r ) {
/*************************************************************/
// Concatenate operator: String + C string
    size_t  rstrlen;

    // If "r" is an empty string, just use "l":
    rstrlen = (r == NULL) ? 0 : ::strlen( r );
    if( rstrlen == 0 ) {
        String result( l );
        return( result );
    }

    // If "l" is an empty string, just use "r":
    if( l.__slength == 0 ) {
        String result( r );
        return( result );
    }

    // Append "r" to "l" giving "*this":
    String result;
    result.__AppendToStringRep( l, r, rstrlen );
    return( result );
}
