// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/09    Steve McDowell  Initial simple implementation using C library
//                              string functions wherever possible.
//  92/01/20    ...             Added checking for invalid Strings, including
//                              adding the ! operator, the == and !=
//                              operators with integer arguments, and the
//                              "valid" member and friend functions.
//  92/03/11    ...             Re-implemented using StringReps (reference
//                              counts, offset and length).
//  92/10/08	Greg Bentz	Cleanup.
//  93/08/31	Greg Bentz	- make extractor skip whitespace if
//				  ios::skipws is set
//				- correct offset computation in substring
//  93/10/07	Greg Bentz	- alloc_mult_size() not setting new value right
//  93/10/19	Raymond Tang	split into separate files
//  94/04/06	Greg Bentz	combine header files

#include "strng.h"
#include "stghdr.h"

String::operator const char *() {
/*******************************/
// Conversion operator: convert a String to a (const char *)
// NOTE: the pointer returned is valid only as long as "this" is valid.
//       If the C string should persist longer, then it should be copied
//       (eg. using strdup)

    ::free( __c_string );
#ifndef NDEBUG
    if( __c_string != NULL ) {
        _CStrAllocCount--;
    }
#endif
    if( __srep == NULL ) {
        __c_string = NULL;
        return( __c_string );
    }
    __c_string = (char *) ::malloc( __slength + 1 );
    if( __c_string == NULL ) {
        return( __c_string );
    }
#ifndef NDEBUG
    _CStrAllocCount++;
#endif
    if( __slength > 0 ) {
        ::memcpy( __c_string, __srep->__value + __offset, __slength );
    }
    __c_string[__slength] = '\0';
    return( __c_string );
}
