// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/09    Steve McDowell  Initial simple implementation using C library
//                              string functions wherever possible.
//  92/01/20    ...             Added checking for invalid Strings, including
//                              adding the ! operator, the == and !=
//                              operators with integer arguments, and the
//                              "valid" member and friend functions.
//  92/03/11    ...             Re-implemented using StringReps (reference
//                              counts, offset and length).
//  92/10/08	Greg Bentz	Cleanup.
//  93/08/31	Greg Bentz	- make extractor skip whitespace if
//				  ios::skipws is set
//				- correct offset computation in substring
//  93/10/07	Greg Bentz	- alloc_mult_size() not setting new value right
//  93/10/19	Raymond Tang	split into separate files
//  94/04/06	Greg Bentz	combine header files
//  95/05/19	Greg Bentz	dll linkage

#include "strng.h"

#define FALSE    0
#define TRUE     1

_WPRTLINK istream &operator >> ( istream &strm, String &s ) {
/**********************************************************/
// Input (get from) operator: read a String from the stream.
    #define CHUNK_SIZE          128
    char    chunk[CHUNK_SIZE+1];
    int     count               = 0;
    char    done                = FALSE;
    char    assigned            = FALSE;

    if( strm.flags() & ios::skipws ) {
	ws( strm );
    }
    do {
        for( ; count < CHUNK_SIZE; ++count ) {
            chunk[count] = (char)strm.get();
            if( !strm.good() ) {
                done = TRUE;
                break;
            }
            if( isspace( chunk[count] ) ) {
                strm.putback( chunk[count] );
                done = TRUE;
                break;
            }
        }
        if( count > 0 ) {
            chunk[count] = '\0';
            if( assigned ) {
                s += chunk;
            } else {
                assigned = TRUE;
                s        = chunk;
            }
            count = 0;
        }
    } while( !done );
    return( strm );
}
