// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %     Copyright (C) 1992, by WATCOM International Inc.  All rights    %
// %     reserved.  No part of this software may be reproduced or        %
// %     used in any form or by any means - graphic, electronic or       %
// %     mechanical, including photocopying, recording, taping or        %
// %     information storage and retrieval systems - except with the     %
// %     written permission of WATCOM International Inc.                 %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
//  Modified    By              Reason
//  ========    ==              ======
//  92/01/09    Steve McDowell  Initial simple implementation using C library
//                              string functions wherever possible.
//  92/01/20    ...             Added checking for invalid Strings, including
//                              adding the ! operator, the == and !=
//                              operators with integer arguments, and the
//                              "valid" member and friend functions.
//  92/03/11    ...             Re-implemented using StringReps (reference
//                              counts, offset and length).
//  92/10/08	Greg Bentz	Cleanup.
//  93/08/31	Greg Bentz	- make extractor skip whitespace if
//				  ios::skipws is set
//				- correct offset computation in substring
//  93/10/07	Greg Bentz	- alloc_mult_size() not setting new value right
//  93/10/19	Raymond Tang	split into separate files
//  94/04/06	Greg Bentz	combine header files

#include "strng.h"

String String::operator () ( size_t pos, size_t len ) const {
/***********************************************************/
// Substring operator: return a String containing the characters from
// position "pos" for a length of "len".
// Use the existing StringRep with an appropriate offset/length.
    String  result;

    result.__FreeStringRep();
    if( __srep == NULL  ||  pos >= __slength  ||  len <= 0 ) {
        return( result );
    }
    if( len > (__slength - pos) ) {  // length too long?
        len = (__slength - pos);     // - truncate!
    }
    __srep->__refcount++;
    result.__srep    = __srep;
    result.__offset  = pos + __offset;
    result.__slength = len;
    return( result );
}

