;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1989 by WATCOM Systems Inc. All rights	   %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
; Date		By		Reason
; ====		==		======
; 21-jul-90	F.W.Crigger	handle denormal numbers
; 28-apr-91	F.W.Crigger	handle infinity and NaNs
; 19-apr-93	F.W.Crigger	Check for infinity was backwards
; 21-may-95	F.W.Crigger	Allow -0
; 23-nov-95	Greg Bentz	merge with Mathlib support

ifdef _BUILDING_MATHLIB
	xdefp	__iFDLD
else
	xdefp	__EmuFDLD
endif

;	convert double to long double
; input:
;ifdef _BUILDING_MATHLIB
;	EAX	pointer to double
;	EDX	pointer to long double to be filled in
;else
;	EDX:EAX double
;	EBX	pointer to long double to be filled in
;endif

ifdef _BUILDING_MATHLIB
__iFDLD proc	near
	push	ECX			; save ECX
	push	EBX			; save EBX
	mov	EBX,EDX			; get pointer to long double
	mov	EDX,4[EAX]		; get double
	mov	EAX,[EAX]		; ...
else
__EmuFDLD proc	near
	push	ECX			; save ECX
endif
	mov	ECX,EDX 		; get exponent and sign
	shld	EDX,EAX,11		; shift fraction left 11 bits
	shl	EAX,11			; ...
	_guess				; guess: a normal number
	  sar	ECX,32-12		; - shift exponent to bottom
	  and	CX,07FFh		; - isolate exponent
	  _quif	e			; - quit if denormal number
	  _guess			; - guess: normal number
	    cmp	  CX,07FFh		; - - quit if infinity or NaN
	    _quif e			; - - ...
	    add	  CX,3FFFh-03FFh	; - - change bias to temp real format
	  _admit			; - guess: NaN
	    mov	  CX,7FFFh		; - - set exponent for infinity or NaN
	    test  EDX,7FFFFFFFh		; - - check for infinity
	    _if	  e			; - - if top part is 0
	      or    EAX,EAX		; - - - check low word
	    _endif			; - - endif
	    _quif e			; - - quit if infinity
	    push  EDX			; - - save EDX
	    push  EAX			; - - save EAX
	    call  F8InvalidOp		; - - indicate "Invalid" exception
	    pop	  EAX			; - - restore EAX
	    pop	  EDX			; - - restore EDX
	    or	  EDX,40000000h		; - - indicate NaN
	  _endguess			; - endguess
	  or	EDX,80000000h		; - turn on implied 1 bit
	_admit				; guess: zero
	  or	EDX,EDX			; - quit if non-zero
	  _quif ne			; - ...
	  or    EAX,EAX			; - ...
	  _quif ne			; - ...
	  sub	ECX,ECX			; - set exponent and sign to 0
	_admit				; admit: denormal number
	  mov	CX,3C01h		; - set exponent
	  or	EDX,EDX			; - if high word is zero
	  _if	e			; - then
	    xchg  EAX,EDX		; - - shift number left 32 bits
	    sub   CX,32 		; - - adjust exponent
	  _endif			; - endif
	  _loop 			; - loop (normalize number)
	    or	  EDX,EDX		; - - quit if top bit is on
	    _quif s			; - - ...
	    _shl  EAX,1 		; - - shift number left 1 bit
	    _rcl  EDX,1 		; - - ...
	    dec   CX			; - - decrement exponent
	  _endloop			; - endloop
	_endguess			; endguess
	mov	[EBX],EAX		; store number
	mov	4[EBX],EDX		; ...
	_shl	ECX,1			; get sign
	rcr	CX,1			; place in top bit
	mov	8[EBX],CX		; ...
ifdef _BUILDING_MATHLIB
	pop	EBX			; restore EBX
	pop	ECX			; restore ECX
	ret				; return
__iFDLD endp
else
	pop	ECX			; restore ECX
	ret				; return
__EmuFDLD endp
endif
