;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
;<>
;<> __FLDC - long double comparison
;<>     input:  EAX - pointer to operand 1
;<>             EDX - pointer to operand 2
;<>       if op1 > op2,  1 is returned in EAX
;<>       if op1 < op2, -1 is returned in EAX
;<>       if op1 = op2,  0 is returned in EAX
;<>	  if either opnd is NaN, then 2 is returned in EAX
;<>
;<>  modified:    by:           reason:
;<>  ---------    ---           -------
;<>  29-sep-86  F.W.Crigger     F8cmp adapted to new code generator
;<>  26-oct-87  John Dahms      Added __EDC
;<>--------------------------------------------------------Version 6.0-----
;<>  15-apr-88  F.W.Crigger     __EDC didn't set si before calling __FDC
;<>  22-may-88  F.W.Crigger     Save some memory references
;<>  10-mar-89  F.W.Crigger     Adapted for 386
;<>  29-may-89  F.W.Crigger     Adapted for long doubles
;<>  08-jul-89  F.W.Crigger     Added chkfor0 for comparing +0 with -0
;<>--------------------------------------------------------Version 9.0-----
;<>  07-jun-92	F.W.Crigger	Support added for NaNs
;<>
;<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>

        xdefp   __FLDC

        defp    __FLDC
        push    EDI             ; save EDI
        push    ESI             ; save ESI
	_guess			; guess: op1 is not a NaN
	  mov	SI,8[EAX]	; - get sign and exponent of op1
	  or	SI,8000H	; - turn on sign bit (all 1's if a NaN)
	  inc	SI		; - will be 0 if a NaN
	  _quif	ne		; - quit if not a NaN
	  mov	ESI,4[EAX]	; - get high order word of fraction 
	  _shl	ESI,1		; - get rid of implied 1 bit
	  or	ESI,[EAX]	; - or in rest of fraction
	  jne	short NaN	; - non-zero fraction means its a NaN
	_endguess		; endguess
	_guess			; guess: op2 is not a NaN
	  mov	SI,8[EDX]	; - get sign and exponent of op2
	  or	SI,8000H	; - turn on sign bit (all 1's if a NaN)
	  inc	SI		; - will be 0 if a NaN
	  _quif	ne		; - quit if not a NaN
	  mov	ESI,4[EDX]	; - get high order word of fraction 
	  _shl	ESI,1		; - get rid of implied 1 bit
	  or	ESI,[EDX]	; - or in rest of fraction
	  jne	short NaN	; - non-zero fraction means its a NaN
	_endguess		; endguess
        mov     ESI,6[EAX]      ; get sign of op1
        mov     EDI,6[EDX]      ; get op2 exponent and sign
        xor     EDI,ESI         ; see about signs of the operands
        mov     EDI,0           ; clear result
        js      short chkfor0   ; quif arg1 & arg2 have diff signs
        _guess                  ; guess
          mov   SI,8[EAX]       ; - get exponent
          cmp   SI,8[EDX]       ; - compare them
          _quif ne              ; - quif not equal
          mov   EDI,4[EAX]      ; - get high part of fraction
          cmp   EDI,4[EDX]      ; - compare them
          _quif ne              ; - quif not equal
          mov   EDI,[EAX]       ; - get low part of fraction
          cmp   EDI,[EDX]       ; - compare them
        _endguess               ; endguess
        mov     EDI,0           ; clear result
        _if     ne              ; if arg1 <> arg2
          rcr   EAX,1           ; - save carry in EAX
          xor   ESI,EAX         ; - sign of ESI is sign of result

cmpdone:  _shl  ESI,1           ; - get sign of result into carry
          sbb   EDI,0           ; - EDI gets sign of result
          _shl  EDI,1           ; - double EDI
          inc   EDI             ; - make EDI -1 or 1
        _endif                  ; endif
        mov     EAX,EDI         ; get result
        pop     ESI             ; restore ESI
        pop     EDI             ; restore EDI
        ret                     ; return to caller

NaN:	mov	EAX,2		; indicate NaN
        pop     ESI             ; restore ESI
        pop     EDI             ; restore EDI
        ret                     ; return to caller

chkfor0:or      EDI,[EAX]       ; see if both operands are 0
        or      EDI,[EDX]       ; ...
        or      EDI,4[EAX]      ; ...
        or      EDI,4[EDX]      ; ...
        mov     AX,8[EAX]       ; get exponnet
        shl     EAX,16          ; ...
        mov     AX,8[EDX]       ; ...
        and     EAX,7FFF7FFFh   ; get rid of signs
        or      EAX,EDI         ; check for 0
        mov     EDI,0           ;
        jne     cmpdone         ; if not zero
        pop     ESI             ; restore ESI
        pop     EDI             ; restore EDI
        ret                     ; return to caller

        endproc __FLDC

