;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%       Copyright (C) 1989 by WATCOM Systems Inc. All rights      %
;%       reserved. No part of this software may be reproduced      %
;%       in any form or by any means - graphic, electronic or      %
;%       mechanical, including photocopying, recording, taping     %
;%       or information storage and retrieval systems - except     %
;%       with the written permission of WATCOM Systems Inc.        %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
; Date		By		Reason
; ====		==		======
; 19-apr-93	F.W.Crigger	handle infinity and NaNs
; 23-nov-95	Greg Bentz	merge with Mathlib support

ifdef _BUILDING_MATHLIB
        xdefp   __iFSLD
else
        xdefp   __EmuFSLD
endif

;       convert float to long double
; input:
;ifdef _BUILDING_MATHLIB
;	EAX	pointer to float
;       EDX     pointer to long double to be filled in
;else
;       EAX     float
;       EDX     pointer to long double to be filled in
;endif

ifdef _BUILDING_MATHLIB
__iFSLD proc  near
	mov	EAX,[EAX]		; get float value
else
__EmuFSLD proc  near
endif
        push    ECX                     ; save ECX
        push    EBX                     ; save EBX
        mov     EBX,EDX                 ; save address of long double
        sub     EDX,EDX                 ; zero rest of fraction
        mov     ECX,EAX                 ; get exponent and sign
        sar     ECX,32-9                ; shift to bottom
        and     CX,00FFh                ; isolate exponent
        _if     ne                      ; if not 0
          shl   EAX,8                   ; - shift fraction into place
	  _guess			; - guess: normal number
	    cmp	  CL,0FFh		; - - quit if NaN or infinity
	    _quif e			; - - ...
            add   CX,3FFFh-007Fh        ; - - change bias to temp real format
	  _admit			; - guess: NaN
	    mov	  CH,0FFh		; - - set exponent to all one's
	    and	  EAX,7FFFFFFFh		; - - isolate fraction bits
	    _quif e			; - - quit if infinity
	    or	  EAX,40000000h		; - - indicate NaN
	  _endguess			; - endguess
          _shl  ECX,1                   ; - get sign
          rcr   CX,1                    ; - place in top bit
          or    EAX,80000000h           ; - turn on implied 1 bit
        _endif                          ; endif
        mov     [EBX],EDX               ; store number
        mov     4[EBX],EAX              ; ...
        mov     8[EBX],CX               ; ...
        pop     EBX                     ; restore EBX
        pop     ECX                     ; restore ECX
        ret                             ; return
ifdef _BUILDING_MATHLIB
__iFSLD endp
else
__EmuFSLD endp
endif
