//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%     Copyright (C) 1994, by WATCOM International Inc.  All rights    %
//%     reserved.  No part of this software may be reproduced or        %
//%     used in any form or by any means - graphic, electronic or       %
//%     mechanical, including photocopying, recording, taping or        %
//%     information storage and retrieval systems - except with the     %
//%     written permission of WATCOM International Inc.                 %
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
// Date		By		Reason
// ----		--		------
// 11-nov-93	Greg Bentz	defined to rationalize exit_with_msg
// 21-feb-95	Greg Bentz	alpha support
// 21-apr-95	Greg Bentz	variety.h for near/far and composite macros
//
//
#ifndef _EXITWMSG_H_INCLUDED
#define _EXITWMSG_H_INCLUDED

#include "variety.h"

#ifdef __cplusplus
    extern "C" {
#endif

#undef _EWM_PARM1
#undef _EWM_PARM2
#if defined(__AXP__) || defined(__PPC__)
    #define _EWM_PARM1
    #define _EWM_PARM2
#elif defined(__386__)
    #define _EWM_PARM1  eax
    #define _EWM_PARM2  edx
#elif defined(M_I86)
    #define _EWM_PARM1  ax dx
    #define _EWM_PARM2  bx
#else
    #error unrecognized platform
#endif

// C interface
// - tracks normal calling convention
// - this is the funtion that is called from ASM and from C, C++
// - note there is no #pragma aborts so that debugger can trace out
_WCRTLINK extern void __exit_with_msg( char _WCI86FAR *, unsigned );
_WCRTLINK extern void __fatal_runtime_error( char _WCI86FAR *, unsigned );

// ASM interface
// - always uses register calling convention
// - this function is only called from the C implementation
//   of __exit_with_msg
extern void __do_exit_with_msg( char _WCI86FAR *, unsigned );
#ifdef _M_IX86
    #pragma aux __do_exit_with_msg "*__" \
		parm caller [_EWM_PARM1] [_EWM_PARM2];
#endif

#undef _EWM_PARM1
#undef _EWM_PARM2

_WCRTLINK extern char volatile __WD_Present;

// WVIDEO interface
// this function should be called before __exit_with_msg()
// to allow WVIDEO to trap runtime errors.
// this really needs to be far!!!
_WCRTLINK extern int __EnterWVIDEO( char _WCFAR *string );

#ifdef __cplusplus
    };
#endif
#endif
