#ifndef EXTFUNC_H_INCLUDED
#define EXTFUNC_H_INCLUDED

#include "variety.h"

#if defined(_M_IX86)
    #if !defined(__WINDOWS__)
	#if defined(__BIG_DATA__)
	    #define __DS	ds
	#endif
    #endif
    
    #if !defined(__FLAT__)
	#define __ES	es
    #endif
    
    #if defined(__386__)
	#if defined(__WINDOWS__) || !defined(__FLAT__)
	    #define __FS	fs
	#endif
	
	#define __GS	gs
	#if defined(__SW_3S)
	    #define __AX	eax
	    #define __BX	ebx
	    #define __CX	ecx
	    #define __DX	edx
	#endif
    #endif
    
    #ifndef __AX
	#define __AX
    #endif
    #ifndef __BX
	#define __BX
    #endif
    #ifndef __CX
	#define __CX
    #endif
    #ifndef __DX
	#define __DX
    #endif
    #ifndef __DS
	#define __DS
    #endif
    #ifndef __ES
	#define __ES
    #endif
    #ifndef __FS
	#define __FS
    #endif
    #ifndef __GS
	#define __GS
    #endif
    
    #pragma aux __outside_CLIB modify [__AX __BX __CX __DX __DS __ES __FS __GS];
    /*
	    use as follows:
    
    typedef void vfv( void );
    #pragma aux (__outside_CLIB) __vfv;
    */
    
    #undef __AX
    #undef __BX
    #undef __CX
    #undef __DX
    #undef __DS
    #undef __ES
    #undef __FS
    #undef __GS
#elif defined(__AXP__)
    // __outside_CLIB is not necessary for alpha
#elif defined(__PPC__)
    // __outside_CLIB is not necessary for ppc
#else
    #error platform not supported
#endif

#endif
