#ifndef _LIBALLOC_H_INCLUDED
#define _LIBALLOC_H_INCLUDED
#include "variety.h"
#include <malloc.h>

#ifdef __NETWARE__
    #define lib_malloc( x ) _NW_malloc( x )
    #define lib_free( x ) _NW_free( x )
    #define lib_realloc( x, y, z ) _NW_realloc( x, y, z )
    #define lib_calloc( x, y ) _NW_calloc( x, y )

//  #define lib_nmalloc( x ) _NW_malloc( x )
//  #define lib_nfree( x ) _NW_free( x )
//  #define lib_nrealloc( x, y ) _NW_realloc( x, y )

//  #define lib_fmalloc( x ) _NW_malloc( x )
//  #define lib_ffree( x ) _NW_free( x )
//  #define lib_frealloc( x, y ) _NW_realloc( x, y )


    extern void *_NW_calloc( size_t __n,size_t __size );
    extern void *_NW_malloc( size_t );
    extern void *_NW_realloc( void *ptr,size_t size,size_t old);
    extern void _NW_free( void *ptr );
#else
    #define lib_malloc( x ) malloc( x )
    #define lib_free( x ) free( x )
    #define lib_realloc( x, y ) realloc( x, y )

    #define lib_nmalloc( x ) _nmalloc( x )
    #define lib_nfree( x ) _nfree( x )
    #define lib_nrealloc( x, y ) _nrealloc( x, y )

    #define lib_fmalloc( x ) _fmalloc( x )
    #define lib_ffree( x ) _ffree( x )
    #define lib_frealloc( x, y ) _frealloc( x, y )

    #define lib_calloc( x, y ) calloc( x, y )
#endif

// these are used by the C++ library
// they are real routines so that the C++ library
// remains platform independent.
#ifdef __cplusplus
extern "C" {
#endif
_WCRTLINK extern void _plib_free( void *ptr );
_WCRTLINK extern void *_plib_malloc( size_t size );
#ifdef __cplusplus
}
#endif

#endif
