/*
	PDIV( n, d ) performs "n / d" properly,
	even on a Pentium with bad divide hardware.
*/
#ifndef _PDIV_H_INCLUDED
#define _PDIV_H_INCLUDED

#include "variety.h"

#if defined(_M_IX86)
  extern unsigned _WCNEAR __chipbug;
  extern double __fdiv_chk( double n, double d );
  #pragma aux __fdiv_chk "*" parm [8087] value [8087]

  #if defined( __SW_FPC ) || (__WATCOMC__ >= 1000)
    #define PDIV( n, d )	((n)/(d))
  #else
    #define PDIV( n, d )	((__chipbug&1)?__fdiv_chk(n,d):(n)/(d))
  #endif
#else
  #define PDIV( n, d )	((n)/(d))
#endif

#endif
