/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1995, by Watcom International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of Watcom International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ----		--		------
   23-feb-95	M.P.Hildebrand	Initial implementation.
   03-mar-95	M.P.Hildebrand	Added CHAR_TYPE, since OS/2 defines CHAR.
   14-mar-95	M. Hildebrand	Removed defines of CLIB internal names.
   27-nov-95	Greg Bentz	add _UNICODE and __UNICODE__ defines
   				make sure this header is included before
				system and compiler headers
*/
#ifndef _WIDECHAR_H_INCLUDED
#define _WIDECHAR_H_INCLUDED

#include "variety.h"
#include <stdlib.h>		/* for wchar_t and _atouni */

/*** Define some handy macros ***/
#ifdef __WIDECHAR__
    #define DIR_TYPE		struct _wdirent
    #define CHAR_TYPE		wchar_t
    #define UCHAR_TYPE		wchar_t
    #define NULLCHAR		0
    #define _AToUni(p1,p2)	_atouni(p1,p2)
    #define IS_ASCII(c)		( (c & 0xff00) == 0 )
    #define __F_NAME(n1,n2)	n2
    #define UNICODE
    #define _UNICODE
    #define __UNICODE__
#else
    #define DIR_TYPE		struct dirent
    #define CHAR_TYPE		char
    #define UCHAR_TYPE		unsigned char
    #define NULLCHAR		'\0'
    #define _AToUni(p1,p2)	(p2)
    #define IS_ASCII(c)		( 1 )
    #define __F_NAME(n1,n2)	n1
#endif
#define CHARSIZE		(sizeof( CHAR_TYPE ))

#endif
