;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1990 by WATCOM Systems Inc. All rights	   %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  Modified:	by:		reason:
;  ---------	---		-------
;  14-apr-90	F.W.Crigger	replacement for C version
;  20-mar-91	F.W.Crigger	traceable stack frames added with prolog/epilog
;  03-sep-91	J.B.Schueler	added __8087 xref
;  12-mar-95	Greg Bentz	remove _ from "C" symbols, wasm version check
;  29-aug-95    T. Schiller     Moved constant data into data segment since
;                               the emulated FLD instruction can't deal with
;                               it in the code segment in win32(s) systems
;  08-nov-96	Greg Bentz	handle special case for acos(1), acos(-1)
;
ifdef __386__
 include mdef.inc
 .387
else
 include mdef.inc
 .8087
endif
include struct.inc
include math387.inc

	xref		IF@DATAN2
	xref		__@DSQRT
	xref		__8087	; indicate that NDP instructions are present

	modstart	acos387

    if __WASM__ ge 100
	xdefp	"C",acos	; double acos( double x )
    else
	xdefp	<"C",acos>	; double acos( double x )
    endif


ifdef __386__
    datasegment
endif
piby2	dt	1.57079632679489661923
ifdef __386__
    enddata
endif

;
;	acos(x) = pi/2 - atan( x / sqrt( 1 - x*x ) );
;

	public	IF@DACOS	; double acos( double x )
	public	IF@ACOS 	; double acos( double x )
	defp	IF@DACOS
	defp	IF@ACOS
	push	ax
ifndef __386__
	prolog
	sub	sp,2		; for status word
endif
	fld	st(0)		; duplicate x
	fmul	st(0),st	; calc. x * x
	fld1			; 1.0
	fsubrp	st(1),st	; 1.0 - x * x
	ftst			; compare with 0.0
ifdef __386__
	fstsw	ax		;
else
	fstsw	word ptr -2[bp]
	fwait     
	mov	ax,word ptr -2[bp]
endif
	sahf			; if (1.0 - x * x) == 0.0
        _if     e		; then
	  fcompp		; - compare x with 0.0 (still on stack)
ifdef __386__
	  fstsw	ax		;
else
	  fstsw	word ptr -2[bp]
	  fwait     
	  mov	ax,word ptr -2[bp]
endif
	  sahf			; - if x > 0
	  _if 	be		; - then
	    fldz		; - - result is 0.0
	  _else			; - else
	    fldpi 		; - - result is pi
	  _endif		; - endif
	_else			; else
	  mov	AL,FUNC_ACOS	; - indicate ACOS function
	  call	__@DSQRT	; - calculate sqrt( 1.0 - x * x )
	  cmp	AL,0		; - if no error
	  _if	e		; - then
	    fxch st(1)		; - - flip arguments
;;;;	    fpatan		; - - atan( x / sqrt( 1.0 - x * x ) )
	    call IF@DATAN2	; - - atan2( x, sqrt( 1.0 - x * x ) );
	    fld	tbyte ptr piby2 ; - - load pi/2
	    fsubrp  st(1),st(0)	; - - compute arcos(x)=pi/2-arcsin(x)
	  _endif		; - endif
	_endif			; endif
ifndef __386__
	mov	sp,bp
	epilog
endif
	pop	ax
	ret			; return
	endproc IF@ACOS
	endproc IF@DACOS

;  input:	x - on the stack
;  output:	arccos of x in st(0)
;
	defp	acos
ifdef __386__
	fld	qword ptr 4[ESP]; load argument x
	call	IF@DACOS	; calculate acos(x)
	loadres 		; load result
else
if _MODEL and _BIG_CODE
argx	equ	6
else
argx	equ	4
endif
	prolog
	fld	qword ptr argx[BP]; load argument x
	call	IF@DACOS	; calculate acos(x)
	epilog
endif
	ret_pop 8		; return
	endproc acos

	endmod
	end
