;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1990 by WATCOM Systems Inc. All rights	   %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  Modified:	by:		reason:
;  ---------	---		-------
;  27-sep-90	F.W.Crigger	Initial implementation
;  03-sep-91	J.B.Schueler	added __8087 xref
;  26-jan-93	F.W.Crigger	treat -ve numbers as special case so that
;				we produce mathematically correct results
;				i.e. asinh(x) = - asinh( -x )
;  12-mar-95	Greg Bentz	remove _ from "C" symbols, wasm version check
;
ifdef __386__
 include mdef.inc
 .387
else
 include mdef.inc
 .8087
endif
include struct.inc
include math387.inc

	xref		__8087	; indicate that NDP instructions are present

	modstart	asinh387

    if __WASM__ ge 100
	xdefp	"C",asinh	; double asinh( double x )
    else
	xdefp	<"C",asinh>	; double asinh( double x )
    endif

;
;	asinh(x) = log(x + sqrt(x*x + 1.0)));
;	asinh(x) = - asinh( -x );
;

	public	IF@DASINH	; double asinh( double x )
	public	IF@ASINH	; double asinh( double x )
	defp	IF@DASINH
	defp	IF@ASINH
	prolog
	sub	_SP,16			; allocate space
	fst	qword ptr -16[_BP]	; make copy of argument
	fmul	st(0),st		; calc. x*x
	fld1				; 1.0
	faddp	st(1),st		; x*x + 1.0
	fsqrt				; sqrt( x*x + 1.0 )
	test	byte ptr -16+7[_BP],80h	; if x < 0.0
	_if	ne			; then
	  fsub	qword ptr -16[_BP]	; - sqrt( x*x + 1.0 ) - x
	  fldln2			; - load ln(2)
	  fxch	st(1)			; - get arguments in right order
	  fyl2x				; - calc. log( sqrt( x*x + 1.0 ) - x )
	  fchs				; - negate result
	_else				; else
	  fadd	qword ptr -16[_BP]	; - sqrt( x*x + 1.0 ) + x
	  fldln2			; - load ln(2)
	  fxch	st(1)			; - get arguments in right order
	  fyl2x				; - calc. log( x + sqrt( x*x + 1.0 ) )
	_endif				; endif
	mov	_SP,_BP 		; reset SP
	epilog				; epilog
	ret				; return
	endproc IF@ASINH
	endproc IF@DASINH


;  input:	x - on the stack
;  output:	asinh of x in st(0)
;
	defp	asinh
ifdef __386__
	fld	qword ptr 4[ESP]; load argument x
	call	IF@DASINH	; calculate asinh(x)
	loadres 		; load result
else
if _MODEL and _BIG_CODE
argx	equ	6
else
argx	equ	4
endif
	push	BP		; save BP
	mov	BP,SP		; get access to parms
	fld	qword ptr argx[BP]; load argument x
	call	IF@DASINH	; calculate asinh(x)
	pop	BP		; restore BP
endif
	ret_pop 8		; return
	endproc asinh

	endmod
	end
