;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1990 by WATCOM Systems Inc. All rights	   %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  Modified:	by:		reason:
;  ---------	---		-------
;  27-sep-90	F.W.Crigger	Initial implementation
;  20-mar-91	F.W.Crigger	traceable stack frames added with prolog/epilog
;  03-sep-91	J.B.Schueler	added __8087 xref
;----------------------------------------------------------Version 9.0-----
;  17-mar-92	F.W.Crigger	save/restore EDX for 3s model
;   8-oct-93	B.J. Stecher	divide of (1+x) by (1-x) was backwards
;  12-mar-95	Greg Bentz	remove _ from "C" symbols, wasm version check
;  29-aug-95    T. Schiller     Moved constant data into data segment since
;                               the emulated FLD instruction can't deal with
;                               it in the code segment in win32(s) systems
;
include mdef.inc
ifdef __386__
 .387
else
 .8087
endif
include struct.inc
include math387.inc

	extern_chipbug
    if __WASM__ ge 100
	xref	"C",__log87_err
    else
	xref	<"C",__log87_err>
    endif
	xref	__8087	; indicate that NDP instructions are present

	modstart    atanh387

    if __WASM__ ge 100
	xdefp	"C",atanh	; double atanh( double x )
    else
	xdefp	<"C",atanh>	; double atanh( double x )
    endif

;
;	atanh(x) = log( (1.0 + x) / (1.0 - x) ) / 2.0
;
ifdef __386__
    datasegment
endif
two	dw	2
ifdef __386__
    enddata
endif

	public	IF@DATANH	; double atanh( double x )
	public	IF@ATANH	; double atanh( double x )
	defp	IF@DATANH
	defp	IF@ATANH
	prolog
	fld1			; get 1.0
	fld	st(1)		; duplicate the number
	fabs			; get absolute value of number
	fcompp			; compare against 1.0
	sub	_SP,16		; allocate space
	fstsw	word ptr -16[_BP] ; get status word
	fwait			; ...
	mov	AH,-16+1[_BP]	; ...
	sahf			; set flags
	_if	ae		; if number is >= 1.0
	  mov	-16+12[_BP],_DX	; - save DX (-3s) clobbers EDX 17-mar-92
	  mov	AL,FUNC_ATANH	; - indicate "atanh"
	  mov	-16+8[_BP],_AX	; - push code
	  fstp	qword ptr -16[_BP]; - push argument on stack
	  call	__log87_err	; - log error
ifdef __386__
 ifdef __STACK__
	  push	EDX		; - load result into 8087
	  push	EAX		; - ...
	  fld	qword ptr 0[ESP]; - ...
	  mov	EDX,-16+12[EBP]	; - restore EDX 17-mar-92
	  fwait 		; - ...
 endif
endif
	_else			; else
	  fld1			; - 1.0
	  fsub	  st,st(1)	; - 1.0 - x
	  fld1			; - 1.0
	  faddp   st(2),st	; - 1.0 + x
	  do_fdivp 1,0		; - (1.0 + x) / (1.0 - x)
	  fldln2		; - load ln(2)
	  fxch	st(1)		; - get arguments in right order
	  fyl2x 		; - calc. log( (1.0 + x) / (1.0 - x) )
	  fidiv two		; - divide result by 2.0
	_endif			; endif
	mov	_SP,_BP 	; reset SP
	epilog
	ret			; return
	endproc IF@ATANH
	endproc IF@DATANH


;  input:	x - on the stack
;  output:	atanh of x in st(0)
;
	defp	atanh
ifdef __386__
	fld	qword ptr 4[ESP]; load argument x
	call	IF@DATANH	; calculate atanh(x)
	loadres 		; load result
else
if _MODEL and _BIG_CODE
argx	equ	6
else
argx	equ	4
endif
	prolog
	fld	qword ptr argx[BP]; load argument x
	call	IF@DATANH	; calculate atanh(x)
	epilog
endif
	ret_pop 8		; return
	endproc atanh

	endmod
	end
