;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;     interface to floating point library for trig functions
;
;  Modified:	By:		Reason:
;  18-apr-90	F.W.Crigger	new implementation for 387
;  19-may-90	F.W.Crigger	check for OVERFLOW
;  23-may-90	F.W.Crigger	Added __@DEXP1 to be used by tanh
;  13-feb-91	G.Coschi	in _@DEXP, allow large negative args
;				so you get zero as an answer, not overflow
;  20-mar-91	F.W.Crigger	traceable stack frames added with prolog/epilog
;  02-jul-91	J.B.Schueler	Added __387__ conditional
;  03-sep-91	J.B.Schueler	added __8087 xref
;  07-nov-91	John Dahms	add datasegment (chk387 macro uses DGROUP)
;----------------------------------------------------------Version 9.0-----
;  17-mar-92	F.W.Crigger	save/restore EDX for 3s model
;  12-oct-92	F.W.Crigger	check for large negative arguments on non 387
;  06-nov-92	F.W.Crigger	Must check for too small an argument because
;				387 returns NaN for -Infinity, we want 0.0
;  22-nov-93	Greg Bentz	change __387__ to __FPI87__ for WASM
;  03-mar-94	Greg Bentz	change dq to db for broken 9.5 wasm
;  12-mar-95	Greg Bentz	remove _ from "C" symbols, wasm version check
;  29-aug-95    T. Schiller     Moved constant data into data segment since
;                               the emulated FLD instruction can't deal with
;                               it in the code segment in win32(s) systems
;
ifdef __386__
 include mdef.inc
 .387
else
 include mdef.inc
 .8087
endif
include struct.inc
include math387.inc

    if __WASM__ ge 100
	xref	"C",__math87_err
    else
	xref	<"C",__math87_err>
    endif
	xref	__8087	; indicate that NDP instructions are present

	modstart    exp387

	;datasegment
	;enddata

    if __WASM__ ge 100
	xdefp	"C",exp		; calc exp(fac1)
    else
	xdefp	<"C",exp>	; calc exp(fac1)
    endif

ifndef __386__
if _MODEL and _BIG_CODE
argx	equ	6
else
argx	equ	4
endif
endif

ifdef __386__
    datasegment
endif
MaxExpVal dq	709.7827128933839
;MaxExpVal DB	0eeH,39H,0faH,0feH,42H,2eH,86H,040H
MinExpVal dq	-709.7827128933839
;MinExpVal DB	0eeH,39H,0faH,0feH,42H,2eH,86H,0c0H
ifdef __386__
    enddata
endif

	public	__@DEXP1
	defp	__@DEXP1		; calc. exp(x) with no check
	prolog
	sub	_SP,16			; allocate space
	jmp	short calc_exp		; go calculate exp(x)
	endproc __@DEXP1

	public	IF@EXP
	public	IF@DEXP
	defp	IF@DEXP
	defp	IF@EXP

;	calculate exp(st(0)) using 387
	mov	AL,FUNC_EXP		; indicate exp function

	public	__@DEXP
	defp	__@DEXP
	prolog
	sub	_SP,16			; allocate space
	fcom	qword ptr MaxExpVal	; compare with largest valid argument
	fstsw	word ptr -16+0[_BP]	; get status
	fwait				; wait for it
	mov	AH,-16+1[_BP]		; get status word
	sahf				; set flags
	_if	a			; if number is too large
	  cmp	AL,FUNC_POW		; - if not "pow" function
	  _if	ne			; - then
	    fstp  qword ptr -16+0[_BP]	; - - push argument on stack
	    mov   -16+8[_BP],_AX	; - - set func code
 	    mov	  -16+12[_BP],_DX	; - - save DX (-3s) clobbers EDX 17-mar-92
	    call  __math87_err 	; - - error (func code in AL)
ifdef __386__
 ifdef __STACK__
	    push  EDX			; - - load result into 8087
	    push  EAX			; - - ...
	    fld   qword ptr 0[ESP]	; - - ...
	    mov	  EDX,-16+12[EBP]	; - - restore EDX 17-mar-92
	    fwait			; - - ...
 endif
endif
	  _endif			; - endif
	  mov	AL,1			; - indicate error
	  mov	_SP,_BP 		; - reset stack pointer
	  epilog
	  ret				; - return
	_endif				; endif
calc_exp:
	  _guess 			; - guess: argument too small
	    fcom  qword ptr MinExpVal	; - - compare with smallest valid arg
	    fstsw word ptr -16+0[_BP]	; - - get status
	    fwait			; - - wait for it
	    mov   AH,-16+1[_BP]		; - - get status word
	    sahf			; - - set flags
	    _quif a			; - - quit if number is not too small
	    fldz			; - - set result to 0.0
	  _admit			; - guess: 387
ifndef __FPI87__
	    chk387
	    _quif  ne			; - - quit if not 387
endif					; __FPI87__
	    fldl2e			; - - load log2(e)
	    fmulp   st(1),st(0)		; - - calculate argument * log2(e)
	    fld     st(0)		; - - duplicate fac1
	    frndint			; - - round to an integer
	    fxch    st(1)		; - - flip around
	    fsub    st,st(1)		; - - calc. x - int(x)
	    f2xm1			; - - calc. 2 ** ( x - int(x) )
	    fld1			; - - load 1.0
	    faddp   st(1),st(0) 	; - - add 1 to result
	    fscale			; - - multiply by 2 ** int(x)
ifndef __FPI87__
	  _admit			; - admit: argument in valid range
	    fldl2e			; - - load log2(e)
	    fmulp   st(1),st(0)		; - - calculate argument * log2(e)
	    fld1			; - - load -1 for dividing by 2
	    fchs			; - - ...
	    fld   st(1) 		; - - duplicate x
	    fstcw word ptr -16+0[_BP]	; - - save control word
	    fwait			; - - wait
	    mov   AL,-16+1[_BP] 	; - - save it
	    and   byte ptr -16+1[_BP],0F3h; - - mask out rounding control bits
	    or	  byte ptr -16+1[_BP],04h ; - - set to round down to - infinity
	    fldcw word ptr -16+0[_BP]	; - - load new control word
	    frndint			; - - round to an integer
	    mov   -16+1[_BP],AL 	; - - set original control word
	    fldcw word ptr -16+0[_BP]	; - - restore original control word
	    fxch  st(2) 		; - - exchange int(x) with x
	    fsub  st,st(2)		; - - calc. x - int(x)
	    fscale			; - - divide by 2
	    f2xm1			; - - calc 2 ** x
	    fsubrp st(1),st		; - - subtract -1 (or add 1)
	    fmul  st,st(0)		; - - square the result
	    fscale			; - - multiply by 2 ** int(x)
endif					; __FPI87__
	  _endguess			; - endguess
	  fstp  st(1)			; - copy answer up
	  mov	AL,0			; - indicate no error
	mov	_SP,_BP 		; reset stack pointer
	epilog
	ret				; return
	endproc __@DEXP
	endproc IF@EXP
	endproc IF@DEXP


	defp	exp
ifdef __386__
	fld	qword ptr 4[ESP]; load argument x
	call	IF@DEXP 	; calculate exp(x)
	loadres 		; load result
else
	prolog
	fld	qword ptr argx[BP]; load argument x
	call	IF@DEXP 	; calculate exp(x)
	epilog
endif
	ret_pop 8		; return
	endproc exp

	endmod
	end
