;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1990 by WATCOM Systems Inc. All rights	   %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  Name:	CHOP
;  Operation:	chop float in ST(0) towards 0
;  Inputs:	ST(0)	float
;  Outputs:	ST(0)	chopped float, condition codes unmodified
;  Volatile:	none
;
;  Modified:	by:		reason:
;  ---------	---		-------
;  07-jan-87	John Dahms	Initial implementation
;  10-mar-89	F.W.Crigger	Adapted for 386
;  26-jul-90	F.W.Crigger	Modified so that condition codes not changed
;  10-dec-90	F.W.Crigger	changed "wait" to "fwait" for /fpi option
;  03-sep-91	J.B.Schueler	added __8087 xref
;  20-nov-91	F.W.Crigger	optimized 386 sequence
;  26-apr-92	F.W.Crigger	Condition codes were being modified in 386
;
ifdef __386__
 include mdef.inc
 .386
 .387
else
 include mdef.inc
 .8087
endif
include math387.inc

	xref		__8087	; indicate that NDP instructions are present

	modstart fchop

	xdefp	__CHP

	defp	__CHP
ifdef __386__
	push	EAX			; allocate temporary
	fstcw	word ptr [ESP] 		; get 8087 control word
	fwait				; wait until store complete
	push	dword ptr [ESP]		; remember old control word
	mov	byte ptr 1[ESP],1Fh	; set control word to truncate
	fldcw	word ptr [ESP] 		; load new control word
	frndint 			; truncate top of stack
	fldcw	word ptr 4[ESP] 	; restore old control word
	fwait				; wait until load complete
	lea	ESP,8[ESP]		; remove temporaries
else
	push	_AX			; save a register
	push	_BP			; allocate 2 bytes on stack
	mov	_BP,_SP 		; get access to stack
	push	_AX			; allocate temporary
	fstcw	-2[_BP] 		; get 8087 control word
	fwait				; wait until store complete
	mov	AX,-2[_BP]		; remember old control word
	mov	byte ptr -1[_BP],1Fh	; set control word to truncate
	fldcw	-2[_BP] 		; load new control word
	frndint 			; truncate top of stack
	mov	-2[_BP],AX		; restore old 8087 control word
	fldcw	-2[_BP] 		; ...
	fwait				; wait until load complete
	mov	_SP,_BP 		; remove temporary
	pop	_BP			; restore BP
	pop	_AX			; restore AX
endif
	ret				; return
	endproc __CHP

	endmod
	end
