;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1985,1986 by WATCOM Systems Inc. All rights %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  Modified:	By:		Reason:
;  18-apr-90	F.W.Crigger	split out into separate module
;  10-may-90	F.W.Crigger	check for bad argument
;  27-sep-90	F.W.Crigger	log2 entry point added
;  20-mar-91	F.W.Crigger	traceable stack frames added with prolog/epilog
;  03-sep-91	J.B.Schueler	added __8087 xref
;----------------------------------------------------------Version 9.0-----
;  17-mar-92	F.W.Crigger	save/restore EDX for 3s model
;  12-mar-95	Greg Bentz	remove _ from "C" symbols, wasm version check
;
ifdef __386__
 include mdef.inc
 .387
else
 include mdef.inc
 .8087
endif
include struct.inc
include math387.inc

    if __WASM__ ge 100
	xref	"C",__log87_err
    else
	xref	<"C",__log87_err>
    endif
	xref	__8087	; indicate that NDP instructions are present

	modstart    log387

    if __WASM__ ge 100
	xdefp	"C",log		; calc log(fac1)
	xdefp	"C",log2	; calc log2(fac1)
	xdefp	"C",log10	; calc log10(fac1)
    else
	xdefp	<"C",log>	; calc log(fac1)
	xdefp	<"C",log2>	; calc log2(fac1)
	xdefp	<"C",log10>	; calc log10(fac1)
    endif

ifndef __386__
	if _MODEL and _BIG_CODE
	 argx	 equ	 6
	else
	 argx	 equ	 4
	endif
endif


	public	IF@LOG
	public	IF@DLOG
	defp	IF@DLOG
	defp	IF@LOG

	mov	AL,FUNC_LOG		; indicate log

do_log:
	ftst				; test sign of argument
	prolog
	sub	_SP,16			; allocate space
	fstsw	word ptr -16[_BP]	; get status word
	fwait				; ...
	mov	AH,-16+1[_BP]		; ...
	sahf				; set flags
	_if	be			; if number is <= 0.0
	  mov	-16+8[_BP],_AX		; - push code
	  fstp	qword ptr -16[_BP]	; - push argument on stack
	  mov	-16+12[_BP],_DX		; - save DX (-3s) clobbers EDX 17-mar-92
	  call	__log87_err		; - log error
ifdef __386__
 ifdef __STACK__
	  push	EDX			; - load result into 8087
	  push	EAX			; - ...
	  fld	qword ptr 0[ESP]	; - ...
	  mov	EDX,-16+12[EBP]		; - restore EDX 17-mar-92
	  fwait 			; - ...
 endif
endif
	  mov	AL,1			; - indicate error
	_else				; else
	  cmp	AL,FUNC_LOG10		; - if "log10"
	  _if	e			; - then
	    fldlg2			; - - load log10(2)
	  _else 			; - else
	    cmp   AL,FUNC_LOG2		; - - if "log2"
	    _if   e			; - - then
	      fld1			; - - - load 1.0
	    _else			; - - else
	      fldln2			; - - - load ln(2)
	    _endif			; - - endif
	  _endif			; - endif
	  fxch	st(1)			; - get arguments in right order
	  fyl2x 			; - ln(x) = ln(2) * log2(x)
	  mov	AL,0			; - indicate success
	_endif				; endif
	mov	_SP,_BP 		; reset SP
	epilog
	ret				; return
	endproc IF@LOG
	endproc IF@DLOG


	public	IF@LOG2
	public	IF@DLOG2
	defp	IF@DLOG2
	defp	IF@LOG2
	mov	AL,FUNC_LOG2		; indicate log2
	jmp	do_log			; calculate log2
	endproc IF@LOG2
	endproc IF@DLOG2


	public	IF@LOG10
	public	IF@DLOG10
	defp	IF@DLOG10
	defp	IF@LOG10
	mov	AL,FUNC_LOG10		; indicate log10
	jmp	do_log			; calculate log10
	endproc IF@LOG10
	endproc IF@DLOG10


	defp	log
ifdef __386__
	fld	qword ptr 4[ESP]	; load argument
	call	IF@DLOG 		; calculate log(x)
	loadres 			; load result
else
	prolog
	fld	qword ptr argx[BP]	; load argument
	call	IF@DLOG 		; calculate log(x)
	epilog
endif
	ret_pop 8			; return
	endproc log

	defp	log10
ifdef __386__
	fld	qword ptr 4[ESP]	; load argument
	call	IF@DLOG10		; calculate log10(x)
	loadres 			; load result
else
	prolog
	fld	qword ptr argx[BP]	; load argument
	call	IF@DLOG10		; calculate log10(x)
	epilog
endif
	ret_pop 8			; return
	endproc log10


	defp	log2
ifdef __386__
	fld	qword ptr 4[ESP]	; load argument
	call	IF@DLOG2		; calculate log2(x)
	loadres 			; load result
else
	prolog
	fld	qword ptr argx[BP]	; load argument
	call	IF@DLOG2		; calculate log2(x)
	epilog
endif
	ret_pop 8			; return
	endproc log2

	endmod
	end
