;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1986,1991 by WATCOM Systems Inc. All rights %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  Modified:	by:		reason:
;  ---------	---		-------
;  12-oct-87	F.W.Crigger	initial implementation for C Library
;  10-feb-88	F.W.Crigger	correct implementation
;  10-feb-88	John Dahms	store into iptr as double not single
;  13-mar-89	F.W.Crigger	Adapted for 386
;  12-jun-89	F.W.Crigger	Adapted for /3s option
;  03-sep-91	J.B.Schueler	added __8087 xref
;  12-mar-95	Greg Bentz	remove _ from "C" symbols, wasm version check
;
ifdef __386__
 include mdef.inc
 .387
else
 include mdef.inc
 .8087
endif
include math387.inc

	xref		__CHP
	xref		__8087	; indicate that NDP instructions are present

	modstart	modf387

    if __WASM__ ge 100
	xdefp	"C",modf	; double modf( double x, double *iptr )
    else
	xdefp	<"C",modf>	; double modf( double x, double *iptr )
    endif

;  input:	x - on the stack
;		iptr on the stack
;  output:	signed fractional part of x in EDX:EAX
;		*iptr gets the integer part of x
;
	defp	modf
ifdef __386__
	push	EAX		; save EAX
	fld	qword ptr 8[ESP]; load x
	fld	st(0)		; duplicate it
	call	__CHP		; calculate integer part
	fsub	st(1),st(0)	; subtract integer part from x
	mov	EAX,16[ESP]	; get iptr
	fstp	qword ptr [EAX] ; store integer part
	pop	EAX		; restore EAX
	loadres 		; load result
	fwait			; wait
	ret_pop 12		; return
else
	if _MODEL and _BIG_CODE
	 argx	 equ	 6
	else
	 argx	 equ	 4
	endif
	iptr	equ	argx+8

	push	BP		; save BP
	mov	BP,SP		; get access to parms
	push	BX		; save BX
if _MODEL and (_BIG_DATA or _HUGE_DATA)
	push	DS		; save DS
	lds	BX,iptr[BP]	; get segment and offset of iptr
	popamt	equ	8+4
else
	mov	BX,iptr[BP]	; get iptr
	popamt	equ	8+2
endif
	fld	qword ptr argx[BP]; load argument
	fld	st(0)		; dup x
	docall	__CHP		; calculate integer part
	fsub	st(1),st(0)	; subtract integer part from x
	fstp	qword ptr [bx]	; store integer part
if _MODEL and (_BIG_DATA or _HUGE_DATA)
	pop	DS		; restore DS
endif
	pop	BX		; restore BX
	fwait			; wait
	pop	BP		; restore BP
	ret	popamt		; return
endif
	endproc modf

	endmod
	end
