;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%	 Copyright (C) 1994 by WATCOM Systems Inc. All rights	   %
;%	 reserved. No part of this software may be reproduced	   %
;%	 in any form or by any means - graphic, electronic or	   %
;%	 mechanical, including photocopying, recording, taping	   %
;%	 or information storage and retrieval systems - except	   %
;%	 with the written permission of WATCOM Systems Inc.	   %
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;  Name:	__LDI4
;  Operation:	convert float in ST(0) to 32-bit integer
;  Inputs:	ST(0)	float
;  Outputs:	EAX	32-bit
;		DX:AX	16-bit
;  Volatile:	none
;
;  Modified:	by:		reason:
;  ---------	---		-------
;  07-jan-87	John Dahms	Initial implementation
;  10-mar-89	F.W.Crigger	Adapted for 386
;  26-jul-90	F.W.Crigger	Modified so that condition codes not changed
;  10-dec-90	F.W.Crigger	changed "wait" to "fwait" for /fpi option
;  03-sep-91	J.B.Schueler	added __8087 xref
;  20-nov-91	F.W.Crigger	optimized 386 sequence
;  26-apr-92	F.W.Crigger	Condition codes were being modified in 386
;  26-jul-94	F.W.Crigger	Adapted from fchop.asm
;
ifdef __386__
 include mdef.inc
 .386
 .387
else
 include mdef.inc
 .8087
endif
include math387.inc

	xref		__8087	; indicate that NDP instructions are present

	modstart __LDI4

	xdefp	__LDI4
	xdefp	__LDI4_

	defp	__LDI4
	defp	__LDI4_
ifdef __386__
	push	EAX			; allocate temporary
	fstcw	word ptr [ESP] 		; get 8087 control word
	fwait				; wait until store complete
	push	dword ptr [ESP]		; remember old control word
	mov	byte ptr 4+1[ESP],1Fh	; set control word to truncate
	fldcw	word ptr 4[ESP]		; load new control word
	fistp	dword ptr 4[ESP]	; store value as integer
	fldcw	word ptr [ESP]	 	; restore old control word
	fwait				; wait until load complete
	pop	EAX			; remove control word
	pop	EAX			; retrieve value
else
	push	_BP			; allocate 2 bytes on stack
	mov	_BP,_SP 		; get access to stack
	push	_AX			; allocate temporary
	push	_AX			; allocate temporary
	push	_AX			; allocate temporary
	fstcw	-6[_BP] 		; get 8087 control word
	fwait				; wait until store complete
	mov	AX,-6[_BP]		; remember old control word
	mov	byte ptr -5[_BP],1Fh	; set control word to truncate
	fldcw	-6[_BP] 		; load new control word
	fistp	dword ptr -4[_BP]	; store value as 32-bit integer
	mov	-6[_BP],AX		; restore old 8087 control word
	fldcw	-6[_BP] 		; ...
	fwait				; wait until load complete
	pop	_AX			; remove control word
	pop	_AX			; load 32-bit integer value
	pop	_DX			; ...
	pop	_BP			; restore BP
endif
	ret				; return
	endproc __LDI4_
	endproc __LDI4

	endmod
	end
