/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  01-oct-86     F.W.Crigger     Translated to WSL
  16-jan-87     A.J.Stein       Converted from WSL to C
  24-aug-87     F.W.Crigger     Exception handling added.
--------------------------------------------------------------Version 8.0-----
  20-dec-90     F.W.Crigger     IF@DACOS entry added
  91-jan-04     John Dahms      Made IF@ routines conform to new code generator
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	Greg Bentz	modify name of IF@ functions for alpha
  28-may-96	Greg Bentz	fixup _IF_ function modifiers
*/
#include "variety.h"
#include <stddef.h>
#include <math.h>
#include "pi.h"
#include "ifprag.h"
#include "mathcode.h"
#include "pdiv.h"


_WMRTLINK extern double _IF_dacos( double );
#if defined(_M_IX86)
 #pragma aux (if_rtn) _IF_acos "IF@ACOS";
 #pragma aux (if_rtn) _IF_dacos "IF@DACOS";
#endif

_WMRTLINK float _IF_acos( float x )
/*********************/
    {
        return( _IF_dacos( x ) );
    }

_WMRTLINK double (acos)( double x )
/***********************/
    {
        return( _IF_dacos( x ) );
    }

_WMRTLINK double _IF_dacos( double x )
/*************************/
    {
        auto double     z;

        z =  1.0 - x * x;
        if( z < 0.0 ) {
//            z = _matherr( DOMAIN, "acos", &x, &x, 0.0 );
            z = __math1err( FUNC_ACOS | M_DOMAIN | V_ZERO, &x );
        } else if( z == 0.0 ) {
            if( x < 0.0 ) {
                z = Pi;
            } else {
                z = 0.0;
            }
        } else {
            z = Piby2 - atan( PDIV( x , sqrt( z ) ) );
        }
        return( z );
    }
