/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  27-sep-90     F.W.Crigger     Initial implementation
--------------------------------------------------------------Version 8.0-----
  20-dec-90     F.W.Crigger     IF@DACOSH entry added
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
*/
#include "variety.h"
#include <stddef.h>
#include <math.h>
#include "mathcode.h"

//      acosh(x) = log( x + sqrt(x*x - 1.0) );

#if defined(_M_IX86)
  #pragma aux __acosh "IF@DACOSH";
#endif
_WMRTLINK double __acosh( double x )
    {
        return( acosh( x ) );
    }

_WMRTLINK double acosh( double x )
/**********************/
    {
        double  z;

        if( x < 1.0 ) {
//            z = _matherr( DOMAIN, "acosh", &x, &x, -HUGE_VAL );
            z = __math1err( FUNC_ACOSH | M_DOMAIN | V_NEG_HUGEVAL, &x );
        } else {
            z = log( x + sqrt( x*x - 1.0 ) );
        }
        return( z );
    }
