/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  27-sep-90     F.W.Crigger     Initial implementation
  20-dec-90     F.W.Crigger     IF@DATANH entry added
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
*/
#include "variety.h"
#include <math.h>
#include "mathcode.h"
#include "pdiv.h"

//      atanh(x) = log( (1.0 + x) / (1.0 - x) ) / 2.0;

#if defined(_M_IX86)
  #pragma aux __atanh "IF@DATANH";
#endif

_WMRTLINK double __atanh( double x )
    {
        return( atanh( x ) );
    }

_WMRTLINK double atanh( double x )
/**********************/
    {
        double  z;

        if( fabs(x) >= 1.0 ) {
//            z = _matherr( DOMAIN, "atanh", &x, &x, -HUGE_VAL );
            z = __math1err( FUNC_ATANH | M_DOMAIN | V_NEG_HUGEVAL, &x );
        } else {
            z = log( PDIV( (1.0 + x) , (1.0 - x) ) ) / 2.0;
        }
        return( z );
    }
