/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  01-oct-86     F.W.Crigger     Initial implementation in WSL
  16-jan-87     A.J.Stein       Converted from WSL to C
  24-aug-87     F.W.Crigger     Exception handling added
-----------------------------------------------------------Version 6.5------
  21-jul-88     F.W.Crigger     check for small values of x
--------------------------------------------------------------Version 8.0-----
  20-dec-90     F.W.Crigger     IF@DCOSH entry added
  04-jan-91     John Dahms      Made IF@ routines conform to new code generator
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	Greg Bentz	modify name of IF@ functions for alpha
  28-may-96	Greg Bentz	fixup _IF_ function modifiers
*/
#include "variety.h"
#include <stddef.h>
#include <math.h>
#include "ifprag.h"
#include "mathcode.h"
#include "pdiv.h"

_WMRTLINK extern double _IF_dcosh( double );

#if defined(_M_IX86)
  #pragma aux (if_rtn) _IF_cosh "IF@COSH";
  #pragma aux (if_rtn) _IF_dcosh "IF@DCOSH";
#endif

_WMRTLINK float _IF_cosh( float x )
/*********************/
    {
        return( _IF_dcosh( x ) );
    }

_WMRTLINK double (cosh)( double x )
/***********************/
    {
        return( _IF_dcosh( x ) );
    }

_WMRTLINK double _IF_dcosh( double x )
/*************************/
    {
        double z;

        z = fabs( x );
        if( z > 709.782712893384 ) {            /* if argument is too large */
//            z = _matherr( OVERFLOW, "cosh", &x, &x, HUGE_VAL );
            z = __math1err( FUNC_COSH | M_OVERFLOW | V_HUGEVAL, &x );
        } else {
/*          if( z <= ldexp( 1.0, -26 ) ) { */
            if( z <= 1.49011611938476580e-008 ) { /* if x is small */
                z = 1.0;
            } else {
                z = exp( x );
                z = (z + PDIV( 1.0 , z) ) / 2.0;
            }
        }
        return( z );
    }
