/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  10-mar-88     F.W.Crigger     Initial implementation
  25-may-90     F.W.Crigger     moved --ndigits to fix 0.0 format problem
  20-jun-90     F.W.Crigger     set ndigits to 0 instead of 1 if -ve
  13-aug-90     F.W.Crigger     don't set ndigits to 1, (affects 'F' format)
  05-mar-91     F.W.Crigger     Check for Nan or Infinity
  18-mar-91     F.W.Crigger     return ndigits worth of 0's for 0.0 in 'F' fmt
  18-mar-91     F.W.Crigger     Pass "char *" instead of "char near *" to __cvt
  05-aug-91	F.W.Crigger	Only look for +ve adjustment after 2'nd _Scale
  				This fixes the 1e-5 problem.(adjustment was -1)
  29-aug-92	B.J. Stecher	got rid of some pointer trunc warnings.
  30-jun-93	F.W.Crigger	Check for integral values
  				Changed SIG_DIGITS from 18 to 16
  23-nov-93	F.W.Crigger	allow ndigits to be 17 for 1E300
  28-jun-94	F.W.Crigger	modified to support long doubles
  09-mar-95	F.W.Crigger	support both doubles and long doubles
--------------------------------------------------------Version-11.0---------
  28-apr-95	Greg Bentz	variety.h for near/far and composite macros
  19-may-95	F.W.Crigger	newer version of __LDcvt
  06-jun-95	Greg Bentz	dll linkage
  22-jun-95	F.W.Crigger	set cvt.scale to 0 for F_FMT
*/
#include "variety.h"
#include <stdio.h>
#include <string.h>
#include "xfloat.h"


char *__cvt( double value,
             int    ndigits,
             int    *dec,
             int    *sign,
             int    fmt,
             char   *buf )
{
    CVT_INFO	cvt;
    long_double	ld;
#ifdef _LONG_DOUBLE_
    double	double_value;

    /* convert this double into a long double */
    double_value = value;
    __iFDLD( (double _WCNEAR *)&double_value, (long_double _WCNEAR *)&ld );
#else
    ld.value = value;
#endif
    if( fmt == 'F' ) {		// fcvt passes in 'F'
	cvt.flags = F_FMT + F_CVT;
	cvt.scale = 0;
    } else {			// ecvt passes in 'G'
	cvt.flags = G_FMT + F_CVT;
	cvt.scale = 1;
    }
    cvt.ndigits = ndigits;
    cvt.expwidth = 0;
    cvt.expchar  = fmt;
    __LDcvt( &ld, &cvt, buf );
    *dec = cvt.decimal_place;
    *sign = cvt.sign;
    return( buf );
}
