/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  

 DIVC32          : complex division runtime routine

  Date		By		Reason
  ----		--		------
  93/09/23	Alex Brodsky	Initial implementation.
  94/04/08	Kevin Hui	merge C++ and Fortran Complex support
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  26-sep-95	Greg Bentz	intrinsic support for alpha
*/
#include "variety.h"
#include "cplx.h"
#include "pdiv.h"

_WMRTLINK xcomplex _IF_C32Div( extended a, extended b, extended c, extended d ) {
//==============================================================================

// Divide two extended precision complex numbers and return the
// imaginary part of the result.
// ( a, b )/( c, d ) = (( a, b )/( d + c*c/d )) * ( c/d, -1 )

    extended      quo;
    extended      tmp;
    xcomplex    res;

    if( fabs( d ) < fabs( c ) ) {
        tmp = a;        // convert to (-b,a)/(-d,c)
        a = - b;
        b = tmp;
        tmp = c;
        c = -d;
        d = tmp;
    }
    quo = PDIV( c , d );
    tmp = quo * c + d;
    a = PDIV( a, tmp );
    b = PDIV( b, tmp );
    c = quo;
    res.realpart = a * c + b;
    res.imagpart = b * c - a;
    return( res );
}
