/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  10-mar-88	F.W.Crigger	Initial implementation
  18-mar-91	F.W.Crigger	Pass "char *" instead of "char near *" to __cvt
  10-jul-92	D. Wellstood	Unicode Support
  26-oct-92	J.B.Schueler	Added dynamic allocation for cvt buffer
  23-nov-92	F.W.Crigger	Moved cvt buffer to cvtbuf.c in CLIB
  15-dec-93	Greg Bentz	fixup result of __cvt() have trailing zeros
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  20-may-96	Greg Bentz	remove aliased symbols
*/

#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <float.h>

extern	CHAR_TYPE *__CVTBuffer();
extern	char *__cvt( double, int, int *, int *, int, char * );

// LDBL_DIG + decimal point + 'e' + exponent (what about '\0'?)
#define MaxPrec	(LDBL_DIG+1+1+3)

static char *fixup( char *p, int n )
{
    char *start = p;
    if( n < MaxPrec && isdigit( *p ) ) {
	while( *p ) {
	    p++;
	    n--;
	}
	while( n > 0 ) {
	    *p++ = '0';
	    n--;
	}
	*p = '\0';
    }
    return( start );
}

_WMRTLINK CHAR_TYPE *__F_NAME(ecvt,_wecvt)(double value,int ndigits, int *dec, int *sign )
{
    /* ndigits represents the number of significant digits */
    CHAR_TYPE	*buf;

    buf = __CVTBuffer();
    buf = (CHAR_TYPE *)__cvt( value, ndigits, dec, sign, 'G', (char *)buf );
    return( _AToUni( buf, fixup( (char *)buf, ndigits ) ) );
}

_WMRTLINK CHAR_TYPE *__F_NAME(fcvt,_wfcvt)(double value,int ndigits, int *dec, int *sign )
{
    /* ndigits represents the number of decimal places */
    CHAR_TYPE	*buf;

    buf = __CVTBuffer();
    buf = (CHAR_TYPE *)__cvt( value, ndigits, dec, sign, 'F', (char *)buf );
    return( _AToUni( buf, fixup( (char *)buf, ndigits+(*dec) ) ) );
}
