/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  18-oct-86     F.W.Crigger     Initial implementation in WSL
  16-jan-87     A.J.Stein       Converted from WSL to C
------------------------------------------------------------Version 6.0------
  11-may-88     F.W.Crigger     Added code to perform scaled subtractions
------------------------------------------------------------Version 7.0------
  24-mar-89     F.W.Crigger     Use the __fprem routine to calculate answer
  91-jan-04     John Dahms      Made IF@ routines conform to new code generator
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	Greg Bentz	modify name of IF@ functions for alpha
  28-may-96	Greg Bentz	fixup _IF_ function modifiers
*/
#include "variety.h"
#include <math.h>
#include <ifprag.h>

extern  void __fprem( double x, double y, int *quot, double *rem );
#if defined(_M_IX86)
  #pragma aux  __fprem "*_" parm [];
#endif

/*  The fmod function computes the floating-point remainder of x/y.
    It returns x if y is 0, otherwise it returns the value f that has
    the same sign as x, such that x == i*y + f for some integer i,
    where the magnitude of f is less than the magnitude of y.
*/

_WMRTLINK extern double _IF_dfmod( double, double );
#if defined(_M_IX86)
  #pragma aux (if_rtn) _IF_fmod "IF@FMOD";
  #pragma aux (if_rtn) _IF_dfmod "IF@DFMOD";
#endif

_WMRTLINK float _IF_fmod( float x, float y )
/********************************/
    {
        return( _IF_dfmod( x, y ) );
    }
    
_WMRTLINK double (fmod)( double x, double y )
/*********************************/
    {
        return( _IF_dfmod( x, y ) );
    }
    
_WMRTLINK double _IF_dfmod( double x, double y )
/***********************************/
    {
        auto int quot;
        auto double rem;

	__fprem( x, y, &quot, &rem );
        return( rem );
    }

