/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1988, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  10-mar-88     F.W.Crigger     Initial implementation
  05-mar-91     F.W.Crigger     Check for Nan or Infinity
  18-mar-91     F.W.Crigger     Pass "char *" instead of "char near *" to __cvt
  02-may-91	F.W.Crigger	Handle -0.0 so log10 doesn't get error
  19-nov-91	F.W.Crigger	adjust exponent if log10(value) >= 0
  14-jul-92	D. Wellstood	added _ugcvt
  25-feb-94	Greg Bentz	added _gcvt
  26-jun-94	F.W.Crigger	modified for support for long doubles
  09-mar-95	F.W.Crigger	support both doubles and long doubles
--------------------------------------------------------Version-11.0---------
  28-apr-95	Greg Bentz	variety.h for near/far and composite macros
  19-may-95	F.W.Crigger	newer version of __LDcvt
  06-jun-95	Greg Bentz	dll linkage
  27-nov-95	Alex Brodsky	Make use of the NO_TRUNC flag for required
  				precision (that LSB is important :).
  28-nov-95	Greg Bentz	add __gcvt() to ease version issues
  20-may-96	Greg Bentz	remove aliased symbols
*/
#include "variety.h"
#include "widechar.h"
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "xfloat.h"

#if defined(__WIDECHAR__)
_WMRTLINK CHAR_TYPE *_wgcvt( double value, int digits, CHAR_TYPE *buf )
{
    gcvt( value, digits, (char *)buf );
    return( _atouni( buf, (char *)buf ) );
}
#else
_WMRTLINK char *gcvt( double value, int digits, char *buf )
{
    int		i;
    CVT_INFO	cvt;
    long_double	ld;
    auto char	stkbuf[64];	// See comment in LDCVT.c regarding stkbuf size
#ifdef _LONG_DOUBLE_
    double	double_value;

    /* convert this double into a long double */
    double_value = value;
    __iFDLD( (double _WCNEAR *)&double_value, (long_double _WCNEAR *)&ld );
#else
    ld.value = value;
#endif
    cvt.ndigits = digits;
    cvt.flags = G_FMT | NO_TRUNC;
    cvt.scale = 1;
    cvt.expwidth = 0;
    cvt.expchar  = 'E';
    __LDcvt( &ld, &cvt, stkbuf );
    i = 0;
    if( cvt.sign < 0 )  buf[i++] = '-';
    if( cvt.n1 != 0 ) {
	memcpy( &buf[i], &stkbuf[0], cvt.n1 );
	i += cvt.n1;
    }
    memset( &buf[i], '0', cvt.nz1 );
    i += cvt.nz1;
    if( cvt.n2 != 0 ) {
	memcpy( &buf[i], &stkbuf[cvt.n1], cvt.n2 );
	i += cvt.n2;
    }
    buf[i] = '\0';
    return( buf );
}
#endif
