/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  

 IFCDABS      : absolute value for COMPLEX*16 argument

  Date		By		Reason
  ----		--		------
  88/01/14	G. Coschi	initial implementation
  94/04/08	Kevin Hui	merge C++ and Fortran Complex support
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  26-sep-95	Greg Bentz	intrinsic support for alpha
*/
#include "variety.h"
#include "cplx.h"
#include "pdiv.h"

_WMRTLINK double _IF_CDABS( double rp, double ip ) {
//=================================================

// Return the absolute value of arg.

    rp = fabs( rp );
    ip = fabs( ip );
    if( rp > ip ) {
        ip = PDIV( ip , rp );
        return( rp * sqrt( 1.0 + ip * ip ) );
    } else if( ip == 0.0 ) {
        return( rp );
    } else {
        rp = PDIV( rp , ip );
        return( ip * sqrt( 1.0 + rp * rp ) );
    }
}
