/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  

 IFCDLOG	: logarithm function for COMPLEX*16 argument

  Date		By		Reason
  ----		--		------
  88/01/14	G. Coschi	initial implementation
  94/04/08	Kevin Hui	merge C++ and Fortran Complex support
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  26-sep-95	Greg Bentz	intrinsic support for alpha
*/
#include "variety.h"
#include "cplx.h"

_WMRTLINK dcomplex _IF_CDLOG( double rp, double ip ) {
//===================================================

// Return the logarithm (base e) of arg.
// ln(x + iy) = u + iv  =>  x + iy = exp(u) * cis(v)
// Thus x*x + y*y = exp(2u) or u = 0.5 ln(x*x + y*y)
// Also y/x = tan(v)  so  v = atan2(y,x)

    dcomplex    result;

    result.realpart = 0.5 * DLOG( rp*rp + ip*ip );
    result.imagpart = DATAN2( ip, rp );
    return( result );
}
