/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  

 IFCDSIN	: sine function for COMPLEX*16 argument

  Date		By		Reason
  ----		--		------
  88/01/14	G. Coschi	initial implementation
  94/04/08	Kevin Hui	merge C++ and Fortran Complex support
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  26-sep-95	Greg Bentz	intrinsic support for alpha
*/
#include "variety.h"
#include "cplx.h"

_WMRTLINK dcomplex _IF_CDSIN( double rp, double ip ) {
//===================================================

// Return the sine of arg.
// sin(x + iy) = ( exp(ix - y) - exp(-ix + y) ) / ( 2i )
//             = cis(x) exp(-y) /2i - cis(-x) exp(y) /2i
//             = sin(x)* cosh(y) + i cos(x)*sinh(y)

    dcomplex result;

    result.realpart = DSIN( rp ) * DCOSH( ip );
    result.imagpart = DCOS( rp ) * DSINH( ip );
    return( result );
}
