/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1994, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  05-mar-91     F.W.Crigger     Initial implementation
  23-jun-94	F.W.Crigger	changed to support long doubles
  09-mar-95	F.W.Crigger	support double as well as long double
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  24-jul-95	F.W.Crigger	added __DENORMAL classification
*/
#include "variety.h"
#include <string.h>
#include "xfloat.h"


int __LDClass( long_double *ld )
{
#ifdef _LONG_DOUBLE_
    if( (ld->exponent & 0x7FFF) == 0x7FFF ) {    /* NaN or Inf */
	if( ld->high_word == 0x80000000  &&  ld->low_word == 0 ) {
	    return( __INFINITY );
	}
	return( __NAN );
    }
    if( (ld->exponent & 0x7FFF) == 0 ) {
	if( ld->high_word == 0 && ld->low_word == 0 ) {
	    return( __ZERO );
	}
	return( __DENORMAL );
    }
    return( __NONZERO );
#else
    if( (ld->word[1] & 0x7FF00000) == 0x7FF00000 ) {/* NaN or Inf */
	if( (ld->word[1] & 0x7FFFFFFF) == 0x7FF00000 && ld->word[0] == 0 ) {
	    return( __INFINITY );
	}
	return( __NAN );
    }
    if( (ld->word[1] & 0x7FFFFFFF) == 0 && ld->word[0] == 0 ) {
	return( __ZERO );
    }
    if( (ld->word[1] & 0x7FF00000) == 0 ) {
	return( __DENORMAL );
    }
    return( __NONZERO );
#endif
}
