/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  24-aug-87     A.F.Scian       defined
  02-feb-88     F.W.Crigger     re-implemented in C, instead of asm
  18-aug-89     John Dahms      include "newerrno.h" so errno is ok in DOS
                                as well as multi-threaded OS/2 environment
  20-sep-89     F.W.Crigger     catch underflow/overflow when n is large
  28-feb-90     F.W.Crigger     call __set_ERANGE() to set errno
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  28-may-96	Greg Bentz	fixup function prototypes and add libsupp.h
*/
#include "variety.h"
#include "libsupp.h"
#include <math.h>


_WMRTLINK double ldexp( double value, int n )
/*********************************/
    {
        register int exp;
        auto    union {
                        double x;
                        short int a[4];
                } u;

        u.x = value;
        if( value != 0.0 ) {
            exp = (u.a[3] & 0x7ff0) >> 4;
            if( n > 16000 ) n = 16000;  /* so exp +=n does not overflow */
            if( n < -16000 ) n = -16000;/* so exp +=n does not underflow */
            exp += n;
            if( exp <= 0 )              return( 0.0 );
            if( exp >= 0x07ff ) {
                __set_ERANGE();
                if( u.a[3] > 0 )        return( HUGE_VAL );
                return( - HUGE_VAL );
            }
            exp = exp << 4;
            u.a[3] &= 0x800f;
            u.a[3] |= exp;
        }
        return( u.x );
    }
