/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  01-oct-86     F.W.Crigger     Translated to WSL
  11-aug-87     F.W.Crigger     Converted from WSL to C
--------------------------------------------------------------Version 8.0-----
  20-dec-90     F.W.Crigger     IF@DLOG10 entry added
  04-jan-91     John Dahms      Made IF@ routines conform to new code generator
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	Greg Bentz	modify name of IF@ functions for alpha
  28-may-96	Greg Bentz	fixup _IF_ function modifiers
*/
#include "variety.h"
#include <math.h>
#include "ifprag.h"
#include "mathcode.h"

#define log10_of_e    0.4342944819032518

_WMRTLINK extern double _IF_dlog10( double );
#if defined(_M_IX86)
  #pragma aux (if_rtn) _IF_log10 "IF@LOG10";
  #pragma aux (if_rtn) _IF_dlog10 "IF@DLOG10";
#endif

_WMRTLINK float _IF_log10( float x )
/*********************/
    {
        return( _IF_dlog10( x ) );
    }

_WMRTLINK double (log10)( double x )
/************************/
    {
        return( _IF_dlog10( x ) );
    }

_WMRTLINK double _IF_dlog10( double x )
/**************************/
{
    if( x <= 0.0 ) {
//        x = _matherr( x == 0.0 ? SING : DOMAIN, "log10", &x, &x, -HUGE_VAL );
        x = __log87_err( x, FUNC_LOG10 );
    } else {
        x =  log(x) * log10_of_e;
    }
    return( x );
}
