/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  24-aug-87     F.W.Crigger     Initial implementation
------------------------------------------------------Version 6.0--------
  08-apr-88     F.W.Crigger     changed fprintf to fputs
  01-may-88     F.W.Crigger     Add "fputc( '\n', stderr)" to match the fprintf
  18-aug-89     John Dahms      include "newerrno.h" so errno is ok in DOS
                                as well as multi-threaded OS/2 environment
  28-feb-90     F.W.Crigger     call __set_ERANGE() and __set_EDOM to set errno
  19-mar-91     F.W.Crigger     call __matherr which calls matherr
  23-mar-91     F.W.Crigger     Added __math1err and __math2err
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  28-may-96	Greg Bentz	fixup function prototypes and add libsupp.h
*/
#include "variety.h"
#include <math.h>
#include "mathcode.h"
#undef  __func__
#define __func__
#include "mathcode.h"

_WMRTLINK double __math1err( unsigned int err_info, double *arg1 )
    {
        return( __math2err( err_info, arg1, arg1 ) );
    }

_WMRTLINK double __math2err( unsigned int err_info, double *arg1, double *arg2 )
    {
        int     why;
        auto struct exception exc;

        exc.arg1 = *arg1;
        exc.arg2 = *arg2;
        if(      err_info & M_DOMAIN   ) { why = DOMAIN;   }
        else if( err_info & M_SING     ) { why = SING;     }
        else if( err_info & M_OVERFLOW ) { why = OVERFLOW; }
        else if( err_info & M_UNDERFLOW) { why = UNDERFLOW;}
        else if( err_info & M_PLOSS    ) { why = PLOSS;    }
        else if( err_info & M_TLOSS    ) { why = TLOSS;    }
        exc.type = why;
        exc.name = MathFuncNames[ (err_info & FUNC_MASK) - 1 ];
        if(      err_info & V_NEG_HUGEVAL ) { exc.retval = - HUGE_VAL; }
        else if( err_info & V_ZERO        ) { exc.retval = 0.0;        }
        else if( err_info & V_ONE         ) { exc.retval = 1.0;        }
        else if( err_info & V_HUGEVAL     ) { exc.retval = HUGE_VAL;   }
        else  /* PLOSS from sin,cos,tan */  { exc.retval = *arg2;      }

        return( _matherr( &exc ) );
    }
