/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  13-may-90     F.W.Crigger     Initial implementation
  27-sep-90     F.W.Crigger     "acosh", "asinh" added
  24-mar-91     F.W.Crigger     Used new __math1err instead of _matherr
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
*/
#include "variety.h"
#include <stddef.h>
#include <math.h>
#include "mathcode.h"


_WMRTLINK double __math87_err( double x, unsigned char code )
/*************************************************/
    {
        unsigned int  err_code;

        switch( code ) {
        case FUNC_ACOS:
        case FUNC_ASIN:
        case FUNC_SQRT:
            return( __math1err( code | M_DOMAIN | V_ZERO, &x ) );
        case FUNC_EXP:
            if( x < 0.0 ) return( 0.0 );
        }
        err_code = code | M_OVERFLOW | V_HUGEVAL;
        if( code == FUNC_SINH ) {
            if( x < 0.0 )  err_code = code | M_OVERFLOW | V_NEG_HUGEVAL;
        }
        return( __math1err( err_code, &x ) );
    }
