/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-11.0---------
  26-sep-95	Greg Bentz	alpha support
*/

#include "variety.h"
#include <float.h>
#include "xfloat.h"

extern void __fprem( double x, double y, int *quot, double *rem );

_WMRTLINK double modf( double x, double *iptr ) {
    double 	frac;
    long_double	ld;
    int		exp;

    ld.value = x;
    switch( __LDClass( &ld ) ) {
    case __ZERO:
	frac = 0.0;
	*iptr = 0.0;
	break;
    case __DENORMAL:
	frac = x;
	*iptr = 0.0;
	break;
    case __NAN:
    case __INFINITY:
	frac = 0.0;
	*iptr = x;
	break;
    case __NONZERO:
	exp = ((ld.word[1] >> 20)&0x7FF) - 0x3FE;
	if( exp < 0 ) {
	    frac = x;
	    *iptr = 0.0;
	} else if( exp > DBL_MANT_DIG ) {
	    frac = 0.0;
	    *iptr = x;
	} else {
	    int quot;
	    __fprem( x, 1.0, &quot, &frac );
	    *iptr = x - frac;
	}
	break;
    }
    return( frac );
}
