/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  19-may-90     F.W.Crigger     error part of pow.c: called from pow387.asm
  27-may-90     F.W.Crigger     if y < 0.0, result is 0.0, otherwise +/-inf
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  06-feb-96	Greg Bentz	make sure pow87_err doesn't mess up registers
  				expected saved by assembler code
*/
#include "variety.h"
#include <stddef.h>
#include <math.h>
#include "mathcode.h"

#if defined(__386__) && defined(__SW_3S)
   #pragma aux __pow87_err parm [] modify []
#endif


double __pow87_err( double x, double y, unsigned char code )
/**********************************************************/
    {
        unsigned int err_code;

        if( code <= 1 ) {
            if( code == 0 ) {           /* x == 0.0  */
                if( y > 0.0 )  return( 0.0 );
                if( y < 0.0 ) {
//                    result = HUGE_VAL;
                    err_code = FUNC_POW | M_DOMAIN | V_HUGEVAL; /* 0.0 ** -ve */
                } else {
//                    result = 1.0;
                    err_code = FUNC_POW | M_DOMAIN | V_ONE;     /* 0.0 ** 0.0 */
                }
            } else {                    /* negative ** fraction  */
                err_code = FUNC_POW | M_DOMAIN | V_ZERO;        /* -ve ** frac*/
            }
//            result = _matherr( DOMAIN, "pow", &x, &y, result );
            return( __math2err( err_code, &x, &y ) );
        } else {        /* code == 2 */
            if( y <= 0.0 )  return( 0.0 );                      /* 27-may-90 */
//            result = (x > 0.0) ? HUGE_VAL : - HUGE_VAL;
//            result = _matherr( OVERFLOW, "pow", &x, &y, result );
            if( x > 0.0 ) {
                err_code = FUNC_POW | M_OVERFLOW | V_HUGEVAL;
            } else {
                err_code = FUNC_POW | M_OVERFLOW | V_NEG_HUGEVAL;
            }
            return( __math2err( err_code, &x, &y ) );
        }
    }
