/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  

 POWC32          : complex power run-time routine

  Date		By		Reason
  ----		--		------
  93/09/23	Alex Brodsky	Initial implementation.
  94/04/08	Kevin Hui	merge C++ and Fortran Complex support
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  26-sep-95	Greg Bentz	intrinsic support for alpha
*/
#include "variety.h"
#include "cplx.h"

/* 
extern  extended          QSIN(extended);
extern  extended          QCOS(extended);
extern  extended          QLOG(extended);
extern  extended          QEXP(extended);
extern  extended          QATAN2(extended,extended);
*/
dcomplex _IF_C16Pow( double a, double b, double c, double d );

_WMRTLINK xcomplex _IF_C32Pow( extended a, extended b, extended c, extended d ) {
//==============================================================================

// Return the real part of the result of taking one extended precision
// complex number to the power of another.
// ( a, b ) ** ( c, d ) = exp( ( c,d ) * log( a,b ) )

    dcomplex    arg1 = _IF_C16Pow( a, b, c, d );
    xcomplex    arg2;
    arg2.realpart = arg1.realpart;
    arg2.imagpart = arg1.imagpart;
    return( arg2 );  // kill this when extendeds are enabled

/*	UNCOMMENT_TOKEN
    extended      u;
    extended      v;
    xcomplex    arg1;
    xcomplex    arg2;
    xcomplex    res;

    if( ( a == 0 ) && ( b == 0 ) ) {
        if( d == 0 ) {
            if( c > 0 ) {
                res.realpart = 0;
                res.imagpart = 0;
		return( res );
	    }
	}
	arg1.realpart = a;
	arg1.imagpart = b;
	arg2.realpart = c;
	arg2.imagpart = d;
	return( __qmath2err( FUNC_POW | M_DOMAIN | V_ZERO, &arg1, &arg2 ) );
    } else {
        u = QLOG( a*a + b*b ) / 2;
        v = QATAN2( b, a );
        res.realpart = QEXP( u*c - v*d );
        res.imagpart = res.realpart;
        u = u*d + v*c;
        res.realpart *= QCOS( u );
        res.imagpart *= QSIN( u );
	return( res );
    }
    */
}
