/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  

 POWIC8		: complex power run-time routine

  Date		By		Reason
  ----		--		------
--------------------------------------------------------Version-11.0---------
  95/07/06	G. Coschi	Initial implementation.
  95/08/10	T. Schiller	Adapted for the mathlib.
  26-sep-95	Greg Bentz	intrinsic support for alpha
*/

#include "variety.h"
#include "cplx.h"
#include "mathcode.h"


_WMRTLINK complex _IF_C8PowI( single a, single b, intstar4 i ) {
//=============================================================

// Complex power to an integer exponent.

    single      t;
    complex	arg1;
    complex	arg2;
    complex     res;

    if( ( a == 0 ) && ( b == 0 ) ) {
	if( i > 0 ) {
	    res.realpart = 0;
	    res.imagpart = 0;
	    return( res );
	}
	arg1.realpart = a;
	arg1.imagpart = b;
	arg2.realpart = i;
	arg2.imagpart = 0;
	return( __zmath2err( FUNC_POW | M_DOMAIN | V_ZERO, &arg1, &arg2 ) );
    } else {
	if( i < 0 ) {
	    i = -i;
	    t = a*a + b*b;
	    a = a / t;
	    b = -b / t;
	}
	res.realpart = 1;
	res.imagpart = 0;
	while( i > 0 ) {
	    if( i % 2 == 0 ) {
		t = a;
	        a = a*a - b*b;
		b = 2*t*b;
		i = i / 2;
	    } else {
	        t = res.realpart;
	    	res.realpart = res.realpart*a - res.imagpart*b;
		res.imagpart = t*b + res.imagpart*a;
		--i;
	    }
	}
	return res;
    }
}
