/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
   88/01/14     G. Coschi       Initial implementation.
   90/01/05     John Dahms      Adapted for CLIB
   91/04/09     G. Coschi       added "value [EAX]" to if_powii pragma
                                - override "value [8087]" with "value [EAX]"
                                  (got "invalid register for return value")
   94/04/08     Kevin Hui	merge C++ and Fortran Complex support
   94/04/12	Kevin Hui	fixup error-handling
   94/06/03	Greg Bentz	handle (-1)**(-1)
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	Greg Bentz	modify name of IF@ functions for alpha
*/

#include "variety.h"
#include <stddef.h>
#include <math.h>
#include <limits.h>
#include "ifprag.h"
#include "cplx.h"
#include "mathcode.h"

#if defined(__386__)
  #pragma aux (if_rtn) _IF_ipow "IF@IPOW" value [EAX];
#elif defined(M_I86)
  #pragma aux (if_rtn) _IF_ipow "IF@IPOW";
#endif

_WMRTLINK long _IF_ipow( long base, long power )
/**********************************************/
    {

        long  result;

        if( base == 0 ) {
            if( power <= 0 ) {
		double  dummy;
                dummy = 0.0;
//		used to be like this:
//              result = _matherr( DOMAIN, "ipow", NULL, NULL, 1.0 );
//		now it is like this:
		result = __math1err( FUNC_IPOW | M_DOMAIN | V_ONE, &dummy );
//		should be more like this:
//		result = __imath2err( FUNC_POW | M_DOMAIN | V_ZERO, &base, &power );
            } else {
                result = 0;
            }
        } else if( power < 0 ) {
            if( base == 1 ) {
                result = 1;
	    } else if( base == -1 ) {
		if( power & 1 ) {
		    result = -1;
		} else {
		    result = 1;
		}
            } else {
                result = 0;
            }
        } else {
            result = 1;
            while( power > 0 ) {
                if( power & 1 ) {
                    result *= base;
                    --power;
                } else {
                    base *= base;
                    power /= 2;
                }
            }
        }
        return( result );
    }

_WMRTLINK intstar4 _IF_powii( intstar4 base, intstar4 power )
/**********************************************************/
    {
	return( _IF_ipow( base, power ) );
    }
