/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1990, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
   88/01/14	G. Coschi	Initial implementation.
   90/01/05	John Dahms	Adapted for CLIB
   91/07/02	J.B.Schueler	macrotized read/write data reference
   94/04/08     Kevin Hui	merge C++ and Fortran Complex support
   94/04/12     Kevin Hui	fixup error-handling
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	Greg Bentz	modify name of IF@ functions for alpha
  26-sep-95	Greg Bentz	intrinsic support for alpha
  28-may-96	Greg Bentz	fixup _IF_ function modifiers
*/

#include "variety.h"
#include <stddef.h>
#include <math.h>
#include <limits.h>
#include "ifprag.h"
#include "rtdata.h"
#include "cplx.h"
#include "mathcode.h"

_WMRTLINK extern double _IF_dpowi( double, long );

#if defined(_M_IX86)
  #pragma aux (if_rtn) _IF_dpowi "IF@DPOWI";
  #pragma aux (if_rtn) _IF_powi "IF@POWI";
#endif

_WMRTLINK float _IF_powi( float base, long power )
/***********************************************/
{
    return( _IF_dpowi( base, power ) );
}

_WMRTLINK double _IF_dpowi( double base, long power )
/**************************************************/
{
    double    result;

    #if defined(_M_IX86)
	if( _RWD_real87 ) return( pow( base, power ) );
    #endif
    if( base == 0.0 ) {
	if( power <= 0 ) {
//	    result = _matherr( DOMAIN, "dpowi", NULL, NULL, 0.0 );
	    result = power;
	    result = __math2err( FUNC_DPOWI | M_DOMAIN | V_ZERO,
				     &base, &result  );
	} else {
	    result = 0.0;
	}
    } else {
	if( power < 0 ) {
	    power = -power;
	    base = 1 / base;
	}
	result = 1.0;
	while( power > 0 ) {
	    if( power % 2 == 0 ) {
		base *= base;
		power /= 2;
	    } else {
		result *= base;
		--power;
	    }
	}
    }
    return( result );
}

_WMRTLINK double	_IF_PowRI( double base, intstar4 power )
/******************************************************/
    {
	return( _IF_dpowi( base, power ) );
    }
