/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  

 POWRR        : power - double precision

  Date		By		Reason
  ----		--		------
  88/01/14	G. Coschi	Initial implementation.
  94/04/08	Kevin Hui	merge C++ and Fortran Complex support
  94/04/12	Kevin Hui   	fixup error-handling
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  26-sep-95	Greg Bentz	intrinsic support for alpha
*/
#include "variety.h"
#include "cplx.h"
#include "mathcode.h"


_WMRTLINK double _IF_PowRR( double base, double power ) {
//======================================================

// Return base ** power.

    if( base < 0.0 ) {
	return( __math2err( FUNC_POW | M_DOMAIN | V_ZERO, &base, &power ) );
    } else {
        if( base == 0.0 ) {
            if( power <= 0.0 ) {
		return( __math2err( FUNC_POW | M_DOMAIN | V_ZERO,
		                    &base, &power ) );
            }
        }
	return( pow( base, power ) );
    }
}
