/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %     Copyright (C) 1995, by WATCOM International Inc.  All rights    %
  %     reserved.  No part of this software may be reproduced or        %
  %     used in any form or by any means - graphic, electronic or       %
  %     mechanical, including photocopying, recording, taping or        %
  %     information storage and retrieval systems - except with the     %
  %     written permission of WATCOM International Inc.                 %
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  

 POWXI	: power - integer exponent

  Date		By		Reason
  ----		--		------
  93/09/23	Alex Brodsky	Initial implementation
  94/04/08	Kevin Hui	merge C++ and Fortran Complex support
  94/04/12	Kevin Hui	fixup error-handling
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  26-sep-95	Greg Bentz	intrinsic support for alpha
*/
#include "variety.h"
#include "cplx.h"
#include "mathcode.h"
#include "pdiv.h"


_WMRTLINK extended _IF_PowXI( extended base, intstar4 power ) {
//============================================================

// Return base ** power where power could be <= 0.

    extended    result;

    if( base == 0.0 ) {
        if( power <= 0 ) {
	    result = power;
	    return( __math2err( FUNC_DPOWI | M_DOMAIN | V_ZERO, &base, &result ) );
        } else {
	    return( 0.0 );
        }
    } else {
        if( power < 0 ) {
            power = -power;
            base = PDIV( 1.0 , base );
        }
        result = 1.0;
        while( power > 0 ) {
            if( power % 2 == 0 ) {
                base *= base;
                power /= 2;
            } else {
                result *= base;
                --power;
            }
        }
	return( result );
    }
}
