/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  02-oct-86	F.W.Crigger	Initial implementation in WSL
  16-jan-87	A.J.Stein	Converted from WSL to C
  24-aug-87	F.W.Crigger	Exception handling added
------------------------------------------------------------Version 7.0------
  31-mar-89	F.W.Crigger	Adapted for 386
--------------------------------------------------------------Version 8.0-----
  20-dec-90	F.W.Crigger	IF@DSQRT entry added
  04-jan-91	John Dahms	Made IF@ routines conform to new code generator
  03-sep-91	J.B.Schueler	macrotized read/write data reference
  09-sep-91	J.B.Schueler	changed _8087 to _real87
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	Greg Bentz	modify name of IF@ functions for alpha
  28-may-96	Greg Bentz	fixup _IF_ function modifiers
*/
#include "variety.h"
#include <stddef.h>
#include <math.h>
#include "ifprag.h"
#include "mathcode.h"
#include "rtdata.h"

#if defined(__386__)
 extern double __sqrtd(double);
 #pragma aux __sqrtd "*" parm [edx eax] value [edx eax];
 extern	double	_sqrt87(double);
 #pragma aux	_sqrt87 = \
		0x55			/* push ebp */\
		0x52 0x50		/* push edx,eax */\
		0x89 0xe5		/* mov ebp,esp */\
		0xdd 0x45 0x00		/* fld 0[ebp] */\
		0xd9 0xfa		/* fsqrt */\
		0xdd 0x5d 0x00		/* fstp 0[ebp] */\
		0x9b			/* fwait */\
		0x58 0x5a		/* pop eax,edx */\
		0x5d			/* pop ebp */\
		parm [edx eax] value [edx eax];
#elif defined(M_I86)
 extern double __sqrtd(double);
 #pragma aux __sqrtd "*" parm [ax bx cx dx] value [ax bx cx dx];
 extern	double	_sqrt87(double);
 #pragma aux	_sqrt87 = \
		0x55			/* push bp */\
		0x50 0x53 0x51 0x52	/* push ax,bx,cx,dx */\
		0x89 0xe5		/* mov bp,sp */\
		0xdd 0x46 0x00		/* fld 0[bp] */\
		0x9b			/* fwait */\
		0xd9 0xfa		/* fsqrt */\
		0x9b			/* fwait */\
		0xdd 0x5e 0x00		/* fstp 0[bp] */\
		0x9b			/* fwait */\
		0x5a 0x59 0x5b 0x58	/* pop dx,cx,bx,ax */\
		0x5d			/* pop bp */\
		parm [ax bx cx dx] value [ax bx cx dx];
#endif

_WMRTLINK extern double _IF_dsqrt( double );
#if defined(_M_IX86)
  #pragma aux (if_rtn) _IF_sqrt "IF@SQRT";
  #pragma aux (if_rtn) _IF_dsqrt "IF@DSQRT";
#endif

_WMRTLINK float _IF_sqrt( float x )
/*********************/
{
    return( _IF_dsqrt( x ) );
}

_WMRTLINK double (sqrt)( double x )
/***********************/
{
    return( _IF_dsqrt( x ) );
}


_WMRTLINK double _IF_dsqrt( double x )
/*************************/
{
    if( x < 0.0 ) {
//	x = _matherr( DOMAIN, "sqrt", &x, &x, 0.0 );
	x = __math1err( FUNC_SQRT | M_DOMAIN | V_ZERO, &x );
#if defined(_M_IX86)
    } else if( _RWD_real87 ) {
	x = _sqrt87( x );
#endif
    } else if( x != 0.0 ) {
	#if defined(_M_IX86)
	    x = __sqrtd( x );
	#else
	    register int	i;
	    auto int	exp;
	    auto double	e;
    
	    x = frexp( x, &exp );
	    if( exp & 1 ) {     /* if odd */
		++exp;
		x = x / 2.0;
		e = x * 0.828427314758301 + 0.297334909439087;
	    } else {	    /* even */
		e = x * 0.58578634262085 + 0.42049503326416;
	    }
	    i = 4;
	    do {
		e = (x / e + e) / 2.0;
	    } while( --i != 0 );
	    x = ldexp( e, exp >> 1 );
	#endif
    }
    return( x );
}
