/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:     By:             Reason:
  ---------     ---             -------
  01-oct-86     F.W.Crigger     Initial implementation in WSL
  16-jan-87     A.J.Stein       Converted from WSL to C
-----------------------------------------------------------Version 6.5------
  21-jul-88     F.W.Crigger     check for small values of x
--------------------------------------------------------------Version 8.0-----
  20-dec-90     F.W.Crigger     IF@DTANH entry added
  91-jan-04     John Dahms      Made IF@ routines conform to new code generator
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  19-sep-95	Greg Bentz	modify name of IF@ functions for alpha
  28-may-96	Greg Bentz	fixup _IF_ function modifiers
*/
#include "variety.h"
#include <math.h>
#include <ifprag.h>
#include "pdiv.h"

        
_WMRTLINK extern double _IF_dtanh( double );
#if defined(_M_IX86)
  #pragma aux (if_rtn) _IF_tanh "IF@TANH";
  #pragma aux (if_rtn) _IF_dtanh "IF@DTANH";
#endif

_WMRTLINK float _IF_tanh( float x )
/*********************/
    {
        return( _IF_dtanh( x ) );
    }
    
_WMRTLINK double (tanh)( double x )
/***********************/
    {
        return( _IF_dtanh( x ) );
    }
    
_WMRTLINK double _IF_dtanh( double x )
/*************************/
    {
        double z;

        z = fabs( x );
        if( z >= 64.0 ) {
            if( x < 0.0 ) {
                z = -1.0;
            } else {
                z = 1.0;
            }
        } else {
/*          if( z <= ldexp( 1.0, -26 ) ) { */
            if( z <= 1.49011611938476580e-008 ) { /* if x is small */
                z = x;
            } else {
                z = exp( (-2.0) * x );
                z = PDIV( (1.0 - z) , (1.0 + z) );
            }
        }
        return( z );
    }
