/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%       Copyright (C) 1989, by WATCOM Systems Inc. All rights     %
 *%       reserved. No part of this software may be reproduced      %
 *%       in any form or by any means - graphic, electronic or      %
 *%       mechanical, including photocopying, recording, taping     %
 *%       or information storage and retrieval systems - except     %
 *%       with the written permission of WATCOM Systems Inc.        %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     Algorithm taken from "Numerical Recipes in C" page 187.

  Modified:     By:             Reason:
  ---------     ---             -------
  14-nov-89     F.W.Crigger     Initial implementation
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
*/
#include "variety.h"
#include <math.h>
#include "mathcode.h"
#include "pdiv.h"


_WMRTLINK double yn( int n, double x )
/**************************/
    {
        int     j;
        double  by, bym, byp, tox;

        if( x < 0.0 ) {
//            return _matherr( DOMAIN, "yn", &x, &x, - HUGE_VAL );
            return __math1err( FUNC_YN | M_DOMAIN | V_NEG_HUGEVAL, &x );
        }
        bym = y0( x );
        if( n == 0 ) return( bym );
        tox = PDIV( 2.0 , x );
        by = y1( x );
        for( j = 1; j < n; j++ ) {
            byp = j * tox * by - bym;
            bym = by;
            by = byp;
        }
        return( by );
    }
