/*
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 *%	  Copyright (C) 1986, by WATCOM Systems Inc. All rights     %
 *%	  reserved. No part of this software may be reproduced	    %
 *%	  in any form or by any means - graphic, electronic or	    %
 *%	  mechanical, including photocopying, recording, taping     %
 *%	  or information storage and retrieval systems - except     %
 *%	  with the written permission of WATCOM Systems Inc.	    %
 *%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Modified:	By:		Reason:
  ---------	---		-------
  24-aug-87	F.W.Crigger	Initial implementation
------------------------------------------------------Version 6.0--------
  08-apr-88	F.W.Crigger	changed fprintf to fputs
  01-may-88	F.W.Crigger	Add "fputc( '\n', stderr)" to match the fprintf
  18-aug-89	John Dahms	include "newerrno.h" so errno is ok in DOS
				as well as multi-threaded OS/2 environment
  28-feb-90	F.W.Crigger	call __set_ERANGE() and __set_EDOM to set errno
------------------------------------------------------Version 8.0--------
  19-mar-91	F.W.Crigger	call __matherr which calls matherr
  24-mar-91	F.W.Crigger	__math2err calls _matherr with ptr to struct
				Perform indirect through __MathErrRtn so that
				Netware NLM programs can change it to point to
				a different routine.
  03-jul-91	J.B.Schueler	added _set_matherr for PenPoint
  03-sep-92	J.B.Schueler	Added "const" attribute to Msgs
  14-apr-94	Kevin Hui	Use __rterrmsg() to output error, so that
				it can be used by qmath2err, etc.
  13-may-94	Greg Bentz	Use __get_std_stream() to get FILE * for
				stderr to keep this code platform independent
--------------------------------------------------------Version-11.0---------
  06-jun-95	Greg Bentz	variety.h and dll linkage
  21-jun-95	Greg Bentz	axp doesn't need __matherr
  09-sep-95	Greg Bentz	ppc doesn't need __matherr
  28-may-96	Greg Bentz	fixup function prototypes and add libsupp.h
*/
#include "variety.h"
#include "libsupp.h"
#include <stdio.h>
#include <math.h>
#include <unistd.h>
#include "rtdata.h"

#if defined(_M_IX86)
 extern int	__matherr( struct exception * );
 #pragma aux	__matherr "*";
#endif

static const char * const Msgs[] = {
	0,
	"Domain error",
	"Argument singularity",
	"Overflow range error",
	"Underflow range error",
	"Total loss of significance",
	"Partial loss of significance"
   };

#if !defined(__PENPOINT__)
  int	(*_RWD_matherr)( struct exception * ) =
  #if defined(__AXP__) || defined(__PPC__)
    matherr;
  #elif defined(_M_IX86)
    __matherr;
  #endif
#endif

_WMRTLINK void _set_matherr( int (*rtn)( struct exception * ) )
{
    _RWD_matherr = rtn;
}

void __rterrmsg( const int errcode, const char *funcname )
{
    FILE *fp;
    fp = __get_std_stream( STDERR_FILENO );
    fputs( Msgs[errcode], fp );
    fputs( " in ", fp );
    fputs( funcname, fp );
    fputc( '\n', fp );
}

_WMRTLINK double _matherr( struct exception *excp )
/***************************************/
    {
	if( (*_RWD_matherr)( excp ) == 0 ) {
	    __rterrmsg( excp->type, excp->name );
	    excp->type == DOMAIN ? __set_EDOM() : __set_ERANGE();
	}
	return( excp->retval );
    }
