/*      The first parm to __math1err and __math2err is an unsigned int
        that indicates the math function, the type of error, and the
        expected result value.
*/
#ifndef _COMDEF_H_INCLUDED
 #include <_comdef.h>
#endif

_WMRTLINK extern double __math1err( unsigned int, double *arg1 );
_WMRTLINK extern double __math2err( unsigned int, double *arg1, double *arg2 );
_WMRTLINK extern double __log87_err( double, unsigned int );

#ifndef __func__
 #define __func__(code,name)  code
 enum func_codes {
#else
 #undef __func__
 #define __func__(code,name)  name
 static char *MathFuncNames[] = {
#endif

        __func__( FUNC_ACOS = 1,"acos" ),
        __func__( FUNC_ASIN,    "asin" ),
        __func__( FUNC_SQRT,    "sqrt" ),
        __func__( FUNC_EXP,     "exp"  ),
        __func__( FUNC_COSH,    "cosh" ),
        __func__( FUNC_SINH,    "sinh" ),
        __func__( FUNC_POW,     "pow"  ),
        __func__( FUNC_ACOSH,   "acosh"),
        __func__( FUNC_LOG2,    "log2" ),
        __func__( FUNC_LOG,     "log"  ),
        __func__( FUNC_LOG10,   "log10"),
        __func__( FUNC_ATANH,   "atanh"),
        __func__( FUNC_ATAN2,   "atan2"),
        __func__( FUNC_IPOW,    "ipow" ),
        __func__( FUNC_DPOWI,   "dpowi"),
        __func__( FUNC_COS,     "cos"  ),
        __func__( FUNC_SIN,     "sin"  ),
        __func__( FUNC_TAN,     "tan"  ),
        __func__( FUNC_Y0,      "y0"   ),
        __func__( FUNC_Y1,      "y1"   ),
        __func__( FUNC_YN,      "yn"   ),
        __func__( FUNC_MOD,     "mod"  ),
        __func__( FUNC_COTAN,   "cotan")
};
#define FUNC_MASK       0x001F

/*       bits for the type of math errors */

#define M_DOMAIN        0x0040
#define M_SING          0x0080
#define M_OVERFLOW      0x0100
#define M_PLOSS         0x0200
#define M_TLOSS         0x0400
#define M_UNDERFLOW     0x0800

/*       bits for the return value expected */

#define V_NEG_HUGEVAL   0x1000
#define V_ZERO          0x2000
#define V_ONE           0x4000
#define V_HUGEVAL       0x8000
