/*
*******************************************************************
*	Copyright by WATCOM Systems Inc. 1987, 1990. All rights	  *
*	reserved. No part of this software may be reproduced	  *
*	in any form or by any means - graphic, electronic or	  *
*	mechanical, including photocopying, recording, taping	  *
*	or information storage and retrieval systems - except	  *
*	with the written permission of WATCOM Systems Inc.	  *
*******************************************************************

NOTE: If you make changes to this file change the file watlimit.h
(if necessary) to reflect the changes here.
*/

#ifndef _WATCOM_H_INCLUDED_

/*
   This next set of lines is a temp fix until the 11.0 headers are
   in universal usage.
*/
#if ( !defined( _WCUNALIGNED ) && ( __WATCOMC__ < 1100 ) )
    #include <errno.h>
    #ifndef _WCUNALIGNED
        #define _WCUNALIGNED
    #endif
#endif

#if !defined(__sun__) && !defined(sun) && !defined(__sgi) && !defined(__hppa) && !defined(_AIX) && !defined( __alpha )
    typedef unsigned        uint;
#endif

typedef unsigned char	uint_8;
typedef unsigned short	uint_16;
typedef unsigned long	uint_32;
typedef unsigned char	unsigned_8;
typedef unsigned short	unsigned_16;
typedef unsigned long	unsigned_32;

typedef signed char	int_8;
typedef signed short	int_16;
typedef signed long	int_32;
typedef signed char	signed_8;
typedef signed short	signed_16;
typedef signed long	signed_32;

typedef struct {
    union {
	unsigned_32	_32[2];
	unsigned_16	_16[4];
	unsigned_8	 _8[8];
	struct {
#if defined( WATCOM_BIG_ENDIAN )
	    unsigned	v	: 1;
	    unsigned		: 15;
	    unsigned		: 16;
	    unsigned		: 16;
	    unsigned		: 16;
#else
	    unsigned		: 16;
	    unsigned		: 16;
	    unsigned		: 16;
	    unsigned		: 15;
	    unsigned	v	: 1;
#endif
	}	sign;
	#ifdef __WATCOM_INT64__
	   unsigned __int64	_64[1];
	#endif
    } u;
} unsigned_64;
typedef unsigned_64	signed_64;

/* for little endian machines */

#if defined( WATCOM_BIG_ENDIAN )
    #define I64LO32	1
    #define I64HI32	0
#else
    #define I64LO32	0
    #define I64HI32	1
#endif

/* Define _crtn for prototypes for external C routines called from C++.
 * Eg. extern _crtn void Foo();
 */
#if !defined( _crtn )
    #if defined( __cplusplus )
	#define _crtn   "C"
    #else
	#define _crtn
    #endif
#endif

#define _WATCOM_H_INCLUDED_
#endif
