/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %       Copyright (C) 1991, by WATCOM Systems Inc. All rights     %
   %       reserved. No part of this software may be reproduced      %
   %       in any form or by any means - graphic, electronic or      %
   %       mechanical, including photocopying, recording, taping     %
   %       or information storage and retrieval systems - except     %
   %       with the written permission of WATCOM Systems Inc.        %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
   Date		By		Reason
   ====		==		======
   17-mar-92	Craig Eisler	defined
   13-mar-93	Craig Eisler	added stuff for WM_MENUSELECT
   21-may-93	D. Wellstood	added GET_CLASS_STYLE
   27-may-93	Wes Nelson	added WM_MDIACTIVATE stuff
   03-jun-93	Paul Fast	added SET_CLASSCURSOR
   17-oct-93	D. Wellstood	fixed up the CALLBACK macro
   01-feb-94	D. Wellstood	added WM_HSCROLL stuff
   21-feb-95	Greg Bentz	alpha support
   08-jun-95	Kevin Hui	CALLBACK macro for AXP
   27-sep-95	T. Schiller	Added PPC support
*/
#ifndef __WIN1632_INCLUDED__
#define __WIN1632_INCLUDED__
#if defined(__NT__) || defined(TWIN32)

#define GET_HINSTANCE( hwnd ) (HANDLE) GetWindowLong( hwnd, GWL_HINSTANCE )
#define GET_ID( hwnd )	(DWORD) GetWindowLong( hwnd, GWL_ID )
#define GET_CBWNDEXTRA( hwnd )	(DWORD) GetClassLong( hwnd, GCL_CBWNDEXTRA )
#define GET_CLASS_STYLE(hwnd)	GetClassLong( hwnd, GCL_STYLE )

#define __FAR
#define HOOKPROC	PROC
#define WINMAINENTRY	WINAPI
#define GET_EM_SETSEL_MPS(iStart, iEnd) (UINT)(iStart), (LONG)(iEnd)
#define GET_WM_COMMAND_CMD(wp, lp)      HIWORD(wp)
#define GET_WM_COMMAND_HWND(wp, lp)     (HWND)(lp)
#define GET_WM_COMMAND_MPS(id, hwnd, cmd) (UINT)MAKELONG(id, cmd), (LONG)(hwnd)
#define GET_WM_ACTIVATE_FACTIVE(wp, lp)     LOWORD(wp)
#define GET_WM_ACTIVATE_FMINIMIZED(wp, lp)  (BOOL)HIWORD(wp)
#define GET_WM_ACTIVATE_HWND(wp, lp)        (HWND)(lp)
#define GET_WM_MDIACTIVATE_FACTIVATE(hwnd, wp, lp)  (lp == (LONG)hwnd)
#define GET_WM_MDIACTIVATE_HWNDACTIVATE(wp, lp)  (HWND)(wp)
#define GET_WM_MDIACTIVATE_HWNDDEACTIVATE(wp, lp)  (HWND)(lp)
#define GET_WM_VSCROLL_POS( wp, lp )	HIWORD(wp)
#define GET_WM_VSCROLL_HWND( wp, lp )	(HWND)(lp)
#define GET_WM_VSCROLL_CODE( wp, lp )	LOWORD(wp)
#define GET_WM_HSCROLL_POS( wp, lp )	HIWORD(wp)
#define GET_WM_HSCROLL_HWND( wp, lp )	(HWND)(lp)
#define GET_WM_HSCROLL_CODE( wp, lp )	LOWORD(wp)
#define SET_HBRBACKGROUND( hw, br ) (HBRUSH) SetClassLong( hw, GCL_HBRBACKGROUND, (LONG)br )
#define SET_HICON( hw, ic ) (HICON) SetClassLong( hw, GCL_HICON, (LONG)ic )
#define SET_CLASSCURSOR(hwnd, cur) (LONG)SetClassLong( hwnd, GCL_HCURSOR, (LONG)cur )
#define MAKE_POINT( p, pnt ) (p).x = (signed short)LOWORD( pnt ), (p).y = (signed short)HIWORD( pnt )
#define GET_WM_MENUSELECT_HMENU(wp,lp)	(HMENU)(lp)
#define GET_WM_MENUSELECT_ITEM(wp,lp) LOWORD(wp)
#define GET_WM_MENUSELECT_FLAGS(wp,lp) HIWORD(wp)
#define GET_WM_PARENTNOTIFY_EVENT(wp,lp) LOWORD(wp)
#define GET_WM_PARENTNOTIFY_ID(wp,lp) HIWORD(wp)
#define GET_WM_PARENTNOTIFY_HANDLE(wp,lp) (lp)
#define GET_WM_PARENTNOTIFY_POINT(wp,lp) (lp)

#else

#define GET_HINSTANCE( hwnd ) (HINSTANCE) GetWindowWord( hwnd, GWW_HINSTANCE )
#define GET_ID( hwnd )	(WORD) GetWindowWord( hwnd, GWW_ID )
#define GET_CBWNDEXTRA( hwnd )	(WORD) GetClassWord( hwnd, GCW_CBWNDEXTRA)
#define GET_CLASS_STYLE(hwnd)	GetClassWord( hwnd, GCW_STYLE )

#ifndef APIENTRY
#define APIENTRY	FAR PASCAL
#endif
#ifndef __FAR
#define __FAR		__far
#endif
#define WINMAINENTRY	PASCAL
#define GET_EM_SETSEL_MPS(iStart, iEnd) 0, MAKELONG(iStart, iEnd)
#define GET_WM_COMMAND_CMD(wp, lp)      HIWORD(lp)
#define GET_WM_COMMAND_HWND(wp, lp)     (HWND)LOWORD(lp)
#define GET_WM_COMMAND_MPS(id, hwnd, cmd) (UINT)(id), MAKELONG(hwnd, cmd)
#define GET_WM_ACTIVATE_FACTIVE(wp, lp)     (wp)
#define GET_WM_ACTIVATE_FMINIMIZED(wp, lp)  (BOOL)HIWORD(lp)
#define GET_WM_ACTIVATE_HWND(wp, lp)        (HWND)LOWORD(lp)
#define GET_WM_MDIACTIVATE_FACTIVATE(hwnd, wp, lp)  (BOOL)(wp)
#define GET_WM_MDIACTIVATE_HWNDACTIVATE(wp, lp)  (HWND)HIWORD(lp)
#define GET_WM_MDIACTIVATE_HWNDDEACTIVATE(wp, lp)  (HWND)LOWORD(lp)
#define GET_WM_VSCROLL_POS( wp, lp )	LOWORD(lp)
#define GET_WM_VSCROLL_HWND( wp, lp )	HIWORD(lp)
#define GET_WM_VSCROLL_CODE( wp, lp )	(wp)
#define GET_WM_HSCROLL_POS( wp, lp )	LOWORD(lp)
#define GET_WM_HSCROLL_HWND( wp, lp )	HIWORD(lp)
#define GET_WM_HSCROLL_CODE( wp, lp )	(wp)
#define SET_HBRBACKGROUND( hw, br ) (HBRUSH) SetClassWord( hw, GCW_HBRBACKGROUND, br )
#define SET_HICON( hw, ic ) (HICON) SetClassWord( hw, GCW_HICON, ic )
#define SET_CLASSCURSOR(hwnd, cur) (WORD)SetClassWord( hwnd, GCW_HCURSOR, cur )
#define MAKE_POINT( p, pnt ) p = MAKEPOINT( pnt )
#define GET_WM_MENUSELECT_HMENU(wp,lp) (HMENU)HIWORD(lp)
#define GET_WM_MENUSELECT_ITEM(wp,lp) (wp)
#define GET_WM_MENUSELECT_FLAGS(wp,lp) LOWORD(lp)
#define GET_WM_PARENTNOTIFY_EVENT(wp,lp) LOWORD(wp)
#define GET_WM_PARENTNOTIFY_ID(wp,lp) HIWORD(lp)
#define GET_WM_PARENTNOTIFY_HANDLE(wp,lp) LOWORD(lp)
#define GET_WM_PARENTNOTIFY_POINT(wp,lp) (lp)

#endif

#if defined(__386__) || defined(__AXP__) || defined(__PPC__)
#define FARstricmp stricmp
#define FARstrcpy strcpy
#define FARmemcpy memcpy
#else
#define FARstricmp _fstricmp
#define FARstrcpy _fstrcpy
#define FARmemcpy _fmemcpy
#endif

#undef CALLBACK
#if defined( __WINDOWS_386__ )
#define	CALLBACK	APIENTRY
#elif defined( UNIX )
#define CALLBACK
#else
#define	CALLBACK	__export APIENTRY
#endif

#ifndef DECLSPEC
#if defined(__AXP__) || defined(__PPC__)
#define DECLSPEC	__declspec(dllexport)
#else
#define DECLSPEC
#endif
#endif

#endif
