;=========================================================================
;==	Name:		SARD						==
;==	Operation:	shift arithmetic right double (long)		==
;==	Inputs: 	DX:AX	long integer to be shifted		==
;==			CX	integer shift count			==
;==	Outputs:	DX:AX	DX:AX >> CX 				==
;==	Volatile:	CX destroyed					==
;==	Date:		By:		Reason: 			==
;==	18-dec-91	F.W.Crigger	Initial implementation		==
;=========================================================================
include mdef.inc
include struct.inc

	modstart	sard

	xdefp	__SARD

	defp	__SARD
	cmp	CL,16			; if shift count >= 16
	_if	ae			; then
	  mov	AX,DX			; - shift right by 16
	  sub	CL,16			; - adjust shift count
	  cwd				; - sign extend
	  sar	AX,CL			; - shift the low word by (count-16)
	  ret				; - return
	_endif				; endif
;
;	CL < 16
;
	push	SI			; save work reg
	mov	SI,0FFFFh		; calc mask of bits to keep
	shl	SI,CL			; ...
	and	AX,SI			; get rid of bottom bits
	and	SI,DX			; save top bits of high word
	xor	DX,SI			; isolate low bits of high word
	or	AX,DX			; or these into bottom word
	ror	AX,CL			; rotate bottom part into place
	mov	DX,SI			; get high word
	sar	DX,CL			; shift high word
	pop	SI			; restore SI
	ret				; return
	endproc __SARD

	endmod
	end
